# IPython log file

query4 = '''
SELECT
    s.sName, s.sID
FROM
    store s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query4 = '''
SELECT
    s.sName, s.sID
FROM
    store s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT
    s.sName, s.sID
FROM
    store s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query4 = '''
SELECT
    s.sName, s.sID
FROM
    store s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  sID
#[Out]# 0  Albert Hein   44
#[Out]# 1         Coop   55
#[Out]# 2         Dirk   58
#[Out]# 3    Hoogvliet   49
#[Out]# 4        Jumbo   63
#[Out]# 5         Lidl   61
#[Out]# 6       Sligro   50
query4 = '''
SELECT
    s.sName, s.sID
FROM
    store s
GROUP BY
    s.sName, s.sID
HAVING
    COUNT(distinct s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName, sID]
#[Out]# Index: []
query4 = '''
SELECT
    s.sName, s.sID
FROM
    store s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  sID
#[Out]# 0  Albert Hein   44
#[Out]# 1         Coop   55
#[Out]# 2         Dirk   58
#[Out]# 3    Hoogvliet   49
#[Out]# 4        Jumbo   63
#[Out]# 5         Lidl   61
#[Out]# 6       Sligro   50
query4 = '''
WITH storeChains AS (
SELECT
    s.sName, s.sID
FROM
    store s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
)
SELECT
    *
FROM
    storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  sID
#[Out]# 0  Albert Hein   44
#[Out]# 1         Coop   55
#[Out]# 2         Dirk   58
#[Out]# 3    Hoogvliet   49
#[Out]# 4        Jumbo   63
#[Out]# 5         Lidl   61
#[Out]# 6       Sligro   50
query4 = '''
WITH storeChains AS (
SELECT
    s.sName
FROM
    store s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
)
SELECT
    sName
FROM
    storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
WITH storeChains AS (
SELECT
    s.sName
FROM
    store s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
)
SELECT
    sName, AVG(i.quantity)
FROM
    storeChains sc, inventory i, store s
WHERE
    s.sName == sc.sName AND i.sID == s.sID
GROUP BY
    sc.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
WITH storeChains AS (
SELECT
    s.sName
FROM
    store s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
)
SELECT
    sc.sName, AVG(i.quantity)
FROM
    storeChains sc, inventory i, store s
WHERE
    s.sName == sc.sName AND i.sID == s.sID
GROUP BY
    sc.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.008475
#[Out]# 1         Coop        16.695000
#[Out]# 2         Dirk        20.884615
#[Out]# 3    Hoogvliet        16.898438
#[Out]# 4        Jumbo        16.312500
#[Out]# 5         Lidl        25.048077
#[Out]# 6       Sligro        16.795620
query4 = '''
WITH storeChains AS (
SELECT
    s.sName
FROM
    store s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
)
SELECT
    sc.sName, COUNT(*)
FROM
    storeChains sc, inventory i, store s
WHERE
    s.sName == sc.sName AND i.sID == s.sID
GROUP BY
    sc.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  COUNT(*)
#[Out]# 0  Albert Hein       118
#[Out]# 1         Coop       200
#[Out]# 2         Dirk        78
#[Out]# 3    Hoogvliet       128
#[Out]# 4        Jumbo        64
#[Out]# 5         Lidl       104
#[Out]# 6       Sligro       137
query4 = '''
WITH storeChains AS (
SELECT
    s.sName
FROM
    store s, inventory i
WHERE
    s.sID == i.sID
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
)
SELECT
    *
FROM
    storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT
    s.sName
FROM
    store s, inventory i
WHERE
    i.sID == s.sID
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2 AND AVG(i.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT
    s.sName
FROM
    store s, purchase pur
WHERE
    pur.sID == s.sID
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2 AND AVG(pur.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro

# IPython log file

query1 = '''
    SELECT
        p.pID, COUNT(distinct p.cID)
    FROM
        purchase p
    GROUP BY
        p.pID;
'''

pd.read_sql_query(query1, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT
        p.pID, COUNT(distinct p.cID)
    FROM
        purchase p
    GROUP BY
        p.pID;
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  COUNT(distinct p.cID)
#[Out]# 0     0                     22
#[Out]# 1     1                     13
#[Out]# 2     2                      9
#[Out]# 3     3                     20
#[Out]# 4     4                     16
#[Out]# 5     5                     14
#[Out]# 6     6                     15
#[Out]# 7     7                     13
#[Out]# 8     8                     12
#[Out]# 9     9                     18
#[Out]# 10   10                     14
#[Out]# 11   11                     13
#[Out]# 12   12                     16
#[Out]# 13   13                     21
#[Out]# 14   14                     18
#[Out]# 15   15                     13
#[Out]# 16   16                     20
#[Out]# 17   17                     13
#[Out]# 18   18                     10
#[Out]# 19   19                     20
#[Out]# 20   20                     16
#[Out]# 21   21                     19
#[Out]# 22   22                     20
#[Out]# 23   23                     11
#[Out]# 24   24                     20
#[Out]# 25   25                     14
#[Out]# 26   26                     19
#[Out]# 27   27                     13
#[Out]# 28   28                     23
#[Out]# 29   29                      2
#[Out]# 30   30                      1
query1 = '''
CREATE VIEW distinct_customer_purchases(pid, nr_customers) AS
    SELECT
        p.pID, COUNT(distinct p.cID)
    FROM
        purchase p
    GROUP BY
        p.pID;
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT 
    pID, nr_customers
FROM (
    SELECT
        p.pID, COUNT(distinct p.cID)
    FROM
        purchase p
    GROUP BY
        p.pID 
    )
    AS distinct_product_purchases(pID, nr_customers)
WHERE
    nr_customers <= 2
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT 
    dpp.pID, dpp.nr_customers
FROM (
    SELECT
        p.pID, COUNT(distinct p.cID) AS nr_customers
    FROM
        purchase p
    GROUP BY
        p.pID 
    ) AS dpp
WHERE
    dpp.nr_customers <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  nr_customers
#[Out]# 0   29             2
#[Out]# 1   30             1
query2 = '''
SELECT
    pur.cID, pur.date
FROM
    purchase pur
GROUP BY
    pur.cID, pur.date
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID        date
#[Out]# 0      0  2018-08-22
#[Out]# 1      1  2018-08-20
#[Out]# 2      1  2018-08-21
#[Out]# 3      2  2018-08-16
#[Out]# 4      2  2018-08-17
#[Out]# 5      3  2018-08-18
#[Out]# 6      3  2018-08-19
#[Out]# 7      4  2018-08-24
#[Out]# 8      4  2018-08-25
#[Out]# 9      5  2018-08-17
#[Out]# 10     5  2018-08-22
#[Out]# 11     5  2018-08-23
#[Out]# 12     7  2018-08-23
#[Out]# 13     7  2018-08-24
#[Out]# 14     7  2018-08-25
#[Out]# 15     7  2018-08-26
#[Out]# 16     8  2018-08-16
#[Out]# 17    10  2018-08-27
#[Out]# 18    11  2018-08-25
#[Out]# 19    13  2018-08-17
#[Out]# 20    13  2018-08-25
#[Out]# 21    13  2018-08-26
#[Out]# 22    13  2018-08-27
#[Out]# 23    15  2018-08-27
#[Out]# 24    16  2018-08-18
#[Out]# 25    16  2018-08-19
#[Out]# 26    16  2018-08-24
#[Out]# 27    16  2018-08-25
#[Out]# 28    16  2018-08-26
#[Out]# 29    16  2018-08-27
#[Out]# ..   ...         ...
#[Out]# 255  178  2018-08-27
#[Out]# 256  179  2018-08-22
#[Out]# 257  179  2018-08-23
#[Out]# 258  179  2018-08-24
#[Out]# 259  180  2018-08-26
#[Out]# 260  180  2018-08-27
#[Out]# 261  181  2018-08-24
#[Out]# 262  181  2018-08-27
#[Out]# 263  182  2018-08-23
#[Out]# 264  182  2018-08-28
#[Out]# 265  184  2018-08-20
#[Out]# 266  185  2018-08-20
#[Out]# 267  186  2018-08-21
#[Out]# 268  188  2018-08-20
#[Out]# 269  188  2018-09-20
#[Out]# 270  189  2018-08-25
#[Out]# 271  189  2018-08-26
#[Out]# 272  190  2018-08-15
#[Out]# 273  190  2018-08-16
#[Out]# 274  190  2018-08-17
#[Out]# 275  190  2018-08-18
#[Out]# 276  190  2018-08-19
#[Out]# 277  190  2018-08-20
#[Out]# 278  190  2018-08-21
#[Out]# 279  190  2018-08-22
#[Out]# 280  190  2018-08-23
#[Out]# 281  190  2018-08-24
#[Out]# 282  190  2018-08-25
#[Out]# 283  190  2018-08-26
#[Out]# 284  190  2018-08-27
#[Out]# 
#[Out]# [285 rows x 2 columns]
query2 = '''
SELECT
    pur.cID, pur.date
FROM
    purchase pur, product prod
WHERE
    prod.pID == pur.pID
GROUP BY
    pur.cID, pur.date
HAVING
    prod.pName == 'Coffee' AND prod.pName == 'Onions'
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, date]
#[Out]# Index: []
query2 = '''
SELECT
    cust.cID, cust.cName
FROM
    purchase pur, product prod, customer cust
WHERE
    prod.pID == pur.pID AND prod.cID == cust.cID
GROUP BY
    pur.cID, pur.date
HAVING
    prod.pName == 'Coffee' AND prod.pName == 'Onions'
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT
    cust.cID, cust.cName
FROM
    purchase pur, product prod, customer cust
WHERE
    prod.pID == pur.pID AND pur.cID == cust.cID
GROUP BY
    pur.cID, pur.date
HAVING
    prod.pName == 'Coffee' AND prod.pName == 'Onions'
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query3 = '''
SELECT
    pur.cID
FROM
    purchase pur
GROUP BY
    pur.cID
HAVING
    pur.sID IN (SELECT s.sID FROM store s);
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
SELECT
    pur.cID
FROM
    purchase pur
GROUP BY
    pur.cID
HAVING
    COUNT(pur.sID) == (SELECT COUNT(s.sID) FROM STORE s)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
SELECT
    s.sName
FROM
    STORE s
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT
    s.sName
FROM
    store s, inventory i
WHERE
    i.sID == s.sID
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2 AND AVG(i.quantity > 4)
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query5 = '''
(SELECT MAX(mp.price) FROM purchase mp
'''

pd.read_sql_query(query5, conn)
query5 = '''
 SELECT MAX(mp.price) FROM purchase mp
'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(mp.price)
#[Out]# 0           13.8
query5 = '''
SELECT
    prod.pName, s.sName
FROM
    purchase pur, product prod, store s
WHERE
    pur.price = (SELECT MAX(mp.price) FROM purchase mp) AND prod.pID == pur.pID AND s.sID == pur.sID;
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
SELECT
    i1.sID, i2.sID
FROM
    inventory i1, inventory i2
WHERE
    i1.sID != i2.sID AND i1.date == '2018-08-23' AND i2.date == '2018-08-23' AND i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#      sID  sID
#[Out]# 0      2   33
#[Out]# 1      2   35
#[Out]# 2      2    5
#[Out]# 3      2    6
#[Out]# 4      2   11
#[Out]# 5      3   17
#[Out]# 6      3   33
#[Out]# 7      3   44
#[Out]# 8      3   57
#[Out]# 9      4   12
#[Out]# 10     4   35
#[Out]# 11     4   45
#[Out]# 12     5    9
#[Out]# 13     5   42
#[Out]# 14     5   54
#[Out]# 15     5    2
#[Out]# 16     5    6
#[Out]# 17     5   11
#[Out]# 18     5   29
#[Out]# 19     5   38
#[Out]# 20     6   29
#[Out]# 21     6   31
#[Out]# 22     6   11
#[Out]# 23     6   12
#[Out]# 24     6   13
#[Out]# 25     6    2
#[Out]# 26     6    5
#[Out]# 27     6   11
#[Out]# 28     7   41
#[Out]# 29     7   55
#[Out]# ..   ...  ...
#[Out]# 124   47   43
#[Out]# 125   50   34
#[Out]# 126   50   51
#[Out]# 127   50   11
#[Out]# 128   50   40
#[Out]# 129   50   41
#[Out]# 130   50   16
#[Out]# 131   50   30
#[Out]# 132   50   51
#[Out]# 133   51   34
#[Out]# 134   51   50
#[Out]# 135   51   16
#[Out]# 136   51   30
#[Out]# 137   51   50
#[Out]# 138   52   32
#[Out]# 139   52   37
#[Out]# 140   54    5
#[Out]# 141   54    9
#[Out]# 142   54   42
#[Out]# 143   55    7
#[Out]# 144   55   41
#[Out]# 145   55   56
#[Out]# 146   56    7
#[Out]# 147   56   41
#[Out]# 148   56   55
#[Out]# 149   56   35
#[Out]# 150   57    3
#[Out]# 151   57   17
#[Out]# 152   57   33
#[Out]# 153   57   44
#[Out]# 
#[Out]# [154 rows x 2 columns]
query6 = '''
SELECT
    MAX(i2.unit_price - i1.unit_price)
FROM
    inventory i1, inventory i2
WHERE
    i1.sID != i2.sID AND i1.date == '2018-08-23' AND i2.date == '2018-08-23' AND i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i2.unit_price - i1.unit_price)
#[Out]# 0                                 2.0
query6 = '''
SELECT
    MAX(i2.unit_price - i1.unit_price) as max_difference
FROM
    inventory i1, inventory i2
WHERE
    i1.sID != i2.sID AND i1.date == '2018-08-23' AND i2.date == '2018-08-23' AND i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_difference
#[Out]# 0             2.0
query6 = '''
SELECT
    MAX(i2.unit_price - i1.unit_price) as max_difference, i1.pID
FROM
    inventory i1, inventory i2
WHERE
    i1.sID != i2.sID AND i1.date == '2018-08-23' AND i2.date == '2018-08-23' AND i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_difference  pID
#[Out]# 0             2.0   12
query6 = '''
SELECT
    MAX(i2.unit_price - i1.unit_price) as max_difference, i1.pID, i1.sID
FROM
    inventory i1, inventory i2
WHERE
    i1.sID != i2.sID AND i1.date == '2018-08-23' AND i2.date == '2018-08-23' AND i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_difference  pID  sID
#[Out]# 0             2.0   12   42
query6 = '''
SELECT
    MAX(i2.unit_price - i1.unit_price) as max_difference, i1.pID, i1.sID, i2.sID
FROM
    inventory i1, inventory i2
WHERE
    i1.sID != i2.sID AND i1.date == '2018-08-23' AND i2.date == '2018-08-23' AND i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_difference  pID  sID  sID
#[Out]# 0             2.0   12   42    5
query6 = '''
SELECT
    MAX(i2.unit_price - i1.unit_price) as max_difference
FROM
    inventory i1, inventory i2
WHERE
    i1.sID != i2.sID AND i1.date == '2018-08-23' AND i2.date == '2018-08-23' AND i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_difference
#[Out]# 0             2.0
query1 = '''
SELECT
    p.pID
FROM
    purchase p
GROUP BY
    p.pID
HAVING
    COUNT(distinct p.cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
SELECT
    p.date, p.cID
FROM
    purchase p
GROUP BY
    p.date, p.cID
HAVING
   COUNT(p.pID == 21) >= 1 AND COUNT(p.pID == 4) >= 1
'''

pd.read_sql_query(query2, conn)
#[Out]#            date  cID
#[Out]# 0    2018-08-15   21
#[Out]# 1    2018-08-15   30
#[Out]# 2    2018-08-15   37
#[Out]# 3    2018-08-15   42
#[Out]# 4    2018-08-15   59
#[Out]# 5    2018-08-15  108
#[Out]# 6    2018-08-15  167
#[Out]# 7    2018-08-15  190
#[Out]# 8    2018-08-16    2
#[Out]# 9    2018-08-16    8
#[Out]# 10   2018-08-16   18
#[Out]# 11   2018-08-16   21
#[Out]# 12   2018-08-16   27
#[Out]# 13   2018-08-16   33
#[Out]# 14   2018-08-16   40
#[Out]# 15   2018-08-16   45
#[Out]# 16   2018-08-16   55
#[Out]# 17   2018-08-16   57
#[Out]# 18   2018-08-16   59
#[Out]# 19   2018-08-16   66
#[Out]# 20   2018-08-16   80
#[Out]# 21   2018-08-16   96
#[Out]# 22   2018-08-16  162
#[Out]# 23   2018-08-16  168
#[Out]# 24   2018-08-16  169
#[Out]# 25   2018-08-16  170
#[Out]# 26   2018-08-16  190
#[Out]# 27   2018-08-17    2
#[Out]# 28   2018-08-17    5
#[Out]# 29   2018-08-17   13
#[Out]# ..          ...  ...
#[Out]# 255  2018-08-27   16
#[Out]# 256  2018-08-27   22
#[Out]# 257  2018-08-27   27
#[Out]# 258  2018-08-27   28
#[Out]# 259  2018-08-27   31
#[Out]# 260  2018-08-27   33
#[Out]# 261  2018-08-27   58
#[Out]# 262  2018-08-27   67
#[Out]# 263  2018-08-27   68
#[Out]# 264  2018-08-27   91
#[Out]# 265  2018-08-27   92
#[Out]# 266  2018-08-27  110
#[Out]# 267  2018-08-27  157
#[Out]# 268  2018-08-27  163
#[Out]# 269  2018-08-27  169
#[Out]# 270  2018-08-27  172
#[Out]# 271  2018-08-27  178
#[Out]# 272  2018-08-27  180
#[Out]# 273  2018-08-27  181
#[Out]# 274  2018-08-27  190
#[Out]# 275  2018-08-28   22
#[Out]# 276  2018-08-28   25
#[Out]# 277  2018-08-28   31
#[Out]# 278  2018-08-28   39
#[Out]# 279  2018-08-28   69
#[Out]# 280  2018-08-28  157
#[Out]# 281  2018-08-28  169
#[Out]# 282  2018-08-28  182
#[Out]# 283  2018-08-29   39
#[Out]# 284  2018-09-20  188
#[Out]# 
#[Out]# [285 rows x 2 columns]
query1 = '''
SELECT
    p.date, p.cID
FROM
    purchase p
WHERE
    p.pID == 21 OR p.pID == 4
GROUP BY
    p.date, p.cID
HAVING
   COUNT(distinct p.pID) >= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#          date  cID
#[Out]# 0  2018-08-26  124
#[Out]# 1  2018-08-26  190
query2 = '''
SELECT
    p.date, p.cID
FROM
    purchase p
WHERE
    p.pID == 21 OR p.pID == 4
GROUP BY
    p.date, p.cID
HAVING
   COUNT(distinct p.pID) >= 2
'''

pd.read_sql_query(query2, conn)
#[Out]#          date  cID
#[Out]# 0  2018-08-26  124
#[Out]# 1  2018-08-26  190
query1 = '''
SELECT
    p.pID
FROM
    purchase p
GROUP BY
    p.pID
HAVING
    COUNT(distinct p.cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
SELECT
    p.date, p.cID
FROM
    purchase p, product prod
WHERE
    prod.pID == p.pID OR prod.pName == 'Coffee' OR prod.pName == 'Onions'
GROUP BY
    p.date, p.cID
HAVING
   COUNT(distinct p.pID) >= 2
'''

pd.read_sql_query(query2, conn)
#[Out]#            date  cID
#[Out]# 0    2018-08-15   37
#[Out]# 1    2018-08-15  108
#[Out]# 2    2018-08-15  167
#[Out]# 3    2018-08-15  190
#[Out]# 4    2018-08-16    8
#[Out]# 5    2018-08-16   18
#[Out]# 6    2018-08-16   40
#[Out]# 7    2018-08-16   66
#[Out]# 8    2018-08-16  170
#[Out]# 9    2018-08-16  190
#[Out]# 10   2018-08-17    2
#[Out]# 11   2018-08-17   13
#[Out]# 12   2018-08-17   86
#[Out]# 13   2018-08-17   94
#[Out]# 14   2018-08-17  123
#[Out]# 15   2018-08-17  151
#[Out]# 16   2018-08-17  169
#[Out]# 17   2018-08-17  190
#[Out]# 18   2018-08-18   19
#[Out]# 19   2018-08-18   20
#[Out]# 20   2018-08-18   30
#[Out]# 21   2018-08-18   35
#[Out]# 22   2018-08-18   86
#[Out]# 23   2018-08-18  139
#[Out]# 24   2018-08-18  190
#[Out]# 25   2018-08-19    3
#[Out]# 26   2018-08-19   16
#[Out]# 27   2018-08-19   17
#[Out]# 28   2018-08-19   24
#[Out]# 29   2018-08-19   51
#[Out]# ..          ...  ...
#[Out]# 90   2018-08-25  122
#[Out]# 91   2018-08-25  134
#[Out]# 92   2018-08-25  149
#[Out]# 93   2018-08-25  176
#[Out]# 94   2018-08-25  190
#[Out]# 95   2018-08-26    7
#[Out]# 96   2018-08-26   27
#[Out]# 97   2018-08-26   33
#[Out]# 98   2018-08-26   44
#[Out]# 99   2018-08-26   51
#[Out]# 100  2018-08-26   91
#[Out]# 101  2018-08-26  113
#[Out]# 102  2018-08-26  124
#[Out]# 103  2018-08-26  159
#[Out]# 104  2018-08-26  161
#[Out]# 105  2018-08-26  176
#[Out]# 106  2018-08-26  190
#[Out]# 107  2018-08-27   33
#[Out]# 108  2018-08-27   67
#[Out]# 109  2018-08-27   91
#[Out]# 110  2018-08-27   92
#[Out]# 111  2018-08-27  110
#[Out]# 112  2018-08-27  157
#[Out]# 113  2018-08-27  163
#[Out]# 114  2018-08-27  178
#[Out]# 115  2018-08-27  180
#[Out]# 116  2018-08-27  190
#[Out]# 117  2018-08-28   39
#[Out]# 118  2018-08-28  182
#[Out]# 119  2018-08-29   39
#[Out]# 
#[Out]# [120 rows x 2 columns]
query2 = '''
SELECT
    p.date, p.cID
FROM
    purchase p, product prod
WHERE
    prod.pID == p.pID AND (prod.pName == 'Coffee' OR prod.pName == 'Onions')
GROUP BY
    p.date, p.cID
HAVING
   COUNT(distinct p.pID) >= 2
'''

pd.read_sql_query(query2, conn)
#[Out]#          date  cID
#[Out]# 0  2018-08-26  124
#[Out]# 1  2018-08-26  190
query4 = '''
WITH (
    SELECT
        s.sName as name
    FROM
        store s, inventory i
    WHERE
        i.sID == s.sID
    GROUP BY
        s.sName
    HAVING
        COUNT(distinct s.sID) >= 2
    ) AS chain_stores
SELECT
    cs.name
FROM
    chain_stores cs
    
'''

pd.read_sql_query(query4, conn)
query4 = '''
WITH chain_stores AS (
    SELECT
        s.sName as name
    FROM
        store s, inventory i
    WHERE
        i.sID == s.sID
    GROUP BY
        s.sName
    HAVING
        COUNT(distinct s.sID) >= 2
)
SELECT
    cs.name
FROM
    chain_stores cs
'''

pd.read_sql_query(query4, conn)
#[Out]#           name
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
WITH 
SELECT
    s.sName, AVG(i.quantity) > 4
FROM
    store s, inventory i
WHERE
    i.sID == s.sID
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
query4 = '''
WITH 
SELECT
    s.sName, AVG(i.quantity)
FROM
    store s, inventory i
WHERE
    i.sID == s.sID
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT
    s.sName, AVG(i.quantity)
FROM
    store s, inventory i
WHERE
    i.sID == s.sID
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.008475
#[Out]# 1         Coop        16.695000
#[Out]# 2         Dirk        20.884615
#[Out]# 3    Hoogvliet        16.898438
#[Out]# 4        Jumbo        16.312500
#[Out]# 5         Lidl        25.048077
#[Out]# 6       Sligro        16.795620
query4 = '''
SELECT
    s.sName, AVG(i.quantity)
FROM
    store s, inventory i
WHERE
    i.sID == s.sID
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2 AND AVG(i.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.008475
#[Out]# 1         Coop        16.695000
#[Out]# 2         Dirk        20.884615
#[Out]# 3    Hoogvliet        16.898438
#[Out]# 4        Jumbo        16.312500
#[Out]# 5         Lidl        25.048077
#[Out]# 6       Sligro        16.795620
query4 = '''
SELECT
    s.sName
FROM
    store s, inventory i
WHERE
    i.sID == s.sID
GROUP BY
    s.sName
HAVING
    COUNT(distinct s.sID) >= 2 AND AVG(i.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
practicequery1a = '''
SELECT
    sl.cID, sl.pID, sl.date
FROM
    shoppinglist sl
GROUP BY
    sl.date

'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#     cID  pID        date
#[Out]# 0   169   21  2018-08-15
#[Out]# 1   170   28  2018-08-16
#[Out]# 2   169    3  2018-08-17
#[Out]# 3   169   22  2018-08-18
#[Out]# 4   183    5  2018-08-19
#[Out]# 5   183   10  2018-08-20
#[Out]# 6   183   18  2018-08-21
#[Out]# 7   183   25  2018-08-22
#[Out]# 8   165   25  2018-08-23
#[Out]# 9   181   26  2018-08-24
#[Out]# 10  176   24  2018-08-25
#[Out]# 11  180   26  2018-08-26
#[Out]# 12  181   21  2018-08-27
#[Out]# 13   39   23  2018-08-28
#[Out]# 14   39   28  2018-08-29
practicequery1a = '''
SELECT
    sl.cID, sl.date
FROM
    shoppinglist sl
GROUP BY
    sl.date

'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#     cID        date
#[Out]# 0   169  2018-08-15
#[Out]# 1   170  2018-08-16
#[Out]# 2   169  2018-08-17
#[Out]# 3   169  2018-08-18
#[Out]# 4   183  2018-08-19
#[Out]# 5   183  2018-08-20
#[Out]# 6   183  2018-08-21
#[Out]# 7   183  2018-08-22
#[Out]# 8   165  2018-08-23
#[Out]# 9   181  2018-08-24
#[Out]# 10  176  2018-08-25
#[Out]# 11  180  2018-08-26
#[Out]# 12  181  2018-08-27
#[Out]# 13   39  2018-08-28
#[Out]# 14   39  2018-08-29
practicequery1a = '''
SELECT
    sl.cID
FROM
    shoppinglist sl
GROUP BY
    sl.date

'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#     cID
#[Out]# 0   169
#[Out]# 1   170
#[Out]# 2   169
#[Out]# 3   169
#[Out]# 4   183
#[Out]# 5   183
#[Out]# 6   183
#[Out]# 7   183
#[Out]# 8   165
#[Out]# 9   181
#[Out]# 10  176
#[Out]# 11  180
#[Out]# 12  181
#[Out]# 13   39
#[Out]# 14   39
practicequery1a = '''
SELECT
    pur.cID, COUNT(*)
FROM
    purchase pur
WHERE
     pur.pID IN (SELECT sl.pID FROM shoppinglist sl WHERE sl.date == pur.date)
GROUP BY
    sl.date

'''

pd.read_sql_query(practicequery1a, conn)
practicequery1a = '''
SELECT
    c.cID, c.cName
FROM
    purchase pur, customer c
WHERE
     pur.pID IN (SELECT sl.pID FROM shoppinglist sl WHERE pur.date = sl.date) AND c.cID = pur.cID
GROUP BY
    pur.date
HAVING
    COUNT(*) == 0
'''

pd.read_sql_query(practicequery1a, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []

# IPython log file

# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x1fa6565a180>
query1 = '''
    SELECT p.pID, COUNT(p.tID)
    FROM purchase p,
    GROUPBY p.pID
'''

pd.read_sql_query(query1, conn)

