# IPython log file

query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    (SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    Where p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    (SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
query2 = '''
    SELECT cID, cName
    FROM customer AS c, product AS p1, product AS p2, purchase AS pr1, purchase AS pr2
    WHERE p1.pName = "Coffee" AND p2.pName = "Onions" AND p1.pID = pr1.pID AND p2.pID = pr2.pID
    GROUP BY date
'''

pd.read_sql_query(query2, conn)
query3 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query3, conn)
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    (SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor object at 0x000001C9A86C33B0>
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    (SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    (SELECT pID
    FROM purchase AS p)
    EXCEPT
    (SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    SELECT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT cID, cName
    FROM customer AS c, product AS p1, product AS p2, purchase AS pr1, purchase AS pr2
    WHERE p1.pName = "Coffee" AND p2.pName = "Onions" AND p1.pID = pr1.pID AND p2.pID = pr2.pID
    GROUP BY date
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, cName
    FROM customer AS c, product AS p1, product AS p2, purchase AS pr1, purchase AS pr2
    WHERE p1.pName = "Coffee" 
    AND p2.pName = "Onions" 
    AND p1.pID = pr1.pID 
    AND p2.pID = pr2.pID 
    AND pr1.date = pr2.date 
    AND pr1.cID = c.cID 
    AND pr2.cID = c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND NOT IN
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    EXCEPT
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    EXCEPT
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    NOT IN
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    EXCEPT
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query4 = '''
    SELECT sName
    FROM store AS s, purchase AS p, store AS s2
    WHERE s.sName = p.sName
    AND s2.sName = p.sName
    GROUP BY sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store AS s, purchase AS p, store AS s2
    WHERE s.sName = p.sName
    AND s2.sName = p.sName
    GROUP BY sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store AS s1, purchase AS p, store AS s2
    WHERE s1.sName = p.sName
    AND s2.sName = p.sName
    GROUP BY s1.sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store AS s1, purchase AS p, store AS s2
    WHERE s1.sID = p.sID
    AND s2.sID = p.sID
    AND s1.sName = s2.sName
    GROUP BY s1.sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID, s.sID = pur.sID
    GROUP BY pName, sName
    HAVING MAX(price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID
    GROUP BY pName, sName
    HAVING MAX(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0             Apples  Albert Hein
#[Out]# 1             Apples         Coop
#[Out]# 2             Apples         Dirk
#[Out]# 3             Apples    Hoogvliet
#[Out]# 4             Apples        Jumbo
#[Out]# 5             Apples         Lidl
#[Out]# 6             Apples       Sligro
#[Out]# 7            Bananas  Albert Hein
#[Out]# 8            Bananas         Coop
#[Out]# 9            Bananas         Dirk
#[Out]# 10           Bananas    Hoogvliet
#[Out]# 11           Bananas        Jumbo
#[Out]# 12           Bananas         Lidl
#[Out]# 13           Bananas       Sligro
#[Out]# 14              Beef  Albert Hein
#[Out]# 15              Beef         Coop
#[Out]# 16              Beef         Dirk
#[Out]# 17              Beef    Hoogvliet
#[Out]# 18              Beef       Sligro
#[Out]# 19             Bread  Albert Hein
#[Out]# 20             Bread         Coop
#[Out]# 21             Bread         Dirk
#[Out]# 22             Bread    Hoogvliet
#[Out]# 23             Bread        Jumbo
#[Out]# 24             Bread         Lidl
#[Out]# 25             Bread       Sligro
#[Out]# 26           Carrots  Albert Hein
#[Out]# 27           Carrots         Coop
#[Out]# 28           Carrots         Dirk
#[Out]# 29           Carrots    Hoogvliet
#[Out]# ..               ...          ...
#[Out]# 155             Rice         Dirk
#[Out]# 156             Rice    Hoogvliet
#[Out]# 157             Rice        Jumbo
#[Out]# 158             Rice         Lidl
#[Out]# 159             Rice       Sligro
#[Out]# 160           Salmon        Jumbo
#[Out]# 161  Spiced Biscuits  Albert Hein
#[Out]# 162  Spiced Biscuits         Coop
#[Out]# 163  Spiced Biscuits    Hoogvliet
#[Out]# 164  Spiced Biscuits        Jumbo
#[Out]# 165  Spiced Biscuits         Lidl
#[Out]# 166              Tea  Albert Hein
#[Out]# 167              Tea         Coop
#[Out]# 168              Tea         Dirk
#[Out]# 169              Tea    Hoogvliet
#[Out]# 170              Tea        Jumbo
#[Out]# 171              Tea         Lidl
#[Out]# 172              Tea       Sligro
#[Out]# 173         Tomatoes  Albert Hein
#[Out]# 174         Tomatoes         Coop
#[Out]# 175         Tomatoes    Hoogvliet
#[Out]# 176         Tomatoes        Jumbo
#[Out]# 177         Tomatoes         Lidl
#[Out]# 178         Tomatoes       Sligro
#[Out]# 179            Water  Albert Hein
#[Out]# 180            Water         Coop
#[Out]# 181            Water         Dirk
#[Out]# 182            Water    Hoogvliet
#[Out]# 183            Water        Jumbo
#[Out]# 184            Water       Sligro
#[Out]# 
#[Out]# [185 rows x 2 columns]
query5 = '''
    
    SELECT MAX(price)
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID
    GROUP BY pName, sName
    HAVING MAX(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#      MAX(price)
#[Out]# 0          4.30
#[Out]# 1          4.45
#[Out]# 2          4.65
#[Out]# 3          4.70
#[Out]# 4          3.50
#[Out]# 5          4.65
#[Out]# 6          4.50
#[Out]# 7          3.00
#[Out]# 8          1.65
#[Out]# 9          1.70
#[Out]# 10         1.65
#[Out]# 11         3.15
#[Out]# 12         1.80
#[Out]# 13         1.75
#[Out]# 14        13.25
#[Out]# 15        13.60
#[Out]# 16        12.80
#[Out]# 17        12.30
#[Out]# 18        13.80
#[Out]# 19         2.60
#[Out]# 20         3.25
#[Out]# 21         2.40
#[Out]# 22         2.30
#[Out]# 23         3.80
#[Out]# 24         2.30
#[Out]# 25         1.20
#[Out]# 26         2.95
#[Out]# 27         1.10
#[Out]# 28         0.90
#[Out]# 29         1.15
#[Out]# ..          ...
#[Out]# 155        2.05
#[Out]# 156        1.90
#[Out]# 157        2.10
#[Out]# 158        2.05
#[Out]# 159        1.90
#[Out]# 160        1.00
#[Out]# 161        2.00
#[Out]# 162        3.75
#[Out]# 163        2.55
#[Out]# 164        2.40
#[Out]# 165        2.50
#[Out]# 166        2.05
#[Out]# 167        1.90
#[Out]# 168        1.60
#[Out]# 169        2.05
#[Out]# 170        2.00
#[Out]# 171        2.60
#[Out]# 172        3.20
#[Out]# 173        1.65
#[Out]# 174        2.35
#[Out]# 175        2.05
#[Out]# 176        2.35
#[Out]# 177        2.20
#[Out]# 178        2.00
#[Out]# 179        0.55
#[Out]# 180        4.15
#[Out]# 181        4.35
#[Out]# 182        0.95
#[Out]# 183        0.60
#[Out]# 184        0.50
#[Out]# 
#[Out]# [185 rows x 1 columns]
query5 = '''
    
    SELECT MAX(price)
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID
'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(price)
#[Out]# 0        13.8
query5 = '''
    
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID
'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(price) pName   sName
#[Out]# 0        13.8  Beef  Sligro
query5 = '''
    
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s

'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(price)        pName sName
#[Out]# 0        13.8  Cashew Nuts  Coop
query5 = '''
    
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID

'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(price) pName   sName
#[Out]# 0        13.8  Beef  Sligro
query5 = '''
    
    SELECT pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID AND MAX(price)

'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID

'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s
    WHERE s.sID = pur.sID
    AND
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID

'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s
    WHERE s.sID = pur.sID
    AND p.pID = pur.pID
    AND pur.price =
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID

'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s
    WHERE s.sID = pur.sID
    AND p.pID = pur.pID
    AND pur.price =
    SELECT MAX(price)

'''

pd.read_sql_query(query5, conn)
query6 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query6, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND pur.price = MAX(price)


'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    GROUP BY pName, sName
    HAVING pur.price = MAX(price)


'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0             Apples  Albert Hein
#[Out]# 1             Apples         Coop
#[Out]# 2             Apples         Dirk
#[Out]# 3             Apples    Hoogvliet
#[Out]# 4             Apples        Jumbo
#[Out]# 5             Apples         Lidl
#[Out]# 6             Apples       Sligro
#[Out]# 7            Bananas  Albert Hein
#[Out]# 8            Bananas         Coop
#[Out]# 9            Bananas         Dirk
#[Out]# 10           Bananas    Hoogvliet
#[Out]# 11           Bananas        Jumbo
#[Out]# 12           Bananas         Lidl
#[Out]# 13           Bananas       Sligro
#[Out]# 14              Beef  Albert Hein
#[Out]# 15              Beef         Coop
#[Out]# 16              Beef         Dirk
#[Out]# 17              Beef    Hoogvliet
#[Out]# 18              Beef       Sligro
#[Out]# 19             Bread  Albert Hein
#[Out]# 20             Bread         Coop
#[Out]# 21             Bread         Dirk
#[Out]# 22             Bread    Hoogvliet
#[Out]# 23             Bread        Jumbo
#[Out]# 24             Bread         Lidl
#[Out]# 25             Bread       Sligro
#[Out]# 26           Carrots  Albert Hein
#[Out]# 27           Carrots         Coop
#[Out]# 28           Carrots         Dirk
#[Out]# 29           Carrots    Hoogvliet
#[Out]# ..               ...          ...
#[Out]# 155             Rice         Dirk
#[Out]# 156             Rice    Hoogvliet
#[Out]# 157             Rice        Jumbo
#[Out]# 158             Rice         Lidl
#[Out]# 159             Rice       Sligro
#[Out]# 160           Salmon        Jumbo
#[Out]# 161  Spiced Biscuits  Albert Hein
#[Out]# 162  Spiced Biscuits         Coop
#[Out]# 163  Spiced Biscuits    Hoogvliet
#[Out]# 164  Spiced Biscuits        Jumbo
#[Out]# 165  Spiced Biscuits         Lidl
#[Out]# 166              Tea  Albert Hein
#[Out]# 167              Tea         Coop
#[Out]# 168              Tea         Dirk
#[Out]# 169              Tea    Hoogvliet
#[Out]# 170              Tea        Jumbo
#[Out]# 171              Tea         Lidl
#[Out]# 172              Tea       Sligro
#[Out]# 173         Tomatoes  Albert Hein
#[Out]# 174         Tomatoes         Coop
#[Out]# 175         Tomatoes    Hoogvliet
#[Out]# 176         Tomatoes        Jumbo
#[Out]# 177         Tomatoes         Lidl
#[Out]# 178         Tomatoes       Sligro
#[Out]# 179            Water  Albert Hein
#[Out]# 180            Water         Coop
#[Out]# 181            Water         Dirk
#[Out]# 182            Water    Hoogvliet
#[Out]# 183            Water        Jumbo
#[Out]# 184            Water       Sligro
#[Out]# 
#[Out]# [185 rows x 2 columns]
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    UNION
    SELECT MAX(price)


'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    UNION
    SELECT MAX(price)
    FROM purchase as pur


'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND pur.price = 
    SELECT MAX(price)
    FROM purchase


'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND price = 
    SELECT MAX(price)
    FROM purchase


'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND price = (
    SELECT MAX(price)
    FROM purchase)


'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT DIFFERENCE(MIN(unit_price),MAX(unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = ‘2018-08-23’
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT DIFFERENCE(MIN(unit_price),MAX(unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = ‘2018-08-23’
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT DIFFERENCE(MIN(unit_price),MAX(unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT DIFFERENCE(MIN(i1.unit_price),MAX(i2.unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT DIFFERENCE(MIN(i1.unit_price),MAX(i2.unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT (MAX(i2.unit_price)-MIN(i1.unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#   (MAX(i2.unit_price)-MIN(i1.unit_price))
#[Out]# 0                                    None
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#   MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  None
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    AND i1.unit_price = (
    SELECT MAX(unit_price)
    FROM inventory)
    AND i2.unit_price = (
    SELECT MIN(unit_price)
    FROM inventory)
'''

pd.read_sql_query(query6, conn)
#[Out]#   MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  None
practicequery1a = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1a, conn)
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    AND i1.unit_price = (
    SELECT MAX(unit_price)
    FROM inventory)
    AND i2.unit_price = (
    SELECT MIN(unit_price)
    FROM inventory)
'''

pd.read_sql_query(query6, conn)
#[Out]#   MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  None
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND price = (
    SELECT MAX(price)
    FROM purchase)


'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT 
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    AND i1.unit_price = (
    SELECT MAX(unit_price)
    FROM inventory)
    AND i2.unit_price = (
    SELECT MIN(unit_price)
    FROM inventory)
'''

pd.read_sql_query(query6, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND price = (
    SELECT MAX(price)
    FROM purchase)


'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#   MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  None
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  12.95
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  12.95
query6 = '''
    SELECT *
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#      sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0     51   10  2018-08-23        31        0.60   34   10  2018-08-23   
#[Out]# 1     51   10  2018-08-23        31        0.60   50   10  2018-08-23   
#[Out]# 2     57   19  2018-08-23        12        2.95    3   19  2018-08-23   
#[Out]# 3     57   19  2018-08-23        12        2.95   17   19  2018-08-23   
#[Out]# 4     57   19  2018-08-23        12        2.95   33   19  2018-08-23   
#[Out]# 5     57   19  2018-08-23        12        2.95   44   19  2018-08-23   
#[Out]# 6     38   23  2018-08-23        29        1.80   21   23  2018-08-23   
#[Out]# 7     35   13  2018-08-23        28        4.15    4   13  2018-08-23   
#[Out]# 8     35   13  2018-08-23        28        4.15   12   13  2018-08-23   
#[Out]# 9     35   13  2018-08-23        28        4.15   45   13  2018-08-23   
#[Out]# 10    45   13  2018-08-23        32        4.10    4   13  2018-08-23   
#[Out]# 11    45   13  2018-08-23        32        4.10   12   13  2018-08-23   
#[Out]# 12    45   13  2018-08-23        32        4.10   35   13  2018-08-23   
#[Out]# 13     5   17  2018-08-23        34        2.45   29   17  2018-08-23   
#[Out]# 14    13   15  2018-08-23        11        1.25    6   15  2018-08-23   
#[Out]# 15    13   15  2018-08-23        11        1.25   11   15  2018-08-23   
#[Out]# 16    13   15  2018-08-23        11        1.25   12   15  2018-08-23   
#[Out]# 17    50   10  2018-08-23        54        0.55   34   10  2018-08-23   
#[Out]# 18    50   10  2018-08-23        54        0.55   51   10  2018-08-23   
#[Out]# 19     7    1  2018-08-23        18        5.80   41    1  2018-08-23   
#[Out]# 20     7    1  2018-08-23        18        5.80   55    1  2018-08-23   
#[Out]# 21     7    1  2018-08-23        18        5.80   56    1  2018-08-23   
#[Out]# 22     2   11  2018-08-23        21        1.00   33   11  2018-08-23   
#[Out]# 23     2   11  2018-08-23        21        1.00   35   11  2018-08-23   
#[Out]# 24    28   27  2018-08-23        43        8.50   35   27  2018-08-23   
#[Out]# 25    28   27  2018-08-23        43        8.50   40   27  2018-08-23   
#[Out]# 26    35   25  2018-08-23        36        4.00   56   25  2018-08-23   
#[Out]# 27    41    1  2018-08-23        53        4.60    7    1  2018-08-23   
#[Out]# 28    41    1  2018-08-23        53        4.60   55    1  2018-08-23   
#[Out]# 29    41    1  2018-08-23        53        4.60   56    1  2018-08-23   
#[Out]# ..   ...  ...         ...       ...         ...  ...  ...         ...   
#[Out]# 124   12   13  2018-08-23        15        3.55   45   13  2018-08-23   
#[Out]# 125   35   11  2018-08-23        15        1.20    2   11  2018-08-23   
#[Out]# 126   35   11  2018-08-23        15        1.20   33   11  2018-08-23   
#[Out]# 127   55    1  2018-08-23         1        4.80    7    1  2018-08-23   
#[Out]# 128   55    1  2018-08-23         1        4.80   41    1  2018-08-23   
#[Out]# 129   55    1  2018-08-23         1        4.80   56    1  2018-08-23   
#[Out]# 130   54   12  2018-08-23         5       12.55    5   12  2018-08-23   
#[Out]# 131   54   12  2018-08-23         5       12.55    9   12  2018-08-23   
#[Out]# 132   54   12  2018-08-23         5       12.55   42   12  2018-08-23   
#[Out]# 133   11   15  2018-08-23        14        1.30    6   15  2018-08-23   
#[Out]# 134   11   15  2018-08-23        14        1.30   12   15  2018-08-23   
#[Out]# 135   11   15  2018-08-23        14        1.30   13   15  2018-08-23   
#[Out]# 136   35    7  2018-08-23         7        2.20   43    7  2018-08-23   
#[Out]# 137   35    7  2018-08-23         7        2.20   47    7  2018-08-23   
#[Out]# 138    6   15  2018-08-23         4        1.00   11   15  2018-08-23   
#[Out]# 139    6   15  2018-08-23         4        1.00   12   15  2018-08-23   
#[Out]# 140    6   15  2018-08-23         4        1.00   13   15  2018-08-23   
#[Out]# 141   37   28  2018-08-23        19        7.75   32   28  2018-08-23   
#[Out]# 142   37   28  2018-08-23        19        7.75   52   28  2018-08-23   
#[Out]# 143   25    8  2018-08-23         6        5.55   33    8  2018-08-23   
#[Out]# 144    9   12  2018-08-23         5       13.15    5   12  2018-08-23   
#[Out]# 145    9   12  2018-08-23         5       13.15   42   12  2018-08-23   
#[Out]# 146    9   12  2018-08-23         5       13.15   54   12  2018-08-23   
#[Out]# 147   38   24  2018-08-23        10        3.55    5   24  2018-08-23   
#[Out]# 148   56    1  2018-08-23         1        4.40    7    1  2018-08-23   
#[Out]# 149   56    1  2018-08-23         1        4.40   41    1  2018-08-23   
#[Out]# 150   56    1  2018-08-23         1        4.40   55    1  2018-08-23   
#[Out]# 151    4   13  2018-08-23        23        4.20   12   13  2018-08-23   
#[Out]# 152    4   13  2018-08-23        23        4.20   35   13  2018-08-23   
#[Out]# 153    4   13  2018-08-23        23        4.20   45   13  2018-08-23   
#[Out]# 
#[Out]#      quantity  unit_price  
#[Out]# 0           8        0.45  
#[Out]# 1          54        0.55  
#[Out]# 2          11        2.10  
#[Out]# 3          10        2.20  
#[Out]# 4          32        2.25  
#[Out]# 5           4        2.65  
#[Out]# 6          20        2.10  
#[Out]# 7          23        4.20  
#[Out]# 8          15        3.55  
#[Out]# 9          32        4.10  
#[Out]# 10         23        4.20  
#[Out]# 11         15        3.55  
#[Out]# 12         28        4.15  
#[Out]# 13          4        1.95  
#[Out]# 14          4        1.00  
#[Out]# 15         14        1.30  
#[Out]# 16          1        1.25  
#[Out]# 17          8        0.45  
#[Out]# 18         31        0.60  
#[Out]# 19         53        4.60  
#[Out]# 20          1        4.80  
#[Out]# 21          1        4.40  
#[Out]# 22         32        1.05  
#[Out]# 23         15        1.20  
#[Out]# 24         54        8.85  
#[Out]# 25         17        6.90  
#[Out]# 26         19        4.35  
#[Out]# 27         18        5.80  
#[Out]# 28          1        4.80  
#[Out]# 29          1        4.40  
#[Out]# ..        ...         ...  
#[Out]# 124        32        4.10  
#[Out]# 125        21        1.00  
#[Out]# 126        32        1.05  
#[Out]# 127        18        5.80  
#[Out]# 128        53        4.60  
#[Out]# 129         1        4.40  
#[Out]# 130        11       13.40  
#[Out]# 131         5       13.15  
#[Out]# 132        46       11.40  
#[Out]# 133         4        1.00  
#[Out]# 134         1        1.25  
#[Out]# 135        11        1.25  
#[Out]# 136        20        1.95  
#[Out]# 137        27        1.85  
#[Out]# 138        14        1.30  
#[Out]# 139         1        1.25  
#[Out]# 140        11        1.25  
#[Out]# 141        36        6.85  
#[Out]# 142         8        7.35  
#[Out]# 143        16        4.80  
#[Out]# 144        11       13.40  
#[Out]# 145        46       11.40  
#[Out]# 146         5       12.55  
#[Out]# 147        32        4.10  
#[Out]# 148        18        5.80  
#[Out]# 149        53        4.60  
#[Out]# 150         1        4.80  
#[Out]# 151        15        3.55  
#[Out]# 152        28        4.15  
#[Out]# 153        32        4.10  
#[Out]# 
#[Out]# [154 rows x 10 columns]
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                    0.80
#[Out]# 1                                    1.40
#[Out]# 2                                    0.40
#[Out]# 3                                    0.20
#[Out]# 4                                    0.35
#[Out]# 5                                    0.75
#[Out]# 6                                    0.15
#[Out]# 7                                    0.20
#[Out]# 8                                    2.00
#[Out]# 9                                    0.65
#[Out]# 10                                   0.90
#[Out]# 11                                   0.30
#[Out]# 12                                   0.35
#[Out]# 13                                   0.50
#[Out]# 14                                   0.85
#[Out]# 15                                   0.50
#[Out]# 16                                   0.30
#[Out]# 17                                   0.55
#[Out]# 18                                   0.35
#[Out]# 19                                   1.95
#[Out]# 20                                   0.90
query6 = '''
    SELECT *
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0    31    0  2018-08-23        25        4.60   29    0  2018-08-23   
#[Out]# 1    56    1  2018-08-23         1        4.40   55    1  2018-08-23   
#[Out]# 2    12    2  2018-08-23         3        1.70   11    2  2018-08-23   
#[Out]# 3    45    4  2018-08-23        50        1.00   19    4  2018-08-23   
#[Out]# 4    47    7  2018-08-23        27        1.85   43    7  2018-08-23   
#[Out]# 5    33    8  2018-08-23        16        4.80   25    8  2018-08-23   
#[Out]# 6    51   10  2018-08-23        31        0.60   50   10  2018-08-23   
#[Out]# 7    35   11  2018-08-23        15        1.20   33   11  2018-08-23   
#[Out]# 8    54   12  2018-08-23         5       12.55   42   12  2018-08-23   
#[Out]# 9    45   13  2018-08-23        32        4.10   35   13  2018-08-23   
#[Out]# 10   50   14  2018-08-23        19        3.85   41   14  2018-08-23   
#[Out]# 11   13   15  2018-08-23        11        1.25   12   15  2018-08-23   
#[Out]# 12   11   16  2018-08-23         3        1.90    6   16  2018-08-23   
#[Out]# 13   29   17  2018-08-23         4        1.95    5   17  2018-08-23   
#[Out]# 14   57   19  2018-08-23        12        2.95   44   19  2018-08-23   
#[Out]# 15   51   22  2018-08-23        13        1.55   50   22  2018-08-23   
#[Out]# 16   38   23  2018-08-23        29        1.80   21   23  2018-08-23   
#[Out]# 17   38   24  2018-08-23        10        3.55    5   24  2018-08-23   
#[Out]# 18   56   25  2018-08-23        19        4.35   35   25  2018-08-23   
#[Out]# 19   40   27  2018-08-23        17        6.90   35   27  2018-08-23   
#[Out]# 20   52   28  2018-08-23         8        7.35   37   28  2018-08-23   
#[Out]# 
#[Out]#     quantity  unit_price  
#[Out]# 0         28        5.15  
#[Out]# 1          1        4.80  
#[Out]# 2         22        2.10  
#[Out]# 3         53        1.20  
#[Out]# 4         20        1.95  
#[Out]# 5          6        5.55  
#[Out]# 6         54        0.55  
#[Out]# 7         32        1.05  
#[Out]# 8         46       11.40  
#[Out]# 9         28        4.15  
#[Out]# 10         3        3.35  
#[Out]# 11         1        1.25  
#[Out]# 12        14        1.85  
#[Out]# 13        34        2.45  
#[Out]# 14         4        2.65  
#[Out]# 15         5        1.95  
#[Out]# 16        20        2.10  
#[Out]# 17        32        4.10  
#[Out]# 18        36        4.00  
#[Out]# 19        54        8.85  
#[Out]# 20        19        7.75  
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                    0.80
#[Out]# 1                                    1.40
#[Out]# 2                                    0.40
#[Out]# 3                                    0.20
#[Out]# 4                                    0.35
#[Out]# 5                                    0.75
#[Out]# 6                                    0.15
#[Out]# 7                                    0.20
#[Out]# 8                                    2.00
#[Out]# 9                                    0.65
#[Out]# 10                                   0.90
#[Out]# 11                                   0.30
#[Out]# 12                                   0.35
#[Out]# 13                                   0.50
#[Out]# 14                                   0.85
#[Out]# 15                                   0.50
#[Out]# 16                                   0.30
#[Out]# 17                                   0.55
#[Out]# 18                                   0.35
#[Out]# 19                                   1.95
#[Out]# 20                                   0.90
query6 = '''
    WITH difference(unit_price) as(
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID)
    SELECT MAX(unit_price)
    FROM difference
    
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(unit_price)
#[Out]# 0              2.0
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    EXCEPT
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query4 = '''
    SELECT s1.sName
    FROM store AS s1, purchase AS p, store AS s2
    WHERE s1.sID = p.sID
    AND s2.sID = p.sID
    AND s1.sName = s2.sName
    GROUP BY s1.sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND price = (
    SELECT MAX(price)
    FROM purchase)


'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    NOT IN
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, purchase AS p, store AS s1, store AS s2
    WHERE cust.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2
    WHERE cust.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2
    WHERE cust.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query4 = '''
    SELECT s1.sName
    FROM store AS s1, purchase AS p, store AS s2
    WHERE s1.sID = p.sID
    AND s2.sID = p.sID
    AND s1.sName = s2.sName
    GROUP BY s1.sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#        cID
#[Out]# 0        0
#[Out]# 1        0
#[Out]# 2        0
#[Out]# 3        0
#[Out]# 4        0
#[Out]# 5        0
#[Out]# 6        0
#[Out]# 7        0
#[Out]# 8        0
#[Out]# 9        0
#[Out]# 10       0
#[Out]# 11       0
#[Out]# 12       0
#[Out]# 13       0
#[Out]# 14       0
#[Out]# 15       0
#[Out]# 16       0
#[Out]# 17       0
#[Out]# 18       0
#[Out]# 19       0
#[Out]# 20       0
#[Out]# 21       0
#[Out]# 22       0
#[Out]# 23       0
#[Out]# 24       0
#[Out]# 25       0
#[Out]# 26       0
#[Out]# 27       0
#[Out]# 28       0
#[Out]# 29       0
#[Out]# ...    ...
#[Out]# 96171  190
#[Out]# 96172  190
#[Out]# 96173  190
#[Out]# 96174  190
#[Out]# 96175  190
#[Out]# 96176  190
#[Out]# 96177  190
#[Out]# 96178  190
#[Out]# 96179  190
#[Out]# 96180  190
#[Out]# 96181  190
#[Out]# 96182  190
#[Out]# 96183  190
#[Out]# 96184  190
#[Out]# 96185  190
#[Out]# 96186  190
#[Out]# 96187  190
#[Out]# 96188  190
#[Out]# 96189  190
#[Out]# 96190  190
#[Out]# 96191  190
#[Out]# 96192  190
#[Out]# 96193  190
#[Out]# 96194  190
#[Out]# 96195  190
#[Out]# 96196  190
#[Out]# 96197  190
#[Out]# 96198  190
#[Out]# 96199  190
#[Out]# 96200  190
#[Out]# 
#[Out]# [96201 rows x 1 columns]
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#        cID
#[Out]# 0        0
#[Out]# 1        0
#[Out]# 2        0
#[Out]# 3        0
#[Out]# 4        0
#[Out]# 5        0
#[Out]# 6        0
#[Out]# 7        0
#[Out]# 8        0
#[Out]# 9        0
#[Out]# 10       0
#[Out]# 11       0
#[Out]# 12       0
#[Out]# 13       0
#[Out]# 14       0
#[Out]# 15       0
#[Out]# 16       0
#[Out]# 17       0
#[Out]# 18       0
#[Out]# 19       0
#[Out]# 20       0
#[Out]# 21       0
#[Out]# 22       0
#[Out]# 23       0
#[Out]# 24       0
#[Out]# 25       0
#[Out]# 26       0
#[Out]# 27       0
#[Out]# 28       0
#[Out]# 29       0
#[Out]# ...    ...
#[Out]# 96171  190
#[Out]# 96172  190
#[Out]# 96173  190
#[Out]# 96174  190
#[Out]# 96175  190
#[Out]# 96176  190
#[Out]# 96177  190
#[Out]# 96178  190
#[Out]# 96179  190
#[Out]# 96180  190
#[Out]# 96181  190
#[Out]# 96182  190
#[Out]# 96183  190
#[Out]# 96184  190
#[Out]# 96185  190
#[Out]# 96186  190
#[Out]# 96187  190
#[Out]# 96188  190
#[Out]# 96189  190
#[Out]# 96190  190
#[Out]# 96191  190
#[Out]# 96192  190
#[Out]# 96193  190
#[Out]# 96194  190
#[Out]# 96195  190
#[Out]# 96196  190
#[Out]# 96197  190
#[Out]# 96198  190
#[Out]# 96199  190
#[Out]# 96200  190
#[Out]# 
#[Out]# [96201 rows x 1 columns]
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#        cID
#[Out]# 0        0
#[Out]# 1        0
#[Out]# 2        0
#[Out]# 3        0
#[Out]# 4        0
#[Out]# 5        0
#[Out]# 6        0
#[Out]# 7        0
#[Out]# 8        0
#[Out]# 9        0
#[Out]# 10       0
#[Out]# 11       0
#[Out]# 12       0
#[Out]# 13       0
#[Out]# 14       0
#[Out]# 15       0
#[Out]# 16       0
#[Out]# 17       0
#[Out]# 18       0
#[Out]# 19       0
#[Out]# 20       0
#[Out]# 21       0
#[Out]# 22       0
#[Out]# 23       0
#[Out]# 24       0
#[Out]# 25       0
#[Out]# 26       0
#[Out]# 27       0
#[Out]# 28       0
#[Out]# 29       0
#[Out]# ...    ...
#[Out]# 96171  190
#[Out]# 96172  190
#[Out]# 96173  190
#[Out]# 96174  190
#[Out]# 96175  190
#[Out]# 96176  190
#[Out]# 96177  190
#[Out]# 96178  190
#[Out]# 96179  190
#[Out]# 96180  190
#[Out]# 96181  190
#[Out]# 96182  190
#[Out]# 96183  190
#[Out]# 96184  190
#[Out]# 96185  190
#[Out]# 96186  190
#[Out]# 96187  190
#[Out]# 96188  190
#[Out]# 96189  190
#[Out]# 96190  190
#[Out]# 96191  190
#[Out]# 96192  190
#[Out]# 96193  190
#[Out]# 96194  190
#[Out]# 96195  190
#[Out]# 96196  190
#[Out]# 96197  190
#[Out]# 96198  190
#[Out]# 96199  190
#[Out]# 96200  190
#[Out]# 
#[Out]# [96201 rows x 1 columns]
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
    GROUP BY cust.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID
    GROUP BY cust.cID)
    
'''

pd.read_sql_query(query3, conn)
#[Out]#        cID
#[Out]# 0        0
#[Out]# 1        0
#[Out]# 2        0
#[Out]# 3        0
#[Out]# 4        0
#[Out]# 5        0
#[Out]# 6        0
#[Out]# 7        0
#[Out]# 8        0
#[Out]# 9        0
#[Out]# 10       0
#[Out]# 11       0
#[Out]# 12       0
#[Out]# 13       0
#[Out]# 14       0
#[Out]# 15       0
#[Out]# 16       0
#[Out]# 17       0
#[Out]# 18       0
#[Out]# 19       0
#[Out]# 20       0
#[Out]# 21       0
#[Out]# 22       0
#[Out]# 23       0
#[Out]# 24       0
#[Out]# 25       0
#[Out]# 26       0
#[Out]# 27       0
#[Out]# 28       0
#[Out]# 29       0
#[Out]# ...    ...
#[Out]# 96171  190
#[Out]# 96172  190
#[Out]# 96173  190
#[Out]# 96174  190
#[Out]# 96175  190
#[Out]# 96176  190
#[Out]# 96177  190
#[Out]# 96178  190
#[Out]# 96179  190
#[Out]# 96180  190
#[Out]# 96181  190
#[Out]# 96182  190
#[Out]# 96183  190
#[Out]# 96184  190
#[Out]# 96185  190
#[Out]# 96186  190
#[Out]# 96187  190
#[Out]# 96188  190
#[Out]# 96189  190
#[Out]# 96190  190
#[Out]# 96191  190
#[Out]# 96192  190
#[Out]# 96193  190
#[Out]# 96194  190
#[Out]# 96195  190
#[Out]# 96196  190
#[Out]# 96197  190
#[Out]# 96198  190
#[Out]# 96199  190
#[Out]# 96200  190
#[Out]# 
#[Out]# [96201 rows x 1 columns]
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID
    GROUP BY cust.cID)
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      6
#[Out]# 7      7
#[Out]# 8      8
#[Out]# 9      9
#[Out]# 10    10
#[Out]# 11    11
#[Out]# 12    12
#[Out]# 13    13
#[Out]# 14    14
#[Out]# 15    15
#[Out]# 16    16
#[Out]# 17    17
#[Out]# 18    18
#[Out]# 19    19
#[Out]# 20    20
#[Out]# 21    21
#[Out]# 22    22
#[Out]# 23    23
#[Out]# 24    24
#[Out]# 25    25
#[Out]# 26    26
#[Out]# 27    27
#[Out]# 28    28
#[Out]# 29    29
#[Out]# ..   ...
#[Out]# 160  160
#[Out]# 161  161
#[Out]# 162  162
#[Out]# 163  163
#[Out]# 164  164
#[Out]# 165  165
#[Out]# 166  166
#[Out]# 167  167
#[Out]# 168  168
#[Out]# 169  169
#[Out]# 170  170
#[Out]# 171  171
#[Out]# 172  172
#[Out]# 173  173
#[Out]# 174  174
#[Out]# 175  175
#[Out]# 176  176
#[Out]# 177  177
#[Out]# 178  178
#[Out]# 179  179
#[Out]# 180  180
#[Out]# 181  181
#[Out]# 182  182
#[Out]# 183  183
#[Out]# 184  184
#[Out]# 185  185
#[Out]# 186  186
#[Out]# 187  188
#[Out]# 188  189
#[Out]# 189  190
#[Out]# 
#[Out]# [190 rows x 1 columns]
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID
    )
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      6
#[Out]# 7      7
#[Out]# 8      8
#[Out]# 9      9
#[Out]# 10    10
#[Out]# 11    11
#[Out]# 12    12
#[Out]# 13    13
#[Out]# 14    14
#[Out]# 15    15
#[Out]# 16    16
#[Out]# 17    17
#[Out]# 18    18
#[Out]# 19    19
#[Out]# 20    20
#[Out]# 21    21
#[Out]# 22    22
#[Out]# 23    23
#[Out]# 24    24
#[Out]# 25    25
#[Out]# 26    26
#[Out]# 27    27
#[Out]# 28    28
#[Out]# 29    29
#[Out]# ..   ...
#[Out]# 160  160
#[Out]# 161  161
#[Out]# 162  162
#[Out]# 163  163
#[Out]# 164  164
#[Out]# 165  165
#[Out]# 166  166
#[Out]# 167  167
#[Out]# 168  168
#[Out]# 169  169
#[Out]# 170  170
#[Out]# 171  171
#[Out]# 172  172
#[Out]# 173  173
#[Out]# 174  174
#[Out]# 175  175
#[Out]# 176  176
#[Out]# 177  177
#[Out]# 178  178
#[Out]# 179  179
#[Out]# 180  180
#[Out]# 181  181
#[Out]# 182  182
#[Out]# 183  183
#[Out]# 184  184
#[Out]# 185  185
#[Out]# 186  186
#[Out]# 187  188
#[Out]# 188  189
#[Out]# 189  190
#[Out]# 
#[Out]# [190 rows x 1 columns]
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c
    WHERE NOT EXISTS 
    (SELECT sID
    FROM store as s
    WHERE NOT EXISTS (
    SELECT tID
    FROM purchase
    WHERE c.cID = p.cID
    AND s.sID = p.sID
    ))
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c
    WHERE NOT EXISTS 
    (SELECT sID
    FROM store as s
    WHERE NOT EXISTS (
    SELECT tID
    FROM purchase AS p
    WHERE c.cID = p.cID
    AND s.sID = p.sID
    ))
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    SELECT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT c.cID, cName
    FROM customer AS c, product AS p1, product AS p2, purchase AS pr1, purchase AS pr2
    WHERE p1.pName = "Coffee" 
    AND p2.pName = "Onions" 
    AND p1.pID = pr1.pID 
    AND p2.pID = pr2.pID 
    AND pr1.date = pr2.date 
    AND pr1.cID = c.cID 
    AND pr2.cID = c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c
    WHERE NOT EXISTS 
    (SELECT sID
    FROM store as s
    WHERE NOT EXISTS (
    SELECT tID
    FROM purchase AS p
    WHERE c.cID = p.cID
    AND s.sID = p.sID
    ))
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT  c.cID
    FROM customer AS c
    WHERE NOT EXISTS 
    (SELECT sID
    FROM store as s
    WHERE NOT EXISTS (
    SELECT tID
    FROM purchase AS p
    WHERE c.cID = p.cID
    AND s.sID = p.sID
    ))
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT  c.cID
    FROM customer AS c
    WHERE NOT EXISTS 
    (SELECT sID
    FROM store as s
    WHERE NOT EXISTS (
    SELECT tID
    FROM purchase AS p
    WHERE c.cID = p.cID
    AND s.sID = p.sID
    ))
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c
    WHERE NOT EXISTS 
    (SELECT sID
    FROM store as s
    WHERE NOT EXISTS (
    SELECT tID
    FROM purchase AS p
    WHERE c.cID = p.cID
    AND s.sID = p.sID
    ))
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c
    WHERE NOT EXISTS 
    (SELECT sID
    FROM store as s
    WHERE NOT EXISTS (
    SELECT tID
    FROM purchase AS p
    WHERE c.cID = p.cID
    AND s.sID = p.sID
    ))
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT s1.sName
    FROM store AS s1, purchase AS p, store AS s2
    WHERE s1.sID = p.sID
    AND s2.sID = p.sID
    AND s1.sName = s2.sName
    GROUP BY s1.sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query6 = '''

    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID)
    SELECT MAX(unit_price)

    
'''

pd.read_sql_query(query6, conn)
query6 = '''

    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID)

    
'''

pd.read_sql_query(query6, conn)
query6 = '''

    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID


    
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  12.95
query6 = '''
    WITH difference(unit_price) as(
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID)
    SELECT MAX(unit_price)
    FROM difference
    
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(unit_price)
#[Out]# 0              2.0
query6 = '''

    SELECT *
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID)
    SELECT MAX(unit_price)

    
'''

pd.read_sql_query(query6, conn)
query6 = '''

    SELECT *
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID


    
'''

pd.read_sql_query(query6, conn)
#[Out]#      sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0     51   10  2018-08-23        31        0.60   34   10  2018-08-23   
#[Out]# 1     51   10  2018-08-23        31        0.60   50   10  2018-08-23   
#[Out]# 2     57   19  2018-08-23        12        2.95    3   19  2018-08-23   
#[Out]# 3     57   19  2018-08-23        12        2.95   17   19  2018-08-23   
#[Out]# 4     57   19  2018-08-23        12        2.95   33   19  2018-08-23   
#[Out]# 5     57   19  2018-08-23        12        2.95   44   19  2018-08-23   
#[Out]# 6     38   23  2018-08-23        29        1.80   21   23  2018-08-23   
#[Out]# 7     35   13  2018-08-23        28        4.15    4   13  2018-08-23   
#[Out]# 8     35   13  2018-08-23        28        4.15   12   13  2018-08-23   
#[Out]# 9     35   13  2018-08-23        28        4.15   45   13  2018-08-23   
#[Out]# 10    45   13  2018-08-23        32        4.10    4   13  2018-08-23   
#[Out]# 11    45   13  2018-08-23        32        4.10   12   13  2018-08-23   
#[Out]# 12    45   13  2018-08-23        32        4.10   35   13  2018-08-23   
#[Out]# 13     5   17  2018-08-23        34        2.45   29   17  2018-08-23   
#[Out]# 14    13   15  2018-08-23        11        1.25    6   15  2018-08-23   
#[Out]# 15    13   15  2018-08-23        11        1.25   11   15  2018-08-23   
#[Out]# 16    13   15  2018-08-23        11        1.25   12   15  2018-08-23   
#[Out]# 17    50   10  2018-08-23        54        0.55   34   10  2018-08-23   
#[Out]# 18    50   10  2018-08-23        54        0.55   51   10  2018-08-23   
#[Out]# 19     7    1  2018-08-23        18        5.80   41    1  2018-08-23   
#[Out]# 20     7    1  2018-08-23        18        5.80   55    1  2018-08-23   
#[Out]# 21     7    1  2018-08-23        18        5.80   56    1  2018-08-23   
#[Out]# 22     2   11  2018-08-23        21        1.00   33   11  2018-08-23   
#[Out]# 23     2   11  2018-08-23        21        1.00   35   11  2018-08-23   
#[Out]# 24    28   27  2018-08-23        43        8.50   35   27  2018-08-23   
#[Out]# 25    28   27  2018-08-23        43        8.50   40   27  2018-08-23   
#[Out]# 26    35   25  2018-08-23        36        4.00   56   25  2018-08-23   
#[Out]# 27    41    1  2018-08-23        53        4.60    7    1  2018-08-23   
#[Out]# 28    41    1  2018-08-23        53        4.60   55    1  2018-08-23   
#[Out]# 29    41    1  2018-08-23        53        4.60   56    1  2018-08-23   
#[Out]# ..   ...  ...         ...       ...         ...  ...  ...         ...   
#[Out]# 124   12   13  2018-08-23        15        3.55   45   13  2018-08-23   
#[Out]# 125   35   11  2018-08-23        15        1.20    2   11  2018-08-23   
#[Out]# 126   35   11  2018-08-23        15        1.20   33   11  2018-08-23   
#[Out]# 127   55    1  2018-08-23         1        4.80    7    1  2018-08-23   
#[Out]# 128   55    1  2018-08-23         1        4.80   41    1  2018-08-23   
#[Out]# 129   55    1  2018-08-23         1        4.80   56    1  2018-08-23   
#[Out]# 130   54   12  2018-08-23         5       12.55    5   12  2018-08-23   
#[Out]# 131   54   12  2018-08-23         5       12.55    9   12  2018-08-23   
#[Out]# 132   54   12  2018-08-23         5       12.55   42   12  2018-08-23   
#[Out]# 133   11   15  2018-08-23        14        1.30    6   15  2018-08-23   
#[Out]# 134   11   15  2018-08-23        14        1.30   12   15  2018-08-23   
#[Out]# 135   11   15  2018-08-23        14        1.30   13   15  2018-08-23   
#[Out]# 136   35    7  2018-08-23         7        2.20   43    7  2018-08-23   
#[Out]# 137   35    7  2018-08-23         7        2.20   47    7  2018-08-23   
#[Out]# 138    6   15  2018-08-23         4        1.00   11   15  2018-08-23   
#[Out]# 139    6   15  2018-08-23         4        1.00   12   15  2018-08-23   
#[Out]# 140    6   15  2018-08-23         4        1.00   13   15  2018-08-23   
#[Out]# 141   37   28  2018-08-23        19        7.75   32   28  2018-08-23   
#[Out]# 142   37   28  2018-08-23        19        7.75   52   28  2018-08-23   
#[Out]# 143   25    8  2018-08-23         6        5.55   33    8  2018-08-23   
#[Out]# 144    9   12  2018-08-23         5       13.15    5   12  2018-08-23   
#[Out]# 145    9   12  2018-08-23         5       13.15   42   12  2018-08-23   
#[Out]# 146    9   12  2018-08-23         5       13.15   54   12  2018-08-23   
#[Out]# 147   38   24  2018-08-23        10        3.55    5   24  2018-08-23   
#[Out]# 148   56    1  2018-08-23         1        4.40    7    1  2018-08-23   
#[Out]# 149   56    1  2018-08-23         1        4.40   41    1  2018-08-23   
#[Out]# 150   56    1  2018-08-23         1        4.40   55    1  2018-08-23   
#[Out]# 151    4   13  2018-08-23        23        4.20   12   13  2018-08-23   
#[Out]# 152    4   13  2018-08-23        23        4.20   35   13  2018-08-23   
#[Out]# 153    4   13  2018-08-23        23        4.20   45   13  2018-08-23   
#[Out]# 
#[Out]#      quantity  unit_price  
#[Out]# 0           8        0.45  
#[Out]# 1          54        0.55  
#[Out]# 2          11        2.10  
#[Out]# 3          10        2.20  
#[Out]# 4          32        2.25  
#[Out]# 5           4        2.65  
#[Out]# 6          20        2.10  
#[Out]# 7          23        4.20  
#[Out]# 8          15        3.55  
#[Out]# 9          32        4.10  
#[Out]# 10         23        4.20  
#[Out]# 11         15        3.55  
#[Out]# 12         28        4.15  
#[Out]# 13          4        1.95  
#[Out]# 14          4        1.00  
#[Out]# 15         14        1.30  
#[Out]# 16          1        1.25  
#[Out]# 17          8        0.45  
#[Out]# 18         31        0.60  
#[Out]# 19         53        4.60  
#[Out]# 20          1        4.80  
#[Out]# 21          1        4.40  
#[Out]# 22         32        1.05  
#[Out]# 23         15        1.20  
#[Out]# 24         54        8.85  
#[Out]# 25         17        6.90  
#[Out]# 26         19        4.35  
#[Out]# 27         18        5.80  
#[Out]# 28          1        4.80  
#[Out]# 29          1        4.40  
#[Out]# ..        ...         ...  
#[Out]# 124        32        4.10  
#[Out]# 125        21        1.00  
#[Out]# 126        32        1.05  
#[Out]# 127        18        5.80  
#[Out]# 128        53        4.60  
#[Out]# 129         1        4.40  
#[Out]# 130        11       13.40  
#[Out]# 131         5       13.15  
#[Out]# 132        46       11.40  
#[Out]# 133         4        1.00  
#[Out]# 134         1        1.25  
#[Out]# 135        11        1.25  
#[Out]# 136        20        1.95  
#[Out]# 137        27        1.85  
#[Out]# 138        14        1.30  
#[Out]# 139         1        1.25  
#[Out]# 140        11        1.25  
#[Out]# 141        36        6.85  
#[Out]# 142         8        7.35  
#[Out]# 143        16        4.80  
#[Out]# 144        11       13.40  
#[Out]# 145        46       11.40  
#[Out]# 146         5       12.55  
#[Out]# 147        32        4.10  
#[Out]# 148        18        5.80  
#[Out]# 149        53        4.60  
#[Out]# 150         1        4.80  
#[Out]# 151        15        3.55  
#[Out]# 152        28        4.15  
#[Out]# 153        32        4.10  
#[Out]# 
#[Out]# [154 rows x 10 columns]
query6 = '''
    WITH difference(unit_price) as(
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID)
    SELECT MAX(unit_price)
    FROM difference
    
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(unit_price)
#[Out]# 0              2.0
query6 = '''
    WITH difference(unit_price) as(
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID)
    SELECT MAX(unit_price)
    FROM difference
    
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(unit_price)
#[Out]# 0              2.0
query6 = '''
    WITH difference(unit_price) as(
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID)
    SELECT MAX(unit_price)
    FROM difference
    
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(unit_price)
#[Out]# 0              2.0
query6 = '''
    WITH difference(unit_price) as(
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID)
    SELECT MAX(unit_price)
    FROM difference
    
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(unit_price)
#[Out]# 0              2.0

# IPython log file

query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    (SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    Where p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    (SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
query2 = '''
    SELECT cID, cName
    FROM customer AS c, product AS p1, product AS p2, purchase AS pr1, purchase AS pr2
    WHERE p1.pName = "Coffee" AND p2.pName = "Onions" AND p1.pID = pr1.pID AND p2.pID = pr2.pID
    GROUP BY date
'''

pd.read_sql_query(query2, conn)
query3 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query3, conn)
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    (SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x1c9a86c33b0>
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    (SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    (SELECT pID
    FROM purchase AS p)
    EXCEPT
    (SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    SELECT pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase AS p
    EXCEPT
    SELECT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.cID <> p2.cID AND
    p1.cID <> p3.cID AND
    p2.cID <> p3.cID AND
    p1.pID = p2.pID AND
    p2.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT cID, cName
    FROM customer AS c, product AS p1, product AS p2, purchase AS pr1, purchase AS pr2
    WHERE p1.pName = "Coffee" AND p2.pName = "Onions" AND p1.pID = pr1.pID AND p2.pID = pr2.pID
    GROUP BY date
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, cName
    FROM customer AS c, product AS p1, product AS p2, purchase AS pr1, purchase AS pr2
    WHERE p1.pName = "Coffee" 
    AND p2.pName = "Onions" 
    AND p1.pID = pr1.pID 
    AND p2.pID = pr2.pID 
    AND pr1.date = pr2.date 
    AND pr1.cID = c.cID 
    AND pr2.cID = c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND NOT IN
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    EXCEPT
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    EXCEPT
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    NOT IN
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    EXCEPT
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query4 = '''
    SELECT sName
    FROM store AS s, purchase AS p, store AS s2
    WHERE s.sName = p.sName
    AND s2.sName = p.sName
    GROUP BY sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store AS s, purchase AS p, store AS s2
    WHERE s.sName = p.sName
    AND s2.sName = p.sName
    GROUP BY sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store AS s1, purchase AS p, store AS s2
    WHERE s1.sName = p.sName
    AND s2.sName = p.sName
    GROUP BY s1.sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store AS s1, purchase AS p, store AS s2
    WHERE s1.sID = p.sID
    AND s2.sID = p.sID
    AND s1.sName = s2.sName
    GROUP BY s1.sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID, s.sID = pur.sID
    GROUP BY pName, sName
    HAVING MAX(price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID
    GROUP BY pName, sName
    HAVING MAX(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0             Apples  Albert Hein
#[Out]# 1             Apples         Coop
#[Out]# 2             Apples         Dirk
#[Out]# 3             Apples    Hoogvliet
#[Out]# 4             Apples        Jumbo
#[Out]# 5             Apples         Lidl
#[Out]# 6             Apples       Sligro
#[Out]# 7            Bananas  Albert Hein
#[Out]# 8            Bananas         Coop
#[Out]# 9            Bananas         Dirk
#[Out]# 10           Bananas    Hoogvliet
#[Out]# 11           Bananas        Jumbo
#[Out]# 12           Bananas         Lidl
#[Out]# 13           Bananas       Sligro
#[Out]# 14              Beef  Albert Hein
#[Out]# 15              Beef         Coop
#[Out]# 16              Beef         Dirk
#[Out]# 17              Beef    Hoogvliet
#[Out]# 18              Beef       Sligro
#[Out]# 19             Bread  Albert Hein
#[Out]# 20             Bread         Coop
#[Out]# 21             Bread         Dirk
#[Out]# 22             Bread    Hoogvliet
#[Out]# 23             Bread        Jumbo
#[Out]# 24             Bread         Lidl
#[Out]# 25             Bread       Sligro
#[Out]# 26           Carrots  Albert Hein
#[Out]# 27           Carrots         Coop
#[Out]# 28           Carrots         Dirk
#[Out]# 29           Carrots    Hoogvliet
#[Out]# ..               ...          ...
#[Out]# 155             Rice         Dirk
#[Out]# 156             Rice    Hoogvliet
#[Out]# 157             Rice        Jumbo
#[Out]# 158             Rice         Lidl
#[Out]# 159             Rice       Sligro
#[Out]# 160           Salmon        Jumbo
#[Out]# 161  Spiced Biscuits  Albert Hein
#[Out]# 162  Spiced Biscuits         Coop
#[Out]# 163  Spiced Biscuits    Hoogvliet
#[Out]# 164  Spiced Biscuits        Jumbo
#[Out]# 165  Spiced Biscuits         Lidl
#[Out]# 166              Tea  Albert Hein
#[Out]# 167              Tea         Coop
#[Out]# 168              Tea         Dirk
#[Out]# 169              Tea    Hoogvliet
#[Out]# 170              Tea        Jumbo
#[Out]# 171              Tea         Lidl
#[Out]# 172              Tea       Sligro
#[Out]# 173         Tomatoes  Albert Hein
#[Out]# 174         Tomatoes         Coop
#[Out]# 175         Tomatoes    Hoogvliet
#[Out]# 176         Tomatoes        Jumbo
#[Out]# 177         Tomatoes         Lidl
#[Out]# 178         Tomatoes       Sligro
#[Out]# 179            Water  Albert Hein
#[Out]# 180            Water         Coop
#[Out]# 181            Water         Dirk
#[Out]# 182            Water    Hoogvliet
#[Out]# 183            Water        Jumbo
#[Out]# 184            Water       Sligro
#[Out]# 
#[Out]# [185 rows x 2 columns]
query5 = '''
    
    SELECT MAX(price)
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID
    GROUP BY pName, sName
    HAVING MAX(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#      MAX(price)
#[Out]# 0          4.30
#[Out]# 1          4.45
#[Out]# 2          4.65
#[Out]# 3          4.70
#[Out]# 4          3.50
#[Out]# 5          4.65
#[Out]# 6          4.50
#[Out]# 7          3.00
#[Out]# 8          1.65
#[Out]# 9          1.70
#[Out]# 10         1.65
#[Out]# 11         3.15
#[Out]# 12         1.80
#[Out]# 13         1.75
#[Out]# 14        13.25
#[Out]# 15        13.60
#[Out]# 16        12.80
#[Out]# 17        12.30
#[Out]# 18        13.80
#[Out]# 19         2.60
#[Out]# 20         3.25
#[Out]# 21         2.40
#[Out]# 22         2.30
#[Out]# 23         3.80
#[Out]# 24         2.30
#[Out]# 25         1.20
#[Out]# 26         2.95
#[Out]# 27         1.10
#[Out]# 28         0.90
#[Out]# 29         1.15
#[Out]# ..          ...
#[Out]# 155        2.05
#[Out]# 156        1.90
#[Out]# 157        2.10
#[Out]# 158        2.05
#[Out]# 159        1.90
#[Out]# 160        1.00
#[Out]# 161        2.00
#[Out]# 162        3.75
#[Out]# 163        2.55
#[Out]# 164        2.40
#[Out]# 165        2.50
#[Out]# 166        2.05
#[Out]# 167        1.90
#[Out]# 168        1.60
#[Out]# 169        2.05
#[Out]# 170        2.00
#[Out]# 171        2.60
#[Out]# 172        3.20
#[Out]# 173        1.65
#[Out]# 174        2.35
#[Out]# 175        2.05
#[Out]# 176        2.35
#[Out]# 177        2.20
#[Out]# 178        2.00
#[Out]# 179        0.55
#[Out]# 180        4.15
#[Out]# 181        4.35
#[Out]# 182        0.95
#[Out]# 183        0.60
#[Out]# 184        0.50
#[Out]# 
#[Out]# [185 rows x 1 columns]
query5 = '''
    
    SELECT MAX(price)
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID
'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(price)
#[Out]# 0        13.8
query5 = '''
    
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID
'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(price) pName   sName
#[Out]# 0        13.8  Beef  Sligro
query5 = '''
    
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s

'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(price)        pName sName
#[Out]# 0        13.8  Cashew Nuts  Coop
query5 = '''
    
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID

'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(price) pName   sName
#[Out]# 0        13.8  Beef  Sligro
query5 = '''
    
    SELECT pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID AND MAX(price)

'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID

'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s
    WHERE s.sID = pur.sID
    AND
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID

'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s
    WHERE s.sID = pur.sID
    AND p.pID = pur.pID
    AND pur.price =
    SELECT MAX(price), pName, sName
    FROM product AS p, purchase AS pur, store AS s
    WHERE p.pID = pur.pID AND s.sID = pur.sID

'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s
    WHERE s.sID = pur.sID
    AND p.pID = pur.pID
    AND pur.price =
    SELECT MAX(price)

'''

pd.read_sql_query(query5, conn)
query6 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query6, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND pur.price = MAX(price)


'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    GROUP BY pName, sName
    HAVING pur.price = MAX(price)


'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0             Apples  Albert Hein
#[Out]# 1             Apples         Coop
#[Out]# 2             Apples         Dirk
#[Out]# 3             Apples    Hoogvliet
#[Out]# 4             Apples        Jumbo
#[Out]# 5             Apples         Lidl
#[Out]# 6             Apples       Sligro
#[Out]# 7            Bananas  Albert Hein
#[Out]# 8            Bananas         Coop
#[Out]# 9            Bananas         Dirk
#[Out]# 10           Bananas    Hoogvliet
#[Out]# 11           Bananas        Jumbo
#[Out]# 12           Bananas         Lidl
#[Out]# 13           Bananas       Sligro
#[Out]# 14              Beef  Albert Hein
#[Out]# 15              Beef         Coop
#[Out]# 16              Beef         Dirk
#[Out]# 17              Beef    Hoogvliet
#[Out]# 18              Beef       Sligro
#[Out]# 19             Bread  Albert Hein
#[Out]# 20             Bread         Coop
#[Out]# 21             Bread         Dirk
#[Out]# 22             Bread    Hoogvliet
#[Out]# 23             Bread        Jumbo
#[Out]# 24             Bread         Lidl
#[Out]# 25             Bread       Sligro
#[Out]# 26           Carrots  Albert Hein
#[Out]# 27           Carrots         Coop
#[Out]# 28           Carrots         Dirk
#[Out]# 29           Carrots    Hoogvliet
#[Out]# ..               ...          ...
#[Out]# 155             Rice         Dirk
#[Out]# 156             Rice    Hoogvliet
#[Out]# 157             Rice        Jumbo
#[Out]# 158             Rice         Lidl
#[Out]# 159             Rice       Sligro
#[Out]# 160           Salmon        Jumbo
#[Out]# 161  Spiced Biscuits  Albert Hein
#[Out]# 162  Spiced Biscuits         Coop
#[Out]# 163  Spiced Biscuits    Hoogvliet
#[Out]# 164  Spiced Biscuits        Jumbo
#[Out]# 165  Spiced Biscuits         Lidl
#[Out]# 166              Tea  Albert Hein
#[Out]# 167              Tea         Coop
#[Out]# 168              Tea         Dirk
#[Out]# 169              Tea    Hoogvliet
#[Out]# 170              Tea        Jumbo
#[Out]# 171              Tea         Lidl
#[Out]# 172              Tea       Sligro
#[Out]# 173         Tomatoes  Albert Hein
#[Out]# 174         Tomatoes         Coop
#[Out]# 175         Tomatoes    Hoogvliet
#[Out]# 176         Tomatoes        Jumbo
#[Out]# 177         Tomatoes         Lidl
#[Out]# 178         Tomatoes       Sligro
#[Out]# 179            Water  Albert Hein
#[Out]# 180            Water         Coop
#[Out]# 181            Water         Dirk
#[Out]# 182            Water    Hoogvliet
#[Out]# 183            Water        Jumbo
#[Out]# 184            Water       Sligro
#[Out]# 
#[Out]# [185 rows x 2 columns]
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    UNION
    SELECT MAX(price)


'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    UNION
    SELECT MAX(price)
    FROM purchase as pur


'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND pur.price = 
    SELECT MAX(price)
    FROM purchase


'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND price = 
    SELECT MAX(price)
    FROM purchase


'''

pd.read_sql_query(query5, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND price = (
    SELECT MAX(price)
    FROM purchase)


'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT DIFFERENCE(MIN(unit_price),MAX(unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = ‘2018-08-23’
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT DIFFERENCE(MIN(unit_price),MAX(unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = ‘2018-08-23’
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT DIFFERENCE(MIN(unit_price),MAX(unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT DIFFERENCE(MIN(i1.unit_price),MAX(i2.unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT DIFFERENCE(MIN(i1.unit_price),MAX(i2.unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT (MAX(i2.unit_price)-MIN(i1.unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#   (MAX(i2.unit_price)-MIN(i1.unit_price))
#[Out]# 0                                    None
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#   MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  None
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    AND i1.unit_price = (
    SELECT MAX(unit_price)
    FROM inventory)
    AND i2.unit_price = (
    SELECT MIN(unit_price)
    FROM inventory)
'''

pd.read_sql_query(query6, conn)
#[Out]#   MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  None
practicequery1a = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1a, conn)
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    AND i1.unit_price = (
    SELECT MAX(unit_price)
    FROM inventory)
    AND i2.unit_price = (
    SELECT MIN(unit_price)
    FROM inventory)
'''

pd.read_sql_query(query6, conn)
#[Out]#   MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  None
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND price = (
    SELECT MAX(price)
    FROM purchase)


'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT 
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    AND i1.unit_price = (
    SELECT MAX(unit_price)
    FROM inventory)
    AND i2.unit_price = (
    SELECT MIN(unit_price)
    FROM inventory)
'''

pd.read_sql_query(query6, conn)
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND price = (
    SELECT MAX(price)
    FROM purchase)


'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = 2018-08-23
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#   MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  None
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  12.95
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                  12.95
query6 = '''
    SELECT *
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#      sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0     51   10  2018-08-23        31        0.60   34   10  2018-08-23   
#[Out]# 1     51   10  2018-08-23        31        0.60   50   10  2018-08-23   
#[Out]# 2     57   19  2018-08-23        12        2.95    3   19  2018-08-23   
#[Out]# 3     57   19  2018-08-23        12        2.95   17   19  2018-08-23   
#[Out]# 4     57   19  2018-08-23        12        2.95   33   19  2018-08-23   
#[Out]# 5     57   19  2018-08-23        12        2.95   44   19  2018-08-23   
#[Out]# 6     38   23  2018-08-23        29        1.80   21   23  2018-08-23   
#[Out]# 7     35   13  2018-08-23        28        4.15    4   13  2018-08-23   
#[Out]# 8     35   13  2018-08-23        28        4.15   12   13  2018-08-23   
#[Out]# 9     35   13  2018-08-23        28        4.15   45   13  2018-08-23   
#[Out]# 10    45   13  2018-08-23        32        4.10    4   13  2018-08-23   
#[Out]# 11    45   13  2018-08-23        32        4.10   12   13  2018-08-23   
#[Out]# 12    45   13  2018-08-23        32        4.10   35   13  2018-08-23   
#[Out]# 13     5   17  2018-08-23        34        2.45   29   17  2018-08-23   
#[Out]# 14    13   15  2018-08-23        11        1.25    6   15  2018-08-23   
#[Out]# 15    13   15  2018-08-23        11        1.25   11   15  2018-08-23   
#[Out]# 16    13   15  2018-08-23        11        1.25   12   15  2018-08-23   
#[Out]# 17    50   10  2018-08-23        54        0.55   34   10  2018-08-23   
#[Out]# 18    50   10  2018-08-23        54        0.55   51   10  2018-08-23   
#[Out]# 19     7    1  2018-08-23        18        5.80   41    1  2018-08-23   
#[Out]# 20     7    1  2018-08-23        18        5.80   55    1  2018-08-23   
#[Out]# 21     7    1  2018-08-23        18        5.80   56    1  2018-08-23   
#[Out]# 22     2   11  2018-08-23        21        1.00   33   11  2018-08-23   
#[Out]# 23     2   11  2018-08-23        21        1.00   35   11  2018-08-23   
#[Out]# 24    28   27  2018-08-23        43        8.50   35   27  2018-08-23   
#[Out]# 25    28   27  2018-08-23        43        8.50   40   27  2018-08-23   
#[Out]# 26    35   25  2018-08-23        36        4.00   56   25  2018-08-23   
#[Out]# 27    41    1  2018-08-23        53        4.60    7    1  2018-08-23   
#[Out]# 28    41    1  2018-08-23        53        4.60   55    1  2018-08-23   
#[Out]# 29    41    1  2018-08-23        53        4.60   56    1  2018-08-23   
#[Out]# ..   ...  ...         ...       ...         ...  ...  ...         ...   
#[Out]# 124   12   13  2018-08-23        15        3.55   45   13  2018-08-23   
#[Out]# 125   35   11  2018-08-23        15        1.20    2   11  2018-08-23   
#[Out]# 126   35   11  2018-08-23        15        1.20   33   11  2018-08-23   
#[Out]# 127   55    1  2018-08-23         1        4.80    7    1  2018-08-23   
#[Out]# 128   55    1  2018-08-23         1        4.80   41    1  2018-08-23   
#[Out]# 129   55    1  2018-08-23         1        4.80   56    1  2018-08-23   
#[Out]# 130   54   12  2018-08-23         5       12.55    5   12  2018-08-23   
#[Out]# 131   54   12  2018-08-23         5       12.55    9   12  2018-08-23   
#[Out]# 132   54   12  2018-08-23         5       12.55   42   12  2018-08-23   
#[Out]# 133   11   15  2018-08-23        14        1.30    6   15  2018-08-23   
#[Out]# 134   11   15  2018-08-23        14        1.30   12   15  2018-08-23   
#[Out]# 135   11   15  2018-08-23        14        1.30   13   15  2018-08-23   
#[Out]# 136   35    7  2018-08-23         7        2.20   43    7  2018-08-23   
#[Out]# 137   35    7  2018-08-23         7        2.20   47    7  2018-08-23   
#[Out]# 138    6   15  2018-08-23         4        1.00   11   15  2018-08-23   
#[Out]# 139    6   15  2018-08-23         4        1.00   12   15  2018-08-23   
#[Out]# 140    6   15  2018-08-23         4        1.00   13   15  2018-08-23   
#[Out]# 141   37   28  2018-08-23        19        7.75   32   28  2018-08-23   
#[Out]# 142   37   28  2018-08-23        19        7.75   52   28  2018-08-23   
#[Out]# 143   25    8  2018-08-23         6        5.55   33    8  2018-08-23   
#[Out]# 144    9   12  2018-08-23         5       13.15    5   12  2018-08-23   
#[Out]# 145    9   12  2018-08-23         5       13.15   42   12  2018-08-23   
#[Out]# 146    9   12  2018-08-23         5       13.15   54   12  2018-08-23   
#[Out]# 147   38   24  2018-08-23        10        3.55    5   24  2018-08-23   
#[Out]# 148   56    1  2018-08-23         1        4.40    7    1  2018-08-23   
#[Out]# 149   56    1  2018-08-23         1        4.40   41    1  2018-08-23   
#[Out]# 150   56    1  2018-08-23         1        4.40   55    1  2018-08-23   
#[Out]# 151    4   13  2018-08-23        23        4.20   12   13  2018-08-23   
#[Out]# 152    4   13  2018-08-23        23        4.20   35   13  2018-08-23   
#[Out]# 153    4   13  2018-08-23        23        4.20   45   13  2018-08-23   
#[Out]# 
#[Out]#      quantity  unit_price  
#[Out]# 0           8        0.45  
#[Out]# 1          54        0.55  
#[Out]# 2          11        2.10  
#[Out]# 3          10        2.20  
#[Out]# 4          32        2.25  
#[Out]# 5           4        2.65  
#[Out]# 6          20        2.10  
#[Out]# 7          23        4.20  
#[Out]# 8          15        3.55  
#[Out]# 9          32        4.10  
#[Out]# 10         23        4.20  
#[Out]# 11         15        3.55  
#[Out]# 12         28        4.15  
#[Out]# 13          4        1.95  
#[Out]# 14          4        1.00  
#[Out]# 15         14        1.30  
#[Out]# 16          1        1.25  
#[Out]# 17          8        0.45  
#[Out]# 18         31        0.60  
#[Out]# 19         53        4.60  
#[Out]# 20          1        4.80  
#[Out]# 21          1        4.40  
#[Out]# 22         32        1.05  
#[Out]# 23         15        1.20  
#[Out]# 24         54        8.85  
#[Out]# 25         17        6.90  
#[Out]# 26         19        4.35  
#[Out]# 27         18        5.80  
#[Out]# 28          1        4.80  
#[Out]# 29          1        4.40  
#[Out]# ..        ...         ...  
#[Out]# 124        32        4.10  
#[Out]# 125        21        1.00  
#[Out]# 126        32        1.05  
#[Out]# 127        18        5.80  
#[Out]# 128        53        4.60  
#[Out]# 129         1        4.40  
#[Out]# 130        11       13.40  
#[Out]# 131         5       13.15  
#[Out]# 132        46       11.40  
#[Out]# 133         4        1.00  
#[Out]# 134         1        1.25  
#[Out]# 135        11        1.25  
#[Out]# 136        20        1.95  
#[Out]# 137        27        1.85  
#[Out]# 138        14        1.30  
#[Out]# 139         1        1.25  
#[Out]# 140        11        1.25  
#[Out]# 141        36        6.85  
#[Out]# 142         8        7.35  
#[Out]# 143        16        4.80  
#[Out]# 144        11       13.40  
#[Out]# 145        46       11.40  
#[Out]# 146         5       12.55  
#[Out]# 147        32        4.10  
#[Out]# 148        18        5.80  
#[Out]# 149        53        4.60  
#[Out]# 150         1        4.80  
#[Out]# 151        15        3.55  
#[Out]# 152        28        4.15  
#[Out]# 153        32        4.10  
#[Out]# 
#[Out]# [154 rows x 10 columns]
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                    0.80
#[Out]# 1                                    1.40
#[Out]# 2                                    0.40
#[Out]# 3                                    0.20
#[Out]# 4                                    0.35
#[Out]# 5                                    0.75
#[Out]# 6                                    0.15
#[Out]# 7                                    0.20
#[Out]# 8                                    2.00
#[Out]# 9                                    0.65
#[Out]# 10                                   0.90
#[Out]# 11                                   0.30
#[Out]# 12                                   0.35
#[Out]# 13                                   0.50
#[Out]# 14                                   0.85
#[Out]# 15                                   0.50
#[Out]# 16                                   0.30
#[Out]# 17                                   0.55
#[Out]# 18                                   0.35
#[Out]# 19                                   1.95
#[Out]# 20                                   0.90
query6 = '''
    SELECT *
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0    31    0  2018-08-23        25        4.60   29    0  2018-08-23   
#[Out]# 1    56    1  2018-08-23         1        4.40   55    1  2018-08-23   
#[Out]# 2    12    2  2018-08-23         3        1.70   11    2  2018-08-23   
#[Out]# 3    45    4  2018-08-23        50        1.00   19    4  2018-08-23   
#[Out]# 4    47    7  2018-08-23        27        1.85   43    7  2018-08-23   
#[Out]# 5    33    8  2018-08-23        16        4.80   25    8  2018-08-23   
#[Out]# 6    51   10  2018-08-23        31        0.60   50   10  2018-08-23   
#[Out]# 7    35   11  2018-08-23        15        1.20   33   11  2018-08-23   
#[Out]# 8    54   12  2018-08-23         5       12.55   42   12  2018-08-23   
#[Out]# 9    45   13  2018-08-23        32        4.10   35   13  2018-08-23   
#[Out]# 10   50   14  2018-08-23        19        3.85   41   14  2018-08-23   
#[Out]# 11   13   15  2018-08-23        11        1.25   12   15  2018-08-23   
#[Out]# 12   11   16  2018-08-23         3        1.90    6   16  2018-08-23   
#[Out]# 13   29   17  2018-08-23         4        1.95    5   17  2018-08-23   
#[Out]# 14   57   19  2018-08-23        12        2.95   44   19  2018-08-23   
#[Out]# 15   51   22  2018-08-23        13        1.55   50   22  2018-08-23   
#[Out]# 16   38   23  2018-08-23        29        1.80   21   23  2018-08-23   
#[Out]# 17   38   24  2018-08-23        10        3.55    5   24  2018-08-23   
#[Out]# 18   56   25  2018-08-23        19        4.35   35   25  2018-08-23   
#[Out]# 19   40   27  2018-08-23        17        6.90   35   27  2018-08-23   
#[Out]# 20   52   28  2018-08-23         8        7.35   37   28  2018-08-23   
#[Out]# 
#[Out]#     quantity  unit_price  
#[Out]# 0         28        5.15  
#[Out]# 1          1        4.80  
#[Out]# 2         22        2.10  
#[Out]# 3         53        1.20  
#[Out]# 4         20        1.95  
#[Out]# 5          6        5.55  
#[Out]# 6         54        0.55  
#[Out]# 7         32        1.05  
#[Out]# 8         46       11.40  
#[Out]# 9         28        4.15  
#[Out]# 10         3        3.35  
#[Out]# 11         1        1.25  
#[Out]# 12        14        1.85  
#[Out]# 13        34        2.45  
#[Out]# 14         4        2.65  
#[Out]# 15         5        1.95  
#[Out]# 16        20        2.10  
#[Out]# 17        32        4.10  
#[Out]# 18        36        4.00  
#[Out]# 19        54        8.85  
#[Out]# 20        19        7.75  
query6 = '''
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     MAX(i2.unit_price)-MIN(i1.unit_price)
#[Out]# 0                                    0.80
#[Out]# 1                                    1.40
#[Out]# 2                                    0.40
#[Out]# 3                                    0.20
#[Out]# 4                                    0.35
#[Out]# 5                                    0.75
#[Out]# 6                                    0.15
#[Out]# 7                                    0.20
#[Out]# 8                                    2.00
#[Out]# 9                                    0.65
#[Out]# 10                                   0.90
#[Out]# 11                                   0.30
#[Out]# 12                                   0.35
#[Out]# 13                                   0.50
#[Out]# 14                                   0.85
#[Out]# 15                                   0.50
#[Out]# 16                                   0.30
#[Out]# 17                                   0.55
#[Out]# 18                                   0.35
#[Out]# 19                                   1.95
#[Out]# 20                                   0.90
query6 = '''
    WITH difference(unit_price) as(
    SELECT MAX(i2.unit_price)-MIN(i1.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = i2.date
    AND i1.date = '2018-08-23'
    AND i1.sID <> i2.sID
    AND i1.pID = i2.pID
    GROUP BY i1.pID)
    SELECT MAX(unit_price)
    FROM difference
    
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(unit_price)
#[Out]# 0              2.0
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    EXCEPT
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query4 = '''
    SELECT s1.sName
    FROM store AS s1, purchase AS p, store AS s2
    WHERE s1.sID = p.sID
    AND s2.sID = p.sID
    AND s1.sName = s2.sName
    GROUP BY s1.sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    
    SELECT pName, sName
    FROM purchase AS pur, store AS s, product AS p
    WHERE s.sID = pur.sID
    AND s.sID = pur.sID
    AND p.pID = pur.pID
    AND price = (
    SELECT MAX(price)
    FROM purchase)


'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    NOT IN
    SELECT c.cID
    FROM customer AS c, purchase AS p, store AS s1, store AS s2
    WHERE c.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, purchase AS p, store AS s1, store AS s2
    WHERE cust.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2
    WHERE cust.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2
    WHERE cust.cID = p.cID
    AND p.sID = s1.sID
    AND p.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query4 = '''
    SELECT s1.sName
    FROM store AS s1, purchase AS p, store AS s2
    WHERE s1.sID = p.sID
    AND s2.sID = p.sID
    AND s1.sName = s2.sName
    GROUP BY s1.sName
    HAVING AVG(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT c.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID = p.cID
    AND c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#        cID
#[Out]# 0        0
#[Out]# 1        0
#[Out]# 2        0
#[Out]# 3        0
#[Out]# 4        0
#[Out]# 5        0
#[Out]# 6        0
#[Out]# 7        0
#[Out]# 8        0
#[Out]# 9        0
#[Out]# 10       0
#[Out]# 11       0
#[Out]# 12       0
#[Out]# 13       0
#[Out]# 14       0
#[Out]# 15       0
#[Out]# 16       0
#[Out]# 17       0
#[Out]# 18       0
#[Out]# 19       0
#[Out]# 20       0
#[Out]# 21       0
#[Out]# 22       0
#[Out]# 23       0
#[Out]# 24       0
#[Out]# 25       0
#[Out]# 26       0
#[Out]# 27       0
#[Out]# 28       0
#[Out]# 29       0
#[Out]# ...    ...
#[Out]# 96171  190
#[Out]# 96172  190
#[Out]# 96173  190
#[Out]# 96174  190
#[Out]# 96175  190
#[Out]# 96176  190
#[Out]# 96177  190
#[Out]# 96178  190
#[Out]# 96179  190
#[Out]# 96180  190
#[Out]# 96181  190
#[Out]# 96182  190
#[Out]# 96183  190
#[Out]# 96184  190
#[Out]# 96185  190
#[Out]# 96186  190
#[Out]# 96187  190
#[Out]# 96188  190
#[Out]# 96189  190
#[Out]# 96190  190
#[Out]# 96191  190
#[Out]# 96192  190
#[Out]# 96193  190
#[Out]# 96194  190
#[Out]# 96195  190
#[Out]# 96196  190
#[Out]# 96197  190
#[Out]# 96198  190
#[Out]# 96199  190
#[Out]# 96200  190
#[Out]# 
#[Out]# [96201 rows x 1 columns]
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#        cID
#[Out]# 0        0
#[Out]# 1        0
#[Out]# 2        0
#[Out]# 3        0
#[Out]# 4        0
#[Out]# 5        0
#[Out]# 6        0
#[Out]# 7        0
#[Out]# 8        0
#[Out]# 9        0
#[Out]# 10       0
#[Out]# 11       0
#[Out]# 12       0
#[Out]# 13       0
#[Out]# 14       0
#[Out]# 15       0
#[Out]# 16       0
#[Out]# 17       0
#[Out]# 18       0
#[Out]# 19       0
#[Out]# 20       0
#[Out]# 21       0
#[Out]# 22       0
#[Out]# 23       0
#[Out]# 24       0
#[Out]# 25       0
#[Out]# 26       0
#[Out]# 27       0
#[Out]# 28       0
#[Out]# 29       0
#[Out]# ...    ...
#[Out]# 96171  190
#[Out]# 96172  190
#[Out]# 96173  190
#[Out]# 96174  190
#[Out]# 96175  190
#[Out]# 96176  190
#[Out]# 96177  190
#[Out]# 96178  190
#[Out]# 96179  190
#[Out]# 96180  190
#[Out]# 96181  190
#[Out]# 96182  190
#[Out]# 96183  190
#[Out]# 96184  190
#[Out]# 96185  190
#[Out]# 96186  190
#[Out]# 96187  190
#[Out]# 96188  190
#[Out]# 96189  190
#[Out]# 96190  190
#[Out]# 96191  190
#[Out]# 96192  190
#[Out]# 96193  190
#[Out]# 96194  190
#[Out]# 96195  190
#[Out]# 96196  190
#[Out]# 96197  190
#[Out]# 96198  190
#[Out]# 96199  190
#[Out]# 96200  190
#[Out]# 
#[Out]# [96201 rows x 1 columns]
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#        cID
#[Out]# 0        0
#[Out]# 1        0
#[Out]# 2        0
#[Out]# 3        0
#[Out]# 4        0
#[Out]# 5        0
#[Out]# 6        0
#[Out]# 7        0
#[Out]# 8        0
#[Out]# 9        0
#[Out]# 10       0
#[Out]# 11       0
#[Out]# 12       0
#[Out]# 13       0
#[Out]# 14       0
#[Out]# 15       0
#[Out]# 16       0
#[Out]# 17       0
#[Out]# 18       0
#[Out]# 19       0
#[Out]# 20       0
#[Out]# 21       0
#[Out]# 22       0
#[Out]# 23       0
#[Out]# 24       0
#[Out]# 25       0
#[Out]# 26       0
#[Out]# 27       0
#[Out]# 28       0
#[Out]# 29       0
#[Out]# ...    ...
#[Out]# 96171  190
#[Out]# 96172  190
#[Out]# 96173  190
#[Out]# 96174  190
#[Out]# 96175  190
#[Out]# 96176  190
#[Out]# 96177  190
#[Out]# 96178  190
#[Out]# 96179  190
#[Out]# 96180  190
#[Out]# 96181  190
#[Out]# 96182  190
#[Out]# 96183  190
#[Out]# 96184  190
#[Out]# 96185  190
#[Out]# 96186  190
#[Out]# 96187  190
#[Out]# 96188  190
#[Out]# 96189  190
#[Out]# 96190  190
#[Out]# 96191  190
#[Out]# 96192  190
#[Out]# 96193  190
#[Out]# 96194  190
#[Out]# 96195  190
#[Out]# 96196  190
#[Out]# 96197  190
#[Out]# 96198  190
#[Out]# 96199  190
#[Out]# 96200  190
#[Out]# 
#[Out]# [96201 rows x 1 columns]
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID)
    GROUP BY cust.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID
    GROUP BY cust.cID)
    
'''

pd.read_sql_query(query3, conn)
#[Out]#        cID
#[Out]# 0        0
#[Out]# 1        0
#[Out]# 2        0
#[Out]# 3        0
#[Out]# 4        0
#[Out]# 5        0
#[Out]# 6        0
#[Out]# 7        0
#[Out]# 8        0
#[Out]# 9        0
#[Out]# 10       0
#[Out]# 11       0
#[Out]# 12       0
#[Out]# 13       0
#[Out]# 14       0
#[Out]# 15       0
#[Out]# 16       0
#[Out]# 17       0
#[Out]# 18       0
#[Out]# 19       0
#[Out]# 20       0
#[Out]# 21       0
#[Out]# 22       0
#[Out]# 23       0
#[Out]# 24       0
#[Out]# 25       0
#[Out]# 26       0
#[Out]# 27       0
#[Out]# 28       0
#[Out]# 29       0
#[Out]# ...    ...
#[Out]# 96171  190
#[Out]# 96172  190
#[Out]# 96173  190
#[Out]# 96174  190
#[Out]# 96175  190
#[Out]# 96176  190
#[Out]# 96177  190
#[Out]# 96178  190
#[Out]# 96179  190
#[Out]# 96180  190
#[Out]# 96181  190
#[Out]# 96182  190
#[Out]# 96183  190
#[Out]# 96184  190
#[Out]# 96185  190
#[Out]# 96186  190
#[Out]# 96187  190
#[Out]# 96188  190
#[Out]# 96189  190
#[Out]# 96190  190
#[Out]# 96191  190
#[Out]# 96192  190
#[Out]# 96193  190
#[Out]# 96194  190
#[Out]# 96195  190
#[Out]# 96196  190
#[Out]# 96197  190
#[Out]# 96198  190
#[Out]# 96199  190
#[Out]# 96200  190
#[Out]# 
#[Out]# [96201 rows x 1 columns]
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID
    GROUP BY cust.cID)
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      6
#[Out]# 7      7
#[Out]# 8      8
#[Out]# 9      9
#[Out]# 10    10
#[Out]# 11    11
#[Out]# 12    12
#[Out]# 13    13
#[Out]# 14    14
#[Out]# 15    15
#[Out]# 16    16
#[Out]# 17    17
#[Out]# 18    18
#[Out]# 19    19
#[Out]# 20    20
#[Out]# 21    21
#[Out]# 22    22
#[Out]# 23    23
#[Out]# 24    24
#[Out]# 25    25
#[Out]# 26    26
#[Out]# 27    27
#[Out]# 28    28
#[Out]# 29    29
#[Out]# ..   ...
#[Out]# 160  160
#[Out]# 161  161
#[Out]# 162  162
#[Out]# 163  163
#[Out]# 164  164
#[Out]# 165  165
#[Out]# 166  166
#[Out]# 167  167
#[Out]# 168  168
#[Out]# 169  169
#[Out]# 170  170
#[Out]# 171  171
#[Out]# 172  172
#[Out]# 173  173
#[Out]# 174  174
#[Out]# 175  175
#[Out]# 176  176
#[Out]# 177  177
#[Out]# 178  178
#[Out]# 179  179
#[Out]# 180  180
#[Out]# 181  181
#[Out]# 182  182
#[Out]# 183  183
#[Out]# 184  184
#[Out]# 185  185
#[Out]# 186  186
#[Out]# 187  188
#[Out]# 188  189
#[Out]# 189  190
#[Out]# 
#[Out]# [190 rows x 1 columns]
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c, purchase AS p
    WHERE c.cID
    NOT IN (
    SELECT cust.cID
    FROM customer AS cust, store AS s1, store AS s2, purchase AS p2
    WHERE cust.cID = p.cID
    AND cust.cID = p2.cID
    AND p.sID = s1.sID
    AND p2.sID <> s2.sID
    )
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      6
#[Out]# 7      7
#[Out]# 8      8
#[Out]# 9      9
#[Out]# 10    10
#[Out]# 11    11
#[Out]# 12    12
#[Out]# 13    13
#[Out]# 14    14
#[Out]# 15    15
#[Out]# 16    16
#[Out]# 17    17
#[Out]# 18    18
#[Out]# 19    19
#[Out]# 20    20
#[Out]# 21    21
#[Out]# 22    22
#[Out]# 23    23
#[Out]# 24    24
#[Out]# 25    25
#[Out]# 26    26
#[Out]# 27    27
#[Out]# 28    28
#[Out]# 29    29
#[Out]# ..   ...
#[Out]# 160  160
#[Out]# 161  161
#[Out]# 162  162
#[Out]# 163  163
#[Out]# 164  164
#[Out]# 165  165
#[Out]# 166  166
#[Out]# 167  167
#[Out]# 168  168
#[Out]# 169  169
#[Out]# 170  170
#[Out]# 171  171
#[Out]# 172  172
#[Out]# 173  173
#[Out]# 174  174
#[Out]# 175  175
#[Out]# 176  176
#[Out]# 177  177
#[Out]# 178  178
#[Out]# 179  179
#[Out]# 180  180
#[Out]# 181  181
#[Out]# 182  182
#[Out]# 183  183
#[Out]# 184  184
#[Out]# 185  185
#[Out]# 186  186
#[Out]# 187  188
#[Out]# 188  189
#[Out]# 189  190
#[Out]# 
#[Out]# [190 rows x 1 columns]
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c
    WHERE NOT EXISTS 
    (SELECT sID
    FROM store as s
    WHERE NOT EXISTS (
    SELECT tID
    FROM purchase
    WHERE c.cID = p.cID
    AND s.sID = p.sID
    ))
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer AS c
    WHERE NOT EXISTS 
    (SELECT sID
    FROM store as s
    WHERE NOT EXISTS (
    SELECT tID
    FROM purchase AS p
    WHERE c.cID = p.cID
    AND s.sID = p.sID
    ))
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd

