# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
query3 = '''
    select ps.cID
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = count(distinct st.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
    select ps.cID
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) > 10
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  124
#[Out]# 1  169
#[Out]# 2  190
query3 = '''
    select ps.cID
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = max(count(distinct st.sID))
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select ps.cID
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = distinct st.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select ps.cID
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = count(distinct st.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
    select ps.cID
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = max(distinct st.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0   77
query3 = '''
    select ps.cID
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = count(distinct st.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
    select ps.cID, count(distinct st.sID)
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = count(distinct st.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count(distinct st.sID)
#[Out]# 0      0                       1
#[Out]# 1      1                       7
#[Out]# 2      2                       5
#[Out]# 3      3                       3
#[Out]# 4      4                       6
#[Out]# 5      5                       6
#[Out]# 6      7                       6
#[Out]# 7      8                       2
#[Out]# 8     10                       1
#[Out]# 9     11                       1
#[Out]# 10    13                       7
#[Out]# 11    15                       1
#[Out]# 12    16                      10
#[Out]# 13    17                       2
#[Out]# 14    18                       3
#[Out]# 15    19                       4
#[Out]# 16    20                       3
#[Out]# 17    21                       3
#[Out]# 18    22                       2
#[Out]# 19    24                       9
#[Out]# 20    25                       1
#[Out]# 21    26                       1
#[Out]# 22    27                       5
#[Out]# 23    28                       1
#[Out]# 24    29                       2
#[Out]# 25    30                       3
#[Out]# 26    31                       2
#[Out]# 27    33                       9
#[Out]# 28    34                       1
#[Out]# 29    35                       2
#[Out]# ..   ...                     ...
#[Out]# 102  147                       3
#[Out]# 103  149                       2
#[Out]# 104  151                       2
#[Out]# 105  152                       3
#[Out]# 106  157                       2
#[Out]# 107  159                       2
#[Out]# 108  161                       9
#[Out]# 109  162                       8
#[Out]# 110  163                       4
#[Out]# 111  165                       6
#[Out]# 112  167                      10
#[Out]# 113  168                       1
#[Out]# 114  169                      11
#[Out]# 115  170                       3
#[Out]# 116  171                       2
#[Out]# 117  172                       2
#[Out]# 118  175                       2
#[Out]# 119  176                       6
#[Out]# 120  177                       5
#[Out]# 121  178                       2
#[Out]# 122  179                       6
#[Out]# 123  180                       2
#[Out]# 124  181                       3
#[Out]# 125  182                       3
#[Out]# 126  184                       1
#[Out]# 127  185                       1
#[Out]# 128  186                       1
#[Out]# 129  188                       1
#[Out]# 130  189                       2
#[Out]# 131  190                      64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    select ps.cID, count(distinct st.sID), count(distinct ps.sID)
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = count(distinct st.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count(distinct st.sID)  count(distinct ps.sID)
#[Out]# 0      0                       1                       1
#[Out]# 1      1                       7                       7
#[Out]# 2      2                       5                       5
#[Out]# 3      3                       3                       3
#[Out]# 4      4                       6                       6
#[Out]# 5      5                       6                       6
#[Out]# 6      7                       6                       6
#[Out]# 7      8                       2                       2
#[Out]# 8     10                       1                       1
#[Out]# 9     11                       1                       1
#[Out]# 10    13                       7                       7
#[Out]# 11    15                       1                       1
#[Out]# 12    16                      10                      10
#[Out]# 13    17                       2                       2
#[Out]# 14    18                       3                       3
#[Out]# 15    19                       4                       4
#[Out]# 16    20                       3                       3
#[Out]# 17    21                       3                       3
#[Out]# 18    22                       2                       2
#[Out]# 19    24                       9                       9
#[Out]# 20    25                       1                       1
#[Out]# 21    26                       1                       1
#[Out]# 22    27                       5                       5
#[Out]# 23    28                       1                       1
#[Out]# 24    29                       2                       2
#[Out]# 25    30                       3                       3
#[Out]# 26    31                       2                       2
#[Out]# 27    33                       9                       9
#[Out]# 28    34                       1                       1
#[Out]# 29    35                       2                       2
#[Out]# ..   ...                     ...                     ...
#[Out]# 102  147                       3                       3
#[Out]# 103  149                       2                       2
#[Out]# 104  151                       2                       2
#[Out]# 105  152                       3                       3
#[Out]# 106  157                       2                       2
#[Out]# 107  159                       2                       2
#[Out]# 108  161                       9                       9
#[Out]# 109  162                       8                       8
#[Out]# 110  163                       4                       4
#[Out]# 111  165                       6                       6
#[Out]# 112  167                      10                      10
#[Out]# 113  168                       1                       1
#[Out]# 114  169                      11                      11
#[Out]# 115  170                       3                       3
#[Out]# 116  171                       2                       2
#[Out]# 117  172                       2                       2
#[Out]# 118  175                       2                       2
#[Out]# 119  176                       6                       6
#[Out]# 120  177                       5                       5
#[Out]# 121  178                       2                       2
#[Out]# 122  179                       6                       6
#[Out]# 123  180                       2                       2
#[Out]# 124  181                       3                       3
#[Out]# 125  182                       3                       3
#[Out]# 126  184                       1                       1
#[Out]# 127  185                       1                       1
#[Out]# 128  186                       1                       1
#[Out]# 129  188                       1                       1
#[Out]# 130  189                       2                       2
#[Out]# 131  190                      64                      64
#[Out]# 
#[Out]# [132 rows x 3 columns]
query3 = '''
    select ps.cID, count(distinct st.sID), count(distinct ps.sID)
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = max(count(distinct st.sID))
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select ps.cID, count(distinct st.sID)
    from purchase ps, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = count(distinct st.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count(distinct st.sID)
#[Out]# 0      0                       1
#[Out]# 1      1                       7
#[Out]# 2      2                       5
#[Out]# 3      3                       3
#[Out]# 4      4                       6
#[Out]# 5      5                       6
#[Out]# 6      7                       6
#[Out]# 7      8                       2
#[Out]# 8     10                       1
#[Out]# 9     11                       1
#[Out]# 10    13                       7
#[Out]# 11    15                       1
#[Out]# 12    16                      10
#[Out]# 13    17                       2
#[Out]# 14    18                       3
#[Out]# 15    19                       4
#[Out]# 16    20                       3
#[Out]# 17    21                       3
#[Out]# 18    22                       2
#[Out]# 19    24                       9
#[Out]# 20    25                       1
#[Out]# 21    26                       1
#[Out]# 22    27                       5
#[Out]# 23    28                       1
#[Out]# 24    29                       2
#[Out]# 25    30                       3
#[Out]# 26    31                       2
#[Out]# 27    33                       9
#[Out]# 28    34                       1
#[Out]# 29    35                       2
#[Out]# ..   ...                     ...
#[Out]# 102  147                       3
#[Out]# 103  149                       2
#[Out]# 104  151                       2
#[Out]# 105  152                       3
#[Out]# 106  157                       2
#[Out]# 107  159                       2
#[Out]# 108  161                       9
#[Out]# 109  162                       8
#[Out]# 110  163                       4
#[Out]# 111  165                       6
#[Out]# 112  167                      10
#[Out]# 113  168                       1
#[Out]# 114  169                      11
#[Out]# 115  170                       3
#[Out]# 116  171                       2
#[Out]# 117  172                       2
#[Out]# 118  175                       2
#[Out]# 119  176                       6
#[Out]# 120  177                       5
#[Out]# 121  178                       2
#[Out]# 122  179                       6
#[Out]# 123  180                       2
#[Out]# 124  181                       3
#[Out]# 125  182                       3
#[Out]# 126  184                       1
#[Out]# 127  185                       1
#[Out]# 128  186                       1
#[Out]# 129  188                       1
#[Out]# 130  189                       2
#[Out]# 131  190                      64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    select ps.cID, count(distinct st.sID)
    from purchase ps, (
        select max(count(sID)) as stores
        from store
    ) as maximum
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = stores
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select ps.cID, count(distinct st.sID)
    from purchase ps, (
        select count(sID as stores
        from store
    ) as maximum
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = stores
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select ps.cID, count(distinct st.sID)
    from purchase ps, (
        select count(sID) as stores
        from store
    ) as maximum
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = stores
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select ps.cID
    from purchase ps, (
        select count(sID) as stores
        from store
    ) as maximum
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = stores
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select ps.cID
    from purchase ps, (
        select count(sID) as stores
        from store
    ) as maximum, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = stores
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    select ps.cID
    from purchase ps, (
        select count(sID) as stores
        from store
    ) as maximum, store st
    where ps.sID = st.sID
    group by ps.cID
    having count(distinct ps.sID) = maximum.stores
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
