# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 

# IPython log file

query2 = '''
    SELECT cID, cName
    FROM customer, purchase, product
    WHERE customer.cID = purchase.cID AND product.pID = purchase.pID
'''

pd.read_sql_query(query2, conn)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT pID
    FROM purchase
    GROUP BY pID
    HAVING count(cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT pID
    FROM purchase
    GROUP BY pID
    HAVING count(DISTINCT cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT cID, cName
    FROM customer, purchase, product
    WHERE customer.cID = purchase.cID AND product.pID = purchase.pID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT customer.cID, cName
    FROM customer, purchase, product
    WHERE customer.cID = purchase.cID AND product.pID = purchase.pID
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID   cName
#[Out]# 0      0    Noah
#[Out]# 1      1     Sem
#[Out]# 2      1     Sem
#[Out]# 3      1     Sem
#[Out]# 4      1     Sem
#[Out]# 5      1     Sem
#[Out]# 6      1     Sem
#[Out]# 7      1     Sem
#[Out]# 8      2   Lucas
#[Out]# 9      2   Lucas
#[Out]# 10     2   Lucas
#[Out]# 11     2   Lucas
#[Out]# 12     2   Lucas
#[Out]# 13     3    Finn
#[Out]# 14     3    Finn
#[Out]# 15     3    Finn
#[Out]# 16     4    Daan
#[Out]# 17     4    Daan
#[Out]# 18     4    Daan
#[Out]# 19     4    Daan
#[Out]# 20     4    Daan
#[Out]# 21     4    Daan
#[Out]# 22     5    Levi
#[Out]# 23     5    Levi
#[Out]# 24     5    Levi
#[Out]# 25     5    Levi
#[Out]# 26     5    Levi
#[Out]# 27     5    Levi
#[Out]# 28     7    Bram
#[Out]# 29     7    Bram
#[Out]# ..   ...     ...
#[Out]# 479  190  Kostas
#[Out]# 480  190  Kostas
#[Out]# 481  190  Kostas
#[Out]# 482  190  Kostas
#[Out]# 483  190  Kostas
#[Out]# 484  190  Kostas
#[Out]# 485  190  Kostas
#[Out]# 486  190  Kostas
#[Out]# 487  190  Kostas
#[Out]# 488  190  Kostas
#[Out]# 489  190  Kostas
#[Out]# 490  190  Kostas
#[Out]# 491  190  Kostas
#[Out]# 492  190  Kostas
#[Out]# 493  190  Kostas
#[Out]# 494  190  Kostas
#[Out]# 495  190  Kostas
#[Out]# 496  190  Kostas
#[Out]# 497  190  Kostas
#[Out]# 498  190  Kostas
#[Out]# 499  190  Kostas
#[Out]# 500  190  Kostas
#[Out]# 501  190  Kostas
#[Out]# 502  190  Kostas
#[Out]# 503  190  Kostas
#[Out]# 504  190  Kostas
#[Out]# 505  190  Kostas
#[Out]# 506  190  Kostas
#[Out]# 507  190  Kostas
#[Out]# 508  190  Kostas
#[Out]# 
#[Out]# [509 rows x 2 columns]
query2 = '''
    SELECT customer.cID, cName
    FROM (
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Onions'
        ) as OPurchasers,
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Coffee'
        ) as CPurchasers
    )
    WHERE OPurchasers.cID = CPurchasers.cID AND OPurchasers.cName = CPurchasers.cName AND OPurchasers.date = CPurchasers.date
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT cID, cName
    FROM (
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Onions'
        ) as OPurchasers,
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Coffee'
        ) as CPurchasers
    )
    WHERE OPurchasers.cID = CPurchasers.cID AND OPurchasers.cName = CPurchasers.cName AND OPurchasers.date = CPurchasers.date
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT OPurchasers.cID, OPurchasers.cName
    FROM (
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Onions'
        ) as OPurchasers,
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Coffee'
        ) as CPurchasers
    )
    WHERE OPurchasers.cID = CPurchasers.cID AND OPurchasers.cName = CPurchasers.cName AND OPurchasers.date = CPurchasers.date
'''

pd.read_sql_query(query2, conn)
#[Out]#    OPurchasers.cID OPurchasers.cName
#[Out]# 0              124             Sofie
#[Out]# 1              190            Kostas
query2 = '''
    SELECT OPurchasers.cID as cID, OPurchasers.cName as cName
    FROM (
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Onions'
        ) as OPurchasers,
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Coffee'
        ) as CPurchasers
    )
    WHERE OPurchasers.cID = CPurchasers.cID AND OPurchasers.cName = CPurchasers.cName AND OPurchasers.date = CPurchasers.date
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    SELECT *
    FROM purchase
    WHERE cID = 124 OR cID = 190
'''

pd.read_sql_query(query2, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   323  124   54    4  2018-08-26         4   1.10
#[Out]# 1   324  124   17   26  2018-08-26         9   2.75
#[Out]# 2   325  124   14   28  2018-08-26         6   8.25
#[Out]# 3   326  124   16   16  2018-08-26         1   1.40
#[Out]# 4   327  124   23   12  2018-08-26         3  11.65
#[Out]# 5   328  124    9   21  2018-08-26         6   2.15
#[Out]# 6   329  124   18   10  2018-08-26         2   0.50
#[Out]# 7   330  124    1   11  2018-08-26         6   1.00
#[Out]# 8   331  124   21    9  2018-08-23         1   1.65
#[Out]# 9   332  124   35    7  2018-08-23         7   2.20
#[Out]# 10  333  124    6   15  2018-08-23         1   1.00
#[Out]# 11  784  190    0   27  2018-08-19         5   4.45
#[Out]# 12  785  190    1   19  2018-08-24         6   2.55
#[Out]# 13  786  190    2   19  2018-08-19         4   1.40
#[Out]# 14  787  190    3   28  2018-08-23         5   0.50
#[Out]# 15  788  190    4    7  2018-08-26         7   1.30
#[Out]# 16  789  190    5    2  2018-08-23         7   2.00
#[Out]# 17  790  190    6   10  2018-08-15         2   4.15
#[Out]# 18  791  190    7   22  2018-08-20         4   3.20
#[Out]# 19  792  190    8   20  2018-08-16         7   3.25
#[Out]# 20  793  190    9   21  2018-08-26         5   4.25
#[Out]# 21  794  190   10   19  2018-08-22         7   0.90
#[Out]# 22  795  190   11    9  2018-08-22         5   3.00
#[Out]# 23  796  190   12   26  2018-08-17         6   2.75
#[Out]# 24  797  190   13    0  2018-08-26         4   2.00
#[Out]# 25  798  190   14   15  2018-08-17         5   3.80
#[Out]# 26  799  190   15   21  2018-08-20         2   3.10
#[Out]# 27  800  190   16    4  2018-08-26         1   2.40
#[Out]# 28  801  190   17   10  2018-08-23         6   0.95
#[Out]# 29  802  190   18   27  2018-08-21         4   0.55
#[Out]# ..  ...  ...  ...  ...         ...       ...    ...
#[Out]# 45  818  190   34   28  2018-08-20         4   2.80
#[Out]# 46  819  190   35   27  2018-08-15         5   0.50
#[Out]# 47  820  190   36    5  2018-08-23         3   2.55
#[Out]# 48  821  190   37   28  2018-08-15         4   0.65
#[Out]# 49  822  190   38    7  2018-08-24         4   0.70
#[Out]# 50  823  190   39    0  2018-08-25         4   3.70
#[Out]# 51  824  190   40   11  2018-08-15         2   3.50
#[Out]# 52  825  190   41    6  2018-08-15         5   2.95
#[Out]# 53  826  190   42   19  2018-08-22         5   2.75
#[Out]# 54  827  190   43   17  2018-08-17         7   1.50
#[Out]# 55  828  190   44    9  2018-08-18         5   0.85
#[Out]# 56  829  190   45   11  2018-08-19         2   3.55
#[Out]# 57  830  190   46   22  2018-08-25         4   2.60
#[Out]# 58  831  190   47   17  2018-08-17         4   3.25
#[Out]# 59  832  190   48   20  2018-08-26         6   4.30
#[Out]# 60  833  190   49   11  2018-08-17         3   3.05
#[Out]# 61  834  190   50   21  2018-08-22         6   4.05
#[Out]# 62  835  190   51   23  2018-08-19         1   1.50
#[Out]# 63  836  190   52   23  2018-08-15         5   2.50
#[Out]# 64  837  190   53    8  2018-08-18         4   3.95
#[Out]# 65  838  190   54    0  2018-08-25         6   3.50
#[Out]# 66  839  190   55    8  2018-08-18         7   2.95
#[Out]# 67  840  190   56   11  2018-08-15         4   1.60
#[Out]# 68  841  190   57   15  2018-08-22         5   3.25
#[Out]# 69  842  190   58    2  2018-08-19         7   0.75
#[Out]# 70  843  190   59   17  2018-08-26         2   3.80
#[Out]# 71  844  190   60    5  2018-08-27         6   4.35
#[Out]# 72  845  190   61   19  2018-08-23         5   2.85
#[Out]# 73  846  190   62    9  2018-08-16         2   3.15
#[Out]# 74  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [75 rows x 7 columns]
query2 = '''
    SELECT *
    FROM purchase
    WHERE cID = 124 OR cID = 190
    ORDER BY date
'''

pd.read_sql_query(query2, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   790  190    6   10  2018-08-15         2   4.15
#[Out]# 1   803  190   19   23  2018-08-15         7   3.75
#[Out]# 2   819  190   35   27  2018-08-15         5   0.50
#[Out]# 3   821  190   37   28  2018-08-15         4   0.65
#[Out]# 4   824  190   40   11  2018-08-15         2   3.50
#[Out]# 5   825  190   41    6  2018-08-15         5   2.95
#[Out]# 6   836  190   52   23  2018-08-15         5   2.50
#[Out]# 7   840  190   56   11  2018-08-15         4   1.60
#[Out]# 8   792  190    8   20  2018-08-16         7   3.25
#[Out]# 9   805  190   21   17  2018-08-16         6   3.15
#[Out]# 10  808  190   24   26  2018-08-16         5   3.25
#[Out]# 11  846  190   62    9  2018-08-16         2   3.15
#[Out]# 12  796  190   12   26  2018-08-17         6   2.75
#[Out]# 13  798  190   14   15  2018-08-17         5   3.80
#[Out]# 14  804  190   20   20  2018-08-17         7   0.50
#[Out]# 15  811  190   27   13  2018-08-17         4   0.90
#[Out]# 16  827  190   43   17  2018-08-17         7   1.50
#[Out]# 17  831  190   47   17  2018-08-17         4   3.25
#[Out]# 18  833  190   49   11  2018-08-17         3   3.05
#[Out]# 19  807  190   23    3  2018-08-18         1   2.75
#[Out]# 20  814  190   30   10  2018-08-18         4   4.35
#[Out]# 21  828  190   44    9  2018-08-18         5   0.85
#[Out]# 22  837  190   53    8  2018-08-18         4   3.95
#[Out]# 23  839  190   55    8  2018-08-18         7   2.95
#[Out]# 24  784  190    0   27  2018-08-19         5   4.45
#[Out]# 25  786  190    2   19  2018-08-19         4   1.40
#[Out]# 26  806  190   22   25  2018-08-19         7   3.20
#[Out]# 27  815  190   31   17  2018-08-19         7   1.20
#[Out]# 28  817  190   33   19  2018-08-19         5   4.25
#[Out]# 29  829  190   45   11  2018-08-19         2   3.55
#[Out]# ..  ...  ...  ...  ...         ...       ...    ...
#[Out]# 45  332  124   35    7  2018-08-23         7   2.20
#[Out]# 46  333  124    6   15  2018-08-23         1   1.00
#[Out]# 47  787  190    3   28  2018-08-23         5   0.50
#[Out]# 48  789  190    5    2  2018-08-23         7   2.00
#[Out]# 49  801  190   17   10  2018-08-23         6   0.95
#[Out]# 50  812  190   28   19  2018-08-23         5   1.75
#[Out]# 51  820  190   36    5  2018-08-23         3   2.55
#[Out]# 52  845  190   61   19  2018-08-23         5   2.85
#[Out]# 53  785  190    1   19  2018-08-24         6   2.55
#[Out]# 54  822  190   38    7  2018-08-24         4   0.70
#[Out]# 55  823  190   39    0  2018-08-25         4   3.70
#[Out]# 56  830  190   46   22  2018-08-25         4   2.60
#[Out]# 57  838  190   54    0  2018-08-25         6   3.50
#[Out]# 58  323  124   54    4  2018-08-26         4   1.10
#[Out]# 59  324  124   17   26  2018-08-26         9   2.75
#[Out]# 60  325  124   14   28  2018-08-26         6   8.25
#[Out]# 61  326  124   16   16  2018-08-26         1   1.40
#[Out]# 62  327  124   23   12  2018-08-26         3  11.65
#[Out]# 63  328  124    9   21  2018-08-26         6   2.15
#[Out]# 64  329  124   18   10  2018-08-26         2   0.50
#[Out]# 65  330  124    1   11  2018-08-26         6   1.00
#[Out]# 66  788  190    4    7  2018-08-26         7   1.30
#[Out]# 67  793  190    9   21  2018-08-26         5   4.25
#[Out]# 68  797  190   13    0  2018-08-26         4   2.00
#[Out]# 69  800  190   16    4  2018-08-26         1   2.40
#[Out]# 70  816  190   32    0  2018-08-26         4   3.85
#[Out]# 71  832  190   48   20  2018-08-26         6   4.30
#[Out]# 72  843  190   59   17  2018-08-26         2   3.80
#[Out]# 73  813  190   29   17  2018-08-27         5   1.20
#[Out]# 74  844  190   60    5  2018-08-27         6   4.35
#[Out]# 
#[Out]# [75 rows x 7 columns]
query2 = '''
    SELECT OPurchasers.cID as cID, OPurchasers.cName as cName
    FROM (
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Onions'
        ) as OPurchasers,
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Coffee'
        ) as CPurchasers
    )
    WHERE OPurchasers.cID = CPurchasers.cID AND OPurchasers.cName = CPurchasers.cName AND OPurchasers.date = CPurchasers.date
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT count(cID)
    FROM store
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT count(sID)
    FROM store
'''

pd.read_sql_query(query3, conn)
#[Out]#    count(sID)
#[Out]# 0          64
query3 = '''
    SELECT DISTINCT cID, count(DISTINCT sID)
    FROM purchase
    GROUP BY cID
    HAVING count(DISTINCT sID) = (SELECT count(sID) FROM store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  count(DISTINCT sID)
#[Out]# 0  190                   64
query3 = '''
    SELECT DISTINCT cID, count(DISTINCT sID)
    FROM purchase
    GROUP BY cID
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count(DISTINCT sID)
#[Out]# 0      0                    1
#[Out]# 1      1                    7
#[Out]# 2      2                    5
#[Out]# 3      3                    3
#[Out]# 4      4                    6
#[Out]# 5      5                    6
#[Out]# 6      7                    6
#[Out]# 7      8                    2
#[Out]# 8     10                    1
#[Out]# 9     11                    1
#[Out]# 10    13                    7
#[Out]# 11    15                    1
#[Out]# 12    16                   10
#[Out]# 13    17                    2
#[Out]# 14    18                    3
#[Out]# 15    19                    4
#[Out]# 16    20                    3
#[Out]# 17    21                    3
#[Out]# 18    22                    2
#[Out]# 19    24                    9
#[Out]# 20    25                    1
#[Out]# 21    26                    1
#[Out]# 22    27                    5
#[Out]# 23    28                    1
#[Out]# 24    29                    2
#[Out]# 25    30                    3
#[Out]# 26    31                    2
#[Out]# 27    33                    9
#[Out]# 28    34                    1
#[Out]# 29    35                    2
#[Out]# ..   ...                  ...
#[Out]# 102  147                    3
#[Out]# 103  149                    2
#[Out]# 104  151                    2
#[Out]# 105  152                    3
#[Out]# 106  157                    2
#[Out]# 107  159                    2
#[Out]# 108  161                    9
#[Out]# 109  162                    8
#[Out]# 110  163                    4
#[Out]# 111  165                    6
#[Out]# 112  167                   10
#[Out]# 113  168                    1
#[Out]# 114  169                   11
#[Out]# 115  170                    3
#[Out]# 116  171                    2
#[Out]# 117  172                    2
#[Out]# 118  175                    2
#[Out]# 119  176                    6
#[Out]# 120  177                    5
#[Out]# 121  178                    2
#[Out]# 122  179                    6
#[Out]# 123  180                    2
#[Out]# 124  181                    3
#[Out]# 125  182                    3
#[Out]# 126  184                    1
#[Out]# 127  185                    1
#[Out]# 128  186                    1
#[Out]# 129  188                    1
#[Out]# 130  189                    2
#[Out]# 131  190                   64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    SELECT DISTINCT cID
    FROM purchase
    GROUP BY cID
    HAVING count(DISTINCT sID) = (SELECT count(sID) FROM store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT *
    FROM store, purchase
    WHERE store.sID = purchase.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#      sID        sName            street       city  tID  cID  sID  pID  \
#[Out]# 0      3       Sligro    Stadhoudersweg  Rotterdam    0    0    3   10   
#[Out]# 1     23         Dirk     Stationsplein      Breda    1    1   23   14   
#[Out]# 2      3       Sligro    Stadhoudersweg  Rotterdam    2    1    3   16   
#[Out]# 3     17    Hoogvliet        Kerkstraat  Eindhoven    3    1   17    9   
#[Out]# 4     32  Albert Hein        Hoogstraat    Utrecht    4    1   32   25   
#[Out]# 5     16         Lidl     Ambachtstraat    Utrecht    5    1   16   26   
#[Out]# 6     46         Lidl        Bergselaan  Rotterdam    6    1   46   11   
#[Out]# 7     36         Lidl     Julianastraat  Eindhoven    7    1   36   27   
#[Out]# 8     12         Lidl  Wilhelminastraat  Eindhoven    8    2   12   20   
#[Out]# 9     39       Sligro       Dorpsstraat  Eindhoven    9    2   39    9   
#[Out]# 10    13         Coop         Koestraat    Tilburg   10    2   13    4   
#[Out]# 11    51         Coop       Parallelweg    Utrecht   11    2   51   13   
#[Out]# 12    47         Coop     Julianastraat  Rotterdam   12    2   47   22   
#[Out]# 13    44  Albert Hein     Ambachtstraat    Utrecht   13    3   44   14   
#[Out]# 14    30         Dirk       Nieuwstraat  Eindhoven   14    3   30   26   
#[Out]# 15    29       Sligro      Marnixstraat  Amsterdam   15    3   29    9   
#[Out]# 16    17    Hoogvliet        Kerkstraat  Eindhoven   16    4   17    8   
#[Out]# 17    10        Jumbo        Bergselaan  Rotterdam   17    4   10   27   
#[Out]# 18    53         Coop        Hoogstraat    Utrecht   18    4   53   12   
#[Out]# 19    21         Coop      Kasteeldreef    Tilburg   19    4   21    6   
#[Out]# 20     7       Sligro  Wilhelminastraat  Eindhoven   20    4    7   13   
#[Out]# 21    44  Albert Hein     Ambachtstraat    Utrecht   21    4   44   26   
#[Out]# 22     4    Hoogvliet       Molenstraat  Eindhoven   22    5    4   14   
#[Out]# 23    36         Lidl     Julianastraat  Eindhoven   23    5   36   28   
#[Out]# 24    55         Coop   Sint Annastraat      Breda   24    5   55    6   
#[Out]# 25    51         Coop       Parallelweg    Utrecht   25    5   51   22   
#[Out]# 26     6         Coop    Stadhoudersweg  Rotterdam   26    5    6   16   
#[Out]# 27    17    Hoogvliet        Kerkstraat  Eindhoven   27    5   17   19   
#[Out]# 28     3       Sligro    Stadhoudersweg  Rotterdam   28    7    3   19   
#[Out]# 29    12         Lidl  Wilhelminastraat  Eindhoven   29    7   12    2   
#[Out]# ..   ...          ...               ...        ...  ...  ...  ...  ...   
#[Out]# 479   34         Coop          Bierkaai  Amsterdam  818  190   34   28   
#[Out]# 480   35         Lidl     Julianastraat    Utrecht  819  190   35   27   
#[Out]# 481   36         Lidl     Julianastraat  Eindhoven  820  190   36    5   
#[Out]# 482   37        Jumbo          Molenweg  Eindhoven  821  190   37   28   
#[Out]# 483   38    Hoogvliet          Hofplein  Rotterdam  822  190   38    7   
#[Out]# 484   39       Sligro       Dorpsstraat  Eindhoven  823  190   39    0   
#[Out]# 485   40    Hoogvliet          Hofplein  Rotterdam  824  190   40   11   
#[Out]# 486   41  Albert Hein        Bergselaan  Rotterdam  825  190   41    6   
#[Out]# 487   42       Sligro      Kalverstraat  Amsterdam  826  190   42   19   
#[Out]# 488   43         Coop    Gasthuisstraat    Utrecht  827  190   43   17   
#[Out]# 489   44  Albert Hein     Ambachtstraat    Utrecht  828  190   44    9   
#[Out]# 490   45         Coop      Kasteeldreef    Tilburg  829  190   45   11   
#[Out]# 491   46         Lidl        Bergselaan  Rotterdam  830  190   46   22   
#[Out]# 492   47         Coop     Julianastraat  Rotterdam  831  190   47   17   
#[Out]# 493   48    Hoogvliet      Kasteeldreef    Tilburg  832  190   48   20   
#[Out]# 494   49    Hoogvliet      Keizerstraat  Rotterdam  833  190   49   11   
#[Out]# 495   50       Sligro     Stationsplein      Breda  834  190   50   21   
#[Out]# 496   51         Coop       Parallelweg    Utrecht  835  190   51   23   
#[Out]# 497   52         Lidl       Nieuwstraat  Eindhoven  836  190   52   23   
#[Out]# 498   53         Coop        Hoogstraat    Utrecht  837  190   53    8   
#[Out]# 499   54         Dirk     Julianastraat  Eindhoven  838  190   54    0   
#[Out]# 500   55         Coop   Sint Annastraat      Breda  839  190   55    8   
#[Out]# 501   56        Jumbo       Parallelweg  Eindhoven  840  190   56   11   
#[Out]# 502   57         Dirk       Molenstraat  Eindhoven  841  190   57   15   
#[Out]# 503   58         Dirk      Keizerstraat  Rotterdam  842  190   58    2   
#[Out]# 504   59        Jumbo  Rozemarijnstraat      Breda  843  190   59   17   
#[Out]# 505   60         Lidl      Pannekoekweg      Breda  844  190   60    5   
#[Out]# 506   61         Lidl      Pannekoekweg      Breda  845  190   61   19   
#[Out]# 507   62        Jumbo     Poffertjesweg  Eindhoven  846  190   62    9   
#[Out]# 508   63        Jumbo     Stationstraat        Oss  847  190   63   18   
#[Out]# 
#[Out]#            date  quantity  price  
#[Out]# 0    2018-08-22         1   0.45  
#[Out]# 1    2018-08-20         2   4.65  
#[Out]# 2    2018-08-20         3   1.60  
#[Out]# 3    2018-08-20         2   1.25  
#[Out]# 4    2018-08-20         4   3.95  
#[Out]# 5    2018-08-20         4   2.75  
#[Out]# 6    2018-08-21         8   0.90  
#[Out]# 7    2018-08-21         6   9.10  
#[Out]# 8    2018-08-16         1   2.45  
#[Out]# 9    2018-08-17         7   1.35  
#[Out]# 10   2018-08-17         6   1.10  
#[Out]# 11   2018-08-17         4   3.70  
#[Out]# 12   2018-08-17         1   1.55  
#[Out]# 13   2018-08-18         2   4.30  
#[Out]# 14   2018-08-19         2   2.75  
#[Out]# 15   2018-08-19         6   1.45  
#[Out]# 16   2018-08-24         2   4.15  
#[Out]# 17   2018-08-24         9   9.05  
#[Out]# 18   2018-08-25         5  13.60  
#[Out]# 19   2018-08-24         2   1.05  
#[Out]# 20   2018-08-25         9   3.05  
#[Out]# 21   2018-08-25         4   2.75  
#[Out]# 22   2018-08-17         6   4.70  
#[Out]# 23   2018-08-22         6   8.25  
#[Out]# 24   2018-08-23         9   1.10  
#[Out]# 25   2018-08-23         2   1.55  
#[Out]# 26   2018-08-23         2   1.85  
#[Out]# 27   2018-08-23         1   2.20  
#[Out]# 28   2018-08-23         2   2.10  
#[Out]# 29   2018-08-23         6   1.70  
#[Out]# ..          ...       ...    ...  
#[Out]# 479  2018-08-20         4   2.80  
#[Out]# 480  2018-08-15         5   0.50  
#[Out]# 481  2018-08-23         3   2.55  
#[Out]# 482  2018-08-15         4   0.65  
#[Out]# 483  2018-08-24         4   0.70  
#[Out]# 484  2018-08-25         4   3.70  
#[Out]# 485  2018-08-15         2   3.50  
#[Out]# 486  2018-08-15         5   2.95  
#[Out]# 487  2018-08-22         5   2.75  
#[Out]# 488  2018-08-17         7   1.50  
#[Out]# 489  2018-08-18         5   0.85  
#[Out]# 490  2018-08-19         2   3.55  
#[Out]# 491  2018-08-25         4   2.60  
#[Out]# 492  2018-08-17         4   3.25  
#[Out]# 493  2018-08-26         6   4.30  
#[Out]# 494  2018-08-17         3   3.05  
#[Out]# 495  2018-08-22         6   4.05  
#[Out]# 496  2018-08-19         1   1.50  
#[Out]# 497  2018-08-15         5   2.50  
#[Out]# 498  2018-08-18         4   3.95  
#[Out]# 499  2018-08-25         6   3.50  
#[Out]# 500  2018-08-18         7   2.95  
#[Out]# 501  2018-08-15         4   1.60  
#[Out]# 502  2018-08-22         5   3.25  
#[Out]# 503  2018-08-19         7   0.75  
#[Out]# 504  2018-08-26         2   3.80  
#[Out]# 505  2018-08-27         6   4.35  
#[Out]# 506  2018-08-23         5   2.85  
#[Out]# 507  2018-08-16         2   3.15  
#[Out]# 508  2018-08-21         1   3.30  
#[Out]# 
#[Out]# [509 rows x 11 columns]
query4 = '''
    SELECT *
    FROM store, purchase
    WHERE store.sID = purchase.sID
    GROUP BY store.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID        sName           street       city  tID  cID  sID  pID  \
#[Out]# 0   44  Albert Hein    Ambachtstraat    Utrecht  828  190   44    9   
#[Out]# 1   55         Coop  Sint Annastraat      Breda  839  190   55    8   
#[Out]# 2   58         Dirk     Keizerstraat  Rotterdam  842  190   58    2   
#[Out]# 3   49    Hoogvliet     Keizerstraat  Rotterdam  833  190   49   11   
#[Out]# 4   63        Jumbo    Stationstraat        Oss  847  190   63   18   
#[Out]# 5   61         Lidl     Pannekoekweg      Breda  845  190   61   19   
#[Out]# 6   50       Sligro    Stationsplein      Breda  834  190   50   21   
#[Out]# 
#[Out]#          date  quantity  price  
#[Out]# 0  2018-08-18         5   0.85  
#[Out]# 1  2018-08-18         7   2.95  
#[Out]# 2  2018-08-19         7   0.75  
#[Out]# 3  2018-08-17         3   3.05  
#[Out]# 4  2018-08-21         1   3.30  
#[Out]# 5  2018-08-23         5   2.85  
#[Out]# 6  2018-08-22         6   4.05  
query4 = '''
    SELECT avg(quantity)
    FROM store, purchase
    WHERE store.sID = purchase.sID
    GROUP BY store.sName
    HAVING avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(quantity)
#[Out]# 0       4.969697
#[Out]# 1       4.681818
#[Out]# 2       5.268293
#[Out]# 3       5.280000
#[Out]# 4       4.796875
#[Out]# 5       4.674419
query4 = '''
    SELECT store.sName, avg(quantity)
    FROM store, purchase
    WHERE store.sID = purchase.sID
    GROUP BY store.sName
    HAVING avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg(quantity)
#[Out]# 0  Albert Hein       4.969697
#[Out]# 1         Coop       4.681818
#[Out]# 2         Dirk       5.268293
#[Out]# 3    Hoogvliet       5.280000
#[Out]# 4         Lidl       4.796875
#[Out]# 5       Sligro       4.674419
query4 = '''
    SELECT store.sName
    FROM store, purchase
    WHERE store.sID = purchase.sID
    GROUP BY store.sName
    HAVING avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
query5 = '''
    SELECT pName, sName
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND price = (SELECT max(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query4 = '''
    SELECT store.sName
    FROM store, purchase
    WHERE store.sID = purchase.sID
    GROUP BY store.sName
    HAVING avg(quantity) > 4 AND count(sName) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT pName, sName
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND price = max(purchase.price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pName, sName
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND price = (SELECT max(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT <diff in price>
    FROM inventory
    WHERE date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT *
    FROM inventory
    WHERE date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#     sID  pID        date  quantity  unit_price
#[Out]# 0    51   10  2018-08-23        31        0.60
#[Out]# 1    57   19  2018-08-23        12        2.95
#[Out]# 2    38   23  2018-08-23        29        1.80
#[Out]# 3    35   13  2018-08-23        28        4.15
#[Out]# 4    45   13  2018-08-23        32        4.10
#[Out]# 5     5   17  2018-08-23        34        2.45
#[Out]# 6    13   15  2018-08-23        11        1.25
#[Out]# 7    50   10  2018-08-23        54        0.55
#[Out]# 8     7    1  2018-08-23        18        5.80
#[Out]# 9     2   11  2018-08-23        21        1.00
#[Out]# 10   28   27  2018-08-23        43        8.50
#[Out]# 11   35   25  2018-08-23        36        4.00
#[Out]# 12   41    1  2018-08-23        53        4.60
#[Out]# 13   56   25  2018-08-23        19        4.35
#[Out]# 14   45    4  2018-08-23        50        1.00
#[Out]# 15   19    4  2018-08-23        53        1.20
#[Out]# 16   29   17  2018-08-23         4        1.95
#[Out]# 17   11    2  2018-08-23        22        2.10
#[Out]# 18   32   28  2018-08-23        36        6.85
#[Out]# 19    6    0  2018-08-23        37        4.35
#[Out]# 20   33   11  2018-08-23        32        1.05
#[Out]# 21   35   27  2018-08-23        54        8.85
#[Out]# 22   34   10  2018-08-23         8        0.45
#[Out]# 23   42   12  2018-08-23        46       11.40
#[Out]# 24   41   14  2018-08-23         3        3.35
#[Out]# 25   33   19  2018-08-23        32        2.25
#[Out]# 26   30   22  2018-08-23        29        2.05
#[Out]# 27   50   22  2018-08-23         5        1.95
#[Out]# 28   29    0  2018-08-23        28        5.15
#[Out]# 29   47    7  2018-08-23        27        1.85
#[Out]# ..  ...  ...         ...       ...         ...
#[Out]# 38   11   16  2018-08-23         3        1.90
#[Out]# 39   21   23  2018-08-23        20        2.10
#[Out]# 40   43    7  2018-08-23        20        1.95
#[Out]# 41   40   14  2018-08-23         3        4.10
#[Out]# 42    3    3  2018-08-23        17        1.35
#[Out]# 43   16   22  2018-08-23        14        1.60
#[Out]# 44   50   14  2018-08-23        19        3.85
#[Out]# 45   40   27  2018-08-23        17        6.90
#[Out]# 46   33    8  2018-08-23        16        4.80
#[Out]# 47   44   19  2018-08-23         4        2.65
#[Out]# 48   12   15  2018-08-23         1        1.25
#[Out]# 49   11   14  2018-08-23        12        3.20
#[Out]# 50    5   16  2018-08-23         4        1.65
#[Out]# 51    1    5  2018-08-23         2        0.45
#[Out]# 52   52   28  2018-08-23         8        7.35
#[Out]# 53    5   12  2018-08-23        11       13.40
#[Out]# 54   12   13  2018-08-23        15        3.55
#[Out]# 55   35   11  2018-08-23        15        1.20
#[Out]# 56   55    1  2018-08-23         1        4.80
#[Out]# 57   54   12  2018-08-23         5       12.55
#[Out]# 58   11   15  2018-08-23        14        1.30
#[Out]# 59   35    7  2018-08-23         7        2.20
#[Out]# 60    6   15  2018-08-23         4        1.00
#[Out]# 61   37   28  2018-08-23        19        7.75
#[Out]# 62   25    8  2018-08-23         6        5.55
#[Out]# 63    9   12  2018-08-23         5       13.15
#[Out]# 64   38   24  2018-08-23        10        3.55
#[Out]# 65   56    1  2018-08-23         1        4.40
#[Out]# 66   48    6  2018-08-23        21        1.15
#[Out]# 67    4   13  2018-08-23        23        4.20
#[Out]# 
#[Out]# [68 rows x 5 columns]
query6 = '''
    SELECT max(price)
    FROM inventory
    WHERE date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(unit_price)
    FROM inventory
    WHERE date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(unit_price)
#[Out]# 0             13.4
query6 = '''
    SELECT *
    FROM inventory
    WHERE date = '2018-08-23' AND unit_price = (SELECT max(unit_price) FROM inventory)
'''

pd.read_sql_query(query6, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sID, pID, date, quantity, unit_price]
#[Out]# Index: []
query6 = '''
    SELECT *
    FROM inventory
    WHERE date = '2018-08-23' AND unit_price = (SELECT max(unit_price) FROM inventory WHERE date = '2018-08-23')
'''

pd.read_sql_query(query6, conn)
#[Out]#    sID  pID        date  quantity  unit_price
#[Out]# 0    5   12  2018-08-23        11        13.4
query6 = '''
    SELECT *
    FROM inventory
    WHERE date = '2018-08-23' AND unit_price = (SELECT max(unit_price) - min(unit_price) FROM inventory WHERE date = '2018-08-23')
'''

pd.read_sql_query(query6, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sID, pID, date, quantity, unit_price]
#[Out]# Index: []
query6 = '''
    SELECT *
    FROM inventory
    WHERE unit_price = (SELECT max(unit_price) - min(unit_price) FROM inventory WHERE date = '2018-08-23')
'''

pd.read_sql_query(query6, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sID, pID, date, quantity, unit_price]
#[Out]# Index: []
query6 = '''
    SELECT *
    FROM inventory
    WHERE unit_price = (SELECT max(unit_price) - min(unit_price) FROM inventory)
'''

pd.read_sql_query(query6, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sID, pID, date, quantity, unit_price]
#[Out]# Index: []
query6 = '''
    SELECT *
    FROM (SELECT * FROM inventory WHERE date = '2018-08-23')
'''

pd.read_sql_query(query6, conn)
#[Out]#     sID  pID        date  quantity  unit_price
#[Out]# 0    51   10  2018-08-23        31        0.60
#[Out]# 1    57   19  2018-08-23        12        2.95
#[Out]# 2    38   23  2018-08-23        29        1.80
#[Out]# 3    35   13  2018-08-23        28        4.15
#[Out]# 4    45   13  2018-08-23        32        4.10
#[Out]# 5     5   17  2018-08-23        34        2.45
#[Out]# 6    13   15  2018-08-23        11        1.25
#[Out]# 7    50   10  2018-08-23        54        0.55
#[Out]# 8     7    1  2018-08-23        18        5.80
#[Out]# 9     2   11  2018-08-23        21        1.00
#[Out]# 10   28   27  2018-08-23        43        8.50
#[Out]# 11   35   25  2018-08-23        36        4.00
#[Out]# 12   41    1  2018-08-23        53        4.60
#[Out]# 13   56   25  2018-08-23        19        4.35
#[Out]# 14   45    4  2018-08-23        50        1.00
#[Out]# 15   19    4  2018-08-23        53        1.20
#[Out]# 16   29   17  2018-08-23         4        1.95
#[Out]# 17   11    2  2018-08-23        22        2.10
#[Out]# 18   32   28  2018-08-23        36        6.85
#[Out]# 19    6    0  2018-08-23        37        4.35
#[Out]# 20   33   11  2018-08-23        32        1.05
#[Out]# 21   35   27  2018-08-23        54        8.85
#[Out]# 22   34   10  2018-08-23         8        0.45
#[Out]# 23   42   12  2018-08-23        46       11.40
#[Out]# 24   41   14  2018-08-23         3        3.35
#[Out]# 25   33   19  2018-08-23        32        2.25
#[Out]# 26   30   22  2018-08-23        29        2.05
#[Out]# 27   50   22  2018-08-23         5        1.95
#[Out]# 28   29    0  2018-08-23        28        5.15
#[Out]# 29   47    7  2018-08-23        27        1.85
#[Out]# ..  ...  ...         ...       ...         ...
#[Out]# 38   11   16  2018-08-23         3        1.90
#[Out]# 39   21   23  2018-08-23        20        2.10
#[Out]# 40   43    7  2018-08-23        20        1.95
#[Out]# 41   40   14  2018-08-23         3        4.10
#[Out]# 42    3    3  2018-08-23        17        1.35
#[Out]# 43   16   22  2018-08-23        14        1.60
#[Out]# 44   50   14  2018-08-23        19        3.85
#[Out]# 45   40   27  2018-08-23        17        6.90
#[Out]# 46   33    8  2018-08-23        16        4.80
#[Out]# 47   44   19  2018-08-23         4        2.65
#[Out]# 48   12   15  2018-08-23         1        1.25
#[Out]# 49   11   14  2018-08-23        12        3.20
#[Out]# 50    5   16  2018-08-23         4        1.65
#[Out]# 51    1    5  2018-08-23         2        0.45
#[Out]# 52   52   28  2018-08-23         8        7.35
#[Out]# 53    5   12  2018-08-23        11       13.40
#[Out]# 54   12   13  2018-08-23        15        3.55
#[Out]# 55   35   11  2018-08-23        15        1.20
#[Out]# 56   55    1  2018-08-23         1        4.80
#[Out]# 57   54   12  2018-08-23         5       12.55
#[Out]# 58   11   15  2018-08-23        14        1.30
#[Out]# 59   35    7  2018-08-23         7        2.20
#[Out]# 60    6   15  2018-08-23         4        1.00
#[Out]# 61   37   28  2018-08-23        19        7.75
#[Out]# 62   25    8  2018-08-23         6        5.55
#[Out]# 63    9   12  2018-08-23         5       13.15
#[Out]# 64   38   24  2018-08-23        10        3.55
#[Out]# 65   56    1  2018-08-23         1        4.40
#[Out]# 66   48    6  2018-08-23        21        1.15
#[Out]# 67    4   13  2018-08-23        23        4.20
#[Out]# 
#[Out]# [68 rows x 5 columns]
query6 = '''
    SELECT *
    FROM (SELECT * FROM inventory WHERE date = '2018-08-23')
    GROUP BY sID
'''

pd.read_sql_query(query6, conn)
#[Out]#     sID  pID        date  quantity  unit_price
#[Out]# 0     1    5  2018-08-23         2        0.45
#[Out]# 1     2   16  2018-08-23         0        2.00
#[Out]# 2     3   19  2018-08-23        11        2.10
#[Out]# 3     4   13  2018-08-23        23        4.20
#[Out]# 4     5   24  2018-08-23        32        4.10
#[Out]# 5     6   16  2018-08-23        14        1.85
#[Out]# 6     7    1  2018-08-23        18        5.80
#[Out]# 7     9   12  2018-08-23         5       13.15
#[Out]# 8    11   16  2018-08-23         3        1.90
#[Out]# 9    12   15  2018-08-23         1        1.25
#[Out]# 10   13   15  2018-08-23        11        1.25
#[Out]# 11   16   22  2018-08-23        14        1.60
#[Out]# 12   17   19  2018-08-23        10        2.20
#[Out]# 13   19    4  2018-08-23        53        1.20
#[Out]# 14   21   23  2018-08-23        20        2.10
#[Out]# 15   25    8  2018-08-23         6        5.55
#[Out]# 16   28   27  2018-08-23        43        8.50
#[Out]# 17   29   17  2018-08-23         4        1.95
#[Out]# 18   30   22  2018-08-23        29        2.05
#[Out]# 19   31    0  2018-08-23        25        4.60
#[Out]# 20   32   28  2018-08-23        36        6.85
#[Out]# 21   33   19  2018-08-23        32        2.25
#[Out]# 22   34   10  2018-08-23         8        0.45
#[Out]# 23   35   27  2018-08-23        54        8.85
#[Out]# 24   37   28  2018-08-23        19        7.75
#[Out]# 25   38   24  2018-08-23        10        3.55
#[Out]# 26   40   27  2018-08-23        17        6.90
#[Out]# 27   41   14  2018-08-23         3        3.35
#[Out]# 28   42   12  2018-08-23        46       11.40
#[Out]# 29   43    7  2018-08-23        20        1.95
#[Out]# 30   44   19  2018-08-23         4        2.65
#[Out]# 31   45   13  2018-08-23        32        4.10
#[Out]# 32   47    7  2018-08-23        27        1.85
#[Out]# 33   48    6  2018-08-23        21        1.15
#[Out]# 34   50   22  2018-08-23         5        1.95
#[Out]# 35   51   22  2018-08-23        13        1.55
#[Out]# 36   52   28  2018-08-23         8        7.35
#[Out]# 37   54   12  2018-08-23         5       12.55
#[Out]# 38   55    1  2018-08-23         1        4.80
#[Out]# 39   56   25  2018-08-23        19        4.35
#[Out]# 40   57   19  2018-08-23        12        2.95
query6 = '''
    SELECT *
    FROM (SELECT * FROM inventory WHERE date = '2018-08-23')
'''

pd.read_sql_query(query6, conn)
#[Out]#     sID  pID        date  quantity  unit_price
#[Out]# 0    51   10  2018-08-23        31        0.60
#[Out]# 1    57   19  2018-08-23        12        2.95
#[Out]# 2    38   23  2018-08-23        29        1.80
#[Out]# 3    35   13  2018-08-23        28        4.15
#[Out]# 4    45   13  2018-08-23        32        4.10
#[Out]# 5     5   17  2018-08-23        34        2.45
#[Out]# 6    13   15  2018-08-23        11        1.25
#[Out]# 7    50   10  2018-08-23        54        0.55
#[Out]# 8     7    1  2018-08-23        18        5.80
#[Out]# 9     2   11  2018-08-23        21        1.00
#[Out]# 10   28   27  2018-08-23        43        8.50
#[Out]# 11   35   25  2018-08-23        36        4.00
#[Out]# 12   41    1  2018-08-23        53        4.60
#[Out]# 13   56   25  2018-08-23        19        4.35
#[Out]# 14   45    4  2018-08-23        50        1.00
#[Out]# 15   19    4  2018-08-23        53        1.20
#[Out]# 16   29   17  2018-08-23         4        1.95
#[Out]# 17   11    2  2018-08-23        22        2.10
#[Out]# 18   32   28  2018-08-23        36        6.85
#[Out]# 19    6    0  2018-08-23        37        4.35
#[Out]# 20   33   11  2018-08-23        32        1.05
#[Out]# 21   35   27  2018-08-23        54        8.85
#[Out]# 22   34   10  2018-08-23         8        0.45
#[Out]# 23   42   12  2018-08-23        46       11.40
#[Out]# 24   41   14  2018-08-23         3        3.35
#[Out]# 25   33   19  2018-08-23        32        2.25
#[Out]# 26   30   22  2018-08-23        29        2.05
#[Out]# 27   50   22  2018-08-23         5        1.95
#[Out]# 28   29    0  2018-08-23        28        5.15
#[Out]# 29   47    7  2018-08-23        27        1.85
#[Out]# ..  ...  ...         ...       ...         ...
#[Out]# 38   11   16  2018-08-23         3        1.90
#[Out]# 39   21   23  2018-08-23        20        2.10
#[Out]# 40   43    7  2018-08-23        20        1.95
#[Out]# 41   40   14  2018-08-23         3        4.10
#[Out]# 42    3    3  2018-08-23        17        1.35
#[Out]# 43   16   22  2018-08-23        14        1.60
#[Out]# 44   50   14  2018-08-23        19        3.85
#[Out]# 45   40   27  2018-08-23        17        6.90
#[Out]# 46   33    8  2018-08-23        16        4.80
#[Out]# 47   44   19  2018-08-23         4        2.65
#[Out]# 48   12   15  2018-08-23         1        1.25
#[Out]# 49   11   14  2018-08-23        12        3.20
#[Out]# 50    5   16  2018-08-23         4        1.65
#[Out]# 51    1    5  2018-08-23         2        0.45
#[Out]# 52   52   28  2018-08-23         8        7.35
#[Out]# 53    5   12  2018-08-23        11       13.40
#[Out]# 54   12   13  2018-08-23        15        3.55
#[Out]# 55   35   11  2018-08-23        15        1.20
#[Out]# 56   55    1  2018-08-23         1        4.80
#[Out]# 57   54   12  2018-08-23         5       12.55
#[Out]# 58   11   15  2018-08-23        14        1.30
#[Out]# 59   35    7  2018-08-23         7        2.20
#[Out]# 60    6   15  2018-08-23         4        1.00
#[Out]# 61   37   28  2018-08-23        19        7.75
#[Out]# 62   25    8  2018-08-23         6        5.55
#[Out]# 63    9   12  2018-08-23         5       13.15
#[Out]# 64   38   24  2018-08-23        10        3.55
#[Out]# 65   56    1  2018-08-23         1        4.40
#[Out]# 66   48    6  2018-08-23        21        1.15
#[Out]# 67    4   13  2018-08-23        23        4.20
#[Out]# 
#[Out]# [68 rows x 5 columns]

# IPython log file

query2 = '''
    SELECT cID, cName
    FROM customer, purchase, product
    WHERE customer.cID = purchase.cID AND product.pID = purchase.pID
'''

pd.read_sql_query(query2, conn)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT pID
    FROM purchase
    GROUP BY pID
    HAVING count(cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT pID
    FROM purchase
    GROUP BY pID
    HAVING count(DISTINCT cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT cID, cName
    FROM customer, purchase, product
    WHERE customer.cID = purchase.cID AND product.pID = purchase.pID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT customer.cID, cName
    FROM customer, purchase, product
    WHERE customer.cID = purchase.cID AND product.pID = purchase.pID
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID   cName
#[Out]# 0      0    Noah
#[Out]# 1      1     Sem
#[Out]# 2      1     Sem
#[Out]# 3      1     Sem
#[Out]# 4      1     Sem
#[Out]# 5      1     Sem
#[Out]# 6      1     Sem
#[Out]# 7      1     Sem
#[Out]# 8      2   Lucas
#[Out]# 9      2   Lucas
#[Out]# 10     2   Lucas
#[Out]# 11     2   Lucas
#[Out]# 12     2   Lucas
#[Out]# 13     3    Finn
#[Out]# 14     3    Finn
#[Out]# 15     3    Finn
#[Out]# 16     4    Daan
#[Out]# 17     4    Daan
#[Out]# 18     4    Daan
#[Out]# 19     4    Daan
#[Out]# 20     4    Daan
#[Out]# 21     4    Daan
#[Out]# 22     5    Levi
#[Out]# 23     5    Levi
#[Out]# 24     5    Levi
#[Out]# 25     5    Levi
#[Out]# 26     5    Levi
#[Out]# 27     5    Levi
#[Out]# 28     7    Bram
#[Out]# 29     7    Bram
#[Out]# ..   ...     ...
#[Out]# 479  190  Kostas
#[Out]# 480  190  Kostas
#[Out]# 481  190  Kostas
#[Out]# 482  190  Kostas
#[Out]# 483  190  Kostas
#[Out]# 484  190  Kostas
#[Out]# 485  190  Kostas
#[Out]# 486  190  Kostas
#[Out]# 487  190  Kostas
#[Out]# 488  190  Kostas
#[Out]# 489  190  Kostas
#[Out]# 490  190  Kostas
#[Out]# 491  190  Kostas
#[Out]# 492  190  Kostas
#[Out]# 493  190  Kostas
#[Out]# 494  190  Kostas
#[Out]# 495  190  Kostas
#[Out]# 496  190  Kostas
#[Out]# 497  190  Kostas
#[Out]# 498  190  Kostas
#[Out]# 499  190  Kostas
#[Out]# 500  190  Kostas
#[Out]# 501  190  Kostas
#[Out]# 502  190  Kostas
#[Out]# 503  190  Kostas
#[Out]# 504  190  Kostas
#[Out]# 505  190  Kostas
#[Out]# 506  190  Kostas
#[Out]# 507  190  Kostas
#[Out]# 508  190  Kostas
#[Out]# 
#[Out]# [509 rows x 2 columns]
query2 = '''
    SELECT customer.cID, cName
    FROM (
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Onions'
        ) as OPurchasers,
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Coffee'
        ) as CPurchasers
    )
    WHERE OPurchasers.cID = CPurchasers.cID AND OPurchasers.cName = CPurchasers.cName AND OPurchasers.date = CPurchasers.date
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT cID, cName
    FROM (
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Onions'
        ) as OPurchasers,
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Coffee'
        ) as CPurchasers
    )
    WHERE OPurchasers.cID = CPurchasers.cID AND OPurchasers.cName = CPurchasers.cName AND OPurchasers.date = CPurchasers.date
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT OPurchasers.cID, OPurchasers.cName
    FROM (
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Onions'
        ) as OPurchasers,
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Coffee'
        ) as CPurchasers
    )
    WHERE OPurchasers.cID = CPurchasers.cID AND OPurchasers.cName = CPurchasers.cName AND OPurchasers.date = CPurchasers.date
'''

pd.read_sql_query(query2, conn)
#[Out]#    OPurchasers.cID OPurchasers.cName
#[Out]# 0              124             Sofie
#[Out]# 1              190            Kostas
query2 = '''
    SELECT OPurchasers.cID as cID, OPurchasers.cName as cName
    FROM (
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Onions'
        ) as OPurchasers,
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Coffee'
        ) as CPurchasers
    )
    WHERE OPurchasers.cID = CPurchasers.cID AND OPurchasers.cName = CPurchasers.cName AND OPurchasers.date = CPurchasers.date
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    SELECT *
    FROM purchase
    WHERE cID = 124 OR cID = 190
'''

pd.read_sql_query(query2, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   323  124   54    4  2018-08-26         4   1.10
#[Out]# 1   324  124   17   26  2018-08-26         9   2.75
#[Out]# 2   325  124   14   28  2018-08-26         6   8.25
#[Out]# 3   326  124   16   16  2018-08-26         1   1.40
#[Out]# 4   327  124   23   12  2018-08-26         3  11.65
#[Out]# 5   328  124    9   21  2018-08-26         6   2.15
#[Out]# 6   329  124   18   10  2018-08-26         2   0.50
#[Out]# 7   330  124    1   11  2018-08-26         6   1.00
#[Out]# 8   331  124   21    9  2018-08-23         1   1.65
#[Out]# 9   332  124   35    7  2018-08-23         7   2.20
#[Out]# 10  333  124    6   15  2018-08-23         1   1.00
#[Out]# 11  784  190    0   27  2018-08-19         5   4.45
#[Out]# 12  785  190    1   19  2018-08-24         6   2.55
#[Out]# 13  786  190    2   19  2018-08-19         4   1.40
#[Out]# 14  787  190    3   28  2018-08-23         5   0.50
#[Out]# 15  788  190    4    7  2018-08-26         7   1.30
#[Out]# 16  789  190    5    2  2018-08-23         7   2.00
#[Out]# 17  790  190    6   10  2018-08-15         2   4.15
#[Out]# 18  791  190    7   22  2018-08-20         4   3.20
#[Out]# 19  792  190    8   20  2018-08-16         7   3.25
#[Out]# 20  793  190    9   21  2018-08-26         5   4.25
#[Out]# 21  794  190   10   19  2018-08-22         7   0.90
#[Out]# 22  795  190   11    9  2018-08-22         5   3.00
#[Out]# 23  796  190   12   26  2018-08-17         6   2.75
#[Out]# 24  797  190   13    0  2018-08-26         4   2.00
#[Out]# 25  798  190   14   15  2018-08-17         5   3.80
#[Out]# 26  799  190   15   21  2018-08-20         2   3.10
#[Out]# 27  800  190   16    4  2018-08-26         1   2.40
#[Out]# 28  801  190   17   10  2018-08-23         6   0.95
#[Out]# 29  802  190   18   27  2018-08-21         4   0.55
#[Out]# ..  ...  ...  ...  ...         ...       ...    ...
#[Out]# 45  818  190   34   28  2018-08-20         4   2.80
#[Out]# 46  819  190   35   27  2018-08-15         5   0.50
#[Out]# 47  820  190   36    5  2018-08-23         3   2.55
#[Out]# 48  821  190   37   28  2018-08-15         4   0.65
#[Out]# 49  822  190   38    7  2018-08-24         4   0.70
#[Out]# 50  823  190   39    0  2018-08-25         4   3.70
#[Out]# 51  824  190   40   11  2018-08-15         2   3.50
#[Out]# 52  825  190   41    6  2018-08-15         5   2.95
#[Out]# 53  826  190   42   19  2018-08-22         5   2.75
#[Out]# 54  827  190   43   17  2018-08-17         7   1.50
#[Out]# 55  828  190   44    9  2018-08-18         5   0.85
#[Out]# 56  829  190   45   11  2018-08-19         2   3.55
#[Out]# 57  830  190   46   22  2018-08-25         4   2.60
#[Out]# 58  831  190   47   17  2018-08-17         4   3.25
#[Out]# 59  832  190   48   20  2018-08-26         6   4.30
#[Out]# 60  833  190   49   11  2018-08-17         3   3.05
#[Out]# 61  834  190   50   21  2018-08-22         6   4.05
#[Out]# 62  835  190   51   23  2018-08-19         1   1.50
#[Out]# 63  836  190   52   23  2018-08-15         5   2.50
#[Out]# 64  837  190   53    8  2018-08-18         4   3.95
#[Out]# 65  838  190   54    0  2018-08-25         6   3.50
#[Out]# 66  839  190   55    8  2018-08-18         7   2.95
#[Out]# 67  840  190   56   11  2018-08-15         4   1.60
#[Out]# 68  841  190   57   15  2018-08-22         5   3.25
#[Out]# 69  842  190   58    2  2018-08-19         7   0.75
#[Out]# 70  843  190   59   17  2018-08-26         2   3.80
#[Out]# 71  844  190   60    5  2018-08-27         6   4.35
#[Out]# 72  845  190   61   19  2018-08-23         5   2.85
#[Out]# 73  846  190   62    9  2018-08-16         2   3.15
#[Out]# 74  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [75 rows x 7 columns]
query2 = '''
    SELECT *
    FROM purchase
    WHERE cID = 124 OR cID = 190
    ORDER BY date
'''

pd.read_sql_query(query2, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   790  190    6   10  2018-08-15         2   4.15
#[Out]# 1   803  190   19   23  2018-08-15         7   3.75
#[Out]# 2   819  190   35   27  2018-08-15         5   0.50
#[Out]# 3   821  190   37   28  2018-08-15         4   0.65
#[Out]# 4   824  190   40   11  2018-08-15         2   3.50
#[Out]# 5   825  190   41    6  2018-08-15         5   2.95
#[Out]# 6   836  190   52   23  2018-08-15         5   2.50
#[Out]# 7   840  190   56   11  2018-08-15         4   1.60
#[Out]# 8   792  190    8   20  2018-08-16         7   3.25
#[Out]# 9   805  190   21   17  2018-08-16         6   3.15
#[Out]# 10  808  190   24   26  2018-08-16         5   3.25
#[Out]# 11  846  190   62    9  2018-08-16         2   3.15
#[Out]# 12  796  190   12   26  2018-08-17         6   2.75
#[Out]# 13  798  190   14   15  2018-08-17         5   3.80
#[Out]# 14  804  190   20   20  2018-08-17         7   0.50
#[Out]# 15  811  190   27   13  2018-08-17         4   0.90
#[Out]# 16  827  190   43   17  2018-08-17         7   1.50
#[Out]# 17  831  190   47   17  2018-08-17         4   3.25
#[Out]# 18  833  190   49   11  2018-08-17         3   3.05
#[Out]# 19  807  190   23    3  2018-08-18         1   2.75
#[Out]# 20  814  190   30   10  2018-08-18         4   4.35
#[Out]# 21  828  190   44    9  2018-08-18         5   0.85
#[Out]# 22  837  190   53    8  2018-08-18         4   3.95
#[Out]# 23  839  190   55    8  2018-08-18         7   2.95
#[Out]# 24  784  190    0   27  2018-08-19         5   4.45
#[Out]# 25  786  190    2   19  2018-08-19         4   1.40
#[Out]# 26  806  190   22   25  2018-08-19         7   3.20
#[Out]# 27  815  190   31   17  2018-08-19         7   1.20
#[Out]# 28  817  190   33   19  2018-08-19         5   4.25
#[Out]# 29  829  190   45   11  2018-08-19         2   3.55
#[Out]# ..  ...  ...  ...  ...         ...       ...    ...
#[Out]# 45  332  124   35    7  2018-08-23         7   2.20
#[Out]# 46  333  124    6   15  2018-08-23         1   1.00
#[Out]# 47  787  190    3   28  2018-08-23         5   0.50
#[Out]# 48  789  190    5    2  2018-08-23         7   2.00
#[Out]# 49  801  190   17   10  2018-08-23         6   0.95
#[Out]# 50  812  190   28   19  2018-08-23         5   1.75
#[Out]# 51  820  190   36    5  2018-08-23         3   2.55
#[Out]# 52  845  190   61   19  2018-08-23         5   2.85
#[Out]# 53  785  190    1   19  2018-08-24         6   2.55
#[Out]# 54  822  190   38    7  2018-08-24         4   0.70
#[Out]# 55  823  190   39    0  2018-08-25         4   3.70
#[Out]# 56  830  190   46   22  2018-08-25         4   2.60
#[Out]# 57  838  190   54    0  2018-08-25         6   3.50
#[Out]# 58  323  124   54    4  2018-08-26         4   1.10
#[Out]# 59  324  124   17   26  2018-08-26         9   2.75
#[Out]# 60  325  124   14   28  2018-08-26         6   8.25
#[Out]# 61  326  124   16   16  2018-08-26         1   1.40
#[Out]# 62  327  124   23   12  2018-08-26         3  11.65
#[Out]# 63  328  124    9   21  2018-08-26         6   2.15
#[Out]# 64  329  124   18   10  2018-08-26         2   0.50
#[Out]# 65  330  124    1   11  2018-08-26         6   1.00
#[Out]# 66  788  190    4    7  2018-08-26         7   1.30
#[Out]# 67  793  190    9   21  2018-08-26         5   4.25
#[Out]# 68  797  190   13    0  2018-08-26         4   2.00
#[Out]# 69  800  190   16    4  2018-08-26         1   2.40
#[Out]# 70  816  190   32    0  2018-08-26         4   3.85
#[Out]# 71  832  190   48   20  2018-08-26         6   4.30
#[Out]# 72  843  190   59   17  2018-08-26         2   3.80
#[Out]# 73  813  190   29   17  2018-08-27         5   1.20
#[Out]# 74  844  190   60    5  2018-08-27         6   4.35
#[Out]# 
#[Out]# [75 rows x 7 columns]
query2 = '''
    SELECT OPurchasers.cID as cID, OPurchasers.cName as cName
    FROM (
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Onions'
        ) as OPurchasers,
        (
        SELECT customer.cID, cName, date
        FROM customer, purchase, product
        WHERE customer.cID = purchase.cID AND product.pID = purchase.pID AND pName = 'Coffee'
        ) as CPurchasers
    )
    WHERE OPurchasers.cID = CPurchasers.cID AND OPurchasers.cName = CPurchasers.cName AND OPurchasers.date = CPurchasers.date
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT count(cID)
    FROM store
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT count(sID)
    FROM store
'''

pd.read_sql_query(query3, conn)
#[Out]#    count(sID)
#[Out]# 0          64
query3 = '''
    SELECT DISTINCT cID, count(DISTINCT sID)
    FROM purchase
    GROUP BY cID
    HAVING count(DISTINCT sID) = (SELECT count(sID) FROM store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  count(DISTINCT sID)
#[Out]# 0  190                   64
query3 = '''
    SELECT DISTINCT cID, count(DISTINCT sID)
    FROM purchase
    GROUP BY cID
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count(DISTINCT sID)
#[Out]# 0      0                    1
#[Out]# 1      1                    7
#[Out]# 2      2                    5
#[Out]# 3      3                    3
#[Out]# 4      4                    6
#[Out]# 5      5                    6
#[Out]# 6      7                    6
#[Out]# 7      8                    2
#[Out]# 8     10                    1
#[Out]# 9     11                    1
#[Out]# 10    13                    7
#[Out]# 11    15                    1
#[Out]# 12    16                   10
#[Out]# 13    17                    2
#[Out]# 14    18                    3
#[Out]# 15    19                    4
#[Out]# 16    20                    3
#[Out]# 17    21                    3
#[Out]# 18    22                    2
#[Out]# 19    24                    9
#[Out]# 20    25                    1
#[Out]# 21    26                    1
#[Out]# 22    27                    5
#[Out]# 23    28                    1
#[Out]# 24    29                    2
#[Out]# 25    30                    3
#[Out]# 26    31                    2
#[Out]# 27    33                    9
#[Out]# 28    34                    1
#[Out]# 29    35                    2
#[Out]# ..   ...                  ...
#[Out]# 102  147                    3
#[Out]# 103  149                    2
#[Out]# 104  151                    2
#[Out]# 105  152                    3
#[Out]# 106  157                    2
#[Out]# 107  159                    2
#[Out]# 108  161                    9
#[Out]# 109  162                    8
#[Out]# 110  163                    4
#[Out]# 111  165                    6
#[Out]# 112  167                   10
#[Out]# 113  168                    1
#[Out]# 114  169                   11
#[Out]# 115  170                    3
#[Out]# 116  171                    2
#[Out]# 117  172                    2
#[Out]# 118  175                    2
#[Out]# 119  176                    6
#[Out]# 120  177                    5
#[Out]# 121  178                    2
#[Out]# 122  179                    6
#[Out]# 123  180                    2
#[Out]# 124  181                    3
#[Out]# 125  182                    3
#[Out]# 126  184                    1
#[Out]# 127  185                    1
#[Out]# 128  186                    1
#[Out]# 129  188                    1
#[Out]# 130  189                    2
#[Out]# 131  190                   64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    SELECT DISTINCT cID
    FROM purchase
    GROUP BY cID
    HAVING count(DISTINCT sID) = (SELECT count(sID) FROM store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT *
    FROM store, purchase
    WHERE store.sID = purchase.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#      sID        sName            street       city  tID  cID  sID  pID  \
#[Out]# 0      3       Sligro    Stadhoudersweg  Rotterdam    0    0    3   10   
#[Out]# 1     23         Dirk     Stationsplein      Breda    1    1   23   14   
#[Out]# 2      3       Sligro    Stadhoudersweg  Rotterdam    2    1    3   16   
#[Out]# 3     17    Hoogvliet        Kerkstraat  Eindhoven    3    1   17    9   
#[Out]# 4     32  Albert Hein        Hoogstraat    Utrecht    4    1   32   25   
#[Out]# 5     16         Lidl     Ambachtstraat    Utrecht    5    1   16   26   
#[Out]# 6     46         Lidl        Bergselaan  Rotterdam    6    1   46   11   
#[Out]# 7     36         Lidl     Julianastraat  Eindhoven    7    1   36   27   
#[Out]# 8     12         Lidl  Wilhelminastraat  Eindhoven    8    2   12   20   
#[Out]# 9     39       Sligro       Dorpsstraat  Eindhoven    9    2   39    9   
#[Out]# 10    13         Coop         Koestraat    Tilburg   10    2   13    4   
#[Out]# 11    51         Coop       Parallelweg    Utrecht   11    2   51   13   
#[Out]# 12    47         Coop     Julianastraat  Rotterdam   12    2   47   22   
#[Out]# 13    44  Albert Hein     Ambachtstraat    Utrecht   13    3   44   14   
#[Out]# 14    30         Dirk       Nieuwstraat  Eindhoven   14    3   30   26   
#[Out]# 15    29       Sligro      Marnixstraat  Amsterdam   15    3   29    9   
#[Out]# 16    17    Hoogvliet        Kerkstraat  Eindhoven   16    4   17    8   
#[Out]# 17    10        Jumbo        Bergselaan  Rotterdam   17    4   10   27   
#[Out]# 18    53         Coop        Hoogstraat    Utrecht   18    4   53   12   
#[Out]# 19    21         Coop      Kasteeldreef    Tilburg   19    4   21    6   
#[Out]# 20     7       Sligro  Wilhelminastraat  Eindhoven   20    4    7   13   
#[Out]# 21    44  Albert Hein     Ambachtstraat    Utrecht   21    4   44   26   
#[Out]# 22     4    Hoogvliet       Molenstraat  Eindhoven   22    5    4   14   
#[Out]# 23    36         Lidl     Julianastraat  Eindhoven   23    5   36   28   
#[Out]# 24    55         Coop   Sint Annastraat      Breda   24    5   55    6   
#[Out]# 25    51         Coop       Parallelweg    Utrecht   25    5   51   22   
#[Out]# 26     6         Coop    Stadhoudersweg  Rotterdam   26    5    6   16   
#[Out]# 27    17    Hoogvliet        Kerkstraat  Eindhoven   27    5   17   19   
#[Out]# 28     3       Sligro    Stadhoudersweg  Rotterdam   28    7    3   19   
#[Out]# 29    12         Lidl  Wilhelminastraat  Eindhoven   29    7   12    2   
#[Out]# ..   ...          ...               ...        ...  ...  ...  ...  ...   
#[Out]# 479   34         Coop          Bierkaai  Amsterdam  818  190   34   28   
#[Out]# 480   35         Lidl     Julianastraat    Utrecht  819  190   35   27   
#[Out]# 481   36         Lidl     Julianastraat  Eindhoven  820  190   36    5   
#[Out]# 482   37        Jumbo          Molenweg  Eindhoven  821  190   37   28   
#[Out]# 483   38    Hoogvliet          Hofplein  Rotterdam  822  190   38    7   
#[Out]# 484   39       Sligro       Dorpsstraat  Eindhoven  823  190   39    0   
#[Out]# 485   40    Hoogvliet          Hofplein  Rotterdam  824  190   40   11   
#[Out]# 486   41  Albert Hein        Bergselaan  Rotterdam  825  190   41    6   
#[Out]# 487   42       Sligro      Kalverstraat  Amsterdam  826  190   42   19   
#[Out]# 488   43         Coop    Gasthuisstraat    Utrecht  827  190   43   17   
#[Out]# 489   44  Albert Hein     Ambachtstraat    Utrecht  828  190   44    9   
#[Out]# 490   45         Coop      Kasteeldreef    Tilburg  829  190   45   11   
#[Out]# 491   46         Lidl        Bergselaan  Rotterdam  830  190   46   22   
#[Out]# 492   47         Coop     Julianastraat  Rotterdam  831  190   47   17   
#[Out]# 493   48    Hoogvliet      Kasteeldreef    Tilburg  832  190   48   20   
#[Out]# 494   49    Hoogvliet      Keizerstraat  Rotterdam  833  190   49   11   
#[Out]# 495   50       Sligro     Stationsplein      Breda  834  190   50   21   
#[Out]# 496   51         Coop       Parallelweg    Utrecht  835  190   51   23   
#[Out]# 497   52         Lidl       Nieuwstraat  Eindhoven  836  190   52   23   
#[Out]# 498   53         Coop        Hoogstraat    Utrecht  837  190   53    8   
#[Out]# 499   54         Dirk     Julianastraat  Eindhoven  838  190   54    0   
#[Out]# 500   55         Coop   Sint Annastraat      Breda  839  190   55    8   
#[Out]# 501   56        Jumbo       Parallelweg  Eindhoven  840  190   56   11   
#[Out]# 502   57         Dirk       Molenstraat  Eindhoven  841  190   57   15   
#[Out]# 503   58         Dirk      Keizerstraat  Rotterdam  842  190   58    2   
#[Out]# 504   59        Jumbo  Rozemarijnstraat      Breda  843  190   59   17   
#[Out]# 505   60         Lidl      Pannekoekweg      Breda  844  190   60    5   
#[Out]# 506   61         Lidl      Pannekoekweg      Breda  845  190   61   19   
#[Out]# 507   62        Jumbo     Poffertjesweg  Eindhoven  846  190   62    9   
#[Out]# 508   63        Jumbo     Stationstraat        Oss  847  190   63   18   
#[Out]# 
#[Out]#            date  quantity  price  
#[Out]# 0    2018-08-22         1   0.45  
#[Out]# 1    2018-08-20         2   4.65  
#[Out]# 2    2018-08-20         3   1.60  
#[Out]# 3    2018-08-20         2   1.25  
#[Out]# 4    2018-08-20         4   3.95  
#[Out]# 5    2018-08-20         4   2.75  
#[Out]# 6    2018-08-21         8   0.90  
#[Out]# 7    2018-08-21         6   9.10  
#[Out]# 8    2018-08-16         1   2.45  
#[Out]# 9    2018-08-17         7   1.35  
#[Out]# 10   2018-08-17         6   1.10  
#[Out]# 11   2018-08-17         4   3.70  
#[Out]# 12   2018-08-17         1   1.55  
#[Out]# 13   2018-08-18         2   4.30  
#[Out]# 14   2018-08-19         2   2.75  
#[Out]# 15   2018-08-19         6   1.45  
#[Out]# 16   2018-08-24         2   4.15  
#[Out]# 17   2018-08-24         9   9.05  
#[Out]# 18   2018-08-25         5  13.60  
#[Out]# 19   2018-08-24         2   1.05  
#[Out]# 20   2018-08-25         9   3.05  
#[Out]# 21   2018-08-25         4   2.75  
#[Out]# 22   2018-08-17         6   4.70  
#[Out]# 23   2018-08-22         6   8.25  
#[Out]# 24   2018-08-23         9   1.10  
#[Out]# 25   2018-08-23         2   1.55  
#[Out]# 26   2018-08-23         2   1.85  
#[Out]# 27   2018-08-23         1   2.20  
#[Out]# 28   2018-08-23         2   2.10  
#[Out]# 29   2018-08-23         6   1.70  
#[Out]# ..          ...       ...    ...  
#[Out]# 479  2018-08-20         4   2.80  
#[Out]# 480  2018-08-15         5   0.50  
#[Out]# 481  2018-08-23         3   2.55  
#[Out]# 482  2018-08-15         4   0.65  
#[Out]# 483  2018-08-24         4   0.70  
#[Out]# 484  2018-08-25         4   3.70  
#[Out]# 485  2018-08-15         2   3.50  
#[Out]# 486  2018-08-15         5   2.95  
#[Out]# 487  2018-08-22         5   2.75  
#[Out]# 488  2018-08-17         7   1.50  
#[Out]# 489  2018-08-18         5   0.85  
#[Out]# 490  2018-08-19         2   3.55  
#[Out]# 491  2018-08-25         4   2.60  
#[Out]# 492  2018-08-17         4   3.25  
#[Out]# 493  2018-08-26         6   4.30  
#[Out]# 494  2018-08-17         3   3.05  
#[Out]# 495  2018-08-22         6   4.05  
#[Out]# 496  2018-08-19         1   1.50  
#[Out]# 497  2018-08-15         5   2.50  
#[Out]# 498  2018-08-18         4   3.95  
#[Out]# 499  2018-08-25         6   3.50  
#[Out]# 500  2018-08-18         7   2.95  
#[Out]# 501  2018-08-15         4   1.60  
#[Out]# 502  2018-08-22         5   3.25  
#[Out]# 503  2018-08-19         7   0.75  
#[Out]# 504  2018-08-26         2   3.80  
#[Out]# 505  2018-08-27         6   4.35  
#[Out]# 506  2018-08-23         5   2.85  
#[Out]# 507  2018-08-16         2   3.15  
#[Out]# 508  2018-08-21         1   3.30  
#[Out]# 
#[Out]# [509 rows x 11 columns]
query4 = '''
    SELECT *
    FROM store, purchase
    WHERE store.sID = purchase.sID
    GROUP BY store.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID        sName           street       city  tID  cID  sID  pID  \
#[Out]# 0   44  Albert Hein    Ambachtstraat    Utrecht  828  190   44    9   
#[Out]# 1   55         Coop  Sint Annastraat      Breda  839  190   55    8   
#[Out]# 2   58         Dirk     Keizerstraat  Rotterdam  842  190   58    2   
#[Out]# 3   49    Hoogvliet     Keizerstraat  Rotterdam  833  190   49   11   
#[Out]# 4   63        Jumbo    Stationstraat        Oss  847  190   63   18   
#[Out]# 5   61         Lidl     Pannekoekweg      Breda  845  190   61   19   
#[Out]# 6   50       Sligro    Stationsplein      Breda  834  190   50   21   
#[Out]# 
#[Out]#          date  quantity  price  
#[Out]# 0  2018-08-18         5   0.85  
#[Out]# 1  2018-08-18         7   2.95  
#[Out]# 2  2018-08-19         7   0.75  
#[Out]# 3  2018-08-17         3   3.05  
#[Out]# 4  2018-08-21         1   3.30  
#[Out]# 5  2018-08-23         5   2.85  
#[Out]# 6  2018-08-22         6   4.05  
query4 = '''
    SELECT avg(quantity)
    FROM store, purchase
    WHERE store.sID = purchase.sID
    GROUP BY store.sName
    HAVING avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(quantity)
#[Out]# 0       4.969697
#[Out]# 1       4.681818
#[Out]# 2       5.268293
#[Out]# 3       5.280000
#[Out]# 4       4.796875
#[Out]# 5       4.674419
query4 = '''
    SELECT store.sName, avg(quantity)
    FROM store, purchase
    WHERE store.sID = purchase.sID
    GROUP BY store.sName
    HAVING avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg(quantity)
#[Out]# 0  Albert Hein       4.969697
#[Out]# 1         Coop       4.681818
#[Out]# 2         Dirk       5.268293
#[Out]# 3    Hoogvliet       5.280000
#[Out]# 4         Lidl       4.796875
#[Out]# 5       Sligro       4.674419
query4 = '''
    SELECT store.sName
    FROM store, purchase
    WHERE store.sID = purchase.sID
    GROUP BY store.sName
    HAVING avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd

# IPython log file

query2 = '''
    SELECT cID, cName
    FROM customer, purchase, product
    WHERE customer.cID = purchase.cID AND product.pID = purchase.pID
'''

pd.read_sql_query(query2, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x178c1394340>
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID not in (
        SELECT pID, count(pID)
        FROM purchase
        GROUP BY pID
        HAVING count(pID) <= 2
    )
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID not in (
        SELECT pID
        FROM purchase
        GROUP BY pID
        HAVING count(pID) <= 2
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 475   28
#[Out]# 476   27
#[Out]# 477    5
#[Out]# 478   28
#[Out]# 479    7
#[Out]# 480    0
#[Out]# 481   11
#[Out]# 482    6
#[Out]# 483   19
#[Out]# 484   17
#[Out]# 485    9
#[Out]# 486   11
#[Out]# 487   22
#[Out]# 488   17
#[Out]# 489   20
#[Out]# 490   11
#[Out]# 491   21
#[Out]# 492   23
#[Out]# 493   23
#[Out]# 494    8
#[Out]# 495    0
#[Out]# 496    8
#[Out]# 497   11
#[Out]# 498   15
#[Out]# 499    2
#[Out]# 500   17
#[Out]# 501    5
#[Out]# 502   19
#[Out]# 503    9
#[Out]# 504   18
#[Out]# 
#[Out]# [505 rows x 1 columns]
query1 = '''
    SELECT *
    FROM purchase
'''
"""
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID not in (
        SELECT pID
        FROM purchase
        GROUP BY pID
        HAVING count(pID) <= 2
    )
'''
"""

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    SELECT *
    FROM purchase
    SORT BY pID
'''
"""
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID not in (
        SELECT pID
        FROM purchase
        GROUP BY pID
        HAVING count(pID) <= 2
    )
'''
"""

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT *
    FROM purchase
    ORDER BY pID
'''
"""
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID not in (
        SELECT pID
        FROM purchase
        GROUP BY pID
        HAVING count(pID) <= 2
    )
'''
"""

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0     38   13   33    0  2018-08-17         5   5.35
#[Out]# 1     48   16   50    0  2018-08-24         1   3.70
#[Out]# 2     63   19   59    0  2018-08-17         1   3.90
#[Out]# 3     68   20   21    0  2018-08-18         3   5.40
#[Out]# 4     81   24   14    0  2018-08-20         3   4.80
#[Out]# 5    104   33   36    0  2018-08-27         6   3.95
#[Out]# 6    187   66   44    0  2018-08-17         8   5.40
#[Out]# 7    214   78   21    0  2018-08-17         4   5.40
#[Out]# 8    227   82   42    0  2018-08-25         3   5.00
#[Out]# 9    259   95    3    0  2018-08-24         5   4.85
#[Out]# 10   297  113    1    0  2018-08-26         5   5.30
#[Out]# 11   321  123   49    0  2018-08-25         2   4.40
#[Out]# 12   336  127    3    0  2018-08-25         9   3.75
#[Out]# 13   354  139   26    0  2018-08-19         5   4.90
#[Out]# 14   355  144   31    0  2018-08-22         6   5.10
#[Out]# 15   380  157   49    0  2018-08-27         3   4.20
#[Out]# 16   403  163   43    0  2018-08-27         3   4.65
#[Out]# 17   423  167    8    0  2018-08-21         9   4.00
#[Out]# 18   439  170   52    0  2018-08-16         7   3.95
#[Out]# 19   449  176   35    0  2018-08-25         2   4.35
#[Out]# 20   777  184    0    0  2018-08-20         2   3.50
#[Out]# 21   797  190   13    0  2018-08-26         4   2.00
#[Out]# 22   816  190   32    0  2018-08-26         4   3.85
#[Out]# 23   823  190   39    0  2018-08-25         4   3.70
#[Out]# 24   838  190   54    0  2018-08-25         6   3.50
#[Out]# 25   107   33   26    1  2018-08-17         6   5.95
#[Out]# 26   175   59   47    1  2018-08-26         5   5.85
#[Out]# 27   195   69   25    1  2018-08-28         8   6.05
#[Out]# 28   252   92   50    1  2018-08-27         5   5.35
#[Out]# 29   281  108    0    1  2018-08-15         1   6.35
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  819  190   35   27  2018-08-15         5   0.50
#[Out]# 480   23    5   36   28  2018-08-22         6   8.25
#[Out]# 481   73   22   25   28  2018-08-27         3   8.05
#[Out]# 482  111   35   34   28  2018-08-18         7   9.45
#[Out]# 483  123   39   21   28  2018-08-29         3   7.05
#[Out]# 484  124   40   52   28  2018-08-16         9   9.60
#[Out]# 485  180   60   30   28  2018-08-23         6   8.90
#[Out]# 486  197   70   54   28  2018-08-25         4   9.70
#[Out]# 487  200   71   55   28  2018-08-24         8   7.25
#[Out]# 488  224   82   52   28  2018-08-23         2   7.35
#[Out]# 489  234   86   20   28  2018-08-17         6   8.60
#[Out]# 490  271  100   40   28  2018-08-22         2   8.25
#[Out]# 491  280  108   41   28  2018-08-15         2   7.65
#[Out]# 492  307  118   38   28  2018-08-20         5   6.95
#[Out]# 493  320  123   34   28  2018-08-24         3   8.25
#[Out]# 494  325  124   14   28  2018-08-26         6   8.25
#[Out]# 495  337  127   34   28  2018-08-26         7   8.35
#[Out]# 496  350  136   37   28  2018-08-24         5   7.75
#[Out]# 497  393  161   36   28  2018-08-26         4   7.20
#[Out]# 498  397  162   18   28  2018-08-22         1   8.70
#[Out]# 499  428  169   18   28  2018-08-17         8   7.70
#[Out]# 500  438  170    9   28  2018-08-16         2   9.85
#[Out]# 501  445  175   27   28  2018-08-19         1   8.10
#[Out]# 502  787  190    3   28  2018-08-23         5   0.50
#[Out]# 503  818  190   34   28  2018-08-20         4   2.80
#[Out]# 504  821  190   37   28  2018-08-15         4   0.65
#[Out]# 505  778  185   62   29  2018-08-20         1   1.00
#[Out]# 506  779  186   62   29  2018-08-21         5   1.00
#[Out]# 507  780  188   62   30  2018-08-20         1   1.00
#[Out]# 508  781  188   62   30  2018-09-20         1   1.00
#[Out]# 
#[Out]# [509 rows x 7 columns]

query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID not in (
        SELECT pID
        FROM purchase
        GROUP BY pID
        HAVING count(pID) <= 2
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 475   28
#[Out]# 476   27
#[Out]# 477    5
#[Out]# 478   28
#[Out]# 479    7
#[Out]# 480    0
#[Out]# 481   11
#[Out]# 482    6
#[Out]# 483   19
#[Out]# 484   17
#[Out]# 485    9
#[Out]# 486   11
#[Out]# 487   22
#[Out]# 488   17
#[Out]# 489   20
#[Out]# 490   11
#[Out]# 491   21
#[Out]# 492   23
#[Out]# 493   23
#[Out]# 494    8
#[Out]# 495    0
#[Out]# 496    8
#[Out]# 497   11
#[Out]# 498   15
#[Out]# 499    2
#[Out]# 500   17
#[Out]# 501    5
#[Out]# 502   19
#[Out]# 503    9
#[Out]# 504   18
#[Out]# 
#[Out]# [505 rows x 1 columns]
query1 = '''
    SELECT *
    FROM purchase
    WHERE pID = 10
    ORDER BY pID
'''
"""
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID not in (
        SELECT pID
        FROM purchase
        GROUP BY pID
        HAVING count(pID) <= 2
    )
'''
"""

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0     0    0    3   10  2018-08-22         1   0.45
#[Out]# 1    43   13   28   10  2018-08-25         4   0.40
#[Out]# 2    74   22   27   10  2018-08-28         6   0.45
#[Out]# 3    79   24   45   10  2018-08-20         1   0.60
#[Out]# 4   204   72   54   10  2018-08-22         5   0.50
#[Out]# 5   220   82    5   10  2018-08-21         1   0.50
#[Out]# 6   272  100    9   10  2018-08-22         5   0.50
#[Out]# 7   329  124   18   10  2018-08-26         2   0.50
#[Out]# 8   406  163    6   10  2018-08-22         6   0.55
#[Out]# 9   412  165   45   10  2018-08-24         3   0.45
#[Out]# 10  436  169   24   10  2018-08-27         7   0.55
#[Out]# 11  465  179   45   10  2018-08-23         7   0.45
#[Out]# 12  468  180   56   10  2018-08-27         3   0.60
#[Out]# 13  790  190    6   10  2018-08-15         2   4.15
#[Out]# 14  801  190   17   10  2018-08-23         6   0.95
#[Out]# 15  814  190   30   10  2018-08-18         4   4.35
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID not in (
        SELECT pID
        FROM (SELECT pID, cID FROM purchase)
        GROUP BY pID
        HAVING count(pID) <= 2
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 475   28
#[Out]# 476   27
#[Out]# 477    5
#[Out]# 478   28
#[Out]# 479    7
#[Out]# 480    0
#[Out]# 481   11
#[Out]# 482    6
#[Out]# 483   19
#[Out]# 484   17
#[Out]# 485    9
#[Out]# 486   11
#[Out]# 487   22
#[Out]# 488   17
#[Out]# 489   20
#[Out]# 490   11
#[Out]# 491   21
#[Out]# 492   23
#[Out]# 493   23
#[Out]# 494    8
#[Out]# 495    0
#[Out]# 496    8
#[Out]# 497   11
#[Out]# 498   15
#[Out]# 499    2
#[Out]# 500   17
#[Out]# 501    5
#[Out]# 502   19
#[Out]# 503    9
#[Out]# 504   18
#[Out]# 
#[Out]# [505 rows x 1 columns]
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID NOT IN (
        SELECT DISTINCT pID
        FROM purchase
        GROUP BY pID
        HAVING count(DISTINCT pID) <= 2
    )
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID]
#[Out]# Index: []
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID NOT IN (
        SELECT DISTINCT pID, DISTINCT cID
        FROM purchase
        GROUP BY pID
        HAVING count(DISTINCT cID) <= 2
    )
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID NOT IN (
        SELECT DISTINCT pID, cID
        FROM purchase
        GROUP BY pID
        HAVING count(DISTINCT cID) <= 2
    )
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID NOT IN (
        SELECT DISTINCT pID
        FROM purchase
        GROUP BY pID
        HAVING count(DISTINCT cID) <= 2
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 475   28
#[Out]# 476   27
#[Out]# 477    5
#[Out]# 478   28
#[Out]# 479    7
#[Out]# 480    0
#[Out]# 481   11
#[Out]# 482    6
#[Out]# 483   19
#[Out]# 484   17
#[Out]# 485    9
#[Out]# 486   11
#[Out]# 487   22
#[Out]# 488   17
#[Out]# 489   20
#[Out]# 490   11
#[Out]# 491   21
#[Out]# 492   23
#[Out]# 493   23
#[Out]# 494    8
#[Out]# 495    0
#[Out]# 496    8
#[Out]# 497   11
#[Out]# 498   15
#[Out]# 499    2
#[Out]# 500   17
#[Out]# 501    5
#[Out]# 502   19
#[Out]# 503    9
#[Out]# 504   18
#[Out]# 
#[Out]# [505 rows x 1 columns]
query1 = '''
        SELECT DISTINCT pID
        FROM purchase
        GROUP BY pID
        HAVING count(DISTINCT cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
        SELECT DISTINCT pID
        FROM purchase
        GROUP BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
        SELECT DISTINCT pID, cID
        FROM purchase
        GROUP BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  cID
#[Out]# 0     0  190
#[Out]# 1     1  169
#[Out]# 2     2  190
#[Out]# 3     3  190
#[Out]# 4     4  190
#[Out]# 5     5  190
#[Out]# 6     6  190
#[Out]# 7     7  190
#[Out]# 8     8  190
#[Out]# 9     9  190
#[Out]# 10   10  190
#[Out]# 11   11  190
#[Out]# 12   12  162
#[Out]# 13   13  190
#[Out]# 14   14  179
#[Out]# 15   15  190
#[Out]# 16   16  179
#[Out]# 17   17  190
#[Out]# 18   18  190
#[Out]# 19   19  190
#[Out]# 20   20  190
#[Out]# 21   21  190
#[Out]# 22   22  190
#[Out]# 23   23  190
#[Out]# 24   24  178
#[Out]# 25   25  190
#[Out]# 26   26  190
#[Out]# 27   27  190
#[Out]# 28   28  190
#[Out]# 29   29  186
#[Out]# 30   30  188
query1 = '''
        SELECT *
        FROM purchase
        GROUP BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   838  190   54    0  2018-08-25         6   3.50
#[Out]# 1   430  169   43    1  2018-08-18         9   6.55
#[Out]# 2   842  190   58    2  2018-08-19         7   0.75
#[Out]# 3   807  190   23    3  2018-08-18         1   2.75
#[Out]# 4   800  190   16    4  2018-08-26         1   2.40
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35
#[Out]# 6   825  190   41    6  2018-08-15         5   2.95
#[Out]# 7   822  190   38    7  2018-08-24         4   0.70
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   846  190   62    9  2018-08-16         2   3.15
#[Out]# 10  814  190   30   10  2018-08-18         4   4.35
#[Out]# 11  840  190   56   11  2018-08-15         4   1.60
#[Out]# 12  399  162    9   12  2018-08-24         9  13.15
#[Out]# 13  811  190   27   13  2018-08-17         4   0.90
#[Out]# 14  460  179   25   14  2018-08-24         5   3.70
#[Out]# 15  841  190   57   15  2018-08-22         5   3.25
#[Out]# 16  464  179   35   16  2018-08-22         9   1.85
#[Out]# 17  843  190   59   17  2018-08-26         2   3.80
#[Out]# 18  847  190   63   18  2018-08-21         1   3.30
#[Out]# 19  845  190   61   19  2018-08-23         5   2.85
#[Out]# 20  832  190   48   20  2018-08-26         6   4.30
#[Out]# 21  834  190   50   21  2018-08-22         6   4.05
#[Out]# 22  830  190   46   22  2018-08-25         4   2.60
#[Out]# 23  836  190   52   23  2018-08-15         5   2.50
#[Out]# 24  459  178   39   24  2018-08-27         1   3.90
#[Out]# 25  806  190   22   25  2018-08-19         7   3.20
#[Out]# 26  808  190   24   26  2018-08-16         5   3.25
#[Out]# 27  819  190   35   27  2018-08-15         5   0.50
#[Out]# 28  821  190   37   28  2018-08-15         4   0.65
#[Out]# 29  779  186   62   29  2018-08-21         5   1.00
#[Out]# 30  781  188   62   30  2018-09-20         1   1.00
query1 = '''
        SELECT *
        FROM purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
        SELECT *
        FROM purchase
        GROUP BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   838  190   54    0  2018-08-25         6   3.50
#[Out]# 1   430  169   43    1  2018-08-18         9   6.55
#[Out]# 2   842  190   58    2  2018-08-19         7   0.75
#[Out]# 3   807  190   23    3  2018-08-18         1   2.75
#[Out]# 4   800  190   16    4  2018-08-26         1   2.40
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35
#[Out]# 6   825  190   41    6  2018-08-15         5   2.95
#[Out]# 7   822  190   38    7  2018-08-24         4   0.70
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   846  190   62    9  2018-08-16         2   3.15
#[Out]# 10  814  190   30   10  2018-08-18         4   4.35
#[Out]# 11  840  190   56   11  2018-08-15         4   1.60
#[Out]# 12  399  162    9   12  2018-08-24         9  13.15
#[Out]# 13  811  190   27   13  2018-08-17         4   0.90
#[Out]# 14  460  179   25   14  2018-08-24         5   3.70
#[Out]# 15  841  190   57   15  2018-08-22         5   3.25
#[Out]# 16  464  179   35   16  2018-08-22         9   1.85
#[Out]# 17  843  190   59   17  2018-08-26         2   3.80
#[Out]# 18  847  190   63   18  2018-08-21         1   3.30
#[Out]# 19  845  190   61   19  2018-08-23         5   2.85
#[Out]# 20  832  190   48   20  2018-08-26         6   4.30
#[Out]# 21  834  190   50   21  2018-08-22         6   4.05
#[Out]# 22  830  190   46   22  2018-08-25         4   2.60
#[Out]# 23  836  190   52   23  2018-08-15         5   2.50
#[Out]# 24  459  178   39   24  2018-08-27         1   3.90
#[Out]# 25  806  190   22   25  2018-08-19         7   3.20
#[Out]# 26  808  190   24   26  2018-08-16         5   3.25
#[Out]# 27  819  190   35   27  2018-08-15         5   0.50
#[Out]# 28  821  190   37   28  2018-08-15         4   0.65
#[Out]# 29  779  186   62   29  2018-08-21         5   1.00
#[Out]# 30  781  188   62   30  2018-09-20         1   1.00
query1 = '''
        SELECT *
        FROM purchase
        ORDER BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0     38   13   33    0  2018-08-17         5   5.35
#[Out]# 1     48   16   50    0  2018-08-24         1   3.70
#[Out]# 2     63   19   59    0  2018-08-17         1   3.90
#[Out]# 3     68   20   21    0  2018-08-18         3   5.40
#[Out]# 4     81   24   14    0  2018-08-20         3   4.80
#[Out]# 5    104   33   36    0  2018-08-27         6   3.95
#[Out]# 6    187   66   44    0  2018-08-17         8   5.40
#[Out]# 7    214   78   21    0  2018-08-17         4   5.40
#[Out]# 8    227   82   42    0  2018-08-25         3   5.00
#[Out]# 9    259   95    3    0  2018-08-24         5   4.85
#[Out]# 10   297  113    1    0  2018-08-26         5   5.30
#[Out]# 11   321  123   49    0  2018-08-25         2   4.40
#[Out]# 12   336  127    3    0  2018-08-25         9   3.75
#[Out]# 13   354  139   26    0  2018-08-19         5   4.90
#[Out]# 14   355  144   31    0  2018-08-22         6   5.10
#[Out]# 15   380  157   49    0  2018-08-27         3   4.20
#[Out]# 16   403  163   43    0  2018-08-27         3   4.65
#[Out]# 17   423  167    8    0  2018-08-21         9   4.00
#[Out]# 18   439  170   52    0  2018-08-16         7   3.95
#[Out]# 19   449  176   35    0  2018-08-25         2   4.35
#[Out]# 20   777  184    0    0  2018-08-20         2   3.50
#[Out]# 21   797  190   13    0  2018-08-26         4   2.00
#[Out]# 22   816  190   32    0  2018-08-26         4   3.85
#[Out]# 23   823  190   39    0  2018-08-25         4   3.70
#[Out]# 24   838  190   54    0  2018-08-25         6   3.50
#[Out]# 25   107   33   26    1  2018-08-17         6   5.95
#[Out]# 26   175   59   47    1  2018-08-26         5   5.85
#[Out]# 27   195   69   25    1  2018-08-28         8   6.05
#[Out]# 28   252   92   50    1  2018-08-27         5   5.35
#[Out]# 29   281  108    0    1  2018-08-15         1   6.35
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  819  190   35   27  2018-08-15         5   0.50
#[Out]# 480   23    5   36   28  2018-08-22         6   8.25
#[Out]# 481   73   22   25   28  2018-08-27         3   8.05
#[Out]# 482  111   35   34   28  2018-08-18         7   9.45
#[Out]# 483  123   39   21   28  2018-08-29         3   7.05
#[Out]# 484  124   40   52   28  2018-08-16         9   9.60
#[Out]# 485  180   60   30   28  2018-08-23         6   8.90
#[Out]# 486  197   70   54   28  2018-08-25         4   9.70
#[Out]# 487  200   71   55   28  2018-08-24         8   7.25
#[Out]# 488  224   82   52   28  2018-08-23         2   7.35
#[Out]# 489  234   86   20   28  2018-08-17         6   8.60
#[Out]# 490  271  100   40   28  2018-08-22         2   8.25
#[Out]# 491  280  108   41   28  2018-08-15         2   7.65
#[Out]# 492  307  118   38   28  2018-08-20         5   6.95
#[Out]# 493  320  123   34   28  2018-08-24         3   8.25
#[Out]# 494  325  124   14   28  2018-08-26         6   8.25
#[Out]# 495  337  127   34   28  2018-08-26         7   8.35
#[Out]# 496  350  136   37   28  2018-08-24         5   7.75
#[Out]# 497  393  161   36   28  2018-08-26         4   7.20
#[Out]# 498  397  162   18   28  2018-08-22         1   8.70
#[Out]# 499  428  169   18   28  2018-08-17         8   7.70
#[Out]# 500  438  170    9   28  2018-08-16         2   9.85
#[Out]# 501  445  175   27   28  2018-08-19         1   8.10
#[Out]# 502  787  190    3   28  2018-08-23         5   0.50
#[Out]# 503  818  190   34   28  2018-08-20         4   2.80
#[Out]# 504  821  190   37   28  2018-08-15         4   0.65
#[Out]# 505  778  185   62   29  2018-08-20         1   1.00
#[Out]# 506  779  186   62   29  2018-08-21         5   1.00
#[Out]# 507  780  188   62   30  2018-08-20         1   1.00
#[Out]# 508  781  188   62   30  2018-09-20         1   1.00
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
        SELECT *
        FROM purchase
        GROUP BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   838  190   54    0  2018-08-25         6   3.50
#[Out]# 1   430  169   43    1  2018-08-18         9   6.55
#[Out]# 2   842  190   58    2  2018-08-19         7   0.75
#[Out]# 3   807  190   23    3  2018-08-18         1   2.75
#[Out]# 4   800  190   16    4  2018-08-26         1   2.40
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35
#[Out]# 6   825  190   41    6  2018-08-15         5   2.95
#[Out]# 7   822  190   38    7  2018-08-24         4   0.70
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   846  190   62    9  2018-08-16         2   3.15
#[Out]# 10  814  190   30   10  2018-08-18         4   4.35
#[Out]# 11  840  190   56   11  2018-08-15         4   1.60
#[Out]# 12  399  162    9   12  2018-08-24         9  13.15
#[Out]# 13  811  190   27   13  2018-08-17         4   0.90
#[Out]# 14  460  179   25   14  2018-08-24         5   3.70
#[Out]# 15  841  190   57   15  2018-08-22         5   3.25
#[Out]# 16  464  179   35   16  2018-08-22         9   1.85
#[Out]# 17  843  190   59   17  2018-08-26         2   3.80
#[Out]# 18  847  190   63   18  2018-08-21         1   3.30
#[Out]# 19  845  190   61   19  2018-08-23         5   2.85
#[Out]# 20  832  190   48   20  2018-08-26         6   4.30
#[Out]# 21  834  190   50   21  2018-08-22         6   4.05
#[Out]# 22  830  190   46   22  2018-08-25         4   2.60
#[Out]# 23  836  190   52   23  2018-08-15         5   2.50
#[Out]# 24  459  178   39   24  2018-08-27         1   3.90
#[Out]# 25  806  190   22   25  2018-08-19         7   3.20
#[Out]# 26  808  190   24   26  2018-08-16         5   3.25
#[Out]# 27  819  190   35   27  2018-08-15         5   0.50
#[Out]# 28  821  190   37   28  2018-08-15         4   0.65
#[Out]# 29  779  186   62   29  2018-08-21         5   1.00
#[Out]# 30  781  188   62   30  2018-09-20         1   1.00
query1 = '''
        SELECT *
        FROM purchase
        ORDER BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0     38   13   33    0  2018-08-17         5   5.35
#[Out]# 1     48   16   50    0  2018-08-24         1   3.70
#[Out]# 2     63   19   59    0  2018-08-17         1   3.90
#[Out]# 3     68   20   21    0  2018-08-18         3   5.40
#[Out]# 4     81   24   14    0  2018-08-20         3   4.80
#[Out]# 5    104   33   36    0  2018-08-27         6   3.95
#[Out]# 6    187   66   44    0  2018-08-17         8   5.40
#[Out]# 7    214   78   21    0  2018-08-17         4   5.40
#[Out]# 8    227   82   42    0  2018-08-25         3   5.00
#[Out]# 9    259   95    3    0  2018-08-24         5   4.85
#[Out]# 10   297  113    1    0  2018-08-26         5   5.30
#[Out]# 11   321  123   49    0  2018-08-25         2   4.40
#[Out]# 12   336  127    3    0  2018-08-25         9   3.75
#[Out]# 13   354  139   26    0  2018-08-19         5   4.90
#[Out]# 14   355  144   31    0  2018-08-22         6   5.10
#[Out]# 15   380  157   49    0  2018-08-27         3   4.20
#[Out]# 16   403  163   43    0  2018-08-27         3   4.65
#[Out]# 17   423  167    8    0  2018-08-21         9   4.00
#[Out]# 18   439  170   52    0  2018-08-16         7   3.95
#[Out]# 19   449  176   35    0  2018-08-25         2   4.35
#[Out]# 20   777  184    0    0  2018-08-20         2   3.50
#[Out]# 21   797  190   13    0  2018-08-26         4   2.00
#[Out]# 22   816  190   32    0  2018-08-26         4   3.85
#[Out]# 23   823  190   39    0  2018-08-25         4   3.70
#[Out]# 24   838  190   54    0  2018-08-25         6   3.50
#[Out]# 25   107   33   26    1  2018-08-17         6   5.95
#[Out]# 26   175   59   47    1  2018-08-26         5   5.85
#[Out]# 27   195   69   25    1  2018-08-28         8   6.05
#[Out]# 28   252   92   50    1  2018-08-27         5   5.35
#[Out]# 29   281  108    0    1  2018-08-15         1   6.35
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  819  190   35   27  2018-08-15         5   0.50
#[Out]# 480   23    5   36   28  2018-08-22         6   8.25
#[Out]# 481   73   22   25   28  2018-08-27         3   8.05
#[Out]# 482  111   35   34   28  2018-08-18         7   9.45
#[Out]# 483  123   39   21   28  2018-08-29         3   7.05
#[Out]# 484  124   40   52   28  2018-08-16         9   9.60
#[Out]# 485  180   60   30   28  2018-08-23         6   8.90
#[Out]# 486  197   70   54   28  2018-08-25         4   9.70
#[Out]# 487  200   71   55   28  2018-08-24         8   7.25
#[Out]# 488  224   82   52   28  2018-08-23         2   7.35
#[Out]# 489  234   86   20   28  2018-08-17         6   8.60
#[Out]# 490  271  100   40   28  2018-08-22         2   8.25
#[Out]# 491  280  108   41   28  2018-08-15         2   7.65
#[Out]# 492  307  118   38   28  2018-08-20         5   6.95
#[Out]# 493  320  123   34   28  2018-08-24         3   8.25
#[Out]# 494  325  124   14   28  2018-08-26         6   8.25
#[Out]# 495  337  127   34   28  2018-08-26         7   8.35
#[Out]# 496  350  136   37   28  2018-08-24         5   7.75
#[Out]# 497  393  161   36   28  2018-08-26         4   7.20
#[Out]# 498  397  162   18   28  2018-08-22         1   8.70
#[Out]# 499  428  169   18   28  2018-08-17         8   7.70
#[Out]# 500  438  170    9   28  2018-08-16         2   9.85
#[Out]# 501  445  175   27   28  2018-08-19         1   8.10
#[Out]# 502  787  190    3   28  2018-08-23         5   0.50
#[Out]# 503  818  190   34   28  2018-08-20         4   2.80
#[Out]# 504  821  190   37   28  2018-08-15         4   0.65
#[Out]# 505  778  185   62   29  2018-08-20         1   1.00
#[Out]# 506  779  186   62   29  2018-08-21         5   1.00
#[Out]# 507  780  188   62   30  2018-08-20         1   1.00
#[Out]# 508  781  188   62   30  2018-09-20         1   1.00
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
        SELECT pID, cID
        FROM purchase
        ORDER BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID  cID
#[Out]# 0      0   13
#[Out]# 1      0   16
#[Out]# 2      0   19
#[Out]# 3      0   20
#[Out]# 4      0   24
#[Out]# 5      0   33
#[Out]# 6      0   66
#[Out]# 7      0   78
#[Out]# 8      0   82
#[Out]# 9      0   95
#[Out]# 10     0  113
#[Out]# 11     0  123
#[Out]# 12     0  127
#[Out]# 13     0  139
#[Out]# 14     0  144
#[Out]# 15     0  157
#[Out]# 16     0  163
#[Out]# 17     0  167
#[Out]# 18     0  170
#[Out]# 19     0  176
#[Out]# 20     0  184
#[Out]# 21     0  190
#[Out]# 22     0  190
#[Out]# 23     0  190
#[Out]# 24     0  190
#[Out]# 25     1   33
#[Out]# 26     1   59
#[Out]# 27     1   69
#[Out]# 28     1   92
#[Out]# 29     1  108
#[Out]# ..   ...  ...
#[Out]# 479   27  190
#[Out]# 480   28    5
#[Out]# 481   28   22
#[Out]# 482   28   35
#[Out]# 483   28   39
#[Out]# 484   28   40
#[Out]# 485   28   60
#[Out]# 486   28   70
#[Out]# 487   28   71
#[Out]# 488   28   82
#[Out]# 489   28   86
#[Out]# 490   28  100
#[Out]# 491   28  108
#[Out]# 492   28  118
#[Out]# 493   28  123
#[Out]# 494   28  124
#[Out]# 495   28  127
#[Out]# 496   28  136
#[Out]# 497   28  161
#[Out]# 498   28  162
#[Out]# 499   28  169
#[Out]# 500   28  170
#[Out]# 501   28  175
#[Out]# 502   28  190
#[Out]# 503   28  190
#[Out]# 504   28  190
#[Out]# 505   29  185
#[Out]# 506   29  186
#[Out]# 507   30  188
#[Out]# 508   30  188
#[Out]# 
#[Out]# [509 rows x 2 columns]
query1 = '''
        SELECT pID, cID
        FROM purchase
        GROUP BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  cID
#[Out]# 0     0  190
#[Out]# 1     1  169
#[Out]# 2     2  190
#[Out]# 3     3  190
#[Out]# 4     4  190
#[Out]# 5     5  190
#[Out]# 6     6  190
#[Out]# 7     7  190
#[Out]# 8     8  190
#[Out]# 9     9  190
#[Out]# 10   10  190
#[Out]# 11   11  190
#[Out]# 12   12  162
#[Out]# 13   13  190
#[Out]# 14   14  179
#[Out]# 15   15  190
#[Out]# 16   16  179
#[Out]# 17   17  190
#[Out]# 18   18  190
#[Out]# 19   19  190
#[Out]# 20   20  190
#[Out]# 21   21  190
#[Out]# 22   22  190
#[Out]# 23   23  190
#[Out]# 24   24  178
#[Out]# 25   25  190
#[Out]# 26   26  190
#[Out]# 27   27  190
#[Out]# 28   28  190
#[Out]# 29   29  186
#[Out]# 30   30  188
query1 = '''
        SELECT pID, count(cID)
        FROM purchase
        GROUP BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  count(cID)
#[Out]# 0     0          25
#[Out]# 1     1          13
#[Out]# 2     2          10
#[Out]# 3     3          20
#[Out]# 4     4          16
#[Out]# 5     5          16
#[Out]# 6     6          15
#[Out]# 7     7          14
#[Out]# 8     8          13
#[Out]# 9     9          20
#[Out]# 10   10          16
#[Out]# 11   11          16
#[Out]# 12   12          16
#[Out]# 13   13          21
#[Out]# 14   14          18
#[Out]# 15   15          14
#[Out]# 16   16          20
#[Out]# 17   17          18
#[Out]# 18   18          10
#[Out]# 19   19          26
#[Out]# 20   20          18
#[Out]# 21   21          22
#[Out]# 22   22          21
#[Out]# 23   23          13
#[Out]# 24   24          20
#[Out]# 25   25          14
#[Out]# 26   26          20
#[Out]# 27   27          15
#[Out]# 28   28          25
#[Out]# 29   29           2
#[Out]# 30   30           2
query1 = '''
        SELECT pID
        FROM purchase
        GROUP BY pID
        HAVING count(cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT pID
    FROM purchase
    WHERE pID NOT IN (
        SELECT pID
        FROM purchase
        GROUP BY pID
        HAVING count(cID) <= 2
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 475   28
#[Out]# 476   27
#[Out]# 477    5
#[Out]# 478   28
#[Out]# 479    7
#[Out]# 480    0
#[Out]# 481   11
#[Out]# 482    6
#[Out]# 483   19
#[Out]# 484   17
#[Out]# 485    9
#[Out]# 486   11
#[Out]# 487   22
#[Out]# 488   17
#[Out]# 489   20
#[Out]# 490   11
#[Out]# 491   21
#[Out]# 492   23
#[Out]# 493   23
#[Out]# 494    8
#[Out]# 495    0
#[Out]# 496    8
#[Out]# 497   11
#[Out]# 498   15
#[Out]# 499    2
#[Out]# 500   17
#[Out]# 501    5
#[Out]# 502   19
#[Out]# 503    9
#[Out]# 504   18
#[Out]# 
#[Out]# [505 rows x 1 columns]
query1 = '''
    SELECT pID
    FROM purchase
    GROUP BY pID
    HAVING count(cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30

