# IPython log file

query2 = '''
    SELECT c.cID AND c.cName
    FROM (customer c AND product pr1 AND purchase pu1 AND 
    product pr2 AND purchase pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND
    pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID 
    AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.

# db_location = 'shoppingDB.sql'

# f = open(db_location,'r')
# sql = f.read()
# cur.executescript(sql)
query1 = '''
    SELECT p.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE (p1.cID = p2.cID OR p1.cID = p3.cID OR p2.cID = p3.cID AND p1.pID = p2.pID AND p2.pID = p3.pID and p1.pID = p3.pID)
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE (p1.cID = p2.cID OR p1.cID = p3.cID OR p2.cID = p3.cID AND p1.pID = p2.pID AND p2.pID = p3.pID and p1.pID = p3.pID)
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#          pID
#[Out]# 0         10
#[Out]# 1         10
#[Out]# 2         10
#[Out]# 3         10
#[Out]# 4         10
#[Out]# 5         10
#[Out]# 6         10
#[Out]# 7         10
#[Out]# 8         10
#[Out]# 9         10
#[Out]# 10        10
#[Out]# 11        10
#[Out]# 12        10
#[Out]# 13        10
#[Out]# 14        10
#[Out]# 15        10
#[Out]# 16        10
#[Out]# 17        10
#[Out]# 18        10
#[Out]# 19        10
#[Out]# 20        10
#[Out]# 21        10
#[Out]# 22        10
#[Out]# 23        10
#[Out]# 24        10
#[Out]# 25        10
#[Out]# 26        10
#[Out]# 27        10
#[Out]# 28        10
#[Out]# 29        10
#[Out]# ...      ...
#[Out]# 6305417   18
#[Out]# 6305418   18
#[Out]# 6305419   18
#[Out]# 6305420   18
#[Out]# 6305421   18
#[Out]# 6305422   18
#[Out]# 6305423   18
#[Out]# 6305424   18
#[Out]# 6305425   18
#[Out]# 6305426   18
#[Out]# 6305427   18
#[Out]# 6305428   18
#[Out]# 6305429   18
#[Out]# 6305430   18
#[Out]# 6305431   18
#[Out]# 6305432   18
#[Out]# 6305433   18
#[Out]# 6305434   18
#[Out]# 6305435   18
#[Out]# 6305436   18
#[Out]# 6305437   18
#[Out]# 6305438   18
#[Out]# 6305439   18
#[Out]# 6305440   18
#[Out]# 6305441   18
#[Out]# 6305442   18
#[Out]# 6305443   18
#[Out]# 6305444   18
#[Out]# 6305445   18
#[Out]# 6305446   18
#[Out]# 
#[Out]# [6305447 rows x 1 columns]
query2 = '''
    SELECT c.cID AND c.cName
    FROM (customer AS c AND product AS pr1 AND purchase AS pu1 AND 
    product AS pr2 AND purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND
    pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID 
    AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
query1 = '''
    SELECT UNIQUE p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE (p1.cID = p2.cID OR p1.cID = p3.cID OR p2.cID = p3.cID AND p1.pID = p2.pID AND p2.pID = p3.pID and p1.pID = p3.pID)
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
query1 = '''
    SELECT DISTINCT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE (p1.cID = p2.cID OR p1.cID = p3.cID OR p2.cID = p3.cID AND p1.pID = p2.pID AND p2.pID = p3.pID and p1.pID = p3.pID)
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0    10
#[Out]# 1    14
#[Out]# 2    16
#[Out]# 3     9
#[Out]# 4    25
#[Out]# 5    26
#[Out]# 6    11
#[Out]# 7    27
#[Out]# 8    20
#[Out]# 9     4
#[Out]# 10   13
#[Out]# 11   22
#[Out]# 12    8
#[Out]# 13   12
#[Out]# 14    6
#[Out]# 15   28
#[Out]# 16   19
#[Out]# 17    2
#[Out]# 18   24
#[Out]# 19    0
#[Out]# 20   23
#[Out]# 21   17
#[Out]# 22    3
#[Out]# 23    5
#[Out]# 24   21
#[Out]# 25    7
#[Out]# 26   15
#[Out]# 27   18
#[Out]# 28    1
#[Out]# 29   29
#[Out]# 30   30
query2 = '''
    SELECT DISTINCT c.cID AND c.cName
    FROM (customer AS c AND product AS pr1 AND purchase AS pu1 AND 
    product AS pr2 AND purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND
    pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID 
    AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
query1 = '''
    SELECT DISTINCT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.pID not in (p1.pID = p2.pID AND p2.pID = p3.pID AND p1.pID = p3.pID 
    AND p1.cID != p2.cID AND p2.cID != p3.cID AND p1.cID != p3.cID )
    
'''
# (p1.cID = p2.cID OR p1.cID = p3.cID OR p2.cID = p3.cID AND p1.pID = p2.pID AND p2.pID = p3.pID and p1.pID = p3.pID)
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0    10
#[Out]# 1    14
#[Out]# 2    16
#[Out]# 3     9
#[Out]# 4    25
#[Out]# 5    26
#[Out]# 6    11
#[Out]# 7    27
#[Out]# 8    20
#[Out]# 9     4
#[Out]# 10   13
#[Out]# 11   22
#[Out]# 12    8
#[Out]# 13   12
#[Out]# 14    6
#[Out]# 15   28
#[Out]# 16   19
#[Out]# 17    2
#[Out]# 18   24
#[Out]# 19    0
#[Out]# 20   23
#[Out]# 21   17
#[Out]# 22    3
#[Out]# 23    5
#[Out]# 24   21
#[Out]# 25    7
#[Out]# 26   15
#[Out]# 27   18
#[Out]# 28    1
#[Out]# 29   29
#[Out]# 30   30
query2 = '''
    SELECT DISTINCT c.cID AND c.cName
    FROM (customer AS c AND product AS pr1 AND purchase AS pu1 AND 
    product AS pr2 AND purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND
    pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID 
    AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT DISTINCT c.cID AND c.cName
    FROM (customer AS c AND product AS pr1 AND purchase AS pu1 AND product AS pr2 AND purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT DISTINCT c.cID, c.cName
    FROM (customer AS c AND product AS pr1 AND purchase AS pu1 AND product AS pr2 AND purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT DISTINCT c.cID, c.cName
    FROM (customer AS c, product AS pr1, purchase AS pu1, product AS pr2, purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = '2018-08-23' AND i2.date = '2018-08-23' AND i1.pID = i2.pID AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
queryTEST = '''SELECT product'''
pd.read_sql_query(queryTEST, conn)
queryTEST = '''SELECT product.pID'''
pd.read_sql_query(queryTEST, conn)
queryTEST = '''SELECT p.pID
FROM product AS p'''
pd.read_sql_query(queryTEST, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
#[Out]# 31   31
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE (SELECT MAX(i.unit_price))
'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE (SELECT MAX(i.unit_price) FROM inventory AS i)
'''
pd.read_sql_query(query5, conn)
#[Out]#                    pName  sName
#[Out]# 0            Cashew Nuts   Coop
#[Out]# 1            Cashew Nuts   Coop
#[Out]# 2            Cashew Nuts   Coop
#[Out]# 3            Cashew Nuts   Coop
#[Out]# 4            Cashew Nuts   Coop
#[Out]# 5            Cashew Nuts   Coop
#[Out]# 6            Cashew Nuts   Coop
#[Out]# 7            Cashew Nuts   Coop
#[Out]# 8            Cashew Nuts   Coop
#[Out]# 9            Cashew Nuts   Coop
#[Out]# 10           Cashew Nuts   Coop
#[Out]# 11           Cashew Nuts   Coop
#[Out]# 12           Cashew Nuts   Coop
#[Out]# 13           Cashew Nuts   Coop
#[Out]# 14           Cashew Nuts   Coop
#[Out]# 15           Cashew Nuts   Coop
#[Out]# 16           Cashew Nuts   Coop
#[Out]# 17           Cashew Nuts   Coop
#[Out]# 18           Cashew Nuts   Coop
#[Out]# 19           Cashew Nuts   Coop
#[Out]# 20           Cashew Nuts   Coop
#[Out]# 21           Cashew Nuts   Coop
#[Out]# 22           Cashew Nuts   Coop
#[Out]# 23           Cashew Nuts   Coop
#[Out]# 24           Cashew Nuts   Coop
#[Out]# 25           Cashew Nuts   Coop
#[Out]# 26           Cashew Nuts   Coop
#[Out]# 27           Cashew Nuts   Coop
#[Out]# 28           Cashew Nuts   Coop
#[Out]# 29           Cashew Nuts   Coop
#[Out]# ...                  ...    ...
#[Out]# 1697762  French baguette  Jumbo
#[Out]# 1697763  French baguette  Jumbo
#[Out]# 1697764  French baguette  Jumbo
#[Out]# 1697765  French baguette  Jumbo
#[Out]# 1697766  French baguette  Jumbo
#[Out]# 1697767  French baguette  Jumbo
#[Out]# 1697768  French baguette  Jumbo
#[Out]# 1697769  French baguette  Jumbo
#[Out]# 1697770  French baguette  Jumbo
#[Out]# 1697771  French baguette  Jumbo
#[Out]# 1697772  French baguette  Jumbo
#[Out]# 1697773  French baguette  Jumbo
#[Out]# 1697774  French baguette  Jumbo
#[Out]# 1697775  French baguette  Jumbo
#[Out]# 1697776  French baguette  Jumbo
#[Out]# 1697777  French baguette  Jumbo
#[Out]# 1697778  French baguette  Jumbo
#[Out]# 1697779  French baguette  Jumbo
#[Out]# 1697780  French baguette  Jumbo
#[Out]# 1697781  French baguette  Jumbo
#[Out]# 1697782  French baguette  Jumbo
#[Out]# 1697783  French baguette  Jumbo
#[Out]# 1697784  French baguette  Jumbo
#[Out]# 1697785  French baguette  Jumbo
#[Out]# 1697786  French baguette  Jumbo
#[Out]# 1697787  French baguette  Jumbo
#[Out]# 1697788  French baguette  Jumbo
#[Out]# 1697789  French baguette  Jumbo
#[Out]# 1697790  French baguette  Jumbo
#[Out]# 1697791  French baguette  Jumbo
#[Out]# 
#[Out]# [1697792 rows x 2 columns]
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    HAVING MAX(i.unit_price)
    WHERE i.sID = s.sID AND i.pID = p.pID 
'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID 
    HAVING MAX(i.unit_price)

'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID 
    GROUP BY i.pID
    HAVING MAX(i.unit_price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts    Hoogvliet
#[Out]# 2           Potatoes  Albert Hein
#[Out]# 3       Green Pepper    Hoogvliet
#[Out]# 4             Onions         Coop
#[Out]# 5          Mushrooms  Albert Hein
#[Out]# 6            Carrots         Coop
#[Out]# 7           Tomatoes    Hoogvliet
#[Out]# 8   Hot Dog Sausages         Dirk
#[Out]# 9            Bananas         Lidl
#[Out]# 10             Water         Coop
#[Out]# 11              Milk  Albert Hein
#[Out]# 12              Beef  Albert Hein
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples  Albert Hein
#[Out]# 15         Cucumbers         Dirk
#[Out]# 16              Rice    Hoogvliet
#[Out]# 17             Bread  Albert Hein
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca       Sligro
#[Out]# 20             Fanta       Sligro
#[Out]# 21            Coffee         Coop
#[Out]# 22               Tea        Jumbo
#[Out]# 23   Spiced Biscuits  Albert Hein
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza         Dirk
#[Out]# 28           Lasanga  Albert Hein
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    UNION
    SELECT p.pID
    FROM purchase AS p
    WHERE p.pID NOT IN (SELECT p.pID FROM purchase AS p)
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    UNION
    SELECT p.pID
    FROM purchase AS p
    WHERE p.pID NOT IN (SELECT p.pID FROM purchase AS p)
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    UNION
    SELECT p.pID
    FROM purchase AS p
    WHERE p.pID NOT IN (SELECT p.pID FROM purchase AS p)
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    UNION
    SELECT pr.pID
    FROM product AS pr
    WHERE pr.pID NOT IN (SELECT p.pID FROM purchase AS p)
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID AND (
    SELECT i.unit_price
    FROM inventory AS i
    GROUP BY i.pID
    HAVING MAX(i.unit_price))

'''
pd.read_sql_query(query5, conn)
#[Out]#                 pName      sName
#[Out]# 0         Cashew Nuts       Coop
#[Out]# 1          Mixed Nuts       Coop
#[Out]# 2            Potatoes       Coop
#[Out]# 3            Potatoes       Coop
#[Out]# 4            Potatoes       Coop
#[Out]# 5        Green Pepper       Coop
#[Out]# 6              Onions       Coop
#[Out]# 7            Tomatoes       Coop
#[Out]# 8             Bananas       Coop
#[Out]# 9                Beef       Coop
#[Out]# 10               Eggs       Coop
#[Out]# 11             Apples       Coop
#[Out]# 12             Apples       Coop
#[Out]# 13          Cucumbers       Coop
#[Out]# 14               Rice       Coop
#[Out]# 15               Rice       Coop
#[Out]# 16               Rice       Coop
#[Out]# 17              Fanta       Coop
#[Out]# 18             Coffee       Coop
#[Out]# 19    Spiced Biscuits       Coop
#[Out]# 20              Pizza       Coop
#[Out]# 21        Cashew Nuts  Hoogvliet
#[Out]# 22           Potatoes  Hoogvliet
#[Out]# 23       Green Pepper  Hoogvliet
#[Out]# 24             Onions  Hoogvliet
#[Out]# 25          Mushrooms  Hoogvliet
#[Out]# 26          Mushrooms  Hoogvliet
#[Out]# 27           Tomatoes  Hoogvliet
#[Out]# 28              Water  Hoogvliet
#[Out]# 29               Milk  Hoogvliet
#[Out]# ..                ...        ...
#[Out]# 799  Hot Dog Sausages       Dirk
#[Out]# 800              Beef       Dirk
#[Out]# 801              Beef       Dirk
#[Out]# 802              Eggs       Dirk
#[Out]# 803         Cucumbers       Dirk
#[Out]# 804             Bread       Dirk
#[Out]# 805             Bread       Dirk
#[Out]# 806              Coca       Dirk
#[Out]# 807              Coca       Dirk
#[Out]# 808             Pasta       Dirk
#[Out]# 809              Milk       Dirk
#[Out]# 810              Milk       Dirk
#[Out]# 811              Beef       Dirk
#[Out]# 812              Rice       Dirk
#[Out]# 813               Tea       Dirk
#[Out]# 814             Pizza       Dirk
#[Out]# 815       Cashew Nuts      Jumbo
#[Out]# 816        Mixed Nuts      Jumbo
#[Out]# 817          Potatoes      Jumbo
#[Out]# 818            Onions      Jumbo
#[Out]# 819  Hot Dog Sausages      Jumbo
#[Out]# 820              Eggs      Jumbo
#[Out]# 821            Apples      Jumbo
#[Out]# 822             Bread      Jumbo
#[Out]# 823            Coffee      Jumbo
#[Out]# 824               Tea      Jumbo
#[Out]# 825             Pasta      Jumbo
#[Out]# 826             Pizza      Jumbo
#[Out]# 827           Lasanga      Jumbo
#[Out]# 828              Coca       Lidl
#[Out]# 
#[Out]# [829 rows x 2 columns]
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID 
    GROUP BY i.pID
    HAVING MAX(i.unit_price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts    Hoogvliet
#[Out]# 2           Potatoes  Albert Hein
#[Out]# 3       Green Pepper    Hoogvliet
#[Out]# 4             Onions         Coop
#[Out]# 5          Mushrooms  Albert Hein
#[Out]# 6            Carrots         Coop
#[Out]# 7           Tomatoes    Hoogvliet
#[Out]# 8   Hot Dog Sausages         Dirk
#[Out]# 9            Bananas         Lidl
#[Out]# 10             Water         Coop
#[Out]# 11              Milk  Albert Hein
#[Out]# 12              Beef  Albert Hein
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples  Albert Hein
#[Out]# 15         Cucumbers         Dirk
#[Out]# 16              Rice    Hoogvliet
#[Out]# 17             Bread  Albert Hein
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca       Sligro
#[Out]# 20             Fanta       Sligro
#[Out]# 21            Coffee         Coop
#[Out]# 22               Tea        Jumbo
#[Out]# 23   Spiced Biscuits  Albert Hein
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza         Dirk
#[Out]# 28           Lasanga  Albert Hein
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID 
    GROUP BY i.pID
    HAVING MAX(i.unit_price)

'''
test = '''MAX(i.unit_price)
'''
pd.read_sql_query(test, conn)
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY i.pID
#     HAVING MAX(i.unit_price)

# '''
test = '''MAX(i.unit_price)
'''
pd.read_sql_query(test, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID 
    GROUP BY i.pID
    HAVING MAX(i.unit_price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts    Hoogvliet
#[Out]# 2           Potatoes  Albert Hein
#[Out]# 3       Green Pepper    Hoogvliet
#[Out]# 4             Onions         Coop
#[Out]# 5          Mushrooms  Albert Hein
#[Out]# 6            Carrots         Coop
#[Out]# 7           Tomatoes    Hoogvliet
#[Out]# 8   Hot Dog Sausages         Dirk
#[Out]# 9            Bananas         Lidl
#[Out]# 10             Water         Coop
#[Out]# 11              Milk  Albert Hein
#[Out]# 12              Beef  Albert Hein
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples  Albert Hein
#[Out]# 15         Cucumbers         Dirk
#[Out]# 16              Rice    Hoogvliet
#[Out]# 17             Bread  Albert Hein
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca       Sligro
#[Out]# 20             Fanta       Sligro
#[Out]# 21            Coffee         Coop
#[Out]# 22               Tea        Jumbo
#[Out]# 23   Spiced Biscuits  Albert Hein
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza         Dirk
#[Out]# 28           Lasanga  Albert Hein
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY i.pID
#     HAVING MAX(i.unit_price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY pu.pID
    HAVING MAX(pu.unit_price)

'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY i.pID
#     HAVING MAX(i.unit_price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY pu.pID
    HAVING MAX(pu.price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts         Coop
#[Out]# 2           Potatoes         Coop
#[Out]# 3       Green Pepper         Dirk
#[Out]# 4             Onions         Lidl
#[Out]# 5          Mushrooms         Lidl
#[Out]# 6            Carrots  Albert Hein
#[Out]# 7           Tomatoes        Jumbo
#[Out]# 8   Hot Dog Sausages  Albert Hein
#[Out]# 9            Bananas        Jumbo
#[Out]# 10             Water         Dirk
#[Out]# 11              Milk         Coop
#[Out]# 12              Beef       Sligro
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples    Hoogvliet
#[Out]# 15         Cucumbers         Coop
#[Out]# 16              Rice        Jumbo
#[Out]# 17             Bread        Jumbo
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca         Dirk
#[Out]# 20             Fanta    Hoogvliet
#[Out]# 21            Coffee  Albert Hein
#[Out]# 22               Tea       Sligro
#[Out]# 23   Spiced Biscuits         Coop
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza    Hoogvliet
#[Out]# 28           Lasanga  Albert Hein
#[Out]# 29            Salmon        Jumbo
#[Out]# 30           Ketchup        Jumbo
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY i.pID
#     HAVING MAX(i.unit_price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY pu.tID
    HAVING MAX(pu.price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 474           Lasanga         Coop
#[Out]# 475             Pizza         Lidl
#[Out]# 476         Mushrooms         Lidl
#[Out]# 477           Lasanga        Jumbo
#[Out]# 478          Tomatoes    Hoogvliet
#[Out]# 479       Cashew Nuts       Sligro
#[Out]# 480              Milk    Hoogvliet
#[Out]# 481           Carrots  Albert Hein
#[Out]# 482              Coca       Sligro
#[Out]# 483             Bread         Coop
#[Out]# 484           Bananas  Albert Hein
#[Out]# 485              Milk         Coop
#[Out]# 486               Tea         Lidl
#[Out]# 487             Bread         Coop
#[Out]# 488             Fanta    Hoogvliet
#[Out]# 489              Milk    Hoogvliet
#[Out]# 490            Coffee       Sligro
#[Out]# 491   Spiced Biscuits         Coop
#[Out]# 492   Spiced Biscuits         Lidl
#[Out]# 493  Hot Dog Sausages         Coop
#[Out]# 494       Cashew Nuts         Dirk
#[Out]# 495  Hot Dog Sausages         Coop
#[Out]# 496              Milk        Jumbo
#[Out]# 497         Cucumbers         Dirk
#[Out]# 498          Potatoes         Dirk
#[Out]# 499             Bread        Jumbo
#[Out]# 500         Mushrooms         Lidl
#[Out]# 501              Coca         Lidl
#[Out]# 502           Bananas        Jumbo
#[Out]# 503            Cheese        Jumbo
#[Out]# 
#[Out]# [504 rows x 2 columns]
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY MAX(i.unit_price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY pu.ID
    HAVING MAX(pu.price)

'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY i.pID
#     HAVING MAX(i.unit_price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY pu.tID
    HAVING MAX(pu.price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 474           Lasanga         Coop
#[Out]# 475             Pizza         Lidl
#[Out]# 476         Mushrooms         Lidl
#[Out]# 477           Lasanga        Jumbo
#[Out]# 478          Tomatoes    Hoogvliet
#[Out]# 479       Cashew Nuts       Sligro
#[Out]# 480              Milk    Hoogvliet
#[Out]# 481           Carrots  Albert Hein
#[Out]# 482              Coca       Sligro
#[Out]# 483             Bread         Coop
#[Out]# 484           Bananas  Albert Hein
#[Out]# 485              Milk         Coop
#[Out]# 486               Tea         Lidl
#[Out]# 487             Bread         Coop
#[Out]# 488             Fanta    Hoogvliet
#[Out]# 489              Milk    Hoogvliet
#[Out]# 490            Coffee       Sligro
#[Out]# 491   Spiced Biscuits         Coop
#[Out]# 492   Spiced Biscuits         Lidl
#[Out]# 493  Hot Dog Sausages         Coop
#[Out]# 494       Cashew Nuts         Dirk
#[Out]# 495  Hot Dog Sausages         Coop
#[Out]# 496              Milk        Jumbo
#[Out]# 497         Cucumbers         Dirk
#[Out]# 498          Potatoes         Dirk
#[Out]# 499             Bread        Jumbo
#[Out]# 500         Mushrooms         Lidl
#[Out]# 501              Coca         Lidl
#[Out]# 502           Bananas        Jumbo
#[Out]# 503            Cheese        Jumbo
#[Out]# 
#[Out]# [504 rows x 2 columns]
# query3 = '''
#     SELECT c.cID 
#     FROM (customer AS c AND purchase AS p)
#     WHERE (c.cID = p.cID AND p.sID )
# '''

query3 = '''
    SELECT p.cID
    FROM purchase AS p
    GROUP BY p.sID
    
'''
pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0   190
#[Out]# 1   190
#[Out]# 2   190
#[Out]# 3   190
#[Out]# 4   190
#[Out]# 5   190
#[Out]# 6   190
#[Out]# 7   190
#[Out]# 8   190
#[Out]# 9   190
#[Out]# 10  190
#[Out]# 11  190
#[Out]# 12  190
#[Out]# 13  190
#[Out]# 14  190
#[Out]# 15  190
#[Out]# 16  190
#[Out]# 17  190
#[Out]# 18  190
#[Out]# 19  190
#[Out]# 20  190
#[Out]# 21  190
#[Out]# 22  190
#[Out]# 23  190
#[Out]# 24  190
#[Out]# 25  190
#[Out]# 26  190
#[Out]# 27  190
#[Out]# 28  190
#[Out]# 29  190
#[Out]# ..  ...
#[Out]# 34  190
#[Out]# 35  190
#[Out]# 36  190
#[Out]# 37  190
#[Out]# 38  190
#[Out]# 39  190
#[Out]# 40  190
#[Out]# 41  190
#[Out]# 42  190
#[Out]# 43  190
#[Out]# 44  190
#[Out]# 45  190
#[Out]# 46  190
#[Out]# 47  190
#[Out]# 48  190
#[Out]# 49  190
#[Out]# 50  190
#[Out]# 51  190
#[Out]# 52  190
#[Out]# 53  190
#[Out]# 54  190
#[Out]# 55  190
#[Out]# 56  190
#[Out]# 57  190
#[Out]# 58  190
#[Out]# 59  190
#[Out]# 60  190
#[Out]# 61  190
#[Out]# 62  190
#[Out]# 63  190
#[Out]# 
#[Out]# [64 rows x 1 columns]
# query3 = '''
#     SELECT c.cID 
#     FROM (customer AS c AND purchase AS p)
#     WHERE (c.cID = p.cID AND p.sID )
# '''

query3 = '''
    SELECT DISTINCT p.cID
    FROM purchase AS p
    GROUP BY p.cID
    HAVING COUNT(p.sID)
    
'''
pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
# query3 = '''
#     SELECT c.cID 
#     FROM (customer AS c AND purchase AS p)
#     WHERE (c.cID = p.cID AND p.sID )
# '''

query3 = '''
    SELECT DISTINCT p.cID
    FROM purchase AS p
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID)
    
'''
pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, product AS pr, store s
    WHERE pu.pID = pr.pID AND pr.pName = 'Fanta' AND s.sID = pu.sID
    GROUP BY s.sName
    HAVING COUNT(DISTINCT s.sID) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#        sName
#[Out]# 0  Hoogvliet
#[Out]# 1     Sligro
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, product AS pr, store s
    WHERE pu.pID = pr.pID AND s.sID = pu.sID
    GROUP BY s.sName
    HAVING COUNT(DISTINCT s.sID) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, product AS pr, store s
    WHERE pu.pID = pr.pID AND s.sID = pu.sID
    GROUP BY s.sName
    HAVING COUNT(AVERAGE(pu.quantity)) >= 4

'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, product AS pr, store s
    WHERE pu.pID = pr.pID AND s.sID = pu.sID
    GROUP BY s.sName
    HAVING COUNT(AVG(pu.quantity)) >= 4

'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, product AS pr, store s
    WHERE pu.pID = pr.pID AND s.sID = pu.sID
    GROUP BY s.sName
    HAVING AVG(pu.quantity) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, store s
    WHERE s.sID = pu.sID
    GROUP BY s.sName
    HAVING AVG(pu.quantity) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT s.sName
    FROM purchase AS p, store s
    WHERE s.sID = p.sID
    GROUP BY s.sName
    HAVING AVG(p.quantity) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY MAX(pu.price)

'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND pu.price = MAX(pu.price)
'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND 
        (SELECT MAX(pu.price))
'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND 
        (SELECT pu.price = MAX(pu.price))
'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND pu.price = HighestProduct
        (SELECT MAX(pu.price) as HighestProduct)
'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr, MAX(pu.price) as HighestProduct
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND pu.price = HighestProduct

'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr, 
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND pu.price = HighestProduct
        (SELECT MAX(pu.price)
         FROM purchase AS pu
         )

'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr, 
    WHERE pu.sID = s.sID AND pu.pID = pr.pID COUNT(MAX(pu.prize))


'''
pd.read_sql_query(query5, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c
    GROUP BY p.cID
    HAVING 
    WHERE (SELECT COUNT(DISTINCT p.sID))
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c
    GROUP BY p.cID
    WHERE (SELECT COUNT(DISTINCT p.sID))
    
'''
pd.read_sql_query(query3, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr, 
    WHERE pu.price IN (SELECT MAX(pu.price) FROM purchase)


'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr, 
    WHERE price IN (SELECT MAX(price) FROM purchase)


'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase, store AS s, product AS pr, 
    WHERE purchase.price IN (SELECT MAX(purchase.price) FROM purchase)


'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase, store AS s, product AS pr, 
    WHERE purchase.price IN (SELECT MAX(purchase.price) FROM purchase)

'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS price, store AS s, product AS pr, 
    WHERE purchaseprice IN (SELECT MAX(price) FROM purchase)

'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS price, store AS s, product AS pr, 
    WHERE purchase price IN (SELECT MAX(price) FROM purchase)

'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS price, store AS s, product AS pr, 
    WHERE price IN 
    (SELECT MAX(price) 
    FROM purchase)

'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS price, store AS s, product AS pr, 
    WHERE price IN 
    (SELECT MAX(price) 
    FROM purchase)
'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS p, store AS s, product AS pr, 
    WHERE price IN(SELECT MAX(price) FROM purchase);
'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS p, store AS s, product AS pr 
    WHERE price IN(SELECT MAX(price) FROM purchase)
'''
pd.read_sql_query(query5, conn)
#[Out]#                  pName  sName
#[Out]# 0          Cashew Nuts   Coop
#[Out]# 1           Mixed Nuts   Coop
#[Out]# 2             Potatoes   Coop
#[Out]# 3         Green Pepper   Coop
#[Out]# 4               Onions   Coop
#[Out]# 5            Mushrooms   Coop
#[Out]# 6              Carrots   Coop
#[Out]# 7             Tomatoes   Coop
#[Out]# 8     Hot Dog Sausages   Coop
#[Out]# 9              Bananas   Coop
#[Out]# 10               Water   Coop
#[Out]# 11                Milk   Coop
#[Out]# 12                Beef   Coop
#[Out]# 13                Eggs   Coop
#[Out]# 14              Apples   Coop
#[Out]# 15           Cucumbers   Coop
#[Out]# 16                Rice   Coop
#[Out]# 17               Bread   Coop
#[Out]# 18              Cheese   Coop
#[Out]# 19                Coca   Coop
#[Out]# 20               Fanta   Coop
#[Out]# 21              Coffee   Coop
#[Out]# 22                 Tea   Coop
#[Out]# 23     Spiced Biscuits   Coop
#[Out]# 24             Oranges   Coop
#[Out]# 25              Donuts   Coop
#[Out]# 26               Pasta   Coop
#[Out]# 27               Pizza   Coop
#[Out]# 28             Lasanga   Coop
#[Out]# 29              Salmon   Coop
#[Out]# ...                ...    ...
#[Out]# 2018          Potatoes  Jumbo
#[Out]# 2019      Green Pepper  Jumbo
#[Out]# 2020            Onions  Jumbo
#[Out]# 2021         Mushrooms  Jumbo
#[Out]# 2022           Carrots  Jumbo
#[Out]# 2023          Tomatoes  Jumbo
#[Out]# 2024  Hot Dog Sausages  Jumbo
#[Out]# 2025           Bananas  Jumbo
#[Out]# 2026             Water  Jumbo
#[Out]# 2027              Milk  Jumbo
#[Out]# 2028              Beef  Jumbo
#[Out]# 2029              Eggs  Jumbo
#[Out]# 2030            Apples  Jumbo
#[Out]# 2031         Cucumbers  Jumbo
#[Out]# 2032              Rice  Jumbo
#[Out]# 2033             Bread  Jumbo
#[Out]# 2034            Cheese  Jumbo
#[Out]# 2035              Coca  Jumbo
#[Out]# 2036             Fanta  Jumbo
#[Out]# 2037            Coffee  Jumbo
#[Out]# 2038               Tea  Jumbo
#[Out]# 2039   Spiced Biscuits  Jumbo
#[Out]# 2040           Oranges  Jumbo
#[Out]# 2041            Donuts  Jumbo
#[Out]# 2042             Pasta  Jumbo
#[Out]# 2043             Pizza  Jumbo
#[Out]# 2044           Lasanga  Jumbo
#[Out]# 2045            Salmon  Jumbo
#[Out]# 2046           Ketchup  Jumbo
#[Out]# 2047   French baguette  Jumbo
#[Out]# 
#[Out]# [2048 rows x 2 columns]
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS p, store AS s, product AS pr 
    WHERE pr.pID = p.pID AND s.sID = p.sID AND price IN(SELECT MAX(price) FROM purchase)
'''
pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query4 = '''
    SELECT COUNT(store.sID)
    FROM store

'''

pd.read_sql_query(query4, conn)
#[Out]#    COUNT(store.sID)
#[Out]# 0                64
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c, store AS s
    GROUP BY p.cID
    WHERE (SELECT COUNT(DISTINCT p.sID) = COUNT(s.sID))
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c, store AS s
    GROUP BY p.cID
    WHERE COUNT(DISTINCT p.sID) = COUNT(s.sID)
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c, store AS s
    GROUP BY p.cID
    WHERE COUNT(DISTINCT p.sID) = 64
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c, store AS s
    GROUP BY p.cID
    WHERE p.cID = c.cID COUNT(DISTINCT p.sID) = COUNT(s.sID)
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c, store AS s
    GROUP BY p.cID
    WHERE p.cID = c.cID AND COUNT(DISTINCT p.sID) = COUNT(s.sID)
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    WHERE COUNT(DISTINCT p.sID) = COUNT(s.sID)
    GROUP BY p.cID
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    WHERE (COUNT(DISTINCT p.sID)) = (COUNT(s.sID))
    GROUP BY p.cID
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    WHERE COUNT(DISTINCT p.sID) = COUNT(s.sID)
    GROUP BY p.cID
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    WHERE COUNT(DISTINCT p.sID) = COUNT(s.sID)
    GROUP BY p.cID
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID) = COUNT(s.sID)

'''
pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(p.sID) = COUNT(s.sID)

'''
pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID) = COUNT(s.sID)

'''
pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID) = 64

'''
pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID) = (SELECT COUNT(s.sID) FROM store AS s)

'''
pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.

# db_location = 'shoppingDB.sql'

# f = open(db_location,'r')
# sql = f.read()
# cur.executescript(sql)
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    UNION 
    SELECT pr.pID
    FROM product AS pr
    WHERE pr.pID NOT IN (SELECT p.pID FROM purchase AS p)
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    SELECT DISTINCT c.cID, c.cName
    FROM (customer AS c, product AS pr1, purchase AS pu1, product AS pr2, purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID) = (SELECT COUNT(s.sID) FROM store AS s)

'''
pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT s.sName
    FROM purchase AS p, store s
    WHERE s.sID = p.sID
    GROUP BY s.sName
    HAVING AVG(p.quantity) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS p, store AS s, product AS pr 
    WHERE pr.pID = p.pID AND s.sID = p.sID AND price IN(SELECT MAX(price) FROM purchase)
'''
pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = '2018-08-23' AND i2.date = '2018-08-23' AND i1.pID = i2.pID AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
practicequery1a = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1a, conn)

# IPython log file

query2 = '''
    SELECT c.cID AND c.cName
    FROM (customer c AND product pr1 AND purchase pu1 AND 
    product pr2 AND purchase pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND
    pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID 
    AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.

# db_location = 'shoppingDB.sql'

# f = open(db_location,'r')
# sql = f.read()
# cur.executescript(sql)
query1 = '''
    SELECT p.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE (p1.cID = p2.cID OR p1.cID = p3.cID OR p2.cID = p3.cID AND p1.pID = p2.pID AND p2.pID = p3.pID and p1.pID = p3.pID)
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE (p1.cID = p2.cID OR p1.cID = p3.cID OR p2.cID = p3.cID AND p1.pID = p2.pID AND p2.pID = p3.pID and p1.pID = p3.pID)
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#          pID
#[Out]# 0         10
#[Out]# 1         10
#[Out]# 2         10
#[Out]# 3         10
#[Out]# 4         10
#[Out]# 5         10
#[Out]# 6         10
#[Out]# 7         10
#[Out]# 8         10
#[Out]# 9         10
#[Out]# 10        10
#[Out]# 11        10
#[Out]# 12        10
#[Out]# 13        10
#[Out]# 14        10
#[Out]# 15        10
#[Out]# 16        10
#[Out]# 17        10
#[Out]# 18        10
#[Out]# 19        10
#[Out]# 20        10
#[Out]# 21        10
#[Out]# 22        10
#[Out]# 23        10
#[Out]# 24        10
#[Out]# 25        10
#[Out]# 26        10
#[Out]# 27        10
#[Out]# 28        10
#[Out]# 29        10
#[Out]# ...      ...
#[Out]# 6305417   18
#[Out]# 6305418   18
#[Out]# 6305419   18
#[Out]# 6305420   18
#[Out]# 6305421   18
#[Out]# 6305422   18
#[Out]# 6305423   18
#[Out]# 6305424   18
#[Out]# 6305425   18
#[Out]# 6305426   18
#[Out]# 6305427   18
#[Out]# 6305428   18
#[Out]# 6305429   18
#[Out]# 6305430   18
#[Out]# 6305431   18
#[Out]# 6305432   18
#[Out]# 6305433   18
#[Out]# 6305434   18
#[Out]# 6305435   18
#[Out]# 6305436   18
#[Out]# 6305437   18
#[Out]# 6305438   18
#[Out]# 6305439   18
#[Out]# 6305440   18
#[Out]# 6305441   18
#[Out]# 6305442   18
#[Out]# 6305443   18
#[Out]# 6305444   18
#[Out]# 6305445   18
#[Out]# 6305446   18
#[Out]# 
#[Out]# [6305447 rows x 1 columns]
query2 = '''
    SELECT c.cID AND c.cName
    FROM (customer AS c AND product AS pr1 AND purchase AS pu1 AND 
    product AS pr2 AND purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND
    pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID 
    AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
query1 = '''
    SELECT UNIQUE p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE (p1.cID = p2.cID OR p1.cID = p3.cID OR p2.cID = p3.cID AND p1.pID = p2.pID AND p2.pID = p3.pID and p1.pID = p3.pID)
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
query1 = '''
    SELECT DISTINCT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE (p1.cID = p2.cID OR p1.cID = p3.cID OR p2.cID = p3.cID AND p1.pID = p2.pID AND p2.pID = p3.pID and p1.pID = p3.pID)
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0    10
#[Out]# 1    14
#[Out]# 2    16
#[Out]# 3     9
#[Out]# 4    25
#[Out]# 5    26
#[Out]# 6    11
#[Out]# 7    27
#[Out]# 8    20
#[Out]# 9     4
#[Out]# 10   13
#[Out]# 11   22
#[Out]# 12    8
#[Out]# 13   12
#[Out]# 14    6
#[Out]# 15   28
#[Out]# 16   19
#[Out]# 17    2
#[Out]# 18   24
#[Out]# 19    0
#[Out]# 20   23
#[Out]# 21   17
#[Out]# 22    3
#[Out]# 23    5
#[Out]# 24   21
#[Out]# 25    7
#[Out]# 26   15
#[Out]# 27   18
#[Out]# 28    1
#[Out]# 29   29
#[Out]# 30   30
query2 = '''
    SELECT DISTINCT c.cID AND c.cName
    FROM (customer AS c AND product AS pr1 AND purchase AS pu1 AND 
    product AS pr2 AND purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND
    pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID 
    AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
query1 = '''
    SELECT DISTINCT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.pID not in (p1.pID = p2.pID AND p2.pID = p3.pID AND p1.pID = p3.pID 
    AND p1.cID != p2.cID AND p2.cID != p3.cID AND p1.cID != p3.cID )
    
'''
# (p1.cID = p2.cID OR p1.cID = p3.cID OR p2.cID = p3.cID AND p1.pID = p2.pID AND p2.pID = p3.pID and p1.pID = p3.pID)
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0    10
#[Out]# 1    14
#[Out]# 2    16
#[Out]# 3     9
#[Out]# 4    25
#[Out]# 5    26
#[Out]# 6    11
#[Out]# 7    27
#[Out]# 8    20
#[Out]# 9     4
#[Out]# 10   13
#[Out]# 11   22
#[Out]# 12    8
#[Out]# 13   12
#[Out]# 14    6
#[Out]# 15   28
#[Out]# 16   19
#[Out]# 17    2
#[Out]# 18   24
#[Out]# 19    0
#[Out]# 20   23
#[Out]# 21   17
#[Out]# 22    3
#[Out]# 23    5
#[Out]# 24   21
#[Out]# 25    7
#[Out]# 26   15
#[Out]# 27   18
#[Out]# 28    1
#[Out]# 29   29
#[Out]# 30   30
query2 = '''
    SELECT DISTINCT c.cID AND c.cName
    FROM (customer AS c AND product AS pr1 AND purchase AS pu1 AND 
    product AS pr2 AND purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND
    pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID 
    AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT DISTINCT c.cID AND c.cName
    FROM (customer AS c AND product AS pr1 AND purchase AS pu1 AND product AS pr2 AND purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT DISTINCT c.cID, c.cName
    FROM (customer AS c AND product AS pr1 AND purchase AS pu1 AND product AS pr2 AND purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT DISTINCT c.cID, c.cName
    FROM (customer AS c, product AS pr1, purchase AS pu1, product AS pr2, purchase AS pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = '2018-08-23' AND i2.date = '2018-08-23' AND i1.pID = i2.pID AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
queryTEST = '''SELECT product'''
pd.read_sql_query(queryTEST, conn)
queryTEST = '''SELECT product.pID'''
pd.read_sql_query(queryTEST, conn)
queryTEST = '''SELECT p.pID
FROM product AS p'''
pd.read_sql_query(queryTEST, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
#[Out]# 31   31
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE (SELECT MAX(i.unit_price))
'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE (SELECT MAX(i.unit_price) FROM inventory AS i)
'''
pd.read_sql_query(query5, conn)
#[Out]#                    pName  sName
#[Out]# 0            Cashew Nuts   Coop
#[Out]# 1            Cashew Nuts   Coop
#[Out]# 2            Cashew Nuts   Coop
#[Out]# 3            Cashew Nuts   Coop
#[Out]# 4            Cashew Nuts   Coop
#[Out]# 5            Cashew Nuts   Coop
#[Out]# 6            Cashew Nuts   Coop
#[Out]# 7            Cashew Nuts   Coop
#[Out]# 8            Cashew Nuts   Coop
#[Out]# 9            Cashew Nuts   Coop
#[Out]# 10           Cashew Nuts   Coop
#[Out]# 11           Cashew Nuts   Coop
#[Out]# 12           Cashew Nuts   Coop
#[Out]# 13           Cashew Nuts   Coop
#[Out]# 14           Cashew Nuts   Coop
#[Out]# 15           Cashew Nuts   Coop
#[Out]# 16           Cashew Nuts   Coop
#[Out]# 17           Cashew Nuts   Coop
#[Out]# 18           Cashew Nuts   Coop
#[Out]# 19           Cashew Nuts   Coop
#[Out]# 20           Cashew Nuts   Coop
#[Out]# 21           Cashew Nuts   Coop
#[Out]# 22           Cashew Nuts   Coop
#[Out]# 23           Cashew Nuts   Coop
#[Out]# 24           Cashew Nuts   Coop
#[Out]# 25           Cashew Nuts   Coop
#[Out]# 26           Cashew Nuts   Coop
#[Out]# 27           Cashew Nuts   Coop
#[Out]# 28           Cashew Nuts   Coop
#[Out]# 29           Cashew Nuts   Coop
#[Out]# ...                  ...    ...
#[Out]# 1697762  French baguette  Jumbo
#[Out]# 1697763  French baguette  Jumbo
#[Out]# 1697764  French baguette  Jumbo
#[Out]# 1697765  French baguette  Jumbo
#[Out]# 1697766  French baguette  Jumbo
#[Out]# 1697767  French baguette  Jumbo
#[Out]# 1697768  French baguette  Jumbo
#[Out]# 1697769  French baguette  Jumbo
#[Out]# 1697770  French baguette  Jumbo
#[Out]# 1697771  French baguette  Jumbo
#[Out]# 1697772  French baguette  Jumbo
#[Out]# 1697773  French baguette  Jumbo
#[Out]# 1697774  French baguette  Jumbo
#[Out]# 1697775  French baguette  Jumbo
#[Out]# 1697776  French baguette  Jumbo
#[Out]# 1697777  French baguette  Jumbo
#[Out]# 1697778  French baguette  Jumbo
#[Out]# 1697779  French baguette  Jumbo
#[Out]# 1697780  French baguette  Jumbo
#[Out]# 1697781  French baguette  Jumbo
#[Out]# 1697782  French baguette  Jumbo
#[Out]# 1697783  French baguette  Jumbo
#[Out]# 1697784  French baguette  Jumbo
#[Out]# 1697785  French baguette  Jumbo
#[Out]# 1697786  French baguette  Jumbo
#[Out]# 1697787  French baguette  Jumbo
#[Out]# 1697788  French baguette  Jumbo
#[Out]# 1697789  French baguette  Jumbo
#[Out]# 1697790  French baguette  Jumbo
#[Out]# 1697791  French baguette  Jumbo
#[Out]# 
#[Out]# [1697792 rows x 2 columns]
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    HAVING MAX(i.unit_price)
    WHERE i.sID = s.sID AND i.pID = p.pID 
'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID 
    HAVING MAX(i.unit_price)

'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID 
    GROUP BY i.pID
    HAVING MAX(i.unit_price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts    Hoogvliet
#[Out]# 2           Potatoes  Albert Hein
#[Out]# 3       Green Pepper    Hoogvliet
#[Out]# 4             Onions         Coop
#[Out]# 5          Mushrooms  Albert Hein
#[Out]# 6            Carrots         Coop
#[Out]# 7           Tomatoes    Hoogvliet
#[Out]# 8   Hot Dog Sausages         Dirk
#[Out]# 9            Bananas         Lidl
#[Out]# 10             Water         Coop
#[Out]# 11              Milk  Albert Hein
#[Out]# 12              Beef  Albert Hein
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples  Albert Hein
#[Out]# 15         Cucumbers         Dirk
#[Out]# 16              Rice    Hoogvliet
#[Out]# 17             Bread  Albert Hein
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca       Sligro
#[Out]# 20             Fanta       Sligro
#[Out]# 21            Coffee         Coop
#[Out]# 22               Tea        Jumbo
#[Out]# 23   Spiced Biscuits  Albert Hein
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza         Dirk
#[Out]# 28           Lasanga  Albert Hein
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    UNION
    SELECT p.pID
    FROM purchase AS p
    WHERE p.pID NOT IN (SELECT p.pID FROM purchase AS p)
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    UNION
    SELECT p.pID
    FROM purchase AS p
    WHERE p.pID NOT IN (SELECT p.pID FROM purchase AS p)
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    UNION
    SELECT p.pID
    FROM purchase AS p
    WHERE p.pID NOT IN (SELECT p.pID FROM purchase AS p)
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    FROM purchase AS p
    GROUP BY p.pID
    HAVING COUNT(p.cID)<=2
    UNION
    SELECT pr.pID
    FROM product AS pr
    WHERE pr.pID NOT IN (SELECT p.pID FROM purchase AS p)
    
'''
#List all the product ids of products that were bought by at most two different customers
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID AND (
    SELECT i.unit_price
    FROM inventory AS i
    GROUP BY i.pID
    HAVING MAX(i.unit_price))

'''
pd.read_sql_query(query5, conn)
#[Out]#                 pName      sName
#[Out]# 0         Cashew Nuts       Coop
#[Out]# 1          Mixed Nuts       Coop
#[Out]# 2            Potatoes       Coop
#[Out]# 3            Potatoes       Coop
#[Out]# 4            Potatoes       Coop
#[Out]# 5        Green Pepper       Coop
#[Out]# 6              Onions       Coop
#[Out]# 7            Tomatoes       Coop
#[Out]# 8             Bananas       Coop
#[Out]# 9                Beef       Coop
#[Out]# 10               Eggs       Coop
#[Out]# 11             Apples       Coop
#[Out]# 12             Apples       Coop
#[Out]# 13          Cucumbers       Coop
#[Out]# 14               Rice       Coop
#[Out]# 15               Rice       Coop
#[Out]# 16               Rice       Coop
#[Out]# 17              Fanta       Coop
#[Out]# 18             Coffee       Coop
#[Out]# 19    Spiced Biscuits       Coop
#[Out]# 20              Pizza       Coop
#[Out]# 21        Cashew Nuts  Hoogvliet
#[Out]# 22           Potatoes  Hoogvliet
#[Out]# 23       Green Pepper  Hoogvliet
#[Out]# 24             Onions  Hoogvliet
#[Out]# 25          Mushrooms  Hoogvliet
#[Out]# 26          Mushrooms  Hoogvliet
#[Out]# 27           Tomatoes  Hoogvliet
#[Out]# 28              Water  Hoogvliet
#[Out]# 29               Milk  Hoogvliet
#[Out]# ..                ...        ...
#[Out]# 799  Hot Dog Sausages       Dirk
#[Out]# 800              Beef       Dirk
#[Out]# 801              Beef       Dirk
#[Out]# 802              Eggs       Dirk
#[Out]# 803         Cucumbers       Dirk
#[Out]# 804             Bread       Dirk
#[Out]# 805             Bread       Dirk
#[Out]# 806              Coca       Dirk
#[Out]# 807              Coca       Dirk
#[Out]# 808             Pasta       Dirk
#[Out]# 809              Milk       Dirk
#[Out]# 810              Milk       Dirk
#[Out]# 811              Beef       Dirk
#[Out]# 812              Rice       Dirk
#[Out]# 813               Tea       Dirk
#[Out]# 814             Pizza       Dirk
#[Out]# 815       Cashew Nuts      Jumbo
#[Out]# 816        Mixed Nuts      Jumbo
#[Out]# 817          Potatoes      Jumbo
#[Out]# 818            Onions      Jumbo
#[Out]# 819  Hot Dog Sausages      Jumbo
#[Out]# 820              Eggs      Jumbo
#[Out]# 821            Apples      Jumbo
#[Out]# 822             Bread      Jumbo
#[Out]# 823            Coffee      Jumbo
#[Out]# 824               Tea      Jumbo
#[Out]# 825             Pasta      Jumbo
#[Out]# 826             Pizza      Jumbo
#[Out]# 827           Lasanga      Jumbo
#[Out]# 828              Coca       Lidl
#[Out]# 
#[Out]# [829 rows x 2 columns]
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID 
    GROUP BY i.pID
    HAVING MAX(i.unit_price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts    Hoogvliet
#[Out]# 2           Potatoes  Albert Hein
#[Out]# 3       Green Pepper    Hoogvliet
#[Out]# 4             Onions         Coop
#[Out]# 5          Mushrooms  Albert Hein
#[Out]# 6            Carrots         Coop
#[Out]# 7           Tomatoes    Hoogvliet
#[Out]# 8   Hot Dog Sausages         Dirk
#[Out]# 9            Bananas         Lidl
#[Out]# 10             Water         Coop
#[Out]# 11              Milk  Albert Hein
#[Out]# 12              Beef  Albert Hein
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples  Albert Hein
#[Out]# 15         Cucumbers         Dirk
#[Out]# 16              Rice    Hoogvliet
#[Out]# 17             Bread  Albert Hein
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca       Sligro
#[Out]# 20             Fanta       Sligro
#[Out]# 21            Coffee         Coop
#[Out]# 22               Tea        Jumbo
#[Out]# 23   Spiced Biscuits  Albert Hein
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza         Dirk
#[Out]# 28           Lasanga  Albert Hein
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID 
    GROUP BY i.pID
    HAVING MAX(i.unit_price)

'''
test = '''MAX(i.unit_price)
'''
pd.read_sql_query(test, conn)
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY i.pID
#     HAVING MAX(i.unit_price)

# '''
test = '''MAX(i.unit_price)
'''
pd.read_sql_query(test, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM inventory AS i, store AS s, product AS p
    WHERE i.sID = s.sID AND i.pID = p.pID 
    GROUP BY i.pID
    HAVING MAX(i.unit_price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts    Hoogvliet
#[Out]# 2           Potatoes  Albert Hein
#[Out]# 3       Green Pepper    Hoogvliet
#[Out]# 4             Onions         Coop
#[Out]# 5          Mushrooms  Albert Hein
#[Out]# 6            Carrots         Coop
#[Out]# 7           Tomatoes    Hoogvliet
#[Out]# 8   Hot Dog Sausages         Dirk
#[Out]# 9            Bananas         Lidl
#[Out]# 10             Water         Coop
#[Out]# 11              Milk  Albert Hein
#[Out]# 12              Beef  Albert Hein
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples  Albert Hein
#[Out]# 15         Cucumbers         Dirk
#[Out]# 16              Rice    Hoogvliet
#[Out]# 17             Bread  Albert Hein
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca       Sligro
#[Out]# 20             Fanta       Sligro
#[Out]# 21            Coffee         Coop
#[Out]# 22               Tea        Jumbo
#[Out]# 23   Spiced Biscuits  Albert Hein
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza         Dirk
#[Out]# 28           Lasanga  Albert Hein
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY i.pID
#     HAVING MAX(i.unit_price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY pu.pID
    HAVING MAX(pu.unit_price)

'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY i.pID
#     HAVING MAX(i.unit_price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY pu.pID
    HAVING MAX(pu.price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts         Coop
#[Out]# 2           Potatoes         Coop
#[Out]# 3       Green Pepper         Dirk
#[Out]# 4             Onions         Lidl
#[Out]# 5          Mushrooms         Lidl
#[Out]# 6            Carrots  Albert Hein
#[Out]# 7           Tomatoes        Jumbo
#[Out]# 8   Hot Dog Sausages  Albert Hein
#[Out]# 9            Bananas        Jumbo
#[Out]# 10             Water         Dirk
#[Out]# 11              Milk         Coop
#[Out]# 12              Beef       Sligro
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples    Hoogvliet
#[Out]# 15         Cucumbers         Coop
#[Out]# 16              Rice        Jumbo
#[Out]# 17             Bread        Jumbo
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca         Dirk
#[Out]# 20             Fanta    Hoogvliet
#[Out]# 21            Coffee  Albert Hein
#[Out]# 22               Tea       Sligro
#[Out]# 23   Spiced Biscuits         Coop
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza    Hoogvliet
#[Out]# 28           Lasanga  Albert Hein
#[Out]# 29            Salmon        Jumbo
#[Out]# 30           Ketchup        Jumbo
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY i.pID
#     HAVING MAX(i.unit_price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY pu.tID
    HAVING MAX(pu.price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 474           Lasanga         Coop
#[Out]# 475             Pizza         Lidl
#[Out]# 476         Mushrooms         Lidl
#[Out]# 477           Lasanga        Jumbo
#[Out]# 478          Tomatoes    Hoogvliet
#[Out]# 479       Cashew Nuts       Sligro
#[Out]# 480              Milk    Hoogvliet
#[Out]# 481           Carrots  Albert Hein
#[Out]# 482              Coca       Sligro
#[Out]# 483             Bread         Coop
#[Out]# 484           Bananas  Albert Hein
#[Out]# 485              Milk         Coop
#[Out]# 486               Tea         Lidl
#[Out]# 487             Bread         Coop
#[Out]# 488             Fanta    Hoogvliet
#[Out]# 489              Milk    Hoogvliet
#[Out]# 490            Coffee       Sligro
#[Out]# 491   Spiced Biscuits         Coop
#[Out]# 492   Spiced Biscuits         Lidl
#[Out]# 493  Hot Dog Sausages         Coop
#[Out]# 494       Cashew Nuts         Dirk
#[Out]# 495  Hot Dog Sausages         Coop
#[Out]# 496              Milk        Jumbo
#[Out]# 497         Cucumbers         Dirk
#[Out]# 498          Potatoes         Dirk
#[Out]# 499             Bread        Jumbo
#[Out]# 500         Mushrooms         Lidl
#[Out]# 501              Coca         Lidl
#[Out]# 502           Bananas        Jumbo
#[Out]# 503            Cheese        Jumbo
#[Out]# 
#[Out]# [504 rows x 2 columns]
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY MAX(i.unit_price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY pu.ID
    HAVING MAX(pu.price)

'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT p.pName, s.sName
#     FROM inventory AS i, store AS s, product AS p
#     WHERE i.sID = s.sID AND i.pID = p.pID 
#     GROUP BY i.pID
#     HAVING MAX(i.unit_price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY pu.tID
    HAVING MAX(pu.price)

'''
pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 474           Lasanga         Coop
#[Out]# 475             Pizza         Lidl
#[Out]# 476         Mushrooms         Lidl
#[Out]# 477           Lasanga        Jumbo
#[Out]# 478          Tomatoes    Hoogvliet
#[Out]# 479       Cashew Nuts       Sligro
#[Out]# 480              Milk    Hoogvliet
#[Out]# 481           Carrots  Albert Hein
#[Out]# 482              Coca       Sligro
#[Out]# 483             Bread         Coop
#[Out]# 484           Bananas  Albert Hein
#[Out]# 485              Milk         Coop
#[Out]# 486               Tea         Lidl
#[Out]# 487             Bread         Coop
#[Out]# 488             Fanta    Hoogvliet
#[Out]# 489              Milk    Hoogvliet
#[Out]# 490            Coffee       Sligro
#[Out]# 491   Spiced Biscuits         Coop
#[Out]# 492   Spiced Biscuits         Lidl
#[Out]# 493  Hot Dog Sausages         Coop
#[Out]# 494       Cashew Nuts         Dirk
#[Out]# 495  Hot Dog Sausages         Coop
#[Out]# 496              Milk        Jumbo
#[Out]# 497         Cucumbers         Dirk
#[Out]# 498          Potatoes         Dirk
#[Out]# 499             Bread        Jumbo
#[Out]# 500         Mushrooms         Lidl
#[Out]# 501              Coca         Lidl
#[Out]# 502           Bananas        Jumbo
#[Out]# 503            Cheese        Jumbo
#[Out]# 
#[Out]# [504 rows x 2 columns]
# query3 = '''
#     SELECT c.cID 
#     FROM (customer AS c AND purchase AS p)
#     WHERE (c.cID = p.cID AND p.sID )
# '''

query3 = '''
    SELECT p.cID
    FROM purchase AS p
    GROUP BY p.sID
    
'''
pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0   190
#[Out]# 1   190
#[Out]# 2   190
#[Out]# 3   190
#[Out]# 4   190
#[Out]# 5   190
#[Out]# 6   190
#[Out]# 7   190
#[Out]# 8   190
#[Out]# 9   190
#[Out]# 10  190
#[Out]# 11  190
#[Out]# 12  190
#[Out]# 13  190
#[Out]# 14  190
#[Out]# 15  190
#[Out]# 16  190
#[Out]# 17  190
#[Out]# 18  190
#[Out]# 19  190
#[Out]# 20  190
#[Out]# 21  190
#[Out]# 22  190
#[Out]# 23  190
#[Out]# 24  190
#[Out]# 25  190
#[Out]# 26  190
#[Out]# 27  190
#[Out]# 28  190
#[Out]# 29  190
#[Out]# ..  ...
#[Out]# 34  190
#[Out]# 35  190
#[Out]# 36  190
#[Out]# 37  190
#[Out]# 38  190
#[Out]# 39  190
#[Out]# 40  190
#[Out]# 41  190
#[Out]# 42  190
#[Out]# 43  190
#[Out]# 44  190
#[Out]# 45  190
#[Out]# 46  190
#[Out]# 47  190
#[Out]# 48  190
#[Out]# 49  190
#[Out]# 50  190
#[Out]# 51  190
#[Out]# 52  190
#[Out]# 53  190
#[Out]# 54  190
#[Out]# 55  190
#[Out]# 56  190
#[Out]# 57  190
#[Out]# 58  190
#[Out]# 59  190
#[Out]# 60  190
#[Out]# 61  190
#[Out]# 62  190
#[Out]# 63  190
#[Out]# 
#[Out]# [64 rows x 1 columns]
# query3 = '''
#     SELECT c.cID 
#     FROM (customer AS c AND purchase AS p)
#     WHERE (c.cID = p.cID AND p.sID )
# '''

query3 = '''
    SELECT DISTINCT p.cID
    FROM purchase AS p
    GROUP BY p.cID
    HAVING COUNT(p.sID)
    
'''
pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
# query3 = '''
#     SELECT c.cID 
#     FROM (customer AS c AND purchase AS p)
#     WHERE (c.cID = p.cID AND p.sID )
# '''

query3 = '''
    SELECT DISTINCT p.cID
    FROM purchase AS p
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID)
    
'''
pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, product AS pr, store s
    WHERE pu.pID = pr.pID AND pr.pName = 'Fanta' AND s.sID = pu.sID
    GROUP BY s.sName
    HAVING COUNT(DISTINCT s.sID) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#        sName
#[Out]# 0  Hoogvliet
#[Out]# 1     Sligro
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, product AS pr, store s
    WHERE pu.pID = pr.pID AND s.sID = pu.sID
    GROUP BY s.sName
    HAVING COUNT(DISTINCT s.sID) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, product AS pr, store s
    WHERE pu.pID = pr.pID AND s.sID = pu.sID
    GROUP BY s.sName
    HAVING COUNT(AVERAGE(pu.quantity)) >= 4

'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, product AS pr, store s
    WHERE pu.pID = pr.pID AND s.sID = pu.sID
    GROUP BY s.sName
    HAVING COUNT(AVG(pu.quantity)) >= 4

'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, product AS pr, store s
    WHERE pu.pID = pr.pID AND s.sID = pu.sID
    GROUP BY s.sName
    HAVING AVG(pu.quantity) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT s.sName
    FROM purchase AS pu, store s
    WHERE s.sID = pu.sID
    GROUP BY s.sName
    HAVING AVG(pu.quantity) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT s.sName
    FROM purchase AS p, store s
    WHERE s.sID = p.sID
    GROUP BY s.sName
    HAVING AVG(p.quantity) >= 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID 
    GROUP BY MAX(pu.price)

'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND pu.price = MAX(pu.price)
'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND 
        (SELECT MAX(pu.price))
'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND 
        (SELECT pu.price = MAX(pu.price))
'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND pu.price = HighestProduct
        (SELECT MAX(pu.price) as HighestProduct)
'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr, MAX(pu.price) as HighestProduct
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND pu.price = HighestProduct

'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr, 
    WHERE pu.sID = s.sID AND pu.pID = pr.pID AND pu.price = HighestProduct
        (SELECT MAX(pu.price)
         FROM purchase AS pu
         )

'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr, 
    WHERE pu.sID = s.sID AND pu.pID = pr.pID COUNT(MAX(pu.prize))


'''
pd.read_sql_query(query5, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c
    GROUP BY p.cID
    HAVING 
    WHERE (SELECT COUNT(DISTINCT p.sID))
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c
    GROUP BY p.cID
    WHERE (SELECT COUNT(DISTINCT p.sID))
    
'''
pd.read_sql_query(query3, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr, 
    WHERE pu.price IN (SELECT MAX(pu.price) FROM purchase)


'''
pd.read_sql_query(query5, conn)
# query5 = '''
#     SELECT pr.pName, s.sName
#     FROM purchase AS pu, store AS s, product AS pr
#     WHERE pu.sID = s.sID AND pu.pID = pr.pID 
#     GROUP BY pu.tID
#     HAVING MAX(pu.price)

# '''
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS pu, store AS s, product AS pr, 
    WHERE price IN (SELECT MAX(price) FROM purchase)


'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase, store AS s, product AS pr, 
    WHERE purchase.price IN (SELECT MAX(purchase.price) FROM purchase)


'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase, store AS s, product AS pr, 
    WHERE purchase.price IN (SELECT MAX(purchase.price) FROM purchase)

'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS price, store AS s, product AS pr, 
    WHERE purchaseprice IN (SELECT MAX(price) FROM purchase)

'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS price, store AS s, product AS pr, 
    WHERE purchase price IN (SELECT MAX(price) FROM purchase)

'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS price, store AS s, product AS pr, 
    WHERE price IN 
    (SELECT MAX(price) 
    FROM purchase)

'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS price, store AS s, product AS pr, 
    WHERE price IN 
    (SELECT MAX(price) 
    FROM purchase)
'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS p, store AS s, product AS pr, 
    WHERE price IN(SELECT MAX(price) FROM purchase);
'''
pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS p, store AS s, product AS pr 
    WHERE price IN(SELECT MAX(price) FROM purchase)
'''
pd.read_sql_query(query5, conn)
#[Out]#                  pName  sName
#[Out]# 0          Cashew Nuts   Coop
#[Out]# 1           Mixed Nuts   Coop
#[Out]# 2             Potatoes   Coop
#[Out]# 3         Green Pepper   Coop
#[Out]# 4               Onions   Coop
#[Out]# 5            Mushrooms   Coop
#[Out]# 6              Carrots   Coop
#[Out]# 7             Tomatoes   Coop
#[Out]# 8     Hot Dog Sausages   Coop
#[Out]# 9              Bananas   Coop
#[Out]# 10               Water   Coop
#[Out]# 11                Milk   Coop
#[Out]# 12                Beef   Coop
#[Out]# 13                Eggs   Coop
#[Out]# 14              Apples   Coop
#[Out]# 15           Cucumbers   Coop
#[Out]# 16                Rice   Coop
#[Out]# 17               Bread   Coop
#[Out]# 18              Cheese   Coop
#[Out]# 19                Coca   Coop
#[Out]# 20               Fanta   Coop
#[Out]# 21              Coffee   Coop
#[Out]# 22                 Tea   Coop
#[Out]# 23     Spiced Biscuits   Coop
#[Out]# 24             Oranges   Coop
#[Out]# 25              Donuts   Coop
#[Out]# 26               Pasta   Coop
#[Out]# 27               Pizza   Coop
#[Out]# 28             Lasanga   Coop
#[Out]# 29              Salmon   Coop
#[Out]# ...                ...    ...
#[Out]# 2018          Potatoes  Jumbo
#[Out]# 2019      Green Pepper  Jumbo
#[Out]# 2020            Onions  Jumbo
#[Out]# 2021         Mushrooms  Jumbo
#[Out]# 2022           Carrots  Jumbo
#[Out]# 2023          Tomatoes  Jumbo
#[Out]# 2024  Hot Dog Sausages  Jumbo
#[Out]# 2025           Bananas  Jumbo
#[Out]# 2026             Water  Jumbo
#[Out]# 2027              Milk  Jumbo
#[Out]# 2028              Beef  Jumbo
#[Out]# 2029              Eggs  Jumbo
#[Out]# 2030            Apples  Jumbo
#[Out]# 2031         Cucumbers  Jumbo
#[Out]# 2032              Rice  Jumbo
#[Out]# 2033             Bread  Jumbo
#[Out]# 2034            Cheese  Jumbo
#[Out]# 2035              Coca  Jumbo
#[Out]# 2036             Fanta  Jumbo
#[Out]# 2037            Coffee  Jumbo
#[Out]# 2038               Tea  Jumbo
#[Out]# 2039   Spiced Biscuits  Jumbo
#[Out]# 2040           Oranges  Jumbo
#[Out]# 2041            Donuts  Jumbo
#[Out]# 2042             Pasta  Jumbo
#[Out]# 2043             Pizza  Jumbo
#[Out]# 2044           Lasanga  Jumbo
#[Out]# 2045            Salmon  Jumbo
#[Out]# 2046           Ketchup  Jumbo
#[Out]# 2047   French baguette  Jumbo
#[Out]# 
#[Out]# [2048 rows x 2 columns]
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase AS p, store AS s, product AS pr 
    WHERE pr.pID = p.pID AND s.sID = p.sID AND price IN(SELECT MAX(price) FROM purchase)
'''
pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query4 = '''
    SELECT COUNT(store.sID)
    FROM store

'''

pd.read_sql_query(query4, conn)
#[Out]#    COUNT(store.sID)
#[Out]# 0                64
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c, store AS s
    GROUP BY p.cID
    WHERE (SELECT COUNT(DISTINCT p.sID) = COUNT(s.sID))
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c, store AS s
    GROUP BY p.cID
    WHERE COUNT(DISTINCT p.sID) = COUNT(s.sID)
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c, store AS s
    GROUP BY p.cID
    WHERE COUNT(DISTINCT p.sID) = 64
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c, store AS s
    GROUP BY p.cID
    WHERE p.cID = c.cID COUNT(DISTINCT p.sID) = COUNT(s.sID)
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, customer AS c, store AS s
    GROUP BY p.cID
    WHERE p.cID = c.cID AND COUNT(DISTINCT p.sID) = COUNT(s.sID)
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    WHERE COUNT(DISTINCT p.sID) = COUNT(s.sID)
    GROUP BY p.cID
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    WHERE (COUNT(DISTINCT p.sID)) = (COUNT(s.sID))
    GROUP BY p.cID
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    WHERE COUNT(DISTINCT p.sID) = COUNT(s.sID)
    GROUP BY p.cID
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    WHERE COUNT(DISTINCT p.sID) = COUNT(s.sID)
    GROUP BY p.cID
    
'''
pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID) = COUNT(s.sID)

'''
pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(p.sID) = COUNT(s.sID)

'''
pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID) = COUNT(s.sID)

'''
pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID) = 64

'''
pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT p.cID
    FROM purchase AS p, store AS s
    GROUP BY p.cID
    HAVING COUNT(DISTINCT p.sID) = (SELECT COUNT(s.sID) FROM store AS s)

'''
pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd

# IPython log file

query2 = '''
    SELECT c.cID AND c.cName
    FROM (customer c AND product pr1 AND purchase pu1 AND 
    product pr2 AND purchase pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND
    pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID 
    AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd

# IPython log file

query2 = '''
    SELECT c.cID AND c.cName
    FROM (customer c AND product pr1 AND purchase pu1 AND 
    product pr2 AND purchase pu2)
    WHERE (c.cID = pu1.cID AND c.cID = pu2.cID AND
    pr1.pName = 'Onions' AND pr2.pName = 'Coffee' AND pr1.pID = pu1.pID 
    AND pr2.pID = pu2.pID AND pu1.date = pu2.date)
'''

pd.read_sql_query(query2, conn)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x155f916a7a0>

