# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) <= 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT pr.pID
    FROM product pr
    NOT IN (SELECT ps.pID
            FROM purchase ps
            GROUP BY ps.pID
            HAVING COUNT(DISTINCT ps.cID) > 2)
    
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pr.pID
    FROM product pr
    EXCEPT
    SELECT ps.pID
    FROM purchase ps
    GROUP BY ps.pID
    HAVING COUNT(DISTINCT ps.cID) > 2)
    
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pr.pID
    FROM product pr
    EXCEPT
    SELECT ps.pID
    FROM purchase ps
    GROUP BY ps.pID
    HAVING COUNT(DISTINCT ps.cID) > 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    SELECT DISTINCT c.cID, c.cName
    FROM customer c, purchase p1, purchase p2, product pr1, product pr2
    WHERE c.cID = p1.cID AND c.cID = p2.cID AND p1.date = p2.date AND p1.pID = pr1.pID AND pr1.pName = "Coffee"
    AND p2.pID = pr2.pID AND pr2.pName = "Onions"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT cID
    FROM purchase
    GROUP BY CID 
    HAVING COUNT(DISTINCT sID) = (SELECT COUNT(DISTINCT sID) FROM purchase)
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT DISTINCT pName, sName
    FROM product pr, purchase ps, store s
    WHERE pr.pID = ps.pID AND s.sID = ps.sID AND ps.price = (SELECT MAX(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        /* AND i1.quantity > 0 AND i2.quantity > 0 check if in stock? */
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        AND i1.quantity > 0 AND i2.quantity > 0 /* check if in stock? */
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query1 = '''
    SELECT DISTINCT pr.pID
    FROM product pr
    EXCEPT
    SELECT ps.pID
    FROM purchase ps
    GROUP BY ps.pID
    HAVING COUNT(DISTINCT ps.cID) > 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31

# IPython log file

query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        /* AND i1.quantity > 0 AND i2.quantity > 0 check if in stock? */
'''

pd.read_sql_query(query6, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        /* AND i1.quantity > 0 AND i2.quantity > 0 check if in stock? */
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query1 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) <= 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT DISTINCT c.cID, c.cName
    FROM customer c, purchase p1, purchase p2, product pr1, product pr2
    WHERE c.cID = p1.cID AND c.cID = p2.cID AND p1.date = p2.date AND p1.pID = pr1.pID AND pr1.pName = "Coffee"
    AND p2.pID = pr2.pID AND pr2.pName = "Onions"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT cID
    FROM purchase
    GROUP BY CID 
    HAVING COUNT(DISTINCT sID) = (SELECT COUNT(DISTINCT sID) FROM purchase)
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT DISTINCT pName, sName
    FROM product pr, purchase ps, store s
    WHERE pr.pID = ps.pID AND s.sID = ps.sID AND ps.price = (SELECT MAX(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        /* AND i1.quantity > 0 AND i2.quantity > 0 check if in stock? */
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query4 = '''
    SELECT sName, AVG(quantity)
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(quantity)
#[Out]# 0  Albert Hein       4.969697
#[Out]# 1         Coop       4.681818
#[Out]# 2         Dirk       5.268293
#[Out]# 3    Hoogvliet       5.280000
#[Out]# 4         Lidl       4.796875
#[Out]# 5       Sligro       4.674419
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x1216cbc17a0>
query1 = '''
    SELECT p.pID
    FROM product p
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
#[Out]# 31   31
query1 = '''
    SELECT p.pID
    FROM purchase p
    HAVING COUNT(DISTINCT p.cID <= 2)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p
    WHERE COUNT(DISTINCT p.cID <= 2)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p
    WHERE COUNT(DISTINCT p.cID) <= 2
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p
    WHERE COUNT(DISTINCT cID) <= 2
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.pID, p.cID
    HAVING COUNT(DISTINCT cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0      0
#[Out]# 1      0
#[Out]# 2      0
#[Out]# 3      0
#[Out]# 4      0
#[Out]# 5      0
#[Out]# 6      0
#[Out]# 7      0
#[Out]# 8      0
#[Out]# 9      0
#[Out]# 10     0
#[Out]# 11     0
#[Out]# 12     0
#[Out]# 13     0
#[Out]# 14     0
#[Out]# 15     0
#[Out]# 16     0
#[Out]# 17     0
#[Out]# 18     0
#[Out]# 19     0
#[Out]# 20     0
#[Out]# 21     0
#[Out]# 22     1
#[Out]# 23     1
#[Out]# 24     1
#[Out]# 25     1
#[Out]# 26     1
#[Out]# 27     1
#[Out]# 28     1
#[Out]# 29     1
#[Out]# ..   ...
#[Out]# 438   27
#[Out]# 439   27
#[Out]# 440   27
#[Out]# 441   27
#[Out]# 442   28
#[Out]# 443   28
#[Out]# 444   28
#[Out]# 445   28
#[Out]# 446   28
#[Out]# 447   28
#[Out]# 448   28
#[Out]# 449   28
#[Out]# 450   28
#[Out]# 451   28
#[Out]# 452   28
#[Out]# 453   28
#[Out]# 454   28
#[Out]# 455   28
#[Out]# 456   28
#[Out]# 457   28
#[Out]# 458   28
#[Out]# 459   28
#[Out]# 460   28
#[Out]# 461   28
#[Out]# 462   28
#[Out]# 463   28
#[Out]# 464   28
#[Out]# 465   29
#[Out]# 466   29
#[Out]# 467   30
#[Out]# 
#[Out]# [468 rows x 1 columns]
query1 = '''
    SELECT distinct p.pID
    FROM purchase p
    GROUP BY p.pID, p.cID
    HAVING COUNT(DISTINCT cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
    SELECT DISTINCT p.pID
    FROM purchase p
    GROUP BY p.pID, p.cID
    HAVING COUNT(DISTINCT cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
    SELECT DISTINCT p.pID
    FROM purchase p
    GROUP BY p.pID, p.cID
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
    SELECT DISTINCT p.pID
    FROM purchase p
    GROUP BY p.pID, p.cID
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID, p.cID
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID  cID
#[Out]# 0      0   13
#[Out]# 1      0   16
#[Out]# 2      0   19
#[Out]# 3      0   20
#[Out]# 4      0   24
#[Out]# 5      0   33
#[Out]# 6      0   66
#[Out]# 7      0   78
#[Out]# 8      0   82
#[Out]# 9      0   95
#[Out]# 10     0  113
#[Out]# 11     0  123
#[Out]# 12     0  127
#[Out]# 13     0  139
#[Out]# 14     0  144
#[Out]# 15     0  157
#[Out]# 16     0  163
#[Out]# 17     0  167
#[Out]# 18     0  170
#[Out]# 19     0  176
#[Out]# 20     0  184
#[Out]# 21     0  190
#[Out]# 22     1   33
#[Out]# 23     1   59
#[Out]# 24     1   69
#[Out]# 25     1   92
#[Out]# 26     1  108
#[Out]# 27     1  109
#[Out]# 28     1  112
#[Out]# 29     1  131
#[Out]# ..   ...  ...
#[Out]# 438   27  134
#[Out]# 439   27  161
#[Out]# 440   27  179
#[Out]# 441   27  190
#[Out]# 442   28    5
#[Out]# 443   28   22
#[Out]# 444   28   35
#[Out]# 445   28   39
#[Out]# 446   28   40
#[Out]# 447   28   60
#[Out]# 448   28   70
#[Out]# 449   28   71
#[Out]# 450   28   82
#[Out]# 451   28   86
#[Out]# 452   28  100
#[Out]# 453   28  108
#[Out]# 454   28  118
#[Out]# 455   28  123
#[Out]# 456   28  124
#[Out]# 457   28  127
#[Out]# 458   28  136
#[Out]# 459   28  161
#[Out]# 460   28  162
#[Out]# 461   28  169
#[Out]# 462   28  170
#[Out]# 463   28  175
#[Out]# 464   28  190
#[Out]# 465   29  185
#[Out]# 466   29  186
#[Out]# 467   30  188
#[Out]# 
#[Out]# [468 rows x 2 columns]
query1 = '''
    SELECT p.pID
    FROM purchase p
    WHERE
    SELECT p.pID, count(p.cID)
    FROM purchase p
    WHERE count(p.cID) <= 2
    GROUP BY p.pID, p.cID
    
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p
    WHERE count(p.cID) <= 2
    GROUP BY p.pID, p.cID
    
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p
    WHERE COUNT(p.cID) <= 2
    GROUP BY p.pID, p.cID
    
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p
    WHERE COUNT(DISTINCT p.cID) <= 2
    GROUP BY p.pID, p.cID
    
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.pID, p.cID
    HAVING COUNT(DISTINCT p.cID) <= 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0      0
#[Out]# 1      0
#[Out]# 2      0
#[Out]# 3      0
#[Out]# 4      0
#[Out]# 5      0
#[Out]# 6      0
#[Out]# 7      0
#[Out]# 8      0
#[Out]# 9      0
#[Out]# 10     0
#[Out]# 11     0
#[Out]# 12     0
#[Out]# 13     0
#[Out]# 14     0
#[Out]# 15     0
#[Out]# 16     0
#[Out]# 17     0
#[Out]# 18     0
#[Out]# 19     0
#[Out]# 20     0
#[Out]# 21     0
#[Out]# 22     1
#[Out]# 23     1
#[Out]# 24     1
#[Out]# 25     1
#[Out]# 26     1
#[Out]# 27     1
#[Out]# 28     1
#[Out]# 29     1
#[Out]# ..   ...
#[Out]# 438   27
#[Out]# 439   27
#[Out]# 440   27
#[Out]# 441   27
#[Out]# 442   28
#[Out]# 443   28
#[Out]# 444   28
#[Out]# 445   28
#[Out]# 446   28
#[Out]# 447   28
#[Out]# 448   28
#[Out]# 449   28
#[Out]# 450   28
#[Out]# 451   28
#[Out]# 452   28
#[Out]# 453   28
#[Out]# 454   28
#[Out]# 455   28
#[Out]# 456   28
#[Out]# 457   28
#[Out]# 458   28
#[Out]# 459   28
#[Out]# 460   28
#[Out]# 461   28
#[Out]# 462   28
#[Out]# 463   28
#[Out]# 464   28
#[Out]# 465   29
#[Out]# 466   29
#[Out]# 467   30
#[Out]# 
#[Out]# [468 rows x 1 columns]
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID, p.cID
    HAVING COUNT(DISTINCT p.cID) <= 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID  cID
#[Out]# 0      0   13
#[Out]# 1      0   16
#[Out]# 2      0   19
#[Out]# 3      0   20
#[Out]# 4      0   24
#[Out]# 5      0   33
#[Out]# 6      0   66
#[Out]# 7      0   78
#[Out]# 8      0   82
#[Out]# 9      0   95
#[Out]# 10     0  113
#[Out]# 11     0  123
#[Out]# 12     0  127
#[Out]# 13     0  139
#[Out]# 14     0  144
#[Out]# 15     0  157
#[Out]# 16     0  163
#[Out]# 17     0  167
#[Out]# 18     0  170
#[Out]# 19     0  176
#[Out]# 20     0  184
#[Out]# 21     0  190
#[Out]# 22     1   33
#[Out]# 23     1   59
#[Out]# 24     1   69
#[Out]# 25     1   92
#[Out]# 26     1  108
#[Out]# 27     1  109
#[Out]# 28     1  112
#[Out]# 29     1  131
#[Out]# ..   ...  ...
#[Out]# 438   27  134
#[Out]# 439   27  161
#[Out]# 440   27  179
#[Out]# 441   27  190
#[Out]# 442   28    5
#[Out]# 443   28   22
#[Out]# 444   28   35
#[Out]# 445   28   39
#[Out]# 446   28   40
#[Out]# 447   28   60
#[Out]# 448   28   70
#[Out]# 449   28   71
#[Out]# 450   28   82
#[Out]# 451   28   86
#[Out]# 452   28  100
#[Out]# 453   28  108
#[Out]# 454   28  118
#[Out]# 455   28  123
#[Out]# 456   28  124
#[Out]# 457   28  127
#[Out]# 458   28  136
#[Out]# 459   28  161
#[Out]# 460   28  162
#[Out]# 461   28  169
#[Out]# 462   28  170
#[Out]# 463   28  175
#[Out]# 464   28  190
#[Out]# 465   29  185
#[Out]# 466   29  186
#[Out]# 467   30  188
#[Out]# 
#[Out]# [468 rows x 2 columns]
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) <= 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID
#[Out]# 0   29  186
#[Out]# 1   30  188
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) <= 3
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID
#[Out]# 0   29  186
#[Out]# 1   30  188
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) <= 4
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID
#[Out]# 0   29  186
#[Out]# 1   30  188
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) <= 5
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID
#[Out]# 0   29  186
#[Out]# 1   30  188
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID)
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  cID
#[Out]# 0     0  190
#[Out]# 1     1  169
#[Out]# 2     2  190
#[Out]# 3     3  190
#[Out]# 4     4  190
#[Out]# 5     5  190
#[Out]# 6     6  190
#[Out]# 7     7  190
#[Out]# 8     8  190
#[Out]# 9     9  190
#[Out]# 10   10  190
#[Out]# 11   11  190
#[Out]# 12   12  162
#[Out]# 13   13  190
#[Out]# 14   14  179
#[Out]# 15   15  190
#[Out]# 16   16  179
#[Out]# 17   17  190
#[Out]# 18   18  190
#[Out]# 19   19  190
#[Out]# 20   20  190
#[Out]# 21   21  190
#[Out]# 22   22  190
#[Out]# 23   23  190
#[Out]# 24   24  178
#[Out]# 25   25  190
#[Out]# 26   26  190
#[Out]# 27   27  190
#[Out]# 28   28  190
#[Out]# 29   29  186
#[Out]# 30   30  188
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) > 0
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  cID
#[Out]# 0     0  190
#[Out]# 1     1  169
#[Out]# 2     2  190
#[Out]# 3     3  190
#[Out]# 4     4  190
#[Out]# 5     5  190
#[Out]# 6     6  190
#[Out]# 7     7  190
#[Out]# 8     8  190
#[Out]# 9     9  190
#[Out]# 10   10  190
#[Out]# 11   11  190
#[Out]# 12   12  162
#[Out]# 13   13  190
#[Out]# 14   14  179
#[Out]# 15   15  190
#[Out]# 16   16  179
#[Out]# 17   17  190
#[Out]# 18   18  190
#[Out]# 19   19  190
#[Out]# 20   20  190
#[Out]# 21   21  190
#[Out]# 22   22  190
#[Out]# 23   23  190
#[Out]# 24   24  178
#[Out]# 25   25  190
#[Out]# 26   26  190
#[Out]# 27   27  190
#[Out]# 28   28  190
#[Out]# 29   29  186
#[Out]# 30   30  188
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) = 1
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID
#[Out]# 0   30  188
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) = 0
    
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID, cID]
#[Out]# Index: []
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) = 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID
#[Out]# 0   29  186
query1 = '''
    SELECT p.pID, p.cID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) > 0
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  cID
#[Out]# 0     0  190
#[Out]# 1     1  169
#[Out]# 2     2  190
#[Out]# 3     3  190
#[Out]# 4     4  190
#[Out]# 5     5  190
#[Out]# 6     6  190
#[Out]# 7     7  190
#[Out]# 8     8  190
#[Out]# 9     9  190
#[Out]# 10   10  190
#[Out]# 11   11  190
#[Out]# 12   12  162
#[Out]# 13   13  190
#[Out]# 14   14  179
#[Out]# 15   15  190
#[Out]# 16   16  179
#[Out]# 17   17  190
#[Out]# 18   18  190
#[Out]# 19   19  190
#[Out]# 20   20  190
#[Out]# 21   21  190
#[Out]# 22   22  190
#[Out]# 23   23  190
#[Out]# 24   24  178
#[Out]# 25   25  190
#[Out]# 26   26  190
#[Out]# 27   27  190
#[Out]# 28   28  190
#[Out]# 29   29  186
#[Out]# 30   30  188
query1 = '''
    SELECT p.pID, p.cID, COUNT(DISTINCT p.cID)
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) > 0
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  cID  COUNT(DISTINCT p.cID)
#[Out]# 0     0  190                     22
#[Out]# 1     1  169                     13
#[Out]# 2     2  190                      9
#[Out]# 3     3  190                     20
#[Out]# 4     4  190                     16
#[Out]# 5     5  190                     14
#[Out]# 6     6  190                     15
#[Out]# 7     7  190                     13
#[Out]# 8     8  190                     12
#[Out]# 9     9  190                     18
#[Out]# 10   10  190                     14
#[Out]# 11   11  190                     13
#[Out]# 12   12  162                     16
#[Out]# 13   13  190                     21
#[Out]# 14   14  179                     18
#[Out]# 15   15  190                     13
#[Out]# 16   16  179                     20
#[Out]# 17   17  190                     13
#[Out]# 18   18  190                     10
#[Out]# 19   19  190                     20
#[Out]# 20   20  190                     16
#[Out]# 21   21  190                     19
#[Out]# 22   22  190                     20
#[Out]# 23   23  190                     11
#[Out]# 24   24  178                     20
#[Out]# 25   25  190                     14
#[Out]# 26   26  190                     19
#[Out]# 27   27  190                     13
#[Out]# 28   28  190                     23
#[Out]# 29   29  186                      2
#[Out]# 30   30  188                      1
query1 = '''
    SELECT p.pID, p.cID, COUNT(DISTINCT p.cID)
    FROM purchase p
    GROUP BY p.pID
    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  cID  COUNT(DISTINCT p.cID)
#[Out]# 0     0  190                     22
#[Out]# 1     1  169                     13
#[Out]# 2     2  190                      9
#[Out]# 3     3  190                     20
#[Out]# 4     4  190                     16
#[Out]# 5     5  190                     14
#[Out]# 6     6  190                     15
#[Out]# 7     7  190                     13
#[Out]# 8     8  190                     12
#[Out]# 9     9  190                     18
#[Out]# 10   10  190                     14
#[Out]# 11   11  190                     13
#[Out]# 12   12  162                     16
#[Out]# 13   13  190                     21
#[Out]# 14   14  179                     18
#[Out]# 15   15  190                     13
#[Out]# 16   16  179                     20
#[Out]# 17   17  190                     13
#[Out]# 18   18  190                     10
#[Out]# 19   19  190                     20
#[Out]# 20   20  190                     16
#[Out]# 21   21  190                     19
#[Out]# 22   22  190                     20
#[Out]# 23   23  190                     11
#[Out]# 24   24  178                     20
#[Out]# 25   25  190                     14
#[Out]# 26   26  190                     19
#[Out]# 27   27  190                     13
#[Out]# 28   28  190                     23
#[Out]# 29   29  186                      2
#[Out]# 30   30  188                      1
query1 = '''
    SELECT p.pID, p.cID, COUNT(DISTINCT p.cID)
    FROM purchase p
    
    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID  COUNT(DISTINCT p.cID)
#[Out]# 0   18  190                    132
query1 = '''
    SELECT p.pID, p.cID, COUNT(DISTINCT p.cID)
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) > 0
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  cID  COUNT(DISTINCT p.cID)
#[Out]# 0     0  190                     22
#[Out]# 1     1  169                     13
#[Out]# 2     2  190                      9
#[Out]# 3     3  190                     20
#[Out]# 4     4  190                     16
#[Out]# 5     5  190                     14
#[Out]# 6     6  190                     15
#[Out]# 7     7  190                     13
#[Out]# 8     8  190                     12
#[Out]# 9     9  190                     18
#[Out]# 10   10  190                     14
#[Out]# 11   11  190                     13
#[Out]# 12   12  162                     16
#[Out]# 13   13  190                     21
#[Out]# 14   14  179                     18
#[Out]# 15   15  190                     13
#[Out]# 16   16  179                     20
#[Out]# 17   17  190                     13
#[Out]# 18   18  190                     10
#[Out]# 19   19  190                     20
#[Out]# 20   20  190                     16
#[Out]# 21   21  190                     19
#[Out]# 22   22  190                     20
#[Out]# 23   23  190                     11
#[Out]# 24   24  178                     20
#[Out]# 25   25  190                     14
#[Out]# 26   26  190                     19
#[Out]# 27   27  190                     13
#[Out]# 28   28  190                     23
#[Out]# 29   29  186                      2
#[Out]# 30   30  188                      1
query1 = '''
    SELECT p.pID, p.cID, COUNT(DISTINCT p.cID)
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) <= 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID  COUNT(DISTINCT p.cID)
#[Out]# 0   29  186                      2
#[Out]# 1   30  188                      1
query1 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.pID
    HAVING COUNT(DISTINCT p.cID) <= 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT c.cID, c.cName
    FROM customer c, purchase p
    WHERE c.cID = p.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID   cName
#[Out]# 0      0    Noah
#[Out]# 1      1     Sem
#[Out]# 2      1     Sem
#[Out]# 3      1     Sem
#[Out]# 4      1     Sem
#[Out]# 5      1     Sem
#[Out]# 6      1     Sem
#[Out]# 7      1     Sem
#[Out]# 8      2   Lucas
#[Out]# 9      2   Lucas
#[Out]# 10     2   Lucas
#[Out]# 11     2   Lucas
#[Out]# 12     2   Lucas
#[Out]# 13     3    Finn
#[Out]# 14     3    Finn
#[Out]# 15     3    Finn
#[Out]# 16     4    Daan
#[Out]# 17     4    Daan
#[Out]# 18     4    Daan
#[Out]# 19     4    Daan
#[Out]# 20     4    Daan
#[Out]# 21     4    Daan
#[Out]# 22     5    Levi
#[Out]# 23     5    Levi
#[Out]# 24     5    Levi
#[Out]# 25     5    Levi
#[Out]# 26     5    Levi
#[Out]# 27     5    Levi
#[Out]# 28     7    Bram
#[Out]# 29     7    Bram
#[Out]# ..   ...     ...
#[Out]# 479  190  Kostas
#[Out]# 480  190  Kostas
#[Out]# 481  190  Kostas
#[Out]# 482  190  Kostas
#[Out]# 483  190  Kostas
#[Out]# 484  190  Kostas
#[Out]# 485  190  Kostas
#[Out]# 486  190  Kostas
#[Out]# 487  190  Kostas
#[Out]# 488  190  Kostas
#[Out]# 489  190  Kostas
#[Out]# 490  190  Kostas
#[Out]# 491  190  Kostas
#[Out]# 492  190  Kostas
#[Out]# 493  190  Kostas
#[Out]# 494  190  Kostas
#[Out]# 495  190  Kostas
#[Out]# 496  190  Kostas
#[Out]# 497  190  Kostas
#[Out]# 498  190  Kostas
#[Out]# 499  190  Kostas
#[Out]# 500  190  Kostas
#[Out]# 501  190  Kostas
#[Out]# 502  190  Kostas
#[Out]# 503  190  Kostas
#[Out]# 504  190  Kostas
#[Out]# 505  190  Kostas
#[Out]# 506  190  Kostas
#[Out]# 507  190  Kostas
#[Out]# 508  190  Kostas
#[Out]# 
#[Out]# [509 rows x 2 columns]
query2 = '''
    SELECT c.cID, c.cName
    FROM customer c, purchase p
    WHERE c.cID = p.cID AND p.pID = 'Onions' AND p.pID = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName
    FROM customer c, purchase p
    WHERE c.cID = p.cID AND p.pID = 'Onions'
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, p.pID
    FROM customer c, purchase p
    WHERE c.cID = p.cID AND p.pID = 'Onions'
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, p.pID
    FROM customer c, purchase p
   
'''

pd.read_sql_query(query2, conn)
#[Out]#        cID   cName  pID
#[Out]# 0        0    Noah   10
#[Out]# 1        0    Noah   14
#[Out]# 2        0    Noah   16
#[Out]# 3        0    Noah    9
#[Out]# 4        0    Noah   25
#[Out]# 5        0    Noah   26
#[Out]# 6        0    Noah   11
#[Out]# 7        0    Noah   27
#[Out]# 8        0    Noah   20
#[Out]# 9        0    Noah    9
#[Out]# 10       0    Noah    4
#[Out]# 11       0    Noah   13
#[Out]# 12       0    Noah   22
#[Out]# 13       0    Noah   14
#[Out]# 14       0    Noah   26
#[Out]# 15       0    Noah    9
#[Out]# 16       0    Noah    8
#[Out]# 17       0    Noah   27
#[Out]# 18       0    Noah   12
#[Out]# 19       0    Noah    6
#[Out]# 20       0    Noah   13
#[Out]# 21       0    Noah   26
#[Out]# 22       0    Noah   14
#[Out]# 23       0    Noah   28
#[Out]# 24       0    Noah    6
#[Out]# 25       0    Noah   22
#[Out]# 26       0    Noah   16
#[Out]# 27       0    Noah   19
#[Out]# 28       0    Noah   19
#[Out]# 29       0    Noah    2
#[Out]# ...    ...     ...  ...
#[Out]# 96680  190  Kostas   28
#[Out]# 96681  190  Kostas   27
#[Out]# 96682  190  Kostas    5
#[Out]# 96683  190  Kostas   28
#[Out]# 96684  190  Kostas    7
#[Out]# 96685  190  Kostas    0
#[Out]# 96686  190  Kostas   11
#[Out]# 96687  190  Kostas    6
#[Out]# 96688  190  Kostas   19
#[Out]# 96689  190  Kostas   17
#[Out]# 96690  190  Kostas    9
#[Out]# 96691  190  Kostas   11
#[Out]# 96692  190  Kostas   22
#[Out]# 96693  190  Kostas   17
#[Out]# 96694  190  Kostas   20
#[Out]# 96695  190  Kostas   11
#[Out]# 96696  190  Kostas   21
#[Out]# 96697  190  Kostas   23
#[Out]# 96698  190  Kostas   23
#[Out]# 96699  190  Kostas    8
#[Out]# 96700  190  Kostas    0
#[Out]# 96701  190  Kostas    8
#[Out]# 96702  190  Kostas   11
#[Out]# 96703  190  Kostas   15
#[Out]# 96704  190  Kostas    2
#[Out]# 96705  190  Kostas   17
#[Out]# 96706  190  Kostas    5
#[Out]# 96707  190  Kostas   19
#[Out]# 96708  190  Kostas    9
#[Out]# 96709  190  Kostas   18
#[Out]# 
#[Out]# [96710 rows x 3 columns]
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product pr
    WHERE c.cID = pr.cID AND pr.pID = ps.pID AND pr.pName = 'Onions'
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product pr
    WHERE c.cID = ps.cID AND pr.pID = ps.pID AND pr.pName = 'Onions'
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID    cName  pID
#[Out]# 0     2    Lucas    4
#[Out]# 1    29    Ruben    4
#[Out]# 2    31  Olivier    4
#[Out]# 3    33     Sven    4
#[Out]# 4    52   Willem    4
#[Out]# 5    59     Joep    4
#[Out]# 6    85   Pieter    4
#[Out]# 7   124    Sofie    4
#[Out]# 8   129    Esmee    4
#[Out]# 9   162    Elena    4
#[Out]# 10  165    Hanna    4
#[Out]# 11  169     Lily    4
#[Out]# 12  172     Lana    4
#[Out]# 13  176    Amira    4
#[Out]# 14  177    Eline    4
#[Out]# 15  190   Kostas    4
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product pr
    WHERE c.cID = ps.cID AND pr.pID = ps.pID AND pr.pName = 'Onions' AND pr.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product pr
    GROUP BY c.cID
    WHERE c.cID = ps.cID AND pr.pID = ps.pID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product pr
    GROUP BY c.cID
    HAVING c.cID = ps.cID AND pr.pID = ps.pID
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product pr
    WHERE c.cID = ps.cID AND pr.pID = ps.pID
    GROUP BY c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID     cName  pID
#[Out]# 0      0      Noah   10
#[Out]# 1      1       Sem   27
#[Out]# 2      2     Lucas   22
#[Out]# 3      3      Finn    9
#[Out]# 4      4      Daan   26
#[Out]# 5      5      Levi   19
#[Out]# 6      7      Bram   20
#[Out]# 7      8      Liam    8
#[Out]# 8     10       Sam   24
#[Out]# 9     11     Thijs   14
#[Out]# 10    13     James    5
#[Out]# 11    15      Noud   11
#[Out]# 12    16    Julian   27
#[Out]# 13    17       Dex    7
#[Out]# 14    18      Hugo    8
#[Out]# 15    19      Lars    3
#[Out]# 16    20      Gijs   27
#[Out]# 17    21  Benjamin   27
#[Out]# 18    22      Mats   10
#[Out]# 19    24      Luca   13
#[Out]# 20    25     Mason   26
#[Out]# 21    26    Jayden   23
#[Out]# 22    27       Tim   22
#[Out]# 23    28      Siem   11
#[Out]# 24    29     Ruben    4
#[Out]# 25    30      Teun   12
#[Out]# 26    31   Olivier   24
#[Out]# 27    33      Sven    4
#[Out]# 28    34     David   26
#[Out]# 29    35     Stijn   28
#[Out]# ..   ...       ...  ...
#[Out]# 102  147    Isabel   25
#[Out]# 103  149     Lizzy   19
#[Out]# 104  151      Jill   23
#[Out]# 105  152      Anne   19
#[Out]# 106  157      Puck    3
#[Out]# 107  159     Fenne   12
#[Out]# 108  161     Floor   28
#[Out]# 109  162     Elena   16
#[Out]# 110  163      Cato   10
#[Out]# 111  165     Hanna    9
#[Out]# 112  167    Veerle   17
#[Out]# 113  168      Kiki    1
#[Out]# 114  169      Lily   14
#[Out]# 115  170      Iris   22
#[Out]# 116  171     Tessa   21
#[Out]# 117  172      Lana   16
#[Out]# 118  175       Sam   21
#[Out]# 119  176     Amira    5
#[Out]# 120  177     Eline    4
#[Out]# 121  178      Elif   24
#[Out]# 122  179      Juul   10
#[Out]# 123  180     Merel   10
#[Out]# 124  181      Liva   21
#[Out]# 125  182   Johanna   13
#[Out]# 126  184     Wilko    0
#[Out]# 127  185      Nick   29
#[Out]# 128  186    Angela   29
#[Out]# 129  188      Pino   30
#[Out]# 130  189      Koen   19
#[Out]# 131  190    Kostas   18
#[Out]# 
#[Out]# [132 rows x 3 columns]
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product pr
    WHERE c.cID = ps.cID AND pr.pID = ps.pID
    GROUP BY c.cID
    HAVING pr.pName = 'Onions' AND pr.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product pr
    WHERE c.cID = ps.cID AND pr.pID = ps.pID
    GROUP BY c.cID
    HAVING pr.pName = 'Onions' OR pr.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID
#[Out]# 0   29   Ruben    4
#[Out]# 1   33    Sven    4
#[Out]# 2   42    Tijn   21
#[Out]# 3  110    Saar   21
#[Out]# 4  111  Lauren   21
#[Out]# 5  171   Tessa   21
#[Out]# 6  175     Sam   21
#[Out]# 7  177   Eline    4
#[Out]# 8  181    Liva   21
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product pr
    WHERE c.cID = ps.cID AND pr.pID = ps.pID AND pr.pName = 'Onions' OR pr.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]#        cID   cName  pID
#[Out]# 0        0    Noah   21
#[Out]# 1        0    Noah   21
#[Out]# 2        0    Noah   21
#[Out]# 3        0    Noah   21
#[Out]# 4        0    Noah   21
#[Out]# 5        0    Noah   21
#[Out]# 6        0    Noah   21
#[Out]# 7        0    Noah   21
#[Out]# 8        0    Noah   21
#[Out]# 9        0    Noah   21
#[Out]# 10       0    Noah   21
#[Out]# 11       0    Noah   21
#[Out]# 12       0    Noah   21
#[Out]# 13       0    Noah   21
#[Out]# 14       0    Noah   21
#[Out]# 15       0    Noah   21
#[Out]# 16       0    Noah   21
#[Out]# 17       0    Noah   21
#[Out]# 18       0    Noah   21
#[Out]# 19       0    Noah   21
#[Out]# 20       0    Noah   21
#[Out]# 21       0    Noah   21
#[Out]# 22       0    Noah   21
#[Out]# 23       0    Noah   21
#[Out]# 24       0    Noah   21
#[Out]# 25       0    Noah   21
#[Out]# 26       0    Noah   21
#[Out]# 27       0    Noah   21
#[Out]# 28       0    Noah   21
#[Out]# 29       0    Noah   21
#[Out]# ...    ...     ...  ...
#[Out]# 96696  190  Kostas   21
#[Out]# 96697  190  Kostas   21
#[Out]# 96698  190  Kostas   21
#[Out]# 96699  190  Kostas   21
#[Out]# 96700  190  Kostas   21
#[Out]# 96701  190  Kostas   21
#[Out]# 96702  190  Kostas   21
#[Out]# 96703  190  Kostas   21
#[Out]# 96704  190  Kostas   21
#[Out]# 96705  190  Kostas   21
#[Out]# 96706  190  Kostas   21
#[Out]# 96707  190  Kostas   21
#[Out]# 96708  190  Kostas   21
#[Out]# 96709  190  Kostas   21
#[Out]# 96710  190  Kostas   21
#[Out]# 96711  190  Kostas   21
#[Out]# 96712  190  Kostas   21
#[Out]# 96713  190  Kostas   21
#[Out]# 96714  190  Kostas   21
#[Out]# 96715  190  Kostas   21
#[Out]# 96716  190  Kostas   21
#[Out]# 96717  190  Kostas   21
#[Out]# 96718  190  Kostas   21
#[Out]# 96719  190  Kostas   21
#[Out]# 96720  190  Kostas   21
#[Out]# 96721  190  Kostas   21
#[Out]# 96722  190  Kostas   21
#[Out]# 96723  190  Kostas   21
#[Out]# 96724  190  Kostas   21
#[Out]# 96725  190  Kostas   21
#[Out]# 
#[Out]# [96726 rows x 3 columns]
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product pr
    WHERE c.cID = ps.cID AND pr.pID = ps.pID
    GROUP BY c.cID
    HAVING pr.pName = 'Onions' OR pr.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID
#[Out]# 0   29   Ruben    4
#[Out]# 1   33    Sven    4
#[Out]# 2   42    Tijn   21
#[Out]# 3  110    Saar   21
#[Out]# 4  111  Lauren   21
#[Out]# 5  171   Tessa   21
#[Out]# 6  175     Sam   21
#[Out]# 7  177   Eline    4
#[Out]# 8  181    Liva   21
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase p1, purchase p2, product pr
    WHERE c.cID = ps.cID AND pr.pID = p1.pID AND pr.pID = p2.pID
    GROUP BY c.cID
    HAVING pr.pName = 'Onions' OR pr.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase p1, purchase p2, product pr
    WHERE c.cID = ps.cID AND pr.pID = p1.pID AND pr.pID = p2.pID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase p1, purchase p2, product pr
    WHERE c.cID = p1.cID AND pr.pID = p1.pID AND pr.pID = p2.pID
'''

pd.read_sql_query(query2, conn)
#[Out]#       cID   cName  pID
#[Out]# 0       0    Noah   10
#[Out]# 1       0    Noah   10
#[Out]# 2       0    Noah   10
#[Out]# 3       0    Noah   10
#[Out]# 4       0    Noah   10
#[Out]# 5       0    Noah   10
#[Out]# 6       0    Noah   10
#[Out]# 7       0    Noah   10
#[Out]# 8       0    Noah   10
#[Out]# 9       0    Noah   10
#[Out]# 10      0    Noah   10
#[Out]# 11      0    Noah   10
#[Out]# 12      0    Noah   10
#[Out]# 13      0    Noah   10
#[Out]# 14      0    Noah   10
#[Out]# 15      0    Noah   10
#[Out]# 16      1     Sem   14
#[Out]# 17      1     Sem   14
#[Out]# 18      1     Sem   14
#[Out]# 19      1     Sem   14
#[Out]# 20      1     Sem   14
#[Out]# 21      1     Sem   14
#[Out]# 22      1     Sem   14
#[Out]# 23      1     Sem   14
#[Out]# 24      1     Sem   14
#[Out]# 25      1     Sem   14
#[Out]# 26      1     Sem   14
#[Out]# 27      1     Sem   14
#[Out]# 28      1     Sem   14
#[Out]# 29      1     Sem   14
#[Out]# ...   ...     ...  ...
#[Out]# 9267  190  Kostas    9
#[Out]# 9268  190  Kostas    9
#[Out]# 9269  190  Kostas    9
#[Out]# 9270  190  Kostas    9
#[Out]# 9271  190  Kostas    9
#[Out]# 9272  190  Kostas    9
#[Out]# 9273  190  Kostas    9
#[Out]# 9274  190  Kostas    9
#[Out]# 9275  190  Kostas    9
#[Out]# 9276  190  Kostas    9
#[Out]# 9277  190  Kostas    9
#[Out]# 9278  190  Kostas    9
#[Out]# 9279  190  Kostas    9
#[Out]# 9280  190  Kostas    9
#[Out]# 9281  190  Kostas    9
#[Out]# 9282  190  Kostas    9
#[Out]# 9283  190  Kostas    9
#[Out]# 9284  190  Kostas    9
#[Out]# 9285  190  Kostas    9
#[Out]# 9286  190  Kostas    9
#[Out]# 9287  190  Kostas   18
#[Out]# 9288  190  Kostas   18
#[Out]# 9289  190  Kostas   18
#[Out]# 9290  190  Kostas   18
#[Out]# 9291  190  Kostas   18
#[Out]# 9292  190  Kostas   18
#[Out]# 9293  190  Kostas   18
#[Out]# 9294  190  Kostas   18
#[Out]# 9295  190  Kostas   18
#[Out]# 9296  190  Kostas   18
#[Out]# 
#[Out]# [9297 rows x 3 columns]
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM customer c, purchase ps, product p1, product p2
    WHERE c.cID = ps.cID AND ps.pID = p1.pID AND ps.pID = p2.pID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, ps.pID
    FROM customer c, purchase ps, product p1, product p2
    WHERE c.cID = ps.cID AND ps.pID = p1.pID AND ps.pID = p2.pID
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID   cName  pID
#[Out]# 0      0    Noah   10
#[Out]# 1      1     Sem   14
#[Out]# 2      1     Sem   16
#[Out]# 3      1     Sem    9
#[Out]# 4      1     Sem   25
#[Out]# 5      1     Sem   26
#[Out]# 6      1     Sem   11
#[Out]# 7      1     Sem   27
#[Out]# 8      2   Lucas   20
#[Out]# 9      2   Lucas    9
#[Out]# 10     2   Lucas    4
#[Out]# 11     2   Lucas   13
#[Out]# 12     2   Lucas   22
#[Out]# 13     3    Finn   14
#[Out]# 14     3    Finn   26
#[Out]# 15     3    Finn    9
#[Out]# 16     4    Daan    8
#[Out]# 17     4    Daan   27
#[Out]# 18     4    Daan   12
#[Out]# 19     4    Daan    6
#[Out]# 20     4    Daan   13
#[Out]# 21     4    Daan   26
#[Out]# 22     5    Levi   14
#[Out]# 23     5    Levi   28
#[Out]# 24     5    Levi    6
#[Out]# 25     5    Levi   22
#[Out]# 26     5    Levi   16
#[Out]# 27     5    Levi   19
#[Out]# 28     7    Bram   19
#[Out]# 29     7    Bram    2
#[Out]# ..   ...     ...  ...
#[Out]# 479  190  Kostas   28
#[Out]# 480  190  Kostas   27
#[Out]# 481  190  Kostas    5
#[Out]# 482  190  Kostas   28
#[Out]# 483  190  Kostas    7
#[Out]# 484  190  Kostas    0
#[Out]# 485  190  Kostas   11
#[Out]# 486  190  Kostas    6
#[Out]# 487  190  Kostas   19
#[Out]# 488  190  Kostas   17
#[Out]# 489  190  Kostas    9
#[Out]# 490  190  Kostas   11
#[Out]# 491  190  Kostas   22
#[Out]# 492  190  Kostas   17
#[Out]# 493  190  Kostas   20
#[Out]# 494  190  Kostas   11
#[Out]# 495  190  Kostas   21
#[Out]# 496  190  Kostas   23
#[Out]# 497  190  Kostas   23
#[Out]# 498  190  Kostas    8
#[Out]# 499  190  Kostas    0
#[Out]# 500  190  Kostas    8
#[Out]# 501  190  Kostas   11
#[Out]# 502  190  Kostas   15
#[Out]# 503  190  Kostas    2
#[Out]# 504  190  Kostas   17
#[Out]# 505  190  Kostas    5
#[Out]# 506  190  Kostas   19
#[Out]# 507  190  Kostas    9
#[Out]# 508  190  Kostas   18
#[Out]# 
#[Out]# [509 rows x 3 columns]
query2 = '''
    SELECT c.cID, c.cName, ps.pID
    FROM customer c, purchase p1, purchase p2
    WHERE c.cID = p1.cID, c.cID = p2.cID, p1.date = p2.date
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, ps.pID
    FROM customer c, purchase p1, purchase p2
    WHERE c.cID = p1.cID AND c.cID = p2.cID AND p1.date = p2.date
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, p1.pID
    FROM customer c, purchase p1, purchase p2
    WHERE c.cID = p1.cID AND c.cID = p2.cID AND p1.date = p2.date
'''

pd.read_sql_query(query2, conn)
#[Out]#       cID   cName  pID
#[Out]# 0       0    Noah   10
#[Out]# 1       1     Sem   14
#[Out]# 2       1     Sem   14
#[Out]# 3       1     Sem   14
#[Out]# 4       1     Sem   14
#[Out]# 5       1     Sem   14
#[Out]# 6       1     Sem   16
#[Out]# 7       1     Sem   16
#[Out]# 8       1     Sem   16
#[Out]# 9       1     Sem   16
#[Out]# 10      1     Sem   16
#[Out]# 11      1     Sem    9
#[Out]# 12      1     Sem    9
#[Out]# 13      1     Sem    9
#[Out]# 14      1     Sem    9
#[Out]# 15      1     Sem    9
#[Out]# 16      1     Sem   25
#[Out]# 17      1     Sem   25
#[Out]# 18      1     Sem   25
#[Out]# 19      1     Sem   25
#[Out]# 20      1     Sem   25
#[Out]# 21      1     Sem   26
#[Out]# 22      1     Sem   26
#[Out]# 23      1     Sem   26
#[Out]# 24      1     Sem   26
#[Out]# 25      1     Sem   26
#[Out]# 26      1     Sem   11
#[Out]# 27      1     Sem   11
#[Out]# 28      1     Sem   27
#[Out]# 29      1     Sem   27
#[Out]# ...   ...     ...  ...
#[Out]# 1413  190  Kostas   15
#[Out]# 1414  190  Kostas    2
#[Out]# 1415  190  Kostas    2
#[Out]# 1416  190  Kostas    2
#[Out]# 1417  190  Kostas    2
#[Out]# 1418  190  Kostas    2
#[Out]# 1419  190  Kostas    2
#[Out]# 1420  190  Kostas    2
#[Out]# 1421  190  Kostas    2
#[Out]# 1422  190  Kostas   17
#[Out]# 1423  190  Kostas   17
#[Out]# 1424  190  Kostas   17
#[Out]# 1425  190  Kostas   17
#[Out]# 1426  190  Kostas   17
#[Out]# 1427  190  Kostas   17
#[Out]# 1428  190  Kostas   17
#[Out]# 1429  190  Kostas    5
#[Out]# 1430  190  Kostas    5
#[Out]# 1431  190  Kostas   19
#[Out]# 1432  190  Kostas   19
#[Out]# 1433  190  Kostas   19
#[Out]# 1434  190  Kostas   19
#[Out]# 1435  190  Kostas   19
#[Out]# 1436  190  Kostas   19
#[Out]# 1437  190  Kostas    9
#[Out]# 1438  190  Kostas    9
#[Out]# 1439  190  Kostas    9
#[Out]# 1440  190  Kostas    9
#[Out]# 1441  190  Kostas   18
#[Out]# 1442  190  Kostas   18
#[Out]# 
#[Out]# [1443 rows x 3 columns]
query2 = '''
    SELECT c.cID, c.cName, p1.pID
    FROM customer c, purchase p1, purchase p2, product pr1, product pr2
    WHERE c.cID = p1.cID AND c.cID = p2.cID AND p1.date = p2.date AND p1.pID = pr1.pID AND pr1.pName = "Coffee"
    AND p2.pID = pr2.pID AND pr2.pName = "Onions"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID
#[Out]# 0  124   Sofie   21
#[Out]# 1  190  Kostas   21
query2 = '''
    SELECT c.cID, c.cName, p1.pID, p2.pID
    FROM customer c, purchase p1, purchase p2, product pr1, product pr2
    WHERE c.cID = p1.cID AND c.cID = p2.cID AND p1.date = p2.date AND p1.pID = pr1.pID AND pr1.pName = "Coffee"
    AND p2.pID = pr2.pID AND pr2.pName = "Onions"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID  pID
#[Out]# 0  124   Sofie   21    4
#[Out]# 1  190  Kostas   21    4
query2 = '''
    SELECT DISTINCT c.cID, c.cName
    FROM customer c, purchase p1, purchase p2, product pr1, product pr2
    WHERE c.cID = p1.cID AND c.cID = p2.cID AND p1.date = p2.date AND p1.pID = pr1.pID AND pr1.pName = "Coffee"
    AND p2.pID = pr2.pID AND pr2.pName = "Onions"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    SELECT DISTINCT c.cID, c.cName
    FROM customer c, purchase p1, purchase p2, product pr1, product pr2
    WHERE c.cID = p1.cID AND c.cID = p2.cID AND p1.date = p2.date AND p1.pID = pr1.pID AND pr1.pName = "Coffee"
    AND p2.pID = pr2.pID AND pr2.pName = "Onions"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT p.cID
    FROM purchase p
    GROUP BY p.CID
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
    GROUP BY p.CID
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  sID
#[Out]# 0      0    3
#[Out]# 1      1   36
#[Out]# 2      2   47
#[Out]# 3      3   29
#[Out]# 4      4   44
#[Out]# 5      5   17
#[Out]# 6      7   42
#[Out]# 7      8   51
#[Out]# 8     10   34
#[Out]# 9     11    0
#[Out]# 10    13    8
#[Out]# 11    15   25
#[Out]# 12    16   26
#[Out]# 13    17   44
#[Out]# 14    18    6
#[Out]# 15    19   15
#[Out]# 16    20   40
#[Out]# 17    21   47
#[Out]# 18    22   27
#[Out]# 19    24   59
#[Out]# 20    25   12
#[Out]# 21    26   21
#[Out]# 22    27   34
#[Out]# 23    28   43
#[Out]# 24    29   29
#[Out]# 25    30   57
#[Out]# 26    31   39
#[Out]# 27    33   29
#[Out]# 28    34   26
#[Out]# 29    35   34
#[Out]# ..   ...  ...
#[Out]# 102  147   33
#[Out]# 103  149   54
#[Out]# 104  151   14
#[Out]# 105  152   43
#[Out]# 106  157   36
#[Out]# 107  159   17
#[Out]# 108  161   36
#[Out]# 109  162   41
#[Out]# 110  163    6
#[Out]# 111  165   46
#[Out]# 112  167   17
#[Out]# 113  168   28
#[Out]# 114  169   52
#[Out]# 115  170   40
#[Out]# 116  171   44
#[Out]# 117  172    0
#[Out]# 118  175   16
#[Out]# 119  176    6
#[Out]# 120  177   51
#[Out]# 121  178   39
#[Out]# 122  179   45
#[Out]# 123  180   56
#[Out]# 124  181   27
#[Out]# 125  182    4
#[Out]# 126  184    0
#[Out]# 127  185   62
#[Out]# 128  186   62
#[Out]# 129  188   62
#[Out]# 130  189   20
#[Out]# 131  190   63
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  sID
#[Out]# 0      0    3
#[Out]# 1      1   23
#[Out]# 2      1    3
#[Out]# 3      1   17
#[Out]# 4      1   32
#[Out]# 5      1   16
#[Out]# 6      1   46
#[Out]# 7      1   36
#[Out]# 8      2   12
#[Out]# 9      2   39
#[Out]# 10     2   13
#[Out]# 11     2   51
#[Out]# 12     2   47
#[Out]# 13     3   44
#[Out]# 14     3   30
#[Out]# 15     3   29
#[Out]# 16     4   17
#[Out]# 17     4   10
#[Out]# 18     4   53
#[Out]# 19     4   21
#[Out]# 20     4    7
#[Out]# 21     4   44
#[Out]# 22     5    4
#[Out]# 23     5   36
#[Out]# 24     5   55
#[Out]# 25     5   51
#[Out]# 26     5    6
#[Out]# 27     5   17
#[Out]# 28     7    3
#[Out]# 29     7   12
#[Out]# ..   ...  ...
#[Out]# 479  190   34
#[Out]# 480  190   35
#[Out]# 481  190   36
#[Out]# 482  190   37
#[Out]# 483  190   38
#[Out]# 484  190   39
#[Out]# 485  190   40
#[Out]# 486  190   41
#[Out]# 487  190   42
#[Out]# 488  190   43
#[Out]# 489  190   44
#[Out]# 490  190   45
#[Out]# 491  190   46
#[Out]# 492  190   47
#[Out]# 493  190   48
#[Out]# 494  190   49
#[Out]# 495  190   50
#[Out]# 496  190   51
#[Out]# 497  190   52
#[Out]# 498  190   53
#[Out]# 499  190   54
#[Out]# 500  190   55
#[Out]# 501  190   56
#[Out]# 502  190   57
#[Out]# 503  190   58
#[Out]# 504  190   59
#[Out]# 505  190   60
#[Out]# 506  190   61
#[Out]# 507  190   62
#[Out]# 508  190   63
#[Out]# 
#[Out]# [509 rows x 2 columns]
query3 = '''
    SELECT p.cID, COUNT(p.sID)
    FROM purchase p
    GROUP BY p.CID
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  COUNT(p.sID)
#[Out]# 0      0             1
#[Out]# 1      1             7
#[Out]# 2      2             5
#[Out]# 3      3             3
#[Out]# 4      4             6
#[Out]# 5      5             6
#[Out]# 6      7             6
#[Out]# 7      8             2
#[Out]# 8     10             1
#[Out]# 9     11             1
#[Out]# 10    13             9
#[Out]# 11    15             1
#[Out]# 12    16            10
#[Out]# 13    17             2
#[Out]# 14    18             3
#[Out]# 15    19             4
#[Out]# 16    20             3
#[Out]# 17    21             3
#[Out]# 18    22             2
#[Out]# 19    24             9
#[Out]# 20    25             1
#[Out]# 21    26             1
#[Out]# 22    27             6
#[Out]# 23    28             1
#[Out]# 24    29             2
#[Out]# 25    30             3
#[Out]# 26    31             2
#[Out]# 27    33             9
#[Out]# 28    34             1
#[Out]# 29    35             2
#[Out]# ..   ...           ...
#[Out]# 102  147             3
#[Out]# 103  149             2
#[Out]# 104  151             2
#[Out]# 105  152             3
#[Out]# 106  157             3
#[Out]# 107  159             2
#[Out]# 108  161            11
#[Out]# 109  162             8
#[Out]# 110  163             4
#[Out]# 111  165             6
#[Out]# 112  167            10
#[Out]# 113  168             1
#[Out]# 114  169            11
#[Out]# 115  170             3
#[Out]# 116  171             2
#[Out]# 117  172             2
#[Out]# 118  175             2
#[Out]# 119  176             6
#[Out]# 120  177             5
#[Out]# 121  178             2
#[Out]# 122  179             6
#[Out]# 123  180             3
#[Out]# 124  181             3
#[Out]# 125  182             4
#[Out]# 126  184             1
#[Out]# 127  185             1
#[Out]# 128  186             1
#[Out]# 129  188             2
#[Out]# 130  189             2
#[Out]# 131  190            64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    SELECT p.cID, COUNT(p.sID)
    FROM purchase p
    WHERE COUNT(p.sID)>64
    GROUP BY p.CID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, COUNT(p.sID)
    FROM purchase p
    HAVING COUNT(p.sID)>64
    GROUP BY p.CID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, COUNT(p.sID)
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT(p.sID)>64
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, COUNT(p.sID)]
#[Out]# Index: []
query3 = '''
    SELECT p.cID, COUNT(p.sID)
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT(p.sID)=64
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  COUNT(p.sID)
#[Out]# 0  190            64
query3 = '''
    SELECT p.cID, COUNT(p.sID)
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID)=64
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  COUNT(p.sID)
#[Out]# 0  190            64
query3 = '''
    SELECT p.cID, COUNT(p.sID)
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID)= 64
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  COUNT(p.sID)
#[Out]# 0  190            64
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID)= 64
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  sID
#[Out]# 0  190   63
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    WHERE COUNT(DISTINCT p.sID)= 64
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    HAVING COUNT(DISTINCT p.sID)= 64
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    WHERE COUNT(DISTINCT p.sID)= 64
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID)= 64
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  sID
#[Out]# 0  190   63
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING p.sID in (SELECT p.sID
    FROM purchase p)
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  sID
#[Out]# 0      0    3
#[Out]# 1      1   36
#[Out]# 2      2   47
#[Out]# 3      3   29
#[Out]# 4      4   44
#[Out]# 5      5   17
#[Out]# 6      7   42
#[Out]# 7      8   51
#[Out]# 8     10   34
#[Out]# 9     11    0
#[Out]# 10    13    8
#[Out]# 11    15   25
#[Out]# 12    16   26
#[Out]# 13    17   44
#[Out]# 14    18    6
#[Out]# 15    19   15
#[Out]# 16    20   40
#[Out]# 17    21   47
#[Out]# 18    22   27
#[Out]# 19    24   59
#[Out]# 20    25   12
#[Out]# 21    26   21
#[Out]# 22    27   34
#[Out]# 23    28   43
#[Out]# 24    29   29
#[Out]# 25    30   57
#[Out]# 26    31   39
#[Out]# 27    33   29
#[Out]# 28    34   26
#[Out]# 29    35   34
#[Out]# ..   ...  ...
#[Out]# 102  147   33
#[Out]# 103  149   54
#[Out]# 104  151   14
#[Out]# 105  152   43
#[Out]# 106  157   36
#[Out]# 107  159   17
#[Out]# 108  161   36
#[Out]# 109  162   41
#[Out]# 110  163    6
#[Out]# 111  165   46
#[Out]# 112  167   17
#[Out]# 113  168   28
#[Out]# 114  169   52
#[Out]# 115  170   40
#[Out]# 116  171   44
#[Out]# 117  172    0
#[Out]# 118  175   16
#[Out]# 119  176    6
#[Out]# 120  177   51
#[Out]# 121  178   39
#[Out]# 122  179   45
#[Out]# 123  180   56
#[Out]# 124  181   27
#[Out]# 125  182    4
#[Out]# 126  184    0
#[Out]# 127  185   62
#[Out]# 128  186   62
#[Out]# 129  188   62
#[Out]# 130  189   20
#[Out]# 131  190   63
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING p.sID not in (SELECT p.sID
    FROM purchase p)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, sID]
#[Out]# Index: []
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING p.sID = (SELECT p.sID
    FROM purchase p)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  sID
#[Out]# 0    0    3
#[Out]# 1   41    3
#[Out]# 2   95    3
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT(p.sID) = COUNT(SELECT p.sID
    FROM purchase p)
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT( DISTINCT p.sID) = COUNT(p.sID
    FROM purchase p)
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT( DISTINCT p.sID) = SELECT COUNT(p.sID FROM purchase p)
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT( DISTINCT p.sID) = SELECT COUNT(DISTINCT p.sID) FROM purchase p
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT( DISTINCT p.sID) =  COUNT(DISTINCT p.sID) FROM purchase p
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT( DISTINCT p.sID) =  COUNT(SELECT DISTINCT p.sID) FROM purchase p
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT( DISTINCT p.sID) =  SELECT COUNT(DISTINCT p.sID) FROM purchase p
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT( DISTINCT p.sID) =  SELECT COUNT(DISTINCT p.sID)
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT( DISTINCT p.sID) = COUNT(DISTINCT p.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  sID
#[Out]# 0      0    3
#[Out]# 1      1   36
#[Out]# 2      2   47
#[Out]# 3      3   29
#[Out]# 4      4   44
#[Out]# 5      5   17
#[Out]# 6      7   42
#[Out]# 7      8   51
#[Out]# 8     10   34
#[Out]# 9     11    0
#[Out]# 10    13    8
#[Out]# 11    15   25
#[Out]# 12    16   26
#[Out]# 13    17   44
#[Out]# 14    18    6
#[Out]# 15    19   15
#[Out]# 16    20   40
#[Out]# 17    21   47
#[Out]# 18    22   27
#[Out]# 19    24   59
#[Out]# 20    25   12
#[Out]# 21    26   21
#[Out]# 22    27   34
#[Out]# 23    28   43
#[Out]# 24    29   29
#[Out]# 25    30   57
#[Out]# 26    31   39
#[Out]# 27    33   29
#[Out]# 28    34   26
#[Out]# 29    35   34
#[Out]# ..   ...  ...
#[Out]# 102  147   33
#[Out]# 103  149   54
#[Out]# 104  151   14
#[Out]# 105  152   43
#[Out]# 106  157   36
#[Out]# 107  159   17
#[Out]# 108  161   36
#[Out]# 109  162   41
#[Out]# 110  163    6
#[Out]# 111  165   46
#[Out]# 112  167   17
#[Out]# 113  168   28
#[Out]# 114  169   52
#[Out]# 115  170   40
#[Out]# 116  171   44
#[Out]# 117  172    0
#[Out]# 118  175   16
#[Out]# 119  176    6
#[Out]# 120  177   51
#[Out]# 121  178   39
#[Out]# 122  179   45
#[Out]# 123  180   56
#[Out]# 124  181   27
#[Out]# 125  182    4
#[Out]# 126  184    0
#[Out]# 127  185   62
#[Out]# 128  186   62
#[Out]# 129  188   62
#[Out]# 130  189   20
#[Out]# 131  190   63
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID) = SELECT COUNT(DISTINCT p.sID) FROM purchase p
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
   
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID) = SELECT COUNT(DISTINCT pa.sID) FROM purchase pa
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID) = SELECT COUNT(DISTINCT p.sID) FROM purchase p
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID) = SELECT COUNT(DISTINCT s.sID) FROM store s
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID) = SELECT COUNT(DISTINCTsID) FROM store s
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID) = SELECT COUNT(DISTINCT sID) FROM purchase
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.cID, p.sID
    FROM purchase p
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID) = (SELECT COUNT(DISTINCT sID) FROM purchase)
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  sID
#[Out]# 0  190   63
query3 = '''
    SELECT p.cID
    FROM purchase p
    GROUP BY p.CID 
    HAVING COUNT(DISTINCT p.sID) = (SELECT COUNT(DISTINCT sID) FROM purchase)
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT s.sName
    FROM store s
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16         Lidl
#[Out]# 17    Hoogvliet
#[Out]# 18       Sligro
#[Out]# 19         Coop
#[Out]# 20        Jumbo
#[Out]# 21         Coop
#[Out]# 22         Lidl
#[Out]# 23         Dirk
#[Out]# 24  Albert Hein
#[Out]# 25  Albert Hein
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28    Hoogvliet
#[Out]# 29       Sligro
#[Out]# ..          ...
#[Out]# 34         Coop
#[Out]# 35         Lidl
#[Out]# 36         Lidl
#[Out]# 37        Jumbo
#[Out]# 38    Hoogvliet
#[Out]# 39       Sligro
#[Out]# 40    Hoogvliet
#[Out]# 41  Albert Hein
#[Out]# 42       Sligro
#[Out]# 43         Coop
#[Out]# 44  Albert Hein
#[Out]# 45         Coop
#[Out]# 46         Lidl
#[Out]# 47         Coop
#[Out]# 48    Hoogvliet
#[Out]# 49    Hoogvliet
#[Out]# 50       Sligro
#[Out]# 51         Coop
#[Out]# 52         Lidl
#[Out]# 53         Coop
#[Out]# 54         Dirk
#[Out]# 55         Coop
#[Out]# 56        Jumbo
#[Out]# 57         Dirk
#[Out]# 58         Dirk
#[Out]# 59        Jumbo
#[Out]# 60         Lidl
#[Out]# 61         Lidl
#[Out]# 62        Jumbo
#[Out]# 63        Jumbo
#[Out]# 
#[Out]# [64 rows x 1 columns]
query4 = '''
    SELECT s.sName
    FROM store s
    EXCEPT 
    SELECT DISTINCT s.sName FROM store s
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT s.sName
    FROM store s
    NOT IN
    SELECT DISTINCT s.sName FROM store s
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store s
    NOT IN
    (SELECT DISTINCT s.sName FROM store s)
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store s
    EXCEPT 
    SELECT DISTINCT s.sName FROM store s
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT s.sName
    FROM store s
    WHERE s.sName not in (DISTINCT s.sName FROM store s)
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store s
    
    WHERE s.sName not in (s.sName FROM store s)
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store s
    
    WHERE s.sName not in (sName FROM store s)
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store s
    
    WHERE s.sName not in (SELECT sName FROM store s)
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT s.sName
    FROM store s
    
    WHERE s.sName not in (SELECT DISTINCT sName FROM store s)
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT s.sName
    FROM store s
    
    WHERE s.sName in (SELECT DISTINCT sName FROM store s)
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16         Lidl
#[Out]# 17    Hoogvliet
#[Out]# 18       Sligro
#[Out]# 19         Coop
#[Out]# 20        Jumbo
#[Out]# 21         Coop
#[Out]# 22         Lidl
#[Out]# 23         Dirk
#[Out]# 24  Albert Hein
#[Out]# 25  Albert Hein
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28    Hoogvliet
#[Out]# 29       Sligro
#[Out]# ..          ...
#[Out]# 34         Coop
#[Out]# 35         Lidl
#[Out]# 36         Lidl
#[Out]# 37        Jumbo
#[Out]# 38    Hoogvliet
#[Out]# 39       Sligro
#[Out]# 40    Hoogvliet
#[Out]# 41  Albert Hein
#[Out]# 42       Sligro
#[Out]# 43         Coop
#[Out]# 44  Albert Hein
#[Out]# 45         Coop
#[Out]# 46         Lidl
#[Out]# 47         Coop
#[Out]# 48    Hoogvliet
#[Out]# 49    Hoogvliet
#[Out]# 50       Sligro
#[Out]# 51         Coop
#[Out]# 52         Lidl
#[Out]# 53         Coop
#[Out]# 54         Dirk
#[Out]# 55         Coop
#[Out]# 56        Jumbo
#[Out]# 57         Dirk
#[Out]# 58         Dirk
#[Out]# 59        Jumbo
#[Out]# 60         Lidl
#[Out]# 61         Lidl
#[Out]# 62        Jumbo
#[Out]# 63        Jumbo
#[Out]# 
#[Out]# [64 rows x 1 columns]
query4 = '''
    SELECT s.sName
    FROM store s
    EXCEPT
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store s
    EXCEPT
    SELECT DISTINCT s.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store s
    EXCEPT
    SELECT DISTINCT s.sName FROM store s
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT ALL s.sName
    FROM store s
    EXCEPT
    SELECT DISTINCT s.sName FROM store s
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT sName
    FROM store s
    EXCEPT
    SELECT DISTINCT sName FROM store s
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query3 = '''
    SELECT cID
    FROM purchase
    GROUP BY CID 
    HAVING COUNT(DISTINCT sID) = (SELECT COUNT(DISTINCT sID) FROM purchase)
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT sName
    FROM store
    EXCEPT
    SELECT DISTINCT sName FROM store
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT sName, sID
    FROM store
    EXCEPT
    SELECT DISTINCT sName FROM store
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName, sID
    FROM store
    EXCEPT
    SELECT DISTINCT sName FROM store
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName, sID
    FROM store
    EXCEPT
    SELECT DISTINCT sName, sID FROM store
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName, sID]
#[Out]# Index: []
query4 = '''
    SELECT sName, sID
    FROM store
    EXCEPT
    SELECT DISTINCT sName FROM store
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName
    FROM store
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16         Lidl
#[Out]# 17    Hoogvliet
#[Out]# 18       Sligro
#[Out]# 19         Coop
#[Out]# 20        Jumbo
#[Out]# 21         Coop
#[Out]# 22         Lidl
#[Out]# 23         Dirk
#[Out]# 24  Albert Hein
#[Out]# 25  Albert Hein
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28    Hoogvliet
#[Out]# 29       Sligro
#[Out]# ..          ...
#[Out]# 34         Coop
#[Out]# 35         Lidl
#[Out]# 36         Lidl
#[Out]# 37        Jumbo
#[Out]# 38    Hoogvliet
#[Out]# 39       Sligro
#[Out]# 40    Hoogvliet
#[Out]# 41  Albert Hein
#[Out]# 42       Sligro
#[Out]# 43         Coop
#[Out]# 44  Albert Hein
#[Out]# 45         Coop
#[Out]# 46         Lidl
#[Out]# 47         Coop
#[Out]# 48    Hoogvliet
#[Out]# 49    Hoogvliet
#[Out]# 50       Sligro
#[Out]# 51         Coop
#[Out]# 52         Lidl
#[Out]# 53         Coop
#[Out]# 54         Dirk
#[Out]# 55         Coop
#[Out]# 56        Jumbo
#[Out]# 57         Dirk
#[Out]# 58         Dirk
#[Out]# 59        Jumbo
#[Out]# 60         Lidl
#[Out]# 61         Lidl
#[Out]# 62        Jumbo
#[Out]# 63        Jumbo
#[Out]# 
#[Out]# [64 rows x 1 columns]
query4 = '''
    SELECT sName
    FROM store
    EXCEPT
    SELECT DISTINCT sName FROM store
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT sName
    FROM store
    GROUP BY sName
    EXCEPT
    SELECT DISTINCT sName FROM store
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE AVG(p.quantity) > 4
    EXCEPT
    SELECT DISTINCT sName FROM store
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID AND AVG(p.quantity) > 4
    EXCEPT
    SELECT DISTINCT sName FROM store
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID AND AVG(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName
    FROM store s, purchase p
    GROUP BY sID
    WHERE s.sID = p.sID AND AVG(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sID
    HAVING AVG(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2        Sligro
#[Out]# 3     Hoogvliet
#[Out]# 4        Sligro
#[Out]# 5        Sligro
#[Out]# 6   Albert Hein
#[Out]# 7   Albert Hein
#[Out]# 8         Jumbo
#[Out]# 9   Albert Hein
#[Out]# 10         Lidl
#[Out]# 11         Lidl
#[Out]# 12    Hoogvliet
#[Out]# 13         Coop
#[Out]# 14        Jumbo
#[Out]# 15         Lidl
#[Out]# 16         Dirk
#[Out]# 17  Albert Hein
#[Out]# 18  Albert Hein
#[Out]# 19    Hoogvliet
#[Out]# 20       Sligro
#[Out]# 21    Hoogvliet
#[Out]# 22       Sligro
#[Out]# 23         Dirk
#[Out]# 24         Coop
#[Out]# 25         Dirk
#[Out]# 26         Coop
#[Out]# 27         Lidl
#[Out]# 28         Lidl
#[Out]# 29    Hoogvliet
#[Out]# 30       Sligro
#[Out]# 31    Hoogvliet
#[Out]# 32  Albert Hein
#[Out]# 33       Sligro
#[Out]# 34         Coop
#[Out]# 35  Albert Hein
#[Out]# 36         Lidl
#[Out]# 37         Coop
#[Out]# 38    Hoogvliet
#[Out]# 39         Coop
#[Out]# 40         Lidl
#[Out]# 41         Dirk
#[Out]# 42         Coop
#[Out]# 43         Dirk
#[Out]# 44         Dirk
#[Out]# 45         Lidl
#[Out]# 46         Lidl
query4 = '''
    SELECT sName, AVG(p.quantity)
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName  AVG(p.quantity)
#[Out]# 0          Coop         4.777778
#[Out]# 1     Hoogvliet         4.750000
#[Out]# 2        Sligro         4.076923
#[Out]# 3     Hoogvliet         6.090909
#[Out]# 4        Sligro         4.875000
#[Out]# 5        Sligro         4.444444
#[Out]# 6   Albert Hein         5.600000
#[Out]# 7   Albert Hein         5.444444
#[Out]# 8         Jumbo         6.400000
#[Out]# 9   Albert Hein         4.272727
#[Out]# 10         Lidl         5.000000
#[Out]# 11         Lidl         4.250000
#[Out]# 12    Hoogvliet         5.538462
#[Out]# 13         Coop         5.571429
#[Out]# 14        Jumbo         5.428571
#[Out]# 15         Lidl         5.500000
#[Out]# 16         Dirk         4.400000
#[Out]# 17  Albert Hein         5.400000
#[Out]# 18  Albert Hein         5.700000
#[Out]# 19    Hoogvliet         6.500000
#[Out]# 20       Sligro         4.750000
#[Out]# 21    Hoogvliet         5.000000
#[Out]# 22       Sligro         6.000000
#[Out]# 23         Dirk         4.900000
#[Out]# 24         Coop         7.166667
#[Out]# 25         Dirk         6.166667
#[Out]# 26         Coop         5.400000
#[Out]# 27         Lidl         4.428571
#[Out]# 28         Lidl         4.142857
#[Out]# 29    Hoogvliet         5.400000
#[Out]# 30       Sligro         4.571429
#[Out]# 31    Hoogvliet         4.300000
#[Out]# 32  Albert Hein         4.833333
#[Out]# 33       Sligro         5.900000
#[Out]# 34         Coop         5.769231
#[Out]# 35  Albert Hein         4.300000
#[Out]# 36         Lidl         5.600000
#[Out]# 37         Coop         4.636364
#[Out]# 38    Hoogvliet         7.500000
#[Out]# 39         Coop         4.100000
#[Out]# 40         Lidl         5.750000
#[Out]# 41         Dirk         4.636364
#[Out]# 42         Coop         5.454545
#[Out]# 43         Dirk         4.666667
#[Out]# 44         Dirk         9.666667
#[Out]# 45         Lidl         6.000000
#[Out]# 46         Lidl         5.000000
query4 = '''
    SELECT DISTINCT sName, AVG(p.quantity)
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName  AVG(p.quantity)
#[Out]# 0          Coop         4.777778
#[Out]# 1     Hoogvliet         4.750000
#[Out]# 2        Sligro         4.076923
#[Out]# 3     Hoogvliet         6.090909
#[Out]# 4        Sligro         4.875000
#[Out]# 5        Sligro         4.444444
#[Out]# 6   Albert Hein         5.600000
#[Out]# 7   Albert Hein         5.444444
#[Out]# 8         Jumbo         6.400000
#[Out]# 9   Albert Hein         4.272727
#[Out]# 10         Lidl         5.000000
#[Out]# 11         Lidl         4.250000
#[Out]# 12    Hoogvliet         5.538462
#[Out]# 13         Coop         5.571429
#[Out]# 14        Jumbo         5.428571
#[Out]# 15         Lidl         5.500000
#[Out]# 16         Dirk         4.400000
#[Out]# 17  Albert Hein         5.400000
#[Out]# 18  Albert Hein         5.700000
#[Out]# 19    Hoogvliet         6.500000
#[Out]# 20       Sligro         4.750000
#[Out]# 21    Hoogvliet         5.000000
#[Out]# 22       Sligro         6.000000
#[Out]# 23         Dirk         4.900000
#[Out]# 24         Coop         7.166667
#[Out]# 25         Dirk         6.166667
#[Out]# 26         Coop         5.400000
#[Out]# 27         Lidl         4.428571
#[Out]# 28         Lidl         4.142857
#[Out]# 29    Hoogvliet         5.400000
#[Out]# 30       Sligro         4.571429
#[Out]# 31    Hoogvliet         4.300000
#[Out]# 32  Albert Hein         4.833333
#[Out]# 33       Sligro         5.900000
#[Out]# 34         Coop         5.769231
#[Out]# 35  Albert Hein         4.300000
#[Out]# 36         Lidl         5.600000
#[Out]# 37         Coop         4.636364
#[Out]# 38    Hoogvliet         7.500000
#[Out]# 39         Coop         4.100000
#[Out]# 40         Lidl         5.750000
#[Out]# 41         Dirk         4.636364
#[Out]# 42         Coop         5.454545
#[Out]# 43         Dirk         4.666667
#[Out]# 44         Dirk         9.666667
#[Out]# 45         Lidl         6.000000
query4 = '''
    SELECT DISTINCT sName, AVG(p.quantity)
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY DISTINCT p.sID
    HAVING AVG(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName, AVG(p.quantity)
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY DISTINCT p.sID
    HAVING AVG(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT DISTINCT sName, AVG(p.quantity)
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName  AVG(p.quantity)
#[Out]# 0          Coop         4.777778
#[Out]# 1     Hoogvliet         4.750000
#[Out]# 2        Sligro         4.076923
#[Out]# 3     Hoogvliet         6.090909
#[Out]# 4        Sligro         4.875000
#[Out]# 5        Sligro         4.444444
#[Out]# 6   Albert Hein         5.600000
#[Out]# 7   Albert Hein         5.444444
#[Out]# 8         Jumbo         6.400000
#[Out]# 9   Albert Hein         4.272727
#[Out]# 10         Lidl         5.000000
#[Out]# 11         Lidl         4.250000
#[Out]# 12    Hoogvliet         5.538462
#[Out]# 13         Coop         5.571429
#[Out]# 14        Jumbo         5.428571
#[Out]# 15         Lidl         5.500000
#[Out]# 16         Dirk         4.400000
#[Out]# 17  Albert Hein         5.400000
#[Out]# 18  Albert Hein         5.700000
#[Out]# 19    Hoogvliet         6.500000
#[Out]# 20       Sligro         4.750000
#[Out]# 21    Hoogvliet         5.000000
#[Out]# 22       Sligro         6.000000
#[Out]# 23         Dirk         4.900000
#[Out]# 24         Coop         7.166667
#[Out]# 25         Dirk         6.166667
#[Out]# 26         Coop         5.400000
#[Out]# 27         Lidl         4.428571
#[Out]# 28         Lidl         4.142857
#[Out]# 29    Hoogvliet         5.400000
#[Out]# 30       Sligro         4.571429
#[Out]# 31    Hoogvliet         4.300000
#[Out]# 32  Albert Hein         4.833333
#[Out]# 33       Sligro         5.900000
#[Out]# 34         Coop         5.769231
#[Out]# 35  Albert Hein         4.300000
#[Out]# 36         Lidl         5.600000
#[Out]# 37         Coop         4.636364
#[Out]# 38    Hoogvliet         7.500000
#[Out]# 39         Coop         4.100000
#[Out]# 40         Lidl         5.750000
#[Out]# 41         Dirk         4.636364
#[Out]# 42         Coop         5.454545
#[Out]# 43         Dirk         4.666667
#[Out]# 44         Dirk         9.666667
#[Out]# 45         Lidl         6.000000
query4 = '''
    SELECT DISTINCT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
    SELECT DISTINCT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(quantity) > 4 AND COUNT(s.sName) > 1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
    SELECT DISTINCT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(quantity) > 4 AND COUNT(s.sName) = 1
'''

pd.read_sql_query(query4, conn)
#[Out]#   sName
#[Out]# 0  Lidl
query4 = '''
    SELECT DISTINCT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(quantity) > 4 AND COUNT(s.sName) > 1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
    SELECT DISTINCT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(quantity) > 4 AND COUNT(s.sName) >  1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
    SELECT DISTINCT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(quantity) > 4 AND COUNT(s.sName) = 1
'''

pd.read_sql_query(query4, conn)
#[Out]#   sName
#[Out]# 0  Lidl
query4 = '''
    SELECT DISTINCT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING COUNT(s.sName) = 1
'''

pd.read_sql_query(query4, conn)
#[Out]#   sName
#[Out]# 0  Lidl
query4 = '''
    SELECT DISTINCT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING COUNT(s.sName) != 0
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2        Jumbo
#[Out]# 3       Sligro
#[Out]# 4  Albert Hein
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
    SELECT DISTINCT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2        Jumbo
#[Out]# 3       Sligro
#[Out]# 4  Albert Hein
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16         Lidl
#[Out]# 17    Hoogvliet
#[Out]# 18       Sligro
#[Out]# 19         Coop
#[Out]# 20        Jumbo
#[Out]# 21         Coop
#[Out]# 22         Lidl
#[Out]# 23         Dirk
#[Out]# 24  Albert Hein
#[Out]# 25  Albert Hein
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28    Hoogvliet
#[Out]# 29       Sligro
#[Out]# ..          ...
#[Out]# 34         Coop
#[Out]# 35         Lidl
#[Out]# 36         Lidl
#[Out]# 37        Jumbo
#[Out]# 38    Hoogvliet
#[Out]# 39       Sligro
#[Out]# 40    Hoogvliet
#[Out]# 41  Albert Hein
#[Out]# 42       Sligro
#[Out]# 43         Coop
#[Out]# 44  Albert Hein
#[Out]# 45         Coop
#[Out]# 46         Lidl
#[Out]# 47         Coop
#[Out]# 48    Hoogvliet
#[Out]# 49    Hoogvliet
#[Out]# 50       Sligro
#[Out]# 51         Coop
#[Out]# 52         Lidl
#[Out]# 53         Coop
#[Out]# 54         Dirk
#[Out]# 55         Coop
#[Out]# 56        Jumbo
#[Out]# 57         Dirk
#[Out]# 58         Dirk
#[Out]# 59        Jumbo
#[Out]# 60         Lidl
#[Out]# 61         Lidl
#[Out]# 62        Jumbo
#[Out]# 63        Jumbo
#[Out]# 
#[Out]# [64 rows x 1 columns]
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2        Sligro
#[Out]# 3     Hoogvliet
#[Out]# 4        Sligro
#[Out]# 5        Sligro
#[Out]# 6   Albert Hein
#[Out]# 7   Albert Hein
#[Out]# 8         Jumbo
#[Out]# 9   Albert Hein
#[Out]# 10         Lidl
#[Out]# 11         Lidl
#[Out]# 12    Hoogvliet
#[Out]# 13         Coop
#[Out]# 14        Jumbo
#[Out]# 15         Lidl
#[Out]# 16         Dirk
#[Out]# 17  Albert Hein
#[Out]# 18  Albert Hein
#[Out]# 19    Hoogvliet
#[Out]# 20       Sligro
#[Out]# 21    Hoogvliet
#[Out]# 22       Sligro
#[Out]# 23         Dirk
#[Out]# 24         Coop
#[Out]# 25         Dirk
#[Out]# 26         Coop
#[Out]# 27         Lidl
#[Out]# 28         Lidl
#[Out]# 29    Hoogvliet
#[Out]# 30       Sligro
#[Out]# 31    Hoogvliet
#[Out]# 32  Albert Hein
#[Out]# 33       Sligro
#[Out]# 34         Coop
#[Out]# 35  Albert Hein
#[Out]# 36         Lidl
#[Out]# 37         Coop
#[Out]# 38    Hoogvliet
#[Out]# 39         Coop
#[Out]# 40         Lidl
#[Out]# 41         Dirk
#[Out]# 42         Coop
#[Out]# 43         Dirk
#[Out]# 44         Dirk
#[Out]# 45         Lidl
#[Out]# 46         Lidl
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY p.sID
    HAVING AVG(quantity) > 4 AND COUNT(sName)=1
'''

pd.read_sql_query(query4, conn)
#[Out]#   sName
#[Out]# 0  Lidl
#[Out]# 1  Lidl
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(sName)=1
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(sName)>1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID)>1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) = 1
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) = 2
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) = 3
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) = 4
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) <50
'''

pd.read_sql_query(query4, conn)
#[Out]#   sName
#[Out]# 0  Dirk
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) >50
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2    Hoogvliet
#[Out]# 3         Lidl
#[Out]# 4       Sligro
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sName) >50
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2    Hoogvliet
#[Out]# 3         Lidl
#[Out]# 4       Sligro
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sName) <50
'''

pd.read_sql_query(query4, conn)
#[Out]#   sName
#[Out]# 0  Dirk
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(p.sID) > 1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) > 1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(sID) > 1
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) > 1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) > 1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID = p.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4 AND COUNT(s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT pName
    FROM product pr, purchase ps
    WHERE pr.pID = ps.pID
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName
#[Out]# 0               Water
#[Out]# 1              Apples
#[Out]# 2                Rice
#[Out]# 3             Bananas
#[Out]# 4              Donuts
#[Out]# 5               Pasta
#[Out]# 6                Milk
#[Out]# 7               Pizza
#[Out]# 8               Fanta
#[Out]# 9             Bananas
#[Out]# 10             Onions
#[Out]# 11               Eggs
#[Out]# 12                Tea
#[Out]# 13             Apples
#[Out]# 14              Pasta
#[Out]# 15            Bananas
#[Out]# 16   Hot Dog Sausages
#[Out]# 17              Pizza
#[Out]# 18               Beef
#[Out]# 19            Carrots
#[Out]# 20               Eggs
#[Out]# 21              Pasta
#[Out]# 22             Apples
#[Out]# 23            Lasanga
#[Out]# 24            Carrots
#[Out]# 25                Tea
#[Out]# 26               Rice
#[Out]# 27               Coca
#[Out]# 28               Coca
#[Out]# 29           Potatoes
#[Out]# ..                ...
#[Out]# 479           Lasanga
#[Out]# 480             Pizza
#[Out]# 481         Mushrooms
#[Out]# 482           Lasanga
#[Out]# 483          Tomatoes
#[Out]# 484       Cashew Nuts
#[Out]# 485              Milk
#[Out]# 486           Carrots
#[Out]# 487              Coca
#[Out]# 488             Bread
#[Out]# 489           Bananas
#[Out]# 490              Milk
#[Out]# 491               Tea
#[Out]# 492             Bread
#[Out]# 493             Fanta
#[Out]# 494              Milk
#[Out]# 495            Coffee
#[Out]# 496   Spiced Biscuits
#[Out]# 497   Spiced Biscuits
#[Out]# 498  Hot Dog Sausages
#[Out]# 499       Cashew Nuts
#[Out]# 500  Hot Dog Sausages
#[Out]# 501              Milk
#[Out]# 502         Cucumbers
#[Out]# 503          Potatoes
#[Out]# 504             Bread
#[Out]# 505         Mushrooms
#[Out]# 506              Coca
#[Out]# 507           Bananas
#[Out]# 508            Cheese
#[Out]# 
#[Out]# [509 rows x 1 columns]
query5 = '''
    SELECT pName
    FROM product pr, purchase ps
    WHERE pr.pID = ps.pID AND ps.price = (SELECT MAX(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName
#[Out]# 0  Beef
query5 = '''
    SELECT pName, sName
    FROM product pr, purchase ps
    WHERE pr.pID = ps.pID AND ps.price = (SELECT MAX(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pName, sName
    FROM product pr, purchase ps, store s
    WHERE pr.pID = ps.pID AND s.sID = ps.sID AND ps.price = (SELECT MAX(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT DISTINCT pName, sName
    FROM product pr, purchase ps, store s
    WHERE pr.pID = ps.pID AND s.sID = ps.sID AND ps.price = (SELECT MAX(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT DISTINCT pName, sName
    FROM product pr, purchase ps, store s
    WHERE pr.pID = ps.pID AND s.sID = ps.sID AND ps.price = (SELECT MAX(price) FROM purchase)-50
'''

pd.read_sql_query(query5, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName, sName]
#[Out]# Index: []
query5 = '''
    SELECT DISTINCT pName, sName
    FROM product pr, purchase ps, store s
    WHERE pr.pID = ps.pID AND s.sID = ps.sID AND ps.price < (SELECT MAX(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15   Hot Dog Sausages    Hoogvliet
#[Out]# 16              Pizza        Jumbo
#[Out]# 17               Beef         Coop
#[Out]# 18            Carrots         Coop
#[Out]# 19               Eggs       Sligro
#[Out]# 20              Pasta  Albert Hein
#[Out]# 21             Apples    Hoogvliet
#[Out]# 22            Lasanga         Lidl
#[Out]# 23               Rice         Coop
#[Out]# 24               Coca    Hoogvliet
#[Out]# 25               Coca       Sligro
#[Out]# 26           Potatoes         Lidl
#[Out]# 27               Rice  Albert Hein
#[Out]# 28               Beef  Albert Hein
#[Out]# 29            Carrots    Hoogvliet
#[Out]# ..                ...          ...
#[Out]# 155           Bananas         Coop
#[Out]# 156          Tomatoes         Lidl
#[Out]# 157             Pizza       Sligro
#[Out]# 158           Bananas         Dirk
#[Out]# 159             Bread    Hoogvliet
#[Out]# 160           Lasanga       Sligro
#[Out]# 161      Green Pepper         Dirk
#[Out]# 162         Mushrooms         Dirk
#[Out]# 163            Onions    Hoogvliet
#[Out]# 164        Mixed Nuts        Jumbo
#[Out]# 165          Potatoes         Dirk
#[Out]# 166              Milk       Sligro
#[Out]# 167               Tea         Dirk
#[Out]# 168   Spiced Biscuits  Albert Hein
#[Out]# 169            Apples         Lidl
#[Out]# 170               Tea    Hoogvliet
#[Out]# 171            Onions        Jumbo
#[Out]# 172            Onions         Lidl
#[Out]# 173             Water        Jumbo
#[Out]# 174            Salmon        Jumbo
#[Out]# 175           Ketchup        Jumbo
#[Out]# 176          Potatoes       Sligro
#[Out]# 177             Fanta  Albert Hein
#[Out]# 178             Fanta        Jumbo
#[Out]# 179            Donuts         Lidl
#[Out]# 180             Bread       Sligro
#[Out]# 181   Spiced Biscuits         Lidl
#[Out]# 182              Milk        Jumbo
#[Out]# 183             Bread        Jumbo
#[Out]# 184            Cheese        Jumbo
#[Out]# 
#[Out]# [185 rows x 2 columns]
query5 = '''
    SELECT pName, sName
    FROM product pr, purchase ps, store s
    WHERE pr.pID = ps.pID AND s.sID = ps.sID AND ps.price < (SELECT MAX(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 478           Lasanga         Coop
#[Out]# 479             Pizza         Lidl
#[Out]# 480         Mushrooms         Lidl
#[Out]# 481           Lasanga        Jumbo
#[Out]# 482          Tomatoes    Hoogvliet
#[Out]# 483       Cashew Nuts       Sligro
#[Out]# 484              Milk    Hoogvliet
#[Out]# 485           Carrots  Albert Hein
#[Out]# 486              Coca       Sligro
#[Out]# 487             Bread         Coop
#[Out]# 488           Bananas  Albert Hein
#[Out]# 489              Milk         Coop
#[Out]# 490               Tea         Lidl
#[Out]# 491             Bread         Coop
#[Out]# 492             Fanta    Hoogvliet
#[Out]# 493              Milk    Hoogvliet
#[Out]# 494            Coffee       Sligro
#[Out]# 495   Spiced Biscuits         Coop
#[Out]# 496   Spiced Biscuits         Lidl
#[Out]# 497  Hot Dog Sausages         Coop
#[Out]# 498       Cashew Nuts         Dirk
#[Out]# 499  Hot Dog Sausages         Coop
#[Out]# 500              Milk        Jumbo
#[Out]# 501         Cucumbers         Dirk
#[Out]# 502          Potatoes         Dirk
#[Out]# 503             Bread        Jumbo
#[Out]# 504         Mushrooms         Lidl
#[Out]# 505              Coca         Lidl
#[Out]# 506           Bananas        Jumbo
#[Out]# 507            Cheese        Jumbo
#[Out]# 
#[Out]# [508 rows x 2 columns]
query5 = '''
    SELECT DISTINCT pName, sName
    FROM product pr, purchase ps, store s
    WHERE pr.pID = ps.pID AND s.sID = ps.sID AND ps.price < (SELECT MAX(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15   Hot Dog Sausages    Hoogvliet
#[Out]# 16              Pizza        Jumbo
#[Out]# 17               Beef         Coop
#[Out]# 18            Carrots         Coop
#[Out]# 19               Eggs       Sligro
#[Out]# 20              Pasta  Albert Hein
#[Out]# 21             Apples    Hoogvliet
#[Out]# 22            Lasanga         Lidl
#[Out]# 23               Rice         Coop
#[Out]# 24               Coca    Hoogvliet
#[Out]# 25               Coca       Sligro
#[Out]# 26           Potatoes         Lidl
#[Out]# 27               Rice  Albert Hein
#[Out]# 28               Beef  Albert Hein
#[Out]# 29            Carrots    Hoogvliet
#[Out]# ..                ...          ...
#[Out]# 155           Bananas         Coop
#[Out]# 156          Tomatoes         Lidl
#[Out]# 157             Pizza       Sligro
#[Out]# 158           Bananas         Dirk
#[Out]# 159             Bread    Hoogvliet
#[Out]# 160           Lasanga       Sligro
#[Out]# 161      Green Pepper         Dirk
#[Out]# 162         Mushrooms         Dirk
#[Out]# 163            Onions    Hoogvliet
#[Out]# 164        Mixed Nuts        Jumbo
#[Out]# 165          Potatoes         Dirk
#[Out]# 166              Milk       Sligro
#[Out]# 167               Tea         Dirk
#[Out]# 168   Spiced Biscuits  Albert Hein
#[Out]# 169            Apples         Lidl
#[Out]# 170               Tea    Hoogvliet
#[Out]# 171            Onions        Jumbo
#[Out]# 172            Onions         Lidl
#[Out]# 173             Water        Jumbo
#[Out]# 174            Salmon        Jumbo
#[Out]# 175           Ketchup        Jumbo
#[Out]# 176          Potatoes       Sligro
#[Out]# 177             Fanta  Albert Hein
#[Out]# 178             Fanta        Jumbo
#[Out]# 179            Donuts         Lidl
#[Out]# 180             Bread       Sligro
#[Out]# 181   Spiced Biscuits         Lidl
#[Out]# 182              Milk        Jumbo
#[Out]# 183             Bread        Jumbo
#[Out]# 184            Cheese        Jumbo
#[Out]# 
#[Out]# [185 rows x 2 columns]
query5 = '''
    SELECT DISTINCT pName, sName
    FROM product pr, purchase ps, store s
    WHERE pr.pID = ps.pID AND s.sID = ps.sID AND ps.price = (SELECT MAX(price) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT MAX(DIFFERENCE(p1.price, p2.price))
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT MAX(DIFFERENCE(p1.price, p2.price))
    FROM purchase p1, purchase p2
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT MAX(p1.price, p2.price)
    FROM purchase p1, purchase p2
'''

pd.read_sql_query(query6, conn)
#[Out]#         MAX(p1.price, p2.price)
#[Out]# 0                          0.45
#[Out]# 1                          4.65
#[Out]# 2                          1.60
#[Out]# 3                          1.25
#[Out]# 4                          3.95
#[Out]# 5                          2.75
#[Out]# 6                          0.90
#[Out]# 7                          9.10
#[Out]# 8                          2.45
#[Out]# 9                          1.35
#[Out]# 10                         1.10
#[Out]# 11                         3.70
#[Out]# 12                         1.55
#[Out]# 13                         4.30
#[Out]# 14                         2.75
#[Out]# 15                         1.45
#[Out]# 16                         4.15
#[Out]# 17                         9.05
#[Out]# 18                        13.60
#[Out]# 19                         1.05
#[Out]# 20                         3.05
#[Out]# 21                         2.75
#[Out]# 22                         4.70
#[Out]# 23                         8.25
#[Out]# 24                         1.10
#[Out]# 25                         1.55
#[Out]# 26                         1.85
#[Out]# 27                         2.20
#[Out]# 28                         2.10
#[Out]# 29                         1.70
#[Out]# ...                         ...
#[Out]# 259051                     3.30
#[Out]# 259052                     3.30
#[Out]# 259053                     3.30
#[Out]# 259054                     3.30
#[Out]# 259055                     3.30
#[Out]# 259056                     3.70
#[Out]# 259057                     3.50
#[Out]# 259058                     3.30
#[Out]# 259059                     3.30
#[Out]# 259060                     3.30
#[Out]# 259061                     3.30
#[Out]# 259062                     3.55
#[Out]# 259063                     3.30
#[Out]# 259064                     3.30
#[Out]# 259065                     4.30
#[Out]# 259066                     3.30
#[Out]# 259067                     4.05
#[Out]# 259068                     3.30
#[Out]# 259069                     3.30
#[Out]# 259070                     3.95
#[Out]# 259071                     3.50
#[Out]# 259072                     3.30
#[Out]# 259073                     3.30
#[Out]# 259074                     3.30
#[Out]# 259075                     3.30
#[Out]# 259076                     3.80
#[Out]# 259077                     4.35
#[Out]# 259078                     3.30
#[Out]# 259079                     3.30
#[Out]# 259080                     3.30
#[Out]# 
#[Out]# [259081 rows x 1 columns]
query6 = '''
    SELECT MAX(p1.price - p2.price)
    FROM purchase p1, purchase p2
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(p1.price - p2.price)
#[Out]# 0                      13.4
query6 = '''
    SELECT MAX(i1.unit-price - i1.unit-price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT MAX(i1.unitprice - i1.unitprice)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT MAX(i1.unit_price - i1.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i1.unit_price)
#[Out]# 0                                 0.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                               12.95
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.date = '2018-08-23' AND i2.date = '2018-08-22'
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                13.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                               12.95
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23' AND i1.quantity != 0
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23' AND i1.quantity != 0 AND i2.quantity != 0
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        /* AND i1.quantity != 0 AND i2.quantity != 0 */
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        /* AND i1.quantity = 0 AND i2.quantity != 0 */
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        /* AND i1.quantity = 0 AND i2.quantity = 0 */
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        /* AND i1.quantity != 0 AND i2.quantity != 0 */
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        /* AND i1.quantity != 0 AND i2.quantity != 0 ff nog navragen? */
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
practicequery1a = '''
    SELECT pID
'''

pd.read_sql_query(practicequery1a, conn)
practicequery1a = '''
    SELECT pID
    FROM inventory i
'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#      pID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      2
#[Out]# 4      2
#[Out]# 5      3
#[Out]# 6      4
#[Out]# 7      7
#[Out]# 8      9
#[Out]# 9     12
#[Out]# 10    13
#[Out]# 11    14
#[Out]# 12    14
#[Out]# 13    15
#[Out]# 14    16
#[Out]# 15    16
#[Out]# 16    16
#[Out]# 17    20
#[Out]# 18    21
#[Out]# 19    23
#[Out]# 20    27
#[Out]# 21     0
#[Out]# 22     2
#[Out]# 23     3
#[Out]# 24     4
#[Out]# 25     5
#[Out]# 26     5
#[Out]# 27     7
#[Out]# 28    10
#[Out]# 29    11
#[Out]# ..   ...
#[Out]# 799    8
#[Out]# 800   12
#[Out]# 801   12
#[Out]# 802   13
#[Out]# 803   15
#[Out]# 804   17
#[Out]# 805   17
#[Out]# 806   19
#[Out]# 807   19
#[Out]# 808   26
#[Out]# 809   11
#[Out]# 810   11
#[Out]# 811   12
#[Out]# 812   16
#[Out]# 813   22
#[Out]# 814   27
#[Out]# 815    0
#[Out]# 816    1
#[Out]# 817    2
#[Out]# 818    4
#[Out]# 819    8
#[Out]# 820   13
#[Out]# 821   14
#[Out]# 822   17
#[Out]# 823   21
#[Out]# 824   22
#[Out]# 825   26
#[Out]# 826   27
#[Out]# 827   28
#[Out]# 828   19
#[Out]# 
#[Out]# [829 rows x 1 columns]
practicequery1a = '''
    SELECT pID
    FROM inventory i
    WHERE i1.quantity = 0
'''

pd.read_sql_query(practicequery1a, conn)
practicequery1a = '''
    SELECT pID
    FROM inventory i
    WHERE quantity = 0
'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#    pID
#[Out]# 0   21
#[Out]# 1   13
#[Out]# 2   21
#[Out]# 3    3
#[Out]# 4    8
#[Out]# 5    6
#[Out]# 6   16
#[Out]# 7   24
practicequery1a = '''
    SELECT pID
    FROM inventory
    WHERE quantity = 0
'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#    pID
#[Out]# 0   21
#[Out]# 1   13
#[Out]# 2   21
#[Out]# 3    3
#[Out]# 4    8
#[Out]# 5    6
#[Out]# 6   16
#[Out]# 7   24
practicequery1a = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1a, conn)
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        AND i1.quantity != 0 AND i2.quantity != 0
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND i1.pID = i2.pID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
        AND i1.quantity > 0 AND i2.quantity > 0
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0

