# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x16d762b8570>
query = '''
SELECT * FROM customers
'''

pd.read_sql_query(query, conn)
query = '''
SELECT * FROM customer
'''

pd.read_sql_query(query, conn)
#[Out]#      cID     cName                street       city
#[Out]# 0      0      Noah             Koestraat    Utrecht
#[Out]# 1      1       Sem      Rozemarijnstraat      Breda
#[Out]# 2      2     Lucas      Oude Leliestraat  Amsterdam
#[Out]# 3      3      Finn         Stationsplein      Breda
#[Out]# 4      4      Daan          Kalverstraat  Amsterdam
#[Out]# 5      5      Levi        Gasthuisstraat    Utrecht
#[Out]# 6      6     Milan           Parallelweg    Utrecht
#[Out]# 7      7      Bram          Schoolstraat  Eindhoven
#[Out]# 8      8      Liam         Rijsbergseweg      Breda
#[Out]# 9      9    Thomas           Parallelweg  Amsterdam
#[Out]# 10    10       Sam           Langestraat    Tilburg
#[Out]# 11    11     Thijs             Koestraat    Tilburg
#[Out]# 12    12      Adam           Nieuwstraat  Eindhoven
#[Out]# 13    13     James       Sint Annastraat      Breda
#[Out]# 14    14       Max             Eikenlaan    Tilburg
#[Out]# 15    15      Noud          Koningshoeve    Tilburg
#[Out]# 16    16    Julian  Prins Bernhardstraat  Eindhoven
#[Out]# 17    17       Dex          Kasteeldreef    Tilburg
#[Out]# 18    18      Hugo          Kasteeldreef    Tilburg
#[Out]# 19    19      Lars         Rijsbergseweg      Breda
#[Out]# 20    20      Gijs            Heiligeweg  Amsterdam
#[Out]# 21    21  Benjamin           Stationsweg    Tilburg
#[Out]# 22    22      Mats           Molenstraat  Eindhoven
#[Out]# 23    23       Jan       Sint Annastraat      Breda
#[Out]# 24    24      Luca          Kasteeldreef    Tilburg
#[Out]# 25    25     Mason          Keizerstraat  Rotterdam
#[Out]# 26    26    Jayden          Schoolstraat  Eindhoven
#[Out]# 27    27       Tim             Koestraat    Utrecht
#[Out]# 28    28      Siem           Langestraat    Tilburg
#[Out]# 29    29     Ruben              Hofplein  Rotterdam
#[Out]# ..   ...       ...                   ...        ...
#[Out]# 160  160      Lara           Langestraat    Tilburg
#[Out]# 161  161     Floor             Eikenlaan    Tilburg
#[Out]# 162  162     Elena            Bergselaan  Rotterdam
#[Out]# 163  163      Cato          Kastanjelaan    Tilburg
#[Out]# 164  164       Evy      Rozemarijnstraat      Breda
#[Out]# 165  165     Hanna             Eikenlaan    Tilburg
#[Out]# 166  166   Rosalie           Stationsweg  Eindhoven
#[Out]# 167  167    Veerle        Ginnekenstraat      Breda
#[Out]# 168  168      Kiki          Keizerstraat  Rotterdam
#[Out]# 169  169      Lily        Gasthuisstraat    Utrecht
#[Out]# 170  170      Iris          Kastanjelaan  Eindhoven
#[Out]# 171  171     Tessa           Haringvliet  Rotterdam
#[Out]# 172  172      Lana             Eikenlaan    Tilburg
#[Out]# 173  173     Livia      Vierwindenstraat      Breda
#[Out]# 174  174      Romy           Parallelweg  Eindhoven
#[Out]# 175  175       Sam             Bredalaan  Eindhoven
#[Out]# 176  176     Amira           Parallelweg  Amsterdam
#[Out]# 177  177     Eline          Kalverstraat  Amsterdam
#[Out]# 178  178      Elif           Parallelweg    Utrecht
#[Out]# 179  179      Juul        Wilhelminapark    Tilburg
#[Out]# 180  180     Merel          Kalverstraat  Amsterdam
#[Out]# 181  181      Liva           Fredriklaan  Eindhoven
#[Out]# 182  182   Johanna         Beatrixstraat  Eindhoven
#[Out]# 183  183     Nikki         Julianastraat    Utrecht
#[Out]# 184  184     Wilko          Onbekendeweg  Eindhoven
#[Out]# 185  185      Nick                Verweg  Eindhoven
#[Out]# 186  186    Angela              Dichtweg  Eindhoven
#[Out]# 187  188      Pino            Maanstraat  Rotterdam
#[Out]# 188  189      Koen              Akkerweg        Oss
#[Out]# 189  190    Kostas              Eindeweg    Utrecht
#[Out]# 
#[Out]# [190 rows x 4 columns]
query = '''
show tables;
'''

pd.read_sql_query(query, conn)
query = '''
SELECT * FROM custom
'''

pd.read_sql_query(query, conn)
query = '''
SELECT * FROM customer
'''

pd.read_sql_query(query, conn)
#[Out]#      cID     cName                street       city
#[Out]# 0      0      Noah             Koestraat    Utrecht
#[Out]# 1      1       Sem      Rozemarijnstraat      Breda
#[Out]# 2      2     Lucas      Oude Leliestraat  Amsterdam
#[Out]# 3      3      Finn         Stationsplein      Breda
#[Out]# 4      4      Daan          Kalverstraat  Amsterdam
#[Out]# 5      5      Levi        Gasthuisstraat    Utrecht
#[Out]# 6      6     Milan           Parallelweg    Utrecht
#[Out]# 7      7      Bram          Schoolstraat  Eindhoven
#[Out]# 8      8      Liam         Rijsbergseweg      Breda
#[Out]# 9      9    Thomas           Parallelweg  Amsterdam
#[Out]# 10    10       Sam           Langestraat    Tilburg
#[Out]# 11    11     Thijs             Koestraat    Tilburg
#[Out]# 12    12      Adam           Nieuwstraat  Eindhoven
#[Out]# 13    13     James       Sint Annastraat      Breda
#[Out]# 14    14       Max             Eikenlaan    Tilburg
#[Out]# 15    15      Noud          Koningshoeve    Tilburg
#[Out]# 16    16    Julian  Prins Bernhardstraat  Eindhoven
#[Out]# 17    17       Dex          Kasteeldreef    Tilburg
#[Out]# 18    18      Hugo          Kasteeldreef    Tilburg
#[Out]# 19    19      Lars         Rijsbergseweg      Breda
#[Out]# 20    20      Gijs            Heiligeweg  Amsterdam
#[Out]# 21    21  Benjamin           Stationsweg    Tilburg
#[Out]# 22    22      Mats           Molenstraat  Eindhoven
#[Out]# 23    23       Jan       Sint Annastraat      Breda
#[Out]# 24    24      Luca          Kasteeldreef    Tilburg
#[Out]# 25    25     Mason          Keizerstraat  Rotterdam
#[Out]# 26    26    Jayden          Schoolstraat  Eindhoven
#[Out]# 27    27       Tim             Koestraat    Utrecht
#[Out]# 28    28      Siem           Langestraat    Tilburg
#[Out]# 29    29     Ruben              Hofplein  Rotterdam
#[Out]# ..   ...       ...                   ...        ...
#[Out]# 160  160      Lara           Langestraat    Tilburg
#[Out]# 161  161     Floor             Eikenlaan    Tilburg
#[Out]# 162  162     Elena            Bergselaan  Rotterdam
#[Out]# 163  163      Cato          Kastanjelaan    Tilburg
#[Out]# 164  164       Evy      Rozemarijnstraat      Breda
#[Out]# 165  165     Hanna             Eikenlaan    Tilburg
#[Out]# 166  166   Rosalie           Stationsweg  Eindhoven
#[Out]# 167  167    Veerle        Ginnekenstraat      Breda
#[Out]# 168  168      Kiki          Keizerstraat  Rotterdam
#[Out]# 169  169      Lily        Gasthuisstraat    Utrecht
#[Out]# 170  170      Iris          Kastanjelaan  Eindhoven
#[Out]# 171  171     Tessa           Haringvliet  Rotterdam
#[Out]# 172  172      Lana             Eikenlaan    Tilburg
#[Out]# 173  173     Livia      Vierwindenstraat      Breda
#[Out]# 174  174      Romy           Parallelweg  Eindhoven
#[Out]# 175  175       Sam             Bredalaan  Eindhoven
#[Out]# 176  176     Amira           Parallelweg  Amsterdam
#[Out]# 177  177     Eline          Kalverstraat  Amsterdam
#[Out]# 178  178      Elif           Parallelweg    Utrecht
#[Out]# 179  179      Juul        Wilhelminapark    Tilburg
#[Out]# 180  180     Merel          Kalverstraat  Amsterdam
#[Out]# 181  181      Liva           Fredriklaan  Eindhoven
#[Out]# 182  182   Johanna         Beatrixstraat  Eindhoven
#[Out]# 183  183     Nikki         Julianastraat    Utrecht
#[Out]# 184  184     Wilko          Onbekendeweg  Eindhoven
#[Out]# 185  185      Nick                Verweg  Eindhoven
#[Out]# 186  186    Angela              Dichtweg  Eindhoven
#[Out]# 187  188      Pino            Maanstraat  Rotterdam
#[Out]# 188  189      Koen              Akkerweg        Oss
#[Out]# 189  190    Kostas              Eindeweg    Utrecht
#[Out]# 
#[Out]# [190 rows x 4 columns]
query = '''
SELECT * FROM customer
LIMIT 10;
'''

pd.read_sql_query(query, conn)
#[Out]#    cID   cName            street       city
#[Out]# 0    0    Noah         Koestraat    Utrecht
#[Out]# 1    1     Sem  Rozemarijnstraat      Breda
#[Out]# 2    2   Lucas  Oude Leliestraat  Amsterdam
#[Out]# 3    3    Finn     Stationsplein      Breda
#[Out]# 4    4    Daan      Kalverstraat  Amsterdam
#[Out]# 5    5    Levi    Gasthuisstraat    Utrecht
#[Out]# 6    6   Milan       Parallelweg    Utrecht
#[Out]# 7    7    Bram      Schoolstraat  Eindhoven
#[Out]# 8    8    Liam     Rijsbergseweg      Breda
#[Out]# 9    9  Thomas       Parallelweg  Amsterdam
query = '''
    SELECT * FROM product
'''

pd.read_sql_query(query, conn)
#[Out]#     pID             pName suffix
#[Out]# 0     0       Cashew Nuts       
#[Out]# 1     1        Mixed Nuts       
#[Out]# 2     2          Potatoes       
#[Out]# 3     3      Green Pepper       
#[Out]# 4     4            Onions       
#[Out]# 5     5         Mushrooms       
#[Out]# 6     6           Carrots       
#[Out]# 7     7          Tomatoes       
#[Out]# 8     8  Hot Dog Sausages       
#[Out]# 9     9           Bananas       
#[Out]# 10   10             Water       
#[Out]# 11   11              Milk       
#[Out]# 12   12              Beef       
#[Out]# 13   13              Eggs       
#[Out]# 14   14            Apples       
#[Out]# 15   15         Cucumbers       
#[Out]# 16   16              Rice       
#[Out]# 17   17             Bread       
#[Out]# 18   18            Cheese       
#[Out]# 19   19              Coca       
#[Out]# 20   20             Fanta       
#[Out]# 21   21            Coffee       
#[Out]# 22   22               Tea       
#[Out]# 23   23   Spiced Biscuits       
#[Out]# 24   24           Oranges       
#[Out]# 25   25            Donuts       
#[Out]# 26   26             Pasta       
#[Out]# 27   27             Pizza       
#[Out]# 28   28           Lasanga       
#[Out]# 29   29            Salmon       
#[Out]# 30   30           Ketchup       
#[Out]# 31   31   French baguette       
query = '''
    SELECT * FROM product LIMIT 10;
'''

pd.read_sql_query(query, conn)
#[Out]#    pID             pName suffix
#[Out]# 0    0       Cashew Nuts       
#[Out]# 1    1        Mixed Nuts       
#[Out]# 2    2          Potatoes       
#[Out]# 3    3      Green Pepper       
#[Out]# 4    4            Onions       
#[Out]# 5    5         Mushrooms       
#[Out]# 6    6           Carrots       
#[Out]# 7    7          Tomatoes       
#[Out]# 8    8  Hot Dog Sausages       
#[Out]# 9    9           Bananas       
query1 = '''
    SELECT pID FROM product
    EXCEPT
    SELECT p1.pID
    FROM purchase p1, purchase p2, purchase p3
    WHERE p1.pID == p2.pID AND
        p2.pID == p3.pID AND
        p1.pID == p3.pID AND
        p1.cID != p2.cID AND
        p2.cID != p3.cID AND
        p1.cID != p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
    SELECT pID FROM product
    EXCEPT
    SELECT p1.pID
    FROM purchase p1, purchase p2, purchase p3
    WHERE p1.pID == p2.pID AND
        p2.pID == p3.pID AND
        p1.cID != p2.cID AND
        p2.cID != p3.cID AND
        p1.cID != p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
    (SELECT pID FROM product
    EXCEPT
    SELECT p1.pID
    FROM purchase p1, purchase p2, purchase p3
    WHERE p1.pID == p2.pID AND
        p2.pID == p3.pID AND
        p1.cID != p2.cID AND
        p2.cID != p3.cID AND
        p1.cID != p3.cID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID FROM product
    EXCEPT
    SELECT p1.pID
    FROM purchase p1, purchase p2, purchase p3
    WHERE p1.pID == p2.pID AND
        p2.pID == p3.pID AND
        p1.cID != p2.cID AND
        p2.cID != p3.cID AND
        p1.cID != p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    SELECT p1.cID
    FROM purchase p1, purchase p2, product pr1, product pr2
    WHERE p1.date == p2.date AND
        p1.cID == p2.cID AND
        p1.pID == pr1.pID AND
        pr1.pName == "Onions" AND
        p2.pID == pr2.pID AND
        pr2.pName == "Coffee"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID
#[Out]# 0  124
#[Out]# 1  190
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase p1, purchase p2, product pr1, product pr2, customer c
    WHERE p1.date == p2.date AND
        p1.cID == p2.cID AND
        p1.pID == pr1.pID AND
        pr1.pName == "Onions" AND
        p2.pID == pr2.pID AND
        pr2.pName == "Coffee" AND
        c.cID == p1.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT DISTINCT cID, sID
    FROM customer, store
    EXCEPT cID, sID
    FROM purchase
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT DISTINCT cID, sID
    FROM customer, store
    EXCEPT 
    SELECT cID, sID
    FROM purchase
'''

pd.read_sql_query(query3, conn)
#[Out]#        cID  sID
#[Out]# 0        0    0
#[Out]# 1        0    1
#[Out]# 2        0    2
#[Out]# 3        0    4
#[Out]# 4        0    5
#[Out]# 5        0    6
#[Out]# 6        0    7
#[Out]# 7        0    8
#[Out]# 8        0    9
#[Out]# 9        0   10
#[Out]# 10       0   11
#[Out]# 11       0   12
#[Out]# 12       0   13
#[Out]# 13       0   14
#[Out]# 14       0   15
#[Out]# 15       0   16
#[Out]# 16       0   17
#[Out]# 17       0   18
#[Out]# 18       0   19
#[Out]# 19       0   20
#[Out]# 20       0   21
#[Out]# 21       0   22
#[Out]# 22       0   23
#[Out]# 23       0   24
#[Out]# 24       0   25
#[Out]# 25       0   26
#[Out]# 26       0   27
#[Out]# 27       0   28
#[Out]# 28       0   29
#[Out]# 29       0   30
#[Out]# ...    ...  ...
#[Out]# 11640  189   33
#[Out]# 11641  189   34
#[Out]# 11642  189   35
#[Out]# 11643  189   36
#[Out]# 11644  189   37
#[Out]# 11645  189   38
#[Out]# 11646  189   39
#[Out]# 11647  189   40
#[Out]# 11648  189   41
#[Out]# 11649  189   42
#[Out]# 11650  189   43
#[Out]# 11651  189   44
#[Out]# 11652  189   45
#[Out]# 11653  189   46
#[Out]# 11654  189   47
#[Out]# 11655  189   48
#[Out]# 11656  189   49
#[Out]# 11657  189   50
#[Out]# 11658  189   51
#[Out]# 11659  189   52
#[Out]# 11660  189   53
#[Out]# 11661  189   54
#[Out]# 11662  189   55
#[Out]# 11663  189   56
#[Out]# 11664  189   57
#[Out]# 11665  189   58
#[Out]# 11666  189   59
#[Out]# 11667  189   60
#[Out]# 11668  189   61
#[Out]# 11669  189   62
#[Out]# 
#[Out]# [11670 rows x 2 columns]
query3 = '''
    WITH (SELECT DISTINCT cID, sID
    FROM customer, store
    EXCEPT 
    SELECT cID, sID
    FROM purchase) AS test(a,b)
'''

pd.read_sql_query(query3, conn)
query3 = '''
    WITH test(a,b) AS (SELECT DISTINCT cID, sID
    FROM customer, store
    EXCEPT 
    SELECT cID, sID
    FROM purchase)
'''

pd.read_sql_query(query3, conn)
query3 = '''
    WITH test (a,b) AS (SELECT DISTINCT cID, sID
    FROM customer, store
    EXCEPT 
    SELECT cID, sID
    FROM purchase)
    SELECT *
    FROM test
'''

pd.read_sql_query(query3, conn)
#[Out]#          a   b
#[Out]# 0        0   0
#[Out]# 1        0   1
#[Out]# 2        0   2
#[Out]# 3        0   4
#[Out]# 4        0   5
#[Out]# 5        0   6
#[Out]# 6        0   7
#[Out]# 7        0   8
#[Out]# 8        0   9
#[Out]# 9        0  10
#[Out]# 10       0  11
#[Out]# 11       0  12
#[Out]# 12       0  13
#[Out]# 13       0  14
#[Out]# 14       0  15
#[Out]# 15       0  16
#[Out]# 16       0  17
#[Out]# 17       0  18
#[Out]# 18       0  19
#[Out]# 19       0  20
#[Out]# 20       0  21
#[Out]# 21       0  22
#[Out]# 22       0  23
#[Out]# 23       0  24
#[Out]# 24       0  25
#[Out]# 25       0  26
#[Out]# 26       0  27
#[Out]# 27       0  28
#[Out]# 28       0  29
#[Out]# 29       0  30
#[Out]# ...    ...  ..
#[Out]# 11640  189  33
#[Out]# 11641  189  34
#[Out]# 11642  189  35
#[Out]# 11643  189  36
#[Out]# 11644  189  37
#[Out]# 11645  189  38
#[Out]# 11646  189  39
#[Out]# 11647  189  40
#[Out]# 11648  189  41
#[Out]# 11649  189  42
#[Out]# 11650  189  43
#[Out]# 11651  189  44
#[Out]# 11652  189  45
#[Out]# 11653  189  46
#[Out]# 11654  189  47
#[Out]# 11655  189  48
#[Out]# 11656  189  49
#[Out]# 11657  189  50
#[Out]# 11658  189  51
#[Out]# 11659  189  52
#[Out]# 11660  189  53
#[Out]# 11661  189  54
#[Out]# 11662  189  55
#[Out]# 11663  189  56
#[Out]# 11664  189  57
#[Out]# 11665  189  58
#[Out]# 11666  189  59
#[Out]# 11667  189  60
#[Out]# 11668  189  61
#[Out]# 11669  189  62
#[Out]# 
#[Out]# [11670 rows x 2 columns]
query3 = '''
    WITH test (cID,sID) AS (SELECT DISTINCT cID, sID
    FROM customer, store
    EXCEPT 
    SELECT cID, sID
    FROM purchase)
    SELECT cID
    FROM customer
    EXCEPT
    SELECT cID
    FROM test
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    WITH test (cID,sID) AS (SELECT cID, sID
    FROM customer, store
    EXCEPT 
    SELECT cID, sID
    FROM purchase)
    SELECT cID
    FROM customer
    EXCEPT
    SELECT cID
    FROM test
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    WITH all (cID,sID) AS (SELECT cID, sID
    FROM customer, store
    EXCEPT 
    SELECT cID, sID
    FROM purchase)
    SELECT cID
    FROM customer
    EXCEPT
    SELECT cID
    FROM all
'''

pd.read_sql_query(query3, conn)
query3 = '''
    WITH cust_store (cID,sID) AS (SELECT cID, sID
    FROM customer, store
    EXCEPT 
    SELECT cID, sID
    FROM purchase)
    SELECT cID
    FROM customer
    EXCEPT
    SELECT cID
    FROM cust_store
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    WITH cust_store (cID,sID) AS (SELECT cID, sID
    FROM customer, store
    EXCEPT 
    SELECT cID, sID
    FROM purchase)
    
    SELECT cID
    FROM customer
    EXCEPT
    SELECT cID
    FROM cust_store
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT cName, avg(quantity)
    FROM store s, purchase p
    WHERE s.sID == p.sID
    GROUP BY cName
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName, avg(quantity)
    FROM store s, purchase p
    WHERE s.sID == p.sID
    GROUP BY sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg(quantity)
#[Out]# 0  Albert Hein       4.969697
#[Out]# 1         Coop       4.681818
#[Out]# 2         Dirk       5.268293
#[Out]# 3    Hoogvliet       5.280000
#[Out]# 4        Jumbo       3.888889
#[Out]# 5         Lidl       4.796875
#[Out]# 6       Sligro       4.674419
query4 = '''
    SELECT sName, avg(quantity)
    FROM store s, purchase p
    WHERE s.sID == p.sID
    GROUP BY sName
    HAVING avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg(quantity)
#[Out]# 0  Albert Hein       4.969697
#[Out]# 1         Coop       4.681818
#[Out]# 2         Dirk       5.268293
#[Out]# 3    Hoogvliet       5.280000
#[Out]# 4         Lidl       4.796875
#[Out]# 5       Sligro       4.674419
query6 = '''
    SELECT i1.unit_price - i2.unit_price
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND
        i1.date == i2.date AND
        i1.date == "2018-08-23" AND
        i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#      i1.unit_price - i2.unit_price
#[Out]# 0                             0.15
#[Out]# 1                             0.05
#[Out]# 2                             0.85
#[Out]# 3                             0.75
#[Out]# 4                             0.70
#[Out]# 5                             0.30
#[Out]# 6                            -0.30
#[Out]# 7                            -0.05
#[Out]# 8                             0.60
#[Out]# 9                             0.05
#[Out]# 10                           -0.10
#[Out]# 11                            0.55
#[Out]# 12                           -0.05
#[Out]# 13                            0.50
#[Out]# 14                            0.25
#[Out]# 15                           -0.05
#[Out]# 16                            0.00
#[Out]# 17                            0.10
#[Out]# 18                           -0.05
#[Out]# 19                            1.20
#[Out]# 20                            1.00
#[Out]# 21                            1.40
#[Out]# 22                           -0.05
#[Out]# 23                           -0.20
#[Out]# 24                           -0.35
#[Out]# 25                            1.60
#[Out]# 26                           -0.35
#[Out]# 27                           -1.20
#[Out]# 28                           -0.20
#[Out]# 29                            0.20
#[Out]# ..                             ...
#[Out]# 124                          -0.55
#[Out]# 125                           0.20
#[Out]# 126                           0.15
#[Out]# 127                          -1.00
#[Out]# 128                           0.20
#[Out]# 129                           0.40
#[Out]# 130                          -0.85
#[Out]# 131                          -0.60
#[Out]# 132                           1.15
#[Out]# 133                           0.30
#[Out]# 134                           0.05
#[Out]# 135                           0.05
#[Out]# 136                           0.25
#[Out]# 137                           0.35
#[Out]# 138                          -0.30
#[Out]# 139                          -0.25
#[Out]# 140                          -0.25
#[Out]# 141                           0.90
#[Out]# 142                           0.40
#[Out]# 143                           0.75
#[Out]# 144                          -0.25
#[Out]# 145                           1.75
#[Out]# 146                           0.60
#[Out]# 147                          -0.55
#[Out]# 148                          -1.40
#[Out]# 149                          -0.20
#[Out]# 150                          -0.40
#[Out]# 151                           0.65
#[Out]# 152                           0.05
#[Out]# 153                           0.10
#[Out]# 
#[Out]# [154 rows x 1 columns]
query6 = '''
    SELECT ab(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND
        i1.date == i2.date AND
        i1.date == "2018-08-23" AND
        i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT abs(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND
        i1.date == i2.date AND
        i1.date == "2018-08-23" AND
        i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#      abs(i1.unit_price - i2.unit_price)
#[Out]# 0                                  0.15
#[Out]# 1                                  0.05
#[Out]# 2                                  0.85
#[Out]# 3                                  0.75
#[Out]# 4                                  0.70
#[Out]# 5                                  0.30
#[Out]# 6                                  0.30
#[Out]# 7                                  0.05
#[Out]# 8                                  0.60
#[Out]# 9                                  0.05
#[Out]# 10                                 0.10
#[Out]# 11                                 0.55
#[Out]# 12                                 0.05
#[Out]# 13                                 0.50
#[Out]# 14                                 0.25
#[Out]# 15                                 0.05
#[Out]# 16                                 0.00
#[Out]# 17                                 0.10
#[Out]# 18                                 0.05
#[Out]# 19                                 1.20
#[Out]# 20                                 1.00
#[Out]# 21                                 1.40
#[Out]# 22                                 0.05
#[Out]# 23                                 0.20
#[Out]# 24                                 0.35
#[Out]# 25                                 1.60
#[Out]# 26                                 0.35
#[Out]# 27                                 1.20
#[Out]# 28                                 0.20
#[Out]# 29                                 0.20
#[Out]# ..                                  ...
#[Out]# 124                                0.55
#[Out]# 125                                0.20
#[Out]# 126                                0.15
#[Out]# 127                                1.00
#[Out]# 128                                0.20
#[Out]# 129                                0.40
#[Out]# 130                                0.85
#[Out]# 131                                0.60
#[Out]# 132                                1.15
#[Out]# 133                                0.30
#[Out]# 134                                0.05
#[Out]# 135                                0.05
#[Out]# 136                                0.25
#[Out]# 137                                0.35
#[Out]# 138                                0.30
#[Out]# 139                                0.25
#[Out]# 140                                0.25
#[Out]# 141                                0.90
#[Out]# 142                                0.40
#[Out]# 143                                0.75
#[Out]# 144                                0.25
#[Out]# 145                                1.75
#[Out]# 146                                0.60
#[Out]# 147                                0.55
#[Out]# 148                                1.40
#[Out]# 149                                0.20
#[Out]# 150                                0.40
#[Out]# 151                                0.65
#[Out]# 152                                0.05
#[Out]# 153                                0.10
#[Out]# 
#[Out]# [154 rows x 1 columns]
query6 = '''
    SELECT max(abs(i1.unit_price - i2.unit_price))
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND
        i1.date == i2.date AND
        i1.date == "2018-08-23" AND
        i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                      2.0
query6 = '''
    SELECT max(abs(i1.unit_price - i2.unit_price)) as a
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND
        i1.date == i2.date AND
        i1.date == "2018-08-23" AND
        i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#      a
#[Out]# 0  2.0
query6 = '''
    SELECT max(abs(i1.unit_price - i2.unit_price)) as max_diff
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND
        i1.date == i2.date AND
        i1.date == "2018-08-23" AND
        i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_diff
#[Out]# 0       2.0
query6 = '''
    SELECT max(abs(i2.unit_price - i1.unit_price)) as max_diff
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND
        i1.date == i2.date AND
        i1.date == "2018-08-23" AND
        i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_diff
#[Out]# 0       2.0
query6 = '''
    SELECT max(abs(i1.unit_price - i2.unit_price)) as max_diff
    FROM inventory i1, inventory i2
    WHERE i1.sID != i2.sID AND
        i1.date == i2.date AND
        i1.date == "2018-08-23" AND
        i1.pID == i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_diff
#[Out]# 0       2.0
query5 = '''
    WITH max_price(value) AS (
    SELECT max(unit_price)
    FROM inventory)
    
    SELECT pName, sName
    FROM inventory i, store s, product p, max_price mp
    WHERE i.sID == s.sID AND
        i.pID == p.pID AND
        i.unit_price == mp.value
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName
#[Out]# 0  Beef  Albert Hein
query5 = '''
    WITH max_price(value) AS (
    SELECT max(unit_price)
    FROM inventory)
    
    SELECT pName, sName, i.unit_price
    FROM inventory i, store s, product p, max_price mp
    WHERE i.sID == s.sID AND
        i.pID == p.pID AND
        i.unit_price == mp.value
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName  unit_price
#[Out]# 0  Beef  Albert Hein        14.9
query5 = '''
    WITH max_price(value) AS (
    SELECT max(unit_price)
    FROM inventory)
    
    SELECT pName, sName
    FROM inventory i, store s, product p, max_price mp
    WHERE i.sID == s.sID AND
        i.pID == p.pID AND
        i.unit_price == mp.value
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName
#[Out]# 0  Beef  Albert Hein
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase p1, purchase p2, product pr1, product pr2, customer c
    WHERE p1.date = p2.date AND
        p1.cID == p2.cID AND
        p1.pID == pr1.pID AND
        pr1.pName == "Onions" AND
        p2.pID == pr2.pID AND
        pr2.pName == "Coffee" AND
        c.cID == p1.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase p1, purchase p2, product pr1, product pr2, customer c
    WHERE p1.date == p2.date AND
        p1.cID == p2.cID AND
        p1.pID == pr1.pID AND
        pr1.pName == "Onions" AND
        p2.pID == pr2.pID AND
        pr2.pName == "Coffee" AND
        c.cID == p1.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID == p.sID
    GROUP BY sName
    HAVING avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID == p.sID
    GROUP BY sName
    HAVING avg(quantity) > 4
    INTERSECT sName
    FROM store s1, store s1
    WHERE s1.sID != s2.sID AND
        s1.sName == s2.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID == p.sID
    GROUP BY sName
    HAVING avg(quantity) > 4
    INTERSECT 
    SELECT sName
    FROM store s1, store s1
    WHERE s1.sID != s2.sID AND
        s1.sName == s2.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID == p.sID
    GROUP BY sName
    HAVING avg(quantity) > 4
    INTERSECT 
    SELECT s1.sName
    FROM store s1, store s1
    WHERE s1.sID != s2.sID AND
        s1.sName == s2.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID == p.sID
    GROUP BY sName
    HAVING avg(quantity) > 4
    INTERSECT 
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sID != s2.sID AND
        s1.sName == s2.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    WITH max_price(value) AS (
    SELECT max(price)
    FROM purchase)
    
    SELECT pName, sName
    FROM inventory i, store s, product p, max_price mp
    WHERE i.sID == s.sID AND
        i.pID == p.pID AND
        i.unit_price == mp.value
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    WITH max_price(value) AS (
    SELECT max(price)
    FROM purchase)
    
    SELECT pName, sName, mp.value
    FROM inventory i, store s, product p, max_price mp
    WHERE i.sID == s.sID AND
        i.pID == p.pID AND
        i.unit_price == mp.value
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName  value
#[Out]# 0  Beef  Sligro   13.8
query5 = '''
    WITH max_price(value) AS (
    SELECT max(price)
    FROM purchase)
    
    SELECT pName, sName, mp.value
    FROM purchase pur, store s, product p, max_price mp
    WHERE i.sID == s.sID AND
        i.pID == p.pID AND
        pur.price == mp.value
'''

pd.read_sql_query(query5, conn)
query5 = '''
    WITH max_price(value) AS (
    SELECT max(price)
    FROM purchase)
    
    SELECT pName, sName, mp.value
    FROM purchase pur, store s, product p, max_price mp
    WHERE pur.sID == s.sID AND
        pur.pID == p.pID AND
        pur.price == mp.value
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName  value
#[Out]# 0  Beef  Sligro   13.8
query5 = '''
    WITH max_price(value) AS (
    SELECT max(price)
    FROM purchase)
    
    SELECT pName, sName
    FROM purchase pur, store s, product p, max_price mp
    WHERE pur.sID == s.sID AND
        pur.pID == p.pID AND
        pur.price == mp.value
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
