# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x1cbcc40a260>
query1 = '''
    select pID
    from purchase
    where count(cID) <= 2
'''

pd.read_sql_query(query1, conn)
query1 = '''
    select cID, pID
    from purchase
    where pID = pID and cID != cID
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, pID]
#[Out]# Index: []
query1 = '''
    select cID, pID
    from purchase

'''

pd.read_sql_query(query1, conn)
#[Out]#      cID  pID
#[Out]# 0      0   10
#[Out]# 1      1   14
#[Out]# 2      1   16
#[Out]# 3      1    9
#[Out]# 4      1   25
#[Out]# 5      1   26
#[Out]# 6      1   11
#[Out]# 7      1   27
#[Out]# 8      2   20
#[Out]# 9      2    9
#[Out]# 10     2    4
#[Out]# 11     2   13
#[Out]# 12     2   22
#[Out]# 13     3   14
#[Out]# 14     3   26
#[Out]# 15     3    9
#[Out]# 16     4    8
#[Out]# 17     4   27
#[Out]# 18     4   12
#[Out]# 19     4    6
#[Out]# 20     4   13
#[Out]# 21     4   26
#[Out]# 22     5   14
#[Out]# 23     5   28
#[Out]# 24     5    6
#[Out]# 25     5   22
#[Out]# 26     5   16
#[Out]# 27     5   19
#[Out]# 28     7   19
#[Out]# 29     7    2
#[Out]# ..   ...  ...
#[Out]# 479  190   28
#[Out]# 480  190   27
#[Out]# 481  190    5
#[Out]# 482  190   28
#[Out]# 483  190    7
#[Out]# 484  190    0
#[Out]# 485  190   11
#[Out]# 486  190    6
#[Out]# 487  190   19
#[Out]# 488  190   17
#[Out]# 489  190    9
#[Out]# 490  190   11
#[Out]# 491  190   22
#[Out]# 492  190   17
#[Out]# 493  190   20
#[Out]# 494  190   11
#[Out]# 495  190   21
#[Out]# 496  190   23
#[Out]# 497  190   23
#[Out]# 498  190    8
#[Out]# 499  190    0
#[Out]# 500  190    8
#[Out]# 501  190   11
#[Out]# 502  190   15
#[Out]# 503  190    2
#[Out]# 504  190   17
#[Out]# 505  190    5
#[Out]# 506  190   19
#[Out]# 507  190    9
#[Out]# 508  190   18
#[Out]# 
#[Out]# [509 rows x 2 columns]
query1 = '''
    select cID, pID
    from purchase
    cID != cID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    select cID, pID
    from purchase
    where cID != cID
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, pID]
#[Out]# Index: []
query1 = '''
    select distinct pID, count(distinct cID)
    from purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(distinct cID)
#[Out]# 0   18                  132
query1 = '''
    select pID, count(distinct cID)
    from purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(distinct cID)
#[Out]# 0   18                  132
query1 = '''
    select pID, count(cID)
    from purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(cID)
#[Out]# 0   18         509
query1 = '''
    select pID
    from purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 479   28
#[Out]# 480   27
#[Out]# 481    5
#[Out]# 482   28
#[Out]# 483    7
#[Out]# 484    0
#[Out]# 485   11
#[Out]# 486    6
#[Out]# 487   19
#[Out]# 488   17
#[Out]# 489    9
#[Out]# 490   11
#[Out]# 491   22
#[Out]# 492   17
#[Out]# 493   20
#[Out]# 494   11
#[Out]# 495   21
#[Out]# 496   23
#[Out]# 497   23
#[Out]# 498    8
#[Out]# 499    0
#[Out]# 500    8
#[Out]# 501   11
#[Out]# 502   15
#[Out]# 503    2
#[Out]# 504   17
#[Out]# 505    5
#[Out]# 506   19
#[Out]# 507    9
#[Out]# 508   18
#[Out]# 
#[Out]# [509 rows x 1 columns]
query1 = '''
    select pID, count(distinct cID)
    from purchase
    group by pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  count(distinct cID)
#[Out]# 0     0                   22
#[Out]# 1     1                   13
#[Out]# 2     2                    9
#[Out]# 3     3                   20
#[Out]# 4     4                   16
#[Out]# 5     5                   14
#[Out]# 6     6                   15
#[Out]# 7     7                   13
#[Out]# 8     8                   12
#[Out]# 9     9                   18
#[Out]# 10   10                   14
#[Out]# 11   11                   13
#[Out]# 12   12                   16
#[Out]# 13   13                   21
#[Out]# 14   14                   18
#[Out]# 15   15                   13
#[Out]# 16   16                   20
#[Out]# 17   17                   13
#[Out]# 18   18                   10
#[Out]# 19   19                   20
#[Out]# 20   20                   16
#[Out]# 21   21                   19
#[Out]# 22   22                   20
#[Out]# 23   23                   11
#[Out]# 24   24                   20
#[Out]# 25   25                   14
#[Out]# 26   26                   19
#[Out]# 27   27                   13
#[Out]# 28   28                   23
#[Out]# 29   29                    2
#[Out]# 30   30                    1
query1 = '''
select pID
from (
    select pID, count(distinct cID)
    from purchase
    group by pID
    )
where count <= 2
     
'''

pd.read_sql_query(query1, conn)
query1 = '''
select pID
from (
    select pID, count(distinct cID) as count
    from purchase
    group by pID
    )
where count <= 2
     
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    select pID
    from (
        select pID, count(distinct cID) as count
        from purchase
        group by pID
        )
    where count <= 2 
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    select customer.cID, cName
    from customer, product, purchase
'''

pd.read_sql_query(query2, conn)
#[Out]#          cID   cName
#[Out]# 0          0    Noah
#[Out]# 1          0    Noah
#[Out]# 2          0    Noah
#[Out]# 3          0    Noah
#[Out]# 4          0    Noah
#[Out]# 5          0    Noah
#[Out]# 6          0    Noah
#[Out]# 7          0    Noah
#[Out]# 8          0    Noah
#[Out]# 9          0    Noah
#[Out]# 10         0    Noah
#[Out]# 11         0    Noah
#[Out]# 12         0    Noah
#[Out]# 13         0    Noah
#[Out]# 14         0    Noah
#[Out]# 15         0    Noah
#[Out]# 16         0    Noah
#[Out]# 17         0    Noah
#[Out]# 18         0    Noah
#[Out]# 19         0    Noah
#[Out]# 20         0    Noah
#[Out]# 21         0    Noah
#[Out]# 22         0    Noah
#[Out]# 23         0    Noah
#[Out]# 24         0    Noah
#[Out]# 25         0    Noah
#[Out]# 26         0    Noah
#[Out]# 27         0    Noah
#[Out]# 28         0    Noah
#[Out]# 29         0    Noah
#[Out]# ...      ...     ...
#[Out]# 3094690  190  Kostas
#[Out]# 3094691  190  Kostas
#[Out]# 3094692  190  Kostas
#[Out]# 3094693  190  Kostas
#[Out]# 3094694  190  Kostas
#[Out]# 3094695  190  Kostas
#[Out]# 3094696  190  Kostas
#[Out]# 3094697  190  Kostas
#[Out]# 3094698  190  Kostas
#[Out]# 3094699  190  Kostas
#[Out]# 3094700  190  Kostas
#[Out]# 3094701  190  Kostas
#[Out]# 3094702  190  Kostas
#[Out]# 3094703  190  Kostas
#[Out]# 3094704  190  Kostas
#[Out]# 3094705  190  Kostas
#[Out]# 3094706  190  Kostas
#[Out]# 3094707  190  Kostas
#[Out]# 3094708  190  Kostas
#[Out]# 3094709  190  Kostas
#[Out]# 3094710  190  Kostas
#[Out]# 3094711  190  Kostas
#[Out]# 3094712  190  Kostas
#[Out]# 3094713  190  Kostas
#[Out]# 3094714  190  Kostas
#[Out]# 3094715  190  Kostas
#[Out]# 3094716  190  Kostas
#[Out]# 3094717  190  Kostas
#[Out]# 3094718  190  Kostas
#[Out]# 3094719  190  Kostas
#[Out]# 
#[Out]# [3094720 rows x 2 columns]
query2 = '''
    select distinct customer.cID, cName
    from customer, product, purchase
    
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID     cName
#[Out]# 0      0      Noah
#[Out]# 1      1       Sem
#[Out]# 2      2     Lucas
#[Out]# 3      3      Finn
#[Out]# 4      4      Daan
#[Out]# 5      5      Levi
#[Out]# 6      6     Milan
#[Out]# 7      7      Bram
#[Out]# 8      8      Liam
#[Out]# 9      9    Thomas
#[Out]# 10    10       Sam
#[Out]# 11    11     Thijs
#[Out]# 12    12      Adam
#[Out]# 13    13     James
#[Out]# 14    14       Max
#[Out]# 15    15      Noud
#[Out]# 16    16    Julian
#[Out]# 17    17       Dex
#[Out]# 18    18      Hugo
#[Out]# 19    19      Lars
#[Out]# 20    20      Gijs
#[Out]# 21    21  Benjamin
#[Out]# 22    22      Mats
#[Out]# 23    23       Jan
#[Out]# 24    24      Luca
#[Out]# 25    25     Mason
#[Out]# 26    26    Jayden
#[Out]# 27    27       Tim
#[Out]# 28    28      Siem
#[Out]# 29    29     Ruben
#[Out]# ..   ...       ...
#[Out]# 160  160      Lara
#[Out]# 161  161     Floor
#[Out]# 162  162     Elena
#[Out]# 163  163      Cato
#[Out]# 164  164       Evy
#[Out]# 165  165     Hanna
#[Out]# 166  166   Rosalie
#[Out]# 167  167    Veerle
#[Out]# 168  168      Kiki
#[Out]# 169  169      Lily
#[Out]# 170  170      Iris
#[Out]# 171  171     Tessa
#[Out]# 172  172      Lana
#[Out]# 173  173     Livia
#[Out]# 174  174      Romy
#[Out]# 175  175       Sam
#[Out]# 176  176     Amira
#[Out]# 177  177     Eline
#[Out]# 178  178      Elif
#[Out]# 179  179      Juul
#[Out]# 180  180     Merel
#[Out]# 181  181      Liva
#[Out]# 182  182   Johanna
#[Out]# 183  183     Nikki
#[Out]# 184  184     Wilko
#[Out]# 185  185      Nick
#[Out]# 186  186    Angela
#[Out]# 187  188      Pino
#[Out]# 188  189      Koen
#[Out]# 189  190    Kostas
#[Out]# 
#[Out]# [190 rows x 2 columns]
query2 = '''
    select distinct customer.cID, cName
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Onions"
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID     cName
#[Out]# 0      0      Noah
#[Out]# 1      1       Sem
#[Out]# 2      2     Lucas
#[Out]# 3      3      Finn
#[Out]# 4      4      Daan
#[Out]# 5      5      Levi
#[Out]# 6      6     Milan
#[Out]# 7      7      Bram
#[Out]# 8      8      Liam
#[Out]# 9      9    Thomas
#[Out]# 10    10       Sam
#[Out]# 11    11     Thijs
#[Out]# 12    12      Adam
#[Out]# 13    13     James
#[Out]# 14    14       Max
#[Out]# 15    15      Noud
#[Out]# 16    16    Julian
#[Out]# 17    17       Dex
#[Out]# 18    18      Hugo
#[Out]# 19    19      Lars
#[Out]# 20    20      Gijs
#[Out]# 21    21  Benjamin
#[Out]# 22    22      Mats
#[Out]# 23    23       Jan
#[Out]# 24    24      Luca
#[Out]# 25    25     Mason
#[Out]# 26    26    Jayden
#[Out]# 27    27       Tim
#[Out]# 28    28      Siem
#[Out]# 29    29     Ruben
#[Out]# ..   ...       ...
#[Out]# 160  160      Lara
#[Out]# 161  161     Floor
#[Out]# 162  162     Elena
#[Out]# 163  163      Cato
#[Out]# 164  164       Evy
#[Out]# 165  165     Hanna
#[Out]# 166  166   Rosalie
#[Out]# 167  167    Veerle
#[Out]# 168  168      Kiki
#[Out]# 169  169      Lily
#[Out]# 170  170      Iris
#[Out]# 171  171     Tessa
#[Out]# 172  172      Lana
#[Out]# 173  173     Livia
#[Out]# 174  174      Romy
#[Out]# 175  175       Sam
#[Out]# 176  176     Amira
#[Out]# 177  177     Eline
#[Out]# 178  178      Elif
#[Out]# 179  179      Juul
#[Out]# 180  180     Merel
#[Out]# 181  181      Liva
#[Out]# 182  182   Johanna
#[Out]# 183  183     Nikki
#[Out]# 184  184     Wilko
#[Out]# 185  185      Nick
#[Out]# 186  186    Angela
#[Out]# 187  188      Pino
#[Out]# 188  189      Koen
#[Out]# 189  190    Kostas
#[Out]# 
#[Out]# [190 rows x 2 columns]
query2 = '''
    select distinct customer.cID, cName
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Onions" and purchase.cID = customer.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID    cName
#[Out]# 0     2    Lucas
#[Out]# 1    29    Ruben
#[Out]# 2    31  Olivier
#[Out]# 3    33     Sven
#[Out]# 4    52   Willem
#[Out]# 5    59     Joep
#[Out]# 6    85   Pieter
#[Out]# 7   124    Sofie
#[Out]# 8   129    Esmee
#[Out]# 9   162    Elena
#[Out]# 10  165    Hanna
#[Out]# 11  169     Lily
#[Out]# 12  172     Lana
#[Out]# 13  176    Amira
#[Out]# 14  177    Eline
#[Out]# 15  190   Kostas
query2 = '''
    select distinct customer.cID, cName
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Onions"
    and purchase.cID = customer.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID    cName
#[Out]# 0     2    Lucas
#[Out]# 1    29    Ruben
#[Out]# 2    31  Olivier
#[Out]# 3    33     Sven
#[Out]# 4    52   Willem
#[Out]# 5    59     Joep
#[Out]# 6    85   Pieter
#[Out]# 7   124    Sofie
#[Out]# 8   129    Esmee
#[Out]# 9   162    Elena
#[Out]# 10  165    Hanna
#[Out]# 11  169     Lily
#[Out]# 12  172     Lana
#[Out]# 13  176    Amira
#[Out]# 14  177    Eline
#[Out]# 15  190   Kostas
query2 = '''
    select distinct customer.cID, cName
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Onions"
    and purchase.cID = customer.cID
    
    intersection 
    
    select *
    from customer
'''

pd.read_sql_query(query2, conn)
query2 = '''
    select distinct customer.cID, cName
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Onions"
    and purchase.cID = customer.cID
    
    intersection 
    
    select distinct customer.cID, cName
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Coffee"
    and purchase.cID = customer.cID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    select distinct customer.cID, cName
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Onions"
    and purchase.cID = customer.cID
    
    intersect
    
    select distinct customer.cID, cName
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Coffee"
    and purchase.cID = customer.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
query2 = '''
    select distinct customer.cID, cName, date
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Onions"
    and purchase.cID = customer.cID
    
    intersect
    
    select distinct customer.cID, cName, date
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Coffee"
    and purchase.cID = customer.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName        date
#[Out]# 0  124   Sofie  2018-08-26
#[Out]# 1  190  Kostas  2018-08-26
query2 = '''
    select customer.cID, cName, date
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Onions"
    and purchase.cID = customer.cID
    
    intersect
    
    select customer.cID, cName, date
    from customer, product, purchase
    where purchase.pID = product.pID and pName = "Coffee"
    and purchase.cID = customer.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName        date
#[Out]# 0  124   Sofie  2018-08-26
#[Out]# 1  190  Kostas  2018-08-26
query2 = '''
    select distinct customer.cID, cName
    from (
        select customer.cID, cName, date
        from customer, product, purchase
        where purchase.pID = product.pID and pName = "Onions"
        and purchase.cID = customer.cID
    
        intersect
    
        select customer.cID, cName, date
        from customer, product, purchase
        where purchase.pID = product.pID and pName = "Coffee"
        and purchase.cID = customer.cID
    )
'''

pd.read_sql_query(query2, conn)
query2 = '''
    select distinct cID, cName
    from (
        select customer.cID, cName, date
        from customer, product, purchase
        where purchase.pID = product.pID and pName = "Onions"
        and purchase.cID = customer.cID
    
        intersect
    
        select customer.cID, cName, date
        from customer, product, purchase
        where purchase.pID = product.pID and pName = "Coffee"
        and purchase.cID = customer.cID
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    select distinct cID, cName
    from (
        select customer.cID, cName, date
        from customer, product, purchase
        where purchase.pID = product.pID and pName = "Onions"
        and purchase.cID = customer.cID
    
        intersect
    
        select customer.cID, cName, date
        from customer, product, purchase
        where purchase.pID = product.pID and pName = "Coffee"
        and purchase.cID = customer.cID
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    select distinct sID, sName
    from store
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID        sName
#[Out]# 0     0         Coop
#[Out]# 1     1    Hoogvliet
#[Out]# 2     2        Jumbo
#[Out]# 3     3       Sligro
#[Out]# 4     4    Hoogvliet
#[Out]# 5     5       Sligro
#[Out]# 6     6         Coop
#[Out]# 7     7       Sligro
#[Out]# 8     8  Albert Hein
#[Out]# 9     9  Albert Hein
#[Out]# 10   10        Jumbo
#[Out]# 11   11  Albert Hein
#[Out]# 12   12         Lidl
#[Out]# 13   13         Coop
#[Out]# 14   14         Coop
#[Out]# 15   15         Lidl
#[Out]# 16   16         Lidl
#[Out]# 17   17    Hoogvliet
#[Out]# 18   18       Sligro
#[Out]# 19   19         Coop
#[Out]# 20   20        Jumbo
#[Out]# 21   21         Coop
#[Out]# 22   22         Lidl
#[Out]# 23   23         Dirk
#[Out]# 24   24  Albert Hein
#[Out]# 25   25  Albert Hein
#[Out]# 26   26    Hoogvliet
#[Out]# 27   27       Sligro
#[Out]# 28   28    Hoogvliet
#[Out]# 29   29       Sligro
#[Out]# ..  ...          ...
#[Out]# 34   34         Coop
#[Out]# 35   35         Lidl
#[Out]# 36   36         Lidl
#[Out]# 37   37        Jumbo
#[Out]# 38   38    Hoogvliet
#[Out]# 39   39       Sligro
#[Out]# 40   40    Hoogvliet
#[Out]# 41   41  Albert Hein
#[Out]# 42   42       Sligro
#[Out]# 43   43         Coop
#[Out]# 44   44  Albert Hein
#[Out]# 45   45         Coop
#[Out]# 46   46         Lidl
#[Out]# 47   47         Coop
#[Out]# 48   48    Hoogvliet
#[Out]# 49   49    Hoogvliet
#[Out]# 50   50       Sligro
#[Out]# 51   51         Coop
#[Out]# 52   52         Lidl
#[Out]# 53   53         Coop
#[Out]# 54   54         Dirk
#[Out]# 55   55         Coop
#[Out]# 56   56        Jumbo
#[Out]# 57   57         Dirk
#[Out]# 58   58         Dirk
#[Out]# 59   59        Jumbo
#[Out]# 60   60         Lidl
#[Out]# 61   61         Lidl
#[Out]# 62   62        Jumbo
#[Out]# 63   63        Jumbo
#[Out]# 
#[Out]# [64 rows x 2 columns]
query3 = '''
    with count_stores (value) as (
        select count(distinct sID)
        from store)
    select distinct cID
    from purchase
    where count(distinct sID) = count_stores
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with count_stores (value) as (
        select count(distinct sID)
        from store)
    select distinct cID
    from purchase
    where count(distinct sID) = count_stores.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with count_stores(value) as (
        select count(distinct sID)
        from store)
    select distinct cID
    from purchase
    where count(distinct sID) = count_stores.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with count_stores.value as (
        select count(distinct sID)
        from store)
    select distinct cID
    from purchase
    where count(distinct sID) = count_stores.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with count_stores as (
        select count(distinct sID)
        from store)
    select distinct cID
    from purchase
    where count(distinct sID) = count_stores.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with count_stores as (
        select count(distinct sID)
        from store)
    select *
    from count_stores
'''

pd.read_sql_query(query3, conn)
#[Out]#    count(distinct sID)
#[Out]# 0                   64
query3 = '''
    with count_stores as (
        select count(distinct sID) as value
        from store)
    select *
    from count_stores
'''

pd.read_sql_query(query3, conn)
#[Out]#    value
#[Out]# 0     64
query3 = '''
    with count_stores as (
        select count(distinct sID) as value
        from store)
    select distinct cID
    from purchase
    where count(distinct sID) = count_stores.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with count_stores as (
        select count(distinct sID) as value
        from store)
    select distinct cID
    from purchase, count_stores
    where count(distinct sID) = count_stores.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with count_stores as (
        select count(distinct sID) as value
        from store),
        stores_per_cust as (
        select cID, count(distinct sID) as value
        from purchase
        group by cID)
    select distinct cID
    from stores_per_cust, count_stores
    where stores_per_cust.value = count_stores.value
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    with count_stores as (
        select count(distinct sID) as value
        from store),
        stores_per_cust as (
        select cID, count(distinct sID) as value
        from purchase
        group by cID)
    select distinct cID
    from stores_per_cust, count_stores
    where stores_per_cust.value = count_stores.value
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    with count_stores as (
        select count(distinct sID) as value
        from store),
        stores_per_cust as (
        select cID, count(distinct sID) as value
        from purchase
        group by cID)
    select distinct cID
    from stores_per_cust, count_stores
    where stores_per_cust.value = count_stores.value
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    with store_chains as (
        select sName
        from store
        where exists(select sID, sName
                     from store
                     where sID != sID))
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with store_chains as (
        select sName
        from store
        where exists(select sID, sName
                     from store
                     where sID != sID))
    select *
    from store
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID        sName            street       city
#[Out]# 0     0         Coop      Kalverstraat  Amsterdam
#[Out]# 1     1    Hoogvliet  Rozemarijnstraat      Breda
#[Out]# 2     2        Jumbo    Stadhoudersweg  Rotterdam
#[Out]# 3     3       Sligro    Stadhoudersweg  Rotterdam
#[Out]# 4     4    Hoogvliet       Molenstraat  Eindhoven
#[Out]# 5     5       Sligro     Stationsplein      Breda
#[Out]# 6     6         Coop    Stadhoudersweg  Rotterdam
#[Out]# 7     7       Sligro  Wilhelminastraat  Eindhoven
#[Out]# 8     8  Albert Hein       Molenstraat  Eindhoven
#[Out]# 9     9  Albert Hein         Koestraat    Tilburg
#[Out]# 10   10        Jumbo        Bergselaan  Rotterdam
#[Out]# 11   11  Albert Hein          Hofplein  Rotterdam
#[Out]# 12   12         Lidl  Wilhelminastraat  Eindhoven
#[Out]# 13   13         Coop         Koestraat    Tilburg
#[Out]# 14   14         Coop     Keizersgracht  Amsterdam
#[Out]# 15   15         Lidl     Prinsengracht  Amsterdam
#[Out]# 16   16         Lidl     Ambachtstraat    Utrecht
#[Out]# 17   17    Hoogvliet        Kerkstraat  Eindhoven
#[Out]# 18   18       Sligro       Parallelweg    Tilburg
#[Out]# 19   19         Coop       Karrestraat      Breda
#[Out]# 20   20        Jumbo      Kasteeldreef    Tilburg
#[Out]# 21   21         Coop      Kasteeldreef    Tilburg
#[Out]# 22   22         Lidl     Prinsengracht  Amsterdam
#[Out]# 23   23         Dirk     Stationsplein      Breda
#[Out]# 24   24  Albert Hein     Stationsplein      Breda
#[Out]# 25   25  Albert Hein     Stationsplein      Breda
#[Out]# 26   26    Hoogvliet   Sint Annastraat      Breda
#[Out]# 27   27       Sligro      Kalverstraat  Amsterdam
#[Out]# 28   28    Hoogvliet         Koestraat    Tilburg
#[Out]# 29   29       Sligro      Marnixstraat  Amsterdam
#[Out]# ..  ...          ...               ...        ...
#[Out]# 34   34         Coop          Bierkaai  Amsterdam
#[Out]# 35   35         Lidl     Julianastraat    Utrecht
#[Out]# 36   36         Lidl     Julianastraat  Eindhoven
#[Out]# 37   37        Jumbo          Molenweg  Eindhoven
#[Out]# 38   38    Hoogvliet          Hofplein  Rotterdam
#[Out]# 39   39       Sligro       Dorpsstraat  Eindhoven
#[Out]# 40   40    Hoogvliet          Hofplein  Rotterdam
#[Out]# 41   41  Albert Hein        Bergselaan  Rotterdam
#[Out]# 42   42       Sligro      Kalverstraat  Amsterdam
#[Out]# 43   43         Coop    Gasthuisstraat    Utrecht
#[Out]# 44   44  Albert Hein     Ambachtstraat    Utrecht
#[Out]# 45   45         Coop      Kasteeldreef    Tilburg
#[Out]# 46   46         Lidl        Bergselaan  Rotterdam
#[Out]# 47   47         Coop     Julianastraat  Rotterdam
#[Out]# 48   48    Hoogvliet      Kasteeldreef    Tilburg
#[Out]# 49   49    Hoogvliet      Keizerstraat  Rotterdam
#[Out]# 50   50       Sligro     Stationsplein      Breda
#[Out]# 51   51         Coop       Parallelweg    Utrecht
#[Out]# 52   52         Lidl       Nieuwstraat  Eindhoven
#[Out]# 53   53         Coop        Hoogstraat    Utrecht
#[Out]# 54   54         Dirk     Julianastraat  Eindhoven
#[Out]# 55   55         Coop   Sint Annastraat      Breda
#[Out]# 56   56        Jumbo       Parallelweg  Eindhoven
#[Out]# 57   57         Dirk       Molenstraat  Eindhoven
#[Out]# 58   58         Dirk      Keizerstraat  Rotterdam
#[Out]# 59   59        Jumbo  Rozemarijnstraat      Breda
#[Out]# 60   60         Lidl      Pannekoekweg      Breda
#[Out]# 61   61         Lidl      Pannekoekweg      Breda
#[Out]# 62   62        Jumbo     Poffertjesweg  Eindhoven
#[Out]# 63   63        Jumbo     Stationstraat        Oss
#[Out]# 
#[Out]# [64 rows x 4 columns]
query4 = '''
    with store_chains as (
        select sName
        from store
        where exists(select sID, sName
                     from store
                     where sID != sID))
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    with store_chains as (
        select sName
        from store
        where exists(select sID, sName
                     from store
                     where sID != store_chains.sID))
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with store_chains as (
        select sName
        from store
        where exists(select sID, sName
                     from store
                     where sID != store.sID))
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sID
        having count(sName) > 1)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sID)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16         Lidl
#[Out]# 17    Hoogvliet
#[Out]# 18       Sligro
#[Out]# 19         Coop
#[Out]# 20        Jumbo
#[Out]# 21         Coop
#[Out]# 22         Lidl
#[Out]# 23         Dirk
#[Out]# 24  Albert Hein
#[Out]# 25  Albert Hein
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28    Hoogvliet
#[Out]# 29       Sligro
#[Out]# ..          ...
#[Out]# 34         Coop
#[Out]# 35         Lidl
#[Out]# 36         Lidl
#[Out]# 37        Jumbo
#[Out]# 38    Hoogvliet
#[Out]# 39       Sligro
#[Out]# 40    Hoogvliet
#[Out]# 41  Albert Hein
#[Out]# 42       Sligro
#[Out]# 43         Coop
#[Out]# 44  Albert Hein
#[Out]# 45         Coop
#[Out]# 46         Lidl
#[Out]# 47         Coop
#[Out]# 48    Hoogvliet
#[Out]# 49    Hoogvliet
#[Out]# 50       Sligro
#[Out]# 51         Coop
#[Out]# 52         Lidl
#[Out]# 53         Coop
#[Out]# 54         Dirk
#[Out]# 55         Coop
#[Out]# 56        Jumbo
#[Out]# 57         Dirk
#[Out]# 58         Dirk
#[Out]# 59        Jumbo
#[Out]# 60         Lidl
#[Out]# 61         Lidl
#[Out]# 62        Jumbo
#[Out]# 63        Jumbo
#[Out]# 
#[Out]# [64 rows x 1 columns]
query4 = '''
    with store_chains as (
        select sID
        from store
        group by sID)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# ..  ...
#[Out]# 34   34
#[Out]# 35   35
#[Out]# 36   36
#[Out]# 37   37
#[Out]# 38   38
#[Out]# 39   39
#[Out]# 40   40
#[Out]# 41   41
#[Out]# 42   42
#[Out]# 43   43
#[Out]# 44   44
#[Out]# 45   45
#[Out]# 46   46
#[Out]# 47   47
#[Out]# 48   48
#[Out]# 49   49
#[Out]# 50   50
#[Out]# 51   51
#[Out]# 52   52
#[Out]# 53   53
#[Out]# 54   54
#[Out]# 55   55
#[Out]# 56   56
#[Out]# 57   57
#[Out]# 58   58
#[Out]# 59   59
#[Out]# 60   60
#[Out]# 61   61
#[Out]# 62   62
#[Out]# 63   63
#[Out]# 
#[Out]# [64 rows x 1 columns]
query4 = '''
    with store_chains as (
        select *
        from store
        group by sID)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID        sName            street       city
#[Out]# 0     0         Coop      Kalverstraat  Amsterdam
#[Out]# 1     1    Hoogvliet  Rozemarijnstraat      Breda
#[Out]# 2     2        Jumbo    Stadhoudersweg  Rotterdam
#[Out]# 3     3       Sligro    Stadhoudersweg  Rotterdam
#[Out]# 4     4    Hoogvliet       Molenstraat  Eindhoven
#[Out]# 5     5       Sligro     Stationsplein      Breda
#[Out]# 6     6         Coop    Stadhoudersweg  Rotterdam
#[Out]# 7     7       Sligro  Wilhelminastraat  Eindhoven
#[Out]# 8     8  Albert Hein       Molenstraat  Eindhoven
#[Out]# 9     9  Albert Hein         Koestraat    Tilburg
#[Out]# 10   10        Jumbo        Bergselaan  Rotterdam
#[Out]# 11   11  Albert Hein          Hofplein  Rotterdam
#[Out]# 12   12         Lidl  Wilhelminastraat  Eindhoven
#[Out]# 13   13         Coop         Koestraat    Tilburg
#[Out]# 14   14         Coop     Keizersgracht  Amsterdam
#[Out]# 15   15         Lidl     Prinsengracht  Amsterdam
#[Out]# 16   16         Lidl     Ambachtstraat    Utrecht
#[Out]# 17   17    Hoogvliet        Kerkstraat  Eindhoven
#[Out]# 18   18       Sligro       Parallelweg    Tilburg
#[Out]# 19   19         Coop       Karrestraat      Breda
#[Out]# 20   20        Jumbo      Kasteeldreef    Tilburg
#[Out]# 21   21         Coop      Kasteeldreef    Tilburg
#[Out]# 22   22         Lidl     Prinsengracht  Amsterdam
#[Out]# 23   23         Dirk     Stationsplein      Breda
#[Out]# 24   24  Albert Hein     Stationsplein      Breda
#[Out]# 25   25  Albert Hein     Stationsplein      Breda
#[Out]# 26   26    Hoogvliet   Sint Annastraat      Breda
#[Out]# 27   27       Sligro      Kalverstraat  Amsterdam
#[Out]# 28   28    Hoogvliet         Koestraat    Tilburg
#[Out]# 29   29       Sligro      Marnixstraat  Amsterdam
#[Out]# ..  ...          ...               ...        ...
#[Out]# 34   34         Coop          Bierkaai  Amsterdam
#[Out]# 35   35         Lidl     Julianastraat    Utrecht
#[Out]# 36   36         Lidl     Julianastraat  Eindhoven
#[Out]# 37   37        Jumbo          Molenweg  Eindhoven
#[Out]# 38   38    Hoogvliet          Hofplein  Rotterdam
#[Out]# 39   39       Sligro       Dorpsstraat  Eindhoven
#[Out]# 40   40    Hoogvliet          Hofplein  Rotterdam
#[Out]# 41   41  Albert Hein        Bergselaan  Rotterdam
#[Out]# 42   42       Sligro      Kalverstraat  Amsterdam
#[Out]# 43   43         Coop    Gasthuisstraat    Utrecht
#[Out]# 44   44  Albert Hein     Ambachtstraat    Utrecht
#[Out]# 45   45         Coop      Kasteeldreef    Tilburg
#[Out]# 46   46         Lidl        Bergselaan  Rotterdam
#[Out]# 47   47         Coop     Julianastraat  Rotterdam
#[Out]# 48   48    Hoogvliet      Kasteeldreef    Tilburg
#[Out]# 49   49    Hoogvliet      Keizerstraat  Rotterdam
#[Out]# 50   50       Sligro     Stationsplein      Breda
#[Out]# 51   51         Coop       Parallelweg    Utrecht
#[Out]# 52   52         Lidl       Nieuwstraat  Eindhoven
#[Out]# 53   53         Coop        Hoogstraat    Utrecht
#[Out]# 54   54         Dirk     Julianastraat  Eindhoven
#[Out]# 55   55         Coop   Sint Annastraat      Breda
#[Out]# 56   56        Jumbo       Parallelweg  Eindhoven
#[Out]# 57   57         Dirk       Molenstraat  Eindhoven
#[Out]# 58   58         Dirk      Keizerstraat  Rotterdam
#[Out]# 59   59        Jumbo  Rozemarijnstraat      Breda
#[Out]# 60   60         Lidl      Pannekoekweg      Breda
#[Out]# 61   61         Lidl      Pannekoekweg      Breda
#[Out]# 62   62        Jumbo     Poffertjesweg  Eindhoven
#[Out]# 63   63        Jumbo     Stationstraat        Oss
#[Out]# 
#[Out]# [64 rows x 4 columns]
query4 = '''
    with store_chains as (
        select *
        from store
        group by sName)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID        sName           street       city
#[Out]# 0   44  Albert Hein    Ambachtstraat    Utrecht
#[Out]# 1   55         Coop  Sint Annastraat      Breda
#[Out]# 2   58         Dirk     Keizerstraat  Rotterdam
#[Out]# 3   49    Hoogvliet     Keizerstraat  Rotterdam
#[Out]# 4   63        Jumbo    Stationstraat        Oss
#[Out]# 5   61         Lidl     Pannekoekweg      Breda
#[Out]# 6   50       Sligro    Stationsplein      Breda
query4 = '''
    with store_chains as (
        select *
        from store
        group by sName
        having count(sID) > 1)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID        sName           street       city
#[Out]# 0   44  Albert Hein    Ambachtstraat    Utrecht
#[Out]# 1   55         Coop  Sint Annastraat      Breda
#[Out]# 2   58         Dirk     Keizerstraat  Rotterdam
#[Out]# 3   49    Hoogvliet     Keizerstraat  Rotterdam
#[Out]# 4   63        Jumbo    Stationstraat        Oss
#[Out]# 5   61         Lidl     Pannekoekweg      Breda
#[Out]# 6   50       Sligro    Stationsplein      Breda
query4 = '''
    with store_chains as (
        select *
        from store
        group by sName
        having count(sID) > 10)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID sName           street   city
#[Out]# 0   55  Coop  Sint Annastraat  Breda
query4 = '''
    with store_chains as (
        select *
        from store
        group by sName
        having count(sID) > 1)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID        sName           street       city
#[Out]# 0   44  Albert Hein    Ambachtstraat    Utrecht
#[Out]# 1   55         Coop  Sint Annastraat      Breda
#[Out]# 2   58         Dirk     Keizerstraat  Rotterdam
#[Out]# 3   49    Hoogvliet     Keizerstraat  Rotterdam
#[Out]# 4   63        Jumbo    Stationstraat        Oss
#[Out]# 5   61         Lidl     Pannekoekweg      Breda
#[Out]# 6   50       Sligro    Stationsplein      Breda
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(sID) > 1)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with store_chains as (
        select *
        from store
        group by sName
        having count(distinct sID) > 1)
    select *
    from store_chains
    group by sName
    having avg()
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with store_chains as (
        select *
        from store
        group by sName
        having count(distinct sID) > 1)
    select *
    from store_chains
    group by sName
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID        sName           street       city
#[Out]# 0   44  Albert Hein    Ambachtstraat    Utrecht
#[Out]# 1   55         Coop  Sint Annastraat      Breda
#[Out]# 2   58         Dirk     Keizerstraat  Rotterdam
#[Out]# 3   49    Hoogvliet     Keizerstraat  Rotterdam
#[Out]# 4   63        Jumbo    Stationstraat        Oss
#[Out]# 5   61         Lidl     Pannekoekweg      Breda
#[Out]# 6   50       Sligro    Stationsplein      Breda
query4 = '''
    with store_chains as (
        select *
        from store
        group by sName
        having count(distinct sID) > 1)
    select *
    from store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID        sName           street       city
#[Out]# 0   44  Albert Hein    Ambachtstraat    Utrecht
#[Out]# 1   55         Coop  Sint Annastraat      Breda
#[Out]# 2   58         Dirk     Keizerstraat  Rotterdam
#[Out]# 3   49    Hoogvliet     Keizerstraat  Rotterdam
#[Out]# 4   63        Jumbo    Stationstraat        Oss
#[Out]# 5   61         Lidl     Pannekoekweg      Breda
#[Out]# 6   50       Sligro    Stationsplein      Breda
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1)
    select *
    from store
    where sName is in store_chains
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1)
    select *
    from store
        where sName in store_chains
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID        sName            street       city
#[Out]# 0     0         Coop      Kalverstraat  Amsterdam
#[Out]# 1     1    Hoogvliet  Rozemarijnstraat      Breda
#[Out]# 2     2        Jumbo    Stadhoudersweg  Rotterdam
#[Out]# 3     3       Sligro    Stadhoudersweg  Rotterdam
#[Out]# 4     4    Hoogvliet       Molenstraat  Eindhoven
#[Out]# 5     5       Sligro     Stationsplein      Breda
#[Out]# 6     6         Coop    Stadhoudersweg  Rotterdam
#[Out]# 7     7       Sligro  Wilhelminastraat  Eindhoven
#[Out]# 8     8  Albert Hein       Molenstraat  Eindhoven
#[Out]# 9     9  Albert Hein         Koestraat    Tilburg
#[Out]# 10   10        Jumbo        Bergselaan  Rotterdam
#[Out]# 11   11  Albert Hein          Hofplein  Rotterdam
#[Out]# 12   12         Lidl  Wilhelminastraat  Eindhoven
#[Out]# 13   13         Coop         Koestraat    Tilburg
#[Out]# 14   14         Coop     Keizersgracht  Amsterdam
#[Out]# 15   15         Lidl     Prinsengracht  Amsterdam
#[Out]# 16   16         Lidl     Ambachtstraat    Utrecht
#[Out]# 17   17    Hoogvliet        Kerkstraat  Eindhoven
#[Out]# 18   18       Sligro       Parallelweg    Tilburg
#[Out]# 19   19         Coop       Karrestraat      Breda
#[Out]# 20   20        Jumbo      Kasteeldreef    Tilburg
#[Out]# 21   21         Coop      Kasteeldreef    Tilburg
#[Out]# 22   22         Lidl     Prinsengracht  Amsterdam
#[Out]# 23   23         Dirk     Stationsplein      Breda
#[Out]# 24   24  Albert Hein     Stationsplein      Breda
#[Out]# 25   25  Albert Hein     Stationsplein      Breda
#[Out]# 26   26    Hoogvliet   Sint Annastraat      Breda
#[Out]# 27   27       Sligro      Kalverstraat  Amsterdam
#[Out]# 28   28    Hoogvliet         Koestraat    Tilburg
#[Out]# 29   29       Sligro      Marnixstraat  Amsterdam
#[Out]# ..  ...          ...               ...        ...
#[Out]# 34   34         Coop          Bierkaai  Amsterdam
#[Out]# 35   35         Lidl     Julianastraat    Utrecht
#[Out]# 36   36         Lidl     Julianastraat  Eindhoven
#[Out]# 37   37        Jumbo          Molenweg  Eindhoven
#[Out]# 38   38    Hoogvliet          Hofplein  Rotterdam
#[Out]# 39   39       Sligro       Dorpsstraat  Eindhoven
#[Out]# 40   40    Hoogvliet          Hofplein  Rotterdam
#[Out]# 41   41  Albert Hein        Bergselaan  Rotterdam
#[Out]# 42   42       Sligro      Kalverstraat  Amsterdam
#[Out]# 43   43         Coop    Gasthuisstraat    Utrecht
#[Out]# 44   44  Albert Hein     Ambachtstraat    Utrecht
#[Out]# 45   45         Coop      Kasteeldreef    Tilburg
#[Out]# 46   46         Lidl        Bergselaan  Rotterdam
#[Out]# 47   47         Coop     Julianastraat  Rotterdam
#[Out]# 48   48    Hoogvliet      Kasteeldreef    Tilburg
#[Out]# 49   49    Hoogvliet      Keizerstraat  Rotterdam
#[Out]# 50   50       Sligro     Stationsplein      Breda
#[Out]# 51   51         Coop       Parallelweg    Utrecht
#[Out]# 52   52         Lidl       Nieuwstraat  Eindhoven
#[Out]# 53   53         Coop        Hoogstraat    Utrecht
#[Out]# 54   54         Dirk     Julianastraat  Eindhoven
#[Out]# 55   55         Coop   Sint Annastraat      Breda
#[Out]# 56   56        Jumbo       Parallelweg  Eindhoven
#[Out]# 57   57         Dirk       Molenstraat  Eindhoven
#[Out]# 58   58         Dirk      Keizerstraat  Rotterdam
#[Out]# 59   59        Jumbo  Rozemarijnstraat      Breda
#[Out]# 60   60         Lidl      Pannekoekweg      Breda
#[Out]# 61   61         Lidl      Pannekoekweg      Breda
#[Out]# 62   62        Jumbo     Poffertjesweg  Eindhoven
#[Out]# 63   63        Jumbo     Stationstraat        Oss
#[Out]# 
#[Out]# [64 rows x 4 columns]
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1)
    select sName
    from store, 
    where sName in store_chains.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1)
    select sName
    from store,
    where sName in store_chains.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1)
    select sName
    from store
    where sName in store_chains.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1)
    select *
    from store, purchase
    where sName in store_chains
    group by sName
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID        sName           street       city  tID  cID  sID  pID  \
#[Out]# 0   44  Albert Hein    Ambachtstraat    Utrecht  847  190   63   18   
#[Out]# 1   55         Coop  Sint Annastraat      Breda  847  190   63   18   
#[Out]# 2   58         Dirk     Keizerstraat  Rotterdam  847  190   63   18   
#[Out]# 3   49    Hoogvliet     Keizerstraat  Rotterdam  847  190   63   18   
#[Out]# 4   63        Jumbo    Stationstraat        Oss  847  190   63   18   
#[Out]# 5   61         Lidl     Pannekoekweg      Breda  847  190   63   18   
#[Out]# 6   50       Sligro    Stationsplein      Breda  847  190   63   18   
#[Out]# 
#[Out]#          date  quantity  price  
#[Out]# 0  2018-08-21         1    3.3  
#[Out]# 1  2018-08-21         1    3.3  
#[Out]# 2  2018-08-21         1    3.3  
#[Out]# 3  2018-08-21         1    3.3  
#[Out]# 4  2018-08-21         1    3.3  
#[Out]# 5  2018-08-21         1    3.3  
#[Out]# 6  2018-08-21         1    3.3  
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1)
    select *
    from store, purchase
    where sName in store_chains
    group by sName
    having avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID        sName           street       city  tID  cID  sID  pID  \
#[Out]# 0   44  Albert Hein    Ambachtstraat    Utrecht  847  190   63   18   
#[Out]# 1   55         Coop  Sint Annastraat      Breda  847  190   63   18   
#[Out]# 2   58         Dirk     Keizerstraat  Rotterdam  847  190   63   18   
#[Out]# 3   49    Hoogvliet     Keizerstraat  Rotterdam  847  190   63   18   
#[Out]# 4   63        Jumbo    Stationstraat        Oss  847  190   63   18   
#[Out]# 5   61         Lidl     Pannekoekweg      Breda  847  190   63   18   
#[Out]# 6   50       Sligro    Stationsplein      Breda  847  190   63   18   
#[Out]# 
#[Out]#          date  quantity  price  
#[Out]# 0  2018-08-21         1    3.3  
#[Out]# 1  2018-08-21         1    3.3  
#[Out]# 2  2018-08-21         1    3.3  
#[Out]# 3  2018-08-21         1    3.3  
#[Out]# 4  2018-08-21         1    3.3  
#[Out]# 5  2018-08-21         1    3.3  
#[Out]# 6  2018-08-21         1    3.3  
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1)
    select distinct sName
    from store, purchase
    where sName in store_chains
    group by sName
    having avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with store_chains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1)
    select distinct sName
    from store, purchase
    where sName in store_chains and purchase.sID = store.sID
    group by sName
    having avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    with max_price as (
        select max(price)
        from purchase)
    select pName, sID
    from purchase, product
    where price = max_pricer
'''

pd.read_sql_query(query5, conn)
query5 = '''
    with max_price as (
        select max(price)
        from purchase)
    select pName, sID
    from purchase, product
    where price = max_price
'''

pd.read_sql_query(query5, conn)
query5 = '''
    with max_price as (
        select max(price)
        from purchase)
    select pName, sID
    from purchase, product
    where price = max_price.max(price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, sID
    from purchase, product
    where price = max_price.max
'''

pd.read_sql_query(query5, conn)
query5 = '''
    with max_price as (
        select max(price)
        from purchase)
    select pName, sID
    from purchase, product, max_price
    where price = max_price
'''

pd.read_sql_query(query5, conn)
query5 = '''
    with max_price as (
        select max(price)
        from purchase)
    select pName, sID
    from purchase, product, max_price
    where price = max_price.max(price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, sID
    from purchase, product, max_price
    where price = max_price.max
'''

pd.read_sql_query(query5, conn)
#[Out]#                pName  sID
#[Out]# 0        Cashew Nuts   27
#[Out]# 1         Mixed Nuts   27
#[Out]# 2           Potatoes   27
#[Out]# 3       Green Pepper   27
#[Out]# 4             Onions   27
#[Out]# 5          Mushrooms   27
#[Out]# 6            Carrots   27
#[Out]# 7           Tomatoes   27
#[Out]# 8   Hot Dog Sausages   27
#[Out]# 9            Bananas   27
#[Out]# 10             Water   27
#[Out]# 11              Milk   27
#[Out]# 12              Beef   27
#[Out]# 13              Eggs   27
#[Out]# 14            Apples   27
#[Out]# 15         Cucumbers   27
#[Out]# 16              Rice   27
#[Out]# 17             Bread   27
#[Out]# 18            Cheese   27
#[Out]# 19              Coca   27
#[Out]# 20             Fanta   27
#[Out]# 21            Coffee   27
#[Out]# 22               Tea   27
#[Out]# 23   Spiced Biscuits   27
#[Out]# 24           Oranges   27
#[Out]# 25            Donuts   27
#[Out]# 26             Pasta   27
#[Out]# 27             Pizza   27
#[Out]# 28           Lasanga   27
#[Out]# 29            Salmon   27
#[Out]# 30           Ketchup   27
#[Out]# 31   French baguette   27
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, sID
    from purchase, product, max_price
    where price = max_price.max and purchase.pID = product.pID
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID
#[Out]# 0  Beef   27
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, sID, sName
    from purchase, product, max_price, store
    where price = max_price.max and purchase.pID = product.pID
'''

pd.read_sql_query(query5, conn)
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, store.sID, sName
    from purchase, product, max_price, store
    where price = max_price.max and purchase.pID = product.pID
'''

pd.read_sql_query(query5, conn)
#[Out]#    pName  sID        sName
#[Out]# 0   Beef    0         Coop
#[Out]# 1   Beef    1    Hoogvliet
#[Out]# 2   Beef    2        Jumbo
#[Out]# 3   Beef    3       Sligro
#[Out]# 4   Beef    4    Hoogvliet
#[Out]# 5   Beef    5       Sligro
#[Out]# 6   Beef    6         Coop
#[Out]# 7   Beef    7       Sligro
#[Out]# 8   Beef    8  Albert Hein
#[Out]# 9   Beef    9  Albert Hein
#[Out]# 10  Beef   10        Jumbo
#[Out]# 11  Beef   11  Albert Hein
#[Out]# 12  Beef   12         Lidl
#[Out]# 13  Beef   13         Coop
#[Out]# 14  Beef   14         Coop
#[Out]# 15  Beef   15         Lidl
#[Out]# 16  Beef   16         Lidl
#[Out]# 17  Beef   17    Hoogvliet
#[Out]# 18  Beef   18       Sligro
#[Out]# 19  Beef   19         Coop
#[Out]# 20  Beef   20        Jumbo
#[Out]# 21  Beef   21         Coop
#[Out]# 22  Beef   22         Lidl
#[Out]# 23  Beef   23         Dirk
#[Out]# 24  Beef   24  Albert Hein
#[Out]# 25  Beef   25  Albert Hein
#[Out]# 26  Beef   26    Hoogvliet
#[Out]# 27  Beef   27       Sligro
#[Out]# 28  Beef   28    Hoogvliet
#[Out]# 29  Beef   29       Sligro
#[Out]# ..   ...  ...          ...
#[Out]# 34  Beef   34         Coop
#[Out]# 35  Beef   35         Lidl
#[Out]# 36  Beef   36         Lidl
#[Out]# 37  Beef   37        Jumbo
#[Out]# 38  Beef   38    Hoogvliet
#[Out]# 39  Beef   39       Sligro
#[Out]# 40  Beef   40    Hoogvliet
#[Out]# 41  Beef   41  Albert Hein
#[Out]# 42  Beef   42       Sligro
#[Out]# 43  Beef   43         Coop
#[Out]# 44  Beef   44  Albert Hein
#[Out]# 45  Beef   45         Coop
#[Out]# 46  Beef   46         Lidl
#[Out]# 47  Beef   47         Coop
#[Out]# 48  Beef   48    Hoogvliet
#[Out]# 49  Beef   49    Hoogvliet
#[Out]# 50  Beef   50       Sligro
#[Out]# 51  Beef   51         Coop
#[Out]# 52  Beef   52         Lidl
#[Out]# 53  Beef   53         Coop
#[Out]# 54  Beef   54         Dirk
#[Out]# 55  Beef   55         Coop
#[Out]# 56  Beef   56        Jumbo
#[Out]# 57  Beef   57         Dirk
#[Out]# 58  Beef   58         Dirk
#[Out]# 59  Beef   59        Jumbo
#[Out]# 60  Beef   60         Lidl
#[Out]# 61  Beef   61         Lidl
#[Out]# 62  Beef   62        Jumbo
#[Out]# 63  Beef   63        Jumbo
#[Out]# 
#[Out]# [64 rows x 3 columns]
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, purchase.sID, sName
    from purchase, product, max_price, store
    where price = max_price.max and purchase.pID = product.pID
'''

pd.read_sql_query(query5, conn)
#[Out]#    pName  sID        sName
#[Out]# 0   Beef   27         Coop
#[Out]# 1   Beef   27    Hoogvliet
#[Out]# 2   Beef   27        Jumbo
#[Out]# 3   Beef   27       Sligro
#[Out]# 4   Beef   27    Hoogvliet
#[Out]# 5   Beef   27       Sligro
#[Out]# 6   Beef   27         Coop
#[Out]# 7   Beef   27       Sligro
#[Out]# 8   Beef   27  Albert Hein
#[Out]# 9   Beef   27  Albert Hein
#[Out]# 10  Beef   27        Jumbo
#[Out]# 11  Beef   27  Albert Hein
#[Out]# 12  Beef   27         Lidl
#[Out]# 13  Beef   27         Coop
#[Out]# 14  Beef   27         Coop
#[Out]# 15  Beef   27         Lidl
#[Out]# 16  Beef   27         Lidl
#[Out]# 17  Beef   27    Hoogvliet
#[Out]# 18  Beef   27       Sligro
#[Out]# 19  Beef   27         Coop
#[Out]# 20  Beef   27        Jumbo
#[Out]# 21  Beef   27         Coop
#[Out]# 22  Beef   27         Lidl
#[Out]# 23  Beef   27         Dirk
#[Out]# 24  Beef   27  Albert Hein
#[Out]# 25  Beef   27  Albert Hein
#[Out]# 26  Beef   27    Hoogvliet
#[Out]# 27  Beef   27       Sligro
#[Out]# 28  Beef   27    Hoogvliet
#[Out]# 29  Beef   27       Sligro
#[Out]# ..   ...  ...          ...
#[Out]# 34  Beef   27         Coop
#[Out]# 35  Beef   27         Lidl
#[Out]# 36  Beef   27         Lidl
#[Out]# 37  Beef   27        Jumbo
#[Out]# 38  Beef   27    Hoogvliet
#[Out]# 39  Beef   27       Sligro
#[Out]# 40  Beef   27    Hoogvliet
#[Out]# 41  Beef   27  Albert Hein
#[Out]# 42  Beef   27       Sligro
#[Out]# 43  Beef   27         Coop
#[Out]# 44  Beef   27  Albert Hein
#[Out]# 45  Beef   27         Coop
#[Out]# 46  Beef   27         Lidl
#[Out]# 47  Beef   27         Coop
#[Out]# 48  Beef   27    Hoogvliet
#[Out]# 49  Beef   27    Hoogvliet
#[Out]# 50  Beef   27       Sligro
#[Out]# 51  Beef   27         Coop
#[Out]# 52  Beef   27         Lidl
#[Out]# 53  Beef   27         Coop
#[Out]# 54  Beef   27         Dirk
#[Out]# 55  Beef   27         Coop
#[Out]# 56  Beef   27        Jumbo
#[Out]# 57  Beef   27         Dirk
#[Out]# 58  Beef   27         Dirk
#[Out]# 59  Beef   27        Jumbo
#[Out]# 60  Beef   27         Lidl
#[Out]# 61  Beef   27         Lidl
#[Out]# 62  Beef   27        Jumbo
#[Out]# 63  Beef   27        Jumbo
#[Out]# 
#[Out]# [64 rows x 3 columns]
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, purchase.sID, sName
    from purchase, product, max_price, store
    where price = max_price.max and purchase.pID = product.pID and store.sID = purchase.sID
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID   sName
#[Out]# 0  Beef   27  Sligro
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, sID
    from purchase, product, max_price, store
    where price = max_price.max and purchase.pID = product.pID
'''

pd.read_sql_query(query5, conn)
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, sID
    from purchase, product, max_price
    where price = max_price.max and purchase.pID = product.pID
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID
#[Out]# 0  Beef   27
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, sID, price
    from purchase, product, max_price
    where price = max_price.max and purchase.pID = product.pID
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID  price
#[Out]# 0  Beef   27   13.8
query5 = '''
    with max_price as (
        select max(price) as max
        from purchase)
    select pName, sID
    from purchase, product, max_price
    where price = max_price.max and purchase.pID = product.pID
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID
#[Out]# 0  Beef   27
query6 = '''
    select sID, pID, unit_price
    from inventory
    group by pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     sID  pID  unit_price
#[Out]# 0     0    0        5.95
#[Out]# 1    43    1        6.55
#[Out]# 2    57    2        2.30
#[Out]# 3     5    3        1.30
#[Out]# 4    52    4        0.90
#[Out]# 5     6    5        0.50
#[Out]# 6    57    6        1.15
#[Out]# 7    56    7        2.10
#[Out]# 8    25    8        5.55
#[Out]# 9    46    9        1.80
#[Out]# 10   27   10        0.55
#[Out]# 11   24   11        0.85
#[Out]# 12    9   12       13.15
#[Out]# 13    4   13        4.20
#[Out]# 14   25   14        3.70
#[Out]# 15   39   15        1.00
#[Out]# 16   35   16        1.85
#[Out]# 17   57   17        2.40
#[Out]# 18   45   18        9.20
#[Out]# 19   60   19        1.75
#[Out]# 20   38   20        2.20
#[Out]# 21   27   21        2.00
#[Out]# 22   40   22        2.05
#[Out]# 23    8   23        2.00
#[Out]# 24   12   24        3.85
#[Out]# 25   17   25        3.90
#[Out]# 26    6   26        2.70
#[Out]# 27   43   27        9.00
#[Out]# 28   27   28        8.10
query6 = '''
    select pID, sID, unit_price
    from inventory
    group by pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     pID  sID  unit_price
#[Out]# 0     0    0        5.95
#[Out]# 1     1   43        6.55
#[Out]# 2     2   57        2.30
#[Out]# 3     3    5        1.30
#[Out]# 4     4   52        0.90
#[Out]# 5     5    6        0.50
#[Out]# 6     6   57        1.15
#[Out]# 7     7   56        2.10
#[Out]# 8     8   25        5.55
#[Out]# 9     9   46        1.80
#[Out]# 10   10   27        0.55
#[Out]# 11   11   24        0.85
#[Out]# 12   12    9       13.15
#[Out]# 13   13    4        4.20
#[Out]# 14   14   25        3.70
#[Out]# 15   15   39        1.00
#[Out]# 16   16   35        1.85
#[Out]# 17   17   57        2.40
#[Out]# 18   18   45        9.20
#[Out]# 19   19   60        1.75
#[Out]# 20   20   38        2.20
#[Out]# 21   21   27        2.00
#[Out]# 22   22   40        2.05
#[Out]# 23   23    8        2.00
#[Out]# 24   24   12        3.85
#[Out]# 25   25   17        3.90
#[Out]# 26   26    6        2.70
#[Out]# 27   27   43        9.00
#[Out]# 28   28   27        8.10
query6 = '''
    select pID, sID, unit_price
    from inventory
    group by pID
    having count(sID) > 0
'''

pd.read_sql_query(query6, conn)
#[Out]#     pID  sID  unit_price
#[Out]# 0     0    0        5.95
#[Out]# 1     1   43        6.55
#[Out]# 2     2   57        2.30
#[Out]# 3     3    5        1.30
#[Out]# 4     4   52        0.90
#[Out]# 5     5    6        0.50
#[Out]# 6     6   57        1.15
#[Out]# 7     7   56        2.10
#[Out]# 8     8   25        5.55
#[Out]# 9     9   46        1.80
#[Out]# 10   10   27        0.55
#[Out]# 11   11   24        0.85
#[Out]# 12   12    9       13.15
#[Out]# 13   13    4        4.20
#[Out]# 14   14   25        3.70
#[Out]# 15   15   39        1.00
#[Out]# 16   16   35        1.85
#[Out]# 17   17   57        2.40
#[Out]# 18   18   45        9.20
#[Out]# 19   19   60        1.75
#[Out]# 20   20   38        2.20
#[Out]# 21   21   27        2.00
#[Out]# 22   22   40        2.05
#[Out]# 23   23    8        2.00
#[Out]# 24   24   12        3.85
#[Out]# 25   25   17        3.90
#[Out]# 26   26    6        2.70
#[Out]# 27   27   43        9.00
#[Out]# 28   28   27        8.10
query6 = '''
    select pID, sID, unit_price
    from inventory
    group by pID
    having count(sID) > 1
'''

pd.read_sql_query(query6, conn)
#[Out]#     pID  sID  unit_price
#[Out]# 0     0    0        5.95
#[Out]# 1     1   43        6.55
#[Out]# 2     2   57        2.30
#[Out]# 3     3    5        1.30
#[Out]# 4     4   52        0.90
#[Out]# 5     5    6        0.50
#[Out]# 6     6   57        1.15
#[Out]# 7     7   56        2.10
#[Out]# 8     8   25        5.55
#[Out]# 9     9   46        1.80
#[Out]# 10   10   27        0.55
#[Out]# 11   11   24        0.85
#[Out]# 12   12    9       13.15
#[Out]# 13   13    4        4.20
#[Out]# 14   14   25        3.70
#[Out]# 15   15   39        1.00
#[Out]# 16   16   35        1.85
#[Out]# 17   17   57        2.40
#[Out]# 18   18   45        9.20
#[Out]# 19   19   60        1.75
#[Out]# 20   20   38        2.20
#[Out]# 21   21   27        2.00
#[Out]# 22   22   40        2.05
#[Out]# 23   23    8        2.00
#[Out]# 24   24   12        3.85
#[Out]# 25   25   17        3.90
#[Out]# 26   26    6        2.70
#[Out]# 27   27   43        9.00
#[Out]# 28   28   27        8.10
query6 = '''
    select pID, sID, min(unit_price), max(unit_price)
    from inventory
    group by pID
    
'''

pd.read_sql_query(query6, conn)
#[Out]#     pID  sID  min(unit_price)  max(unit_price)
#[Out]# 0     0    0             3.70             5.95
#[Out]# 1     1   48             4.40             6.55
#[Out]# 2     2   32             1.65             2.35
#[Out]# 3     3    4             1.20             1.80
#[Out]# 4     4   19             0.80             1.20
#[Out]# 5     5    9             0.40             0.60
#[Out]# 6     6   53             0.90             1.20
#[Out]# 7     7   17             1.60             2.40
#[Out]# 8     8   33             4.05             5.70
#[Out]# 9     9   46             1.20             1.80
#[Out]# 10   10   55             0.40             0.60
#[Out]# 11   11    8             0.80             1.20
#[Out]# 12   12    8            10.15            14.90
#[Out]# 13   13    4             2.85             4.20
#[Out]# 14   14    9             3.20             4.75
#[Out]# 15   15   23             1.00             1.40
#[Out]# 16   16    4             1.40             2.10
#[Out]# 17   17    9             1.75             2.60
#[Out]# 18   18   44             8.55            12.00
#[Out]# 19   19   27             1.75             3.00
#[Out]# 20   20    3             1.90             2.75
#[Out]# 21   21   14             1.60             2.35
#[Out]# 22   22   59             1.45             2.15
#[Out]# 23   23   44             1.80             2.60
#[Out]# 24   24   31             2.85             4.20
#[Out]# 25   25   37             3.25             4.70
#[Out]# 26   26   52             2.45             3.55
#[Out]# 27   27   58             6.65             9.45
#[Out]# 28   28    9             6.85            10.05
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        group by pID
    )
    select max - min
    from product_prices
        
'''

pd.read_sql_query(query6, conn)
#[Out]#     max - min
#[Out]# 0        2.25
#[Out]# 1        2.15
#[Out]# 2        0.70
#[Out]# 3        0.60
#[Out]# 4        0.40
#[Out]# 5        0.20
#[Out]# 6        0.30
#[Out]# 7        0.80
#[Out]# 8        1.65
#[Out]# 9        0.60
#[Out]# 10       0.20
#[Out]# 11       0.40
#[Out]# 12       4.75
#[Out]# 13       1.35
#[Out]# 14       1.55
#[Out]# 15       0.40
#[Out]# 16       0.70
#[Out]# 17       0.85
#[Out]# 18       3.45
#[Out]# 19       1.25
#[Out]# 20       0.85
#[Out]# 21       0.75
#[Out]# 22       0.70
#[Out]# 23       0.80
#[Out]# 24       1.35
#[Out]# 25       1.45
#[Out]# 26       1.10
#[Out]# 27       2.80
#[Out]# 28       3.20
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        group by pID
    )
    select max - min
    from product_prices
    group by pID
    having (max(max-min))
'''

pd.read_sql_query(query6, conn)
#[Out]#     max - min
#[Out]# 0        2.25
#[Out]# 1        2.15
#[Out]# 2        0.70
#[Out]# 3        0.60
#[Out]# 4        0.40
#[Out]# 5        0.20
#[Out]# 6        0.30
#[Out]# 7        0.80
#[Out]# 8        1.65
#[Out]# 9        0.60
#[Out]# 10       0.20
#[Out]# 11       0.40
#[Out]# 12       4.75
#[Out]# 13       1.35
#[Out]# 14       1.55
#[Out]# 15       0.40
#[Out]# 16       0.70
#[Out]# 17       0.85
#[Out]# 18       3.45
#[Out]# 19       1.25
#[Out]# 20       0.85
#[Out]# 21       0.75
#[Out]# 22       0.70
#[Out]# 23       0.80
#[Out]# 24       1.35
#[Out]# 25       1.45
#[Out]# 26       1.10
#[Out]# 27       2.80
#[Out]# 28       3.20
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        group by pID
    ),  max_difference as (
        select max(max-min) as max_diff
        from product_prices
        group by pID
    )
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        group by pID
    ),  max_difference as (
        select max(max-min) as max_diff
        from product_prices
        group by pID
    )
    select *
    from product_prices max_difference
    where max-min = max_difference.max_diff
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        group by pID
    ),  max_difference as (
        select max(max-min) as max_diff
        from product_prices
        group by pID
    )
    select max_diff
    from product_prices, max_difference
    where max-min = max_difference.max_diff
'''

pd.read_sql_query(query6, conn)
#[Out]#     max_diff
#[Out]# 0       2.25
#[Out]# 1       2.15
#[Out]# 2       0.70
#[Out]# 3       0.70
#[Out]# 4       0.60
#[Out]# 5       0.60
#[Out]# 6       0.40
#[Out]# 7       0.40
#[Out]# 8       0.40
#[Out]# 9       0.20
#[Out]# 10      0.20
#[Out]# 11      0.30
#[Out]# 12      0.80
#[Out]# 13      1.65
#[Out]# 14      0.60
#[Out]# 15      0.60
#[Out]# 16      0.20
#[Out]# 17      0.20
#[Out]# 18      0.40
#[Out]# 19      0.40
#[Out]# 20      0.40
#[Out]# 21      4.75
#[Out]# 22      1.35
#[Out]# 23      1.35
#[Out]# 24      1.55
#[Out]# 25      0.40
#[Out]# 26      0.40
#[Out]# 27      0.40
#[Out]# 28      0.70
#[Out]# 29      0.70
#[Out]# 30      0.85
#[Out]# 31      0.85
#[Out]# 32      3.45
#[Out]# 33      1.25
#[Out]# 34      0.85
#[Out]# 35      0.85
#[Out]# 36      0.75
#[Out]# 37      0.70
#[Out]# 38      0.80
#[Out]# 39      1.35
#[Out]# 40      1.35
#[Out]# 41      1.45
#[Out]# 42      1.10
#[Out]# 43      2.80
#[Out]# 44      3.20
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        group by pID
    ),  max_difference as (
        select max(max-min) as max_diff
        from product_prices
        group by pID
    )
    select *
    from product_prices, max_difference
    where max-min = max_difference.max_diff
'''

pd.read_sql_query(query6, conn)
#[Out]#     pID  sID    min    max  max_diff
#[Out]# 0     0    0   3.70   5.95      2.25
#[Out]# 1     1   48   4.40   6.55      2.15
#[Out]# 2     2   32   1.65   2.35      0.70
#[Out]# 3     2   32   1.65   2.35      0.70
#[Out]# 4     3    4   1.20   1.80      0.60
#[Out]# 5     3    4   1.20   1.80      0.60
#[Out]# 6     4   19   0.80   1.20      0.40
#[Out]# 7     4   19   0.80   1.20      0.40
#[Out]# 8     4   19   0.80   1.20      0.40
#[Out]# 9     5    9   0.40   0.60      0.20
#[Out]# 10    5    9   0.40   0.60      0.20
#[Out]# 11    6   53   0.90   1.20      0.30
#[Out]# 12    7   17   1.60   2.40      0.80
#[Out]# 13    8   33   4.05   5.70      1.65
#[Out]# 14    9   46   1.20   1.80      0.60
#[Out]# 15    9   46   1.20   1.80      0.60
#[Out]# 16   10   55   0.40   0.60      0.20
#[Out]# 17   10   55   0.40   0.60      0.20
#[Out]# 18   11    8   0.80   1.20      0.40
#[Out]# 19   11    8   0.80   1.20      0.40
#[Out]# 20   11    8   0.80   1.20      0.40
#[Out]# 21   12    8  10.15  14.90      4.75
#[Out]# 22   13    4   2.85   4.20      1.35
#[Out]# 23   13    4   2.85   4.20      1.35
#[Out]# 24   14    9   3.20   4.75      1.55
#[Out]# 25   15   23   1.00   1.40      0.40
#[Out]# 26   15   23   1.00   1.40      0.40
#[Out]# 27   15   23   1.00   1.40      0.40
#[Out]# 28   16    4   1.40   2.10      0.70
#[Out]# 29   16    4   1.40   2.10      0.70
#[Out]# 30   17    9   1.75   2.60      0.85
#[Out]# 31   17    9   1.75   2.60      0.85
#[Out]# 32   18   44   8.55  12.00      3.45
#[Out]# 33   19   27   1.75   3.00      1.25
#[Out]# 34   20    3   1.90   2.75      0.85
#[Out]# 35   20    3   1.90   2.75      0.85
#[Out]# 36   21   14   1.60   2.35      0.75
#[Out]# 37   22   59   1.45   2.15      0.70
#[Out]# 38   23   44   1.80   2.60      0.80
#[Out]# 39   24   31   2.85   4.20      1.35
#[Out]# 40   24   31   2.85   4.20      1.35
#[Out]# 41   25   37   3.25   4.70      1.45
#[Out]# 42   26   52   2.45   3.55      1.10
#[Out]# 43   27   58   6.65   9.45      2.80
#[Out]# 44   28    9   6.85  10.05      3.20
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        group by pID
    ),  max_difference as (
        select max(max-min) as max_diff
        from product_prices
        group by pID
    )
    select *
    from max_difference
    where max-min = max_difference.max_diff
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        group by pID
    ),  max_difference as (
        select max(max-min) as max_diff
        from product_prices
        group by pID
    )
    select *
    from max_difference
'''

pd.read_sql_query(query6, conn)
#[Out]#     max_diff
#[Out]# 0       2.25
#[Out]# 1       2.15
#[Out]# 2       0.70
#[Out]# 3       0.60
#[Out]# 4       0.40
#[Out]# 5       0.20
#[Out]# 6       0.30
#[Out]# 7       0.80
#[Out]# 8       1.65
#[Out]# 9       0.60
#[Out]# 10      0.20
#[Out]# 11      0.40
#[Out]# 12      4.75
#[Out]# 13      1.35
#[Out]# 14      1.55
#[Out]# 15      0.40
#[Out]# 16      0.70
#[Out]# 17      0.85
#[Out]# 18      3.45
#[Out]# 19      1.25
#[Out]# 20      0.85
#[Out]# 21      0.75
#[Out]# 22      0.70
#[Out]# 23      0.80
#[Out]# 24      1.35
#[Out]# 25      1.45
#[Out]# 26      1.10
#[Out]# 27      2.80
#[Out]# 28      3.20
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        group by pID
    ),  max_difference as (
        select max(max-min) as max_diff
        from product_prices
    )
    select *
    from max_difference
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_diff
#[Out]# 0      4.75
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        where date = "2018-08-23"
        group by pID
    ),  max_difference as (
        select max(max-min) as max_diff
        from product_prices
    )
    select *
    from max_difference
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_diff
#[Out]# 0       2.0
query6 = '''
    with product_prices as (
        select pID, sID, min(unit_price) as min, max(unit_price) as max
        from inventory
        where date = "2018-08-23"
        group by pID
    ),  max_difference as (
        select max(max-min) as max_diff
        from product_prices
    )
    select max_diff
    from max_difference
'''

pd.read_sql_query(query6, conn)
#[Out]#    max_diff
#[Out]# 0       2.0
