# IPython log file

query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.pID = i2.pID
        AND i1.sID <> i2.sID
        AND i1.date = '2018-08-23'
        AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT pID, COUNT(*)
    FROM purchase
    GROUP BY pID
    HAVING COUNT(*) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  COUNT(*)
#[Out]# 0   29         2
#[Out]# 1   30         2
query6 = '''
    SELECT MAX(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.pID = i2.pID
        AND i1.sID <> i2.sID
        AND i1.date = '2018-08-23'
        AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
