# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
q = '''
create view expense as
(select c.cID, c.cName, s.sID, s.sName, p.date, sum(p.quantity * p.price) as totalprice
from customer c, store s, purchase p
where p.cID = c.cID AND p.sID = s.sID AND 
group_by s.sID, date)

'''
pd.read_sql_query(q, conn)
q = '''
create view expense as
(select c.cID, c.cName, s.sID, s.sName, p.date, sum(p.price) as totalprice
from customer c, store s, purchase p
where p.cID = c.cID AND p.sID = s.sID AND 
group_by s.sID, date)

'''
pd.read_sql_query(q, conn)
q = '''
create view expense as (
  select
    c.cID,
    c.cName,
    s.sID,
    s.sName,
    p.date,
    sum(p.quantity * p.price) as totalprice
  from
    customer c,
    store s,
    purchase p
  where
    p.cID = c.cID
    AND p.sID = s.sID
    AND
  group by
    s.sID,
    p.date
)
'''
pd.read_sql_query(q, conn)
q = '''
create view expense as (
  select
    c.cID,
    c.cName,
    s.sID,
    s.sName,
    p.date,
    sum(p.quantity * p.price) as totalprice
  from
    customer c,
    store s,
    purchase p
  where
    p.cID = c.cID
    AND p.sID = s.sID
    AND
  group by
    s.sID,
    p.date
)
'''
pd.read_sql_query(q, conn)
q = '''
create view expense as (
  select c.cID, c.cName, s.sID, s.sName, p.date, sum(p.quantity * p.price) as totalprice
  from customer c, store s, purchase p 
  where p.cID = c.cID AND p.sID = s.sID
  group by s.sID, p.date)
'''
pd.read_sql_query(q, conn)
q = '''
select p.id
from product p
where p.id not in 
(select p1.id
from purchase p1, purchase p2, purchase p3
where p1.pID = p2.pID AND p2.pID = p3.pID AND p1.pID = p3.pID
p1.cID <> p2.cID AND p1.cID <> p3.cID AND p2.cID <> p3.cID)
'''
pd.read_sql_query(q, conn)
q = '''
select p.id
from product p
where p.id not in (select p1.id
from purchase p1, purchase p2, purchase p3
where p1.pID = p2.pID AND p2.pID = p3.pID AND p1.pID = p3.pID
p1.cID <> p2.cID AND p1.cID <> p3.cID AND p2.cID <> p3.cID)
'''
pd.read_sql_query(q, conn)
q = '''
select p.id
from product p
where p.id not in (select p1.id
from purchase as p1, purchase as p2, purchase as p3
where p1.pID = p2.pID AND p2.pID = p3.pID AND p1.pID = p3.pID
p1.cID <> p2.cID AND p1.cID <> p3.cID AND p2.cID <> p3.cID)
'''
pd.read_sql_query(q, conn)
q = '''
select p.id
from product as p
where p.id not in (select p1.id
from purchase as p1, purchase as p2, purchase as p3
where p1.pID = p2.pID AND p2.pID = p3.pID AND p1.pID = p3.pID
p1.cID <> p2.cID AND p1.cID <> p3.cID AND p2.cID <> p3.cID)
'''
pd.read_sql_query(q, conn)
q = '''
SELECT p.id
FROM product AS p
WHERE p.id NOT IN (SELECT p1.id
FROM purchase AS p1, purchase AS p2, purchase AS p3
WHERE p1.pID = p2.pID AND p2.pID = p3.pID AND p1.pID = p3.pID
p1.cID <> p2.cID AND p1.cID <> p3.cID AND p2.cID <> p3.cID)
'''
pd.read_sql_query(q, conn)
q = '''
SELECT
  p.id
FROM
  product AS p
WHERE
  p.id NOT IN (
    SELECT
      p1.id
    FROM
      purchase AS p1,
      purchase AS p2,
      purchase AS p3
    WHERE
      p1.pID = p2.pID
      AND p2.pID = p3.pID
      AND p1.pID = p3.pID
      AND p1.cID <> p2.cID
      AND p1.cID <> p3.cID
      AND p2.cID <> p3.cID
  )
'''
pd.read_sql_query(q, conn)
q = '''
SELECT
  p.pID
FROM
  product AS p
WHERE
  p.pID NOT IN (
    SELECT
      p1.pID
    FROM
      purchase AS p1,
      purchase AS p2,
      purchase AS p3
    WHERE
      p1.pID = p2.pID
      AND p2.pID = p3.pID
      AND p1.pID = p3.pID
      AND p1.cID <> p2.cID
      AND p1.cID <> p3.cID
      AND p2.cID <> p3.cID
  )
'''
pd.read_sql_query(q, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
q4_1 = '''
SELECT
  p.pID
FROM
  product AS p
WHERE
  p.pID NOT IN (
    SELECT
      p1.pID
    FROM
      purchase AS p1,
      purchase AS p2,
      purchase AS p3
    WHERE
      p1.pID = p2.pID
      AND p2.pID = p3.pID
      AND p1.pID = p3.pID
      AND p1.cID <> p2.cID
      AND p1.cID <> p3.cID
      AND p2.cID <> p3.cID
  )
'''
pd.read_sql_query(q4_1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
q4_2 = '''
select
  distinct c.cID,
  c.cName
from
  customer c,
  purchase p1,
  purchase p2,
  product pr1,
  product pr2
where
  c.cID = p1.cID
  AND p1.cID
  AND p2.cID
  AND p1.date = p2.date
  AND pr1.pID = p1.pID
  AND pr2.pID = p2.pID
  AND pr1.cName = "Onions"
  AND pr2.cName = "Coffee"
'''
pd.read_sql_query(q4_2, conn)
q4_2 = '''
select
  distinct c.cID,
  c.cName
from
  customer c,
  purchase p1,
  purchase p2,
  product pr1,
  product pr2
where
  c.cID = p1.cID
  AND p1.cID
  AND p2.cID
  AND p1.date = p2.date
  AND pr1.pID = p1.pID
  AND pr2.pID = p2.pID
  AND pr1.pName = "Onions"
  AND pr2.pName = "Coffee"
'''
pd.read_sql_query(q4_2, conn)
#[Out]#     cID    cName
#[Out]# 0    29    Ruben
#[Out]# 1   129    Esmee
#[Out]# 2    33     Sven
#[Out]# 3    85   Pieter
#[Out]# 4    52   Willem
#[Out]# 5    59     Joep
#[Out]# 6   176    Amira
#[Out]# 7   177    Eline
#[Out]# 8   124    Sofie
#[Out]# 9   190   Kostas
#[Out]# 10  169     Lily
#[Out]# 11   31  Olivier
#[Out]# 12  172     Lana
q4_4 = '''
select sName
from (select s.sName, avg(p.quantity)
from purchase p, store s
where p.sID = s.sID AND 
p.sID in (select distinct (s1.sID, s2.sID)
from store s1, store s2
where s1.sName = s2.sName)
group by s.sName) as x (sName, avg_quantity)
where avg_quantity > 4
'''
pd.read_sql_query(q4_4, conn)
q4_4 = '''
select
  sName
from
  (
    select
      s.sName,
      avg(p.quantity)
    from
      purchase p,
      store s
    where
      p.sID = s.sID
      AND p.sID in (
        select
          distinct (s1.sID, s2.sID)
        from
          store s1,
          store s2
        where
          s1.sName = s2.sName
      )
    group by
      s.sName
  ) as x
where
  avg_quantity > 4
'''
pd.read_sql_query(q4_4, conn)
q4_4 = '''
select
  sName
from
  (
    select
      s.sName,
      avg(p.quantity)
    from
      purchase p,
      store s
    where
      p.sID = s.sID
      AND p.sID in (
        select
          distinct (s1.sID, s2.sID)
        from
          store s1,
          store s2
        where
          s1.sName = s2.sName
      )
    group by
      s.sName
  ) as x
where
  avg_quantity > 4
'''
pd.read_sql_query(q4_4, conn)
q4_4 = '''
select
  sName
from
  (
    select
      s.sName,
      avg(p.quantity)
    from
      purchase as p,
      store as s
    where
      p.sID = s.sID
      AND p.sID in (
        select
          distinct (s1.sID, s2.sID)
        from
          store as s1,
          store as s2
        where
          s1.sName = s2.sName
      )
    group by
      s.sName
  ) as x
where
  avg_quantity > 4
'''
pd.read_sql_query(q4_4, conn)
q4_4 = '''
select
  sName
from
  (
    select
      s.sName,
      avg(p.quantity)
    from
      purchase as p,
      store as s
    where
      p.sID = s.sID
      AND p.sID in (
        select
          distinct (s1.sID, s2.sID)
        from
          store as s1,
          store as s2
        where
          s1.sName = s2.sName
      )
    group by
      s.sName
  ) as x
'''
pd.read_sql_query(q4_4, conn)
q4_4 = '''
select
  sName
from
  (
    select
      s.sName,
      avg(p.quantity)
    from
      purchase as p,
      store as s
    where
      p.sID = s.sID
      AND p.sID in (
        select
          distinct (s1.sID, s2.sID)
        from
          store as s1,
          store as s2
        where
          s1.sName = s2.sName
      )
    group by
      s.sName
  ) as x
where
  avg_quantity > 4
'''
pd.read_sql_query(q4_4, conn)
q4_4 = '''
select
  x.sName
from
  (
    select
      s.sName,
      avg(p.quantity) as avg_quantity
    from
      purchase as p,
      store as s
    where
      p.sID = s.sID
      AND p.sID in (
        select
          distinct (s1.sID, s2.sID)
        from
          store as s1,
          store as s2
        where
          s1.sName = s2.sName
      )
    group by
      s.sName
  ) as x
where
  x.avg_quantity > 4
'''
pd.read_sql_query(q4_4, conn)
q4_5 = '''
select avg(i.unit_price)
from inventory i
group by i.pID
'''
pd.read_sql_query(q4_5, conn)
#[Out]#     avg(i.unit_price)
#[Out]# 0            4.679687
#[Out]# 1            5.570313
#[Out]# 2            1.970833
#[Out]# 3            1.480882
#[Out]# 4            0.991379
#[Out]# 5            0.488889
#[Out]# 6            1.047727
#[Out]# 7            2.004348
#[Out]# 8            4.993478
#[Out]# 9            1.479167
#[Out]# 10           0.509091
#[Out]# 11           0.962000
#[Out]# 12          12.506250
#[Out]# 13           3.516667
#[Out]# 14           4.100000
#[Out]# 15           1.188889
#[Out]# 16           1.805556
#[Out]# 17           2.121154
#[Out]# 18          10.118750
#[Out]# 19           2.474074
#[Out]# 20           2.303226
#[Out]# 21           2.043750
#[Out]# 22           1.791667
#[Out]# 23           2.216667
#[Out]# 24           3.481667
#[Out]# 25           4.058000
#[Out]# 26           3.051667
#[Out]# 27           8.090909
#[Out]# 28           8.201471
q4_5 = '''
select avg(i.unit_price) as avg_unitprice
from inventory i
group by i.pID
'''
pd.read_sql_query(q4_5, conn)
#[Out]#     avg_unitprice
#[Out]# 0        4.679687
#[Out]# 1        5.570313
#[Out]# 2        1.970833
#[Out]# 3        1.480882
#[Out]# 4        0.991379
#[Out]# 5        0.488889
#[Out]# 6        1.047727
#[Out]# 7        2.004348
#[Out]# 8        4.993478
#[Out]# 9        1.479167
#[Out]# 10       0.509091
#[Out]# 11       0.962000
#[Out]# 12      12.506250
#[Out]# 13       3.516667
#[Out]# 14       4.100000
#[Out]# 15       1.188889
#[Out]# 16       1.805556
#[Out]# 17       2.121154
#[Out]# 18      10.118750
#[Out]# 19       2.474074
#[Out]# 20       2.303226
#[Out]# 21       2.043750
#[Out]# 22       1.791667
#[Out]# 23       2.216667
#[Out]# 24       3.481667
#[Out]# 25       4.058000
#[Out]# 26       3.051667
#[Out]# 27       8.090909
#[Out]# 28       8.201471
q4_6 = '''
select max_price - min_price as difference
from (select max(i1.unit_price), min(i2.unit_price)
from inventory i1, inventory i2
where i1.date = "2018-08-23" AND i2.date = "2018-08-23" AND 
i1.sID <> i2.sID) as x (max_price, min_price)
'''
pd.read_sql_query(q4_6, conn)
q4_6 = '''
select max_price - min_price as difference
from (select max(i1.unit_price) as max_price, min(i2.unit_price) as min_price
from inventory i1, inventory i2
where i1.date = "2018-08-23" AND i2.date = "2018-08-23" AND 
i1.sID <> i2.sID) as x
'''
pd.read_sql_query(q4_6, conn)
#[Out]#    difference
#[Out]# 0       12.95
q4_5 = '''
select x.pName, x.sName
from (select pr.pName, s.sName, max(p.price) as max_price
from product pr, store s, purchase p
where pr.pID = p.pID AND s.sID = p.sID) as x 
'''
pd.read_sql_query(q4_5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
q4_4 = '''
select distinct (s1.sID, s2.sID)
from store s1, store s2
where s1.sName = s2.sName
'''
pd.read_sql_query(q4_4, conn)
q4_4 = '''
select distinct s1.sID, s2.sID
from store s1, store s2
where s1.sName = s2.sName
'''
pd.read_sql_query(q4_4, conn)
#[Out]#      sID  sID
#[Out]# 0      0    0
#[Out]# 1      0    6
#[Out]# 2      0   13
#[Out]# 3      0   14
#[Out]# 4      0   19
#[Out]# 5      0   21
#[Out]# 6      0   31
#[Out]# 7      0   34
#[Out]# 8      0   43
#[Out]# 9      0   45
#[Out]# 10     0   47
#[Out]# 11     0   51
#[Out]# 12     0   53
#[Out]# 13     0   55
#[Out]# 14     1    1
#[Out]# 15     1    4
#[Out]# 16     1   17
#[Out]# 17     1   26
#[Out]# 18     1   28
#[Out]# 19     1   38
#[Out]# 20     1   40
#[Out]# 21     1   48
#[Out]# 22     1   49
#[Out]# 23     2    2
#[Out]# 24     2   10
#[Out]# 25     2   20
#[Out]# 26     2   37
#[Out]# 27     2   56
#[Out]# 28     2   59
#[Out]# 29     2   62
#[Out]# ..   ...  ...
#[Out]# 592   60   46
#[Out]# 593   60   52
#[Out]# 594   60   60
#[Out]# 595   60   61
#[Out]# 596   61   12
#[Out]# 597   61   15
#[Out]# 598   61   16
#[Out]# 599   61   22
#[Out]# 600   61   35
#[Out]# 601   61   36
#[Out]# 602   61   46
#[Out]# 603   61   52
#[Out]# 604   61   60
#[Out]# 605   61   61
#[Out]# 606   62    2
#[Out]# 607   62   10
#[Out]# 608   62   20
#[Out]# 609   62   37
#[Out]# 610   62   56
#[Out]# 611   62   59
#[Out]# 612   62   62
#[Out]# 613   62   63
#[Out]# 614   63    2
#[Out]# 615   63   10
#[Out]# 616   63   20
#[Out]# 617   63   37
#[Out]# 618   63   56
#[Out]# 619   63   59
#[Out]# 620   63   62
#[Out]# 621   63   63
#[Out]# 
#[Out]# [622 rows x 2 columns]
q4_4 = '''
select distinct s1.sID
from store s1, store s2
where s1.sName = s2.sName
'''
pd.read_sql_query(q4_4, conn)
#[Out]#     sID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# ..  ...
#[Out]# 34   34
#[Out]# 35   35
#[Out]# 36   36
#[Out]# 37   37
#[Out]# 38   38
#[Out]# 39   39
#[Out]# 40   40
#[Out]# 41   41
#[Out]# 42   42
#[Out]# 43   43
#[Out]# 44   44
#[Out]# 45   45
#[Out]# 46   46
#[Out]# 47   47
#[Out]# 48   48
#[Out]# 49   49
#[Out]# 50   50
#[Out]# 51   51
#[Out]# 52   52
#[Out]# 53   53
#[Out]# 54   54
#[Out]# 55   55
#[Out]# 56   56
#[Out]# 57   57
#[Out]# 58   58
#[Out]# 59   59
#[Out]# 60   60
#[Out]# 61   61
#[Out]# 62   62
#[Out]# 63   63
#[Out]# 
#[Out]# [64 rows x 1 columns]
q4_4 = '''
select distinct s1.sID
from store s1, store s2
where s1.sName = s2.sName AND s1.sID <> s2.sID
'''
pd.read_sql_query(q4_4, conn)
#[Out]#     sID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# ..  ...
#[Out]# 34   34
#[Out]# 35   35
#[Out]# 36   36
#[Out]# 37   37
#[Out]# 38   38
#[Out]# 39   39
#[Out]# 40   40
#[Out]# 41   41
#[Out]# 42   42
#[Out]# 43   43
#[Out]# 44   44
#[Out]# 45   45
#[Out]# 46   46
#[Out]# 47   47
#[Out]# 48   48
#[Out]# 49   49
#[Out]# 50   50
#[Out]# 51   51
#[Out]# 52   52
#[Out]# 53   53
#[Out]# 54   54
#[Out]# 55   55
#[Out]# 56   56
#[Out]# 57   57
#[Out]# 58   58
#[Out]# 59   59
#[Out]# 60   60
#[Out]# 61   61
#[Out]# 62   62
#[Out]# 63   63
#[Out]# 
#[Out]# [64 rows x 1 columns]
q4_4 = '''
select distinct s1.sID, s1.sName
from store s1, store s2
where s1.sName = s2.sName AND s1.sID <> s2.sID
'''
pd.read_sql_query(q4_4, conn)
#[Out]#     sID        sName
#[Out]# 0     0         Coop
#[Out]# 1     1    Hoogvliet
#[Out]# 2     2        Jumbo
#[Out]# 3     3       Sligro
#[Out]# 4     4    Hoogvliet
#[Out]# 5     5       Sligro
#[Out]# 6     6         Coop
#[Out]# 7     7       Sligro
#[Out]# 8     8  Albert Hein
#[Out]# 9     9  Albert Hein
#[Out]# 10   10        Jumbo
#[Out]# 11   11  Albert Hein
#[Out]# 12   12         Lidl
#[Out]# 13   13         Coop
#[Out]# 14   14         Coop
#[Out]# 15   15         Lidl
#[Out]# 16   16         Lidl
#[Out]# 17   17    Hoogvliet
#[Out]# 18   18       Sligro
#[Out]# 19   19         Coop
#[Out]# 20   20        Jumbo
#[Out]# 21   21         Coop
#[Out]# 22   22         Lidl
#[Out]# 23   23         Dirk
#[Out]# 24   24  Albert Hein
#[Out]# 25   25  Albert Hein
#[Out]# 26   26    Hoogvliet
#[Out]# 27   27       Sligro
#[Out]# 28   28    Hoogvliet
#[Out]# 29   29       Sligro
#[Out]# ..  ...          ...
#[Out]# 34   34         Coop
#[Out]# 35   35         Lidl
#[Out]# 36   36         Lidl
#[Out]# 37   37        Jumbo
#[Out]# 38   38    Hoogvliet
#[Out]# 39   39       Sligro
#[Out]# 40   40    Hoogvliet
#[Out]# 41   41  Albert Hein
#[Out]# 42   42       Sligro
#[Out]# 43   43         Coop
#[Out]# 44   44  Albert Hein
#[Out]# 45   45         Coop
#[Out]# 46   46         Lidl
#[Out]# 47   47         Coop
#[Out]# 48   48    Hoogvliet
#[Out]# 49   49    Hoogvliet
#[Out]# 50   50       Sligro
#[Out]# 51   51         Coop
#[Out]# 52   52         Lidl
#[Out]# 53   53         Coop
#[Out]# 54   54         Dirk
#[Out]# 55   55         Coop
#[Out]# 56   56        Jumbo
#[Out]# 57   57         Dirk
#[Out]# 58   58         Dirk
#[Out]# 59   59        Jumbo
#[Out]# 60   60         Lidl
#[Out]# 61   61         Lidl
#[Out]# 62   62        Jumbo
#[Out]# 63   63        Jumbo
#[Out]# 
#[Out]# [64 rows x 2 columns]
q4_4 = '''
select s.sID, s.sName
from store s
where s.sID not in 
(select distinct s1.sID, s1.sName
from store s1, store s2
where s1.sName = s2.sName AND s1.sID <> s2.sID)
'''
pd.read_sql_query(q4_4, conn)
q4_4 = '''
select s.sID, s.sName
from store s
where s.sID not in (select distinct s1.sID, s1.sName
from store s1, store s2
where s1.sName = s2.sName AND s1.sID <> s2.sID)
'''
pd.read_sql_query(q4_4, conn)
q4_4 = '''
select s.sID, s.sName
from store s
where s.sID not in (select distinct s1.sID
from store s1, store s2
where s1.sName = s2.sName AND s1.sID <> s2.sID)
'''
pd.read_sql_query(q4_4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sID, sName]
#[Out]# Index: []
q4_4 = '''
select s.sID, s.sName
from store s
'''
pd.read_sql_query(q4_4, conn)
#[Out]#     sID        sName
#[Out]# 0     0         Coop
#[Out]# 1     1    Hoogvliet
#[Out]# 2     2        Jumbo
#[Out]# 3     3       Sligro
#[Out]# 4     4    Hoogvliet
#[Out]# 5     5       Sligro
#[Out]# 6     6         Coop
#[Out]# 7     7       Sligro
#[Out]# 8     8  Albert Hein
#[Out]# 9     9  Albert Hein
#[Out]# 10   10        Jumbo
#[Out]# 11   11  Albert Hein
#[Out]# 12   12         Lidl
#[Out]# 13   13         Coop
#[Out]# 14   14         Coop
#[Out]# 15   15         Lidl
#[Out]# 16   16         Lidl
#[Out]# 17   17    Hoogvliet
#[Out]# 18   18       Sligro
#[Out]# 19   19         Coop
#[Out]# 20   20        Jumbo
#[Out]# 21   21         Coop
#[Out]# 22   22         Lidl
#[Out]# 23   23         Dirk
#[Out]# 24   24  Albert Hein
#[Out]# 25   25  Albert Hein
#[Out]# 26   26    Hoogvliet
#[Out]# 27   27       Sligro
#[Out]# 28   28    Hoogvliet
#[Out]# 29   29       Sligro
#[Out]# ..  ...          ...
#[Out]# 34   34         Coop
#[Out]# 35   35         Lidl
#[Out]# 36   36         Lidl
#[Out]# 37   37        Jumbo
#[Out]# 38   38    Hoogvliet
#[Out]# 39   39       Sligro
#[Out]# 40   40    Hoogvliet
#[Out]# 41   41  Albert Hein
#[Out]# 42   42       Sligro
#[Out]# 43   43         Coop
#[Out]# 44   44  Albert Hein
#[Out]# 45   45         Coop
#[Out]# 46   46         Lidl
#[Out]# 47   47         Coop
#[Out]# 48   48    Hoogvliet
#[Out]# 49   49    Hoogvliet
#[Out]# 50   50       Sligro
#[Out]# 51   51         Coop
#[Out]# 52   52         Lidl
#[Out]# 53   53         Coop
#[Out]# 54   54         Dirk
#[Out]# 55   55         Coop
#[Out]# 56   56        Jumbo
#[Out]# 57   57         Dirk
#[Out]# 58   58         Dirk
#[Out]# 59   59        Jumbo
#[Out]# 60   60         Lidl
#[Out]# 61   61         Lidl
#[Out]# 62   62        Jumbo
#[Out]# 63   63        Jumbo
#[Out]# 
#[Out]# [64 rows x 2 columns]
q4_4 = '''
select
  x.sName
from
  (
    select
      s.sName,
      avg(p.quantity) as avg_quantity
    from
      purchase p,
      store s
    where
      p.sID = s.sID
      AND p.sID in (
        select
          distinct s1.sID
        from
          store s1,
          store s2
        where
          s1.sName = s2.sName
          AND s1.sID <> s2.sID
      )
    group by
      s.sName
  ) as x
where
  x.avg_quantity > 4
'''
pd.read_sql_query(q4_4, conn)
#[Out]#        x.sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
q4_4 = '''
select
  sName
from
  (
    select
      s.sName,
      avg(p.quantity) as avg_quantity
    from
      purchase p,
      store s
    where
      p.sID = s.sID
      AND p.sID in (
        select
          distinct s1.sID
        from
          store s1,
          store s2
        where
          s1.sName = s2.sName
          AND s1.sID <> s2.sID
      )
    group by
      s.sName
  ) as x
where
  x.avg_quantity > 4
'''
pd.read_sql_query(q4_4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
q4_4 = '''
select
  sName
from
  (
    select
      s.sName,
      avg(p.quantity) as avg_quantity
    from
      purchase p,
      store s
    where
      p.sID = s.sID
      AND p.sID in (
        select
          distinct s1.sID
        from
          store s1,
          store s2
        where
          s1.sName = s2.sName
          AND s1.sID <> s2.sID
      )
    group by
      s.sName
  ) as x
where
  avg_quantity > 4
'''
pd.read_sql_query(q4_4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
q4_2 = '''
select
  distinct c.cID,
  c.cName
from
  customer c,
  purchase p1,
  purchase p2,
  product pr1,
  product pr2
where
  c.cID = p1.cID
  AND p1.cID = p2.cID
  AND p1.date = p2.date
  AND pr1.pID = p1.pID
  AND pr2.pID = p2.pID
  AND pr1.pName = "Onions"
  AND pr2.pName = "Coffee"
'''
pd.read_sql_query(q4_2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
