# IPython log file

query1 = '''
    SELECT pID FROM product
'''

pd.read_sql_query(query1, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT pID FROM product
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
#[Out]# 31   31
query1 = '''
    SELECT pID FROM product WHERE pID NOT IN purchase
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID FROM product WHERE pID NOT IN (SELECT pID FROM purchase)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   31
query1 = '''
    SELECT pID FROM product WHERE pID NOT IN (SELECT DISTINCT pID FROM purchase)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   31
query1 = '''
    SELECT pID FROM product 
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
#[Out]# 31   31
query1 = '''
    SELECT pID FROM purchase 
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 479   28
#[Out]# 480   27
#[Out]# 481    5
#[Out]# 482   28
#[Out]# 483    7
#[Out]# 484    0
#[Out]# 485   11
#[Out]# 486    6
#[Out]# 487   19
#[Out]# 488   17
#[Out]# 489    9
#[Out]# 490   11
#[Out]# 491   22
#[Out]# 492   17
#[Out]# 493   20
#[Out]# 494   11
#[Out]# 495   21
#[Out]# 496   23
#[Out]# 497   23
#[Out]# 498    8
#[Out]# 499    0
#[Out]# 500    8
#[Out]# 501   11
#[Out]# 502   15
#[Out]# 503    2
#[Out]# 504   17
#[Out]# 505    5
#[Out]# 506   19
#[Out]# 507    9
#[Out]# 508   18
#[Out]# 
#[Out]# [509 rows x 1 columns]
query1 = '''
    SELECT distinct pID FROM purchase 
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0    10
#[Out]# 1    14
#[Out]# 2    16
#[Out]# 3     9
#[Out]# 4    25
#[Out]# 5    26
#[Out]# 6    11
#[Out]# 7    27
#[Out]# 8    20
#[Out]# 9     4
#[Out]# 10   13
#[Out]# 11   22
#[Out]# 12    8
#[Out]# 13   12
#[Out]# 14    6
#[Out]# 15   28
#[Out]# 16   19
#[Out]# 17    2
#[Out]# 18   24
#[Out]# 19    0
#[Out]# 20   23
#[Out]# 21   17
#[Out]# 22    3
#[Out]# 23    5
#[Out]# 24   21
#[Out]# 25    7
#[Out]# 26   15
#[Out]# 27   18
#[Out]# 28    1
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
    SELECT pID FROM purchase GROUP BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
    SELECT pID, count(pID) FROM purchase GROUP BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  count(pID)
#[Out]# 0     0          25
#[Out]# 1     1          13
#[Out]# 2     2          10
#[Out]# 3     3          20
#[Out]# 4     4          16
#[Out]# 5     5          16
#[Out]# 6     6          15
#[Out]# 7     7          14
#[Out]# 8     8          13
#[Out]# 9     9          20
#[Out]# 10   10          16
#[Out]# 11   11          16
#[Out]# 12   12          16
#[Out]# 13   13          21
#[Out]# 14   14          18
#[Out]# 15   15          14
#[Out]# 16   16          20
#[Out]# 17   17          18
#[Out]# 18   18          10
#[Out]# 19   19          26
#[Out]# 20   20          18
#[Out]# 21   21          22
#[Out]# 22   22          21
#[Out]# 23   23          13
#[Out]# 24   24          20
#[Out]# 25   25          14
#[Out]# 26   26          20
#[Out]# 27   27          15
#[Out]# 28   28          25
#[Out]# 29   29           2
#[Out]# 30   30           2
query1 = '''
    SELECT pID, count(pID) FROM purchase GROUP BY pID HAVING count(pID)<=2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(pID)
#[Out]# 0   29           2
#[Out]# 1   30           2
query1 = '''
    SELECT pID FROM purchase GROUP BY pID HAVING count(pID)<=2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT pID FROM product WHERE pID NOT IN(
    SELECT pID FROM purchase GROUP BY pID HAVING count(pID)<=2)
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   31
query1 = '''
    SELECT pID FROM purchase GROUP BY pID HAVING count(pID)<=2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT pID FROM purchase GROUP BY pID 
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
    SELECT pID, cID FROM purchase WHERE 
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID, cID FROM purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID  cID
#[Out]# 0     10    0
#[Out]# 1     14    1
#[Out]# 2     16    1
#[Out]# 3      9    1
#[Out]# 4     25    1
#[Out]# 5     26    1
#[Out]# 6     11    1
#[Out]# 7     27    1
#[Out]# 8     20    2
#[Out]# 9      9    2
#[Out]# 10     4    2
#[Out]# 11    13    2
#[Out]# 12    22    2
#[Out]# 13    14    3
#[Out]# 14    26    3
#[Out]# 15     9    3
#[Out]# 16     8    4
#[Out]# 17    27    4
#[Out]# 18    12    4
#[Out]# 19     6    4
#[Out]# 20    13    4
#[Out]# 21    26    4
#[Out]# 22    14    5
#[Out]# 23    28    5
#[Out]# 24     6    5
#[Out]# 25    22    5
#[Out]# 26    16    5
#[Out]# 27    19    5
#[Out]# 28    19    7
#[Out]# 29     2    7
#[Out]# ..   ...  ...
#[Out]# 479   28  190
#[Out]# 480   27  190
#[Out]# 481    5  190
#[Out]# 482   28  190
#[Out]# 483    7  190
#[Out]# 484    0  190
#[Out]# 485   11  190
#[Out]# 486    6  190
#[Out]# 487   19  190
#[Out]# 488   17  190
#[Out]# 489    9  190
#[Out]# 490   11  190
#[Out]# 491   22  190
#[Out]# 492   17  190
#[Out]# 493   20  190
#[Out]# 494   11  190
#[Out]# 495   21  190
#[Out]# 496   23  190
#[Out]# 497   23  190
#[Out]# 498    8  190
#[Out]# 499    0  190
#[Out]# 500    8  190
#[Out]# 501   11  190
#[Out]# 502   15  190
#[Out]# 503    2  190
#[Out]# 504   17  190
#[Out]# 505    5  190
#[Out]# 506   19  190
#[Out]# 507    9  190
#[Out]# 508   18  190
#[Out]# 
#[Out]# [509 rows x 2 columns]
query1 = '''
    SELECT pID, cID FROM purchase WHERE pID=30
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID
#[Out]# 0   30  188
#[Out]# 1   30  188
query1 = '''
    SELECT pID, cID FROM purchase WHERE pID=31
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID, cID]
#[Out]# Index: []
query1 = '''
    SELECT pID, cID FROM purchase WHERE pID=29
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID
#[Out]# 0   29  185
#[Out]# 1   29  186
query1 = '''
    SELECT pID, cID FROM purchase WHERE pID=30
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID
#[Out]# 0   30  188
#[Out]# 1   30  188
query1 = '''
    SELECT distinct pID, cID FROM purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID  cID
#[Out]# 0     10    0
#[Out]# 1     14    1
#[Out]# 2     16    1
#[Out]# 3      9    1
#[Out]# 4     25    1
#[Out]# 5     26    1
#[Out]# 6     11    1
#[Out]# 7     27    1
#[Out]# 8     20    2
#[Out]# 9      9    2
#[Out]# 10     4    2
#[Out]# 11    13    2
#[Out]# 12    22    2
#[Out]# 13    14    3
#[Out]# 14    26    3
#[Out]# 15     9    3
#[Out]# 16     8    4
#[Out]# 17    27    4
#[Out]# 18    12    4
#[Out]# 19     6    4
#[Out]# 20    13    4
#[Out]# 21    26    4
#[Out]# 22    14    5
#[Out]# 23    28    5
#[Out]# 24     6    5
#[Out]# 25    22    5
#[Out]# 26    16    5
#[Out]# 27    19    5
#[Out]# 28    19    7
#[Out]# 29     2    7
#[Out]# ..   ...  ...
#[Out]# 438    0  184
#[Out]# 439   29  185
#[Out]# 440   29  186
#[Out]# 441   30  188
#[Out]# 442    7  189
#[Out]# 443   19  189
#[Out]# 444   27  190
#[Out]# 445   19  190
#[Out]# 446   28  190
#[Out]# 447    7  190
#[Out]# 448    2  190
#[Out]# 449   10  190
#[Out]# 450   22  190
#[Out]# 451   20  190
#[Out]# 452   21  190
#[Out]# 453    9  190
#[Out]# 454   26  190
#[Out]# 455    0  190
#[Out]# 456   15  190
#[Out]# 457    4  190
#[Out]# 458   23  190
#[Out]# 459   17  190
#[Out]# 460   25  190
#[Out]# 461    3  190
#[Out]# 462    5  190
#[Out]# 463   13  190
#[Out]# 464   11  190
#[Out]# 465    6  190
#[Out]# 466    8  190
#[Out]# 467   18  190
#[Out]# 
#[Out]# [468 rows x 2 columns]
query1 = '''
    SELECT distinct pID, cID FROM purchase GROUP BY pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  cID
#[Out]# 0     0  190
#[Out]# 1     1  169
#[Out]# 2     2  190
#[Out]# 3     3  190
#[Out]# 4     4  190
#[Out]# 5     5  190
#[Out]# 6     6  190
#[Out]# 7     7  190
#[Out]# 8     8  190
#[Out]# 9     9  190
#[Out]# 10   10  190
#[Out]# 11   11  190
#[Out]# 12   12  162
#[Out]# 13   13  190
#[Out]# 14   14  179
#[Out]# 15   15  190
#[Out]# 16   16  179
#[Out]# 17   17  190
#[Out]# 18   18  190
#[Out]# 19   19  190
#[Out]# 20   20  190
#[Out]# 21   21  190
#[Out]# 22   22  190
#[Out]# 23   23  190
#[Out]# 24   24  178
#[Out]# 25   25  190
#[Out]# 26   26  190
#[Out]# 27   27  190
#[Out]# 28   28  190
#[Out]# 29   29  186
#[Out]# 30   30  188
query1 = '''
    SELECT distinct pID, cID FROM purchase GROUP BY pID HAVING count(pID)<=2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  cID
#[Out]# 0   29  186
#[Out]# 1   30  188
query1 = '''
    SELECT pID FROM(SELECT distinct pID, cID FROM purchase GROUP BY pID HAVING count(pID)<=2)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT pID FROM(SELECT distinct pID, cID FROM purchase GROUP BY pID HAVING count(pID)<=2) 
    UNION
    SELECT pID FROM product WHERE pID NOT IN (SELECT pID FROM purchase)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    SELECT cID, name
    FROM customer c, purchase p, product pr
    WHERE c.cID=p.cID AND p.pID=pr.pID AND pr.pName="Onions"
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.name
    FROM customer c, purchase p, product pr
    WHERE c.cID=p.cID AND p.pID=pr.pID AND pr.pName="Onions"
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName
    FROM customer c, purchase p, product pr
    WHERE c.cID=p.cID AND p.pID=pr.pID AND pr.pName="Onions"
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID    cName
#[Out]# 0     2    Lucas
#[Out]# 1    29    Ruben
#[Out]# 2    31  Olivier
#[Out]# 3    33     Sven
#[Out]# 4    52   Willem
#[Out]# 5    59     Joep
#[Out]# 6    85   Pieter
#[Out]# 7   124    Sofie
#[Out]# 8   129    Esmee
#[Out]# 9   162    Elena
#[Out]# 10  165    Hanna
#[Out]# 11  169     Lily
#[Out]# 12  172     Lana
#[Out]# 13  176    Amira
#[Out]# 14  177    Eline
#[Out]# 15  190   Kostas
query2 = '''
    SELECT c.cID, c.cName
    FROM customer c, purchase p, product pr
    WHERE c.cID=p.cID AND p.pID=pr.pID AND pr.pName="Onions" AND (c.cID, c.cName) EXISTS IN(
    SELECT c.cID, c.cName
    FROM customer c, purchase p, product pr
    WHERE c.cID=p.cID AND p.pID=pr.pID AND pr.pName="Coffee"
    )
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName
    FROM customer c, purchase p, product pr
    WHERE c.cID=p.cID AND p.pID=pr.pID AND pr.pName="Onions" AND (c.cID, c.cName) IN(
    SELECT c.cID, c.cName
    FROM customer c, purchase p, product pr
    WHERE c.cID=p.cID AND p.pID=pr.pID AND pr.pName="Coffee"
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, product pr1
    WHERE c1.cID=p1.cID AND p1.pID=pr1.pID AND pr1.pName="Onions" AND (c1.cID, c1.cName) IN(
    SELECT c2.cID, c2.cName
    FROM customer c2, purchase p2, product pr2
    WHERE c2.cID=p2.cID AND p2.pID=pr2.pID AND pr2.pName="Coffee"
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
query2 = '''
    SELECT c1.cID, c1.cName, p1.date
    FROM customer c1, purchase p1, product pr1
    WHERE c1.cID=p1.cID AND p1.pID=pr1.pID AND pr1.pName="Onions" AND (c1.cID, c1.cName) IN(
    SELECT c2.cID, c2.cName, p2.date
    FROM customer c2, purchase p2, product pr2
    WHERE c2.cID=p2.cID AND p2.pID=pr2.pID AND pr2.pName="Coffee"
    )
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c1.cID, c1.cName, p1.date
    FROM customer c1, purchase p1, product pr1
    WHERE c1.cID=p1.cID AND p1.pID=pr1.pID AND pr1.pName="Onions" AND (c1.cID, c1.cName) IN(
    SELECT c2.cID, c2.cName
    FROM customer c2, purchase p2, product pr2
    WHERE c2.cID=p2.cID AND p2.pID=pr2.pID AND pr2.pName="Coffee"
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName        date
#[Out]# 0   59    Joep  2018-08-25
#[Out]# 1  124   Sofie  2018-08-26
#[Out]# 2  169    Lily  2018-08-20
#[Out]# 3  176   Amira  2018-08-22
#[Out]# 4  190  Kostas  2018-08-26
query2 = '''
    SELECT c1.cID, c1.cName, p1.date
    FROM customer c1, purchase p1, product pr1
    WHERE c1.cID=p1.cID AND p1.pID=pr1.pID AND pr1.pName="Onions" AND (c1.cID, c1.cName, p1.date) IN(
    SELECT c2.cID, c2.cName, p2.date
    FROM customer c2, purchase p2, product pr2
    WHERE c2.cID=p2.cID AND p2.pID=pr2.pID AND pr2.pName="Coffee"
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName        date
#[Out]# 0  124   Sofie  2018-08-26
#[Out]# 1  190  Kostas  2018-08-26
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, product pr1
    WHERE c1.cID=p1.cID AND p1.pID=pr1.pID AND pr1.pName="Onions" AND (c1.cID, c1.cName, p1.date) IN(
    SELECT c2.cID, c2.cName, p2.date
    FROM customer c2, purchase p2, product pr2
    WHERE c2.cID=p2.cID AND p2.pID=pr2.pID AND pr2.pName="Coffee"
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT *
    FROM store
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID        sName            street       city
#[Out]# 0     0         Coop      Kalverstraat  Amsterdam
#[Out]# 1     1    Hoogvliet  Rozemarijnstraat      Breda
#[Out]# 2     2        Jumbo    Stadhoudersweg  Rotterdam
#[Out]# 3     3       Sligro    Stadhoudersweg  Rotterdam
#[Out]# 4     4    Hoogvliet       Molenstraat  Eindhoven
#[Out]# 5     5       Sligro     Stationsplein      Breda
#[Out]# 6     6         Coop    Stadhoudersweg  Rotterdam
#[Out]# 7     7       Sligro  Wilhelminastraat  Eindhoven
#[Out]# 8     8  Albert Hein       Molenstraat  Eindhoven
#[Out]# 9     9  Albert Hein         Koestraat    Tilburg
#[Out]# 10   10        Jumbo        Bergselaan  Rotterdam
#[Out]# 11   11  Albert Hein          Hofplein  Rotterdam
#[Out]# 12   12         Lidl  Wilhelminastraat  Eindhoven
#[Out]# 13   13         Coop         Koestraat    Tilburg
#[Out]# 14   14         Coop     Keizersgracht  Amsterdam
#[Out]# 15   15         Lidl     Prinsengracht  Amsterdam
#[Out]# 16   16         Lidl     Ambachtstraat    Utrecht
#[Out]# 17   17    Hoogvliet        Kerkstraat  Eindhoven
#[Out]# 18   18       Sligro       Parallelweg    Tilburg
#[Out]# 19   19         Coop       Karrestraat      Breda
#[Out]# 20   20        Jumbo      Kasteeldreef    Tilburg
#[Out]# 21   21         Coop      Kasteeldreef    Tilburg
#[Out]# 22   22         Lidl     Prinsengracht  Amsterdam
#[Out]# 23   23         Dirk     Stationsplein      Breda
#[Out]# 24   24  Albert Hein     Stationsplein      Breda
#[Out]# 25   25  Albert Hein     Stationsplein      Breda
#[Out]# 26   26    Hoogvliet   Sint Annastraat      Breda
#[Out]# 27   27       Sligro      Kalverstraat  Amsterdam
#[Out]# 28   28    Hoogvliet         Koestraat    Tilburg
#[Out]# 29   29       Sligro      Marnixstraat  Amsterdam
#[Out]# ..  ...          ...               ...        ...
#[Out]# 34   34         Coop          Bierkaai  Amsterdam
#[Out]# 35   35         Lidl     Julianastraat    Utrecht
#[Out]# 36   36         Lidl     Julianastraat  Eindhoven
#[Out]# 37   37        Jumbo          Molenweg  Eindhoven
#[Out]# 38   38    Hoogvliet          Hofplein  Rotterdam
#[Out]# 39   39       Sligro       Dorpsstraat  Eindhoven
#[Out]# 40   40    Hoogvliet          Hofplein  Rotterdam
#[Out]# 41   41  Albert Hein        Bergselaan  Rotterdam
#[Out]# 42   42       Sligro      Kalverstraat  Amsterdam
#[Out]# 43   43         Coop    Gasthuisstraat    Utrecht
#[Out]# 44   44  Albert Hein     Ambachtstraat    Utrecht
#[Out]# 45   45         Coop      Kasteeldreef    Tilburg
#[Out]# 46   46         Lidl        Bergselaan  Rotterdam
#[Out]# 47   47         Coop     Julianastraat  Rotterdam
#[Out]# 48   48    Hoogvliet      Kasteeldreef    Tilburg
#[Out]# 49   49    Hoogvliet      Keizerstraat  Rotterdam
#[Out]# 50   50       Sligro     Stationsplein      Breda
#[Out]# 51   51         Coop       Parallelweg    Utrecht
#[Out]# 52   52         Lidl       Nieuwstraat  Eindhoven
#[Out]# 53   53         Coop        Hoogstraat    Utrecht
#[Out]# 54   54         Dirk     Julianastraat  Eindhoven
#[Out]# 55   55         Coop   Sint Annastraat      Breda
#[Out]# 56   56        Jumbo       Parallelweg  Eindhoven
#[Out]# 57   57         Dirk       Molenstraat  Eindhoven
#[Out]# 58   58         Dirk      Keizerstraat  Rotterdam
#[Out]# 59   59        Jumbo  Rozemarijnstraat      Breda
#[Out]# 60   60         Lidl      Pannekoekweg      Breda
#[Out]# 61   61         Lidl      Pannekoekweg      Breda
#[Out]# 62   62        Jumbo     Poffertjesweg  Eindhoven
#[Out]# 63   63        Jumbo     Stationstraat        Oss
#[Out]# 
#[Out]# [64 rows x 4 columns]
query3 = '''
    SELECT count(*)
    FROM store
'''

pd.read_sql_query(query3, conn)
#[Out]#    count(*)
#[Out]# 0        64
query3 = '''
    SELECT *
    FROM store
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID        sName            street       city
#[Out]# 0     0         Coop      Kalverstraat  Amsterdam
#[Out]# 1     1    Hoogvliet  Rozemarijnstraat      Breda
#[Out]# 2     2        Jumbo    Stadhoudersweg  Rotterdam
#[Out]# 3     3       Sligro    Stadhoudersweg  Rotterdam
#[Out]# 4     4    Hoogvliet       Molenstraat  Eindhoven
#[Out]# 5     5       Sligro     Stationsplein      Breda
#[Out]# 6     6         Coop    Stadhoudersweg  Rotterdam
#[Out]# 7     7       Sligro  Wilhelminastraat  Eindhoven
#[Out]# 8     8  Albert Hein       Molenstraat  Eindhoven
#[Out]# 9     9  Albert Hein         Koestraat    Tilburg
#[Out]# 10   10        Jumbo        Bergselaan  Rotterdam
#[Out]# 11   11  Albert Hein          Hofplein  Rotterdam
#[Out]# 12   12         Lidl  Wilhelminastraat  Eindhoven
#[Out]# 13   13         Coop         Koestraat    Tilburg
#[Out]# 14   14         Coop     Keizersgracht  Amsterdam
#[Out]# 15   15         Lidl     Prinsengracht  Amsterdam
#[Out]# 16   16         Lidl     Ambachtstraat    Utrecht
#[Out]# 17   17    Hoogvliet        Kerkstraat  Eindhoven
#[Out]# 18   18       Sligro       Parallelweg    Tilburg
#[Out]# 19   19         Coop       Karrestraat      Breda
#[Out]# 20   20        Jumbo      Kasteeldreef    Tilburg
#[Out]# 21   21         Coop      Kasteeldreef    Tilburg
#[Out]# 22   22         Lidl     Prinsengracht  Amsterdam
#[Out]# 23   23         Dirk     Stationsplein      Breda
#[Out]# 24   24  Albert Hein     Stationsplein      Breda
#[Out]# 25   25  Albert Hein     Stationsplein      Breda
#[Out]# 26   26    Hoogvliet   Sint Annastraat      Breda
#[Out]# 27   27       Sligro      Kalverstraat  Amsterdam
#[Out]# 28   28    Hoogvliet         Koestraat    Tilburg
#[Out]# 29   29       Sligro      Marnixstraat  Amsterdam
#[Out]# ..  ...          ...               ...        ...
#[Out]# 34   34         Coop          Bierkaai  Amsterdam
#[Out]# 35   35         Lidl     Julianastraat    Utrecht
#[Out]# 36   36         Lidl     Julianastraat  Eindhoven
#[Out]# 37   37        Jumbo          Molenweg  Eindhoven
#[Out]# 38   38    Hoogvliet          Hofplein  Rotterdam
#[Out]# 39   39       Sligro       Dorpsstraat  Eindhoven
#[Out]# 40   40    Hoogvliet          Hofplein  Rotterdam
#[Out]# 41   41  Albert Hein        Bergselaan  Rotterdam
#[Out]# 42   42       Sligro      Kalverstraat  Amsterdam
#[Out]# 43   43         Coop    Gasthuisstraat    Utrecht
#[Out]# 44   44  Albert Hein     Ambachtstraat    Utrecht
#[Out]# 45   45         Coop      Kasteeldreef    Tilburg
#[Out]# 46   46         Lidl        Bergselaan  Rotterdam
#[Out]# 47   47         Coop     Julianastraat  Rotterdam
#[Out]# 48   48    Hoogvliet      Kasteeldreef    Tilburg
#[Out]# 49   49    Hoogvliet      Keizerstraat  Rotterdam
#[Out]# 50   50       Sligro     Stationsplein      Breda
#[Out]# 51   51         Coop       Parallelweg    Utrecht
#[Out]# 52   52         Lidl       Nieuwstraat  Eindhoven
#[Out]# 53   53         Coop        Hoogstraat    Utrecht
#[Out]# 54   54         Dirk     Julianastraat  Eindhoven
#[Out]# 55   55         Coop   Sint Annastraat      Breda
#[Out]# 56   56        Jumbo       Parallelweg  Eindhoven
#[Out]# 57   57         Dirk       Molenstraat  Eindhoven
#[Out]# 58   58         Dirk      Keizerstraat  Rotterdam
#[Out]# 59   59        Jumbo  Rozemarijnstraat      Breda
#[Out]# 60   60         Lidl      Pannekoekweg      Breda
#[Out]# 61   61         Lidl      Pannekoekweg      Breda
#[Out]# 62   62        Jumbo     Poffertjesweg  Eindhoven
#[Out]# 63   63        Jumbo     Stationstraat        Oss
#[Out]# 
#[Out]# [64 rows x 4 columns]
query3 = '''
    SELECT count(*) FROM store
'''

pd.read_sql_query(query3, conn)
#[Out]#    count(*)
#[Out]# 0        64
query3 = '''
    SELECT distinct cID, sID
    FROM purchase p, store s
    WHERE p.sID=s.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT distinct p.cID, s.sID
    FROM purchase p, store s
    WHERE p.sID=s.sID
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  sID
#[Out]# 0      0    3
#[Out]# 1      1   23
#[Out]# 2      1    3
#[Out]# 3      1   17
#[Out]# 4      1   32
#[Out]# 5      1   16
#[Out]# 6      1   46
#[Out]# 7      1   36
#[Out]# 8      2   12
#[Out]# 9      2   39
#[Out]# 10     2   13
#[Out]# 11     2   51
#[Out]# 12     2   47
#[Out]# 13     3   44
#[Out]# 14     3   30
#[Out]# 15     3   29
#[Out]# 16     4   17
#[Out]# 17     4   10
#[Out]# 18     4   53
#[Out]# 19     4   21
#[Out]# 20     4    7
#[Out]# 21     4   44
#[Out]# 22     5    4
#[Out]# 23     5   36
#[Out]# 24     5   55
#[Out]# 25     5   51
#[Out]# 26     5    6
#[Out]# 27     5   17
#[Out]# 28     7    3
#[Out]# 29     7   12
#[Out]# ..   ...  ...
#[Out]# 460  190   34
#[Out]# 461  190   35
#[Out]# 462  190   36
#[Out]# 463  190   37
#[Out]# 464  190   38
#[Out]# 465  190   39
#[Out]# 466  190   40
#[Out]# 467  190   41
#[Out]# 468  190   42
#[Out]# 469  190   43
#[Out]# 470  190   44
#[Out]# 471  190   45
#[Out]# 472  190   46
#[Out]# 473  190   47
#[Out]# 474  190   48
#[Out]# 475  190   49
#[Out]# 476  190   50
#[Out]# 477  190   51
#[Out]# 478  190   52
#[Out]# 479  190   53
#[Out]# 480  190   54
#[Out]# 481  190   55
#[Out]# 482  190   56
#[Out]# 483  190   57
#[Out]# 484  190   58
#[Out]# 485  190   59
#[Out]# 486  190   60
#[Out]# 487  190   61
#[Out]# 488  190   62
#[Out]# 489  190   63
#[Out]# 
#[Out]# [490 rows x 2 columns]
query3 = '''
    SELECT distinct p.cID, s.sID
    FROM purchase p, store s
    WHERE p.sID=s.sID
    GROUP BY c.ID
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT distinct p.cID, s.sID
    FROM purchase p, store s
    WHERE p.sID=s.sID
    GROUP BY c.cID
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT distinct p.cID, s.sID
    FROM purchase p, store s
    WHERE p.sID=s.sID
    GROUP BY p.cID
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  sID
#[Out]# 0      0    3
#[Out]# 1      1   36
#[Out]# 2      2   47
#[Out]# 3      3   29
#[Out]# 4      4   44
#[Out]# 5      5   17
#[Out]# 6      7   42
#[Out]# 7      8   51
#[Out]# 8     10   34
#[Out]# 9     11    0
#[Out]# 10    13    8
#[Out]# 11    15   25
#[Out]# 12    16   26
#[Out]# 13    17   44
#[Out]# 14    18    6
#[Out]# 15    19   15
#[Out]# 16    20   40
#[Out]# 17    21   47
#[Out]# 18    22   27
#[Out]# 19    24   59
#[Out]# 20    25   12
#[Out]# 21    26   21
#[Out]# 22    27   34
#[Out]# 23    28   43
#[Out]# 24    29   29
#[Out]# 25    30   57
#[Out]# 26    31   39
#[Out]# 27    33   29
#[Out]# 28    34   26
#[Out]# 29    35   34
#[Out]# ..   ...  ...
#[Out]# 102  147   33
#[Out]# 103  149   54
#[Out]# 104  151   14
#[Out]# 105  152   43
#[Out]# 106  157   36
#[Out]# 107  159   17
#[Out]# 108  161   36
#[Out]# 109  162   41
#[Out]# 110  163    6
#[Out]# 111  165   46
#[Out]# 112  167   17
#[Out]# 113  168   28
#[Out]# 114  169   52
#[Out]# 115  170   40
#[Out]# 116  171   44
#[Out]# 117  172    0
#[Out]# 118  175   16
#[Out]# 119  176    6
#[Out]# 120  177   51
#[Out]# 121  178   39
#[Out]# 122  179   45
#[Out]# 123  180   56
#[Out]# 124  181   27
#[Out]# 125  182    4
#[Out]# 126  184    0
#[Out]# 127  185   62
#[Out]# 128  186   62
#[Out]# 129  188   62
#[Out]# 130  189   20
#[Out]# 131  190   63
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    SELECT distinct p.cID, s.sID, count(cID)
    FROM purchase p, store s
    WHERE p.sID=s.sID
    GROUP BY p.cID
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  sID  count(cID)
#[Out]# 0      0    3           1
#[Out]# 1      1   36           7
#[Out]# 2      2   47           5
#[Out]# 3      3   29           3
#[Out]# 4      4   44           6
#[Out]# 5      5   17           6
#[Out]# 6      7   42           6
#[Out]# 7      8   51           2
#[Out]# 8     10   34           1
#[Out]# 9     11    0           1
#[Out]# 10    13    8           9
#[Out]# 11    15   25           1
#[Out]# 12    16   26          10
#[Out]# 13    17   44           2
#[Out]# 14    18    6           3
#[Out]# 15    19   15           4
#[Out]# 16    20   40           3
#[Out]# 17    21   47           3
#[Out]# 18    22   27           2
#[Out]# 19    24   59           9
#[Out]# 20    25   12           1
#[Out]# 21    26   21           1
#[Out]# 22    27   34           6
#[Out]# 23    28   43           1
#[Out]# 24    29   29           2
#[Out]# 25    30   57           3
#[Out]# 26    31   39           2
#[Out]# 27    33   29           9
#[Out]# 28    34   26           1
#[Out]# 29    35   34           2
#[Out]# ..   ...  ...         ...
#[Out]# 102  147   33           3
#[Out]# 103  149   54           2
#[Out]# 104  151   14           2
#[Out]# 105  152   43           3
#[Out]# 106  157   36           3
#[Out]# 107  159   17           2
#[Out]# 108  161   36          11
#[Out]# 109  162   41           8
#[Out]# 110  163    6           4
#[Out]# 111  165   46           6
#[Out]# 112  167   17          10
#[Out]# 113  168   28           1
#[Out]# 114  169   52          11
#[Out]# 115  170   40           3
#[Out]# 116  171   44           2
#[Out]# 117  172    0           2
#[Out]# 118  175   16           2
#[Out]# 119  176    6           6
#[Out]# 120  177   51           5
#[Out]# 121  178   39           2
#[Out]# 122  179   45           6
#[Out]# 123  180   56           3
#[Out]# 124  181   27           3
#[Out]# 125  182    4           4
#[Out]# 126  184    0           1
#[Out]# 127  185   62           1
#[Out]# 128  186   62           1
#[Out]# 129  188   62           2
#[Out]# 130  189   20           2
#[Out]# 131  190   63          64
#[Out]# 
#[Out]# [132 rows x 3 columns]
query3 = '''
    SELECT distinct p.cID, s.sID, count(cID)
    FROM purchase p, store s
    WHERE p.sID=s.sID
    GROUP BY p.cID
    HAVING count(p.cID)=64
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  sID  count(cID)
#[Out]# 0  190   63          64
query3 = '''
    SELECT distinct p.cID, s.sID, count(cID)
    FROM purchase p, store s
    WHERE p.sID=s.sID
    GROUP BY p.cID
    HAVING count(p.cID)=count(store.sID)
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    WITH store_amount(value) as SELECT count(*) FROM store
    SELECT distinct p.cID, s.sID, count(cID)
    FROM purchase p, store s
    WHERE p.sID=s.sID
    GROUP BY p.cID
    HAVING count(p.cID)=store_amount.value
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    WITH store_amount(value) as (SELECT count(*) FROM store)
    SELECT distinct p.cID, s.sID, count(cID)
    FROM purchase p, store s
    WHERE p.sID=s.sID
    GROUP BY p.cID
    HAVING count(p.cID)=store_amount.value
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    WITH store_amount(value) as (SELECT count(sID) FROM store)
    SELECT distinct p.cID, s.sID, count(cID)
    FROM purchase p, store s
    WHERE p.sID=s.sID
    GROUP BY p.cID
    HAVING count(p.cID)=store_amount.value
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    WITH store_amount(value) as (SELECT count(sID) FROM store)
    SELECT distinct p.cID, s.sID, count(cID)
    FROM purchase p, store s,store_amount
    WHERE p.sID=s.sID
    GROUP BY p.cID
    HAVING count(p.cID)=store_amount.value
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  sID  count(cID)
#[Out]# 0  190   63          64
query3 = '''
    WITH store_amount(value) as (SELECT count(sID) FROM store)
    SELECT distinct p.cID, s.sID
    FROM purchase p, store s,store_amount
    WHERE p.sID=s.sID
    GROUP BY p.cID
    HAVING count(p.cID)=store_amount.value
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  sID
#[Out]# 0  190   63
query3 = '''
    WITH store_amount(value) as (SELECT count(sID) FROM store)
    SELECT distinct p.cID
    FROM purchase p, store s,store_amount
    WHERE p.sID=s.sID
    GROUP BY p.cID
    HAVING count(p.cID)=store_amount.value
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT sName
    FROM store
    
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16         Lidl
#[Out]# 17    Hoogvliet
#[Out]# 18       Sligro
#[Out]# 19         Coop
#[Out]# 20        Jumbo
#[Out]# 21         Coop
#[Out]# 22         Lidl
#[Out]# 23         Dirk
#[Out]# 24  Albert Hein
#[Out]# 25  Albert Hein
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28    Hoogvliet
#[Out]# 29       Sligro
#[Out]# ..          ...
#[Out]# 34         Coop
#[Out]# 35         Lidl
#[Out]# 36         Lidl
#[Out]# 37        Jumbo
#[Out]# 38    Hoogvliet
#[Out]# 39       Sligro
#[Out]# 40    Hoogvliet
#[Out]# 41  Albert Hein
#[Out]# 42       Sligro
#[Out]# 43         Coop
#[Out]# 44  Albert Hein
#[Out]# 45         Coop
#[Out]# 46         Lidl
#[Out]# 47         Coop
#[Out]# 48    Hoogvliet
#[Out]# 49    Hoogvliet
#[Out]# 50       Sligro
#[Out]# 51         Coop
#[Out]# 52         Lidl
#[Out]# 53         Coop
#[Out]# 54         Dirk
#[Out]# 55         Coop
#[Out]# 56        Jumbo
#[Out]# 57         Dirk
#[Out]# 58         Dirk
#[Out]# 59        Jumbo
#[Out]# 60         Lidl
#[Out]# 61         Lidl
#[Out]# 62        Jumbo
#[Out]# 63        Jumbo
#[Out]# 
#[Out]# [64 rows x 1 columns]
query4 = '''
    SELECT quantity FROM purchase
    
'''

pd.read_sql_query(query4, conn)
#[Out]#      quantity
#[Out]# 0           1
#[Out]# 1           2
#[Out]# 2           3
#[Out]# 3           2
#[Out]# 4           4
#[Out]# 5           4
#[Out]# 6           8
#[Out]# 7           6
#[Out]# 8           1
#[Out]# 9           7
#[Out]# 10          6
#[Out]# 11          4
#[Out]# 12          1
#[Out]# 13          2
#[Out]# 14          2
#[Out]# 15          6
#[Out]# 16          2
#[Out]# 17          9
#[Out]# 18          5
#[Out]# 19          2
#[Out]# 20          9
#[Out]# 21          4
#[Out]# 22          6
#[Out]# 23          6
#[Out]# 24          9
#[Out]# 25          2
#[Out]# 26          2
#[Out]# 27          1
#[Out]# 28          2
#[Out]# 29          6
#[Out]# ..        ...
#[Out]# 479         4
#[Out]# 480         5
#[Out]# 481         3
#[Out]# 482         4
#[Out]# 483         4
#[Out]# 484         4
#[Out]# 485         2
#[Out]# 486         5
#[Out]# 487         5
#[Out]# 488         7
#[Out]# 489         5
#[Out]# 490         2
#[Out]# 491         4
#[Out]# 492         4
#[Out]# 493         6
#[Out]# 494         3
#[Out]# 495         6
#[Out]# 496         1
#[Out]# 497         5
#[Out]# 498         4
#[Out]# 499         6
#[Out]# 500         7
#[Out]# 501         4
#[Out]# 502         5
#[Out]# 503         7
#[Out]# 504         2
#[Out]# 505         6
#[Out]# 506         5
#[Out]# 507         2
#[Out]# 508         1
#[Out]# 
#[Out]# [509 rows x 1 columns]
query4 = '''
    SELECT *
    FROM purchase p, store s
    WHERE s.sID=p.pID
    
'''

pd.read_sql_query(query4, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price  sID        sName  \
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45   10        Jumbo   
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65   14         Coop   
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60   16         Lidl   
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25    9  Albert Hein   
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95   25  Albert Hein   
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75   26    Hoogvliet   
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90   11  Albert Hein   
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10   27       Sligro   
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45   20        Jumbo   
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35    9  Albert Hein   
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10    4    Hoogvliet   
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70   13         Coop   
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55   22         Lidl   
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30   14         Coop   
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75   26    Hoogvliet   
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45    9  Albert Hein   
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15    8  Albert Hein   
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05   27       Sligro   
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60   12         Lidl   
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05    6         Coop   
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05   13         Coop   
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75   26    Hoogvliet   
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70   14         Coop   
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25   28    Hoogvliet   
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10    6         Coop   
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55   22         Lidl   
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85   16         Lidl   
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20   19         Coop   
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10   19         Coop   
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70    2        Jumbo   
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...  ...          ...   
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80   28    Hoogvliet   
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50   27       Sligro   
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55    5       Sligro   
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65   28    Hoogvliet   
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70    7       Sligro   
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70    0         Coop   
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50   11  Albert Hein   
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95    6         Coop   
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75   19         Coop   
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50   17    Hoogvliet   
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85    9  Albert Hein   
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55   11  Albert Hein   
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60   22         Lidl   
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25   17    Hoogvliet   
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30   20        Jumbo   
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05   11  Albert Hein   
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05   21         Coop   
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50   23         Dirk   
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50   23         Dirk   
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95    8  Albert Hein   
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50    0         Coop   
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95    8  Albert Hein   
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60   11  Albert Hein   
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25   15         Lidl   
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75    2        Jumbo   
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80   17    Hoogvliet   
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35    5       Sligro   
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85   19         Coop   
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15    9  Albert Hein   
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30   18       Sligro   
#[Out]# 
#[Out]#                street       city  
#[Out]# 0          Bergselaan  Rotterdam  
#[Out]# 1       Keizersgracht  Amsterdam  
#[Out]# 2       Ambachtstraat    Utrecht  
#[Out]# 3           Koestraat    Tilburg  
#[Out]# 4       Stationsplein      Breda  
#[Out]# 5     Sint Annastraat      Breda  
#[Out]# 6            Hofplein  Rotterdam  
#[Out]# 7        Kalverstraat  Amsterdam  
#[Out]# 8        Kasteeldreef    Tilburg  
#[Out]# 9           Koestraat    Tilburg  
#[Out]# 10        Molenstraat  Eindhoven  
#[Out]# 11          Koestraat    Tilburg  
#[Out]# 12      Prinsengracht  Amsterdam  
#[Out]# 13      Keizersgracht  Amsterdam  
#[Out]# 14    Sint Annastraat      Breda  
#[Out]# 15          Koestraat    Tilburg  
#[Out]# 16        Molenstraat  Eindhoven  
#[Out]# 17       Kalverstraat  Amsterdam  
#[Out]# 18   Wilhelminastraat  Eindhoven  
#[Out]# 19     Stadhoudersweg  Rotterdam  
#[Out]# 20          Koestraat    Tilburg  
#[Out]# 21    Sint Annastraat      Breda  
#[Out]# 22      Keizersgracht  Amsterdam  
#[Out]# 23          Koestraat    Tilburg  
#[Out]# 24     Stadhoudersweg  Rotterdam  
#[Out]# 25      Prinsengracht  Amsterdam  
#[Out]# 26      Ambachtstraat    Utrecht  
#[Out]# 27        Karrestraat      Breda  
#[Out]# 28        Karrestraat      Breda  
#[Out]# 29     Stadhoudersweg  Rotterdam  
#[Out]# ..                ...        ...  
#[Out]# 479         Koestraat    Tilburg  
#[Out]# 480      Kalverstraat  Amsterdam  
#[Out]# 481     Stationsplein      Breda  
#[Out]# 482         Koestraat    Tilburg  
#[Out]# 483  Wilhelminastraat  Eindhoven  
#[Out]# 484      Kalverstraat  Amsterdam  
#[Out]# 485          Hofplein  Rotterdam  
#[Out]# 486    Stadhoudersweg  Rotterdam  
#[Out]# 487       Karrestraat      Breda  
#[Out]# 488        Kerkstraat  Eindhoven  
#[Out]# 489         Koestraat    Tilburg  
#[Out]# 490          Hofplein  Rotterdam  
#[Out]# 491     Prinsengracht  Amsterdam  
#[Out]# 492        Kerkstraat  Eindhoven  
#[Out]# 493      Kasteeldreef    Tilburg  
#[Out]# 494          Hofplein  Rotterdam  
#[Out]# 495      Kasteeldreef    Tilburg  
#[Out]# 496     Stationsplein      Breda  
#[Out]# 497     Stationsplein      Breda  
#[Out]# 498       Molenstraat  Eindhoven  
#[Out]# 499      Kalverstraat  Amsterdam  
#[Out]# 500       Molenstraat  Eindhoven  
#[Out]# 501          Hofplein  Rotterdam  
#[Out]# 502     Prinsengracht  Amsterdam  
#[Out]# 503    Stadhoudersweg  Rotterdam  
#[Out]# 504        Kerkstraat  Eindhoven  
#[Out]# 505     Stationsplein      Breda  
#[Out]# 506       Karrestraat      Breda  
#[Out]# 507         Koestraat    Tilburg  
#[Out]# 508       Parallelweg    Tilburg  
#[Out]# 
#[Out]# [509 rows x 11 columns]
query4 = '''
    SELECT *
    FROM purchase p, store s
    WHERE s.sID=p.pID
    GROUP BY s.sName
    
'''

pd.read_sql_query(query4, conn)
#[Out]#    tID  cID  sID  pID        date  quantity  price  sID        sName  \
#[Out]# 0  846  190   62    9  2018-08-16         2   3.15    9  Albert Hein   
#[Out]# 1  845  190   61   19  2018-08-23         5   2.85   19         Coop   
#[Out]# 2  836  190   52   23  2018-08-15         5   2.50   23         Dirk   
#[Out]# 3  843  190   59   17  2018-08-26         2   3.80   17    Hoogvliet   
#[Out]# 4  842  190   58    2  2018-08-19         7   0.75    2        Jumbo   
#[Out]# 5  841  190   57   15  2018-08-22         5   3.25   15         Lidl   
#[Out]# 6  847  190   63   18  2018-08-21         1   3.30   18       Sligro   
#[Out]# 
#[Out]#            street       city  
#[Out]# 0       Koestraat    Tilburg  
#[Out]# 1     Karrestraat      Breda  
#[Out]# 2   Stationsplein      Breda  
#[Out]# 3      Kerkstraat  Eindhoven  
#[Out]# 4  Stadhoudersweg  Rotterdam  
#[Out]# 5   Prinsengracht  Amsterdam  
#[Out]# 6     Parallelweg    Tilburg  
query4 = '''
    SELECT *
    FROM purchase p, store s
    WHERE s.sID=p.pID
    GROUP BY p.quantity
    
'''

pd.read_sql_query(query4, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price  sID        sName  \
#[Out]# 0   847  190   63   18  2018-08-21         1   3.30   18       Sligro   
#[Out]# 1   846  190   62    9  2018-08-16         2   3.15    9  Albert Hein   
#[Out]# 2   833  190   49   11  2018-08-17         3   3.05   11  Albert Hein   
#[Out]# 3   840  190   56   11  2018-08-15         4   1.60   11  Albert Hein   
#[Out]# 4   845  190   61   19  2018-08-23         5   2.85   19         Coop   
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35    5       Sligro   
#[Out]# 6   842  190   58    2  2018-08-19         7   0.75    2        Jumbo   
#[Out]# 7   472  182   17   25  2018-08-28         8   3.90   25  Albert Hein   
#[Out]# 8   474  182    4   13  2018-08-23         9   4.20   13         Coop   
#[Out]# 9    59   17   44    7  2018-08-19        10   1.65    7       Sligro   
#[Out]# 10  289  109   29   12  2018-08-18        11  13.65   12         Lidl   
#[Out]# 11  128   41   33   24  2018-08-19        12   3.20   24  Albert Hein   
#[Out]# 12  266   97   26    2  2018-08-25        13   1.95    2        Jumbo   
#[Out]# 
#[Out]#               street       city  
#[Out]# 0        Parallelweg    Tilburg  
#[Out]# 1          Koestraat    Tilburg  
#[Out]# 2           Hofplein  Rotterdam  
#[Out]# 3           Hofplein  Rotterdam  
#[Out]# 4        Karrestraat      Breda  
#[Out]# 5      Stationsplein      Breda  
#[Out]# 6     Stadhoudersweg  Rotterdam  
#[Out]# 7      Stationsplein      Breda  
#[Out]# 8          Koestraat    Tilburg  
#[Out]# 9   Wilhelminastraat  Eindhoven  
#[Out]# 10  Wilhelminastraat  Eindhoven  
#[Out]# 11     Stationsplein      Breda  
#[Out]# 12    Stadhoudersweg  Rotterdam  
query4 = '''
    SELECT sName
    FROM store s, purchase p
    GROUP BY sName
    HAVING avg(p.quantity)>4
   
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
    GROUP BY sName
    HAVING avg(p.quantity)>4
   
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg(p.quantity)
#[Out]# 0  Albert Hein         4.797642
#[Out]# 1         Coop         4.797642
#[Out]# 2         Dirk         4.797642
#[Out]# 3    Hoogvliet         4.797642
#[Out]# 4        Jumbo         4.797642
#[Out]# 5         Lidl         4.797642
#[Out]# 6       Sligro         4.797642
query4 = '''
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
    GROUP BY distinct sName
    HAVING avg(p.quantity)>4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
    GROUP BY sName
    HAVING avg(p.quantity)>4
   
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg(p.quantity)
#[Out]# 0  Albert Hein         4.797642
#[Out]# 1         Coop         4.797642
#[Out]# 2         Dirk         4.797642
#[Out]# 3    Hoogvliet         4.797642
#[Out]# 4        Jumbo         4.797642
#[Out]# 5         Lidl         4.797642
#[Out]# 6       Sligro         4.797642
query4 = '''
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
    GROUP BY s.sName
    HAVING avg(p.quantity)>4
   
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg(p.quantity)
#[Out]# 0  Albert Hein         4.797642
#[Out]# 1         Coop         4.797642
#[Out]# 2         Dirk         4.797642
#[Out]# 3    Hoogvliet         4.797642
#[Out]# 4        Jumbo         4.797642
#[Out]# 5         Lidl         4.797642
#[Out]# 6       Sligro         4.797642
query4 = '''
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
   
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName  avg(p.quantity)
#[Out]# 0  Jumbo         4.797642
query4 = '''
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
    WHERE s.sID=p.sID
   
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName  avg(p.quantity)
#[Out]# 0  Jumbo         4.797642
query4 = '''
    SELECT sName
    FROM store s, purchase p
    WHERE s.sID=p.sID
   
'''

pd.read_sql_query(query4, conn)
#[Out]#            sName
#[Out]# 0         Sligro
#[Out]# 1           Dirk
#[Out]# 2         Sligro
#[Out]# 3      Hoogvliet
#[Out]# 4    Albert Hein
#[Out]# 5           Lidl
#[Out]# 6           Lidl
#[Out]# 7           Lidl
#[Out]# 8           Lidl
#[Out]# 9         Sligro
#[Out]# 10          Coop
#[Out]# 11          Coop
#[Out]# 12          Coop
#[Out]# 13   Albert Hein
#[Out]# 14          Dirk
#[Out]# 15        Sligro
#[Out]# 16     Hoogvliet
#[Out]# 17         Jumbo
#[Out]# 18          Coop
#[Out]# 19          Coop
#[Out]# 20        Sligro
#[Out]# 21   Albert Hein
#[Out]# 22     Hoogvliet
#[Out]# 23          Lidl
#[Out]# 24          Coop
#[Out]# 25          Coop
#[Out]# 26          Coop
#[Out]# 27     Hoogvliet
#[Out]# 28        Sligro
#[Out]# 29          Lidl
#[Out]# ..           ...
#[Out]# 479         Coop
#[Out]# 480         Lidl
#[Out]# 481         Lidl
#[Out]# 482        Jumbo
#[Out]# 483    Hoogvliet
#[Out]# 484       Sligro
#[Out]# 485    Hoogvliet
#[Out]# 486  Albert Hein
#[Out]# 487       Sligro
#[Out]# 488         Coop
#[Out]# 489  Albert Hein
#[Out]# 490         Coop
#[Out]# 491         Lidl
#[Out]# 492         Coop
#[Out]# 493    Hoogvliet
#[Out]# 494    Hoogvliet
#[Out]# 495       Sligro
#[Out]# 496         Coop
#[Out]# 497         Lidl
#[Out]# 498         Coop
#[Out]# 499         Dirk
#[Out]# 500         Coop
#[Out]# 501        Jumbo
#[Out]# 502         Dirk
#[Out]# 503         Dirk
#[Out]# 504        Jumbo
#[Out]# 505         Lidl
#[Out]# 506         Lidl
#[Out]# 507        Jumbo
#[Out]# 508        Jumbo
#[Out]# 
#[Out]# [509 rows x 1 columns]
query4 = '''
    SELECT sName, p.quantity
    FROM store s, purchase p
    WHERE s.sID=p.sID
   
'''

pd.read_sql_query(query4, conn)
#[Out]#            sName  quantity
#[Out]# 0         Sligro         1
#[Out]# 1           Dirk         2
#[Out]# 2         Sligro         3
#[Out]# 3      Hoogvliet         2
#[Out]# 4    Albert Hein         4
#[Out]# 5           Lidl         4
#[Out]# 6           Lidl         8
#[Out]# 7           Lidl         6
#[Out]# 8           Lidl         1
#[Out]# 9         Sligro         7
#[Out]# 10          Coop         6
#[Out]# 11          Coop         4
#[Out]# 12          Coop         1
#[Out]# 13   Albert Hein         2
#[Out]# 14          Dirk         2
#[Out]# 15        Sligro         6
#[Out]# 16     Hoogvliet         2
#[Out]# 17         Jumbo         9
#[Out]# 18          Coop         5
#[Out]# 19          Coop         2
#[Out]# 20        Sligro         9
#[Out]# 21   Albert Hein         4
#[Out]# 22     Hoogvliet         6
#[Out]# 23          Lidl         6
#[Out]# 24          Coop         9
#[Out]# 25          Coop         2
#[Out]# 26          Coop         2
#[Out]# 27     Hoogvliet         1
#[Out]# 28        Sligro         2
#[Out]# 29          Lidl         6
#[Out]# ..           ...       ...
#[Out]# 479         Coop         4
#[Out]# 480         Lidl         5
#[Out]# 481         Lidl         3
#[Out]# 482        Jumbo         4
#[Out]# 483    Hoogvliet         4
#[Out]# 484       Sligro         4
#[Out]# 485    Hoogvliet         2
#[Out]# 486  Albert Hein         5
#[Out]# 487       Sligro         5
#[Out]# 488         Coop         7
#[Out]# 489  Albert Hein         5
#[Out]# 490         Coop         2
#[Out]# 491         Lidl         4
#[Out]# 492         Coop         4
#[Out]# 493    Hoogvliet         6
#[Out]# 494    Hoogvliet         3
#[Out]# 495       Sligro         6
#[Out]# 496         Coop         1
#[Out]# 497         Lidl         5
#[Out]# 498         Coop         4
#[Out]# 499         Dirk         6
#[Out]# 500         Coop         7
#[Out]# 501        Jumbo         4
#[Out]# 502         Dirk         5
#[Out]# 503         Dirk         7
#[Out]# 504        Jumbo         2
#[Out]# 505         Lidl         6
#[Out]# 506         Lidl         5
#[Out]# 507        Jumbo         2
#[Out]# 508        Jumbo         1
#[Out]# 
#[Out]# [509 rows x 2 columns]
query4 = '''
    SELECT sName, p.quantity
    FROM store s, purchase p
    WHERE s.sID=p.sID
    GRoup by sName
   
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  quantity
#[Out]# 0  Albert Hein         5
#[Out]# 1         Coop         7
#[Out]# 2         Dirk         7
#[Out]# 3    Hoogvliet         3
#[Out]# 4        Jumbo         1
#[Out]# 5         Lidl         5
#[Out]# 6       Sligro         6
query4 = '''
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
    WHERE s.sID=p.sID
    GROUP BY sName
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg(p.quantity)
#[Out]# 0  Albert Hein         4.969697
#[Out]# 1         Coop         4.681818
#[Out]# 2         Dirk         5.268293
#[Out]# 3    Hoogvliet         5.280000
#[Out]# 4        Jumbo         3.888889
#[Out]# 5         Lidl         4.796875
#[Out]# 6       Sligro         4.674419
query4 = '''
    WITH branch_avg(brang,avg) AS(
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
    WHERE s.sID=p.sID
    GROUP BY sName)
    
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    WITH branch_avg(brang,avg) AS(
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
    WHERE s.sID=p.sID
    GROUP BY sName)
    
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    WITH branch_avg(branch,avg) AS(
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
    WHERE s.sID=p.sID
    GROUP BY sName)
    SELECT sName
    FROM store s, branch_avg b
    WHERE s.sName=b.branch AND b.avg>4
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2        Sligro
#[Out]# 3     Hoogvliet
#[Out]# 4        Sligro
#[Out]# 5          Coop
#[Out]# 6        Sligro
#[Out]# 7   Albert Hein
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10         Lidl
#[Out]# 11         Coop
#[Out]# 12         Coop
#[Out]# 13         Lidl
#[Out]# 14         Lidl
#[Out]# 15    Hoogvliet
#[Out]# 16       Sligro
#[Out]# 17         Coop
#[Out]# 18         Coop
#[Out]# 19         Lidl
#[Out]# 20         Dirk
#[Out]# 21  Albert Hein
#[Out]# 22  Albert Hein
#[Out]# 23    Hoogvliet
#[Out]# 24       Sligro
#[Out]# 25    Hoogvliet
#[Out]# 26       Sligro
#[Out]# 27         Dirk
#[Out]# 28         Coop
#[Out]# 29  Albert Hein
#[Out]# 30         Dirk
#[Out]# 31         Coop
#[Out]# 32         Lidl
#[Out]# 33         Lidl
#[Out]# 34    Hoogvliet
#[Out]# 35       Sligro
#[Out]# 36    Hoogvliet
#[Out]# 37  Albert Hein
#[Out]# 38       Sligro
#[Out]# 39         Coop
#[Out]# 40  Albert Hein
#[Out]# 41         Coop
#[Out]# 42         Lidl
#[Out]# 43         Coop
#[Out]# 44    Hoogvliet
#[Out]# 45    Hoogvliet
#[Out]# 46       Sligro
#[Out]# 47         Coop
#[Out]# 48         Lidl
#[Out]# 49         Coop
#[Out]# 50         Dirk
#[Out]# 51         Coop
#[Out]# 52         Dirk
#[Out]# 53         Dirk
#[Out]# 54         Lidl
#[Out]# 55         Lidl
query4 = '''
    WITH branch_avg(branch,avg) AS(
    SELECT sName, avg(p.quantity)
    FROM store s, purchase p
    WHERE s.sID=p.sID
    GROUP BY sName)
    SELECT DISTINCT sName
    FROM store s, branch_avg b
    WHERE s.sName=b.branch AND b.avg>4
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4         Lidl
#[Out]# 5         Dirk
query5 = '''
    SELECT * FROM purchase
'''

pd.read_sql_query(query5, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query5 = '''
    WITH max_price(value) AS (SELECT max(price)FROM purchase) 
    SELECT pr.pname, s.sName
    FROM product pr, purchase p, store s, max_price mp
    WHERE pr.pID=p.pID AND p.sID=s.sID AND p.price=mp.value
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT * FROM inventory WHERE date='2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#     sID  pID        date  quantity  unit_price
#[Out]# 0    51   10  2018-08-23        31        0.60
#[Out]# 1    57   19  2018-08-23        12        2.95
#[Out]# 2    38   23  2018-08-23        29        1.80
#[Out]# 3    35   13  2018-08-23        28        4.15
#[Out]# 4    45   13  2018-08-23        32        4.10
#[Out]# 5     5   17  2018-08-23        34        2.45
#[Out]# 6    13   15  2018-08-23        11        1.25
#[Out]# 7    50   10  2018-08-23        54        0.55
#[Out]# 8     7    1  2018-08-23        18        5.80
#[Out]# 9     2   11  2018-08-23        21        1.00
#[Out]# 10   28   27  2018-08-23        43        8.50
#[Out]# 11   35   25  2018-08-23        36        4.00
#[Out]# 12   41    1  2018-08-23        53        4.60
#[Out]# 13   56   25  2018-08-23        19        4.35
#[Out]# 14   45    4  2018-08-23        50        1.00
#[Out]# 15   19    4  2018-08-23        53        1.20
#[Out]# 16   29   17  2018-08-23         4        1.95
#[Out]# 17   11    2  2018-08-23        22        2.10
#[Out]# 18   32   28  2018-08-23        36        6.85
#[Out]# 19    6    0  2018-08-23        37        4.35
#[Out]# 20   33   11  2018-08-23        32        1.05
#[Out]# 21   35   27  2018-08-23        54        8.85
#[Out]# 22   34   10  2018-08-23         8        0.45
#[Out]# 23   42   12  2018-08-23        46       11.40
#[Out]# 24   41   14  2018-08-23         3        3.35
#[Out]# 25   33   19  2018-08-23        32        2.25
#[Out]# 26   30   22  2018-08-23        29        2.05
#[Out]# 27   50   22  2018-08-23         5        1.95
#[Out]# 28   29    0  2018-08-23        28        5.15
#[Out]# 29   47    7  2018-08-23        27        1.85
#[Out]# ..  ...  ...         ...       ...         ...
#[Out]# 38   11   16  2018-08-23         3        1.90
#[Out]# 39   21   23  2018-08-23        20        2.10
#[Out]# 40   43    7  2018-08-23        20        1.95
#[Out]# 41   40   14  2018-08-23         3        4.10
#[Out]# 42    3    3  2018-08-23        17        1.35
#[Out]# 43   16   22  2018-08-23        14        1.60
#[Out]# 44   50   14  2018-08-23        19        3.85
#[Out]# 45   40   27  2018-08-23        17        6.90
#[Out]# 46   33    8  2018-08-23        16        4.80
#[Out]# 47   44   19  2018-08-23         4        2.65
#[Out]# 48   12   15  2018-08-23         1        1.25
#[Out]# 49   11   14  2018-08-23        12        3.20
#[Out]# 50    5   16  2018-08-23         4        1.65
#[Out]# 51    1    5  2018-08-23         2        0.45
#[Out]# 52   52   28  2018-08-23         8        7.35
#[Out]# 53    5   12  2018-08-23        11       13.40
#[Out]# 54   12   13  2018-08-23        15        3.55
#[Out]# 55   35   11  2018-08-23        15        1.20
#[Out]# 56   55    1  2018-08-23         1        4.80
#[Out]# 57   54   12  2018-08-23         5       12.55
#[Out]# 58   11   15  2018-08-23        14        1.30
#[Out]# 59   35    7  2018-08-23         7        2.20
#[Out]# 60    6   15  2018-08-23         4        1.00
#[Out]# 61   37   28  2018-08-23        19        7.75
#[Out]# 62   25    8  2018-08-23         6        5.55
#[Out]# 63    9   12  2018-08-23         5       13.15
#[Out]# 64   38   24  2018-08-23        10        3.55
#[Out]# 65   56    1  2018-08-23         1        4.40
#[Out]# 66   48    6  2018-08-23        21        1.15
#[Out]# 67    4   13  2018-08-23        23        4.20
#[Out]# 
#[Out]# [68 rows x 5 columns]
query6 = '''
    SELECT * 
    FROM inventory i1, inventory i2
    WHERE date='2018-08-23'
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT * 
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#       sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0      51   10  2018-08-23        31         0.6    1    5  2018-08-23   
#[Out]# 1      51   10  2018-08-23        31         0.6    2   11  2018-08-23   
#[Out]# 2      51   10  2018-08-23        31         0.6    2   16  2018-08-23   
#[Out]# 3      51   10  2018-08-23        31         0.6    3    3  2018-08-23   
#[Out]# 4      51   10  2018-08-23        31         0.6    3   19  2018-08-23   
#[Out]# 5      51   10  2018-08-23        31         0.6    4   13  2018-08-23   
#[Out]# 6      51   10  2018-08-23        31         0.6    5   12  2018-08-23   
#[Out]# 7      51   10  2018-08-23        31         0.6    5   16  2018-08-23   
#[Out]# 8      51   10  2018-08-23        31         0.6    5   17  2018-08-23   
#[Out]# 9      51   10  2018-08-23        31         0.6    5   24  2018-08-23   
#[Out]# 10     51   10  2018-08-23        31         0.6    6    0  2018-08-23   
#[Out]# 11     51   10  2018-08-23        31         0.6    6   15  2018-08-23   
#[Out]# 12     51   10  2018-08-23        31         0.6    6   16  2018-08-23   
#[Out]# 13     51   10  2018-08-23        31         0.6    7    1  2018-08-23   
#[Out]# 14     51   10  2018-08-23        31         0.6    9   12  2018-08-23   
#[Out]# 15     51   10  2018-08-23        31         0.6   11    2  2018-08-23   
#[Out]# 16     51   10  2018-08-23        31         0.6   11   14  2018-08-23   
#[Out]# 17     51   10  2018-08-23        31         0.6   11   15  2018-08-23   
#[Out]# 18     51   10  2018-08-23        31         0.6   11   16  2018-08-23   
#[Out]# 19     51   10  2018-08-23        31         0.6   12    2  2018-08-23   
#[Out]# 20     51   10  2018-08-23        31         0.6   12   13  2018-08-23   
#[Out]# 21     51   10  2018-08-23        31         0.6   12   15  2018-08-23   
#[Out]# 22     51   10  2018-08-23        31         0.6   13   15  2018-08-23   
#[Out]# 23     51   10  2018-08-23        31         0.6   16   22  2018-08-23   
#[Out]# 24     51   10  2018-08-23        31         0.6   17   19  2018-08-23   
#[Out]# 25     51   10  2018-08-23        31         0.6   19    4  2018-08-23   
#[Out]# 26     51   10  2018-08-23        31         0.6   21   23  2018-08-23   
#[Out]# 27     51   10  2018-08-23        31         0.6   25    8  2018-08-23   
#[Out]# 28     51   10  2018-08-23        31         0.6   28   27  2018-08-23   
#[Out]# 29     51   10  2018-08-23        31         0.6   29    0  2018-08-23   
#[Out]# ...   ...  ...         ...       ...         ...  ...  ...         ...   
#[Out]# 4594    4   13  2018-08-23        23         4.2   35    7  2018-08-23   
#[Out]# 4595    4   13  2018-08-23        23         4.2   35   11  2018-08-23   
#[Out]# 4596    4   13  2018-08-23        23         4.2   35   13  2018-08-23   
#[Out]# 4597    4   13  2018-08-23        23         4.2   35   25  2018-08-23   
#[Out]# 4598    4   13  2018-08-23        23         4.2   35   27  2018-08-23   
#[Out]# 4599    4   13  2018-08-23        23         4.2   37   28  2018-08-23   
#[Out]# 4600    4   13  2018-08-23        23         4.2   38   23  2018-08-23   
#[Out]# 4601    4   13  2018-08-23        23         4.2   38   24  2018-08-23   
#[Out]# 4602    4   13  2018-08-23        23         4.2   40   14  2018-08-23   
#[Out]# 4603    4   13  2018-08-23        23         4.2   40   27  2018-08-23   
#[Out]# 4604    4   13  2018-08-23        23         4.2   41    1  2018-08-23   
#[Out]# 4605    4   13  2018-08-23        23         4.2   41   14  2018-08-23   
#[Out]# 4606    4   13  2018-08-23        23         4.2   42   12  2018-08-23   
#[Out]# 4607    4   13  2018-08-23        23         4.2   43    7  2018-08-23   
#[Out]# 4608    4   13  2018-08-23        23         4.2   44   19  2018-08-23   
#[Out]# 4609    4   13  2018-08-23        23         4.2   45    4  2018-08-23   
#[Out]# 4610    4   13  2018-08-23        23         4.2   45   13  2018-08-23   
#[Out]# 4611    4   13  2018-08-23        23         4.2   47    7  2018-08-23   
#[Out]# 4612    4   13  2018-08-23        23         4.2   48    6  2018-08-23   
#[Out]# 4613    4   13  2018-08-23        23         4.2   50   10  2018-08-23   
#[Out]# 4614    4   13  2018-08-23        23         4.2   50   14  2018-08-23   
#[Out]# 4615    4   13  2018-08-23        23         4.2   50   22  2018-08-23   
#[Out]# 4616    4   13  2018-08-23        23         4.2   51   10  2018-08-23   
#[Out]# 4617    4   13  2018-08-23        23         4.2   51   22  2018-08-23   
#[Out]# 4618    4   13  2018-08-23        23         4.2   52   28  2018-08-23   
#[Out]# 4619    4   13  2018-08-23        23         4.2   54   12  2018-08-23   
#[Out]# 4620    4   13  2018-08-23        23         4.2   55    1  2018-08-23   
#[Out]# 4621    4   13  2018-08-23        23         4.2   56    1  2018-08-23   
#[Out]# 4622    4   13  2018-08-23        23         4.2   56   25  2018-08-23   
#[Out]# 4623    4   13  2018-08-23        23         4.2   57   19  2018-08-23   
#[Out]# 
#[Out]#       quantity  unit_price  
#[Out]# 0            2        0.45  
#[Out]# 1           21        1.00  
#[Out]# 2            0        2.00  
#[Out]# 3           17        1.35  
#[Out]# 4           11        2.10  
#[Out]# 5           23        4.20  
#[Out]# 6           11       13.40  
#[Out]# 7            4        1.65  
#[Out]# 8           34        2.45  
#[Out]# 9           32        4.10  
#[Out]# 10          37        4.35  
#[Out]# 11           4        1.00  
#[Out]# 12          14        1.85  
#[Out]# 13          18        5.80  
#[Out]# 14           5       13.15  
#[Out]# 15          22        2.10  
#[Out]# 16          12        3.20  
#[Out]# 17          14        1.30  
#[Out]# 18           3        1.90  
#[Out]# 19           3        1.70  
#[Out]# 20          15        3.55  
#[Out]# 21           1        1.25  
#[Out]# 22          11        1.25  
#[Out]# 23          14        1.60  
#[Out]# 24          10        2.20  
#[Out]# 25          53        1.20  
#[Out]# 26          20        2.10  
#[Out]# 27           6        5.55  
#[Out]# 28          43        8.50  
#[Out]# 29          28        5.15  
#[Out]# ...        ...         ...  
#[Out]# 4594         7        2.20  
#[Out]# 4595        15        1.20  
#[Out]# 4596        28        4.15  
#[Out]# 4597        36        4.00  
#[Out]# 4598        54        8.85  
#[Out]# 4599        19        7.75  
#[Out]# 4600        29        1.80  
#[Out]# 4601        10        3.55  
#[Out]# 4602         3        4.10  
#[Out]# 4603        17        6.90  
#[Out]# 4604        53        4.60  
#[Out]# 4605         3        3.35  
#[Out]# 4606        46       11.40  
#[Out]# 4607        20        1.95  
#[Out]# 4608         4        2.65  
#[Out]# 4609        50        1.00  
#[Out]# 4610        32        4.10  
#[Out]# 4611        27        1.85  
#[Out]# 4612        21        1.15  
#[Out]# 4613        54        0.55  
#[Out]# 4614        19        3.85  
#[Out]# 4615         5        1.95  
#[Out]# 4616        31        0.60  
#[Out]# 4617        13        1.55  
#[Out]# 4618         8        7.35  
#[Out]# 4619         5       12.55  
#[Out]# 4620         1        4.80  
#[Out]# 4621         1        4.40  
#[Out]# 4622        19        4.35  
#[Out]# 4623        12        2.95  
#[Out]# 
#[Out]# [4624 rows x 10 columns]
query6 = '''
    SELECT * 
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#       sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0      51   10  2018-08-23        31         0.6    1    5  2018-08-23   
#[Out]# 1      51   10  2018-08-23        31         0.6    2   11  2018-08-23   
#[Out]# 2      51   10  2018-08-23        31         0.6    2   16  2018-08-23   
#[Out]# 3      51   10  2018-08-23        31         0.6    3    3  2018-08-23   
#[Out]# 4      51   10  2018-08-23        31         0.6    3   19  2018-08-23   
#[Out]# 5      51   10  2018-08-23        31         0.6    4   13  2018-08-23   
#[Out]# 6      51   10  2018-08-23        31         0.6    5   12  2018-08-23   
#[Out]# 7      51   10  2018-08-23        31         0.6    5   16  2018-08-23   
#[Out]# 8      51   10  2018-08-23        31         0.6    5   17  2018-08-23   
#[Out]# 9      51   10  2018-08-23        31         0.6    5   24  2018-08-23   
#[Out]# 10     51   10  2018-08-23        31         0.6    6    0  2018-08-23   
#[Out]# 11     51   10  2018-08-23        31         0.6    6   15  2018-08-23   
#[Out]# 12     51   10  2018-08-23        31         0.6    6   16  2018-08-23   
#[Out]# 13     51   10  2018-08-23        31         0.6    7    1  2018-08-23   
#[Out]# 14     51   10  2018-08-23        31         0.6    9   12  2018-08-23   
#[Out]# 15     51   10  2018-08-23        31         0.6   11    2  2018-08-23   
#[Out]# 16     51   10  2018-08-23        31         0.6   11   14  2018-08-23   
#[Out]# 17     51   10  2018-08-23        31         0.6   11   15  2018-08-23   
#[Out]# 18     51   10  2018-08-23        31         0.6   11   16  2018-08-23   
#[Out]# 19     51   10  2018-08-23        31         0.6   12    2  2018-08-23   
#[Out]# 20     51   10  2018-08-23        31         0.6   12   13  2018-08-23   
#[Out]# 21     51   10  2018-08-23        31         0.6   12   15  2018-08-23   
#[Out]# 22     51   10  2018-08-23        31         0.6   13   15  2018-08-23   
#[Out]# 23     51   10  2018-08-23        31         0.6   16   22  2018-08-23   
#[Out]# 24     51   10  2018-08-23        31         0.6   17   19  2018-08-23   
#[Out]# 25     51   10  2018-08-23        31         0.6   19    4  2018-08-23   
#[Out]# 26     51   10  2018-08-23        31         0.6   21   23  2018-08-23   
#[Out]# 27     51   10  2018-08-23        31         0.6   25    8  2018-08-23   
#[Out]# 28     51   10  2018-08-23        31         0.6   28   27  2018-08-23   
#[Out]# 29     51   10  2018-08-23        31         0.6   29    0  2018-08-23   
#[Out]# ...   ...  ...         ...       ...         ...  ...  ...         ...   
#[Out]# 4440    4   13  2018-08-23        23         4.2   35    7  2018-08-23   
#[Out]# 4441    4   13  2018-08-23        23         4.2   35   11  2018-08-23   
#[Out]# 4442    4   13  2018-08-23        23         4.2   35   13  2018-08-23   
#[Out]# 4443    4   13  2018-08-23        23         4.2   35   25  2018-08-23   
#[Out]# 4444    4   13  2018-08-23        23         4.2   35   27  2018-08-23   
#[Out]# 4445    4   13  2018-08-23        23         4.2   37   28  2018-08-23   
#[Out]# 4446    4   13  2018-08-23        23         4.2   38   23  2018-08-23   
#[Out]# 4447    4   13  2018-08-23        23         4.2   38   24  2018-08-23   
#[Out]# 4448    4   13  2018-08-23        23         4.2   40   14  2018-08-23   
#[Out]# 4449    4   13  2018-08-23        23         4.2   40   27  2018-08-23   
#[Out]# 4450    4   13  2018-08-23        23         4.2   41    1  2018-08-23   
#[Out]# 4451    4   13  2018-08-23        23         4.2   41   14  2018-08-23   
#[Out]# 4452    4   13  2018-08-23        23         4.2   42   12  2018-08-23   
#[Out]# 4453    4   13  2018-08-23        23         4.2   43    7  2018-08-23   
#[Out]# 4454    4   13  2018-08-23        23         4.2   44   19  2018-08-23   
#[Out]# 4455    4   13  2018-08-23        23         4.2   45    4  2018-08-23   
#[Out]# 4456    4   13  2018-08-23        23         4.2   45   13  2018-08-23   
#[Out]# 4457    4   13  2018-08-23        23         4.2   47    7  2018-08-23   
#[Out]# 4458    4   13  2018-08-23        23         4.2   48    6  2018-08-23   
#[Out]# 4459    4   13  2018-08-23        23         4.2   50   10  2018-08-23   
#[Out]# 4460    4   13  2018-08-23        23         4.2   50   14  2018-08-23   
#[Out]# 4461    4   13  2018-08-23        23         4.2   50   22  2018-08-23   
#[Out]# 4462    4   13  2018-08-23        23         4.2   51   10  2018-08-23   
#[Out]# 4463    4   13  2018-08-23        23         4.2   51   22  2018-08-23   
#[Out]# 4464    4   13  2018-08-23        23         4.2   52   28  2018-08-23   
#[Out]# 4465    4   13  2018-08-23        23         4.2   54   12  2018-08-23   
#[Out]# 4466    4   13  2018-08-23        23         4.2   55    1  2018-08-23   
#[Out]# 4467    4   13  2018-08-23        23         4.2   56    1  2018-08-23   
#[Out]# 4468    4   13  2018-08-23        23         4.2   56   25  2018-08-23   
#[Out]# 4469    4   13  2018-08-23        23         4.2   57   19  2018-08-23   
#[Out]# 
#[Out]#       quantity  unit_price  
#[Out]# 0            2        0.45  
#[Out]# 1           21        1.00  
#[Out]# 2            0        2.00  
#[Out]# 3           17        1.35  
#[Out]# 4           11        2.10  
#[Out]# 5           23        4.20  
#[Out]# 6           11       13.40  
#[Out]# 7            4        1.65  
#[Out]# 8           34        2.45  
#[Out]# 9           32        4.10  
#[Out]# 10          37        4.35  
#[Out]# 11           4        1.00  
#[Out]# 12          14        1.85  
#[Out]# 13          18        5.80  
#[Out]# 14           5       13.15  
#[Out]# 15          22        2.10  
#[Out]# 16          12        3.20  
#[Out]# 17          14        1.30  
#[Out]# 18           3        1.90  
#[Out]# 19           3        1.70  
#[Out]# 20          15        3.55  
#[Out]# 21           1        1.25  
#[Out]# 22          11        1.25  
#[Out]# 23          14        1.60  
#[Out]# 24          10        2.20  
#[Out]# 25          53        1.20  
#[Out]# 26          20        2.10  
#[Out]# 27           6        5.55  
#[Out]# 28          43        8.50  
#[Out]# 29          28        5.15  
#[Out]# ...        ...         ...  
#[Out]# 4440         7        2.20  
#[Out]# 4441        15        1.20  
#[Out]# 4442        28        4.15  
#[Out]# 4443        36        4.00  
#[Out]# 4444        54        8.85  
#[Out]# 4445        19        7.75  
#[Out]# 4446        29        1.80  
#[Out]# 4447        10        3.55  
#[Out]# 4448         3        4.10  
#[Out]# 4449        17        6.90  
#[Out]# 4450        53        4.60  
#[Out]# 4451         3        3.35  
#[Out]# 4452        46       11.40  
#[Out]# 4453        20        1.95  
#[Out]# 4454         4        2.65  
#[Out]# 4455        50        1.00  
#[Out]# 4456        32        4.10  
#[Out]# 4457        27        1.85  
#[Out]# 4458        21        1.15  
#[Out]# 4459        54        0.55  
#[Out]# 4460        19        3.85  
#[Out]# 4461         5        1.95  
#[Out]# 4462        31        0.60  
#[Out]# 4463        13        1.55  
#[Out]# 4464         8        7.35  
#[Out]# 4465         5       12.55  
#[Out]# 4466         1        4.80  
#[Out]# 4467         1        4.40  
#[Out]# 4468        19        4.35  
#[Out]# 4469        12        2.95  
#[Out]# 
#[Out]# [4470 rows x 10 columns]
query6 = '''
    SELECT * 
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            
'''

pd.read_sql_query(query6, conn)
#[Out]#       sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0      51   10  2018-08-23        31         0.6    1    5  2018-08-23   
#[Out]# 1      51   10  2018-08-23        31         0.6    2   11  2018-08-23   
#[Out]# 2      51   10  2018-08-23        31         0.6    2   16  2018-08-23   
#[Out]# 3      51   10  2018-08-23        31         0.6    3    3  2018-08-23   
#[Out]# 4      51   10  2018-08-23        31         0.6    3   19  2018-08-23   
#[Out]# 5      51   10  2018-08-23        31         0.6    4   13  2018-08-23   
#[Out]# 6      51   10  2018-08-23        31         0.6    5   12  2018-08-23   
#[Out]# 7      51   10  2018-08-23        31         0.6    5   16  2018-08-23   
#[Out]# 8      51   10  2018-08-23        31         0.6    5   17  2018-08-23   
#[Out]# 9      51   10  2018-08-23        31         0.6    5   24  2018-08-23   
#[Out]# 10     51   10  2018-08-23        31         0.6    6    0  2018-08-23   
#[Out]# 11     51   10  2018-08-23        31         0.6    6   15  2018-08-23   
#[Out]# 12     51   10  2018-08-23        31         0.6    6   16  2018-08-23   
#[Out]# 13     51   10  2018-08-23        31         0.6    7    1  2018-08-23   
#[Out]# 14     51   10  2018-08-23        31         0.6    9   12  2018-08-23   
#[Out]# 15     51   10  2018-08-23        31         0.6   11    2  2018-08-23   
#[Out]# 16     51   10  2018-08-23        31         0.6   11   14  2018-08-23   
#[Out]# 17     51   10  2018-08-23        31         0.6   11   15  2018-08-23   
#[Out]# 18     51   10  2018-08-23        31         0.6   11   16  2018-08-23   
#[Out]# 19     51   10  2018-08-23        31         0.6   12    2  2018-08-23   
#[Out]# 20     51   10  2018-08-23        31         0.6   12   13  2018-08-23   
#[Out]# 21     51   10  2018-08-23        31         0.6   12   15  2018-08-23   
#[Out]# 22     51   10  2018-08-23        31         0.6   13   15  2018-08-23   
#[Out]# 23     51   10  2018-08-23        31         0.6   16   22  2018-08-23   
#[Out]# 24     51   10  2018-08-23        31         0.6   17   19  2018-08-23   
#[Out]# 25     51   10  2018-08-23        31         0.6   19    4  2018-08-23   
#[Out]# 26     51   10  2018-08-23        31         0.6   21   23  2018-08-23   
#[Out]# 27     51   10  2018-08-23        31         0.6   25    8  2018-08-23   
#[Out]# 28     51   10  2018-08-23        31         0.6   28   27  2018-08-23   
#[Out]# 29     51   10  2018-08-23        31         0.6   29    0  2018-08-23   
#[Out]# ...   ...  ...         ...       ...         ...  ...  ...         ...   
#[Out]# 4594    4   13  2018-08-23        23         4.2   35    7  2018-08-23   
#[Out]# 4595    4   13  2018-08-23        23         4.2   35   11  2018-08-23   
#[Out]# 4596    4   13  2018-08-23        23         4.2   35   13  2018-08-23   
#[Out]# 4597    4   13  2018-08-23        23         4.2   35   25  2018-08-23   
#[Out]# 4598    4   13  2018-08-23        23         4.2   35   27  2018-08-23   
#[Out]# 4599    4   13  2018-08-23        23         4.2   37   28  2018-08-23   
#[Out]# 4600    4   13  2018-08-23        23         4.2   38   23  2018-08-23   
#[Out]# 4601    4   13  2018-08-23        23         4.2   38   24  2018-08-23   
#[Out]# 4602    4   13  2018-08-23        23         4.2   40   14  2018-08-23   
#[Out]# 4603    4   13  2018-08-23        23         4.2   40   27  2018-08-23   
#[Out]# 4604    4   13  2018-08-23        23         4.2   41    1  2018-08-23   
#[Out]# 4605    4   13  2018-08-23        23         4.2   41   14  2018-08-23   
#[Out]# 4606    4   13  2018-08-23        23         4.2   42   12  2018-08-23   
#[Out]# 4607    4   13  2018-08-23        23         4.2   43    7  2018-08-23   
#[Out]# 4608    4   13  2018-08-23        23         4.2   44   19  2018-08-23   
#[Out]# 4609    4   13  2018-08-23        23         4.2   45    4  2018-08-23   
#[Out]# 4610    4   13  2018-08-23        23         4.2   45   13  2018-08-23   
#[Out]# 4611    4   13  2018-08-23        23         4.2   47    7  2018-08-23   
#[Out]# 4612    4   13  2018-08-23        23         4.2   48    6  2018-08-23   
#[Out]# 4613    4   13  2018-08-23        23         4.2   50   10  2018-08-23   
#[Out]# 4614    4   13  2018-08-23        23         4.2   50   14  2018-08-23   
#[Out]# 4615    4   13  2018-08-23        23         4.2   50   22  2018-08-23   
#[Out]# 4616    4   13  2018-08-23        23         4.2   51   10  2018-08-23   
#[Out]# 4617    4   13  2018-08-23        23         4.2   51   22  2018-08-23   
#[Out]# 4618    4   13  2018-08-23        23         4.2   52   28  2018-08-23   
#[Out]# 4619    4   13  2018-08-23        23         4.2   54   12  2018-08-23   
#[Out]# 4620    4   13  2018-08-23        23         4.2   55    1  2018-08-23   
#[Out]# 4621    4   13  2018-08-23        23         4.2   56    1  2018-08-23   
#[Out]# 4622    4   13  2018-08-23        23         4.2   56   25  2018-08-23   
#[Out]# 4623    4   13  2018-08-23        23         4.2   57   19  2018-08-23   
#[Out]# 
#[Out]#       quantity  unit_price  
#[Out]# 0            2        0.45  
#[Out]# 1           21        1.00  
#[Out]# 2            0        2.00  
#[Out]# 3           17        1.35  
#[Out]# 4           11        2.10  
#[Out]# 5           23        4.20  
#[Out]# 6           11       13.40  
#[Out]# 7            4        1.65  
#[Out]# 8           34        2.45  
#[Out]# 9           32        4.10  
#[Out]# 10          37        4.35  
#[Out]# 11           4        1.00  
#[Out]# 12          14        1.85  
#[Out]# 13          18        5.80  
#[Out]# 14           5       13.15  
#[Out]# 15          22        2.10  
#[Out]# 16          12        3.20  
#[Out]# 17          14        1.30  
#[Out]# 18           3        1.90  
#[Out]# 19           3        1.70  
#[Out]# 20          15        3.55  
#[Out]# 21           1        1.25  
#[Out]# 22          11        1.25  
#[Out]# 23          14        1.60  
#[Out]# 24          10        2.20  
#[Out]# 25          53        1.20  
#[Out]# 26          20        2.10  
#[Out]# 27           6        5.55  
#[Out]# 28          43        8.50  
#[Out]# 29          28        5.15  
#[Out]# ...        ...         ...  
#[Out]# 4594         7        2.20  
#[Out]# 4595        15        1.20  
#[Out]# 4596        28        4.15  
#[Out]# 4597        36        4.00  
#[Out]# 4598        54        8.85  
#[Out]# 4599        19        7.75  
#[Out]# 4600        29        1.80  
#[Out]# 4601        10        3.55  
#[Out]# 4602         3        4.10  
#[Out]# 4603        17        6.90  
#[Out]# 4604        53        4.60  
#[Out]# 4605         3        3.35  
#[Out]# 4606        46       11.40  
#[Out]# 4607        20        1.95  
#[Out]# 4608         4        2.65  
#[Out]# 4609        50        1.00  
#[Out]# 4610        32        4.10  
#[Out]# 4611        27        1.85  
#[Out]# 4612        21        1.15  
#[Out]# 4613        54        0.55  
#[Out]# 4614        19        3.85  
#[Out]# 4615         5        1.95  
#[Out]# 4616        31        0.60  
#[Out]# 4617        13        1.55  
#[Out]# 4618         8        7.35  
#[Out]# 4619         5       12.55  
#[Out]# 4620         1        4.80  
#[Out]# 4621         1        4.40  
#[Out]# 4622        19        4.35  
#[Out]# 4623        12        2.95  
#[Out]# 
#[Out]# [4624 rows x 10 columns]
query6 = '''
    SELECT * 
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#       sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0      51   10  2018-08-23        31         0.6    1    5  2018-08-23   
#[Out]# 1      51   10  2018-08-23        31         0.6    2   11  2018-08-23   
#[Out]# 2      51   10  2018-08-23        31         0.6    2   16  2018-08-23   
#[Out]# 3      51   10  2018-08-23        31         0.6    3    3  2018-08-23   
#[Out]# 4      51   10  2018-08-23        31         0.6    3   19  2018-08-23   
#[Out]# 5      51   10  2018-08-23        31         0.6    4   13  2018-08-23   
#[Out]# 6      51   10  2018-08-23        31         0.6    5   12  2018-08-23   
#[Out]# 7      51   10  2018-08-23        31         0.6    5   16  2018-08-23   
#[Out]# 8      51   10  2018-08-23        31         0.6    5   17  2018-08-23   
#[Out]# 9      51   10  2018-08-23        31         0.6    5   24  2018-08-23   
#[Out]# 10     51   10  2018-08-23        31         0.6    6    0  2018-08-23   
#[Out]# 11     51   10  2018-08-23        31         0.6    6   15  2018-08-23   
#[Out]# 12     51   10  2018-08-23        31         0.6    6   16  2018-08-23   
#[Out]# 13     51   10  2018-08-23        31         0.6    7    1  2018-08-23   
#[Out]# 14     51   10  2018-08-23        31         0.6    9   12  2018-08-23   
#[Out]# 15     51   10  2018-08-23        31         0.6   11    2  2018-08-23   
#[Out]# 16     51   10  2018-08-23        31         0.6   11   14  2018-08-23   
#[Out]# 17     51   10  2018-08-23        31         0.6   11   15  2018-08-23   
#[Out]# 18     51   10  2018-08-23        31         0.6   11   16  2018-08-23   
#[Out]# 19     51   10  2018-08-23        31         0.6   12    2  2018-08-23   
#[Out]# 20     51   10  2018-08-23        31         0.6   12   13  2018-08-23   
#[Out]# 21     51   10  2018-08-23        31         0.6   12   15  2018-08-23   
#[Out]# 22     51   10  2018-08-23        31         0.6   13   15  2018-08-23   
#[Out]# 23     51   10  2018-08-23        31         0.6   16   22  2018-08-23   
#[Out]# 24     51   10  2018-08-23        31         0.6   17   19  2018-08-23   
#[Out]# 25     51   10  2018-08-23        31         0.6   19    4  2018-08-23   
#[Out]# 26     51   10  2018-08-23        31         0.6   21   23  2018-08-23   
#[Out]# 27     51   10  2018-08-23        31         0.6   25    8  2018-08-23   
#[Out]# 28     51   10  2018-08-23        31         0.6   28   27  2018-08-23   
#[Out]# 29     51   10  2018-08-23        31         0.6   29    0  2018-08-23   
#[Out]# ...   ...  ...         ...       ...         ...  ...  ...         ...   
#[Out]# 4440    4   13  2018-08-23        23         4.2   35    7  2018-08-23   
#[Out]# 4441    4   13  2018-08-23        23         4.2   35   11  2018-08-23   
#[Out]# 4442    4   13  2018-08-23        23         4.2   35   13  2018-08-23   
#[Out]# 4443    4   13  2018-08-23        23         4.2   35   25  2018-08-23   
#[Out]# 4444    4   13  2018-08-23        23         4.2   35   27  2018-08-23   
#[Out]# 4445    4   13  2018-08-23        23         4.2   37   28  2018-08-23   
#[Out]# 4446    4   13  2018-08-23        23         4.2   38   23  2018-08-23   
#[Out]# 4447    4   13  2018-08-23        23         4.2   38   24  2018-08-23   
#[Out]# 4448    4   13  2018-08-23        23         4.2   40   14  2018-08-23   
#[Out]# 4449    4   13  2018-08-23        23         4.2   40   27  2018-08-23   
#[Out]# 4450    4   13  2018-08-23        23         4.2   41    1  2018-08-23   
#[Out]# 4451    4   13  2018-08-23        23         4.2   41   14  2018-08-23   
#[Out]# 4452    4   13  2018-08-23        23         4.2   42   12  2018-08-23   
#[Out]# 4453    4   13  2018-08-23        23         4.2   43    7  2018-08-23   
#[Out]# 4454    4   13  2018-08-23        23         4.2   44   19  2018-08-23   
#[Out]# 4455    4   13  2018-08-23        23         4.2   45    4  2018-08-23   
#[Out]# 4456    4   13  2018-08-23        23         4.2   45   13  2018-08-23   
#[Out]# 4457    4   13  2018-08-23        23         4.2   47    7  2018-08-23   
#[Out]# 4458    4   13  2018-08-23        23         4.2   48    6  2018-08-23   
#[Out]# 4459    4   13  2018-08-23        23         4.2   50   10  2018-08-23   
#[Out]# 4460    4   13  2018-08-23        23         4.2   50   14  2018-08-23   
#[Out]# 4461    4   13  2018-08-23        23         4.2   50   22  2018-08-23   
#[Out]# 4462    4   13  2018-08-23        23         4.2   51   10  2018-08-23   
#[Out]# 4463    4   13  2018-08-23        23         4.2   51   22  2018-08-23   
#[Out]# 4464    4   13  2018-08-23        23         4.2   52   28  2018-08-23   
#[Out]# 4465    4   13  2018-08-23        23         4.2   54   12  2018-08-23   
#[Out]# 4466    4   13  2018-08-23        23         4.2   55    1  2018-08-23   
#[Out]# 4467    4   13  2018-08-23        23         4.2   56    1  2018-08-23   
#[Out]# 4468    4   13  2018-08-23        23         4.2   56   25  2018-08-23   
#[Out]# 4469    4   13  2018-08-23        23         4.2   57   19  2018-08-23   
#[Out]# 
#[Out]#       quantity  unit_price  
#[Out]# 0            2        0.45  
#[Out]# 1           21        1.00  
#[Out]# 2            0        2.00  
#[Out]# 3           17        1.35  
#[Out]# 4           11        2.10  
#[Out]# 5           23        4.20  
#[Out]# 6           11       13.40  
#[Out]# 7            4        1.65  
#[Out]# 8           34        2.45  
#[Out]# 9           32        4.10  
#[Out]# 10          37        4.35  
#[Out]# 11           4        1.00  
#[Out]# 12          14        1.85  
#[Out]# 13          18        5.80  
#[Out]# 14           5       13.15  
#[Out]# 15          22        2.10  
#[Out]# 16          12        3.20  
#[Out]# 17          14        1.30  
#[Out]# 18           3        1.90  
#[Out]# 19           3        1.70  
#[Out]# 20          15        3.55  
#[Out]# 21           1        1.25  
#[Out]# 22          11        1.25  
#[Out]# 23          14        1.60  
#[Out]# 24          10        2.20  
#[Out]# 25          53        1.20  
#[Out]# 26          20        2.10  
#[Out]# 27           6        5.55  
#[Out]# 28          43        8.50  
#[Out]# 29          28        5.15  
#[Out]# ...        ...         ...  
#[Out]# 4440         7        2.20  
#[Out]# 4441        15        1.20  
#[Out]# 4442        28        4.15  
#[Out]# 4443        36        4.00  
#[Out]# 4444        54        8.85  
#[Out]# 4445        19        7.75  
#[Out]# 4446        29        1.80  
#[Out]# 4447        10        3.55  
#[Out]# 4448         3        4.10  
#[Out]# 4449        17        6.90  
#[Out]# 4450        53        4.60  
#[Out]# 4451         3        3.35  
#[Out]# 4452        46       11.40  
#[Out]# 4453        20        1.95  
#[Out]# 4454         4        2.65  
#[Out]# 4455        50        1.00  
#[Out]# 4456        32        4.10  
#[Out]# 4457        27        1.85  
#[Out]# 4458        21        1.15  
#[Out]# 4459        54        0.55  
#[Out]# 4460        19        3.85  
#[Out]# 4461         5        1.95  
#[Out]# 4462        31        0.60  
#[Out]# 4463        13        1.55  
#[Out]# 4464         8        7.35  
#[Out]# 4465         5       12.55  
#[Out]# 4466         1        4.80  
#[Out]# 4467         1        4.40  
#[Out]# 4468        19        4.35  
#[Out]# 4469        12        2.95  
#[Out]# 
#[Out]# [4470 rows x 10 columns]
query6 = '''
    SELECT max(ABS(i1.unit_price-i2.unite_price)
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(ABS(i1.unit_price-i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(ABS(i1.unit-price-i2.unit-price)
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(ABS(i1.unit-price-i2.unit-price))
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(ABS(i1.unit-price - i2.unit-price))
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(ABS(i1.unit-price))
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(i1.unit-price)
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(i1.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price)
#[Out]# 0                13.4
query6 = '''
    SELECT max(i1.unit_price-i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price-i2.unit_price)
#[Out]# 0                             12.95
query6 = '''
    SELECT max(abs(i1.unit_price-i2.unit_price))
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price-i2.unit_price))
#[Out]# 0                                  12.95
query6 = '''
    SELECT max(abs(i1.unit_price-i2.unit_price))
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID AND i1,pID=i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(abs(i1.unit_price-i2.unit_price))
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i2.date='2018-08-23'
            AND i1.sID<>i2.sID AND i1.pID=i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price-i2.unit_price))
#[Out]# 0                                    2.0

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x1b6233e1f10>

