# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
testquery = '''
    SELECT pID
    FROM purchase
    WHERE pID NOT IN (
        SELECT pID, COUNT (cID) AS count
        FROM purchase
        WHERE count > 2
        )
'''
pd.read_sql_query(testquery, conn)
testquery = '''
    SELECT pID
    FROM purchase
    WHERE pID NOT IN (
        SELECT COUNT (cID) AS count
        FROM purchase
        WHERE count > 2
        )
'''
pd.read_sql_query(testquery, conn)
testquery = '''
    SELECT pID
    FROM purchase
    WHERE pID NOT IN (
        SELECT count(cID) AS count
        FROM purchase
        WHERE count > 2
        )
'''
pd.read_sql_query(testquery, conn)
testquery = '''
    SELECT pID
    FROM purchase
    WHERE pID NOT IN (
        SELECT count(cID) AS count
        FROM purchase
        WHERE count > 2
        )
'''
pd.read_sql_query(testquery, conn)
testquery = '''
    SELECT pID
    FROM purchase
    WHERE pID NOT IN (
        SELECT pID, count(cID) AS count
        FROM purchase
        WHERE count > 2
        )
'''
pd.read_sql_query(testquery, conn)
testquery = '''
    SELECT p1.pID, DISTINCT p2.cID
    FROM purchase AS p1, purchase AS p2
    WHERE p1.pID = p2.pID
        )
'''
pd.read_sql_query(testquery, conn)
testquery = '''
    WITH helper AS (
        SELECT DISTINCT cID, pID
        FROM purchase)
    SELECT pID
    FROM helper
        )
'''
pd.read_sql_query(testquery, conn)
testquery = '''
    WITH helper AS (
        SELECT DISTINCT cID, pID
        FROM purchase)
    SELECT pID
    FROM helper
'''
pd.read_sql_query(testquery, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 438    0
#[Out]# 439   29
#[Out]# 440   29
#[Out]# 441   30
#[Out]# 442    7
#[Out]# 443   19
#[Out]# 444   27
#[Out]# 445   19
#[Out]# 446   28
#[Out]# 447    7
#[Out]# 448    2
#[Out]# 449   10
#[Out]# 450   22
#[Out]# 451   20
#[Out]# 452   21
#[Out]# 453    9
#[Out]# 454   26
#[Out]# 455    0
#[Out]# 456   15
#[Out]# 457    4
#[Out]# 458   23
#[Out]# 459   17
#[Out]# 460   25
#[Out]# 461    3
#[Out]# 462    5
#[Out]# 463   13
#[Out]# 464   11
#[Out]# 465    6
#[Out]# 466    8
#[Out]# 467   18
#[Out]# 
#[Out]# [468 rows x 1 columns]
testquery = '''
    WITH helper AS (
        SELECT DISTINCT cID AS custID, pID AS prodID
        FROM purchase)
    SELECT prodID
    FROM helper
'''
pd.read_sql_query(testquery, conn)
#[Out]#      prodID
#[Out]# 0        10
#[Out]# 1        14
#[Out]# 2        16
#[Out]# 3         9
#[Out]# 4        25
#[Out]# 5        26
#[Out]# 6        11
#[Out]# 7        27
#[Out]# 8        20
#[Out]# 9         9
#[Out]# 10        4
#[Out]# 11       13
#[Out]# 12       22
#[Out]# 13       14
#[Out]# 14       26
#[Out]# 15        9
#[Out]# 16        8
#[Out]# 17       27
#[Out]# 18       12
#[Out]# 19        6
#[Out]# 20       13
#[Out]# 21       26
#[Out]# 22       14
#[Out]# 23       28
#[Out]# 24        6
#[Out]# 25       22
#[Out]# 26       16
#[Out]# 27       19
#[Out]# 28       19
#[Out]# 29        2
#[Out]# ..      ...
#[Out]# 438       0
#[Out]# 439      29
#[Out]# 440      29
#[Out]# 441      30
#[Out]# 442       7
#[Out]# 443      19
#[Out]# 444      27
#[Out]# 445      19
#[Out]# 446      28
#[Out]# 447       7
#[Out]# 448       2
#[Out]# 449      10
#[Out]# 450      22
#[Out]# 451      20
#[Out]# 452      21
#[Out]# 453       9
#[Out]# 454      26
#[Out]# 455       0
#[Out]# 456      15
#[Out]# 457       4
#[Out]# 458      23
#[Out]# 459      17
#[Out]# 460      25
#[Out]# 461       3
#[Out]# 462       5
#[Out]# 463      13
#[Out]# 464      11
#[Out]# 465       6
#[Out]# 466       8
#[Out]# 467      18
#[Out]# 
#[Out]# [468 rows x 1 columns]
testquery = '''
    WITH helper AS (
        SELECT DISTINCT cID AS custID, pID AS prodID
        FROM purchase)
    SELECT prodID, custID
    FROM helper
'''
pd.read_sql_query(testquery, conn)
#[Out]#      prodID  custID
#[Out]# 0        10       0
#[Out]# 1        14       1
#[Out]# 2        16       1
#[Out]# 3         9       1
#[Out]# 4        25       1
#[Out]# 5        26       1
#[Out]# 6        11       1
#[Out]# 7        27       1
#[Out]# 8        20       2
#[Out]# 9         9       2
#[Out]# 10        4       2
#[Out]# 11       13       2
#[Out]# 12       22       2
#[Out]# 13       14       3
#[Out]# 14       26       3
#[Out]# 15        9       3
#[Out]# 16        8       4
#[Out]# 17       27       4
#[Out]# 18       12       4
#[Out]# 19        6       4
#[Out]# 20       13       4
#[Out]# 21       26       4
#[Out]# 22       14       5
#[Out]# 23       28       5
#[Out]# 24        6       5
#[Out]# 25       22       5
#[Out]# 26       16       5
#[Out]# 27       19       5
#[Out]# 28       19       7
#[Out]# 29        2       7
#[Out]# ..      ...     ...
#[Out]# 438       0     184
#[Out]# 439      29     185
#[Out]# 440      29     186
#[Out]# 441      30     188
#[Out]# 442       7     189
#[Out]# 443      19     189
#[Out]# 444      27     190
#[Out]# 445      19     190
#[Out]# 446      28     190
#[Out]# 447       7     190
#[Out]# 448       2     190
#[Out]# 449      10     190
#[Out]# 450      22     190
#[Out]# 451      20     190
#[Out]# 452      21     190
#[Out]# 453       9     190
#[Out]# 454      26     190
#[Out]# 455       0     190
#[Out]# 456      15     190
#[Out]# 457       4     190
#[Out]# 458      23     190
#[Out]# 459      17     190
#[Out]# 460      25     190
#[Out]# 461       3     190
#[Out]# 462       5     190
#[Out]# 463      13     190
#[Out]# 464      11     190
#[Out]# 465       6     190
#[Out]# 466       8     190
#[Out]# 467      18     190
#[Out]# 
#[Out]# [468 rows x 2 columns]
testquery = '''
    WITH helper AS (
        SELECT DISTINCT cID AS custID, pID AS prodID
        FROM purchase)
    SELECT prodID, custID
    FROM helper
    GROUP BY prodID
'''
pd.read_sql_query(testquery, conn)
#[Out]#     prodID  custID
#[Out]# 0        0     190
#[Out]# 1        1     169
#[Out]# 2        2     190
#[Out]# 3        3     190
#[Out]# 4        4     190
#[Out]# 5        5     190
#[Out]# 6        6     190
#[Out]# 7        7     190
#[Out]# 8        8     190
#[Out]# 9        9     190
#[Out]# 10      10     190
#[Out]# 11      11     190
#[Out]# 12      12     162
#[Out]# 13      13     190
#[Out]# 14      14     179
#[Out]# 15      15     190
#[Out]# 16      16     179
#[Out]# 17      17     190
#[Out]# 18      18     190
#[Out]# 19      19     190
#[Out]# 20      20     190
#[Out]# 21      21     190
#[Out]# 22      22     190
#[Out]# 23      23     190
#[Out]# 24      24     178
#[Out]# 25      25     190
#[Out]# 26      26     190
#[Out]# 27      27     190
#[Out]# 28      28     190
#[Out]# 29      29     186
#[Out]# 30      30     188
testquery = '''
    WITH helper AS (
        SELECT DISTINCT cID AS custID, pID AS prodID
        FROM purchase)
    SELECT prodID, custID
    FROM helper
'''
pd.read_sql_query(testquery, conn)
#[Out]#      prodID  custID
#[Out]# 0        10       0
#[Out]# 1        14       1
#[Out]# 2        16       1
#[Out]# 3         9       1
#[Out]# 4        25       1
#[Out]# 5        26       1
#[Out]# 6        11       1
#[Out]# 7        27       1
#[Out]# 8        20       2
#[Out]# 9         9       2
#[Out]# 10        4       2
#[Out]# 11       13       2
#[Out]# 12       22       2
#[Out]# 13       14       3
#[Out]# 14       26       3
#[Out]# 15        9       3
#[Out]# 16        8       4
#[Out]# 17       27       4
#[Out]# 18       12       4
#[Out]# 19        6       4
#[Out]# 20       13       4
#[Out]# 21       26       4
#[Out]# 22       14       5
#[Out]# 23       28       5
#[Out]# 24        6       5
#[Out]# 25       22       5
#[Out]# 26       16       5
#[Out]# 27       19       5
#[Out]# 28       19       7
#[Out]# 29        2       7
#[Out]# ..      ...     ...
#[Out]# 438       0     184
#[Out]# 439      29     185
#[Out]# 440      29     186
#[Out]# 441      30     188
#[Out]# 442       7     189
#[Out]# 443      19     189
#[Out]# 444      27     190
#[Out]# 445      19     190
#[Out]# 446      28     190
#[Out]# 447       7     190
#[Out]# 448       2     190
#[Out]# 449      10     190
#[Out]# 450      22     190
#[Out]# 451      20     190
#[Out]# 452      21     190
#[Out]# 453       9     190
#[Out]# 454      26     190
#[Out]# 455       0     190
#[Out]# 456      15     190
#[Out]# 457       4     190
#[Out]# 458      23     190
#[Out]# 459      17     190
#[Out]# 460      25     190
#[Out]# 461       3     190
#[Out]# 462       5     190
#[Out]# 463      13     190
#[Out]# 464      11     190
#[Out]# 465       6     190
#[Out]# 466       8     190
#[Out]# 467      18     190
#[Out]# 
#[Out]# [468 rows x 2 columns]
testquery = '''
    WITH helper AS (
        SELECT DISTINCT cID AS custID, pID AS prodID
        FROM purchase)
    SELECT prodID, custID
    FROM helper
    GROUP BY prodID, custID
'''
pd.read_sql_query(testquery, conn)
#[Out]#      prodID  custID
#[Out]# 0         0      13
#[Out]# 1         0      16
#[Out]# 2         0      19
#[Out]# 3         0      20
#[Out]# 4         0      24
#[Out]# 5         0      33
#[Out]# 6         0      66
#[Out]# 7         0      78
#[Out]# 8         0      82
#[Out]# 9         0      95
#[Out]# 10        0     113
#[Out]# 11        0     123
#[Out]# 12        0     127
#[Out]# 13        0     139
#[Out]# 14        0     144
#[Out]# 15        0     157
#[Out]# 16        0     163
#[Out]# 17        0     167
#[Out]# 18        0     170
#[Out]# 19        0     176
#[Out]# 20        0     184
#[Out]# 21        0     190
#[Out]# 22        1      33
#[Out]# 23        1      59
#[Out]# 24        1      69
#[Out]# 25        1      92
#[Out]# 26        1     108
#[Out]# 27        1     109
#[Out]# 28        1     112
#[Out]# 29        1     131
#[Out]# ..      ...     ...
#[Out]# 438      27     134
#[Out]# 439      27     161
#[Out]# 440      27     179
#[Out]# 441      27     190
#[Out]# 442      28       5
#[Out]# 443      28      22
#[Out]# 444      28      35
#[Out]# 445      28      39
#[Out]# 446      28      40
#[Out]# 447      28      60
#[Out]# 448      28      70
#[Out]# 449      28      71
#[Out]# 450      28      82
#[Out]# 451      28      86
#[Out]# 452      28     100
#[Out]# 453      28     108
#[Out]# 454      28     118
#[Out]# 455      28     123
#[Out]# 456      28     124
#[Out]# 457      28     127
#[Out]# 458      28     136
#[Out]# 459      28     161
#[Out]# 460      28     162
#[Out]# 461      28     169
#[Out]# 462      28     170
#[Out]# 463      28     175
#[Out]# 464      28     190
#[Out]# 465      29     185
#[Out]# 466      29     186
#[Out]# 467      30     188
#[Out]# 
#[Out]# [468 rows x 2 columns]
testquery = '''
    WITH helper AS (
        SELECT DISTINCT cID AS custID, pID AS prodID
        FROM purchase)
    SELECT prodID, custID
    FROM helper
    GROUP BY prodID
'''
pd.read_sql_query(testquery, conn)
#[Out]#     prodID  custID
#[Out]# 0        0     190
#[Out]# 1        1     169
#[Out]# 2        2     190
#[Out]# 3        3     190
#[Out]# 4        4     190
#[Out]# 5        5     190
#[Out]# 6        6     190
#[Out]# 7        7     190
#[Out]# 8        8     190
#[Out]# 9        9     190
#[Out]# 10      10     190
#[Out]# 11      11     190
#[Out]# 12      12     162
#[Out]# 13      13     190
#[Out]# 14      14     179
#[Out]# 15      15     190
#[Out]# 16      16     179
#[Out]# 17      17     190
#[Out]# 18      18     190
#[Out]# 19      19     190
#[Out]# 20      20     190
#[Out]# 21      21     190
#[Out]# 22      22     190
#[Out]# 23      23     190
#[Out]# 24      24     178
#[Out]# 25      25     190
#[Out]# 26      26     190
#[Out]# 27      27     190
#[Out]# 28      28     190
#[Out]# 29      29     186
#[Out]# 30      30     188
testquery = '''
    WITH helper AS (
        SELECT DISTINCT cID AS custID, pID AS prodID
        FROM purchase)
    SELECT prodID, custID
    FROM helper
'''
pd.read_sql_query(testquery, conn)
#[Out]#      prodID  custID
#[Out]# 0        10       0
#[Out]# 1        14       1
#[Out]# 2        16       1
#[Out]# 3         9       1
#[Out]# 4        25       1
#[Out]# 5        26       1
#[Out]# 6        11       1
#[Out]# 7        27       1
#[Out]# 8        20       2
#[Out]# 9         9       2
#[Out]# 10        4       2
#[Out]# 11       13       2
#[Out]# 12       22       2
#[Out]# 13       14       3
#[Out]# 14       26       3
#[Out]# 15        9       3
#[Out]# 16        8       4
#[Out]# 17       27       4
#[Out]# 18       12       4
#[Out]# 19        6       4
#[Out]# 20       13       4
#[Out]# 21       26       4
#[Out]# 22       14       5
#[Out]# 23       28       5
#[Out]# 24        6       5
#[Out]# 25       22       5
#[Out]# 26       16       5
#[Out]# 27       19       5
#[Out]# 28       19       7
#[Out]# 29        2       7
#[Out]# ..      ...     ...
#[Out]# 438       0     184
#[Out]# 439      29     185
#[Out]# 440      29     186
#[Out]# 441      30     188
#[Out]# 442       7     189
#[Out]# 443      19     189
#[Out]# 444      27     190
#[Out]# 445      19     190
#[Out]# 446      28     190
#[Out]# 447       7     190
#[Out]# 448       2     190
#[Out]# 449      10     190
#[Out]# 450      22     190
#[Out]# 451      20     190
#[Out]# 452      21     190
#[Out]# 453       9     190
#[Out]# 454      26     190
#[Out]# 455       0     190
#[Out]# 456      15     190
#[Out]# 457       4     190
#[Out]# 458      23     190
#[Out]# 459      17     190
#[Out]# 460      25     190
#[Out]# 461       3     190
#[Out]# 462       5     190
#[Out]# 463      13     190
#[Out]# 464      11     190
#[Out]# 465       6     190
#[Out]# 466       8     190
#[Out]# 467      18     190
#[Out]# 
#[Out]# [468 rows x 2 columns]
testquery = '''
    SELECT COUNT (cID), pID
    FROM purchase
    GROUP BY pID
    HAVING COUNT (cID) < 3
'''
pd.read_sql_query(testquery, conn)
#[Out]#    COUNT (cID)  pID
#[Out]# 0            2   29
#[Out]# 1            2   30
testquery = '''
    SELECT pID
    FROM purchase
    GROUP BY pID
    HAVING COUNT (cID) < 3
'''
pd.read_sql_query(testquery, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
testquery2 = '''
    SELECT customer.cID, cName
    FROM customer
    WHERE cID IN (
        SELECT p.cID
        FROM purchase AS p
        WHERE p.cID IN (
            SELECT p.cID
            FROM p
            WHERE p.pName = "Onions"
            ) AND p.cID IN (
            SELECT p.cID
            FROM p
            WHERE p.pName = "Coffee"
            )
        )
'''
pd.read_sql_query(testquery2, conn)
testquery2 = '''
    SELECT customer.cID, cName
    FROM customer
    WHERE cID IN (
        SELECT p.cID
        FROM purchase AS p
        WHERE p.cID IN (
            SELECT p.cID
            FROM purchase AS p
            WHERE p.pName = "Onions"
            ) AND p.cID IN (
            SELECT p.cID
            FROM purchase AS p
            WHERE p.pName = "Coffee"
            )
        )
'''
pd.read_sql_query(testquery2, conn)
testquery2 = '''
    SELECT customer.cID, cName
    FROM customer
    WHERE cID IN (
    
        SELECT purchase.cID
        FROM purchase
        WHERE purchase.cID IN (
        
            SELECT purchase.cID
            FROM purchase
            WHERE purchase.pName = "Onions"
            
            ) AND purchase.cID IN (
            
            SELECT purchase.cID
            FROM purchase
            WHERE purchase.pName = "Coffee"
            
            )
        )
'''
pd.read_sql_query(testquery2, conn)
testquery2 = '''
    SELECT customer.cID, cName
    FROM customer
    WHERE cID IN (
    
        SELECT purchase.cID
        FROM purchase
        WHERE purchase.cID IN (
        
            SELECT purchase.cID
            FROM purchase, product
            WHERE purchase.pID = product.pID AND product.pName = "Onions"
            
            ) AND purchase.cID IN (
            
            SELECT purchase.cID
            FROM purchase
            WHERE purchase.pID = product.pID AND product.pName = "Coffee"
            
            )
        )
'''
pd.read_sql_query(testquery2, conn)
testquery2 = '''
    SELECT customer.cID, cName
    FROM customer
    WHERE cID IN (
    
        SELECT purchase.cID
        FROM purchase
        WHERE purchase.cID IN (
        
            SELECT purchase.cID
            FROM purchase, product
            WHERE purchase.pID = product.pID AND product.pName = "Onions"
            
            ) AND purchase.cID IN (
            
            SELECT purchase.cID
            FROM purchase, product
            WHERE purchase.pID = product.pID AND product.pName = "Coffee"
            
            )
        )
'''
pd.read_sql_query(testquery2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
testquery4 = '''
    SELECT sName
    FROM store, purchase
    WHERE store.sID = purchase.sID
    GROUP BY sName
    HAVING AVG(quantity) > 4
'''
pd.read_sql_query(testquery4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
testquery4 = '''
    SELECT sName
    FROM store, purchase
    WHERE store.sID = purchase.sID AND sID IN (
        
        SELECT sName
        FROM store
        GROUP BY sName
        HAVING COUNT(sID) > 1
        
    )
    GROUP BY sName
    HAVING AVG(quantity) > 4
'''
pd.read_sql_query(testquery4, conn)
testquery4 = '''
    SELECT sName
    FROM store, purchase
    WHERE store.sID = purchase.sID AND sID IN (
        
        SELECT sName
        FROM store
        GROUP BY sName
        HAVING COUNT(store.sID) > 1
        
    )
    GROUP BY sName
    HAVING AVG(quantity) > 4
'''
pd.read_sql_query(testquery4, conn)
testquery4 = '''
    SELECT sName
    FROM store, purchase
    WHERE store.sID = purchase.sID AND sName IN (
        
        SELECT sName
        FROM store
        GROUP BY sName
        HAVING COUNT(store.sID) > 1
        
    )
    GROUP BY sName
    HAVING AVG(quantity) > 4
'''
pd.read_sql_query(testquery4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
testquery5 = '''
    SELECT MAX(price), pName
    FROM purchase, product
    WHERE purchase.pID = product.pID
'''
pd.read_sql_query(testquery5, conn)
#[Out]#    MAX(price) pName
#[Out]# 0        13.8  Beef
testquery5 = '''
    SELECT MAX(price), pName, sID
    FROM purchase, product
    WHERE purchase.pID = product.pID
'''
pd.read_sql_query(testquery5, conn)
#[Out]#    MAX(price) pName  sID
#[Out]# 0        13.8  Beef   27
testquery5 = '''
    SELECT pName, sName, MAX(price)
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
'''
pd.read_sql_query(testquery5, conn)
#[Out]#   pName   sName  MAX(price)
#[Out]# 0  Beef  Sligro        13.8
testquery5 = '''
    SELECT pName, sName, MAX(price)
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
    GROUP BY pName
    HAVING MAX(price)
'''
pd.read_sql_query(testquery5, conn)
#[Out]#                pName        sName  MAX(price)
#[Out]# 0             Apples    Hoogvliet        4.70
#[Out]# 1            Bananas        Jumbo        3.15
#[Out]# 2               Beef       Sligro       13.80
#[Out]# 3              Bread        Jumbo        3.80
#[Out]# 4            Carrots  Albert Hein        2.95
#[Out]# 5        Cashew Nuts         Coop        5.40
#[Out]# 6             Cheese  Albert Hein       12.00
#[Out]# 7               Coca         Dirk        4.25
#[Out]# 8             Coffee  Albert Hein        4.25
#[Out]# 9          Cucumbers         Coop        3.80
#[Out]# 10            Donuts        Jumbo        4.70
#[Out]# 11              Eggs    Hoogvliet        4.20
#[Out]# 12             Fanta    Hoogvliet        4.30
#[Out]# 13      Green Pepper         Dirk        2.75
#[Out]# 14  Hot Dog Sausages  Albert Hein        5.70
#[Out]# 15           Ketchup        Jumbo        1.00
#[Out]# 16           Lasanga  Albert Hein        9.85
#[Out]# 17              Milk         Coop        3.55
#[Out]# 18        Mixed Nuts         Coop        6.55
#[Out]# 19         Mushrooms         Lidl        4.35
#[Out]# 20            Onions         Lidl        2.40
#[Out]# 21           Oranges         Coop        4.20
#[Out]# 22             Pasta         Lidl        3.55
#[Out]# 23             Pizza    Hoogvliet        9.25
#[Out]# 24          Potatoes         Coop        2.30
#[Out]# 25              Rice        Jumbo        2.10
#[Out]# 26            Salmon        Jumbo        1.00
#[Out]# 27   Spiced Biscuits         Coop        3.75
#[Out]# 28               Tea       Sligro        3.20
#[Out]# 29          Tomatoes        Jumbo        2.35
#[Out]# 30             Water         Dirk        4.35
testquery5 = '''
    SELECT pName, sName, MAX(price)
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
    GROUP BY pName
'''
pd.read_sql_query(testquery5, conn)
#[Out]#                pName        sName  MAX(price)
#[Out]# 0             Apples    Hoogvliet        4.70
#[Out]# 1            Bananas        Jumbo        3.15
#[Out]# 2               Beef       Sligro       13.80
#[Out]# 3              Bread        Jumbo        3.80
#[Out]# 4            Carrots  Albert Hein        2.95
#[Out]# 5        Cashew Nuts         Coop        5.40
#[Out]# 6             Cheese  Albert Hein       12.00
#[Out]# 7               Coca         Dirk        4.25
#[Out]# 8             Coffee  Albert Hein        4.25
#[Out]# 9          Cucumbers         Coop        3.80
#[Out]# 10            Donuts        Jumbo        4.70
#[Out]# 11              Eggs    Hoogvliet        4.20
#[Out]# 12             Fanta    Hoogvliet        4.30
#[Out]# 13      Green Pepper         Dirk        2.75
#[Out]# 14  Hot Dog Sausages  Albert Hein        5.70
#[Out]# 15           Ketchup        Jumbo        1.00
#[Out]# 16           Lasanga  Albert Hein        9.85
#[Out]# 17              Milk         Coop        3.55
#[Out]# 18        Mixed Nuts         Coop        6.55
#[Out]# 19         Mushrooms         Lidl        4.35
#[Out]# 20            Onions         Lidl        2.40
#[Out]# 21           Oranges         Coop        4.20
#[Out]# 22             Pasta         Lidl        3.55
#[Out]# 23             Pizza    Hoogvliet        9.25
#[Out]# 24          Potatoes         Coop        2.30
#[Out]# 25              Rice        Jumbo        2.10
#[Out]# 26            Salmon        Jumbo        1.00
#[Out]# 27   Spiced Biscuits         Coop        3.75
#[Out]# 28               Tea       Sligro        3.20
#[Out]# 29          Tomatoes        Jumbo        2.35
#[Out]# 30             Water         Dirk        4.35
testquery5 = '''
    SELECT pName, sName, MAX(price)
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
'''
pd.read_sql_query(testquery5, conn)
#[Out]#   pName   sName  MAX(price)
#[Out]# 0  Beef  Sligro        13.8
testquery5 = '''
    SELECT pName, sName
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
'''
pd.read_sql_query(testquery5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 479           Lasanga         Coop
#[Out]# 480             Pizza         Lidl
#[Out]# 481         Mushrooms         Lidl
#[Out]# 482           Lasanga        Jumbo
#[Out]# 483          Tomatoes    Hoogvliet
#[Out]# 484       Cashew Nuts       Sligro
#[Out]# 485              Milk    Hoogvliet
#[Out]# 486           Carrots  Albert Hein
#[Out]# 487              Coca       Sligro
#[Out]# 488             Bread         Coop
#[Out]# 489           Bananas  Albert Hein
#[Out]# 490              Milk         Coop
#[Out]# 491               Tea         Lidl
#[Out]# 492             Bread         Coop
#[Out]# 493             Fanta    Hoogvliet
#[Out]# 494              Milk    Hoogvliet
#[Out]# 495            Coffee       Sligro
#[Out]# 496   Spiced Biscuits         Coop
#[Out]# 497   Spiced Biscuits         Lidl
#[Out]# 498  Hot Dog Sausages         Coop
#[Out]# 499       Cashew Nuts         Dirk
#[Out]# 500  Hot Dog Sausages         Coop
#[Out]# 501              Milk        Jumbo
#[Out]# 502         Cucumbers         Dirk
#[Out]# 503          Potatoes         Dirk
#[Out]# 504             Bread        Jumbo
#[Out]# 505         Mushrooms         Lidl
#[Out]# 506              Coca         Lidl
#[Out]# 507           Bananas        Jumbo
#[Out]# 508            Cheese        Jumbo
#[Out]# 
#[Out]# [509 rows x 2 columns]
testquery5 = '''
    SELECT pName, sName
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.pID IN (
        SELECT purchase.pID, MAX(price)
        FROM purchase
    )
'''
pd.read_sql_query(testquery5, conn)
testquery5 = '''
    SELECT pName, sName
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.pID IN (
        SELECT MAX(price), pID
        FROM purchase
    )
'''
pd.read_sql_query(testquery5, conn)
testquery5 = '''
    SELECT pName, sName
    FROM purchase, product, store
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.pID IN (
        SELECT MAX(price), pID
        FROM purchase
    )
'''
pd.read_sql_query(testquery5, conn)
testquery5 = '''
    WITH maxPrice AS (
        SELECT MAX(price), pID
        FROM purchase
    )
    
    maxPrice
    )
'''
pd.read_sql_query(testquery5, conn)
testquery5 = '''
    WITH maxPrice AS (
        SELECT MAX(price), pID
        FROM purchase
    )
    SELECT *
    FROM maxPrice
    )
'''
pd.read_sql_query(testquery5, conn)
testquery5 = '''
    WITH maxPrice AS (
        SELECT MAX(price), pID
        FROM purchase
    )
    SELECT *
    FROM maxPrice
    
'''
pd.read_sql_query(testquery5, conn)
#[Out]#    MAX(price)  pID
#[Out]# 0        13.8   12
testquery5 = '''
    WITH maxPrice AS (
        SELECT MAX(price), pID, sID
        FROM purchase
    )
    SELECT pName, sName
    FROM product, store, maxPrice
    WHERE product.pID = maxPrice.pID AND store.sID = maxPrice. sID
    
'''
pd.read_sql_query(testquery5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
testquery6 = '''
    SELECT MAX(unit_price), MIN(unit_price)
    FROM inventory
    WHERE date = '2018-08-23'
'''
pd.read_sql_query(testquery6, conn)
#[Out]#    MAX(unit_price)  MIN(unit_price)
#[Out]# 0             13.4             0.45
testquery6 = '''
    SELECT MAX(unit_price) AS max, MIN(unit_price) AS min, diff AS max-min
    FROM inventory
    WHERE date = '2018-08-23'
'''
pd.read_sql_query(testquery6, conn)
testquery6 = '''
    SELECT MAX(unit_price) AS max, MIN(unit_price) AS min
    FROM inventory
    WHERE date = '2018-08-23'
'''
pd.read_sql_query(testquery6, conn)
#[Out]#     max   min
#[Out]# 0  13.4  0.45
testquery6 = '''
    SELECT pID, MAX(unit_price) AS max, MIN(unit_price) AS min
    FROM inventory
    WHERE date = '2018-08-23'
'''
pd.read_sql_query(testquery6, conn)
#[Out]#    pID   max   min
#[Out]# 0   10  13.4  0.45
testquery6 = '''
    SELECT pID, MAX(unit_price) AS max, MIN(unit_price) AS min, diff AS (max - min)
    FROM inventory
    WHERE date = '2018-08-23'
'''
pd.read_sql_query(testquery6, conn)
testquery6 = '''
    SELECT pID, MAX(unit_price) AS max, MIN(unit_price) AS min, (max-min)
    FROM inventory
    WHERE date = '2018-08-23'
'''
pd.read_sql_query(testquery6, conn)
testquery6 = '''
    SELECT (MAX(unit_price) - MIN(unit_price))
    FROM inventory
    WHERE date = '2018-08-23'
'''
pd.read_sql_query(testquery6, conn)
#[Out]#    (MAX(unit_price) - MIN(unit_price))
#[Out]# 0                                12.95
testquery6 = '''
    SELECT (i1.MAX(unit_price) - i2.MIN(unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = '2018-08-23' AND i1.date = i2.date AND i1.sID <> i2.sID
'''
pd.read_sql_query(testquery6, conn)
testquery6 = '''
    SELECT (MAX(i1.unit_price) - MIN(i2.unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = '2018-08-23' AND i1.date = i2.date AND i1.sID <> i2.sID
'''
pd.read_sql_query(testquery6, conn)
#[Out]#    (MAX(i1.unit_price) - MIN(i2.unit_price))
#[Out]# 0                                      12.95
testquery6 = '''
    SELECT (MAX(i1.unit_price) - MIN(i2.unit_price)), i1.pID
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = '2018-08-23' AND i1.date = i2.date AND i1.sID <> i2.sID
'''
pd.read_sql_query(testquery6, conn)
#[Out]#    (MAX(i1.unit_price) - MIN(i2.unit_price))  pID
#[Out]# 0                                      12.95   10
testquery6 = '''
    SELECT (MAX(i1.unit_price) - MIN(i2.unit_price))
    FROM inventory AS i1, inventory AS i2
    WHERE i1.date = '2018-08-23' AND i1.date = i2.date AND i1.sID <> i2.sID
'''
pd.read_sql_query(testquery6, conn)
#[Out]#    (MAX(i1.unit_price) - MIN(i2.unit_price))
#[Out]# 0                                      12.95
testquery3 = '''
    SELECT sID, cID
    FROM purchase
    GROUP BY sID, cID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      sID  cID
#[Out]# 0      0   11
#[Out]# 1      0   24
#[Out]# 2      0   91
#[Out]# 3      0  108
#[Out]# 4      0  123
#[Out]# 5      0  162
#[Out]# 6      0  172
#[Out]# 7      0  184
#[Out]# 8      0  190
#[Out]# 9      1   21
#[Out]# 10     1   70
#[Out]# 11     1   77
#[Out]# 12     1  113
#[Out]# 13     1  124
#[Out]# 14     1  161
#[Out]# 15     1  169
#[Out]# 16     1  190
#[Out]# 17     2   18
#[Out]# 18     2   19
#[Out]# 19     2   21
#[Out]# 20     2   52
#[Out]# 21     2  104
#[Out]# 22     2  190
#[Out]# 23     3    0
#[Out]# 24     3    1
#[Out]# 25     3    7
#[Out]# 26     3   19
#[Out]# 27     3   41
#[Out]# 28     3   52
#[Out]# 29     3   92
#[Out]# ..   ...  ...
#[Out]# 460   56  122
#[Out]# 461   56  126
#[Out]# 462   56  165
#[Out]# 463   56  167
#[Out]# 464   56  171
#[Out]# 465   56  180
#[Out]# 466   56  190
#[Out]# 467   57   30
#[Out]# 468   57   33
#[Out]# 469   57  162
#[Out]# 470   57  167
#[Out]# 471   57  179
#[Out]# 472   57  190
#[Out]# 473   58   59
#[Out]# 474   58  145
#[Out]# 475   58  190
#[Out]# 476   59   19
#[Out]# 477   59   24
#[Out]# 478   59   27
#[Out]# 479   59   59
#[Out]# 480   59  172
#[Out]# 481   59  190
#[Out]# 482   60  190
#[Out]# 483   61  190
#[Out]# 484   62  185
#[Out]# 485   62  186
#[Out]# 486   62  188
#[Out]# 487   62  190
#[Out]# 488   63  189
#[Out]# 489   63  190
#[Out]# 
#[Out]# [490 rows x 2 columns]
testquery3 = '''
    SELECT sID, cID
    FROM purchase
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      sID  cID
#[Out]# 0      3    0
#[Out]# 1     23    1
#[Out]# 2      3    1
#[Out]# 3     17    1
#[Out]# 4     32    1
#[Out]# 5     16    1
#[Out]# 6     46    1
#[Out]# 7     36    1
#[Out]# 8     12    2
#[Out]# 9     39    2
#[Out]# 10    13    2
#[Out]# 11    51    2
#[Out]# 12    47    2
#[Out]# 13    44    3
#[Out]# 14    30    3
#[Out]# 15    29    3
#[Out]# 16    17    4
#[Out]# 17    10    4
#[Out]# 18    53    4
#[Out]# 19    21    4
#[Out]# 20     7    4
#[Out]# 21    44    4
#[Out]# 22     4    5
#[Out]# 23    36    5
#[Out]# 24    55    5
#[Out]# 25    51    5
#[Out]# 26     6    5
#[Out]# 27    17    5
#[Out]# 28     3    7
#[Out]# 29    12    7
#[Out]# ..   ...  ...
#[Out]# 479   34  190
#[Out]# 480   35  190
#[Out]# 481   36  190
#[Out]# 482   37  190
#[Out]# 483   38  190
#[Out]# 484   39  190
#[Out]# 485   40  190
#[Out]# 486   41  190
#[Out]# 487   42  190
#[Out]# 488   43  190
#[Out]# 489   44  190
#[Out]# 490   45  190
#[Out]# 491   46  190
#[Out]# 492   47  190
#[Out]# 493   48  190
#[Out]# 494   49  190
#[Out]# 495   50  190
#[Out]# 496   51  190
#[Out]# 497   52  190
#[Out]# 498   53  190
#[Out]# 499   54  190
#[Out]# 500   55  190
#[Out]# 501   56  190
#[Out]# 502   57  190
#[Out]# 503   58  190
#[Out]# 504   59  190
#[Out]# 505   60  190
#[Out]# 506   61  190
#[Out]# 507   62  190
#[Out]# 508   63  190
#[Out]# 
#[Out]# [509 rows x 2 columns]
testquery3 = '''
    SELECT sID, cID
    FROM purchase
    GROUP BY sID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#     sID  cID
#[Out]# 0     0  190
#[Out]# 1     1  190
#[Out]# 2     2  190
#[Out]# 3     3  190
#[Out]# 4     4  190
#[Out]# 5     5  190
#[Out]# 6     6  190
#[Out]# 7     7  190
#[Out]# 8     8  190
#[Out]# 9     9  190
#[Out]# 10   10  190
#[Out]# 11   11  190
#[Out]# 12   12  190
#[Out]# 13   13  190
#[Out]# 14   14  190
#[Out]# 15   15  190
#[Out]# 16   16  190
#[Out]# 17   17  190
#[Out]# 18   18  190
#[Out]# 19   19  190
#[Out]# 20   20  190
#[Out]# 21   21  190
#[Out]# 22   22  190
#[Out]# 23   23  190
#[Out]# 24   24  190
#[Out]# 25   25  190
#[Out]# 26   26  190
#[Out]# 27   27  190
#[Out]# 28   28  190
#[Out]# 29   29  190
#[Out]# ..  ...  ...
#[Out]# 34   34  190
#[Out]# 35   35  190
#[Out]# 36   36  190
#[Out]# 37   37  190
#[Out]# 38   38  190
#[Out]# 39   39  190
#[Out]# 40   40  190
#[Out]# 41   41  190
#[Out]# 42   42  190
#[Out]# 43   43  190
#[Out]# 44   44  190
#[Out]# 45   45  190
#[Out]# 46   46  190
#[Out]# 47   47  190
#[Out]# 48   48  190
#[Out]# 49   49  190
#[Out]# 50   50  190
#[Out]# 51   51  190
#[Out]# 52   52  190
#[Out]# 53   53  190
#[Out]# 54   54  190
#[Out]# 55   55  190
#[Out]# 56   56  190
#[Out]# 57   57  190
#[Out]# 58   58  190
#[Out]# 59   59  190
#[Out]# 60   60  190
#[Out]# 61   61  190
#[Out]# 62   62  190
#[Out]# 63   63  190
#[Out]# 
#[Out]# [64 rows x 2 columns]
testquery3 = '''
    SELECT sID, cID
    FROM purchase
    GROUP BY sID, cID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      sID  cID
#[Out]# 0      0   11
#[Out]# 1      0   24
#[Out]# 2      0   91
#[Out]# 3      0  108
#[Out]# 4      0  123
#[Out]# 5      0  162
#[Out]# 6      0  172
#[Out]# 7      0  184
#[Out]# 8      0  190
#[Out]# 9      1   21
#[Out]# 10     1   70
#[Out]# 11     1   77
#[Out]# 12     1  113
#[Out]# 13     1  124
#[Out]# 14     1  161
#[Out]# 15     1  169
#[Out]# 16     1  190
#[Out]# 17     2   18
#[Out]# 18     2   19
#[Out]# 19     2   21
#[Out]# 20     2   52
#[Out]# 21     2  104
#[Out]# 22     2  190
#[Out]# 23     3    0
#[Out]# 24     3    1
#[Out]# 25     3    7
#[Out]# 26     3   19
#[Out]# 27     3   41
#[Out]# 28     3   52
#[Out]# 29     3   92
#[Out]# ..   ...  ...
#[Out]# 460   56  122
#[Out]# 461   56  126
#[Out]# 462   56  165
#[Out]# 463   56  167
#[Out]# 464   56  171
#[Out]# 465   56  180
#[Out]# 466   56  190
#[Out]# 467   57   30
#[Out]# 468   57   33
#[Out]# 469   57  162
#[Out]# 470   57  167
#[Out]# 471   57  179
#[Out]# 472   57  190
#[Out]# 473   58   59
#[Out]# 474   58  145
#[Out]# 475   58  190
#[Out]# 476   59   19
#[Out]# 477   59   24
#[Out]# 478   59   27
#[Out]# 479   59   59
#[Out]# 480   59  172
#[Out]# 481   59  190
#[Out]# 482   60  190
#[Out]# 483   61  190
#[Out]# 484   62  185
#[Out]# 485   62  186
#[Out]# 486   62  188
#[Out]# 487   62  190
#[Out]# 488   63  189
#[Out]# 489   63  190
#[Out]# 
#[Out]# [490 rows x 2 columns]
testquery3 = '''
    SELECT sID, cID
    FROM purchase
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      sID  cID
#[Out]# 0      3    0
#[Out]# 1     23    1
#[Out]# 2      3    1
#[Out]# 3     17    1
#[Out]# 4     32    1
#[Out]# 5     16    1
#[Out]# 6     46    1
#[Out]# 7     36    1
#[Out]# 8     12    2
#[Out]# 9     39    2
#[Out]# 10    13    2
#[Out]# 11    51    2
#[Out]# 12    47    2
#[Out]# 13    44    3
#[Out]# 14    30    3
#[Out]# 15    29    3
#[Out]# 16    17    4
#[Out]# 17    10    4
#[Out]# 18    53    4
#[Out]# 19    21    4
#[Out]# 20     7    4
#[Out]# 21    44    4
#[Out]# 22     4    5
#[Out]# 23    36    5
#[Out]# 24    55    5
#[Out]# 25    51    5
#[Out]# 26     6    5
#[Out]# 27    17    5
#[Out]# 28     3    7
#[Out]# 29    12    7
#[Out]# ..   ...  ...
#[Out]# 479   34  190
#[Out]# 480   35  190
#[Out]# 481   36  190
#[Out]# 482   37  190
#[Out]# 483   38  190
#[Out]# 484   39  190
#[Out]# 485   40  190
#[Out]# 486   41  190
#[Out]# 487   42  190
#[Out]# 488   43  190
#[Out]# 489   44  190
#[Out]# 490   45  190
#[Out]# 491   46  190
#[Out]# 492   47  190
#[Out]# 493   48  190
#[Out]# 494   49  190
#[Out]# 495   50  190
#[Out]# 496   51  190
#[Out]# 497   52  190
#[Out]# 498   53  190
#[Out]# 499   54  190
#[Out]# 500   55  190
#[Out]# 501   56  190
#[Out]# 502   57  190
#[Out]# 503   58  190
#[Out]# 504   59  190
#[Out]# 505   60  190
#[Out]# 506   61  190
#[Out]# 507   62  190
#[Out]# 508   63  190
#[Out]# 
#[Out]# [509 rows x 2 columns]
testquery3 = '''
    SELECT sID, cID
    FROM purchase
    ORDER BY sID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      sID  cID
#[Out]# 0      0   11
#[Out]# 1      0   24
#[Out]# 2      0   91
#[Out]# 3      0  108
#[Out]# 4      0  123
#[Out]# 5      0  162
#[Out]# 6      0  172
#[Out]# 7      0  184
#[Out]# 8      0  190
#[Out]# 9      1   21
#[Out]# 10     1   70
#[Out]# 11     1   77
#[Out]# 12     1  113
#[Out]# 13     1  124
#[Out]# 14     1  161
#[Out]# 15     1  169
#[Out]# 16     1  190
#[Out]# 17     2   18
#[Out]# 18     2   19
#[Out]# 19     2   21
#[Out]# 20     2   52
#[Out]# 21     2  104
#[Out]# 22     2  190
#[Out]# 23     3    0
#[Out]# 24     3    1
#[Out]# 25     3    7
#[Out]# 26     3   19
#[Out]# 27     3   41
#[Out]# 28     3   52
#[Out]# 29     3   92
#[Out]# ..   ...  ...
#[Out]# 479   56  126
#[Out]# 480   56  165
#[Out]# 481   56  167
#[Out]# 482   56  171
#[Out]# 483   56  180
#[Out]# 484   56  190
#[Out]# 485   57   30
#[Out]# 486   57   33
#[Out]# 487   57  162
#[Out]# 488   57  167
#[Out]# 489   57  179
#[Out]# 490   57  190
#[Out]# 491   58   59
#[Out]# 492   58  145
#[Out]# 493   58  190
#[Out]# 494   59   19
#[Out]# 495   59   24
#[Out]# 496   59   27
#[Out]# 497   59   59
#[Out]# 498   59  172
#[Out]# 499   59  190
#[Out]# 500   60  190
#[Out]# 501   61  190
#[Out]# 502   62  185
#[Out]# 503   62  186
#[Out]# 504   62  188
#[Out]# 505   62  188
#[Out]# 506   62  190
#[Out]# 507   63  189
#[Out]# 508   63  190
#[Out]# 
#[Out]# [509 rows x 2 columns]
testquery3 = '''
    SELECT sID, cID
    FROM purchase
    ORDER BY sID desc
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      sID  cID
#[Out]# 0     63  189
#[Out]# 1     63  190
#[Out]# 2     62  185
#[Out]# 3     62  186
#[Out]# 4     62  188
#[Out]# 5     62  188
#[Out]# 6     62  190
#[Out]# 7     61  190
#[Out]# 8     60  190
#[Out]# 9     59   19
#[Out]# 10    59   24
#[Out]# 11    59   27
#[Out]# 12    59   59
#[Out]# 13    59  172
#[Out]# 14    59  190
#[Out]# 15    58   59
#[Out]# 16    58  145
#[Out]# 17    58  190
#[Out]# 18    57   30
#[Out]# 19    57   33
#[Out]# 20    57  162
#[Out]# 21    57  167
#[Out]# 22    57  179
#[Out]# 23    57  190
#[Out]# 24    56   40
#[Out]# 25    56   78
#[Out]# 26    56  109
#[Out]# 27    56  122
#[Out]# 28    56  126
#[Out]# 29    56  165
#[Out]# ..   ...  ...
#[Out]# 479    3   92
#[Out]# 480    3   95
#[Out]# 481    3  108
#[Out]# 482    3  127
#[Out]# 483    3  161
#[Out]# 484    3  167
#[Out]# 485    3  190
#[Out]# 486    2   18
#[Out]# 487    2   19
#[Out]# 488    2   21
#[Out]# 489    2   52
#[Out]# 490    2  104
#[Out]# 491    2  190
#[Out]# 492    1   21
#[Out]# 493    1   70
#[Out]# 494    1   77
#[Out]# 495    1  113
#[Out]# 496    1  124
#[Out]# 497    1  161
#[Out]# 498    1  169
#[Out]# 499    1  190
#[Out]# 500    0   11
#[Out]# 501    0   24
#[Out]# 502    0   91
#[Out]# 503    0  108
#[Out]# 504    0  123
#[Out]# 505    0  162
#[Out]# 506    0  172
#[Out]# 507    0  184
#[Out]# 508    0  190
#[Out]# 
#[Out]# [509 rows x 2 columns]
testquery3 = '''
    SELECT sID, cID
    FROM purchase
    ORDER BY sID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      sID  cID
#[Out]# 0      0   11
#[Out]# 1      0   24
#[Out]# 2      0   91
#[Out]# 3      0  108
#[Out]# 4      0  123
#[Out]# 5      0  162
#[Out]# 6      0  172
#[Out]# 7      0  184
#[Out]# 8      0  190
#[Out]# 9      1   21
#[Out]# 10     1   70
#[Out]# 11     1   77
#[Out]# 12     1  113
#[Out]# 13     1  124
#[Out]# 14     1  161
#[Out]# 15     1  169
#[Out]# 16     1  190
#[Out]# 17     2   18
#[Out]# 18     2   19
#[Out]# 19     2   21
#[Out]# 20     2   52
#[Out]# 21     2  104
#[Out]# 22     2  190
#[Out]# 23     3    0
#[Out]# 24     3    1
#[Out]# 25     3    7
#[Out]# 26     3   19
#[Out]# 27     3   41
#[Out]# 28     3   52
#[Out]# 29     3   92
#[Out]# ..   ...  ...
#[Out]# 479   56  126
#[Out]# 480   56  165
#[Out]# 481   56  167
#[Out]# 482   56  171
#[Out]# 483   56  180
#[Out]# 484   56  190
#[Out]# 485   57   30
#[Out]# 486   57   33
#[Out]# 487   57  162
#[Out]# 488   57  167
#[Out]# 489   57  179
#[Out]# 490   57  190
#[Out]# 491   58   59
#[Out]# 492   58  145
#[Out]# 493   58  190
#[Out]# 494   59   19
#[Out]# 495   59   24
#[Out]# 496   59   27
#[Out]# 497   59   59
#[Out]# 498   59  172
#[Out]# 499   59  190
#[Out]# 500   60  190
#[Out]# 501   61  190
#[Out]# 502   62  185
#[Out]# 503   62  186
#[Out]# 504   62  188
#[Out]# 505   62  188
#[Out]# 506   62  190
#[Out]# 507   63  189
#[Out]# 508   63  190
#[Out]# 
#[Out]# [509 rows x 2 columns]
testquery3 = '''
    WITH buy AS (
        SELECT p1.sID, p2.cID
        FROM purchase AS p1, purchase AS p2
        ORDER BY p1.sID
        )
    SELECT 
    FROM buy, 
    WHERE
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    WITH buy AS (
        SELECT p1.sID, p2.cID
        FROM purchase AS p1, purchase AS p2
        ORDER BY p1.sID
        )
    SELECT *
    FROM buy
'''
pd.read_sql_query(testquery3, conn)
#[Out]#         sID  cID
#[Out]# 0         0    0
#[Out]# 1         0    1
#[Out]# 2         0    1
#[Out]# 3         0    1
#[Out]# 4         0    1
#[Out]# 5         0    1
#[Out]# 6         0    1
#[Out]# 7         0    1
#[Out]# 8         0    2
#[Out]# 9         0    2
#[Out]# 10        0    2
#[Out]# 11        0    2
#[Out]# 12        0    2
#[Out]# 13        0    3
#[Out]# 14        0    3
#[Out]# 15        0    3
#[Out]# 16        0    4
#[Out]# 17        0    4
#[Out]# 18        0    4
#[Out]# 19        0    4
#[Out]# 20        0    4
#[Out]# 21        0    4
#[Out]# 22        0    5
#[Out]# 23        0    5
#[Out]# 24        0    5
#[Out]# 25        0    5
#[Out]# 26        0    5
#[Out]# 27        0    5
#[Out]# 28        0    7
#[Out]# 29        0    7
#[Out]# ...     ...  ...
#[Out]# 259051   63  190
#[Out]# 259052   63  190
#[Out]# 259053   63  190
#[Out]# 259054   63  190
#[Out]# 259055   63  190
#[Out]# 259056   63  190
#[Out]# 259057   63  190
#[Out]# 259058   63  190
#[Out]# 259059   63  190
#[Out]# 259060   63  190
#[Out]# 259061   63  190
#[Out]# 259062   63  190
#[Out]# 259063   63  190
#[Out]# 259064   63  190
#[Out]# 259065   63  190
#[Out]# 259066   63  190
#[Out]# 259067   63  190
#[Out]# 259068   63  190
#[Out]# 259069   63  190
#[Out]# 259070   63  190
#[Out]# 259071   63  190
#[Out]# 259072   63  190
#[Out]# 259073   63  190
#[Out]# 259074   63  190
#[Out]# 259075   63  190
#[Out]# 259076   63  190
#[Out]# 259077   63  190
#[Out]# 259078   63  190
#[Out]# 259079   63  190
#[Out]# 259080   63  190
#[Out]# 
#[Out]# [259081 rows x 2 columns]
testquery3 = '''
    WITH total AS (
        SELECT p1.sID, p2.cID
        FROM purchase AS p1, purchase AS p2
        ORDER BY p1.sID
        )
        
        buy AS (
        SELECT sID, cID
        FROM purchase
        ORDER BY sID
        )
        
        not_buy AS (
        SELECT *
        FROM total
        WHERE cID NOT IN (
            SELECT *
            FROM buy
            WHERE buy.cID = total.cID AND buy.sID = total.sID
            )
        )
            
    SELECT *
    FROM not_buy
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    WITH total AS (
        SELECT p1.sID, p2.cID
        FROM purchase AS p1, purchase AS p2
        ORDER BY p1.sID
        )
        
        buy AS (
        SELECT sID, cID
        FROM purchase
        ORDER BY sID
        ),
        
        not_buy AS (
        SELECT *
        FROM total
        WHERE cID NOT IN (
            SELECT *
            FROM buy
            WHERE buy.cID = total.cID AND buy.sID = total.sID
            )
        )
            
    SELECT *
    FROM not_buy
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    WITH total AS (
        SELECT p1.sID, p2.cID
        FROM purchase AS p1, purchase AS p2
        ORDER BY p1.sID
        ),
        
        buy AS (
        SELECT sID, cID
        FROM purchase
        ORDER BY sID
        ),
        
        not_buy AS (
        SELECT *
        FROM total
        WHERE cID NOT IN (
            SELECT *
            FROM buy
            WHERE buy.cID = total.cID AND buy.sID = total.sID
            )
        )
            
    SELECT *
    FROM not_buy
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    WITH total AS (
        SELECT p1.sID, p2.cID
        FROM purchase AS p1, purchase AS p2
        ORDER BY p1.sID
        ),
        
        buy AS (
        SELECT sID, cID
        FROM purchase
        ORDER BY sID
        ),
        diff1 AS (
        SELECT *
        FROM buy
        WHERE buy.cID = total.cID AND buy.sID = total.sID
        ),
        
        not_buy AS (
        SELECT *
        FROM total
        WHERE cID NOT IN diff1
            )
        )
            
    SELECT *
    FROM not_buy
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    WITH total AS (
        SELECT p1.sID, p2.cID
        FROM purchase AS p1, purchase AS p2
        ORDER BY p1.sID
        ),
        
        buy AS (
        SELECT sID, cID
        FROM purchase
        ORDER BY sID
        ),
        diff1 AS (
        SELECT *
        FROM buy
        WHERE buy.cID = total.cID AND buy.sID = total.sID
        ),
        
        not_buy AS (
        SELECT *
        FROM total
        WHERE cID NOT IN diff1
            )
            
    SELECT *
    FROM not_buy
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    WITH total AS (
        SELECT p1.sID, p2.cID
        FROM purchase AS p1, purchase AS p2
        ORDER BY p1.sID
        ),
        
        buy AS (
        SELECT sID, cID
        FROM purchase
        ORDER BY sID
        ),
        
        diff1 AS (
        SELECT *
        FROM buy
        WHERE buy.cID = total.cID AND buy.sID = total.sID
        ),
        
        not_buy AS (
        SELECT *
        FROM total
        WHERE cID NOT IN diff1
            )

'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    SELECT cOUNT(*)
    FROM purchase

'''
pd.read_sql_query(testquery3, conn)
#[Out]#    cOUNT(*)
#[Out]# 0       509
testquery3 = '''
    SELECT cOUNT(sID)
    FROM purchase

'''
pd.read_sql_query(testquery3, conn)
#[Out]#    cOUNT(sID)
#[Out]# 0         509
testquery3 = '''
    SELECT cOUNT DISTINCT(sID)
    FROM purchase

'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    SELECT cOUNT (DISTINCT(sID))
    FROM purchase

'''
pd.read_sql_query(testquery3, conn)
#[Out]#    cOUNT (DISTINCT(sID))
#[Out]# 0                     64
testquery3 = '''
    SELECT COUNT(DISTINCT(sID))
    FROM purchase

'''
pd.read_sql_query(testquery3, conn)
#[Out]#    COUNT(DISTINCT(sID))
#[Out]# 0                    64
testquery3 = '''
    SELECT COUNT(DISTINCT(cID))
    FROM purchase

'''
pd.read_sql_query(testquery3, conn)
#[Out]#    COUNT(DISTINCT(cID))
#[Out]# 0                   132
testquery3 = '''
    SELECT COUNT(DISTINCT(cID))
    FROM purchase

'''
pd.read_sql_query(testquery3, conn)
#[Out]#    COUNT(DISTINCT(cID))
#[Out]# 0                   132
testquery3 = '''
    SELECT COUNT(DISTINCT(cID))
    FROM purchase

'''
pd.read_sql_query(testquery3, conn)
#[Out]#    COUNT(DISTINCT(cID))
#[Out]# 0                   132
testquery3 = '''
    SELECT DISTINCT(cID)
    FROM purchase

'''
pd.read_sql_query(testquery3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
testquery3 = '''
    SELECT DISTINCT(sID)
    FROM purchase

'''
pd.read_sql_query(testquery3, conn)
#[Out]#     sID
#[Out]# 0     3
#[Out]# 1    23
#[Out]# 2    17
#[Out]# 3    32
#[Out]# 4    16
#[Out]# 5    46
#[Out]# 6    36
#[Out]# 7    12
#[Out]# 8    39
#[Out]# 9    13
#[Out]# 10   51
#[Out]# 11   47
#[Out]# 12   44
#[Out]# 13   30
#[Out]# 14   29
#[Out]# 15   10
#[Out]# 16   53
#[Out]# 17   21
#[Out]# 18    7
#[Out]# 19    4
#[Out]# 20   55
#[Out]# 21    6
#[Out]# 22   11
#[Out]# 23   38
#[Out]# 24   42
#[Out]# 25   43
#[Out]# 26   34
#[Out]# 27    0
#[Out]# 28   33
#[Out]# 29   50
#[Out]# ..  ...
#[Out]# 34   14
#[Out]# 35   22
#[Out]# 36   31
#[Out]# 37   27
#[Out]# 38    2
#[Out]# 39   59
#[Out]# 40   15
#[Out]# 41   40
#[Out]# 42    1
#[Out]# 43   45
#[Out]# 44   49
#[Out]# 45    9
#[Out]# 46   57
#[Out]# 47   54
#[Out]# 48   37
#[Out]# 49   52
#[Out]# 50   56
#[Out]# 51    5
#[Out]# 52   20
#[Out]# 53   18
#[Out]# 54   19
#[Out]# 55   58
#[Out]# 56   35
#[Out]# 57   41
#[Out]# 58   24
#[Out]# 59   48
#[Out]# 60   62
#[Out]# 61   63
#[Out]# 62   60
#[Out]# 63   61
#[Out]# 
#[Out]# [64 rows x 1 columns]
testquery2 = '''
    SELECT customer.cID, cName
    FROM customer
    WHERE cID IN (
    
        SELECT p1.cID
        FROM purchase AS p1, purchase AS p2
        WHERE p1.cID = p2.cID AND p1.date = p2.date AND p1.cID IN (
        
            SELECT purchase.cID
            FROM purchase, product
            WHERE purchase.pID = product.pID AND product.pName = "Onions"
            
            ) AND p1.cID IN (
            
            SELECT purchase.cID
            FROM purchase, product
            WHERE purchase.pID = product.pID AND product.pName = "Coffee"
            
            )
            
        )
'''
pd.read_sql_query(testquery2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
testquery2 = '''
    SELECT customer.cID, cName
    FROM customer
    WHERE cID IN (
    
        SELECT p1.cID
        FROM purchase AS p1, purchase AS p2
        WHERE p1.cID = p2.cID AND p1.date = p2.date AND p1.cID IN (
        
            SELECT purchase.cID
            FROM purchase, product
            WHERE purchase.pID = product.pID AND product.pName = "Onions"
            
            ) AND p1.cID IN (
            
            SELECT purchase.cID
            FROM purchase, product
            WHERE purchase.pID = product.pID AND product.pName = "Coffee"
            
            )
            
        )
'''
pd.read_sql_query(testquery2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
testquery3 = '''
    WITH total AS (
    SELECT p1.sID, p1.cID
    FROM purchase AS p1, purchase AS p2)

    SELECT *
    FROM total
    
'''
pd.read_sql_query(testquery3, conn)
#[Out]#         sID  cID
#[Out]# 0         3    0
#[Out]# 1         3    0
#[Out]# 2         3    0
#[Out]# 3         3    0
#[Out]# 4         3    0
#[Out]# 5         3    0
#[Out]# 6         3    0
#[Out]# 7         3    0
#[Out]# 8         3    0
#[Out]# 9         3    0
#[Out]# 10        3    0
#[Out]# 11        3    0
#[Out]# 12        3    0
#[Out]# 13        3    0
#[Out]# 14        3    0
#[Out]# 15        3    0
#[Out]# 16        3    0
#[Out]# 17        3    0
#[Out]# 18        3    0
#[Out]# 19        3    0
#[Out]# 20        3    0
#[Out]# 21        3    0
#[Out]# 22        3    0
#[Out]# 23        3    0
#[Out]# 24        3    0
#[Out]# 25        3    0
#[Out]# 26        3    0
#[Out]# 27        3    0
#[Out]# 28        3    0
#[Out]# 29        3    0
#[Out]# ...     ...  ...
#[Out]# 259051   63  190
#[Out]# 259052   63  190
#[Out]# 259053   63  190
#[Out]# 259054   63  190
#[Out]# 259055   63  190
#[Out]# 259056   63  190
#[Out]# 259057   63  190
#[Out]# 259058   63  190
#[Out]# 259059   63  190
#[Out]# 259060   63  190
#[Out]# 259061   63  190
#[Out]# 259062   63  190
#[Out]# 259063   63  190
#[Out]# 259064   63  190
#[Out]# 259065   63  190
#[Out]# 259066   63  190
#[Out]# 259067   63  190
#[Out]# 259068   63  190
#[Out]# 259069   63  190
#[Out]# 259070   63  190
#[Out]# 259071   63  190
#[Out]# 259072   63  190
#[Out]# 259073   63  190
#[Out]# 259074   63  190
#[Out]# 259075   63  190
#[Out]# 259076   63  190
#[Out]# 259077   63  190
#[Out]# 259078   63  190
#[Out]# 259079   63  190
#[Out]# 259080   63  190
#[Out]# 
#[Out]# [259081 rows x 2 columns]
testquery3 = '''
    WITH total AS (
    SELECT p1.sID, p1.cID
    FROM purchase AS p1, purchase AS p2
    ORDER BY sID)

    SELECT *
    FROM total
    
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    WITH total AS (
    SELECT p1.sID, p1.cID
    FROM purchase AS p1, purchase AS p2
    ORDER BY p1.sID)

    SELECT *
    FROM total
    
'''
pd.read_sql_query(testquery3, conn)
#[Out]#         sID  cID
#[Out]# 0         0   11
#[Out]# 1         0   11
#[Out]# 2         0   11
#[Out]# 3         0   11
#[Out]# 4         0   11
#[Out]# 5         0   11
#[Out]# 6         0   11
#[Out]# 7         0   11
#[Out]# 8         0   11
#[Out]# 9         0   11
#[Out]# 10        0   11
#[Out]# 11        0   11
#[Out]# 12        0   11
#[Out]# 13        0   11
#[Out]# 14        0   11
#[Out]# 15        0   11
#[Out]# 16        0   11
#[Out]# 17        0   11
#[Out]# 18        0   11
#[Out]# 19        0   11
#[Out]# 20        0   11
#[Out]# 21        0   11
#[Out]# 22        0   11
#[Out]# 23        0   11
#[Out]# 24        0   11
#[Out]# 25        0   11
#[Out]# 26        0   11
#[Out]# 27        0   11
#[Out]# 28        0   11
#[Out]# 29        0   11
#[Out]# ...     ...  ...
#[Out]# 259051   63  190
#[Out]# 259052   63  190
#[Out]# 259053   63  190
#[Out]# 259054   63  190
#[Out]# 259055   63  190
#[Out]# 259056   63  190
#[Out]# 259057   63  190
#[Out]# 259058   63  190
#[Out]# 259059   63  190
#[Out]# 259060   63  190
#[Out]# 259061   63  190
#[Out]# 259062   63  190
#[Out]# 259063   63  190
#[Out]# 259064   63  190
#[Out]# 259065   63  190
#[Out]# 259066   63  190
#[Out]# 259067   63  190
#[Out]# 259068   63  190
#[Out]# 259069   63  190
#[Out]# 259070   63  190
#[Out]# 259071   63  190
#[Out]# 259072   63  190
#[Out]# 259073   63  190
#[Out]# 259074   63  190
#[Out]# 259075   63  190
#[Out]# 259076   63  190
#[Out]# 259077   63  190
#[Out]# 259078   63  190
#[Out]# 259079   63  190
#[Out]# 259080   63  190
#[Out]# 
#[Out]# [259081 rows x 2 columns]
testquery3 = '''
    WITH total AS (
    SELECT p1.sID, p1.cID
    FROM purchase AS p1, purchase AS p2
    ORDER BY p1.sID, p1.cID)

    SELECT *
    FROM total
    
'''
pd.read_sql_query(testquery3, conn)
#[Out]#         sID  cID
#[Out]# 0         0   11
#[Out]# 1         0   11
#[Out]# 2         0   11
#[Out]# 3         0   11
#[Out]# 4         0   11
#[Out]# 5         0   11
#[Out]# 6         0   11
#[Out]# 7         0   11
#[Out]# 8         0   11
#[Out]# 9         0   11
#[Out]# 10        0   11
#[Out]# 11        0   11
#[Out]# 12        0   11
#[Out]# 13        0   11
#[Out]# 14        0   11
#[Out]# 15        0   11
#[Out]# 16        0   11
#[Out]# 17        0   11
#[Out]# 18        0   11
#[Out]# 19        0   11
#[Out]# 20        0   11
#[Out]# 21        0   11
#[Out]# 22        0   11
#[Out]# 23        0   11
#[Out]# 24        0   11
#[Out]# 25        0   11
#[Out]# 26        0   11
#[Out]# 27        0   11
#[Out]# 28        0   11
#[Out]# 29        0   11
#[Out]# ...     ...  ...
#[Out]# 259051   63  190
#[Out]# 259052   63  190
#[Out]# 259053   63  190
#[Out]# 259054   63  190
#[Out]# 259055   63  190
#[Out]# 259056   63  190
#[Out]# 259057   63  190
#[Out]# 259058   63  190
#[Out]# 259059   63  190
#[Out]# 259060   63  190
#[Out]# 259061   63  190
#[Out]# 259062   63  190
#[Out]# 259063   63  190
#[Out]# 259064   63  190
#[Out]# 259065   63  190
#[Out]# 259066   63  190
#[Out]# 259067   63  190
#[Out]# 259068   63  190
#[Out]# 259069   63  190
#[Out]# 259070   63  190
#[Out]# 259071   63  190
#[Out]# 259072   63  190
#[Out]# 259073   63  190
#[Out]# 259074   63  190
#[Out]# 259075   63  190
#[Out]# 259076   63  190
#[Out]# 259077   63  190
#[Out]# 259078   63  190
#[Out]# 259079   63  190
#[Out]# 259080   63  190
#[Out]# 
#[Out]# [259081 rows x 2 columns]
testquery3 = '''
    WITH total AS (
    SELECT p1.sID, p1.cID
    FROM purchase AS p1, purchase AS p2
    ORDER BY p1.sID desc, p1.cID asc)

    SELECT *
    FROM total
    
'''
pd.read_sql_query(testquery3, conn)
#[Out]#         sID  cID
#[Out]# 0        63  189
#[Out]# 1        63  189
#[Out]# 2        63  189
#[Out]# 3        63  189
#[Out]# 4        63  189
#[Out]# 5        63  189
#[Out]# 6        63  189
#[Out]# 7        63  189
#[Out]# 8        63  189
#[Out]# 9        63  189
#[Out]# 10       63  189
#[Out]# 11       63  189
#[Out]# 12       63  189
#[Out]# 13       63  189
#[Out]# 14       63  189
#[Out]# 15       63  189
#[Out]# 16       63  189
#[Out]# 17       63  189
#[Out]# 18       63  189
#[Out]# 19       63  189
#[Out]# 20       63  189
#[Out]# 21       63  189
#[Out]# 22       63  189
#[Out]# 23       63  189
#[Out]# 24       63  189
#[Out]# 25       63  189
#[Out]# 26       63  189
#[Out]# 27       63  189
#[Out]# 28       63  189
#[Out]# 29       63  189
#[Out]# ...     ...  ...
#[Out]# 259051    0  190
#[Out]# 259052    0  190
#[Out]# 259053    0  190
#[Out]# 259054    0  190
#[Out]# 259055    0  190
#[Out]# 259056    0  190
#[Out]# 259057    0  190
#[Out]# 259058    0  190
#[Out]# 259059    0  190
#[Out]# 259060    0  190
#[Out]# 259061    0  190
#[Out]# 259062    0  190
#[Out]# 259063    0  190
#[Out]# 259064    0  190
#[Out]# 259065    0  190
#[Out]# 259066    0  190
#[Out]# 259067    0  190
#[Out]# 259068    0  190
#[Out]# 259069    0  190
#[Out]# 259070    0  190
#[Out]# 259071    0  190
#[Out]# 259072    0  190
#[Out]# 259073    0  190
#[Out]# 259074    0  190
#[Out]# 259075    0  190
#[Out]# 259076    0  190
#[Out]# 259077    0  190
#[Out]# 259078    0  190
#[Out]# 259079    0  190
#[Out]# 259080    0  190
#[Out]# 
#[Out]# [259081 rows x 2 columns]
testquery3 = '''
    WITH total AS (
    SELECT p1.sID, p1.cID
    FROM purchase AS p1, purchase AS p2
    ORDER BY p1.sID, p1.cID)

    SELECT *
    FROM total
    
'''
pd.read_sql_query(testquery3, conn)
#[Out]#         sID  cID
#[Out]# 0         0   11
#[Out]# 1         0   11
#[Out]# 2         0   11
#[Out]# 3         0   11
#[Out]# 4         0   11
#[Out]# 5         0   11
#[Out]# 6         0   11
#[Out]# 7         0   11
#[Out]# 8         0   11
#[Out]# 9         0   11
#[Out]# 10        0   11
#[Out]# 11        0   11
#[Out]# 12        0   11
#[Out]# 13        0   11
#[Out]# 14        0   11
#[Out]# 15        0   11
#[Out]# 16        0   11
#[Out]# 17        0   11
#[Out]# 18        0   11
#[Out]# 19        0   11
#[Out]# 20        0   11
#[Out]# 21        0   11
#[Out]# 22        0   11
#[Out]# 23        0   11
#[Out]# 24        0   11
#[Out]# 25        0   11
#[Out]# 26        0   11
#[Out]# 27        0   11
#[Out]# 28        0   11
#[Out]# 29        0   11
#[Out]# ...     ...  ...
#[Out]# 259051   63  190
#[Out]# 259052   63  190
#[Out]# 259053   63  190
#[Out]# 259054   63  190
#[Out]# 259055   63  190
#[Out]# 259056   63  190
#[Out]# 259057   63  190
#[Out]# 259058   63  190
#[Out]# 259059   63  190
#[Out]# 259060   63  190
#[Out]# 259061   63  190
#[Out]# 259062   63  190
#[Out]# 259063   63  190
#[Out]# 259064   63  190
#[Out]# 259065   63  190
#[Out]# 259066   63  190
#[Out]# 259067   63  190
#[Out]# 259068   63  190
#[Out]# 259069   63  190
#[Out]# 259070   63  190
#[Out]# 259071   63  190
#[Out]# 259072   63  190
#[Out]# 259073   63  190
#[Out]# 259074   63  190
#[Out]# 259075   63  190
#[Out]# 259076   63  190
#[Out]# 259077   63  190
#[Out]# 259078   63  190
#[Out]# 259079   63  190
#[Out]# 259080   63  190
#[Out]# 
#[Out]# [259081 rows x 2 columns]
testquery3 = '''
    WITH total AS (
    SELECT p1.sID, p2.cID
    FROM purchase AS p1, purchase AS p2
    ORDER BY p1.sID, p1.cID)

    SELECT *
    FROM total
    
'''
pd.read_sql_query(testquery3, conn)
#[Out]#         sID  cID
#[Out]# 0         0    0
#[Out]# 1         0    1
#[Out]# 2         0    1
#[Out]# 3         0    1
#[Out]# 4         0    1
#[Out]# 5         0    1
#[Out]# 6         0    1
#[Out]# 7         0    1
#[Out]# 8         0    2
#[Out]# 9         0    2
#[Out]# 10        0    2
#[Out]# 11        0    2
#[Out]# 12        0    2
#[Out]# 13        0    3
#[Out]# 14        0    3
#[Out]# 15        0    3
#[Out]# 16        0    4
#[Out]# 17        0    4
#[Out]# 18        0    4
#[Out]# 19        0    4
#[Out]# 20        0    4
#[Out]# 21        0    4
#[Out]# 22        0    5
#[Out]# 23        0    5
#[Out]# 24        0    5
#[Out]# 25        0    5
#[Out]# 26        0    5
#[Out]# 27        0    5
#[Out]# 28        0    7
#[Out]# 29        0    7
#[Out]# ...     ...  ...
#[Out]# 259051   63  190
#[Out]# 259052   63  190
#[Out]# 259053   63  190
#[Out]# 259054   63  190
#[Out]# 259055   63  190
#[Out]# 259056   63  190
#[Out]# 259057   63  190
#[Out]# 259058   63  190
#[Out]# 259059   63  190
#[Out]# 259060   63  190
#[Out]# 259061   63  190
#[Out]# 259062   63  190
#[Out]# 259063   63  190
#[Out]# 259064   63  190
#[Out]# 259065   63  190
#[Out]# 259066   63  190
#[Out]# 259067   63  190
#[Out]# 259068   63  190
#[Out]# 259069   63  190
#[Out]# 259070   63  190
#[Out]# 259071   63  190
#[Out]# 259072   63  190
#[Out]# 259073   63  190
#[Out]# 259074   63  190
#[Out]# 259075   63  190
#[Out]# 259076   63  190
#[Out]# 259077   63  190
#[Out]# 259078   63  190
#[Out]# 259079   63  190
#[Out]# 259080   63  190
#[Out]# 
#[Out]# [259081 rows x 2 columns]
testquery3 = '''
    WITH total AS (
    SELECT p1.sID, p2.cID
    FROM purchase AS p1, purchase AS p2
    ORDER BY p1.sID, p1.cID),
    
    actual AS (
    SELECT sID, cID
    FROM purchase
    ORDER BY sID)

    SELECT *
    FROM actual
    
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      sID  cID
#[Out]# 0      0   11
#[Out]# 1      0   24
#[Out]# 2      0   91
#[Out]# 3      0  108
#[Out]# 4      0  123
#[Out]# 5      0  162
#[Out]# 6      0  172
#[Out]# 7      0  184
#[Out]# 8      0  190
#[Out]# 9      1   21
#[Out]# 10     1   70
#[Out]# 11     1   77
#[Out]# 12     1  113
#[Out]# 13     1  124
#[Out]# 14     1  161
#[Out]# 15     1  169
#[Out]# 16     1  190
#[Out]# 17     2   18
#[Out]# 18     2   19
#[Out]# 19     2   21
#[Out]# 20     2   52
#[Out]# 21     2  104
#[Out]# 22     2  190
#[Out]# 23     3    0
#[Out]# 24     3    1
#[Out]# 25     3    7
#[Out]# 26     3   19
#[Out]# 27     3   41
#[Out]# 28     3   52
#[Out]# 29     3   92
#[Out]# ..   ...  ...
#[Out]# 479   56  126
#[Out]# 480   56  165
#[Out]# 481   56  167
#[Out]# 482   56  171
#[Out]# 483   56  180
#[Out]# 484   56  190
#[Out]# 485   57   30
#[Out]# 486   57   33
#[Out]# 487   57  162
#[Out]# 488   57  167
#[Out]# 489   57  179
#[Out]# 490   57  190
#[Out]# 491   58   59
#[Out]# 492   58  145
#[Out]# 493   58  190
#[Out]# 494   59   19
#[Out]# 495   59   24
#[Out]# 496   59   27
#[Out]# 497   59   59
#[Out]# 498   59  172
#[Out]# 499   59  190
#[Out]# 500   60  190
#[Out]# 501   61  190
#[Out]# 502   62  185
#[Out]# 503   62  186
#[Out]# 504   62  188
#[Out]# 505   62  188
#[Out]# 506   62  190
#[Out]# 507   63  189
#[Out]# 508   63  190
#[Out]# 
#[Out]# [509 rows x 2 columns]
testquery3 = '''
    WITH total AS (
    SELECT p1.sID, p2.cID
    FROM purchase AS p1, purchase AS p2
    ORDER BY p1.sID, p1.cID),
    
    actual AS (
    SELECT sID, cID
    FROM purchase
    ORDER BY sID),
    
    diff AS (
    SELECT *
    FROM total
    WHERE sID NOT IN actual)

    SELECT *
    FROM diff
    
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    SELECT *
    FROM *
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    SELECT *
    FROM purchase
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
testquery3 = '''
    SELECT sID, cID
    FROM purchase
    GROUP BY sID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#     sID  cID
#[Out]# 0     0  190
#[Out]# 1     1  190
#[Out]# 2     2  190
#[Out]# 3     3  190
#[Out]# 4     4  190
#[Out]# 5     5  190
#[Out]# 6     6  190
#[Out]# 7     7  190
#[Out]# 8     8  190
#[Out]# 9     9  190
#[Out]# 10   10  190
#[Out]# 11   11  190
#[Out]# 12   12  190
#[Out]# 13   13  190
#[Out]# 14   14  190
#[Out]# 15   15  190
#[Out]# 16   16  190
#[Out]# 17   17  190
#[Out]# 18   18  190
#[Out]# 19   19  190
#[Out]# 20   20  190
#[Out]# 21   21  190
#[Out]# 22   22  190
#[Out]# 23   23  190
#[Out]# 24   24  190
#[Out]# 25   25  190
#[Out]# 26   26  190
#[Out]# 27   27  190
#[Out]# 28   28  190
#[Out]# 29   29  190
#[Out]# ..  ...  ...
#[Out]# 34   34  190
#[Out]# 35   35  190
#[Out]# 36   36  190
#[Out]# 37   37  190
#[Out]# 38   38  190
#[Out]# 39   39  190
#[Out]# 40   40  190
#[Out]# 41   41  190
#[Out]# 42   42  190
#[Out]# 43   43  190
#[Out]# 44   44  190
#[Out]# 45   45  190
#[Out]# 46   46  190
#[Out]# 47   47  190
#[Out]# 48   48  190
#[Out]# 49   49  190
#[Out]# 50   50  190
#[Out]# 51   51  190
#[Out]# 52   52  190
#[Out]# 53   53  190
#[Out]# 54   54  190
#[Out]# 55   55  190
#[Out]# 56   56  190
#[Out]# 57   57  190
#[Out]# 58   58  190
#[Out]# 59   59  190
#[Out]# 60   60  190
#[Out]# 61   61  190
#[Out]# 62   62  190
#[Out]# 63   63  190
#[Out]# 
#[Out]# [64 rows x 2 columns]
testquery3 = '''
    SELECT sID, cID
    FROM purchase
    GROUP BY cID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      sID  cID
#[Out]# 0      3    0
#[Out]# 1     36    1
#[Out]# 2     47    2
#[Out]# 3     29    3
#[Out]# 4     44    4
#[Out]# 5     17    5
#[Out]# 6     42    7
#[Out]# 7     51    8
#[Out]# 8     34   10
#[Out]# 9      0   11
#[Out]# 10     8   13
#[Out]# 11    25   15
#[Out]# 12    26   16
#[Out]# 13    44   17
#[Out]# 14     6   18
#[Out]# 15    15   19
#[Out]# 16    40   20
#[Out]# 17    47   21
#[Out]# 18    27   22
#[Out]# 19    59   24
#[Out]# 20    12   25
#[Out]# 21    21   26
#[Out]# 22    34   27
#[Out]# 23    43   28
#[Out]# 24    29   29
#[Out]# 25    57   30
#[Out]# 26    39   31
#[Out]# 27    29   33
#[Out]# 28    26   34
#[Out]# 29    34   35
#[Out]# ..   ...  ...
#[Out]# 102   33  147
#[Out]# 103   54  149
#[Out]# 104   14  151
#[Out]# 105   43  152
#[Out]# 106   36  157
#[Out]# 107   17  159
#[Out]# 108   36  161
#[Out]# 109   41  162
#[Out]# 110    6  163
#[Out]# 111   46  165
#[Out]# 112   17  167
#[Out]# 113   28  168
#[Out]# 114   52  169
#[Out]# 115   40  170
#[Out]# 116   44  171
#[Out]# 117    0  172
#[Out]# 118   16  175
#[Out]# 119    6  176
#[Out]# 120   51  177
#[Out]# 121   39  178
#[Out]# 122   45  179
#[Out]# 123   56  180
#[Out]# 124   27  181
#[Out]# 125    4  182
#[Out]# 126    0  184
#[Out]# 127   62  185
#[Out]# 128   62  186
#[Out]# 129   62  188
#[Out]# 130   20  189
#[Out]# 131   63  190
#[Out]# 
#[Out]# [132 rows x 2 columns]
testquery3 = '''
    SELECT sID, cID
    FROM purchase
    GROUP BY sID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#     sID  cID
#[Out]# 0     0  190
#[Out]# 1     1  190
#[Out]# 2     2  190
#[Out]# 3     3  190
#[Out]# 4     4  190
#[Out]# 5     5  190
#[Out]# 6     6  190
#[Out]# 7     7  190
#[Out]# 8     8  190
#[Out]# 9     9  190
#[Out]# 10   10  190
#[Out]# 11   11  190
#[Out]# 12   12  190
#[Out]# 13   13  190
#[Out]# 14   14  190
#[Out]# 15   15  190
#[Out]# 16   16  190
#[Out]# 17   17  190
#[Out]# 18   18  190
#[Out]# 19   19  190
#[Out]# 20   20  190
#[Out]# 21   21  190
#[Out]# 22   22  190
#[Out]# 23   23  190
#[Out]# 24   24  190
#[Out]# 25   25  190
#[Out]# 26   26  190
#[Out]# 27   27  190
#[Out]# 28   28  190
#[Out]# 29   29  190
#[Out]# ..  ...  ...
#[Out]# 34   34  190
#[Out]# 35   35  190
#[Out]# 36   36  190
#[Out]# 37   37  190
#[Out]# 38   38  190
#[Out]# 39   39  190
#[Out]# 40   40  190
#[Out]# 41   41  190
#[Out]# 42   42  190
#[Out]# 43   43  190
#[Out]# 44   44  190
#[Out]# 45   45  190
#[Out]# 46   46  190
#[Out]# 47   47  190
#[Out]# 48   48  190
#[Out]# 49   49  190
#[Out]# 50   50  190
#[Out]# 51   51  190
#[Out]# 52   52  190
#[Out]# 53   53  190
#[Out]# 54   54  190
#[Out]# 55   55  190
#[Out]# 56   56  190
#[Out]# 57   57  190
#[Out]# 58   58  190
#[Out]# 59   59  190
#[Out]# 60   60  190
#[Out]# 61   61  190
#[Out]# 62   62  190
#[Out]# 63   63  190
#[Out]# 
#[Out]# [64 rows x 2 columns]
testquery3 = '''
    SELECT sID, count(cID)
    FROM purchase
    GROUP BY sID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#     sID  count(cID)
#[Out]# 0     0           9
#[Out]# 1     1           8
#[Out]# 2     2           6
#[Out]# 3     3          13
#[Out]# 4     4          11
#[Out]# 5     5           8
#[Out]# 6     6          10
#[Out]# 7     7           9
#[Out]# 8     8          10
#[Out]# 9     9           9
#[Out]# 10   10           5
#[Out]# 11   11          11
#[Out]# 12   12           9
#[Out]# 13   13           9
#[Out]# 14   14           8
#[Out]# 15   15           4
#[Out]# 16   16           6
#[Out]# 17   17          13
#[Out]# 18   18          11
#[Out]# 19   19           7
#[Out]# 20   20           7
#[Out]# 21   21          10
#[Out]# 22   22           4
#[Out]# 23   23           5
#[Out]# 24   24           5
#[Out]# 25   25          10
#[Out]# 26   26           8
#[Out]# 27   27           8
#[Out]# 28   28           7
#[Out]# 29   29          13
#[Out]# ..  ...         ...
#[Out]# 34   34          15
#[Out]# 35   35           7
#[Out]# 36   36          14
#[Out]# 37   37           4
#[Out]# 38   38          10
#[Out]# 39   39           7
#[Out]# 40   40          10
#[Out]# 41   41           6
#[Out]# 42   42          10
#[Out]# 43   43          13
#[Out]# 44   44          10
#[Out]# 45   45           8
#[Out]# 46   46          10
#[Out]# 47   47          11
#[Out]# 48   48           2
#[Out]# 49   49           6
#[Out]# 50   50           7
#[Out]# 51   51          10
#[Out]# 52   52           8
#[Out]# 53   53           5
#[Out]# 54   54          11
#[Out]# 55   55          11
#[Out]# 56   56          10
#[Out]# 57   57           6
#[Out]# 58   58           3
#[Out]# 59   59           6
#[Out]# 60   60           1
#[Out]# 61   61           1
#[Out]# 62   62           5
#[Out]# 63   63           2
#[Out]# 
#[Out]# [64 rows x 2 columns]
testquery3 = '''
    SELECT sID, distinct(cID)
    FROM purchase
    GROUP BY sID
'''
pd.read_sql_query(testquery3, conn)
testquery3 = '''
    SELECT distinct(cID)
    FROM purchase
    GROUP BY sID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#    cID
#[Out]# 0  190
testquery3 = '''
    SELECT distinct(cID)
    FROM purchase
'''
pd.read_sql_query(testquery3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
testquery3 = '''
    SELECT distinct(cID)
    FROM purchase
    GROUP BY sID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#    cID
#[Out]# 0  190
testquery3 = '''
    SELECT distinct(sID)
    FROM purchase
    GROUP BY sID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#     sID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# ..  ...
#[Out]# 34   34
#[Out]# 35   35
#[Out]# 36   36
#[Out]# 37   37
#[Out]# 38   38
#[Out]# 39   39
#[Out]# 40   40
#[Out]# 41   41
#[Out]# 42   42
#[Out]# 43   43
#[Out]# 44   44
#[Out]# 45   45
#[Out]# 46   46
#[Out]# 47   47
#[Out]# 48   48
#[Out]# 49   49
#[Out]# 50   50
#[Out]# 51   51
#[Out]# 52   52
#[Out]# 53   53
#[Out]# 54   54
#[Out]# 55   55
#[Out]# 56   56
#[Out]# 57   57
#[Out]# 58   58
#[Out]# 59   59
#[Out]# 60   60
#[Out]# 61   61
#[Out]# 62   62
#[Out]# 63   63
#[Out]# 
#[Out]# [64 rows x 1 columns]
testquery3 = '''
    SELECT distinct(cID)
    FROM purchase
    GROUP BY sID
'''
pd.read_sql_query(testquery3, conn)
#[Out]#    cID
#[Out]# 0  190
