# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query5 = '''
    SELECT p.pName, s.sName
    FROM product p, store s, purchase t
    WHERE p.pID = t.pID AND s.sID = t.sID AND t.price/t.quantity IN(
    SELECT max(t1.price/t1.quantity)
    FROM purchase t1)
'''

pd.read_sql_query(query5, conn)
#[Out]#     pName        sName
#[Out]# 0  Cheese  Albert Hein
query5 = '''
    SELECT p.pName, s.sName, t.price/t.quantity
    FROM product p, store s, purchase t
    WHERE p.pID = t.pID AND s.sID = t.sID AND t.price/t.quantity IN(
    SELECT max(t1.price/t1.quantity)
    FROM purchase t1)
'''

pd.read_sql_query(query5, conn)
#[Out]#     pName        sName  t.price/t.quantity
#[Out]# 0  Cheese  Albert Hein                  12
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName as storeName, avg(t.quantity) as avg_quantity
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity <= 4
    
    '''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName as storeName, avg(t.quantity) as avg_quantity
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity < 4
    
    '''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName as storeName, avg(t.quantity) as avg_quantity
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity <= 4
    
    '''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query6 = '''
    SELECT max(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2, store s1, store s2
    WHERE i1.sID = s1.sID AND i2.sID = s2.sID AND
    i1.pID = i2.pID AND i1.date = '2018-08-23'
    AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT storeName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName )
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
    
    '''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT storeName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName )
            AS quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
    
    '''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT storeName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY storeName )
            AS quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
    
    '''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY storeName )
            AS quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
    
    '''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            AS quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
    
    '''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName, avg_quantity
    FROM ( SELECT s.sName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            AS quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
    
    '''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
    
    '''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity > 4
    
    '''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName as storeName, avg(t.quantity) as avg_quantity
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity > 4
    
    '''

pd.read_sql_query(query4, conn)
#[Out]#    sName
#[Out]# 0  Jumbo
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName as storeName, avg(t.quantity) as avg_quantity
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity >= 4
    
    '''

pd.read_sql_query(query4, conn)
#[Out]#    sName
#[Out]# 0  Jumbo
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName as storeName, avg(t.quantity) as avg_quantity
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity >= 1
    
    '''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName as storeName, avg(t.quantity) as avg_quantity
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity >= 2
    
    '''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName as storeName, avg(t.quantity) as avg_quantity
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity >= 789123
    
    '''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName as storeName, avg(t.quantity) as avg_quantity
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity > 5
    
    '''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2        Jumbo
#[Out]# 3         Lidl
#[Out]# 4       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName as storeName, avg(t.quantity) as avg_quantity
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            quantity_avg
    WHERE avg_quantity < 4
    
    '''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT p.pName, s.sName
    FROM product p, store s, purchase t
    WHERE p.pID = t.pID AND s.sID = t.sID AND t.price IN(
    SELECT max(t1.price)
    FROM purchase t1)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT p.pName, s.sName
    FROM product p, store s, purchase t
    WHERE p.pID = t.pID AND s.sID = t.sID AND t.price IN(
    SELECT max(t1.price/t1.quantity)
    FROM purchase t1)
'''

pd.read_sql_query(query5, conn)
#[Out]#     pName        sName
#[Out]# 0  Cheese  Albert Hein
query5 = '''
    SELECT p.pName, s.sName, t.quantity
    FROM product p, store s, purchase t
    WHERE p.pID = t.pID AND s.sID = t.sID AND t.price IN(
    SELECT max(t1.price/t1.quantity)
    FROM purchase t1)
'''

pd.read_sql_query(query5, conn)
#[Out]#     pName        sName  quantity
#[Out]# 0  Cheese  Albert Hein         1
query5 = '''
    SELECT p.pName, s.sName, t.quantity
    FROM product p, store s, purchase t
    WHERE p.pID = t.pID AND s.sID = t.sID AND t.price IN(
    SELECT max(t1.price)
    FROM purchase t1)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName  quantity
#[Out]# 0  Beef  Sligro         6
query5 = '''
    SELECT p.pName, s.sName
    FROM product p, store s, purchase t
    WHERE p.pID = t.pID AND s.sID = t.sID AND t.price IN(
    SELECT max(t1.price/t1.quantity)
    FROM purchase t1)
'''

pd.read_sql_query(query5, conn)
#[Out]#     pName        sName
#[Out]# 0  Cheese  Albert Hein

# IPython log file

get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT count(p.pID), t.cID
    FROM product p, purchase t, customer c
    WHERE t.pID = p.pID AND t.cID = c.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(p.pID)  cID
#[Out]# 0           509  190
query1 = '''
    SELECT t1.pID
    FROM purchase t1, purchase t2
    WHERE t1.pID = t2.pID AND NOT t1.tID = t2.tID
    EXCEPT
    SELECT pID
    FROM purchase
    GROUP BY pID
    HAVING count(cID) > 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT t1.pID
    FROM purchase t1, purchase t2
    WHERE t1.pID = t2.pID AND NOT t1.tID = t2.tID
    EXCEPT
    SELECT pID
    FROM purchase
    GROUP BY pID
    HAVING count(cID) >= 2
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID]
#[Out]# Index: []
query1 = '''
    SELECT t1.pID
    FROM purchase t1, purchase t2
    WHERE t1.pID = t2.pID AND NOT t1.tID = t2.tID
    EXCEPT
    SELECT pID
    FROM purchase
    GROUP BY pID
    HAVING count(cID) > 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30


# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x19124c1fc00>
query1 = '''
    SELECT count(pID)
    FROM product p, customer c, purchase t
    WHERE p.pID = t.pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT *
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT *
    FROM *
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT *
    FROM product
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID             pName suffix
#[Out]# 0     0       Cashew Nuts       
#[Out]# 1     1        Mixed Nuts       
#[Out]# 2     2          Potatoes       
#[Out]# 3     3      Green Pepper       
#[Out]# 4     4            Onions       
#[Out]# 5     5         Mushrooms       
#[Out]# 6     6           Carrots       
#[Out]# 7     7          Tomatoes       
#[Out]# 8     8  Hot Dog Sausages       
#[Out]# 9     9           Bananas       
#[Out]# 10   10             Water       
#[Out]# 11   11              Milk       
#[Out]# 12   12              Beef       
#[Out]# 13   13              Eggs       
#[Out]# 14   14            Apples       
#[Out]# 15   15         Cucumbers       
#[Out]# 16   16              Rice       
#[Out]# 17   17             Bread       
#[Out]# 18   18            Cheese       
#[Out]# 19   19              Coca       
#[Out]# 20   20             Fanta       
#[Out]# 21   21            Coffee       
#[Out]# 22   22               Tea       
#[Out]# 23   23   Spiced Biscuits       
#[Out]# 24   24           Oranges       
#[Out]# 25   25            Donuts       
#[Out]# 26   26             Pasta       
#[Out]# 27   27             Pizza       
#[Out]# 28   28           Lasanga       
#[Out]# 29   29            Salmon       
#[Out]# 30   30           Ketchup       
#[Out]# 31   31   French baguette       
query1 = '''
    SELECT pID
    FROM product
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
#[Out]# 31   31
query1 = '''
    SELECT count(pID)
    FROM product
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(pID)
#[Out]# 0          32
query1 = '''
    SELECT count(p.pID)
    FROM product p, purhcase t
    WHERE t.pID = p.pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT count(p.pID)
    FROM product p, purchase t
    WHERE t.pID = p.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(p.pID)
#[Out]# 0           509
query1 = '''
    SELECT count(p.pID), t.cID
    FROM product p, purchase t
    WHERE t.pID = p.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(p.pID)  cID
#[Out]# 0           509  190
query1 = '''
    SELECT count(p.pID), t.cID
    FROM product p, purchase t, customer c
    WHERE t.pID = p.pID AND NOT t.cID = c.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(p.pID)  cID
#[Out]# 0         96201  190
query1 = '''
    SELECT count(p.pID), t.cID
    FROM product p, purchase t, customer c
    WHERE t.pID = p.pID AND t.cID = c.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(p.pID)  cID
#[Out]# 0           509  190
query2 = '''
    SELECT c.cID, c.cName
    FROM customer c, purchase t1, purchase t2
    WHERE c.cID = t1.cID AND c.cID = t2.cID AND
    EXISTS (
    SELECT *
    FROM product p1, p2
    WHERE p1.pID = t1.pID AND p2.pID = t2.pID AND
    p1.pName = 'Onions' AND p2.pName = 'Coffee' AND
    t1.date = t2.date
    )
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName
    FROM customer c, purchase t1, purchase t2
    WHERE c.cID = t1.cID AND c.cID = t2.cID AND
    EXISTS (
    SELECT *
    FROM product p1,product p2
    WHERE p1.pID = t1.pID AND p2.pID = t2.pID AND
    p1.pName = 'Onions' AND p2.pName = 'Coffee' AND
    t1.date = t2.date
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    SELECT c.cID, c.cName
    FROM customer c, purchase t1, purchase t2
    WHERE c.cID = t1.cID AND c.cID = t2.cID AND NOT t1.tID = t2.tID AND
    EXISTS (
    SELECT *
    FROM product p1,product p2
    WHERE p1.pID = t1.pID AND p2.pID = t2.pID AND
    p1.pName = 'Onions' AND p2.pName = 'Coffee' AND
    t1.date = t2.date
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT c.cID
    FROM customer c
    EXCEPT
    SELECT c1.cID
    FROM customer c1, purchase t
    WHERE c1.cID = t.cID AND EXISTS (
    SELECT s.sID
    FROM store s
    WHERE NOT t.sID = s.sID
    )
    
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query3 = '''
    SELECT c.cID
    FROM customer c

'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      6
#[Out]# 7      7
#[Out]# 8      8
#[Out]# 9      9
#[Out]# 10    10
#[Out]# 11    11
#[Out]# 12    12
#[Out]# 13    13
#[Out]# 14    14
#[Out]# 15    15
#[Out]# 16    16
#[Out]# 17    17
#[Out]# 18    18
#[Out]# 19    19
#[Out]# 20    20
#[Out]# 21    21
#[Out]# 22    22
#[Out]# 23    23
#[Out]# 24    24
#[Out]# 25    25
#[Out]# 26    26
#[Out]# 27    27
#[Out]# 28    28
#[Out]# 29    29
#[Out]# ..   ...
#[Out]# 160  160
#[Out]# 161  161
#[Out]# 162  162
#[Out]# 163  163
#[Out]# 164  164
#[Out]# 165  165
#[Out]# 166  166
#[Out]# 167  167
#[Out]# 168  168
#[Out]# 169  169
#[Out]# 170  170
#[Out]# 171  171
#[Out]# 172  172
#[Out]# 173  173
#[Out]# 174  174
#[Out]# 175  175
#[Out]# 176  176
#[Out]# 177  177
#[Out]# 178  178
#[Out]# 179  179
#[Out]# 180  180
#[Out]# 181  181
#[Out]# 182  182
#[Out]# 183  183
#[Out]# 184  184
#[Out]# 185  185
#[Out]# 186  186
#[Out]# 187  188
#[Out]# 188  189
#[Out]# 189  190
#[Out]# 
#[Out]# [190 rows x 1 columns]
query3 = '''
    SELECT c.cID
    FROM customer c
    EXCEPT
    SELECT c2.cID
    FROM customer c2, store s
    WHERE EXISTS (
    SELECT * 
    FROM purchase t
    WHERE t.cID = c2.cID AND NOT s.sID = t.sID
    )
    

'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query3 = '''
    SELECT c.cID
    FROM customer c
    EXCEPT
    SELECT c2.cID
    FROM customer c2, store s
    WHERE EXISTS (
    SELECT t.tID
    FROM purchase t
    WHERE t.cID = c2.cID AND NOT s.sID = t.sID
    )
    

'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query3 = '''
    SELECT c.cID
    FROM customer c
    EXCEPT
    SELECT c2.cID
    FROM customer c2, store s
    WHERE EXISTS (
    SELECT t.tID
    FROM purchase t
    WHERE t.cID = c2.cID
    )
    

'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query3 = '''
    SELECT c.cID
    FROM customer c
   
    

'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      6
#[Out]# 7      7
#[Out]# 8      8
#[Out]# 9      9
#[Out]# 10    10
#[Out]# 11    11
#[Out]# 12    12
#[Out]# 13    13
#[Out]# 14    14
#[Out]# 15    15
#[Out]# 16    16
#[Out]# 17    17
#[Out]# 18    18
#[Out]# 19    19
#[Out]# 20    20
#[Out]# 21    21
#[Out]# 22    22
#[Out]# 23    23
#[Out]# 24    24
#[Out]# 25    25
#[Out]# 26    26
#[Out]# 27    27
#[Out]# 28    28
#[Out]# 29    29
#[Out]# ..   ...
#[Out]# 160  160
#[Out]# 161  161
#[Out]# 162  162
#[Out]# 163  163
#[Out]# 164  164
#[Out]# 165  165
#[Out]# 166  166
#[Out]# 167  167
#[Out]# 168  168
#[Out]# 169  169
#[Out]# 170  170
#[Out]# 171  171
#[Out]# 172  172
#[Out]# 173  173
#[Out]# 174  174
#[Out]# 175  175
#[Out]# 176  176
#[Out]# 177  177
#[Out]# 178  178
#[Out]# 179  179
#[Out]# 180  180
#[Out]# 181  181
#[Out]# 182  182
#[Out]# 183  183
#[Out]# 184  184
#[Out]# 185  185
#[Out]# 186  186
#[Out]# 187  188
#[Out]# 188  189
#[Out]# 189  190
#[Out]# 
#[Out]# [190 rows x 1 columns]
query3 = '''
    SELECT c.cID
    FROM customer c
    EXCEPT
    SELECT c2.cID
    FROM customer c2, store s
    WHERE EXISTS (
    SELECT t.tID
    FROM purchase t
    WHERE t.cID = c2.cID
    )
    

'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query3 = '''
    SELECT c.cID
    FROM customer c
    EXCEPT
    SELECT t.cID
    FROM purchase t
    

'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query3 = '''
    SELECT c1.cID
    FROM customer c1
    EXCEPT
    SELECT c.cID, s.sID
    FROM customer c, store s
    EXCEPT
    SELECT t.cID, t.sID
    FROM purchase t
    

'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT *
    FROM customer c1
    EXCEPT
    SELECT c.cID, s.sID
    FROM customer c, store s
    EXCEPT
    SELECT t.cID, t.sID
    FROM purchase t
    

'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT 
    FROM customer c1
    EXCEPT
    SELECT c.cID
    FROM (
    SELECT c.cID, s.sID
    FROM customer c, store s
    EXCEPT
    SELECT t.cID, t.sID
    FROM purchase t
    )

'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c1.cID
    FROM customer c1
    EXCEPT
    SELECT c.cID
    FROM (
    SELECT c.cID, s.sID
    FROM customer c, store s
    EXCEPT
    SELECT t.cID, t.sID
    FROM purchase t
    )

'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c1.cID
    FROM customer c1
    EXCEPT
    SELECT c2.cID
    FROM (
    SELECT c.cID, s.sID
    FROM customer c, store s
    EXCEPT
    SELECT t.cID, t.sID
    FROM purchase t
    ) c2

'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query6 = '''
    SELECT max(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2, store s1, store s2
    WHERE i1.sID = s1.sID AND i2.sID = s2.sID AND
    i1.pID = i2.pID AND i1.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price - i2.unit_price)
#[Out]# 0                                3.25
query6 = '''
    SELECT max(i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2, store s1, store s2
    WHERE i1.sID = s1.sID AND i2.sID = s2.sID AND
    i1.pID = i2.pID AND i1.date = '2018-08-23'
    AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query5 = '''
    SELECT p.pName, s.sID
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sID
    FROM product p, store s, purchase t
    WHERE p.pID = t.tID AND s.sID = t.sID
'''

pd.read_sql_query(query5, conn)
#[Out]#                pName  sID
#[Out]# 0        Cashew Nuts    3
#[Out]# 1         Mixed Nuts   23
#[Out]# 2           Potatoes    3
#[Out]# 3       Green Pepper   17
#[Out]# 4             Onions   32
#[Out]# 5          Mushrooms   16
#[Out]# 6            Carrots   46
#[Out]# 7           Tomatoes   36
#[Out]# 8   Hot Dog Sausages   12
#[Out]# 9            Bananas   39
#[Out]# 10             Water   13
#[Out]# 11              Milk   51
#[Out]# 12              Beef   47
#[Out]# 13              Eggs   44
#[Out]# 14            Apples   30
#[Out]# 15         Cucumbers   29
#[Out]# 16              Rice   17
#[Out]# 17             Bread   10
#[Out]# 18            Cheese   53
#[Out]# 19              Coca   21
#[Out]# 20             Fanta    7
#[Out]# 21            Coffee   44
#[Out]# 22               Tea    4
#[Out]# 23   Spiced Biscuits   36
#[Out]# 24           Oranges   55
#[Out]# 25            Donuts   51
#[Out]# 26             Pasta    6
#[Out]# 27             Pizza   17
#[Out]# 28           Lasanga    3
#[Out]# 29            Salmon   12
#[Out]# 30           Ketchup   11
#[Out]# 31   French baguette   32
query5 = '''
    SELECT p.pName, s.sID
    FROM product p, store s, purchase t
    WHERE p.pID = t.tID AND s.sID = t.sID AND t.price IN
    SELECT max(t1.price)
    FROM purchase t1
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sID
    FROM product p, store s, purchase t
    WHERE p.pID = t.tID AND s.sID = t.sID AND t.price IN(
    SELECT max(t1.price)
    FROM purchase t1)
'''

pd.read_sql_query(query5, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName, sID]
#[Out]# Index: []
query5 = '''
    SELECT p.pName, s.sName
    FROM product p, store s, purchase t
    WHERE p.pID = t.pD AND s.sID = t.sID AND t.price IN(
    SELECT max(t1.price)
    FROM purchase t1)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM product p, store s, purchase t
    WHERE p.pID = t.pID AND s.sID = t.sID AND t.price IN(
    SELECT max(t1.price)
    FROM purchase t1)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1         Coop
#[Out]# 2         Coop
#[Out]# 3         Coop
#[Out]# 4         Coop
#[Out]# 5         Coop
#[Out]# 6         Coop
#[Out]# 7         Coop
#[Out]# 8         Coop
#[Out]# 9         Coop
#[Out]# 10        Coop
#[Out]# 11        Coop
#[Out]# 12        Coop
#[Out]# 13   Hoogvliet
#[Out]# 14   Hoogvliet
#[Out]# 15   Hoogvliet
#[Out]# 16   Hoogvliet
#[Out]# 17   Hoogvliet
#[Out]# 18   Hoogvliet
#[Out]# 19   Hoogvliet
#[Out]# 20   Hoogvliet
#[Out]# 21       Jumbo
#[Out]# 22       Jumbo
#[Out]# 23       Jumbo
#[Out]# 24       Jumbo
#[Out]# 25       Jumbo
#[Out]# 26       Jumbo
#[Out]# 27       Jumbo
#[Out]# 28      Sligro
#[Out]# 29      Sligro
#[Out]# ..         ...
#[Out]# 528       Lidl
#[Out]# 529       Lidl
#[Out]# 530       Lidl
#[Out]# 531       Lidl
#[Out]# 532       Lidl
#[Out]# 533       Lidl
#[Out]# 534       Lidl
#[Out]# 535       Lidl
#[Out]# 536       Lidl
#[Out]# 537       Lidl
#[Out]# 538       Lidl
#[Out]# 539       Lidl
#[Out]# 540       Lidl
#[Out]# 541       Lidl
#[Out]# 542       Lidl
#[Out]# 543       Lidl
#[Out]# 544      Jumbo
#[Out]# 545      Jumbo
#[Out]# 546      Jumbo
#[Out]# 547      Jumbo
#[Out]# 548      Jumbo
#[Out]# 549      Jumbo
#[Out]# 550      Jumbo
#[Out]# 551      Jumbo
#[Out]# 552      Jumbo
#[Out]# 553      Jumbo
#[Out]# 554      Jumbo
#[Out]# 555      Jumbo
#[Out]# 556      Jumbo
#[Out]# 557      Jumbo
#[Out]# 
#[Out]# [558 rows x 1 columns]
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT sName
    FROM (SELECT s.sName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT sName
    FROM (  SELECT s.sName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT sName
    FROM (  SELECT sName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT sName
    FROM (  SELECT sName, avg(quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName)
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT sName
    FROM (  SELECT sName, avg(quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY sName)
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT sName
    FROM ( SELECT avg(quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY sName)
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT sName
    FROM ( SELECT avg(quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY sName )
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT avg(quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY sName )
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY sName )
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT s.sName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName )
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
    EXCEPT
    SELECT storeName
    FROM ( SELECT storeName, avg(t.quantity)
            FROM store s, purchase t
            WHERE s.sID = t.sID
            GROUP BY s.sName )
            as quantity_avg(storeName, avg_quantity)
    WHERE avg_quantity > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName = s2.sName AND NOT s1.sID = s2.sID 
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1         Coop
#[Out]# 2         Coop
#[Out]# 3         Coop
#[Out]# 4         Coop
#[Out]# 5         Coop
#[Out]# 6         Coop
#[Out]# 7         Coop
#[Out]# 8         Coop
#[Out]# 9         Coop
#[Out]# 10        Coop
#[Out]# 11        Coop
#[Out]# 12        Coop
#[Out]# 13   Hoogvliet
#[Out]# 14   Hoogvliet
#[Out]# 15   Hoogvliet
#[Out]# 16   Hoogvliet
#[Out]# 17   Hoogvliet
#[Out]# 18   Hoogvliet
#[Out]# 19   Hoogvliet
#[Out]# 20   Hoogvliet
#[Out]# 21       Jumbo
#[Out]# 22       Jumbo
#[Out]# 23       Jumbo
#[Out]# 24       Jumbo
#[Out]# 25       Jumbo
#[Out]# 26       Jumbo
#[Out]# 27       Jumbo
#[Out]# 28      Sligro
#[Out]# 29      Sligro
#[Out]# ..         ...
#[Out]# 528       Lidl
#[Out]# 529       Lidl
#[Out]# 530       Lidl
#[Out]# 531       Lidl
#[Out]# 532       Lidl
#[Out]# 533       Lidl
#[Out]# 534       Lidl
#[Out]# 535       Lidl
#[Out]# 536       Lidl
#[Out]# 537       Lidl
#[Out]# 538       Lidl
#[Out]# 539       Lidl
#[Out]# 540       Lidl
#[Out]# 541       Lidl
#[Out]# 542       Lidl
#[Out]# 543       Lidl
#[Out]# 544      Jumbo
#[Out]# 545      Jumbo
#[Out]# 546      Jumbo
#[Out]# 547      Jumbo
#[Out]# 548      Jumbo
#[Out]# 549      Jumbo
#[Out]# 550      Jumbo
#[Out]# 551      Jumbo
#[Out]# 552      Jumbo
#[Out]# 553      Jumbo
#[Out]# 554      Jumbo
#[Out]# 555      Jumbo
#[Out]# 556      Jumbo
#[Out]# 557      Jumbo
#[Out]# 
#[Out]# [558 rows x 1 columns]
