# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    select pID
    from product
    except
    select p1.pID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID and p2.pID = p3.pID 
        and p1.cID <> p2.cID and p1.cID <> p3.cID and p2.cID <> p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    select c.cID, cName
    from customer c, purchase pu1, purchase pu2, product pr1, product pr2
    where c.cID = pu1.cID and c.cID = pu2.cID 
        and pu1.date = pu2.date
        and pu1.pID = pr1.pID and pu2.pID = pr2.pID
        and pr1.pName = 'Onions' and pr2.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    with unbought(cID, sID) as (
        select cID, sID
        from customer, store
        except
        select c.cID, s.sID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select p.cID
    from purchase p
    except
    select cID
    from unbought
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    select sName
    from store s, purchase p
    where s.sID = p.sID
    group by sName
    having avg(quantity) > 4
    
    intersect
    
    select s1.sName
    from store s1, store s2
    where s1.sID <> s2.sID and s1.sName = s2.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    with max_price(price) as (
    select max(price)
    from purchase)

    select pName, sName
    from purchase pu, store s, product pr, max_price
    where pu.sID = s.sID and pu.pID = pr.pID and pu.price = max_price.price
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    select max(abs(i1.unit_price - i2.unit_price))
    from inventory i1, inventory i2
    where i1.date = '2018-08-23' and i1.date = i2.date and i1.sID <> i2.sID and i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                      2.0
practicequery1a = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1a, conn)
practicequery1b = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1b, conn)

# IPython log file

query5 = '''
    with max_price(price) as (
    select max(price)
    from purchase)

    select pName, sName
    from purchase pu, store s, product pr, max_price
    where pu.sID = s.sID and pu.pID = pr.pID and pu.price = max_price.price
'''

pd.read_sql_query(query5, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)


# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x14d15ca4f10>
query1 = '''
    (select pID
    from purchase p)
    except
    (select pID
    from purchase p1, purchase p2, purchase p3
    where p1.cID = p2.cID and p2.cID = p3.cID and p1.pID <> p2.pID and p1.pID <> p3.pID and p2.pID <> p3.pID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    select pID
    from purchase p
    except
    (select pID
    from purchase p1, purchase p2, purchase p3
    where p1.cID = p2.cID and p2.cID = p3.cID and p1.pID <> p2.pID and p1.pID <> p3.pID and p2.pID <> p3.pID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    select pID
    from purchase p
    except
    select pID
    from purchase p1, purchase p2, purchase p3
    where p1.cID = p2.cID and p2.cID = p3.cID and p1.pID <> p2.pID and p1.pID <> p3.pID and p2.pID <> p3.pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    select p.pID
    from purchase p
    except
    select p1.pID
    from purchase p1, purchase p2, purchase p3
    where p1.cID = p2.cID and p2.cID = p3.cID and p1.pID <> p2.pID and p1.pID <> p3.pID and p2.pID <> p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    select p.pID
    from purchase p
    except
    (select p1.pID
    from purchase p1, purchase p2, purchase p3
    where p1.cID = p2.cID and p2.cID = p3.cID and p1.pID <> p2.pID and p1.pID <> p3.pID and p2.pID <> p3.pID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    select p.pID
    from purchase p
    except
    select p1.pID
    from purchase p1, purchase p2, purchase p3
    where p1.cID = p2.cID and p2.cID = p3.cID and p1.pID <> p2.pID and p1.pID <> p3.pID and p2.pID <> p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    select p.pID
    from purchase p
    except
    select p1.pID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID and p2.pID = p3.pID and p1.cID <> p2.cID and p1.cID <> p3.cID and p2.cID <> p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    select p.pID
    from purchase p
    except
    select p1.pID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID and p2.pID = p3.pID 
        and p1.cID <> p2.cID and p1.cID <> p3.cID and p2.cID <> p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    select c.cID, cName
    from customer c, purchase pu1, purchase pu2, product pr1, product pr2
    where c.cID = pu1.cID and c.cID = pu2.cID 
        and pu1.date = pu2.date
        and pu1.pID = pr1.pID and pu2.pID = pr2.pID
        and pr1.pName = 'Onions' and pr2.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query1 = '''
    select pID
    from product
    except
    select p1.pID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID and p2.pID = p3.pID 
        and p1.cID <> p2.cID and p1.cID <> p3.cID and p2.cID <> p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query3 = '''
    select distinct cID
    from purchase p, store s
    where count (p.sID) = count (s.sID)
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select distinct cID
    from purchase p, store s
    where count(p.sID) = count(s.sID)
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select distinct cID
    from purchase p, store s
    where count(p.sID) = 1
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select distinct p.cID
    from purchase p, store s
    where avg(p.sID) = 1
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as (
        select count(sID)
        from store
    ) 
    
    select cID
    from purchase p
    where p.sID = stores_number
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as (
        select count(sID)
        from store
    ) 
    
    select cID
    from purchase p
    where p.sID = stores_number.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as (
        select count(sID)
        from store
    ) 
    
    select cID
    from purchase p
    where count(p.sID) = stores_number.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as (
        select count(sID)
        from store) 
    
    select cID
    from purchase p, stores_number
    where count(p.sID) = stores_number.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as (
        select count(sID)
        from store) 
    
    with stores_visited(cID) as (
        select count(sID)
        from purchase p)
    
    select cID
    from purchase p, stores_number, stores_visited
    where stores_visited(p.cID) = stores_number.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as (
        select count(sID)
        from store) 
    
    with stores_visited(cID) as (
        select count(sID), c.cID
        from purchase p, customer c
        where p.cID = c.cID)
    
    select cID
    from purchase p, stores_number, stores_visited
    where stores_visited(p.cID) = stores_number.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as (
        select count(sID)
        from store),
    
    with stores_visited(cID) as (
        select count(sID), c.cID
        from purchase p, customer c
        where p.cID = c.cID)
    
    select cID
    from purchase p, stores_number, stores_visited
    where stores_visited(p.cID) = stores_number.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as (
        select count(sID)
        from store),
    
    with stores_visited(value) as (
        select count(sID), c.cID
        from purchase p, customer c
        where p.cID = c.cID)
    
    select cID
    from purchase p, stores_number, stores_visited
    where stores_visited.value = stores_number.value
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as (
        select count(sID)
        from store),
    
    with stores_visited(value) as (
        select c.cID, count(sID) 
        from purchase p, customer c
        where p.cID = c.cID)
    
    select cID
    from purchase p, stores_number, stores_visited
    where stores_visited.value = stores_number.value and stores_visited.cID = p.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    create view stores_number as (
        select count(sID)
        from store),
    
    create view stores_visited as (
        select c.cID, count(sID) 
        from purchase p, customer c
        where p.cID = c.cID)
    
    select cID
    from purchase p, stores_number, stores_visited
    where stores_visited.value = stores_number.value and stores_visited.cID = p.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    create view stores_number as 
        select count(sID)
        from store,
    
    create view stores_visited as 
        select c.cID, count(sID) 
        from purchase p, customer c
        where p.cID = c.cID
    
    select cID
    from purchase p, stores_number, stores_visited
    where stores_visited.value = stores_number.value and stores_visited.cID = p.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    create view stores_number as 
        select count(sID)
        from store
    
    create view stores_visited as 
        select c.cID, count(sID) 
        from purchase p, customer c
        where p.cID = c.cID
    
    select cID
    from purchase p, stores_number, stores_visited
    where stores_visited.value = stores_number.value and stores_visited.cID = p.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as ( 
        select count(sID)
        from store)
    
    create view stores_visited as 
        select c.cID, count(sID) 
        from purchase p, customer c
        where p.cID = c.cID
    
    select cID
    from purchase p, stores_number, stores_visited
    where stores_visited.value = stores_number.value and stores_visited.cID = p.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with stores_number(value) as ( 
        select count(sID)
        from store),
    
    create view stores_visited as 
        select c.cID, count(sID) 
        from purchase p, customer c
        where p.cID = c.cID
    
    select cID
    from purchase p, stores_number, stores_visited
    where stores_visited.value = stores_number.value and stores_visited.cID = p.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''

        select c.cID, count(sID) 
        from purchase p, customer c
        where p.cID = c.cID

'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  count(sID)
#[Out]# 0  190         509
query3 = '''

        select p.cID, count(sID) 
        from purchase p

'''

pd.read_sql_query(query3, conn)
#[Out]#    cID  count(sID)
#[Out]# 0  190         509
query3 = '''
    select cID
    from customer, store
    
'''

pd.read_sql_query(query3, conn)
#[Out]#        cID
#[Out]# 0        0
#[Out]# 1        0
#[Out]# 2        0
#[Out]# 3        0
#[Out]# 4        0
#[Out]# 5        0
#[Out]# 6        0
#[Out]# 7        0
#[Out]# 8        0
#[Out]# 9        0
#[Out]# 10       0
#[Out]# 11       0
#[Out]# 12       0
#[Out]# 13       0
#[Out]# 14       0
#[Out]# 15       0
#[Out]# 16       0
#[Out]# 17       0
#[Out]# 18       0
#[Out]# 19       0
#[Out]# 20       0
#[Out]# 21       0
#[Out]# 22       0
#[Out]# 23       0
#[Out]# 24       0
#[Out]# 25       0
#[Out]# 26       0
#[Out]# 27       0
#[Out]# 28       0
#[Out]# 29       0
#[Out]# ...    ...
#[Out]# 12130  190
#[Out]# 12131  190
#[Out]# 12132  190
#[Out]# 12133  190
#[Out]# 12134  190
#[Out]# 12135  190
#[Out]# 12136  190
#[Out]# 12137  190
#[Out]# 12138  190
#[Out]# 12139  190
#[Out]# 12140  190
#[Out]# 12141  190
#[Out]# 12142  190
#[Out]# 12143  190
#[Out]# 12144  190
#[Out]# 12145  190
#[Out]# 12146  190
#[Out]# 12147  190
#[Out]# 12148  190
#[Out]# 12149  190
#[Out]# 12150  190
#[Out]# 12151  190
#[Out]# 12152  190
#[Out]# 12153  190
#[Out]# 12154  190
#[Out]# 12155  190
#[Out]# 12156  190
#[Out]# 12157  190
#[Out]# 12158  190
#[Out]# 12159  190
#[Out]# 
#[Out]# [12160 rows x 1 columns]
query3 = '''
    select cID
    from customer, store
    except
    select cID
    from customer c, store s, purchase p
    where c.cID = p.cID and p.sID = s.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer, store
    except
    select c.cID
    from customer c, store s, purchase p
    where c.cID = p.cID and p.sID = s.sID
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query3 = '''
    create view unbought as
        select cID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID
    
    select cID
    from purchase
    except
    unbought
'''

pd.read_sql_query(query3, conn)
query3 = '''
    create view unbought as
        select cID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID
    
    select cID
    from purchase
    except
    unbought
'''

pd.read_sql_query(query3, conn)
query3 = '''
    create view unbought as (
        select cID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select cID
    from purchase
    except
    unbought
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with unbought(cID) as (
        select cID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select cID
    from purchase
    except
    unbought
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with unbought(cID) as (
        select cID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select cID
    from purchase, unbought
    except
    unbought
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with unbought(cID) as (
        select cID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select cID
    from purchase, unbought
    except
    unbought.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with unbought(cID) as (
        select cID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select cID
    from purchase, unbought
    except
    select cID
    from unbought
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with unbought(cID) as (
        select cID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select p.cID
    from purchase, unbought
    except
    select cID
    from unbought
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with unbought(cID) as (
        select cID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select p.cID
    from purchase p, unbought
    except
    select cID
    from unbought
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
    with unbought(cID) as (
        select cID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select p.cID
    from purchase p
    except
    select cID
    from unbought
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
    with unbought(cID) as (
        select cID, sID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select p.cID
    from purchase p
    except
    select cID
    from unbought
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with unbought(cID, sID) as (
        select cID, sID
        from customer, store
        except
        select c.cID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select p.cID
    from purchase p
    except
    select cID
    from unbought
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with unbought(cID, sID) as (
        select cID, sID
        from customer, store
        except
        select c.cID, s.sID
        from customer c, store s, purchase p
        where c.cID = p.cID and p.sID = s.sID)
    
    select p.cID
    from purchase p
    except
    select cID
    from unbought
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    select sName
    from store s, purchase p
    where s.sID = p.sID and avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    select sName
    from store s, purchase p
    where s.sID = p.sID and avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    select sName
    from store s, purchase p
    where s.sID = p.sID and avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    select sName
    from store s, purchase p
    where s.sID = p.sID
    group by sName
    having avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    select sName
    from store s, purchase p
    where s.sID = p.sID
    group by sName
    having avg(quantity) > 4
    
    intersect
    
    select s1.sName
    from store s1, store s2
    where s1.id <> s2.id and s1.sName = s2.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
    select sName
    from store s, purchase p
    where s.sID = p.sID
    group by sName
    having avg(quantity) > 4
    
    intersect
    
    select s1.sName
    from store s1, store s2
    where s1.sID <> s2.sID and s1.sName = s2.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    select sName, pName
    from purchase pu, store s, product pr
    where pu.sID = s.sID and p.pID = pr.pID
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select sName, pName
    from purchase pu, store s, product pr
    where pu.sID = s.sID and p.pID = pr.pID
    group by product
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select sName, pName
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by product
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select sName, pName
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by pr
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select sName, pName
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by pName
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#           sName             pName
#[Out]# 0     Hoogvliet            Apples
#[Out]# 1         Jumbo           Bananas
#[Out]# 2        Sligro              Beef
#[Out]# 3         Jumbo             Bread
#[Out]# 4   Albert Hein           Carrots
#[Out]# 5          Coop       Cashew Nuts
#[Out]# 6   Albert Hein            Cheese
#[Out]# 7          Dirk              Coca
#[Out]# 8   Albert Hein            Coffee
#[Out]# 9          Coop         Cucumbers
#[Out]# 10        Jumbo            Donuts
#[Out]# 11    Hoogvliet              Eggs
#[Out]# 12    Hoogvliet             Fanta
#[Out]# 13         Dirk      Green Pepper
#[Out]# 14  Albert Hein  Hot Dog Sausages
#[Out]# 15        Jumbo           Ketchup
#[Out]# 16  Albert Hein           Lasanga
#[Out]# 17         Coop              Milk
#[Out]# 18         Coop        Mixed Nuts
#[Out]# 19         Lidl         Mushrooms
#[Out]# 20         Lidl            Onions
#[Out]# 21         Coop           Oranges
#[Out]# 22         Lidl             Pasta
#[Out]# 23    Hoogvliet             Pizza
#[Out]# 24         Coop          Potatoes
#[Out]# 25        Jumbo              Rice
#[Out]# 26        Jumbo            Salmon
#[Out]# 27         Coop   Spiced Biscuits
#[Out]# 28       Sligro               Tea
#[Out]# 29        Jumbo          Tomatoes
#[Out]# 30         Dirk             Water
query5 = '''
    select sName, pName
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by pName, sName
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#            sName            pName
#[Out]# 0    Albert Hein           Apples
#[Out]# 1           Coop           Apples
#[Out]# 2           Dirk           Apples
#[Out]# 3      Hoogvliet           Apples
#[Out]# 4          Jumbo           Apples
#[Out]# 5           Lidl           Apples
#[Out]# 6         Sligro           Apples
#[Out]# 7    Albert Hein          Bananas
#[Out]# 8           Coop          Bananas
#[Out]# 9           Dirk          Bananas
#[Out]# 10     Hoogvliet          Bananas
#[Out]# 11         Jumbo          Bananas
#[Out]# 12          Lidl          Bananas
#[Out]# 13        Sligro          Bananas
#[Out]# 14   Albert Hein             Beef
#[Out]# 15          Coop             Beef
#[Out]# 16          Dirk             Beef
#[Out]# 17     Hoogvliet             Beef
#[Out]# 18        Sligro             Beef
#[Out]# 19   Albert Hein            Bread
#[Out]# 20          Coop            Bread
#[Out]# 21          Dirk            Bread
#[Out]# 22     Hoogvliet            Bread
#[Out]# 23         Jumbo            Bread
#[Out]# 24          Lidl            Bread
#[Out]# 25        Sligro            Bread
#[Out]# 26   Albert Hein          Carrots
#[Out]# 27          Coop          Carrots
#[Out]# 28          Dirk          Carrots
#[Out]# 29     Hoogvliet          Carrots
#[Out]# ..           ...              ...
#[Out]# 155         Dirk             Rice
#[Out]# 156    Hoogvliet             Rice
#[Out]# 157        Jumbo             Rice
#[Out]# 158         Lidl             Rice
#[Out]# 159       Sligro             Rice
#[Out]# 160        Jumbo           Salmon
#[Out]# 161  Albert Hein  Spiced Biscuits
#[Out]# 162         Coop  Spiced Biscuits
#[Out]# 163    Hoogvliet  Spiced Biscuits
#[Out]# 164        Jumbo  Spiced Biscuits
#[Out]# 165         Lidl  Spiced Biscuits
#[Out]# 166  Albert Hein              Tea
#[Out]# 167         Coop              Tea
#[Out]# 168         Dirk              Tea
#[Out]# 169    Hoogvliet              Tea
#[Out]# 170        Jumbo              Tea
#[Out]# 171         Lidl              Tea
#[Out]# 172       Sligro              Tea
#[Out]# 173  Albert Hein         Tomatoes
#[Out]# 174         Coop         Tomatoes
#[Out]# 175    Hoogvliet         Tomatoes
#[Out]# 176        Jumbo         Tomatoes
#[Out]# 177         Lidl         Tomatoes
#[Out]# 178       Sligro         Tomatoes
#[Out]# 179  Albert Hein            Water
#[Out]# 180         Coop            Water
#[Out]# 181         Dirk            Water
#[Out]# 182    Hoogvliet            Water
#[Out]# 183        Jumbo            Water
#[Out]# 184       Sligro            Water
#[Out]# 
#[Out]# [185 rows x 2 columns]
query5 = '''
    select sName, pName
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by pName
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#           sName             pName
#[Out]# 0     Hoogvliet            Apples
#[Out]# 1         Jumbo           Bananas
#[Out]# 2        Sligro              Beef
#[Out]# 3         Jumbo             Bread
#[Out]# 4   Albert Hein           Carrots
#[Out]# 5          Coop       Cashew Nuts
#[Out]# 6   Albert Hein            Cheese
#[Out]# 7          Dirk              Coca
#[Out]# 8   Albert Hein            Coffee
#[Out]# 9          Coop         Cucumbers
#[Out]# 10        Jumbo            Donuts
#[Out]# 11    Hoogvliet              Eggs
#[Out]# 12    Hoogvliet             Fanta
#[Out]# 13         Dirk      Green Pepper
#[Out]# 14  Albert Hein  Hot Dog Sausages
#[Out]# 15        Jumbo           Ketchup
#[Out]# 16  Albert Hein           Lasanga
#[Out]# 17         Coop              Milk
#[Out]# 18         Coop        Mixed Nuts
#[Out]# 19         Lidl         Mushrooms
#[Out]# 20         Lidl            Onions
#[Out]# 21         Coop           Oranges
#[Out]# 22         Lidl             Pasta
#[Out]# 23    Hoogvliet             Pizza
#[Out]# 24         Coop          Potatoes
#[Out]# 25        Jumbo              Rice
#[Out]# 26        Jumbo            Salmon
#[Out]# 27         Coop   Spiced Biscuits
#[Out]# 28       Sligro               Tea
#[Out]# 29        Jumbo          Tomatoes
#[Out]# 30         Dirk             Water
query5 = '''
    select sName, pName
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by price
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#            sName         pName
#[Out]# 0      Hoogvliet         Water
#[Out]# 1         Sligro         Water
#[Out]# 2    Albert Hein     Mushrooms
#[Out]# 3           Lidl     Mushrooms
#[Out]# 4           Coop         Water
#[Out]# 5          Jumbo       Lasanga
#[Out]# 6      Hoogvliet      Tomatoes
#[Out]# 7           Dirk      Potatoes
#[Out]# 8           Lidl          Milk
#[Out]# 9           Coop        Onions
#[Out]# 10          Lidl          Milk
#[Out]# 11          Coop       Carrots
#[Out]# 12          Coop     Cucumbers
#[Out]# 13          Coop       Carrots
#[Out]# 14          Coop        Onions
#[Out]# 15          Lidl       Carrots
#[Out]# 16        Sligro  Green Pepper
#[Out]# 17     Hoogvliet       Bananas
#[Out]# 18     Hoogvliet       Bananas
#[Out]# 19        Sligro       Bananas
#[Out]# 20          Coop          Rice
#[Out]# 21        Sligro       Bananas
#[Out]# 22        Sligro           Tea
#[Out]# 23          Coop           Tea
#[Out]# 24        Sligro          Rice
#[Out]# 25     Hoogvliet       Bananas
#[Out]# 26          Lidl      Potatoes
#[Out]# 27        Sligro       Bananas
#[Out]# 28          Coop      Tomatoes
#[Out]# 29          Coop          Rice
#[Out]# ..           ...           ...
#[Out]# 125         Coop         Pizza
#[Out]# 126        Jumbo         Pizza
#[Out]# 127         Lidl         Pizza
#[Out]# 128    Hoogvliet         Pizza
#[Out]# 129         Coop       Lasanga
#[Out]# 130         Lidl       Lasanga
#[Out]# 131         Coop        Cheese
#[Out]# 132         Dirk       Lasanga
#[Out]# 133  Albert Hein       Lasanga
#[Out]# 134         Coop          Beef
#[Out]# 135         Coop        Cheese
#[Out]# 136       Sligro        Cheese
#[Out]# 137         Coop        Cheese
#[Out]# 138  Albert Hein          Beef
#[Out]# 139         Coop          Beef
#[Out]# 140         Dirk          Beef
#[Out]# 141  Albert Hein        Cheese
#[Out]# 142         Dirk          Beef
#[Out]# 143  Albert Hein        Cheese
#[Out]# 144    Hoogvliet          Beef
#[Out]# 145    Hoogvliet          Beef
#[Out]# 146         Dirk          Beef
#[Out]# 147       Sligro          Beef
#[Out]# 148         Dirk          Beef
#[Out]# 149  Albert Hein          Beef
#[Out]# 150  Albert Hein          Beef
#[Out]# 151       Sligro          Beef
#[Out]# 152         Coop          Beef
#[Out]# 153       Sligro          Beef
#[Out]# 154       Sligro          Beef
#[Out]# 
#[Out]# [155 rows x 2 columns]
query5 = '''
    select sName, pName
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by sName
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#          sName    pName
#[Out]# 0  Albert Hein     Beef
#[Out]# 1         Coop     Beef
#[Out]# 2         Dirk     Beef
#[Out]# 3    Hoogvliet     Beef
#[Out]# 4        Jumbo    Pizza
#[Out]# 5         Lidl  Lasanga
#[Out]# 6       Sligro     Beef
query5 = '''
    select sName, pName, price
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by sName
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#          sName    pName  price
#[Out]# 0  Albert Hein     Beef  13.25
#[Out]# 1         Coop     Beef  13.60
#[Out]# 2         Dirk     Beef  12.80
#[Out]# 3    Hoogvliet     Beef  12.30
#[Out]# 4        Jumbo    Pizza   9.05
#[Out]# 5         Lidl  Lasanga   9.60
#[Out]# 6       Sligro     Beef  13.80
query5 = '''
    select sName, pName, price
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by 
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select sName, pName, price
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID and pu.price = max(price)
    
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select sName, pName, price
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by 
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select sName, pName, price
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by sName
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#          sName    pName  price
#[Out]# 0  Albert Hein     Beef  13.25
#[Out]# 1         Coop     Beef  13.60
#[Out]# 2         Dirk     Beef  12.80
#[Out]# 3    Hoogvliet     Beef  12.30
#[Out]# 4        Jumbo    Pizza   9.05
#[Out]# 5         Lidl  Lasanga   9.60
#[Out]# 6       Sligro     Beef  13.80
query5 = '''
    select sName, pName
    from purchase pu, store s, product pr
    where pu.sID = s.sID and pu.pID = pr.pID
    group by sName
    having pu.price = max(price)
'''

pd.read_sql_query(query5, conn)
#[Out]#          sName    pName
#[Out]# 0  Albert Hein     Beef
#[Out]# 1         Coop     Beef
#[Out]# 2         Dirk     Beef
#[Out]# 3    Hoogvliet     Beef
#[Out]# 4        Jumbo    Pizza
#[Out]# 5         Lidl  Lasanga
#[Out]# 6       Sligro     Beef
query5 = '''
    with max_price(price) as (
    select max(price)
    from purchase)

    select sName, pName
    from purchase pu, store s, product pr, max_price
    where pu.sID = s.sID and pu.pID = pr.pID and pu.price = max_price.price
'''

pd.read_sql_query(query5, conn)
#[Out]#     sName pName
#[Out]# 0  Sligro  Beef
query6 = '''
    with stock(pID, unit_price) as (
    select pID, unit_price
    from inventory
    where date = '2018-08-23')
    
    select max(max(i1.price) - min(i2.price))
    from stock i1, stock i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with stock(pID, unit_price) as (
    select pID, unit_price
    from inventory
    where date = '2018-08-23')
    
    select max(max(i1.unit_price) - min(i2.unit_price))
    from stock i1, stock i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with stock(pID, unit_price) as (
    select pID, unit_price
    from inventory
    where date = '2018-08-23')
    
    select max(i1.unit_price) - min(i2.unit_price)
    from stock i1, stock i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price) - min(i2.unit_price)
#[Out]# 0                                    12.95
query6 = '''
    with stock(pID, unit_price) as (
    select pID, unit_price
    from inventory
    where date = '2018-08-23')
    
    select pID, max(i1.unit_price) - min(i2.unit_price)
    from stock i1, stock i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with stock(pID, unit_price) as (
    select pID, unit_price
    from inventory
    where date = '2018-08-23')
    
    select i1pID, max(i1.unit_price) - min(i2.unit_price)
    from stock i1, stock i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with stock(pID, unit_price) as (
    select pID, unit_price
    from inventory
    where date = '2018-08-23')
    
    select i1.pID, max(i1.unit_price) - min(i2.unit_price)
    from stock i1, stock i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    i1.pID  max(i1.unit_price) - min(i2.unit_price)
#[Out]# 0      10                                    12.95
query6 = '''
    with stock(pID, unit_price) as (
    select pID, unit_price
    from inventory
    where date = '2018-08-23')
    
    select i1.pID, max(i1.unit_price) - min(i2.unit_price)
    from stock i1, stock i2
'''

pd.read_sql_query(query6, conn)
#[Out]#    i1.pID  max(i1.unit_price) - min(i2.unit_price)
#[Out]# 0      10                                    12.95
query6 = '''
    with differences(pID, unit_price) as (
    select max(i1.unit_price) - min(i2.unit_price)
    from inventory i1, inventory i2
    where i1.date = '2018-08-23' and i1.date = i2.date and i1.sID = i2.sID and i1.pID = i2.pID)
    
    select max(i1.unit_price) - min(i2.unit_price)
    from differences d1, differences d2
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with differences(value) as (
    select max(i1.unit_price) - min(i2.unit_price)
    from inventory i1, inventory i2
    where i1.date = '2018-08-23' and i1.date = i2.date and i1.sID = i2.sID and i1.pID = i2.pID)
    
    select max(i1.unit_price) - min(i2.unit_price)
    from differences d1, differences d2
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with differences(value) as (
    select max(i1.unit_price) - min(i2.unit_price)
    from inventory i1, inventory i2
    where i1.date = '2018-08-23' and i1.date = i2.date and i1.sID = i2.sID and i1.pID = i2.pID)
    
    select max(d1.value) - min(d2.value)
    from differences d1, differences d2
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(d1.value) - min(d2.value)
#[Out]# 0                            0.0
query6 = '''
    with differences(value) as (
    select max(i1.unit_price) - min(i2.unit_price)
    from inventory i1, inventory i2
    where i1.date = '2018-08-23' and i1.date = i2.date and i1.sID = i2.sID and i1.pID = i2.pID)
    
    select max(d1.value - d2.value)
    from differences d1, differences d2
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(d1.value - d2.value)
#[Out]# 0                       0.0
query6 = '''
    with differences(value) as (
    select max(abs(i1.unit_price - i2.unit_price))
    from inventory i1, inventory i2
    where i1.date = '2018-08-23' and i1.date = i2.date and i1.sID = i2.sID and i1.pID = i2.pID)
    
    select max(d1.value - d2.value)
    from differences d1, differences d2
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(d1.value - d2.value)
#[Out]# 0                       0.0
query6 = '''
    with differences(value) as (
    select max(abs(i1.unit_price - i2.unit_price))
    from inventory i1, inventory i2
    where i1.date = '2018-08-23' and i1.date = i2.date and i1.sID <> i2.sID and i1.pID = i2.pID)
    
    select max(d1.value - d2.value)
    from differences d1, differences d2
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(d1.value - d2.value)
#[Out]# 0                       0.0
query6 = '''
    select max(abs(i1.unit_price - i2.unit_price))
    from inventory i1, inventory i2
    where i1.date = '2018-08-23' and i1.date = i2.date and i1.sID <> i2.sID and i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                      2.0
