# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x111a7c0a0>
query1 = '''
    SELECT p.pID FROM purchase p, q WHERE p.pID == q.pID AND p.cID != q.cID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID FROM purchase AS p, q WHERE p.pID == q.pID AND p.cID != q.cID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID FROM purchase p, purchase q WHERE p.pID == q.pID AND p.cID != q.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#       pID
#[Out]# 0      10
#[Out]# 1      10
#[Out]# 2      10
#[Out]# 3      10
#[Out]# 4      10
#[Out]# 5      10
#[Out]# 6      10
#[Out]# 7      10
#[Out]# 8      10
#[Out]# 9      10
#[Out]# 10     10
#[Out]# 11     10
#[Out]# 12     10
#[Out]# 13     10
#[Out]# 14     10
#[Out]# 15     14
#[Out]# 16     14
#[Out]# 17     14
#[Out]# 18     14
#[Out]# 19     14
#[Out]# 20     14
#[Out]# 21     14
#[Out]# 22     14
#[Out]# 23     14
#[Out]# 24     14
#[Out]# 25     14
#[Out]# 26     14
#[Out]# 27     14
#[Out]# 28     14
#[Out]# 29     14
#[Out]# ...   ...
#[Out]# 8594   19
#[Out]# 8595   19
#[Out]# 8596   19
#[Out]# 8597   19
#[Out]# 8598    9
#[Out]# 8599    9
#[Out]# 8600    9
#[Out]# 8601    9
#[Out]# 8602    9
#[Out]# 8603    9
#[Out]# 8604    9
#[Out]# 8605    9
#[Out]# 8606    9
#[Out]# 8607    9
#[Out]# 8608    9
#[Out]# 8609    9
#[Out]# 8610    9
#[Out]# 8611    9
#[Out]# 8612    9
#[Out]# 8613    9
#[Out]# 8614    9
#[Out]# 8615   18
#[Out]# 8616   18
#[Out]# 8617   18
#[Out]# 8618   18
#[Out]# 8619   18
#[Out]# 8620   18
#[Out]# 8621   18
#[Out]# 8622   18
#[Out]# 8623   18
#[Out]# 
#[Out]# [8624 rows x 1 columns]
query1 = '''
    SELECT pID FROM purchase EXCEPT
        SELECT p1.pID FROM purchase p1, purchase p2, purchase p3 
        WHERE p1.pID == p2.pID AND p1.pID == p3.pID AND p1.cID != p2.cID
        AND p1.cID != p3.cID AND p2.cID != p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT c.cID, c.cName FROM customer c, purchase prc1, purchase prc2, product prd1, product prd2 
    WHERE prc1.pID == prd1.PID AND prc2.pID = prd2.pID AND prc1.cID == c.cID AND prc1.date == prc2.date
    AND prd1.pName == "Onions" AND prd2.pName == "Coffee"
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID    cName
#[Out]# 0    29    Ruben
#[Out]# 1    31  Olivier
#[Out]# 2    33     Sven
#[Out]# 3    33     Sven
#[Out]# 4    33     Sven
#[Out]# 5    52   Willem
#[Out]# 6    52   Willem
#[Out]# 7    52   Willem
#[Out]# 8    59     Joep
#[Out]# 9    59     Joep
#[Out]# 10   59     Joep
#[Out]# 11   85   Pieter
#[Out]# 12   85   Pieter
#[Out]# 13   85   Pieter
#[Out]# 14  124    Sofie
#[Out]# 15  124    Sofie
#[Out]# 16  124    Sofie
#[Out]# 17  129    Esmee
#[Out]# 18  169     Lily
#[Out]# 19  169     Lily
#[Out]# 20  169     Lily
#[Out]# 21  169     Lily
#[Out]# 22  172     Lana
#[Out]# 23  176    Amira
#[Out]# 24  176    Amira
#[Out]# 25  176    Amira
#[Out]# 26  177    Eline
#[Out]# 27  177    Eline
#[Out]# 28  177    Eline
#[Out]# 29  190   Kostas
#[Out]# 30  190   Kostas
#[Out]# 31  190   Kostas
query2 = '''
    SELECT c.cID, c.cName FROM customer c, purchase prc1, purchase prc2, product prd1, product prd2 
    WHERE prc1.pID == prd1.PID AND prc2.pID = prd2.pID AND prc1.cID == c.cID AND prc2.cID == c.cID
    AND prc1.date == prc2.date AND prd1.pName == "Onions" AND prd2.pName == "Coffee"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    SELECT c.cID, c.cName FROM customer c, purchase prc1, purchase prc2, product prd1, product prd2 
    WHERE prc1.pID == prd1.pID AND prc2.pID = prd2.pID AND prc1.cID == c.cID AND prc2.cID == c.cID
    AND prc1.date == prc2.date AND prd1.pName == "Onions" AND prd2.pName == "Coffee"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    SELECT c.cID, c.cName FROM customer c, purchase prc1, purchase prc2, product prd1, product prd2 
    WHERE prc1.date == prc2.date AND prc1.cID == c.cID AND prc2.cID == c.cID
    AND prc1.pID == prd1.pID AND prc2.pID = prd2.pID
    AND prd1.pName == "Onions" AND prd2.pName == "Coffee"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT cID FROM customer EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.sID != p2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query3 = '''
    SELECT cID FROM customer EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.cID != p2.cID AND p1.sID != p2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query3 = '''
    SELECT cID FROM purchase EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.cID != p2.cID AND p1.sID != p2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID FROM purchase EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.cID != p2.cID AND p2.sID != p1.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID FROM purchase EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.cID == p2.cID AND p1.sID != p2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     0
#[Out]# 1    10
#[Out]# 2    11
#[Out]# 3    15
#[Out]# 4    25
#[Out]# 5    26
#[Out]# 6    28
#[Out]# 7    34
#[Out]# 8    47
#[Out]# 9    63
#[Out]# 10   69
#[Out]# 11   76
#[Out]# 12   77
#[Out]# 13   80
#[Out]# 14   84
#[Out]# 15   88
#[Out]# 16   90
#[Out]# 17   99
#[Out]# 18  103
#[Out]# 19  104
#[Out]# 20  111
#[Out]# 21  128
#[Out]# 22  131
#[Out]# 23  135
#[Out]# 24  136
#[Out]# 25  137
#[Out]# 26  145
#[Out]# 27  168
#[Out]# 28  184
#[Out]# 29  185
#[Out]# 30  186
#[Out]# 31  188
query3 = '''
    SELECT cID FROM purchase EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.cID != p2.cID AND p1.sID NOT IN p2.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT cID FROM purchase EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.sID NOT IN (p2.sID) AND p1.cID != p2.cID 
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID FROM purchase EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.cID != p2.cID 
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID FROM purchase EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.cID != p2.cID 
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID FROM purchase EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.cID != p2.cID AND p1.sID == p2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID FROM purchase EXCEPT
        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.sID != p2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''

        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.sID != p2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]#         cID
#[Out]# 0         0
#[Out]# 1         0
#[Out]# 2         0
#[Out]# 3         0
#[Out]# 4         0
#[Out]# 5         0
#[Out]# 6         0
#[Out]# 7         0
#[Out]# 8         0
#[Out]# 9         0
#[Out]# 10        0
#[Out]# 11        0
#[Out]# 12        0
#[Out]# 13        0
#[Out]# 14        0
#[Out]# 15        0
#[Out]# 16        0
#[Out]# 17        0
#[Out]# 18        0
#[Out]# 19        0
#[Out]# 20        0
#[Out]# 21        0
#[Out]# 22        0
#[Out]# 23        0
#[Out]# 24        0
#[Out]# 25        0
#[Out]# 26        0
#[Out]# 27        0
#[Out]# 28        0
#[Out]# 29        0
#[Out]# ...     ...
#[Out]# 254376  190
#[Out]# 254377  190
#[Out]# 254378  190
#[Out]# 254379  190
#[Out]# 254380  190
#[Out]# 254381  190
#[Out]# 254382  190
#[Out]# 254383  190
#[Out]# 254384  190
#[Out]# 254385  190
#[Out]# 254386  190
#[Out]# 254387  190
#[Out]# 254388  190
#[Out]# 254389  190
#[Out]# 254390  190
#[Out]# 254391  190
#[Out]# 254392  190
#[Out]# 254393  190
#[Out]# 254394  190
#[Out]# 254395  190
#[Out]# 254396  190
#[Out]# 254397  190
#[Out]# 254398  190
#[Out]# 254399  190
#[Out]# 254400  190
#[Out]# 254401  190
#[Out]# 254402  190
#[Out]# 254403  190
#[Out]# 254404  190
#[Out]# 254405  190
#[Out]# 
#[Out]# [254406 rows x 1 columns]
query3 = '''

        SELECT p1.cID FROM purchase p1, purchase p2 WHERE p1.cID == p2.cID AND p1.sID != p2.sID
'''

pd.read_sql_query(query3, conn)
#[Out]#       cID
#[Out]# 0       1
#[Out]# 1       1
#[Out]# 2       1
#[Out]# 3       1
#[Out]# 4       1
#[Out]# 5       1
#[Out]# 6       1
#[Out]# 7       1
#[Out]# 8       1
#[Out]# 9       1
#[Out]# 10      1
#[Out]# 11      1
#[Out]# 12      1
#[Out]# 13      1
#[Out]# 14      1
#[Out]# 15      1
#[Out]# 16      1
#[Out]# 17      1
#[Out]# 18      1
#[Out]# 19      1
#[Out]# 20      1
#[Out]# 21      1
#[Out]# 22      1
#[Out]# 23      1
#[Out]# 24      1
#[Out]# 25      1
#[Out]# 26      1
#[Out]# 27      1
#[Out]# 28      1
#[Out]# 29      1
#[Out]# ...   ...
#[Out]# 5880  190
#[Out]# 5881  190
#[Out]# 5882  190
#[Out]# 5883  190
#[Out]# 5884  190
#[Out]# 5885  190
#[Out]# 5886  190
#[Out]# 5887  190
#[Out]# 5888  190
#[Out]# 5889  190
#[Out]# 5890  190
#[Out]# 5891  190
#[Out]# 5892  190
#[Out]# 5893  190
#[Out]# 5894  190
#[Out]# 5895  190
#[Out]# 5896  190
#[Out]# 5897  190
#[Out]# 5898  190
#[Out]# 5899  190
#[Out]# 5900  190
#[Out]# 5901  190
#[Out]# 5902  190
#[Out]# 5903  190
#[Out]# 5904  190
#[Out]# 5905  190
#[Out]# 5906  190
#[Out]# 5907  190
#[Out]# 5908  190
#[Out]# 5909  190
#[Out]# 
#[Out]# [5910 rows x 1 columns]
query3 = '''

        SELECT cID FROM purchase GROUP BY cID HAVING max(count(*))
'''

pd.read_sql_query(query3, conn)
query3 = '''

        SELECT cID FROM purchase GROUP BY cID HAVING max(count(sID))
'''

pd.read_sql_query(query3, conn)
query1 = '''
    SELECT pID FROM purchase GROUP BY pID WHERE count(cID) <= 2
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID FROM purchase GROUP BY pID HAVING count(cID) <= 2
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query3 = '''
        WITH number_of_stores as (
            SELECT count(distinct sID) FROM purchase)
        SELECT cID FROM purchase GROUP BY cID HAVING count(distinct sID) == max(number_of_stores)
'''

pd.read_sql_query(query3, conn)
query3 = '''
        WITH number_of_stores(value) as (
            SELECT count(distinct sID) FROM purchase)
        SELECT cID FROM purchase, number_of_stores GROUP BY cID HAVING count(distinct sID) == max(number_of_stores.value)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
        WITH number_of_stores(value) as (
            SELECT count(distinct sID) FROM purchase)
        SELECT cID FROM purchase, number_of_stores GROUP BY cID HAVING count(distinct sID) == number_of_stores.value
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT s.sName FROM store s, purchase p WHERE s.sID == p.pID GROUP BY s.sName HAVING avg(p.quantity > 4) AND count(s.sID >= 2)
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s.sName FROM store s, purchase p WHERE s.sID == p.pID GROUP BY s.sName HAVING avg(p.quantity) > 4 AND count(s.sID >= 2)
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s.sName FROM store s, purchase p WHERE s.sID == p.pID GROUP BY s.sName HAVING avg(p.quantity) > 4 AND count(s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s.sName FROM store s, purchase p WHERE s.sID == p.sID 
    GROUP BY s.sName HAVING avg(p.quantity) > 4 AND count(s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT prd.pName, s.sName FROM purchase prc, product prd, store s WHERE prc.pID == prd.pID AND prc.sID == s.sID
    GROUP BY prc.pID HAVING prc.price == max(prc.price)
'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts         Coop
#[Out]# 2           Potatoes         Coop
#[Out]# 3       Green Pepper         Dirk
#[Out]# 4             Onions         Lidl
#[Out]# 5          Mushrooms         Lidl
#[Out]# 6            Carrots  Albert Hein
#[Out]# 7           Tomatoes        Jumbo
#[Out]# 8   Hot Dog Sausages  Albert Hein
#[Out]# 9            Bananas        Jumbo
#[Out]# 10             Water         Dirk
#[Out]# 11              Milk         Coop
#[Out]# 12              Beef       Sligro
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples    Hoogvliet
#[Out]# 15         Cucumbers         Coop
#[Out]# 16              Rice        Jumbo
#[Out]# 17             Bread        Jumbo
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca         Dirk
#[Out]# 20             Fanta    Hoogvliet
#[Out]# 21            Coffee  Albert Hein
#[Out]# 22               Tea       Sligro
#[Out]# 23   Spiced Biscuits         Coop
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza    Hoogvliet
#[Out]# 28           Lasanga  Albert Hein
#[Out]# 29            Salmon        Jumbo
#[Out]# 30           Ketchup        Jumbo
query5 = '''
    SELECT prd.pName, s.sName FROM purchase prc, product prd, store s WHERE prc.pID == prd.pID AND prc.sID == s.sID AND prc.price == max(prc.price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT prd.pName, s.sName FROM purchase prc, product prd, store s WHERE prc.pID == prd.pID AND prc.sID == s.sID
    GROUP BY prc.tID HAVING prc.price == max(prc.price)
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 474           Lasanga         Coop
#[Out]# 475             Pizza         Lidl
#[Out]# 476         Mushrooms         Lidl
#[Out]# 477           Lasanga        Jumbo
#[Out]# 478          Tomatoes    Hoogvliet
#[Out]# 479       Cashew Nuts       Sligro
#[Out]# 480              Milk    Hoogvliet
#[Out]# 481           Carrots  Albert Hein
#[Out]# 482              Coca       Sligro
#[Out]# 483             Bread         Coop
#[Out]# 484           Bananas  Albert Hein
#[Out]# 485              Milk         Coop
#[Out]# 486               Tea         Lidl
#[Out]# 487             Bread         Coop
#[Out]# 488             Fanta    Hoogvliet
#[Out]# 489              Milk    Hoogvliet
#[Out]# 490            Coffee       Sligro
#[Out]# 491   Spiced Biscuits         Coop
#[Out]# 492   Spiced Biscuits         Lidl
#[Out]# 493  Hot Dog Sausages         Coop
#[Out]# 494       Cashew Nuts         Dirk
#[Out]# 495  Hot Dog Sausages         Coop
#[Out]# 496              Milk        Jumbo
#[Out]# 497         Cucumbers         Dirk
#[Out]# 498          Potatoes         Dirk
#[Out]# 499             Bread        Jumbo
#[Out]# 500         Mushrooms         Lidl
#[Out]# 501              Coca         Lidl
#[Out]# 502           Bananas        Jumbo
#[Out]# 503            Cheese        Jumbo
#[Out]# 
#[Out]# [504 rows x 2 columns]
query5 = '''
    SELECT prd.pName, s.sName FROM purchase prc, product prd, store s WHERE prc.pID == prd.pID AND prc.sID == s.sID
    GROUP BY prc.tID HAVING max(prc.price)
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 474           Lasanga         Coop
#[Out]# 475             Pizza         Lidl
#[Out]# 476         Mushrooms         Lidl
#[Out]# 477           Lasanga        Jumbo
#[Out]# 478          Tomatoes    Hoogvliet
#[Out]# 479       Cashew Nuts       Sligro
#[Out]# 480              Milk    Hoogvliet
#[Out]# 481           Carrots  Albert Hein
#[Out]# 482              Coca       Sligro
#[Out]# 483             Bread         Coop
#[Out]# 484           Bananas  Albert Hein
#[Out]# 485              Milk         Coop
#[Out]# 486               Tea         Lidl
#[Out]# 487             Bread         Coop
#[Out]# 488             Fanta    Hoogvliet
#[Out]# 489              Milk    Hoogvliet
#[Out]# 490            Coffee       Sligro
#[Out]# 491   Spiced Biscuits         Coop
#[Out]# 492   Spiced Biscuits         Lidl
#[Out]# 493  Hot Dog Sausages         Coop
#[Out]# 494       Cashew Nuts         Dirk
#[Out]# 495  Hot Dog Sausages         Coop
#[Out]# 496              Milk        Jumbo
#[Out]# 497         Cucumbers         Dirk
#[Out]# 498          Potatoes         Dirk
#[Out]# 499             Bread        Jumbo
#[Out]# 500         Mushrooms         Lidl
#[Out]# 501              Coca         Lidl
#[Out]# 502           Bananas        Jumbo
#[Out]# 503            Cheese        Jumbo
#[Out]# 
#[Out]# [504 rows x 2 columns]
query4 = '''
    SELECT s.sName FROM store s, purchase p WHERE s.sID == p.sID 
    GROUP BY s.sName HAVING avg(p.quantity) > 4 AND count(s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    WITH maximum_price(value) AS (
        SELECT max(price) FROM purchase)
    SELECT prd.pName, s.sName FROM purchase prc, product prd, store s WHERE prc.pID == prd.pID AND prc.sID == s.sID
    GROUP BY prc.pID HAVING prc.price == maximum_price.value
'''

pd.read_sql_query(query5, conn)
query5 = '''
    WITH maximum_price(value) AS (
        SELECT max(price) FROM purchase)
    SELECT prd.pName, s.sName FROM purchase prc, product prd, store s, maximum_price 
    WHERE prc.pID == prd.pID AND prc.sID == s.sID
    GROUP BY prc.pID HAVING prc.price == maximum_price.value
'''

pd.read_sql_query(query5, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName, sName]
#[Out]# Index: []
query5 = '''
    WITH maximum_price(value) AS (
        SELECT max(price) FROM purchase)
    SELECT prd.pName, s.sName FROM purchase prc, product prd, store s, maximum_price 
    WHERE prc.pID == prd.pID AND prc.sID == s.sID AND prc.price == maximum_price.value
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT max(p1.price) - min(p2.price) FROM purchase p1, purchase p2 
    WHERE p1.pID == p2.pID AND p1.date == "2018-08-23" AND p2.date == "2018-08-23"
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(p1.price) - min(p2.price)
#[Out]# 0                           12.8
query6 = '''
    SELECT max(p1.price) - min(p2.price) FROM purchase p1, purchase p2 
    WHERE p1.pID == p2.pID AND p1.date == "2018-08-23" AND p2.date == "2018-08-23" AND p1.sID != p2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(p1.price) - min(p2.price)
#[Out]# 0                           12.8
query6 = '''
    SELECT max(p1.price - p2.price) FROM purchase p1, purchase p2 
    WHERE p1.pID == p2.pID AND p1.date == "2018-08-23" AND p2.date == "2018-08-23" AND p1.sID != p2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(p1.price - p2.price)
#[Out]# 0                       8.4
query6 = '''
    SELECT max(i1.unit_price) - min(i2.unit_price) FROM inventory i1, inventory i2 
    WHERE i1.pID == i2.pID AND i1.date == "2018-08-23" AND i2.date == "2018-08-23" AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price) - min(i2.unit_price)
#[Out]# 0                                    12.95
query6 = '''
    SELECT max(i1.unit_price - i2.unit_price) FROM inventory i1, inventory i2 
    WHERE i1.pID == i2.pID AND i1.date == "2018-08-23" AND i2.date == "2018-08-23" AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT max(i1.unit_price) - min(i2.unit_price) FROM inventory i1, inventory i2 
    WHERE i1.pID == i2.pID AND i1.date == "2018-08-23" AND i2.date == "2018-08-23" AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price) - min(i2.unit_price)
#[Out]# 0                                    12.95
query6 = '''
    SELECT max(i1.unit_price) - min(i2.unit_price), i1.sID, i1.pID FROM inventory i1, inventory i2 
    WHERE i1.pID == i2.pID AND i1.date == "2018-08-23" AND i2.date == "2018-08-23" AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price) - min(i2.unit_price)  sID  pID
#[Out]# 0                                    12.95   51   10
query6 = '''
    SELECT max(i1.unit_price) - min(i2.unit_price), i1.sID, i1.pID, i2.sID FROM inventory i1, inventory i2 
    WHERE i1.pID == i2.pID AND i1.date == "2018-08-23" AND i2.date == "2018-08-23" AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price) - min(i2.unit_price)  sID  pID  sID
#[Out]# 0                                    12.95   51   10   34
query6 = '''
    SELECT max(i1.unit_price) - min(i2.unit_price), i1.sID, i1.pID, i2.sID, i2.pID FROM inventory i1, inventory i2 
    WHERE i1.pID == i2.pID AND i1.date == "2018-08-23" AND i2.date == "2018-08-23" AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price) - min(i2.unit_price)  sID  pID  sID  pID
#[Out]# 0                                    12.95   51   10   34   10
query6 = '''
    SELECT max(i1.unit_price), i1.sID, i1.pID, i2.sID, i2.pID FROM inventory i1, inventory i2 
    WHERE i1.pID == i2.pID AND i1.date == "2018-08-23" AND i2.date == "2018-08-23" AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price)  sID  pID  sID  pID
#[Out]# 0                13.4    5   12    9   12
query6 = '''
    SELECT max(i1.unit_price - i2.unit_price), i1.sID, i1.pID, i2.sID, i2.pID FROM inventory i1, inventory i2 
    WHERE i1.pID == i2.pID AND i1.date == "2018-08-23" AND i2.date == "2018-08-23" AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price - i2.unit_price)  sID  pID  sID  pID
#[Out]# 0                                 2.0    5   12   42   12
query6 = '''
    SELECT max(i1.unit_price - i2.unit_price) FROM inventory i1, inventory i2 
    WHERE i1.pID == i2.pID AND i1.date == "2018-08-23" AND i2.date == "2018-08-23" AND i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query2 = '''
    SELECT c.cID, c.cName FROM customer c, purchase prc1, purchase prc2, product prd1, product prd2 WHERE prc1.date == prc2.date AND prc1.cID == c.cID AND prc2.cID == c.cID AND prc1.pID == prd1.pID AND prc2.pID = prd2.pID AND prd1.pName == "Onions" AND prd2.pName == "Coffee"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
        WITH number_of_stores(value) as (SELECT count(distinct sID) FROM purchase) SELECT cID FROM purchase, number_of_stores GROUP BY cID HAVING count(distinct sID) == number_of_stores.value
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT s.sName FROM store s, purchase p WHERE s.sID == p.sID GROUP BY s.sName HAVING avg(p.quantity) > 4 AND count(s.sID) >= 2
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    WITH maximum_price(value) AS (SELECT max(price) FROM purchase) SELECT prd.pName, s.sName FROM purchase prc, product prd, store s, maximum_price WHERE prc.pID == prd.pID AND prc.sID == s.sID AND prc.price == maximum_price.value
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
