# IPython log file

get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor object at 0x0000026782611F80>
query1 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query1, conn)
query1 = 
'
select pID
from product
where pID not in
    (select p1.pId 
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    and p1.cID <> p2.cID)
'

# Step 1: first select products that were bought by more than 2 customers. 
# Done via select 2 purchase tables, same productID but 2 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
query1 = 

select pID
from product
where pID not in
    (select p1.pId 
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    and p1.cID <> p2.cID)


# Step 1: first select products that were bought by more than 2 customers. 
# Done via select 2 purchase tables, same productID but 2 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
query1 = '''

select pID
from product
where pID not in
    (select p1.pId 
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    and p1.cID <> p2.cID)
'''

# Step 1: first select products that were bought by more than 2 customers. 
# Done via select 2 purchase tables, same productID but 2 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   30
#[Out]# 1   31
query1 = '''

select pur.pID, pur.tID, pur.cID,pur.date
from puchase pur 
where 
and pur.pID not in
    (select p1.pId 
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    and p1.cID <> p2.cID)
'''

# Step 1: first select products that were bought by more than 3 customers. 
# Done via select 2 purchase tables, same productID but 2 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
query1 = '''

select pur.pID, pur.tID, pur.cID,pur.date
from puchase pur 
where pur.pID not in
    (select p1.pId 
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    and p1.cID <> p2.cID)
'''

# Step 1: first select products that were bought by more than 3 customers. 
# Done via select 2 purchase tables, same productID but 2 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
query1 = '''

select pur.pID, pur.tID, pur.cID,pur.date
from purchase pur 
where pur.pID not in
    (select p1.pId 
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    and p1.cID <> p2.cID)
'''

# Step 1: first select products that were bought by more than 3 customers. 
# Done via select 2 purchase tables, same productID but 2 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#    pID  tID  cID        date
#[Out]# 0   30  780  188  2018-08-20
#[Out]# 1   30  781  188  2018-09-20
query1 = '''

select pur.pID, pur.tID, pur.cID,pur.date
from purchase pur 
where pur.pID not in
    (select p1.pId 
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID)
'''

# Step 1: first select products that were bought by more than 3 customers. 
# Done via select 2 purchase tables, same productID but 2 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#    pID  tID  cID        date
#[Out]# 0   30  780  188  2018-08-20
#[Out]# 1   30  781  188  2018-09-20
query1 = '''

select pID
from product
where pur.pID not in
    (select p1.pId 
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID)
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
query1 = 

# select pID
# from product
# where pur.pID not in
#     ('''
    select top 1000
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
query1 = 

# select pID
# from product
# where pur.pID not in
#     (
'''
    select top 1000
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
query1 = 

# select pID
# from product
# where pur.pID not in
#     (
'''
    select top 1000 *
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
query1 = 


'''
    select top 1000 *
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
query1 = 
'''  select top 1000 *
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
query1 = '''select top 1000 *
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
query1 = '''select top 1000 p1.pID, p1.cID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
query1 = '''select p1.pID, p1.cID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
#[Out]#         pID  cID
#[Out]# 0        10    0
#[Out]# 1        10    0
#[Out]# 2        10    0
#[Out]# 3        10    0
#[Out]# 4        10    0
#[Out]# 5        10    0
#[Out]# 6        10    0
#[Out]# 7        10    0
#[Out]# 8        10    0
#[Out]# 9        10    0
#[Out]# 10       10    0
#[Out]# 11       10    0
#[Out]# 12       10    0
#[Out]# 13       10    0
#[Out]# 14       10    0
#[Out]# 15       10    0
#[Out]# 16       10    0
#[Out]# 17       10    0
#[Out]# 18       10    0
#[Out]# 19       10    0
#[Out]# 20       10    0
#[Out]# 21       10    0
#[Out]# 22       10    0
#[Out]# 23       10    0
#[Out]# 24       10    0
#[Out]# 25       10    0
#[Out]# 26       10    0
#[Out]# 27       10    0
#[Out]# 28       10    0
#[Out]# 29       10    0
#[Out]# ...     ...  ...
#[Out]# 155754   18  190
#[Out]# 155755   18  190
#[Out]# 155756   18  190
#[Out]# 155757   18  190
#[Out]# 155758   18  190
#[Out]# 155759   18  190
#[Out]# 155760   18  190
#[Out]# 155761   18  190
#[Out]# 155762   18  190
#[Out]# 155763   18  190
#[Out]# 155764   18  190
#[Out]# 155765   18  190
#[Out]# 155766   18  190
#[Out]# 155767   18  190
#[Out]# 155768   18  190
#[Out]# 155769   18  190
#[Out]# 155770   18  190
#[Out]# 155771   18  190
#[Out]# 155772   18  190
#[Out]# 155773   18  190
#[Out]# 155774   18  190
#[Out]# 155775   18  190
#[Out]# 155776   18  190
#[Out]# 155777   18  190
#[Out]# 155778   18  190
#[Out]# 155779   18  190
#[Out]# 155780   18  190
#[Out]# 155781   18  190
#[Out]# 155782   18  190
#[Out]# 155783   18  190
#[Out]# 
#[Out]# [155784 rows x 2 columns]
query1 = '''select p1.pID, p1.cID, p1.tID, p1.date
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
#[Out]#         pID  cID  tID        date
#[Out]# 0        10    0    0  2018-08-22
#[Out]# 1        10    0    0  2018-08-22
#[Out]# 2        10    0    0  2018-08-22
#[Out]# 3        10    0    0  2018-08-22
#[Out]# 4        10    0    0  2018-08-22
#[Out]# 5        10    0    0  2018-08-22
#[Out]# 6        10    0    0  2018-08-22
#[Out]# 7        10    0    0  2018-08-22
#[Out]# 8        10    0    0  2018-08-22
#[Out]# 9        10    0    0  2018-08-22
#[Out]# 10       10    0    0  2018-08-22
#[Out]# 11       10    0    0  2018-08-22
#[Out]# 12       10    0    0  2018-08-22
#[Out]# 13       10    0    0  2018-08-22
#[Out]# 14       10    0    0  2018-08-22
#[Out]# 15       10    0    0  2018-08-22
#[Out]# 16       10    0    0  2018-08-22
#[Out]# 17       10    0    0  2018-08-22
#[Out]# 18       10    0    0  2018-08-22
#[Out]# 19       10    0    0  2018-08-22
#[Out]# 20       10    0    0  2018-08-22
#[Out]# 21       10    0    0  2018-08-22
#[Out]# 22       10    0    0  2018-08-22
#[Out]# 23       10    0    0  2018-08-22
#[Out]# 24       10    0    0  2018-08-22
#[Out]# 25       10    0    0  2018-08-22
#[Out]# 26       10    0    0  2018-08-22
#[Out]# 27       10    0    0  2018-08-22
#[Out]# 28       10    0    0  2018-08-22
#[Out]# 29       10    0    0  2018-08-22
#[Out]# ...     ...  ...  ...         ...
#[Out]# 155754   18  190  847  2018-08-21
#[Out]# 155755   18  190  847  2018-08-21
#[Out]# 155756   18  190  847  2018-08-21
#[Out]# 155757   18  190  847  2018-08-21
#[Out]# 155758   18  190  847  2018-08-21
#[Out]# 155759   18  190  847  2018-08-21
#[Out]# 155760   18  190  847  2018-08-21
#[Out]# 155761   18  190  847  2018-08-21
#[Out]# 155762   18  190  847  2018-08-21
#[Out]# 155763   18  190  847  2018-08-21
#[Out]# 155764   18  190  847  2018-08-21
#[Out]# 155765   18  190  847  2018-08-21
#[Out]# 155766   18  190  847  2018-08-21
#[Out]# 155767   18  190  847  2018-08-21
#[Out]# 155768   18  190  847  2018-08-21
#[Out]# 155769   18  190  847  2018-08-21
#[Out]# 155770   18  190  847  2018-08-21
#[Out]# 155771   18  190  847  2018-08-21
#[Out]# 155772   18  190  847  2018-08-21
#[Out]# 155773   18  190  847  2018-08-21
#[Out]# 155774   18  190  847  2018-08-21
#[Out]# 155775   18  190  847  2018-08-21
#[Out]# 155776   18  190  847  2018-08-21
#[Out]# 155777   18  190  847  2018-08-21
#[Out]# 155778   18  190  847  2018-08-21
#[Out]# 155779   18  190  847  2018-08-21
#[Out]# 155780   18  190  847  2018-08-21
#[Out]# 155781   18  190  847  2018-08-21
#[Out]# 155782   18  190  847  2018-08-21
#[Out]# 155783   18  190  847  2018-08-21
#[Out]# 
#[Out]# [155784 rows x 4 columns]
query1 = '''select distinct (p1.pID), p1.cID, p1.tID, p1.date
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
#[Out]#      pID  cID  tID        date
#[Out]# 0     10    0    0  2018-08-22
#[Out]# 1     14    1    1  2018-08-20
#[Out]# 2     16    1    2  2018-08-20
#[Out]# 3      9    1    3  2018-08-20
#[Out]# 4     25    1    4  2018-08-20
#[Out]# 5     26    1    5  2018-08-20
#[Out]# 6     11    1    6  2018-08-21
#[Out]# 7     27    1    7  2018-08-21
#[Out]# 8     20    2    8  2018-08-16
#[Out]# 9      9    2    9  2018-08-17
#[Out]# 10     4    2   10  2018-08-17
#[Out]# 11    13    2   11  2018-08-17
#[Out]# 12    22    2   12  2018-08-17
#[Out]# 13    14    3   13  2018-08-18
#[Out]# 14    26    3   14  2018-08-19
#[Out]# 15     9    3   15  2018-08-19
#[Out]# 16     8    4   16  2018-08-24
#[Out]# 17    27    4   17  2018-08-24
#[Out]# 18    12    4   18  2018-08-25
#[Out]# 19     6    4   19  2018-08-24
#[Out]# 20    13    4   20  2018-08-25
#[Out]# 21    26    4   21  2018-08-25
#[Out]# 22    14    5   22  2018-08-17
#[Out]# 23    28    5   23  2018-08-22
#[Out]# 24     6    5   24  2018-08-23
#[Out]# 25    22    5   25  2018-08-23
#[Out]# 26    16    5   26  2018-08-23
#[Out]# 27    19    5   27  2018-08-23
#[Out]# 28    19    7   28  2018-08-23
#[Out]# 29     2    7   29  2018-08-23
#[Out]# ..   ...  ...  ...         ...
#[Out]# 477   28  190  818  2018-08-20
#[Out]# 478   27  190  819  2018-08-15
#[Out]# 479    5  190  820  2018-08-23
#[Out]# 480   28  190  821  2018-08-15
#[Out]# 481    7  190  822  2018-08-24
#[Out]# 482    0  190  823  2018-08-25
#[Out]# 483   11  190  824  2018-08-15
#[Out]# 484    6  190  825  2018-08-15
#[Out]# 485   19  190  826  2018-08-22
#[Out]# 486   17  190  827  2018-08-17
#[Out]# 487    9  190  828  2018-08-18
#[Out]# 488   11  190  829  2018-08-19
#[Out]# 489   22  190  830  2018-08-25
#[Out]# 490   17  190  831  2018-08-17
#[Out]# 491   20  190  832  2018-08-26
#[Out]# 492   11  190  833  2018-08-17
#[Out]# 493   21  190  834  2018-08-22
#[Out]# 494   23  190  835  2018-08-19
#[Out]# 495   23  190  836  2018-08-15
#[Out]# 496    8  190  837  2018-08-18
#[Out]# 497    0  190  838  2018-08-25
#[Out]# 498    8  190  839  2018-08-18
#[Out]# 499   11  190  840  2018-08-15
#[Out]# 500   15  190  841  2018-08-22
#[Out]# 501    2  190  842  2018-08-19
#[Out]# 502   17  190  843  2018-08-26
#[Out]# 503    5  190  844  2018-08-27
#[Out]# 504   19  190  845  2018-08-23
#[Out]# 505    9  190  846  2018-08-16
#[Out]# 506   18  190  847  2018-08-21
#[Out]# 
#[Out]# [507 rows x 4 columns]
query1 = '''select distinct (p1.pID), p1.cID, p1.tID, p1.date
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    order by p1.pID
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1, bought by at least 3 cust.
pd.read_sql_query(query1, conn)
#[Out]#      pID  cID  tID        date
#[Out]# 0      0   13   38  2018-08-17
#[Out]# 1      0   16   48  2018-08-24
#[Out]# 2      0   19   63  2018-08-17
#[Out]# 3      0   20   68  2018-08-18
#[Out]# 4      0   24   81  2018-08-20
#[Out]# 5      0   33  104  2018-08-27
#[Out]# 6      0   66  187  2018-08-17
#[Out]# 7      0   78  214  2018-08-17
#[Out]# 8      0   82  227  2018-08-25
#[Out]# 9      0   95  259  2018-08-24
#[Out]# 10     0  113  297  2018-08-26
#[Out]# 11     0  123  321  2018-08-25
#[Out]# 12     0  127  336  2018-08-25
#[Out]# 13     0  139  354  2018-08-19
#[Out]# 14     0  144  355  2018-08-22
#[Out]# 15     0  157  380  2018-08-27
#[Out]# 16     0  163  403  2018-08-27
#[Out]# 17     0  167  423  2018-08-21
#[Out]# 18     0  170  439  2018-08-16
#[Out]# 19     0  176  449  2018-08-25
#[Out]# 20     0  184  777  2018-08-20
#[Out]# 21     0  190  797  2018-08-26
#[Out]# 22     0  190  816  2018-08-26
#[Out]# 23     0  190  823  2018-08-25
#[Out]# 24     0  190  838  2018-08-25
#[Out]# 25     1   33  107  2018-08-17
#[Out]# 26     1   59  175  2018-08-26
#[Out]# 27     1   69  195  2018-08-28
#[Out]# 28     1   92  252  2018-08-27
#[Out]# 29     1  108  281  2018-08-15
#[Out]# ..   ...  ...  ...         ...
#[Out]# 477   27  190  784  2018-08-19
#[Out]# 478   27  190  802  2018-08-21
#[Out]# 479   27  190  819  2018-08-15
#[Out]# 480   28    5   23  2018-08-22
#[Out]# 481   28   22   73  2018-08-27
#[Out]# 482   28   35  111  2018-08-18
#[Out]# 483   28   39  123  2018-08-29
#[Out]# 484   28   40  124  2018-08-16
#[Out]# 485   28   60  180  2018-08-23
#[Out]# 486   28   70  197  2018-08-25
#[Out]# 487   28   71  200  2018-08-24
#[Out]# 488   28   82  224  2018-08-23
#[Out]# 489   28   86  234  2018-08-17
#[Out]# 490   28  100  271  2018-08-22
#[Out]# 491   28  108  280  2018-08-15
#[Out]# 492   28  118  307  2018-08-20
#[Out]# 493   28  123  320  2018-08-24
#[Out]# 494   28  124  325  2018-08-26
#[Out]# 495   28  127  337  2018-08-26
#[Out]# 496   28  136  350  2018-08-24
#[Out]# 497   28  161  393  2018-08-26
#[Out]# 498   28  162  397  2018-08-22
#[Out]# 499   28  169  428  2018-08-17
#[Out]# 500   28  170  438  2018-08-16
#[Out]# 501   28  175  445  2018-08-19
#[Out]# 502   28  190  787  2018-08-23
#[Out]# 503   28  190  818  2018-08-20
#[Out]# 504   28  190  821  2018-08-15
#[Out]# 505   29  185  778  2018-08-20
#[Out]# 506   29  186  779  2018-08-21
#[Out]# 
#[Out]# [507 rows x 4 columns]
query1 = '''

select pID
from product
where pur.pID not in
    (select p1.pId 
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    
    and p1.cID <> p2.cID
    )
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
query1 = '''

select pID
from product
where pID not in
    (select p1.pId 
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    
    and p1.cID <> p2.cID
    )
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   30
#[Out]# 1   31
query1 = '''

select p1.pId 
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    
    and p1.cID <> p2.cID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#       pID
#[Out]# 0      10
#[Out]# 1      10
#[Out]# 2      10
#[Out]# 3      10
#[Out]# 4      10
#[Out]# 5      10
#[Out]# 6      10
#[Out]# 7      10
#[Out]# 8      10
#[Out]# 9      10
#[Out]# 10     10
#[Out]# 11     10
#[Out]# 12     10
#[Out]# 13     10
#[Out]# 14     10
#[Out]# 15     14
#[Out]# 16     14
#[Out]# 17     14
#[Out]# 18     14
#[Out]# 19     14
#[Out]# 20     14
#[Out]# 21     14
#[Out]# 22     14
#[Out]# 23     14
#[Out]# 24     14
#[Out]# 25     14
#[Out]# 26     14
#[Out]# 27     14
#[Out]# 28     14
#[Out]# 29     14
#[Out]# ...   ...
#[Out]# 8594   19
#[Out]# 8595   19
#[Out]# 8596   19
#[Out]# 8597   19
#[Out]# 8598    9
#[Out]# 8599    9
#[Out]# 8600    9
#[Out]# 8601    9
#[Out]# 8602    9
#[Out]# 8603    9
#[Out]# 8604    9
#[Out]# 8605    9
#[Out]# 8606    9
#[Out]# 8607    9
#[Out]# 8608    9
#[Out]# 8609    9
#[Out]# 8610    9
#[Out]# 8611    9
#[Out]# 8612    9
#[Out]# 8613    9
#[Out]# 8614    9
#[Out]# 8615   18
#[Out]# 8616   18
#[Out]# 8617   18
#[Out]# 8618   18
#[Out]# 8619   18
#[Out]# 8620   18
#[Out]# 8621   18
#[Out]# 8622   18
#[Out]# 8623   18
#[Out]# 
#[Out]# [8624 rows x 1 columns]
query1 = '''

select p1.pId , p1.cId, p1.tID, p1.date
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    
    and p1.cID <> p2.cID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#       pID  cID  tID        date
#[Out]# 0      10    0    0  2018-08-22
#[Out]# 1      10    0    0  2018-08-22
#[Out]# 2      10    0    0  2018-08-22
#[Out]# 3      10    0    0  2018-08-22
#[Out]# 4      10    0    0  2018-08-22
#[Out]# 5      10    0    0  2018-08-22
#[Out]# 6      10    0    0  2018-08-22
#[Out]# 7      10    0    0  2018-08-22
#[Out]# 8      10    0    0  2018-08-22
#[Out]# 9      10    0    0  2018-08-22
#[Out]# 10     10    0    0  2018-08-22
#[Out]# 11     10    0    0  2018-08-22
#[Out]# 12     10    0    0  2018-08-22
#[Out]# 13     10    0    0  2018-08-22
#[Out]# 14     10    0    0  2018-08-22
#[Out]# 15     14    1    1  2018-08-20
#[Out]# 16     14    1    1  2018-08-20
#[Out]# 17     14    1    1  2018-08-20
#[Out]# 18     14    1    1  2018-08-20
#[Out]# 19     14    1    1  2018-08-20
#[Out]# 20     14    1    1  2018-08-20
#[Out]# 21     14    1    1  2018-08-20
#[Out]# 22     14    1    1  2018-08-20
#[Out]# 23     14    1    1  2018-08-20
#[Out]# 24     14    1    1  2018-08-20
#[Out]# 25     14    1    1  2018-08-20
#[Out]# 26     14    1    1  2018-08-20
#[Out]# 27     14    1    1  2018-08-20
#[Out]# 28     14    1    1  2018-08-20
#[Out]# 29     14    1    1  2018-08-20
#[Out]# ...   ...  ...  ...         ...
#[Out]# 8594   19  190  845  2018-08-23
#[Out]# 8595   19  190  845  2018-08-23
#[Out]# 8596   19  190  845  2018-08-23
#[Out]# 8597   19  190  845  2018-08-23
#[Out]# 8598    9  190  846  2018-08-16
#[Out]# 8599    9  190  846  2018-08-16
#[Out]# 8600    9  190  846  2018-08-16
#[Out]# 8601    9  190  846  2018-08-16
#[Out]# 8602    9  190  846  2018-08-16
#[Out]# 8603    9  190  846  2018-08-16
#[Out]# 8604    9  190  846  2018-08-16
#[Out]# 8605    9  190  846  2018-08-16
#[Out]# 8606    9  190  846  2018-08-16
#[Out]# 8607    9  190  846  2018-08-16
#[Out]# 8608    9  190  846  2018-08-16
#[Out]# 8609    9  190  846  2018-08-16
#[Out]# 8610    9  190  846  2018-08-16
#[Out]# 8611    9  190  846  2018-08-16
#[Out]# 8612    9  190  846  2018-08-16
#[Out]# 8613    9  190  846  2018-08-16
#[Out]# 8614    9  190  846  2018-08-16
#[Out]# 8615   18  190  847  2018-08-21
#[Out]# 8616   18  190  847  2018-08-21
#[Out]# 8617   18  190  847  2018-08-21
#[Out]# 8618   18  190  847  2018-08-21
#[Out]# 8619   18  190  847  2018-08-21
#[Out]# 8620   18  190  847  2018-08-21
#[Out]# 8621   18  190  847  2018-08-21
#[Out]# 8622   18  190  847  2018-08-21
#[Out]# 8623   18  190  847  2018-08-21
#[Out]# 
#[Out]# [8624 rows x 4 columns]
query1 = '''

select distinct(p1.cId)  , p1.pId, p1.tID, p1.date
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    
    and p1.cID <> p2.cID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#      cID  pID  tID        date
#[Out]# 0      0   10    0  2018-08-22
#[Out]# 1      1   14    1  2018-08-20
#[Out]# 2      1   16    2  2018-08-20
#[Out]# 3      1    9    3  2018-08-20
#[Out]# 4      1   25    4  2018-08-20
#[Out]# 5      1   26    5  2018-08-20
#[Out]# 6      1   11    6  2018-08-21
#[Out]# 7      1   27    7  2018-08-21
#[Out]# 8      2   20    8  2018-08-16
#[Out]# 9      2    9    9  2018-08-17
#[Out]# 10     2    4   10  2018-08-17
#[Out]# 11     2   13   11  2018-08-17
#[Out]# 12     2   22   12  2018-08-17
#[Out]# 13     3   14   13  2018-08-18
#[Out]# 14     3   26   14  2018-08-19
#[Out]# 15     3    9   15  2018-08-19
#[Out]# 16     4    8   16  2018-08-24
#[Out]# 17     4   27   17  2018-08-24
#[Out]# 18     4   12   18  2018-08-25
#[Out]# 19     4    6   19  2018-08-24
#[Out]# 20     4   13   20  2018-08-25
#[Out]# 21     4   26   21  2018-08-25
#[Out]# 22     5   14   22  2018-08-17
#[Out]# 23     5   28   23  2018-08-22
#[Out]# 24     5    6   24  2018-08-23
#[Out]# 25     5   22   25  2018-08-23
#[Out]# 26     5   16   26  2018-08-23
#[Out]# 27     5   19   27  2018-08-23
#[Out]# 28     7   19   28  2018-08-23
#[Out]# 29     7    2   29  2018-08-23
#[Out]# ..   ...  ...  ...         ...
#[Out]# 477  190   28  818  2018-08-20
#[Out]# 478  190   27  819  2018-08-15
#[Out]# 479  190    5  820  2018-08-23
#[Out]# 480  190   28  821  2018-08-15
#[Out]# 481  190    7  822  2018-08-24
#[Out]# 482  190    0  823  2018-08-25
#[Out]# 483  190   11  824  2018-08-15
#[Out]# 484  190    6  825  2018-08-15
#[Out]# 485  190   19  826  2018-08-22
#[Out]# 486  190   17  827  2018-08-17
#[Out]# 487  190    9  828  2018-08-18
#[Out]# 488  190   11  829  2018-08-19
#[Out]# 489  190   22  830  2018-08-25
#[Out]# 490  190   17  831  2018-08-17
#[Out]# 491  190   20  832  2018-08-26
#[Out]# 492  190   11  833  2018-08-17
#[Out]# 493  190   21  834  2018-08-22
#[Out]# 494  190   23  835  2018-08-19
#[Out]# 495  190   23  836  2018-08-15
#[Out]# 496  190    8  837  2018-08-18
#[Out]# 497  190    0  838  2018-08-25
#[Out]# 498  190    8  839  2018-08-18
#[Out]# 499  190   11  840  2018-08-15
#[Out]# 500  190   15  841  2018-08-22
#[Out]# 501  190    2  842  2018-08-19
#[Out]# 502  190   17  843  2018-08-26
#[Out]# 503  190    5  844  2018-08-27
#[Out]# 504  190   19  845  2018-08-23
#[Out]# 505  190    9  846  2018-08-16
#[Out]# 506  190   18  847  2018-08-21
#[Out]# 
#[Out]# [507 rows x 4 columns]
query1 = '''

select distinct(p1.cId)  , p1.pId, p1.tID, p1.date
    from purchase p1, purchase p2
    where p1.pID = p2.pID
    
    and p1.cID <> p2.cID
    order by p1.pid
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#      cID  pID  tID        date
#[Out]# 0     13    0   38  2018-08-17
#[Out]# 1     16    0   48  2018-08-24
#[Out]# 2     19    0   63  2018-08-17
#[Out]# 3     20    0   68  2018-08-18
#[Out]# 4     24    0   81  2018-08-20
#[Out]# 5     33    0  104  2018-08-27
#[Out]# 6     66    0  187  2018-08-17
#[Out]# 7     78    0  214  2018-08-17
#[Out]# 8     82    0  227  2018-08-25
#[Out]# 9     95    0  259  2018-08-24
#[Out]# 10   113    0  297  2018-08-26
#[Out]# 11   123    0  321  2018-08-25
#[Out]# 12   127    0  336  2018-08-25
#[Out]# 13   139    0  354  2018-08-19
#[Out]# 14   144    0  355  2018-08-22
#[Out]# 15   157    0  380  2018-08-27
#[Out]# 16   163    0  403  2018-08-27
#[Out]# 17   167    0  423  2018-08-21
#[Out]# 18   170    0  439  2018-08-16
#[Out]# 19   176    0  449  2018-08-25
#[Out]# 20   184    0  777  2018-08-20
#[Out]# 21   190    0  797  2018-08-26
#[Out]# 22   190    0  816  2018-08-26
#[Out]# 23   190    0  823  2018-08-25
#[Out]# 24   190    0  838  2018-08-25
#[Out]# 25    33    1  107  2018-08-17
#[Out]# 26    59    1  175  2018-08-26
#[Out]# 27    69    1  195  2018-08-28
#[Out]# 28    92    1  252  2018-08-27
#[Out]# 29   108    1  281  2018-08-15
#[Out]# ..   ...  ...  ...         ...
#[Out]# 477  190   27  784  2018-08-19
#[Out]# 478  190   27  802  2018-08-21
#[Out]# 479  190   27  819  2018-08-15
#[Out]# 480    5   28   23  2018-08-22
#[Out]# 481   22   28   73  2018-08-27
#[Out]# 482   35   28  111  2018-08-18
#[Out]# 483   39   28  123  2018-08-29
#[Out]# 484   40   28  124  2018-08-16
#[Out]# 485   60   28  180  2018-08-23
#[Out]# 486   70   28  197  2018-08-25
#[Out]# 487   71   28  200  2018-08-24
#[Out]# 488   82   28  224  2018-08-23
#[Out]# 489   86   28  234  2018-08-17
#[Out]# 490  100   28  271  2018-08-22
#[Out]# 491  108   28  280  2018-08-15
#[Out]# 492  118   28  307  2018-08-20
#[Out]# 493  123   28  320  2018-08-24
#[Out]# 494  124   28  325  2018-08-26
#[Out]# 495  127   28  337  2018-08-26
#[Out]# 496  136   28  350  2018-08-24
#[Out]# 497  161   28  393  2018-08-26
#[Out]# 498  162   28  397  2018-08-22
#[Out]# 499  169   28  428  2018-08-17
#[Out]# 500  170   28  438  2018-08-16
#[Out]# 501  175   28  445  2018-08-19
#[Out]# 502  190   28  787  2018-08-23
#[Out]# 503  190   28  818  2018-08-20
#[Out]# 504  190   28  821  2018-08-15
#[Out]# 505  185   29  778  2018-08-20
#[Out]# 506  186   29  779  2018-08-21
#[Out]# 
#[Out]# [507 rows x 4 columns]
query1 = '''
select p1.pId 
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#         pID
#[Out]# 0        10
#[Out]# 1        10
#[Out]# 2        10
#[Out]# 3        10
#[Out]# 4        10
#[Out]# 5        10
#[Out]# 6        10
#[Out]# 7        10
#[Out]# 8        10
#[Out]# 9        10
#[Out]# 10       10
#[Out]# 11       10
#[Out]# 12       10
#[Out]# 13       10
#[Out]# 14       10
#[Out]# 15       10
#[Out]# 16       10
#[Out]# 17       10
#[Out]# 18       10
#[Out]# 19       10
#[Out]# 20       10
#[Out]# 21       10
#[Out]# 22       10
#[Out]# 23       10
#[Out]# 24       10
#[Out]# 25       10
#[Out]# 26       10
#[Out]# 27       10
#[Out]# 28       10
#[Out]# 29       10
#[Out]# ...     ...
#[Out]# 155754   18
#[Out]# 155755   18
#[Out]# 155756   18
#[Out]# 155757   18
#[Out]# 155758   18
#[Out]# 155759   18
#[Out]# 155760   18
#[Out]# 155761   18
#[Out]# 155762   18
#[Out]# 155763   18
#[Out]# 155764   18
#[Out]# 155765   18
#[Out]# 155766   18
#[Out]# 155767   18
#[Out]# 155768   18
#[Out]# 155769   18
#[Out]# 155770   18
#[Out]# 155771   18
#[Out]# 155772   18
#[Out]# 155773   18
#[Out]# 155774   18
#[Out]# 155775   18
#[Out]# 155776   18
#[Out]# 155777   18
#[Out]# 155778   18
#[Out]# 155779   18
#[Out]# 155780   18
#[Out]# 155781   18
#[Out]# 155782   18
#[Out]# 155783   18
#[Out]# 
#[Out]# [155784 rows x 1 columns]
query1 = '''
select distinct (p1.pId)
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0    10
#[Out]# 1    14
#[Out]# 2    16
#[Out]# 3     9
#[Out]# 4    25
#[Out]# 5    26
#[Out]# 6    11
#[Out]# 7    27
#[Out]# 8    20
#[Out]# 9     4
#[Out]# 10   13
#[Out]# 11   22
#[Out]# 12    8
#[Out]# 13   12
#[Out]# 14    6
#[Out]# 15   28
#[Out]# 16   19
#[Out]# 17    2
#[Out]# 18   24
#[Out]# 19    0
#[Out]# 20   23
#[Out]# 21   17
#[Out]# 22    3
#[Out]# 23    5
#[Out]# 24   21
#[Out]# 25    7
#[Out]# 26   15
#[Out]# 27   18
#[Out]# 28    1
#[Out]# 29   29
query1 = '''
select distinct (p1.pId), p1.tID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#      pID  tID
#[Out]# 0     10    0
#[Out]# 1     14    1
#[Out]# 2     16    2
#[Out]# 3      9    3
#[Out]# 4     25    4
#[Out]# 5     26    5
#[Out]# 6     11    6
#[Out]# 7     27    7
#[Out]# 8     20    8
#[Out]# 9      9    9
#[Out]# 10     4   10
#[Out]# 11    13   11
#[Out]# 12    22   12
#[Out]# 13    14   13
#[Out]# 14    26   14
#[Out]# 15     9   15
#[Out]# 16     8   16
#[Out]# 17    27   17
#[Out]# 18    12   18
#[Out]# 19     6   19
#[Out]# 20    13   20
#[Out]# 21    26   21
#[Out]# 22    14   22
#[Out]# 23    28   23
#[Out]# 24     6   24
#[Out]# 25    22   25
#[Out]# 26    16   26
#[Out]# 27    19   27
#[Out]# 28    19   28
#[Out]# 29     2   29
#[Out]# ..   ...  ...
#[Out]# 477   28  818
#[Out]# 478   27  819
#[Out]# 479    5  820
#[Out]# 480   28  821
#[Out]# 481    7  822
#[Out]# 482    0  823
#[Out]# 483   11  824
#[Out]# 484    6  825
#[Out]# 485   19  826
#[Out]# 486   17  827
#[Out]# 487    9  828
#[Out]# 488   11  829
#[Out]# 489   22  830
#[Out]# 490   17  831
#[Out]# 491   20  832
#[Out]# 492   11  833
#[Out]# 493   21  834
#[Out]# 494   23  835
#[Out]# 495   23  836
#[Out]# 496    8  837
#[Out]# 497    0  838
#[Out]# 498    8  839
#[Out]# 499   11  840
#[Out]# 500   15  841
#[Out]# 501    2  842
#[Out]# 502   17  843
#[Out]# 503    5  844
#[Out]# 504   19  845
#[Out]# 505    9  846
#[Out]# 506   18  847
#[Out]# 
#[Out]# [507 rows x 2 columns]
query1 = '''
select distinct (p1.pId), p1.tID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    order by pID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
query1 = '''
select distinct (p1.pId), p1.tID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    order by p1.pID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#      pID  tID
#[Out]# 0      0   38
#[Out]# 1      0   48
#[Out]# 2      0   63
#[Out]# 3      0   68
#[Out]# 4      0   81
#[Out]# 5      0  104
#[Out]# 6      0  187
#[Out]# 7      0  214
#[Out]# 8      0  227
#[Out]# 9      0  259
#[Out]# 10     0  297
#[Out]# 11     0  321
#[Out]# 12     0  336
#[Out]# 13     0  354
#[Out]# 14     0  355
#[Out]# 15     0  380
#[Out]# 16     0  403
#[Out]# 17     0  423
#[Out]# 18     0  439
#[Out]# 19     0  449
#[Out]# 20     0  777
#[Out]# 21     0  797
#[Out]# 22     0  816
#[Out]# 23     0  823
#[Out]# 24     0  838
#[Out]# 25     1  107
#[Out]# 26     1  175
#[Out]# 27     1  195
#[Out]# 28     1  252
#[Out]# 29     1  281
#[Out]# ..   ...  ...
#[Out]# 477   27  784
#[Out]# 478   27  802
#[Out]# 479   27  819
#[Out]# 480   28   23
#[Out]# 481   28   73
#[Out]# 482   28  111
#[Out]# 483   28  123
#[Out]# 484   28  124
#[Out]# 485   28  180
#[Out]# 486   28  197
#[Out]# 487   28  200
#[Out]# 488   28  224
#[Out]# 489   28  234
#[Out]# 490   28  271
#[Out]# 491   28  280
#[Out]# 492   28  307
#[Out]# 493   28  320
#[Out]# 494   28  325
#[Out]# 495   28  337
#[Out]# 496   28  350
#[Out]# 497   28  393
#[Out]# 498   28  397
#[Out]# 499   28  428
#[Out]# 500   28  438
#[Out]# 501   28  445
#[Out]# 502   28  787
#[Out]# 503   28  818
#[Out]# 504   28  821
#[Out]# 505   29  778
#[Out]# 506   29  779
#[Out]# 
#[Out]# [507 rows x 2 columns]
query1 = '''
select distinct (p1.pId), p1.tID,p1.cID, p2.cId,p2.tID, p3.cID, p3.tID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    order by p1.pID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#         pID  tID  cID  cID  tID  cID  tID
#[Out]# 0         0   38   13   16   48   13   38
#[Out]# 1         0   38   13   16   48   19   63
#[Out]# 2         0   38   13   16   48   20   68
#[Out]# 3         0   38   13   16   48   24   81
#[Out]# 4         0   38   13   16   48   33  104
#[Out]# 5         0   38   13   16   48   66  187
#[Out]# 6         0   38   13   16   48   78  214
#[Out]# 7         0   38   13   16   48   82  227
#[Out]# 8         0   38   13   16   48   95  259
#[Out]# 9         0   38   13   16   48  113  297
#[Out]# 10        0   38   13   16   48  123  321
#[Out]# 11        0   38   13   16   48  127  336
#[Out]# 12        0   38   13   16   48  139  354
#[Out]# 13        0   38   13   16   48  144  355
#[Out]# 14        0   38   13   16   48  157  380
#[Out]# 15        0   38   13   16   48  163  403
#[Out]# 16        0   38   13   16   48  167  423
#[Out]# 17        0   38   13   16   48  170  439
#[Out]# 18        0   38   13   16   48  176  449
#[Out]# 19        0   38   13   16   48  184  777
#[Out]# 20        0   38   13   16   48  190  797
#[Out]# 21        0   38   13   16   48  190  816
#[Out]# 22        0   38   13   16   48  190  823
#[Out]# 23        0   38   13   16   48  190  838
#[Out]# 24        0   38   13   19   63   13   38
#[Out]# 25        0   38   13   19   63   16   48
#[Out]# 26        0   38   13   19   63   20   68
#[Out]# 27        0   38   13   19   63   24   81
#[Out]# 28        0   38   13   19   63   33  104
#[Out]# 29        0   38   13   19   63   66  187
#[Out]# ...     ...  ...  ...  ...  ...  ...  ...
#[Out]# 155754   28  821  190  170  438  175  445
#[Out]# 155755   28  821  190  170  438  190  787
#[Out]# 155756   28  821  190  170  438  190  818
#[Out]# 155757   28  821  190  170  438  190  821
#[Out]# 155758   28  821  190  175  445    5   23
#[Out]# 155759   28  821  190  175  445   22   73
#[Out]# 155760   28  821  190  175  445   35  111
#[Out]# 155761   28  821  190  175  445   39  123
#[Out]# 155762   28  821  190  175  445   40  124
#[Out]# 155763   28  821  190  175  445   60  180
#[Out]# 155764   28  821  190  175  445   70  197
#[Out]# 155765   28  821  190  175  445   71  200
#[Out]# 155766   28  821  190  175  445   82  224
#[Out]# 155767   28  821  190  175  445   86  234
#[Out]# 155768   28  821  190  175  445  100  271
#[Out]# 155769   28  821  190  175  445  108  280
#[Out]# 155770   28  821  190  175  445  118  307
#[Out]# 155771   28  821  190  175  445  123  320
#[Out]# 155772   28  821  190  175  445  124  325
#[Out]# 155773   28  821  190  175  445  127  337
#[Out]# 155774   28  821  190  175  445  136  350
#[Out]# 155775   28  821  190  175  445  161  393
#[Out]# 155776   28  821  190  175  445  162  397
#[Out]# 155777   28  821  190  175  445  169  428
#[Out]# 155778   28  821  190  175  445  170  438
#[Out]# 155779   28  821  190  175  445  190  787
#[Out]# 155780   28  821  190  175  445  190  818
#[Out]# 155781   28  821  190  175  445  190  821
#[Out]# 155782   29  778  185  186  779  185  778
#[Out]# 155783   29  779  186  185  778  186  779
#[Out]# 
#[Out]# [155784 rows x 7 columns]
query1 = '''
select distinct (p1.pId) ,p1.cID, p1.tID, p2.cId,p2.tID, p3.cID, p3.tID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    order by p1.pID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#         pID  cID  tID  cID  tID  cID  tID
#[Out]# 0         0   13   38   16   48   13   38
#[Out]# 1         0   13   38   16   48   19   63
#[Out]# 2         0   13   38   16   48   20   68
#[Out]# 3         0   13   38   16   48   24   81
#[Out]# 4         0   13   38   16   48   33  104
#[Out]# 5         0   13   38   16   48   66  187
#[Out]# 6         0   13   38   16   48   78  214
#[Out]# 7         0   13   38   16   48   82  227
#[Out]# 8         0   13   38   16   48   95  259
#[Out]# 9         0   13   38   16   48  113  297
#[Out]# 10        0   13   38   16   48  123  321
#[Out]# 11        0   13   38   16   48  127  336
#[Out]# 12        0   13   38   16   48  139  354
#[Out]# 13        0   13   38   16   48  144  355
#[Out]# 14        0   13   38   16   48  157  380
#[Out]# 15        0   13   38   16   48  163  403
#[Out]# 16        0   13   38   16   48  167  423
#[Out]# 17        0   13   38   16   48  170  439
#[Out]# 18        0   13   38   16   48  176  449
#[Out]# 19        0   13   38   16   48  184  777
#[Out]# 20        0   13   38   16   48  190  797
#[Out]# 21        0   13   38   16   48  190  816
#[Out]# 22        0   13   38   16   48  190  823
#[Out]# 23        0   13   38   16   48  190  838
#[Out]# 24        0   13   38   19   63   13   38
#[Out]# 25        0   13   38   19   63   16   48
#[Out]# 26        0   13   38   19   63   20   68
#[Out]# 27        0   13   38   19   63   24   81
#[Out]# 28        0   13   38   19   63   33  104
#[Out]# 29        0   13   38   19   63   66  187
#[Out]# ...     ...  ...  ...  ...  ...  ...  ...
#[Out]# 155754   28  190  821  170  438  175  445
#[Out]# 155755   28  190  821  170  438  190  787
#[Out]# 155756   28  190  821  170  438  190  818
#[Out]# 155757   28  190  821  170  438  190  821
#[Out]# 155758   28  190  821  175  445    5   23
#[Out]# 155759   28  190  821  175  445   22   73
#[Out]# 155760   28  190  821  175  445   35  111
#[Out]# 155761   28  190  821  175  445   39  123
#[Out]# 155762   28  190  821  175  445   40  124
#[Out]# 155763   28  190  821  175  445   60  180
#[Out]# 155764   28  190  821  175  445   70  197
#[Out]# 155765   28  190  821  175  445   71  200
#[Out]# 155766   28  190  821  175  445   82  224
#[Out]# 155767   28  190  821  175  445   86  234
#[Out]# 155768   28  190  821  175  445  100  271
#[Out]# 155769   28  190  821  175  445  108  280
#[Out]# 155770   28  190  821  175  445  118  307
#[Out]# 155771   28  190  821  175  445  123  320
#[Out]# 155772   28  190  821  175  445  124  325
#[Out]# 155773   28  190  821  175  445  127  337
#[Out]# 155774   28  190  821  175  445  136  350
#[Out]# 155775   28  190  821  175  445  161  393
#[Out]# 155776   28  190  821  175  445  162  397
#[Out]# 155777   28  190  821  175  445  169  428
#[Out]# 155778   28  190  821  175  445  170  438
#[Out]# 155779   28  190  821  175  445  190  787
#[Out]# 155780   28  190  821  175  445  190  818
#[Out]# 155781   28  190  821  175  445  190  821
#[Out]# 155782   29  185  778  186  779  185  778
#[Out]# 155783   29  186  779  185  778  186  779
#[Out]# 
#[Out]# [155784 rows x 7 columns]
query1 = '''
select distinct (p1.pId) ,p1.cID, p1.tID, p2.cId,p2.tID, p3.cID, p3.tID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    and p1.cID <> p3.cID
    order by p1.pID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#         pID  cID  tID  cID  tID  cID  tID
#[Out]# 0         0   13   38   16   48   19   63
#[Out]# 1         0   13   38   16   48   20   68
#[Out]# 2         0   13   38   16   48   24   81
#[Out]# 3         0   13   38   16   48   33  104
#[Out]# 4         0   13   38   16   48   66  187
#[Out]# 5         0   13   38   16   48   78  214
#[Out]# 6         0   13   38   16   48   82  227
#[Out]# 7         0   13   38   16   48   95  259
#[Out]# 8         0   13   38   16   48  113  297
#[Out]# 9         0   13   38   16   48  123  321
#[Out]# 10        0   13   38   16   48  127  336
#[Out]# 11        0   13   38   16   48  139  354
#[Out]# 12        0   13   38   16   48  144  355
#[Out]# 13        0   13   38   16   48  157  380
#[Out]# 14        0   13   38   16   48  163  403
#[Out]# 15        0   13   38   16   48  167  423
#[Out]# 16        0   13   38   16   48  170  439
#[Out]# 17        0   13   38   16   48  176  449
#[Out]# 18        0   13   38   16   48  184  777
#[Out]# 19        0   13   38   16   48  190  797
#[Out]# 20        0   13   38   16   48  190  816
#[Out]# 21        0   13   38   16   48  190  823
#[Out]# 22        0   13   38   16   48  190  838
#[Out]# 23        0   13   38   19   63   16   48
#[Out]# 24        0   13   38   19   63   20   68
#[Out]# 25        0   13   38   19   63   24   81
#[Out]# 26        0   13   38   19   63   33  104
#[Out]# 27        0   13   38   19   63   66  187
#[Out]# 28        0   13   38   19   63   78  214
#[Out]# 29        0   13   38   19   63   82  227
#[Out]# ...     ...  ...  ...  ...  ...  ...  ...
#[Out]# 144588   28  190  821  170  438  118  307
#[Out]# 144589   28  190  821  170  438  123  320
#[Out]# 144590   28  190  821  170  438  124  325
#[Out]# 144591   28  190  821  170  438  127  337
#[Out]# 144592   28  190  821  170  438  136  350
#[Out]# 144593   28  190  821  170  438  161  393
#[Out]# 144594   28  190  821  170  438  162  397
#[Out]# 144595   28  190  821  170  438  169  428
#[Out]# 144596   28  190  821  170  438  175  445
#[Out]# 144597   28  190  821  175  445    5   23
#[Out]# 144598   28  190  821  175  445   22   73
#[Out]# 144599   28  190  821  175  445   35  111
#[Out]# 144600   28  190  821  175  445   39  123
#[Out]# 144601   28  190  821  175  445   40  124
#[Out]# 144602   28  190  821  175  445   60  180
#[Out]# 144603   28  190  821  175  445   70  197
#[Out]# 144604   28  190  821  175  445   71  200
#[Out]# 144605   28  190  821  175  445   82  224
#[Out]# 144606   28  190  821  175  445   86  234
#[Out]# 144607   28  190  821  175  445  100  271
#[Out]# 144608   28  190  821  175  445  108  280
#[Out]# 144609   28  190  821  175  445  118  307
#[Out]# 144610   28  190  821  175  445  123  320
#[Out]# 144611   28  190  821  175  445  124  325
#[Out]# 144612   28  190  821  175  445  127  337
#[Out]# 144613   28  190  821  175  445  136  350
#[Out]# 144614   28  190  821  175  445  161  393
#[Out]# 144615   28  190  821  175  445  162  397
#[Out]# 144616   28  190  821  175  445  169  428
#[Out]# 144617   28  190  821  175  445  170  438
#[Out]# 
#[Out]# [144618 rows x 7 columns]
query1 = '''
select distinct (p1.pId) ,p1.cID, p1.tID, p2.cId,p2.tID
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID

    and p1.cID <> p2.cID

    order by p1.pID
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#       pID  cID  tID  cID  tID
#[Out]# 0       0   13   38   16   48
#[Out]# 1       0   13   38   19   63
#[Out]# 2       0   13   38   20   68
#[Out]# 3       0   13   38   24   81
#[Out]# 4       0   13   38   33  104
#[Out]# 5       0   13   38   66  187
#[Out]# 6       0   13   38   78  214
#[Out]# 7       0   13   38   82  227
#[Out]# 8       0   13   38   95  259
#[Out]# 9       0   13   38  113  297
#[Out]# 10      0   13   38  123  321
#[Out]# 11      0   13   38  127  336
#[Out]# 12      0   13   38  139  354
#[Out]# 13      0   13   38  144  355
#[Out]# 14      0   13   38  157  380
#[Out]# 15      0   13   38  163  403
#[Out]# 16      0   13   38  167  423
#[Out]# 17      0   13   38  170  439
#[Out]# 18      0   13   38  176  449
#[Out]# 19      0   13   38  184  777
#[Out]# 20      0   13   38  190  797
#[Out]# 21      0   13   38  190  816
#[Out]# 22      0   13   38  190  823
#[Out]# 23      0   13   38  190  838
#[Out]# 24      0   16   48   13   38
#[Out]# 25      0   16   48   19   63
#[Out]# 26      0   16   48   20   68
#[Out]# 27      0   16   48   24   81
#[Out]# 28      0   16   48   33  104
#[Out]# 29      0   16   48   66  187
#[Out]# ...   ...  ...  ...  ...  ...
#[Out]# 8594   28  190  818  136  350
#[Out]# 8595   28  190  818  161  393
#[Out]# 8596   28  190  818  162  397
#[Out]# 8597   28  190  818  169  428
#[Out]# 8598   28  190  818  170  438
#[Out]# 8599   28  190  818  175  445
#[Out]# 8600   28  190  821    5   23
#[Out]# 8601   28  190  821   22   73
#[Out]# 8602   28  190  821   35  111
#[Out]# 8603   28  190  821   39  123
#[Out]# 8604   28  190  821   40  124
#[Out]# 8605   28  190  821   60  180
#[Out]# 8606   28  190  821   70  197
#[Out]# 8607   28  190  821   71  200
#[Out]# 8608   28  190  821   82  224
#[Out]# 8609   28  190  821   86  234
#[Out]# 8610   28  190  821  100  271
#[Out]# 8611   28  190  821  108  280
#[Out]# 8612   28  190  821  118  307
#[Out]# 8613   28  190  821  123  320
#[Out]# 8614   28  190  821  124  325
#[Out]# 8615   28  190  821  127  337
#[Out]# 8616   28  190  821  136  350
#[Out]# 8617   28  190  821  161  393
#[Out]# 8618   28  190  821  162  397
#[Out]# 8619   28  190  821  169  428
#[Out]# 8620   28  190  821  170  438
#[Out]# 8621   28  190  821  175  445
#[Out]# 8622   29  185  778  186  779
#[Out]# 8623   29  186  779  185  778
#[Out]# 
#[Out]# [8624 rows x 5 columns]
query1 = '''
select pID
from product
where pID not in
    (select distinct (p1.pId) 
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    and p1.cID <> p3.cID
    order by p1.pID);
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
select pID
from purchase
where pID not in
    (select distinct (p1.pId) 
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    and p1.cID <> p3.cID
    order by p1.pID);
    
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
select distinct (pID)
from purchase
where pID not in
    (select distinct (p1.pId) 
    from purchase p1, purchase p2, purchase p3
    where p1.pID = p2.pID
    and p2.pID = p3.pID
    and p1.cID <> p2.cID
    and p2.cID <> p3.cID
    and p1.cID <> p3.cID
    order by p1.pID);
        
'''

# Step 1: first select products that were bought by at least 3 customers, thus >=3.
# Done via select 2 purchase tables, same productID but 3 customerID.
# Step 2: then deduct from the total product inventory with the selected product in step 1.
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    select c1.cID , c1.cName
from customer c1, customer c2, purchase p1,purchase p2, product pr
where p1.pID = p2.pID
and p1.date = p2.date
and p1.cID <> p2.cID
and pr.pName = 'Onions'
and pr.pName = 'Coffee'
and p1.pId = pr.pID
and p2.pId = pr.pID
and p1.cID = c1.cID
and p2.cID = c2.cID

union

select c2.cID , c2.cName
from customer c1, customer c2, purchase p1,purchase p2, product pr
where p1.pID = p2.pID
and p1.date = p2.date
and p1.cID <> p2.cID
and (pr.pName = 'Onions'
or pr.pName = 'Coffee')
and p1.pId = pr.pID
and p2.pId = pr.pID
and p1.cID = c1.cID
and p2.cID = c2.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID    cName
#[Out]# 0    29    Ruben
#[Out]# 1    31  Olivier
#[Out]# 2    33     Sven
#[Out]# 3    42     Tijn
#[Out]# 4    52   Willem
#[Out]# 5    59     Joep
#[Out]# 6    85   Pieter
#[Out]# 7    86     Stef
#[Out]# 8    92    Jelte
#[Out]# 9    97   Sophie
#[Out]# 10  108     Noor
#[Out]# 11  110     Saar
#[Out]# 12  111   Lauren
#[Out]# 13  122     Elin
#[Out]# 14  124    Sofie
#[Out]# 15  129    Esmee
#[Out]# 16  152     Anne
#[Out]# 17  171    Tessa
#[Out]# 18  172     Lana
#[Out]# 19  175      Sam
#[Out]# 20  176    Amira
#[Out]# 21  177    Eline
#[Out]# 22  190   Kostas
query3 = '''
   
select cID
from purchase
group by cID
    having count(sID) = (select count () from store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    select s.sName, avg(p.quantity)
from purchase p, store s
where s.sID = p.sID
group by s.sName
    having avg(p.quantity)> 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg(p.quantity)
#[Out]# 0  Albert Hein         4.969697
#[Out]# 1         Coop         4.681818
#[Out]# 2         Dirk         5.268293
#[Out]# 3    Hoogvliet         5.280000
#[Out]# 4         Lidl         4.796875
#[Out]# 5       Sligro         4.674419
query5 = '''
 with highest_price (h_ProductName, h_StoreName, h_Price) as
    (
    select p.pName, s.sName, max(pur.price)
    from purchase pur, product p, store s
    where p.pID = pur.pID
    and pur.sID = s.sID
    ) 
    
select h_ProductName, h_StoreName
from highest_price
'''

pd.read_sql_query(query5, conn)
#[Out]#   h_ProductName h_StoreName
#[Out]# 0          Beef      Sligro
query6 = '''
    select  max(i1.unit_price - i2.unit_price) as MaxDiff
from inventory i1, inventory i2
where i1.pID = i2.pID
and i1.date = '2018-08-23'
and i1.sID <> i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MaxDiff
#[Out]# 0     3.25
practicequery1a = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1a, conn)
