# IPython log file

query2 = '''
    SELECT c.pID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
'''

pd.read_sql_query(query2, conn)
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query2 = '''
    SELECT c.pID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
'''

pd.read_sql_query(query2, conn)
query1 = '''
    SELECT pID
    FROM purchase p
    EXCEPT
        SELECT pu1.pID
        FROM purchase pu1, purchase pu2, purchase pu3
        WHERE pu1.pID=pu2.pID AND pu1.pID=pu3.pID
            AND pu1.cID<>pu2.cID
            AND pu1.cID<>pu3.cID
            AND pu3.cID<>pu2.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT c.pID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
       
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' 
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
       
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
       
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
       
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' 
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr1.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr1.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr1.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID   cName  pID
#[Out]# 0      2   Lucas    4
#[Out]# 1      2   Lucas    4
#[Out]# 2      2   Lucas    4
#[Out]# 3      2   Lucas    4
#[Out]# 4      2   Lucas    4
#[Out]# 5      2   Lucas    4
#[Out]# 6      2   Lucas    4
#[Out]# 7      2   Lucas    4
#[Out]# 8      2   Lucas    4
#[Out]# 9      2   Lucas    4
#[Out]# 10     2   Lucas    4
#[Out]# 11     2   Lucas    4
#[Out]# 12     2   Lucas    4
#[Out]# 13     2   Lucas    4
#[Out]# 14     2   Lucas    4
#[Out]# 15    29   Ruben    4
#[Out]# 16    29   Ruben    4
#[Out]# 17    29   Ruben    4
#[Out]# 18    29   Ruben    4
#[Out]# 19    29   Ruben    4
#[Out]# 20    29   Ruben    4
#[Out]# 21    29   Ruben    4
#[Out]# 22    29   Ruben    4
#[Out]# 23    29   Ruben    4
#[Out]# 24    29   Ruben    4
#[Out]# 25    29   Ruben    4
#[Out]# 26    29   Ruben    4
#[Out]# 27    29   Ruben    4
#[Out]# 28    29   Ruben    4
#[Out]# 29    29   Ruben    4
#[Out]# ..   ...     ...  ...
#[Out]# 210  177   Eline    4
#[Out]# 211  177   Eline    4
#[Out]# 212  177   Eline    4
#[Out]# 213  177   Eline    4
#[Out]# 214  177   Eline    4
#[Out]# 215  177   Eline    4
#[Out]# 216  177   Eline    4
#[Out]# 217  177   Eline    4
#[Out]# 218  177   Eline    4
#[Out]# 219  177   Eline    4
#[Out]# 220  177   Eline    4
#[Out]# 221  177   Eline    4
#[Out]# 222  177   Eline    4
#[Out]# 223  177   Eline    4
#[Out]# 224  177   Eline    4
#[Out]# 225  190  Kostas    4
#[Out]# 226  190  Kostas    4
#[Out]# 227  190  Kostas    4
#[Out]# 228  190  Kostas    4
#[Out]# 229  190  Kostas    4
#[Out]# 230  190  Kostas    4
#[Out]# 231  190  Kostas    4
#[Out]# 232  190  Kostas    4
#[Out]# 233  190  Kostas    4
#[Out]# 234  190  Kostas    4
#[Out]# 235  190  Kostas    4
#[Out]# 236  190  Kostas    4
#[Out]# 237  190  Kostas    4
#[Out]# 238  190  Kostas    4
#[Out]# 239  190  Kostas    4
#[Out]# 
#[Out]# [240 rows x 3 columns]
query2 = '''
    SELECT c.cID, c.cName, pr1.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID
#[Out]# 0   59    Joep    4
#[Out]# 1  124   Sofie    4
#[Out]# 2  169    Lily    4
#[Out]# 3  176   Amira    4
#[Out]# 4  190  Kostas    4
#[Out]# 5  190  Kostas    4
#[Out]# 6  190  Kostas    4
#[Out]# 7  190  Kostas    4
query2 = '''
    SELECT c.cID, c.cName, pr1.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.date=pu2.date
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID
#[Out]# 0  124   Sofie    4
#[Out]# 1  190  Kostas    4
query2 = '''
    SELECT c.cID, c.cName, pr1.pID, pu1.date
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.date=pu2.date
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID        date
#[Out]# 0  124   Sofie    4  2018-08-26
#[Out]# 1  190  Kostas    4  2018-08-26
query2 = '''
    SELECT c.cID, c.cName, pr1.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.date=pu2.date
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID
#[Out]# 0  124   Sofie    4
#[Out]# 1  190  Kostas    4
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.date=pu2.date
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT sID
    FROM store s, purchase p
    WHERE s.sID
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT s.sID
    FROM store s, purchase p
    WHERE s.sID
    
'''

pd.read_sql_query(query3, conn)
#[Out]#        sID
#[Out]# 0        1
#[Out]# 1        1
#[Out]# 2        1
#[Out]# 3        1
#[Out]# 4        1
#[Out]# 5        1
#[Out]# 6        1
#[Out]# 7        1
#[Out]# 8        1
#[Out]# 9        1
#[Out]# 10       1
#[Out]# 11       1
#[Out]# 12       1
#[Out]# 13       1
#[Out]# 14       1
#[Out]# 15       1
#[Out]# 16       1
#[Out]# 17       1
#[Out]# 18       1
#[Out]# 19       1
#[Out]# 20       1
#[Out]# 21       1
#[Out]# 22       1
#[Out]# 23       1
#[Out]# 24       1
#[Out]# 25       1
#[Out]# 26       1
#[Out]# 27       1
#[Out]# 28       1
#[Out]# 29       1
#[Out]# ...    ...
#[Out]# 32037   63
#[Out]# 32038   63
#[Out]# 32039   63
#[Out]# 32040   63
#[Out]# 32041   63
#[Out]# 32042   63
#[Out]# 32043   63
#[Out]# 32044   63
#[Out]# 32045   63
#[Out]# 32046   63
#[Out]# 32047   63
#[Out]# 32048   63
#[Out]# 32049   63
#[Out]# 32050   63
#[Out]# 32051   63
#[Out]# 32052   63
#[Out]# 32053   63
#[Out]# 32054   63
#[Out]# 32055   63
#[Out]# 32056   63
#[Out]# 32057   63
#[Out]# 32058   63
#[Out]# 32059   63
#[Out]# 32060   63
#[Out]# 32061   63
#[Out]# 32062   63
#[Out]# 32063   63
#[Out]# 32064   63
#[Out]# 32065   63
#[Out]# 32066   63
#[Out]# 
#[Out]# [32067 rows x 1 columns]
query3 = '''
    SELECT sID
    FROM store
    WHERE sID
    
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID
#[Out]# 0     1
#[Out]# 1     2
#[Out]# 2     3
#[Out]# 3     4
#[Out]# 4     5
#[Out]# 5     6
#[Out]# 6     7
#[Out]# 7     8
#[Out]# 8     9
#[Out]# 9    10
#[Out]# 10   11
#[Out]# 11   12
#[Out]# 12   13
#[Out]# 13   14
#[Out]# 14   15
#[Out]# 15   16
#[Out]# 16   17
#[Out]# 17   18
#[Out]# 18   19
#[Out]# 19   20
#[Out]# 20   21
#[Out]# 21   22
#[Out]# 22   23
#[Out]# 23   24
#[Out]# 24   25
#[Out]# 25   26
#[Out]# 26   27
#[Out]# 27   28
#[Out]# 28   29
#[Out]# 29   30
#[Out]# ..  ...
#[Out]# 33   34
#[Out]# 34   35
#[Out]# 35   36
#[Out]# 36   37
#[Out]# 37   38
#[Out]# 38   39
#[Out]# 39   40
#[Out]# 40   41
#[Out]# 41   42
#[Out]# 42   43
#[Out]# 43   44
#[Out]# 44   45
#[Out]# 45   46
#[Out]# 46   47
#[Out]# 47   48
#[Out]# 48   49
#[Out]# 49   50
#[Out]# 50   51
#[Out]# 51   52
#[Out]# 52   53
#[Out]# 53   54
#[Out]# 54   55
#[Out]# 55   56
#[Out]# 56   57
#[Out]# 57   58
#[Out]# 58   59
#[Out]# 59   60
#[Out]# 60   61
#[Out]# 61   62
#[Out]# 62   63
#[Out]# 
#[Out]# [63 rows x 1 columns]
query3 = '''
    SELECT sID
    FROM store
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# ..  ...
#[Out]# 34   34
#[Out]# 35   35
#[Out]# 36   36
#[Out]# 37   37
#[Out]# 38   38
#[Out]# 39   39
#[Out]# 40   40
#[Out]# 41   41
#[Out]# 42   42
#[Out]# 43   43
#[Out]# 44   44
#[Out]# 45   45
#[Out]# 46   46
#[Out]# 47   47
#[Out]# 48   48
#[Out]# 49   49
#[Out]# 50   50
#[Out]# 51   51
#[Out]# 52   52
#[Out]# 53   53
#[Out]# 54   54
#[Out]# 55   55
#[Out]# 56   56
#[Out]# 57   57
#[Out]# 58   58
#[Out]# 59   59
#[Out]# 60   60
#[Out]# 61   61
#[Out]# 62   62
#[Out]# 63   63
#[Out]# 
#[Out]# [64 rows x 1 columns]
query3 = '''
    SELECT sName
    FROM store
    WHERE sID
'''

pd.read_sql_query(query3, conn)
#[Out]#           sName
#[Out]# 0     Hoogvliet
#[Out]# 1         Jumbo
#[Out]# 2        Sligro
#[Out]# 3     Hoogvliet
#[Out]# 4        Sligro
#[Out]# 5          Coop
#[Out]# 6        Sligro
#[Out]# 7   Albert Hein
#[Out]# 8   Albert Hein
#[Out]# 9         Jumbo
#[Out]# 10  Albert Hein
#[Out]# 11         Lidl
#[Out]# 12         Coop
#[Out]# 13         Coop
#[Out]# 14         Lidl
#[Out]# 15         Lidl
#[Out]# 16    Hoogvliet
#[Out]# 17       Sligro
#[Out]# 18         Coop
#[Out]# 19        Jumbo
#[Out]# 20         Coop
#[Out]# 21         Lidl
#[Out]# 22         Dirk
#[Out]# 23  Albert Hein
#[Out]# 24  Albert Hein
#[Out]# 25    Hoogvliet
#[Out]# 26       Sligro
#[Out]# 27    Hoogvliet
#[Out]# 28       Sligro
#[Out]# 29         Dirk
#[Out]# ..          ...
#[Out]# 33         Coop
#[Out]# 34         Lidl
#[Out]# 35         Lidl
#[Out]# 36        Jumbo
#[Out]# 37    Hoogvliet
#[Out]# 38       Sligro
#[Out]# 39    Hoogvliet
#[Out]# 40  Albert Hein
#[Out]# 41       Sligro
#[Out]# 42         Coop
#[Out]# 43  Albert Hein
#[Out]# 44         Coop
#[Out]# 45         Lidl
#[Out]# 46         Coop
#[Out]# 47    Hoogvliet
#[Out]# 48    Hoogvliet
#[Out]# 49       Sligro
#[Out]# 50         Coop
#[Out]# 51         Lidl
#[Out]# 52         Coop
#[Out]# 53         Dirk
#[Out]# 54         Coop
#[Out]# 55        Jumbo
#[Out]# 56         Dirk
#[Out]# 57         Dirk
#[Out]# 58        Jumbo
#[Out]# 59         Lidl
#[Out]# 60         Lidl
#[Out]# 61        Jumbo
#[Out]# 62        Jumbo
#[Out]# 
#[Out]# [63 rows x 1 columns]
query3 = '''
    SELECT sName
    FROM store
'''

pd.read_sql_query(query3, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16         Lidl
#[Out]# 17    Hoogvliet
#[Out]# 18       Sligro
#[Out]# 19         Coop
#[Out]# 20        Jumbo
#[Out]# 21         Coop
#[Out]# 22         Lidl
#[Out]# 23         Dirk
#[Out]# 24  Albert Hein
#[Out]# 25  Albert Hein
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28    Hoogvliet
#[Out]# 29       Sligro
#[Out]# ..          ...
#[Out]# 34         Coop
#[Out]# 35         Lidl
#[Out]# 36         Lidl
#[Out]# 37        Jumbo
#[Out]# 38    Hoogvliet
#[Out]# 39       Sligro
#[Out]# 40    Hoogvliet
#[Out]# 41  Albert Hein
#[Out]# 42       Sligro
#[Out]# 43         Coop
#[Out]# 44  Albert Hein
#[Out]# 45         Coop
#[Out]# 46         Lidl
#[Out]# 47         Coop
#[Out]# 48    Hoogvliet
#[Out]# 49    Hoogvliet
#[Out]# 50       Sligro
#[Out]# 51         Coop
#[Out]# 52         Lidl
#[Out]# 53         Coop
#[Out]# 54         Dirk
#[Out]# 55         Coop
#[Out]# 56        Jumbo
#[Out]# 57         Dirk
#[Out]# 58         Dirk
#[Out]# 59        Jumbo
#[Out]# 60         Lidl
#[Out]# 61         Lidl
#[Out]# 62        Jumbo
#[Out]# 63        Jumbo
#[Out]# 
#[Out]# [64 rows x 1 columns]
query3 = '''
    SELECT cID
    FROM purchase p
    WHERE sID IN ( 
                 SELECT sID
                 FROM store
               )
    GROUP BY cID
    HAVING COUNT(*) = ( 
                        SELECT COUNT (*)
                        FROM p
                      )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT cID
    FROM purchase
    WHERE sID IN ( 
                 SELECT sID
                 FROM store
               )
    GROUP BY cID
    HAVING COUNT(*) = ( 
                        SELECT COUNT (*)
                        FROM p
                      )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT cID
    FROM purchase
    WHERE sID IN ( 
                 SELECT sID
                 FROM store
               )
    GROUP BY cID
    HAVING COUNT(*) = ( 
                        SELECT COUNT (*)
                        FROM purchase
                      )
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID
    FROM purchase
    WHERE sID IN ( 
                 SELECT sID
                 FROM store
               )
    GROUP BY cID
    HAVING COUNT(*) = ( 
                        SELECT COUNT (*)
                        FROM store
                      )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT cID
    FROM purchase
    WHERE sID IN ( 
                 SELECT sID
                 FROM store
               )
    GROUP BY cID
    HAVING COUNT(*) = ( 
                        SELECT COUNT (*)
                        FROM store
                      )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT sName
    FROM store
    WHERE sID
    GROUP BY sName
    HAVING COUNT(sID)>1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>4
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>5
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>6
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>200
    
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>10
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>15
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT sID, AVG(i.quantity)
    FROM store s, inventory i
    WHERE s.sID=i.sID
    GROUP BY s.sName
    HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT i.sID, AVG(i.quantity)
    FROM store s, inventory i
    WHERE s.sID=i.sID
    GROUP BY s.sName
    HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID  AVG(i.quantity)
#[Out]# 0   24        18.008475
#[Out]# 1    0        16.695000
#[Out]# 2   57        20.884615
#[Out]# 3    4        16.898438
#[Out]# 4   56        16.312500
#[Out]# 5   60        25.048077
#[Out]# 6   27        16.795620
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s, inventory i
    WHERE s.sID=i.sID
    GROUP BY s.sName
    HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.008475
#[Out]# 1         Coop        16.695000
#[Out]# 2         Dirk        20.884615
#[Out]# 3    Hoogvliet        16.898438
#[Out]# 4        Jumbo        16.312500
#[Out]# 5         Lidl        25.048077
#[Out]# 6       Sligro        16.795620
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s, inventory i
    WHERE s.sID=i.sID
    GROUP BY s.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.008475
#[Out]# 1         Coop        16.695000
#[Out]# 2         Dirk        20.884615
#[Out]# 3    Hoogvliet        16.898438
#[Out]# 4        Jumbo        16.312500
#[Out]# 5         Lidl        25.048077
#[Out]# 6       Sligro        16.795620
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s, inventory i
    WHERE s.sID=i.sID
    GROUP BY s.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.008475
#[Out]# 1         Coop        16.695000
#[Out]# 2         Dirk        20.884615
#[Out]# 3    Hoogvliet        16.898438
#[Out]# 4        Jumbo        16.312500
#[Out]# 5         Lidl        25.048077
#[Out]# 6       Sligro        16.795620
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s, inventory i
    GROUP BY s.sName
    HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.342581
#[Out]# 1         Coop        18.342581
#[Out]# 2         Dirk        18.342581
#[Out]# 3    Hoogvliet        18.342581
#[Out]# 4        Jumbo        18.342581
#[Out]# 5         Lidl        18.342581
#[Out]# 6       Sligro        18.342581
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName, AVG(i.quantity)
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName  AVG(i.quantity)
#[Out]# 0  Jumbo        18.342581
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1         Coop
#[Out]# 2         Coop
#[Out]# 3         Coop
#[Out]# 4         Coop
#[Out]# 5         Coop
#[Out]# 6         Coop
#[Out]# 7         Coop
#[Out]# 8         Coop
#[Out]# 9         Coop
#[Out]# 10        Coop
#[Out]# 11        Coop
#[Out]# 12        Coop
#[Out]# 13   Hoogvliet
#[Out]# 14   Hoogvliet
#[Out]# 15   Hoogvliet
#[Out]# 16   Hoogvliet
#[Out]# 17   Hoogvliet
#[Out]# 18   Hoogvliet
#[Out]# 19   Hoogvliet
#[Out]# 20   Hoogvliet
#[Out]# 21       Jumbo
#[Out]# 22       Jumbo
#[Out]# 23       Jumbo
#[Out]# 24       Jumbo
#[Out]# 25       Jumbo
#[Out]# 26       Jumbo
#[Out]# 27       Jumbo
#[Out]# 28      Sligro
#[Out]# 29      Sligro
#[Out]# ..         ...
#[Out]# 528       Lidl
#[Out]# 529       Lidl
#[Out]# 530       Lidl
#[Out]# 531       Lidl
#[Out]# 532       Lidl
#[Out]# 533       Lidl
#[Out]# 534       Lidl
#[Out]# 535       Lidl
#[Out]# 536       Lidl
#[Out]# 537       Lidl
#[Out]# 538       Lidl
#[Out]# 539       Lidl
#[Out]# 540       Lidl
#[Out]# 541       Lidl
#[Out]# 542       Lidl
#[Out]# 543       Lidl
#[Out]# 544      Jumbo
#[Out]# 545      Jumbo
#[Out]# 546      Jumbo
#[Out]# 547      Jumbo
#[Out]# 548      Jumbo
#[Out]# 549      Jumbo
#[Out]# 550      Jumbo
#[Out]# 551      Jumbo
#[Out]# 552      Jumbo
#[Out]# 553      Jumbo
#[Out]# 554      Jumbo
#[Out]# 555      Jumbo
#[Out]# 556      Jumbo
#[Out]# 557      Jumbo
#[Out]# 
#[Out]# [558 rows x 1 columns]
query4 = '''
    SELECT DISTINCT s1.sName
    FROM store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2        Jumbo
#[Out]# 3       Sligro
#[Out]# 4  Albert Hein
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
            AND i.sID=s1.sID
    GROUP BY s1.sName
        HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query5 = '''
    SELECT pr.pName
    FROM product pr, purchase pu
    WHERE pr.pID=pu.pID AND MAX(pu.price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM product pr, purchase pu, store s
    WHERE pr.pID=pu.pID AND s.sID=pu.sID 
    
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 479           Lasanga         Coop
#[Out]# 480             Pizza         Lidl
#[Out]# 481         Mushrooms         Lidl
#[Out]# 482           Lasanga        Jumbo
#[Out]# 483          Tomatoes    Hoogvliet
#[Out]# 484       Cashew Nuts       Sligro
#[Out]# 485              Milk    Hoogvliet
#[Out]# 486           Carrots  Albert Hein
#[Out]# 487              Coca       Sligro
#[Out]# 488             Bread         Coop
#[Out]# 489           Bananas  Albert Hein
#[Out]# 490              Milk         Coop
#[Out]# 491               Tea         Lidl
#[Out]# 492             Bread         Coop
#[Out]# 493             Fanta    Hoogvliet
#[Out]# 494              Milk    Hoogvliet
#[Out]# 495            Coffee       Sligro
#[Out]# 496   Spiced Biscuits         Coop
#[Out]# 497   Spiced Biscuits         Lidl
#[Out]# 498  Hot Dog Sausages         Coop
#[Out]# 499       Cashew Nuts         Dirk
#[Out]# 500  Hot Dog Sausages         Coop
#[Out]# 501              Milk        Jumbo
#[Out]# 502         Cucumbers         Dirk
#[Out]# 503          Potatoes         Dirk
#[Out]# 504             Bread        Jumbo
#[Out]# 505         Mushrooms         Lidl
#[Out]# 506              Coca         Lidl
#[Out]# 507           Bananas        Jumbo
#[Out]# 508            Cheese        Jumbo
#[Out]# 
#[Out]# [509 rows x 2 columns]
query5 = '''
        WITH max_price(value) as (
        SELECT MAX(price)
        FROM inventory
    )
    SELECT pr.pName, s.sName
    FROM product pr, purchase pu, store s
    WHERE pr.pID=pu.pID AND s.sID=pu.sID 
    
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 479           Lasanga         Coop
#[Out]# 480             Pizza         Lidl
#[Out]# 481         Mushrooms         Lidl
#[Out]# 482           Lasanga        Jumbo
#[Out]# 483          Tomatoes    Hoogvliet
#[Out]# 484       Cashew Nuts       Sligro
#[Out]# 485              Milk    Hoogvliet
#[Out]# 486           Carrots  Albert Hein
#[Out]# 487              Coca       Sligro
#[Out]# 488             Bread         Coop
#[Out]# 489           Bananas  Albert Hein
#[Out]# 490              Milk         Coop
#[Out]# 491               Tea         Lidl
#[Out]# 492             Bread         Coop
#[Out]# 493             Fanta    Hoogvliet
#[Out]# 494              Milk    Hoogvliet
#[Out]# 495            Coffee       Sligro
#[Out]# 496   Spiced Biscuits         Coop
#[Out]# 497   Spiced Biscuits         Lidl
#[Out]# 498  Hot Dog Sausages         Coop
#[Out]# 499       Cashew Nuts         Dirk
#[Out]# 500  Hot Dog Sausages         Coop
#[Out]# 501              Milk        Jumbo
#[Out]# 502         Cucumbers         Dirk
#[Out]# 503          Potatoes         Dirk
#[Out]# 504             Bread        Jumbo
#[Out]# 505         Mushrooms         Lidl
#[Out]# 506              Coca         Lidl
#[Out]# 507           Bananas        Jumbo
#[Out]# 508            Cheese        Jumbo
#[Out]# 
#[Out]# [509 rows x 2 columns]
query5 = '''
        WITH max_price(value) as (
        SELECT MAX(unit_price)
        FROM inventory
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.value=i.unit_price
    
'''

pd.read_sql_query(query5, conn)
query5 = '''
        WITH max_price(value) as (
        SELECT MAX(unit_price)
        FROM inventory
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, inventory i, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.value=i.unit_price
    
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName
#[Out]# 0  Beef  Albert Hein
query5 = '''
        WITH max_price(price) as (
        SELECT MAX(unit_price)
        FROM inventory
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, inventory i, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.price=i.unit_price
    
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName
#[Out]# 0  Beef  Albert Hein
query6 = '''
    SELECT MAX (i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i1.date=i2.date 
        AND i1.sID<>i2.sID
        AND i1.pID=i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX (i1.unit_price - i2.unit_price)
#[Out]# 0                                  2.0
query5 = '''
        WITH max_price(price2) as (
        SELECT MAX(price)
        FROM purchase
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, inventory i, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.price2=i.price
    
'''

pd.read_sql_query(query5, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query5 = '''
        WITH max_price(price2) as (
        SELECT MAX(price)
        FROM purchase
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, inventory i, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.price2=i.price
    
'''

pd.read_sql_query(query5, conn)
query5 = '''
        WITH max_price(value) as (
        SELECT MAX(unit_price)
        FROM inventory
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, inventoryi, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.value=i.unit_price
    
'''

pd.read_sql_query(query5, conn)
query5 = '''
        WITH max_price(value) as (
        SELECT MAX(unit_price)
        FROM inventory
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, inventory i, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.value=i.unit_price
    
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName
#[Out]# 0  Beef  Albert Hein
query5 = '''
        WITH max_price(value) as (
        SELECT MAX(price)
        FROM purchase
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, purchase pu, max_price m
    WHERE pr.pID=pu.pID AND s.sID=pu.sID 
        AND m.value=pu.price
    
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.date=pu2.date
        
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID    cName
#[Out]# 0      0     Noah
#[Out]# 1      0     Noah
#[Out]# 2      1      Sem
#[Out]# 3      1      Sem
#[Out]# 4      2    Lucas
#[Out]# 5      2    Lucas
#[Out]# 6      3     Finn
#[Out]# 7      3     Finn
#[Out]# 8      4     Daan
#[Out]# 9      4     Daan
#[Out]# 10     5     Levi
#[Out]# 11     5     Levi
#[Out]# 12     6    Milan
#[Out]# 13     6    Milan
#[Out]# 14     7     Bram
#[Out]# 15     7     Bram
#[Out]# 16     8     Liam
#[Out]# 17     8     Liam
#[Out]# 18     9   Thomas
#[Out]# 19     9   Thomas
#[Out]# 20    10      Sam
#[Out]# 21    10      Sam
#[Out]# 22    11    Thijs
#[Out]# 23    11    Thijs
#[Out]# 24    12     Adam
#[Out]# 25    12     Adam
#[Out]# 26    13    James
#[Out]# 27    13    James
#[Out]# 28    14      Max
#[Out]# 29    14      Max
#[Out]# ..   ...      ...
#[Out]# 350  175      Sam
#[Out]# 351  175      Sam
#[Out]# 352  176    Amira
#[Out]# 353  176    Amira
#[Out]# 354  177    Eline
#[Out]# 355  177    Eline
#[Out]# 356  178     Elif
#[Out]# 357  178     Elif
#[Out]# 358  179     Juul
#[Out]# 359  179     Juul
#[Out]# 360  180    Merel
#[Out]# 361  180    Merel
#[Out]# 362  181     Liva
#[Out]# 363  181     Liva
#[Out]# 364  182  Johanna
#[Out]# 365  182  Johanna
#[Out]# 366  183    Nikki
#[Out]# 367  183    Nikki
#[Out]# 368  184    Wilko
#[Out]# 369  184    Wilko
#[Out]# 370  185     Nick
#[Out]# 371  185     Nick
#[Out]# 372  186   Angela
#[Out]# 373  186   Angela
#[Out]# 374  188     Pino
#[Out]# 375  188     Pino
#[Out]# 376  189     Koen
#[Out]# 377  189     Koen
#[Out]# 378  190   Kostas
#[Out]# 379  190   Kostas
#[Out]# 
#[Out]# [380 rows x 2 columns]
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.date=pu2.date
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
            AND i.sID=s1.sID
    GROUP BY (
        SELECT sName
        FROM purchase p, store s
        WHERE s.sID=p.sID)
        
        HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#   sName
#[Out]# 0  Coop
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
            
    GROUP BY (
        SELECT sName
        FROM purchase p, store s
        WHERE s.sID=p.sID)
        
        HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName
#[Out]# 0  Jumbo
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
            AND i.sID=s1.sID
            
    GROUP BY (
        SELECT sName
        FROM purchase p, store s
        WHERE s.sID=p.sID)
        
        HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#   sName
#[Out]# 0  Coop
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
            
    GROUP BY (
        SELECT sName
        FROM purchase p, store s
        WHERE s.sID=p.sID)
        
        HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName
#[Out]# 0  Jumbo
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
            
    GROUP BY (
        SELECT sName
        FROM purchase p, store s
        WHERE s.sID=p.sID)
    HAVING AVG(p.quantity)>4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, purchase p
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
            
    GROUP BY (
        SELECT sName
        FROM purchase p, store s
        WHERE s.sID=p.sID)
    HAVING AVG(p.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName
#[Out]# 0  Jumbo
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, purchase p
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
            
    GROUP BY (
        SELECT sName
        FROM purchase p, store s
        WHERE s.sID=p.sID
        )
    HAVING AVG(p.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName
#[Out]# 0  Jumbo
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, purchase p
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
            
    GROUP BY (
        SELECT sName
        FROM purchase p2, store s
        WHERE s.sID=p2.sID
        )
    HAVING AVG(p.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName
#[Out]# 0  Jumbo
query4 = '''
    WITH chain_quan_avg (sName, avg_quan) as (
        SELECT sName, AVG(p.quantity)
        FROM store s, purchase p
        GROUP BY sName
    )
    
    SELECT sName
    FROM chain_quan_avg ch, store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND avg_quan>4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    WITH chain_quan_avg (sName, avg_quan) as (
        SELECT sName, AVG(p.quantity)
        FROM store s, purchase p
        GROUP BY sName
    )
    
    SELECT ch.sName
    FROM chain_quan_avg ch, store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND avg_quan>4
'''

pd.read_sql_query(query4, conn)
#[Out]#             sName
#[Out]# 0     Albert Hein
#[Out]# 1     Albert Hein
#[Out]# 2     Albert Hein
#[Out]# 3     Albert Hein
#[Out]# 4     Albert Hein
#[Out]# 5     Albert Hein
#[Out]# 6     Albert Hein
#[Out]# 7     Albert Hein
#[Out]# 8     Albert Hein
#[Out]# 9     Albert Hein
#[Out]# 10    Albert Hein
#[Out]# 11    Albert Hein
#[Out]# 12    Albert Hein
#[Out]# 13    Albert Hein
#[Out]# 14    Albert Hein
#[Out]# 15    Albert Hein
#[Out]# 16    Albert Hein
#[Out]# 17    Albert Hein
#[Out]# 18    Albert Hein
#[Out]# 19    Albert Hein
#[Out]# 20    Albert Hein
#[Out]# 21    Albert Hein
#[Out]# 22    Albert Hein
#[Out]# 23    Albert Hein
#[Out]# 24    Albert Hein
#[Out]# 25    Albert Hein
#[Out]# 26    Albert Hein
#[Out]# 27    Albert Hein
#[Out]# 28    Albert Hein
#[Out]# 29    Albert Hein
#[Out]# ...           ...
#[Out]# 3876       Sligro
#[Out]# 3877       Sligro
#[Out]# 3878       Sligro
#[Out]# 3879       Sligro
#[Out]# 3880       Sligro
#[Out]# 3881       Sligro
#[Out]# 3882       Sligro
#[Out]# 3883       Sligro
#[Out]# 3884       Sligro
#[Out]# 3885       Sligro
#[Out]# 3886       Sligro
#[Out]# 3887       Sligro
#[Out]# 3888       Sligro
#[Out]# 3889       Sligro
#[Out]# 3890       Sligro
#[Out]# 3891       Sligro
#[Out]# 3892       Sligro
#[Out]# 3893       Sligro
#[Out]# 3894       Sligro
#[Out]# 3895       Sligro
#[Out]# 3896       Sligro
#[Out]# 3897       Sligro
#[Out]# 3898       Sligro
#[Out]# 3899       Sligro
#[Out]# 3900       Sligro
#[Out]# 3901       Sligro
#[Out]# 3902       Sligro
#[Out]# 3903       Sligro
#[Out]# 3904       Sligro
#[Out]# 3905       Sligro
#[Out]# 
#[Out]# [3906 rows x 1 columns]
query4 = '''
    WITH chain_quan_avg (sName, avg_quan) as (
        SELECT sName, AVG(quantity)
        FROM store s, purchase p
        WHERE s.sID=p.sID
        GROUP BY sName
    )
    
    SELECT ch.sName
    FROM chain_quan_avg ch, store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND avg_quan>4
'''

pd.read_sql_query(query4, conn)
#[Out]#             sName
#[Out]# 0     Albert Hein
#[Out]# 1     Albert Hein
#[Out]# 2     Albert Hein
#[Out]# 3     Albert Hein
#[Out]# 4     Albert Hein
#[Out]# 5     Albert Hein
#[Out]# 6     Albert Hein
#[Out]# 7     Albert Hein
#[Out]# 8     Albert Hein
#[Out]# 9     Albert Hein
#[Out]# 10    Albert Hein
#[Out]# 11    Albert Hein
#[Out]# 12    Albert Hein
#[Out]# 13    Albert Hein
#[Out]# 14    Albert Hein
#[Out]# 15    Albert Hein
#[Out]# 16    Albert Hein
#[Out]# 17    Albert Hein
#[Out]# 18    Albert Hein
#[Out]# 19    Albert Hein
#[Out]# 20    Albert Hein
#[Out]# 21    Albert Hein
#[Out]# 22    Albert Hein
#[Out]# 23    Albert Hein
#[Out]# 24    Albert Hein
#[Out]# 25    Albert Hein
#[Out]# 26    Albert Hein
#[Out]# 27    Albert Hein
#[Out]# 28    Albert Hein
#[Out]# 29    Albert Hein
#[Out]# ...           ...
#[Out]# 3318       Sligro
#[Out]# 3319       Sligro
#[Out]# 3320       Sligro
#[Out]# 3321       Sligro
#[Out]# 3322       Sligro
#[Out]# 3323       Sligro
#[Out]# 3324       Sligro
#[Out]# 3325       Sligro
#[Out]# 3326       Sligro
#[Out]# 3327       Sligro
#[Out]# 3328       Sligro
#[Out]# 3329       Sligro
#[Out]# 3330       Sligro
#[Out]# 3331       Sligro
#[Out]# 3332       Sligro
#[Out]# 3333       Sligro
#[Out]# 3334       Sligro
#[Out]# 3335       Sligro
#[Out]# 3336       Sligro
#[Out]# 3337       Sligro
#[Out]# 3338       Sligro
#[Out]# 3339       Sligro
#[Out]# 3340       Sligro
#[Out]# 3341       Sligro
#[Out]# 3342       Sligro
#[Out]# 3343       Sligro
#[Out]# 3344       Sligro
#[Out]# 3345       Sligro
#[Out]# 3346       Sligro
#[Out]# 3347       Sligro
#[Out]# 
#[Out]# [3348 rows x 1 columns]
query4 = '''
    WITH chain_quan_avg (sName, avg_quan) as (
        SELECT sName, AVG(quantity)
        FROM store s, purchase p
        WHERE s.sID=p.sID
        GROUP BY sName
    )
    
    SELECT ch.sName
    FROM chain_quan_avg ch, store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND s1.sName=ch.sName
        AND avg_quan>4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1         Coop
#[Out]# 2         Coop
#[Out]# 3         Coop
#[Out]# 4         Coop
#[Out]# 5         Coop
#[Out]# 6         Coop
#[Out]# 7         Coop
#[Out]# 8         Coop
#[Out]# 9         Coop
#[Out]# 10        Coop
#[Out]# 11        Coop
#[Out]# 12        Coop
#[Out]# 13   Hoogvliet
#[Out]# 14   Hoogvliet
#[Out]# 15   Hoogvliet
#[Out]# 16   Hoogvliet
#[Out]# 17   Hoogvliet
#[Out]# 18   Hoogvliet
#[Out]# 19   Hoogvliet
#[Out]# 20   Hoogvliet
#[Out]# 21      Sligro
#[Out]# 22      Sligro
#[Out]# 23      Sligro
#[Out]# 24      Sligro
#[Out]# 25      Sligro
#[Out]# 26      Sligro
#[Out]# 27      Sligro
#[Out]# 28      Sligro
#[Out]# 29   Hoogvliet
#[Out]# ..         ...
#[Out]# 472       Coop
#[Out]# 473       Coop
#[Out]# 474       Dirk
#[Out]# 475       Dirk
#[Out]# 476       Dirk
#[Out]# 477       Dirk
#[Out]# 478       Dirk
#[Out]# 479       Dirk
#[Out]# 480       Dirk
#[Out]# 481       Dirk
#[Out]# 482       Dirk
#[Out]# 483       Dirk
#[Out]# 484       Lidl
#[Out]# 485       Lidl
#[Out]# 486       Lidl
#[Out]# 487       Lidl
#[Out]# 488       Lidl
#[Out]# 489       Lidl
#[Out]# 490       Lidl
#[Out]# 491       Lidl
#[Out]# 492       Lidl
#[Out]# 493       Lidl
#[Out]# 494       Lidl
#[Out]# 495       Lidl
#[Out]# 496       Lidl
#[Out]# 497       Lidl
#[Out]# 498       Lidl
#[Out]# 499       Lidl
#[Out]# 500       Lidl
#[Out]# 501       Lidl
#[Out]# 
#[Out]# [502 rows x 1 columns]
query4 = '''
    WITH chain_quan_avg (sName, avg_quan) as (
        SELECT sName, AVG(quantity)
        FROM store s, purchase p
        WHERE s.sID=p.sID
        GROUP BY sName
    )
    
    SELECT ch.sName
    FROM chain_quan_avg ch, store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND s1.sName=ch.sName
        AND avg_quan>4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1         Coop
#[Out]# 2         Coop
#[Out]# 3         Coop
#[Out]# 4         Coop
#[Out]# 5         Coop
#[Out]# 6         Coop
#[Out]# 7         Coop
#[Out]# 8         Coop
#[Out]# 9         Coop
#[Out]# 10        Coop
#[Out]# 11        Coop
#[Out]# 12        Coop
#[Out]# 13   Hoogvliet
#[Out]# 14   Hoogvliet
#[Out]# 15   Hoogvliet
#[Out]# 16   Hoogvliet
#[Out]# 17   Hoogvliet
#[Out]# 18   Hoogvliet
#[Out]# 19   Hoogvliet
#[Out]# 20   Hoogvliet
#[Out]# 21      Sligro
#[Out]# 22      Sligro
#[Out]# 23      Sligro
#[Out]# 24      Sligro
#[Out]# 25      Sligro
#[Out]# 26      Sligro
#[Out]# 27      Sligro
#[Out]# 28      Sligro
#[Out]# 29   Hoogvliet
#[Out]# ..         ...
#[Out]# 472       Coop
#[Out]# 473       Coop
#[Out]# 474       Dirk
#[Out]# 475       Dirk
#[Out]# 476       Dirk
#[Out]# 477       Dirk
#[Out]# 478       Dirk
#[Out]# 479       Dirk
#[Out]# 480       Dirk
#[Out]# 481       Dirk
#[Out]# 482       Dirk
#[Out]# 483       Dirk
#[Out]# 484       Lidl
#[Out]# 485       Lidl
#[Out]# 486       Lidl
#[Out]# 487       Lidl
#[Out]# 488       Lidl
#[Out]# 489       Lidl
#[Out]# 490       Lidl
#[Out]# 491       Lidl
#[Out]# 492       Lidl
#[Out]# 493       Lidl
#[Out]# 494       Lidl
#[Out]# 495       Lidl
#[Out]# 496       Lidl
#[Out]# 497       Lidl
#[Out]# 498       Lidl
#[Out]# 499       Lidl
#[Out]# 500       Lidl
#[Out]# 501       Lidl
#[Out]# 
#[Out]# [502 rows x 1 columns]
query4 = '''
    WITH chain_quan_avg (sName, avg_quan) as (
        SELECT sName, AVG(quantity)
        FROM store s, purchase p
        WHERE s.sID=p.sID
        GROUP BY sName
    )
    
    SELECT ch.sName
    FROM chain_quan_avg ch
    WHERE avg_quan>4
'''

pd.read_sql_query(query4, conn)
#[Out]#       ch.sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    WITH chain_quan_avg (sName, avg_quan) as (
        SELECT sName, AVG(quantity)
        FROM store s, purchase p
        WHERE s.sID=p.sID
        GROUP BY sName
    )
    
    SELECT ch.sName
    FROM chain_quan_avg ch
    WHERE avg_quan>4 AND sName in (
        SELECT sName
        FROM store
        GROUP BY sName
        HAVING count(sID>1)
    )
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro

# IPython log file

query2 = '''
    SELECT c.pID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
'''

pd.read_sql_query(query2, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query2 = '''
    SELECT c.pID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
'''

pd.read_sql_query(query2, conn)
query1 = '''
    SELECT pID
    FROM purchase p
    EXCEPT
        SELECT pu1.pID
        FROM purchase pu1, purchase pu2, purchase pu3
        WHERE pu1.pID=pu2.pID AND pu1.pID=pu3.pID
            AND pu1.cID<>pu2.cID
            AND pu1.cID<>pu3.cID
            AND pu3.cID<>pu2.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT c.pID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
       
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' 
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
       
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
       
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
       
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' 
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr
    WHERE pr.pName='Onions' AND pr.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName, pID]
#[Out]# Index: []
query2 = '''
    SELECT c.cID, c.cName, pr.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr1.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr.pID=pu1.pID
        AND pr.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c.cID, c.cName, pr1.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr1.pID=pu2.pID
        AND pu1.cID<>pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID   cName  pID
#[Out]# 0      2   Lucas    4
#[Out]# 1      2   Lucas    4
#[Out]# 2      2   Lucas    4
#[Out]# 3      2   Lucas    4
#[Out]# 4      2   Lucas    4
#[Out]# 5      2   Lucas    4
#[Out]# 6      2   Lucas    4
#[Out]# 7      2   Lucas    4
#[Out]# 8      2   Lucas    4
#[Out]# 9      2   Lucas    4
#[Out]# 10     2   Lucas    4
#[Out]# 11     2   Lucas    4
#[Out]# 12     2   Lucas    4
#[Out]# 13     2   Lucas    4
#[Out]# 14     2   Lucas    4
#[Out]# 15    29   Ruben    4
#[Out]# 16    29   Ruben    4
#[Out]# 17    29   Ruben    4
#[Out]# 18    29   Ruben    4
#[Out]# 19    29   Ruben    4
#[Out]# 20    29   Ruben    4
#[Out]# 21    29   Ruben    4
#[Out]# 22    29   Ruben    4
#[Out]# 23    29   Ruben    4
#[Out]# 24    29   Ruben    4
#[Out]# 25    29   Ruben    4
#[Out]# 26    29   Ruben    4
#[Out]# 27    29   Ruben    4
#[Out]# 28    29   Ruben    4
#[Out]# 29    29   Ruben    4
#[Out]# ..   ...     ...  ...
#[Out]# 210  177   Eline    4
#[Out]# 211  177   Eline    4
#[Out]# 212  177   Eline    4
#[Out]# 213  177   Eline    4
#[Out]# 214  177   Eline    4
#[Out]# 215  177   Eline    4
#[Out]# 216  177   Eline    4
#[Out]# 217  177   Eline    4
#[Out]# 218  177   Eline    4
#[Out]# 219  177   Eline    4
#[Out]# 220  177   Eline    4
#[Out]# 221  177   Eline    4
#[Out]# 222  177   Eline    4
#[Out]# 223  177   Eline    4
#[Out]# 224  177   Eline    4
#[Out]# 225  190  Kostas    4
#[Out]# 226  190  Kostas    4
#[Out]# 227  190  Kostas    4
#[Out]# 228  190  Kostas    4
#[Out]# 229  190  Kostas    4
#[Out]# 230  190  Kostas    4
#[Out]# 231  190  Kostas    4
#[Out]# 232  190  Kostas    4
#[Out]# 233  190  Kostas    4
#[Out]# 234  190  Kostas    4
#[Out]# 235  190  Kostas    4
#[Out]# 236  190  Kostas    4
#[Out]# 237  190  Kostas    4
#[Out]# 238  190  Kostas    4
#[Out]# 239  190  Kostas    4
#[Out]# 
#[Out]# [240 rows x 3 columns]
query2 = '''
    SELECT c.cID, c.cName, pr1.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID
#[Out]# 0   59    Joep    4
#[Out]# 1  124   Sofie    4
#[Out]# 2  169    Lily    4
#[Out]# 3  176   Amira    4
#[Out]# 4  190  Kostas    4
#[Out]# 5  190  Kostas    4
#[Out]# 6  190  Kostas    4
#[Out]# 7  190  Kostas    4
query2 = '''
    SELECT c.cID, c.cName, pr1.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.date=pu2.date
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID
#[Out]# 0  124   Sofie    4
#[Out]# 1  190  Kostas    4
query2 = '''
    SELECT c.cID, c.cName, pr1.pID, pu1.date
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.date=pu2.date
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID        date
#[Out]# 0  124   Sofie    4  2018-08-26
#[Out]# 1  190  Kostas    4  2018-08-26
query2 = '''
    SELECT c.cID, c.cName, pr1.pID
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.date=pu2.date
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName  pID
#[Out]# 0  124   Sofie    4
#[Out]# 1  190  Kostas    4
query2 = '''
    SELECT c.cID, c.cName
    FROM purchase pu1, purchase pu2, customer c, product pr1, product pr2
    WHERE  pr1.pName='Onions' AND pr2.pName='Coffee' 
        AND pr1.pID=pu1.pID
        AND pr2.pID=pu2.pID
        AND pu1.cID=pu2.cID
        AND pu1.date=pu2.date
        AND pu1.cID=c.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT sID
    FROM store s, purchase p
    WHERE s.sID
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT s.sID
    FROM store s, purchase p
    WHERE s.sID
    
'''

pd.read_sql_query(query3, conn)
#[Out]#        sID
#[Out]# 0        1
#[Out]# 1        1
#[Out]# 2        1
#[Out]# 3        1
#[Out]# 4        1
#[Out]# 5        1
#[Out]# 6        1
#[Out]# 7        1
#[Out]# 8        1
#[Out]# 9        1
#[Out]# 10       1
#[Out]# 11       1
#[Out]# 12       1
#[Out]# 13       1
#[Out]# 14       1
#[Out]# 15       1
#[Out]# 16       1
#[Out]# 17       1
#[Out]# 18       1
#[Out]# 19       1
#[Out]# 20       1
#[Out]# 21       1
#[Out]# 22       1
#[Out]# 23       1
#[Out]# 24       1
#[Out]# 25       1
#[Out]# 26       1
#[Out]# 27       1
#[Out]# 28       1
#[Out]# 29       1
#[Out]# ...    ...
#[Out]# 32037   63
#[Out]# 32038   63
#[Out]# 32039   63
#[Out]# 32040   63
#[Out]# 32041   63
#[Out]# 32042   63
#[Out]# 32043   63
#[Out]# 32044   63
#[Out]# 32045   63
#[Out]# 32046   63
#[Out]# 32047   63
#[Out]# 32048   63
#[Out]# 32049   63
#[Out]# 32050   63
#[Out]# 32051   63
#[Out]# 32052   63
#[Out]# 32053   63
#[Out]# 32054   63
#[Out]# 32055   63
#[Out]# 32056   63
#[Out]# 32057   63
#[Out]# 32058   63
#[Out]# 32059   63
#[Out]# 32060   63
#[Out]# 32061   63
#[Out]# 32062   63
#[Out]# 32063   63
#[Out]# 32064   63
#[Out]# 32065   63
#[Out]# 32066   63
#[Out]# 
#[Out]# [32067 rows x 1 columns]
query3 = '''
    SELECT sID
    FROM store
    WHERE sID
    
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID
#[Out]# 0     1
#[Out]# 1     2
#[Out]# 2     3
#[Out]# 3     4
#[Out]# 4     5
#[Out]# 5     6
#[Out]# 6     7
#[Out]# 7     8
#[Out]# 8     9
#[Out]# 9    10
#[Out]# 10   11
#[Out]# 11   12
#[Out]# 12   13
#[Out]# 13   14
#[Out]# 14   15
#[Out]# 15   16
#[Out]# 16   17
#[Out]# 17   18
#[Out]# 18   19
#[Out]# 19   20
#[Out]# 20   21
#[Out]# 21   22
#[Out]# 22   23
#[Out]# 23   24
#[Out]# 24   25
#[Out]# 25   26
#[Out]# 26   27
#[Out]# 27   28
#[Out]# 28   29
#[Out]# 29   30
#[Out]# ..  ...
#[Out]# 33   34
#[Out]# 34   35
#[Out]# 35   36
#[Out]# 36   37
#[Out]# 37   38
#[Out]# 38   39
#[Out]# 39   40
#[Out]# 40   41
#[Out]# 41   42
#[Out]# 42   43
#[Out]# 43   44
#[Out]# 44   45
#[Out]# 45   46
#[Out]# 46   47
#[Out]# 47   48
#[Out]# 48   49
#[Out]# 49   50
#[Out]# 50   51
#[Out]# 51   52
#[Out]# 52   53
#[Out]# 53   54
#[Out]# 54   55
#[Out]# 55   56
#[Out]# 56   57
#[Out]# 57   58
#[Out]# 58   59
#[Out]# 59   60
#[Out]# 60   61
#[Out]# 61   62
#[Out]# 62   63
#[Out]# 
#[Out]# [63 rows x 1 columns]
query3 = '''
    SELECT sID
    FROM store
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# ..  ...
#[Out]# 34   34
#[Out]# 35   35
#[Out]# 36   36
#[Out]# 37   37
#[Out]# 38   38
#[Out]# 39   39
#[Out]# 40   40
#[Out]# 41   41
#[Out]# 42   42
#[Out]# 43   43
#[Out]# 44   44
#[Out]# 45   45
#[Out]# 46   46
#[Out]# 47   47
#[Out]# 48   48
#[Out]# 49   49
#[Out]# 50   50
#[Out]# 51   51
#[Out]# 52   52
#[Out]# 53   53
#[Out]# 54   54
#[Out]# 55   55
#[Out]# 56   56
#[Out]# 57   57
#[Out]# 58   58
#[Out]# 59   59
#[Out]# 60   60
#[Out]# 61   61
#[Out]# 62   62
#[Out]# 63   63
#[Out]# 
#[Out]# [64 rows x 1 columns]
query3 = '''
    SELECT sName
    FROM store
    WHERE sID
'''

pd.read_sql_query(query3, conn)
#[Out]#           sName
#[Out]# 0     Hoogvliet
#[Out]# 1         Jumbo
#[Out]# 2        Sligro
#[Out]# 3     Hoogvliet
#[Out]# 4        Sligro
#[Out]# 5          Coop
#[Out]# 6        Sligro
#[Out]# 7   Albert Hein
#[Out]# 8   Albert Hein
#[Out]# 9         Jumbo
#[Out]# 10  Albert Hein
#[Out]# 11         Lidl
#[Out]# 12         Coop
#[Out]# 13         Coop
#[Out]# 14         Lidl
#[Out]# 15         Lidl
#[Out]# 16    Hoogvliet
#[Out]# 17       Sligro
#[Out]# 18         Coop
#[Out]# 19        Jumbo
#[Out]# 20         Coop
#[Out]# 21         Lidl
#[Out]# 22         Dirk
#[Out]# 23  Albert Hein
#[Out]# 24  Albert Hein
#[Out]# 25    Hoogvliet
#[Out]# 26       Sligro
#[Out]# 27    Hoogvliet
#[Out]# 28       Sligro
#[Out]# 29         Dirk
#[Out]# ..          ...
#[Out]# 33         Coop
#[Out]# 34         Lidl
#[Out]# 35         Lidl
#[Out]# 36        Jumbo
#[Out]# 37    Hoogvliet
#[Out]# 38       Sligro
#[Out]# 39    Hoogvliet
#[Out]# 40  Albert Hein
#[Out]# 41       Sligro
#[Out]# 42         Coop
#[Out]# 43  Albert Hein
#[Out]# 44         Coop
#[Out]# 45         Lidl
#[Out]# 46         Coop
#[Out]# 47    Hoogvliet
#[Out]# 48    Hoogvliet
#[Out]# 49       Sligro
#[Out]# 50         Coop
#[Out]# 51         Lidl
#[Out]# 52         Coop
#[Out]# 53         Dirk
#[Out]# 54         Coop
#[Out]# 55        Jumbo
#[Out]# 56         Dirk
#[Out]# 57         Dirk
#[Out]# 58        Jumbo
#[Out]# 59         Lidl
#[Out]# 60         Lidl
#[Out]# 61        Jumbo
#[Out]# 62        Jumbo
#[Out]# 
#[Out]# [63 rows x 1 columns]
query3 = '''
    SELECT sName
    FROM store
'''

pd.read_sql_query(query3, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16         Lidl
#[Out]# 17    Hoogvliet
#[Out]# 18       Sligro
#[Out]# 19         Coop
#[Out]# 20        Jumbo
#[Out]# 21         Coop
#[Out]# 22         Lidl
#[Out]# 23         Dirk
#[Out]# 24  Albert Hein
#[Out]# 25  Albert Hein
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28    Hoogvliet
#[Out]# 29       Sligro
#[Out]# ..          ...
#[Out]# 34         Coop
#[Out]# 35         Lidl
#[Out]# 36         Lidl
#[Out]# 37        Jumbo
#[Out]# 38    Hoogvliet
#[Out]# 39       Sligro
#[Out]# 40    Hoogvliet
#[Out]# 41  Albert Hein
#[Out]# 42       Sligro
#[Out]# 43         Coop
#[Out]# 44  Albert Hein
#[Out]# 45         Coop
#[Out]# 46         Lidl
#[Out]# 47         Coop
#[Out]# 48    Hoogvliet
#[Out]# 49    Hoogvliet
#[Out]# 50       Sligro
#[Out]# 51         Coop
#[Out]# 52         Lidl
#[Out]# 53         Coop
#[Out]# 54         Dirk
#[Out]# 55         Coop
#[Out]# 56        Jumbo
#[Out]# 57         Dirk
#[Out]# 58         Dirk
#[Out]# 59        Jumbo
#[Out]# 60         Lidl
#[Out]# 61         Lidl
#[Out]# 62        Jumbo
#[Out]# 63        Jumbo
#[Out]# 
#[Out]# [64 rows x 1 columns]
query3 = '''
    SELECT cID
    FROM purchase p
    WHERE sID IN ( 
                 SELECT sID
                 FROM store
               )
    GROUP BY cID
    HAVING COUNT(*) = ( 
                        SELECT COUNT (*)
                        FROM p
                      )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT cID
    FROM purchase
    WHERE sID IN ( 
                 SELECT sID
                 FROM store
               )
    GROUP BY cID
    HAVING COUNT(*) = ( 
                        SELECT COUNT (*)
                        FROM p
                      )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT cID
    FROM purchase
    WHERE sID IN ( 
                 SELECT sID
                 FROM store
               )
    GROUP BY cID
    HAVING COUNT(*) = ( 
                        SELECT COUNT (*)
                        FROM purchase
                      )
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID
    FROM purchase
    WHERE sID IN ( 
                 SELECT sID
                 FROM store
               )
    GROUP BY cID
    HAVING COUNT(*) = ( 
                        SELECT COUNT (*)
                        FROM store
                      )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT cID
    FROM purchase
    WHERE sID IN ( 
                 SELECT sID
                 FROM store
               )
    GROUP BY cID
    HAVING COUNT(*) = ( 
                        SELECT COUNT (*)
                        FROM store
                      )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT sName
    FROM store
    WHERE sID
    GROUP BY sName
    HAVING COUNT(sID)>1
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>4
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>5
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>6
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>200
    
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>10
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
        AND i.sID=s1.sID
    GROUP BY s1.sName
    HAVING AVG(i.quantity)>15
    
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    SELECT sID, AVG(i.quantity)
    FROM store s, inventory i
    WHERE s.sID=i.sID
    GROUP BY s.sName
    HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT i.sID, AVG(i.quantity)
    FROM store s, inventory i
    WHERE s.sID=i.sID
    GROUP BY s.sName
    HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID  AVG(i.quantity)
#[Out]# 0   24        18.008475
#[Out]# 1    0        16.695000
#[Out]# 2   57        20.884615
#[Out]# 3    4        16.898438
#[Out]# 4   56        16.312500
#[Out]# 5   60        25.048077
#[Out]# 6   27        16.795620
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s, inventory i
    WHERE s.sID=i.sID
    GROUP BY s.sName
    HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.008475
#[Out]# 1         Coop        16.695000
#[Out]# 2         Dirk        20.884615
#[Out]# 3    Hoogvliet        16.898438
#[Out]# 4        Jumbo        16.312500
#[Out]# 5         Lidl        25.048077
#[Out]# 6       Sligro        16.795620
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s, inventory i
    WHERE s.sID=i.sID
    GROUP BY s.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.008475
#[Out]# 1         Coop        16.695000
#[Out]# 2         Dirk        20.884615
#[Out]# 3    Hoogvliet        16.898438
#[Out]# 4        Jumbo        16.312500
#[Out]# 5         Lidl        25.048077
#[Out]# 6       Sligro        16.795620
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s, inventory i
    WHERE s.sID=i.sID
    GROUP BY s.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.008475
#[Out]# 1         Coop        16.695000
#[Out]# 2         Dirk        20.884615
#[Out]# 3    Hoogvliet        16.898438
#[Out]# 4        Jumbo        16.312500
#[Out]# 5         Lidl        25.048077
#[Out]# 6       Sligro        16.795620
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s, inventory i
    GROUP BY s.sName
    HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  AVG(i.quantity)
#[Out]# 0  Albert Hein        18.342581
#[Out]# 1         Coop        18.342581
#[Out]# 2         Dirk        18.342581
#[Out]# 3    Hoogvliet        18.342581
#[Out]# 4        Jumbo        18.342581
#[Out]# 5         Lidl        18.342581
#[Out]# 6       Sligro        18.342581
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName, AVG(i.quantity)
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s1.sName, AVG(i.quantity)
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName  AVG(i.quantity)
#[Out]# 0  Jumbo        18.342581
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1         Coop
#[Out]# 2         Coop
#[Out]# 3         Coop
#[Out]# 4         Coop
#[Out]# 5         Coop
#[Out]# 6         Coop
#[Out]# 7         Coop
#[Out]# 8         Coop
#[Out]# 9         Coop
#[Out]# 10        Coop
#[Out]# 11        Coop
#[Out]# 12        Coop
#[Out]# 13   Hoogvliet
#[Out]# 14   Hoogvliet
#[Out]# 15   Hoogvliet
#[Out]# 16   Hoogvliet
#[Out]# 17   Hoogvliet
#[Out]# 18   Hoogvliet
#[Out]# 19   Hoogvliet
#[Out]# 20   Hoogvliet
#[Out]# 21       Jumbo
#[Out]# 22       Jumbo
#[Out]# 23       Jumbo
#[Out]# 24       Jumbo
#[Out]# 25       Jumbo
#[Out]# 26       Jumbo
#[Out]# 27       Jumbo
#[Out]# 28      Sligro
#[Out]# 29      Sligro
#[Out]# ..         ...
#[Out]# 528       Lidl
#[Out]# 529       Lidl
#[Out]# 530       Lidl
#[Out]# 531       Lidl
#[Out]# 532       Lidl
#[Out]# 533       Lidl
#[Out]# 534       Lidl
#[Out]# 535       Lidl
#[Out]# 536       Lidl
#[Out]# 537       Lidl
#[Out]# 538       Lidl
#[Out]# 539       Lidl
#[Out]# 540       Lidl
#[Out]# 541       Lidl
#[Out]# 542       Lidl
#[Out]# 543       Lidl
#[Out]# 544      Jumbo
#[Out]# 545      Jumbo
#[Out]# 546      Jumbo
#[Out]# 547      Jumbo
#[Out]# 548      Jumbo
#[Out]# 549      Jumbo
#[Out]# 550      Jumbo
#[Out]# 551      Jumbo
#[Out]# 552      Jumbo
#[Out]# 553      Jumbo
#[Out]# 554      Jumbo
#[Out]# 555      Jumbo
#[Out]# 556      Jumbo
#[Out]# 557      Jumbo
#[Out]# 
#[Out]# [558 rows x 1 columns]
query4 = '''
    SELECT DISTINCT s1.sName
    FROM store s1, store s2
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2        Jumbo
#[Out]# 3       Sligro
#[Out]# 4  Albert Hein
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
    SELECT s1.sName
    FROM store s1, store s2, inventory i
    WHERE s1.sName=s2.sName AND s1.sID<>s2.sID 
            AND i.sID=s1.sID
    GROUP BY s1.sName
        HAVING AVG(i.quantity)>4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query5 = '''
    SELECT pr.pName
    FROM product pr, purchase pu
    WHERE pr.pID=pu.pID AND MAX(pu.price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM product pr, purchase pu, store s
    WHERE pr.pID=pu.pID AND s.sID=pu.sID 
    
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 479           Lasanga         Coop
#[Out]# 480             Pizza         Lidl
#[Out]# 481         Mushrooms         Lidl
#[Out]# 482           Lasanga        Jumbo
#[Out]# 483          Tomatoes    Hoogvliet
#[Out]# 484       Cashew Nuts       Sligro
#[Out]# 485              Milk    Hoogvliet
#[Out]# 486           Carrots  Albert Hein
#[Out]# 487              Coca       Sligro
#[Out]# 488             Bread         Coop
#[Out]# 489           Bananas  Albert Hein
#[Out]# 490              Milk         Coop
#[Out]# 491               Tea         Lidl
#[Out]# 492             Bread         Coop
#[Out]# 493             Fanta    Hoogvliet
#[Out]# 494              Milk    Hoogvliet
#[Out]# 495            Coffee       Sligro
#[Out]# 496   Spiced Biscuits         Coop
#[Out]# 497   Spiced Biscuits         Lidl
#[Out]# 498  Hot Dog Sausages         Coop
#[Out]# 499       Cashew Nuts         Dirk
#[Out]# 500  Hot Dog Sausages         Coop
#[Out]# 501              Milk        Jumbo
#[Out]# 502         Cucumbers         Dirk
#[Out]# 503          Potatoes         Dirk
#[Out]# 504             Bread        Jumbo
#[Out]# 505         Mushrooms         Lidl
#[Out]# 506              Coca         Lidl
#[Out]# 507           Bananas        Jumbo
#[Out]# 508            Cheese        Jumbo
#[Out]# 
#[Out]# [509 rows x 2 columns]
query5 = '''
        WITH max_price(value) as (
        SELECT MAX(price)
        FROM inventory
    )
    SELECT pr.pName, s.sName
    FROM product pr, purchase pu, store s
    WHERE pr.pID=pu.pID AND s.sID=pu.sID 
    
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 479           Lasanga         Coop
#[Out]# 480             Pizza         Lidl
#[Out]# 481         Mushrooms         Lidl
#[Out]# 482           Lasanga        Jumbo
#[Out]# 483          Tomatoes    Hoogvliet
#[Out]# 484       Cashew Nuts       Sligro
#[Out]# 485              Milk    Hoogvliet
#[Out]# 486           Carrots  Albert Hein
#[Out]# 487              Coca       Sligro
#[Out]# 488             Bread         Coop
#[Out]# 489           Bananas  Albert Hein
#[Out]# 490              Milk         Coop
#[Out]# 491               Tea         Lidl
#[Out]# 492             Bread         Coop
#[Out]# 493             Fanta    Hoogvliet
#[Out]# 494              Milk    Hoogvliet
#[Out]# 495            Coffee       Sligro
#[Out]# 496   Spiced Biscuits         Coop
#[Out]# 497   Spiced Biscuits         Lidl
#[Out]# 498  Hot Dog Sausages         Coop
#[Out]# 499       Cashew Nuts         Dirk
#[Out]# 500  Hot Dog Sausages         Coop
#[Out]# 501              Milk        Jumbo
#[Out]# 502         Cucumbers         Dirk
#[Out]# 503          Potatoes         Dirk
#[Out]# 504             Bread        Jumbo
#[Out]# 505         Mushrooms         Lidl
#[Out]# 506              Coca         Lidl
#[Out]# 507           Bananas        Jumbo
#[Out]# 508            Cheese        Jumbo
#[Out]# 
#[Out]# [509 rows x 2 columns]
query5 = '''
        WITH max_price(value) as (
        SELECT MAX(unit_price)
        FROM inventory
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.value=i.unit_price
    
'''

pd.read_sql_query(query5, conn)
query5 = '''
        WITH max_price(value) as (
        SELECT MAX(unit_price)
        FROM inventory
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, inventory i, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.value=i.unit_price
    
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName
#[Out]# 0  Beef  Albert Hein
query5 = '''
        WITH max_price(price) as (
        SELECT MAX(unit_price)
        FROM inventory
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, inventory i, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.price=i.unit_price
    
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName
#[Out]# 0  Beef  Albert Hein
query6 = '''
    SELECT MAX (i1.unit_price - i2.unit_price)
    FROM inventory i1, inventory i2
    WHERE i1.date='2018-08-23' AND i1.date=i2.date 
        AND i1.sID<>i2.sID
        AND i1.pID=i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX (i1.unit_price - i2.unit_price)
#[Out]# 0                                  2.0
query5 = '''
        WITH max_price(price2) as (
        SELECT MAX(price)
        FROM purchase
    )
    SELECT pr.pName, s.sName
    FROM product pr, store s, inventory i, max_price m
    WHERE pr.pID=i.pID AND s.sID=i.sID 
        AND m.price2=i.price
    
'''

pd.read_sql_query(query5, conn)
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0xe5334a0>
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID AND p.price>100
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cName]
#[Out]# Index: []
query1 = '''
    SELECT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID AND p.price>10
'''

pd.read_sql_query(query1, conn)
#[Out]#       cName
#[Out]# 0      Daan
#[Out]# 1      Bram
#[Out]# 2      Luca
#[Out]# 3      Teun
#[Out]# 4      Sven
#[Out]# 5      Jack
#[Out]# 6      Ties
#[Out]# 7    Willem
#[Out]# 8      Dean
#[Out]# 9     Dylan
#[Out]# 10    Dylan
#[Out]# 11  Thijmen
#[Out]# 12    Lotte
#[Out]# 13     Lynn
#[Out]# 14    Fenna
#[Out]# 15    Lieke
#[Out]# 16    Milou
#[Out]# 17    Sofie
#[Out]# 18      Ivy
#[Out]# 19    Fenne
#[Out]# 20    Elena
query1 = '''
    SELECT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID AND p.price>30
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cName]
#[Out]# Index: []
query1 = '''
    SELECT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID AND p.price>15
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cName]
#[Out]# Index: []
query1 = '''
    SELECT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID AND p.price>11
'''

pd.read_sql_query(query1, conn)
#[Out]#       cName
#[Out]# 0      Daan
#[Out]# 1      Luca
#[Out]# 2      Teun
#[Out]# 3      Sven
#[Out]# 4    Willem
#[Out]# 5     Dylan
#[Out]# 6     Dylan
#[Out]# 7   Thijmen
#[Out]# 8     Lotte
#[Out]# 9      Lynn
#[Out]# 10    Fenna
#[Out]# 11    Lieke
#[Out]# 12    Sofie
#[Out]# 13      Ivy
#[Out]# 14    Fenne
#[Out]# 15    Elena
query1 = '''
    SELECT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID AND p.price>12
'''

pd.read_sql_query(query1, conn)
#[Out]#       cName
#[Out]# 0      Daan
#[Out]# 1      Sven
#[Out]# 2    Willem
#[Out]# 3     Dylan
#[Out]# 4   Thijmen
#[Out]# 5      Lynn
#[Out]# 6     Fenna
#[Out]# 7     Lieke
#[Out]# 8       Ivy
#[Out]# 9     Fenne
#[Out]# 10    Elena
query1 = '''
    SELECT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID AND p.price>13
'''

pd.read_sql_query(query1, conn)
#[Out]#     cName
#[Out]# 0    Daan
#[Out]# 1  Willem
#[Out]# 2   Dylan
#[Out]# 3    Lynn
#[Out]# 4     Ivy
#[Out]# 5   Elena
query1 = '''
    SELECT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID AND p.price>14
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cName]
#[Out]# Index: []
query1 = '''
    SELECT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID AND p.price>13
'''

pd.read_sql_query(query1, conn)
#[Out]#     cName
#[Out]# 0    Daan
#[Out]# 1  Willem
#[Out]# 2   Dylan
#[Out]# 3    Lynn
#[Out]# 4     Ivy
#[Out]# 5   Elena
query1 = '''
    (SELECT cID from customer)
    intersect
    (SELECT cID from purchase)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT cID from customer
    intersect
    SELECT cID from purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query1 = '''
    SELECT cName, cID from customer
    intersect
    SELECT cID from purchase
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT cName from customer, cID from customer
    intersect
    SELECT cID from purchase
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT cName, cID from customer
    intersect
    SELECT cID from purchase
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT cID from customer
    intersect
    SELECT cID from purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query1 = '''
    SELECT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#       cName
#[Out]# 0      Noah
#[Out]# 1       Sem
#[Out]# 2       Sem
#[Out]# 3       Sem
#[Out]# 4       Sem
#[Out]# 5       Sem
#[Out]# 6       Sem
#[Out]# 7       Sem
#[Out]# 8     Lucas
#[Out]# 9     Lucas
#[Out]# 10    Lucas
#[Out]# 11    Lucas
#[Out]# 12    Lucas
#[Out]# 13     Finn
#[Out]# 14     Finn
#[Out]# 15     Finn
#[Out]# 16     Daan
#[Out]# 17     Daan
#[Out]# 18     Daan
#[Out]# 19     Daan
#[Out]# 20     Daan
#[Out]# 21     Daan
#[Out]# 22     Levi
#[Out]# 23     Levi
#[Out]# 24     Levi
#[Out]# 25     Levi
#[Out]# 26     Levi
#[Out]# 27     Levi
#[Out]# 28     Bram
#[Out]# 29     Bram
#[Out]# ..      ...
#[Out]# 479  Kostas
#[Out]# 480  Kostas
#[Out]# 481  Kostas
#[Out]# 482  Kostas
#[Out]# 483  Kostas
#[Out]# 484  Kostas
#[Out]# 485  Kostas
#[Out]# 486  Kostas
#[Out]# 487  Kostas
#[Out]# 488  Kostas
#[Out]# 489  Kostas
#[Out]# 490  Kostas
#[Out]# 491  Kostas
#[Out]# 492  Kostas
#[Out]# 493  Kostas
#[Out]# 494  Kostas
#[Out]# 495  Kostas
#[Out]# 496  Kostas
#[Out]# 497  Kostas
#[Out]# 498  Kostas
#[Out]# 499  Kostas
#[Out]# 500  Kostas
#[Out]# 501  Kostas
#[Out]# 502  Kostas
#[Out]# 503  Kostas
#[Out]# 504  Kostas
#[Out]# 505  Kostas
#[Out]# 506  Kostas
#[Out]# 507  Kostas
#[Out]# 508  Kostas
#[Out]# 
#[Out]# [509 rows x 1 columns]
query1 = '''
    SELECT DISTINCT cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#         cName
#[Out]# 0        Noah
#[Out]# 1         Sem
#[Out]# 2       Lucas
#[Out]# 3        Finn
#[Out]# 4        Daan
#[Out]# 5        Levi
#[Out]# 6        Bram
#[Out]# 7        Liam
#[Out]# 8         Sam
#[Out]# 9       Thijs
#[Out]# 10      James
#[Out]# 11       Noud
#[Out]# 12     Julian
#[Out]# 13        Dex
#[Out]# 14       Hugo
#[Out]# 15       Lars
#[Out]# 16       Gijs
#[Out]# 17   Benjamin
#[Out]# 18       Mats
#[Out]# 19       Luca
#[Out]# 20      Mason
#[Out]# 21     Jayden
#[Out]# 22        Tim
#[Out]# 23       Siem
#[Out]# 24      Ruben
#[Out]# 25       Teun
#[Out]# 26    Olivier
#[Out]# 27       Sven
#[Out]# 28      David
#[Out]# 29      Stijn
#[Out]# ..        ...
#[Out]# 101      Fien
#[Out]# 102    Isabel
#[Out]# 103     Lizzy
#[Out]# 104      Jill
#[Out]# 105      Anne
#[Out]# 106      Puck
#[Out]# 107     Fenne
#[Out]# 108     Floor
#[Out]# 109     Elena
#[Out]# 110      Cato
#[Out]# 111     Hanna
#[Out]# 112    Veerle
#[Out]# 113      Kiki
#[Out]# 114      Lily
#[Out]# 115      Iris
#[Out]# 116     Tessa
#[Out]# 117      Lana
#[Out]# 118     Amira
#[Out]# 119     Eline
#[Out]# 120      Elif
#[Out]# 121      Juul
#[Out]# 122     Merel
#[Out]# 123      Liva
#[Out]# 124   Johanna
#[Out]# 125     Wilko
#[Out]# 126      Nick
#[Out]# 127    Angela
#[Out]# 128      Pino
#[Out]# 129      Koen
#[Out]# 130    Kostas
#[Out]# 
#[Out]# [131 rows x 1 columns]
query1 = '''
    SELECT distinct cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#         cName
#[Out]# 0        Noah
#[Out]# 1         Sem
#[Out]# 2       Lucas
#[Out]# 3        Finn
#[Out]# 4        Daan
#[Out]# 5        Levi
#[Out]# 6        Bram
#[Out]# 7        Liam
#[Out]# 8         Sam
#[Out]# 9       Thijs
#[Out]# 10      James
#[Out]# 11       Noud
#[Out]# 12     Julian
#[Out]# 13        Dex
#[Out]# 14       Hugo
#[Out]# 15       Lars
#[Out]# 16       Gijs
#[Out]# 17   Benjamin
#[Out]# 18       Mats
#[Out]# 19       Luca
#[Out]# 20      Mason
#[Out]# 21     Jayden
#[Out]# 22        Tim
#[Out]# 23       Siem
#[Out]# 24      Ruben
#[Out]# 25       Teun
#[Out]# 26    Olivier
#[Out]# 27       Sven
#[Out]# 28      David
#[Out]# 29      Stijn
#[Out]# ..        ...
#[Out]# 101      Fien
#[Out]# 102    Isabel
#[Out]# 103     Lizzy
#[Out]# 104      Jill
#[Out]# 105      Anne
#[Out]# 106      Puck
#[Out]# 107     Fenne
#[Out]# 108     Floor
#[Out]# 109     Elena
#[Out]# 110      Cato
#[Out]# 111     Hanna
#[Out]# 112    Veerle
#[Out]# 113      Kiki
#[Out]# 114      Lily
#[Out]# 115      Iris
#[Out]# 116     Tessa
#[Out]# 117      Lana
#[Out]# 118     Amira
#[Out]# 119     Eline
#[Out]# 120      Elif
#[Out]# 121      Juul
#[Out]# 122     Merel
#[Out]# 123      Liva
#[Out]# 124   Johanna
#[Out]# 125     Wilko
#[Out]# 126      Nick
#[Out]# 127    Angela
#[Out]# 128      Pino
#[Out]# 129      Koen
#[Out]# 130    Kostas
#[Out]# 
#[Out]# [131 rows x 1 columns]
query1 = '''
    select distinct cName
    FROM customer c, purchase p
    WHERE c.cID=p.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#         cName
#[Out]# 0        Noah
#[Out]# 1         Sem
#[Out]# 2       Lucas
#[Out]# 3        Finn
#[Out]# 4        Daan
#[Out]# 5        Levi
#[Out]# 6        Bram
#[Out]# 7        Liam
#[Out]# 8         Sam
#[Out]# 9       Thijs
#[Out]# 10      James
#[Out]# 11       Noud
#[Out]# 12     Julian
#[Out]# 13        Dex
#[Out]# 14       Hugo
#[Out]# 15       Lars
#[Out]# 16       Gijs
#[Out]# 17   Benjamin
#[Out]# 18       Mats
#[Out]# 19       Luca
#[Out]# 20      Mason
#[Out]# 21     Jayden
#[Out]# 22        Tim
#[Out]# 23       Siem
#[Out]# 24      Ruben
#[Out]# 25       Teun
#[Out]# 26    Olivier
#[Out]# 27       Sven
#[Out]# 28      David
#[Out]# 29      Stijn
#[Out]# ..        ...
#[Out]# 101      Fien
#[Out]# 102    Isabel
#[Out]# 103     Lizzy
#[Out]# 104      Jill
#[Out]# 105      Anne
#[Out]# 106      Puck
#[Out]# 107     Fenne
#[Out]# 108     Floor
#[Out]# 109     Elena
#[Out]# 110      Cato
#[Out]# 111     Hanna
#[Out]# 112    Veerle
#[Out]# 113      Kiki
#[Out]# 114      Lily
#[Out]# 115      Iris
#[Out]# 116     Tessa
#[Out]# 117      Lana
#[Out]# 118     Amira
#[Out]# 119     Eline
#[Out]# 120      Elif
#[Out]# 121      Juul
#[Out]# 122     Merel
#[Out]# 123      Liva
#[Out]# 124   Johanna
#[Out]# 125     Wilko
#[Out]# 126      Nick
#[Out]# 127    Angela
#[Out]# 128      Pino
#[Out]# 129      Koen
#[Out]# 130    Kostas
#[Out]# 
#[Out]# [131 rows x 1 columns]
query1 = '''
    SELECT pID
    FROM purchase p
    EXCEPT
        SELECT pID
        FROM purchase pu1, purchase pu2, purchase pu3
        WHERE pu1.pID=pu2.pID AND pu1.pID=pu3.pID
            AND pu1.cID<>pu2.cID
            AND pu1.cID<>pu3.cID
            AND pu3.cID<>pu2.cID
            
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase p
    EXCEPT
        SELECT pID
        FROM purchase pu1, purchase pu2, purchase pu3
        WHERE pu1.pID=pu2.pID AND pu1.pID=pu3.pID
            AND pu1.cID<>pu2.cID
            AND pu1.cID<>pu3.cID
            AND pu3.cID<>pu2.cID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase p
    EXCEPT
        SELECT pu1.pID
        FROM purchase pu1, purchase pu2, purchase pu3
        WHERE pu1.pID=pu2.pID AND pu1.pID=pu3.pID
            AND pu1.cID<>pu2.cID
            AND pu1.cID<>pu3.cID
            AND pu3.cID<>pu2.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT pID
    FROM purchase p
    EXCEPT
        SELECT pu2.pID
        FROM purchase pu1, purchase pu2, purchase pu3
        WHERE pu1.pID=pu2.pID AND pu1.pID=pu3.pID
            AND pu1.cID<>pu2.cID
            AND pu1.cID<>pu3.cID
            AND pu3.cID<>pu2.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT pID
    FROM purchase p
    EXCEPT
        SELECT pu3.pID
        FROM purchase pu1, purchase pu2, purchase pu3
        WHERE pu1.pID=pu2.pID AND pu1.pID=pu3.pID
            AND pu1.cID<>pu2.cID
            AND pu1.cID<>pu3.cID
            AND pu3.cID<>pu2.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT pID
    FROM purchase p
    EXCEPT
        SELECT pu1.pID
        FROM purchase pu1, purchase pu2, purchase pu3
        WHERE pu1.pID=pu2.pID AND pu1.pID=pu3.pID
            AND pu1.cID<>pu2.cID
            AND pu1.cID<>pu3.cID
            AND pu3.cID<>pu2.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30

# IPython log file


# IPython log file


