# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0xcad18d0a0>
query1 = ''''''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT pID
FROM purchase
WHERE quanitity < 3
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT pID
FROM purchase
WHERE quantity < 3
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2      9
#[Out]# 3     20
#[Out]# 4     22
#[Out]# 5     14
#[Out]# 6     26
#[Out]# 7      8
#[Out]# 8      6
#[Out]# 9     22
#[Out]# 10    16
#[Out]# 11    19
#[Out]# 12    19
#[Out]# 13    12
#[Out]# 14     3
#[Out]# 15     0
#[Out]# 16    13
#[Out]# 17    27
#[Out]# 18     0
#[Out]# 19    20
#[Out]# 20    15
#[Out]# 21    24
#[Out]# 22    18
#[Out]# 23    10
#[Out]# 24     6
#[Out]# 25    11
#[Out]# 26    16
#[Out]# 27     4
#[Out]# 28    18
#[Out]# 29    23
#[Out]# ..   ...
#[Out]# 91    19
#[Out]# 92     7
#[Out]# 93     3
#[Out]# 94    21
#[Out]# 95    22
#[Out]# 96    28
#[Out]# 97     3
#[Out]# 98    21
#[Out]# 99    28
#[Out]# 100   21
#[Out]# 101    0
#[Out]# 102   18
#[Out]# 103   24
#[Out]# 104   17
#[Out]# 105   18
#[Out]# 106    0
#[Out]# 107   29
#[Out]# 108   30
#[Out]# 109   30
#[Out]# 110   10
#[Out]# 111   21
#[Out]# 112    4
#[Out]# 113    3
#[Out]# 114    5
#[Out]# 115   11
#[Out]# 116   11
#[Out]# 117   23
#[Out]# 118   17
#[Out]# 119    9
#[Out]# 120   18
#[Out]# 
#[Out]# [121 rows x 1 columns]
query1 = '''
SELECT pID
FROM purchase
WHERE cID = cID and quantity < 3
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2      9
#[Out]# 3     20
#[Out]# 4     22
#[Out]# 5     14
#[Out]# 6     26
#[Out]# 7      8
#[Out]# 8      6
#[Out]# 9     22
#[Out]# 10    16
#[Out]# 11    19
#[Out]# 12    19
#[Out]# 13    12
#[Out]# 14     3
#[Out]# 15     0
#[Out]# 16    13
#[Out]# 17    27
#[Out]# 18     0
#[Out]# 19    20
#[Out]# 20    15
#[Out]# 21    24
#[Out]# 22    18
#[Out]# 23    10
#[Out]# 24     6
#[Out]# 25    11
#[Out]# 26    16
#[Out]# 27     4
#[Out]# 28    18
#[Out]# 29    23
#[Out]# ..   ...
#[Out]# 91    19
#[Out]# 92     7
#[Out]# 93     3
#[Out]# 94    21
#[Out]# 95    22
#[Out]# 96    28
#[Out]# 97     3
#[Out]# 98    21
#[Out]# 99    28
#[Out]# 100   21
#[Out]# 101    0
#[Out]# 102   18
#[Out]# 103   24
#[Out]# 104   17
#[Out]# 105   18
#[Out]# 106    0
#[Out]# 107   29
#[Out]# 108   30
#[Out]# 109   30
#[Out]# 110   10
#[Out]# 111   21
#[Out]# 112    4
#[Out]# 113    3
#[Out]# 114    5
#[Out]# 115   11
#[Out]# 116   11
#[Out]# 117   23
#[Out]# 118   17
#[Out]# 119    9
#[Out]# 120   18
#[Out]# 
#[Out]# [121 rows x 1 columns]
query1 = '''
SELECT pID
FROM purchase
WHERE UNIQUE(SELECT cID
FROM purchase)
'''

pd.read_sql_query(query1, conn)
query2 = '''
SELECT cID
FROM purchase
WHERE pName = (SELECT pID
FROM product
WHERE pName = 'Onions')
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT cID
FROM purchase
WHERE pID = (SELECT pID
FROM product
WHERE pName = 'Onions')
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID
#[Out]# 0     2
#[Out]# 1    29
#[Out]# 2    31
#[Out]# 3    33
#[Out]# 4    52
#[Out]# 5    59
#[Out]# 6    85
#[Out]# 7   124
#[Out]# 8   129
#[Out]# 9   162
#[Out]# 10  165
#[Out]# 11  169
#[Out]# 12  172
#[Out]# 13  176
#[Out]# 14  177
#[Out]# 15  190
query2 = '''
SELECT cID, purchase.date
FROM purchase
WHERE pID = (SELECT pID
FROM product
WHERE pName = 'Onions')
and date = purschase.date

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT cID, purchase.date
FROM purchase
WHERE pID = (SELECT pID
FROM product
WHERE pName = 'Onions')
and date = purchase.date

'''

pd.read_sql_query(query2, conn)
#[Out]#     cID        date
#[Out]# 0     2  2018-08-17
#[Out]# 1    29  2018-08-24
#[Out]# 2    31  2018-08-27
#[Out]# 3    33  2018-08-18
#[Out]# 4    52  2018-08-25
#[Out]# 5    59  2018-08-25
#[Out]# 6    85  2018-08-18
#[Out]# 7   124  2018-08-26
#[Out]# 8   129  2018-08-24
#[Out]# 9   162  2018-08-21
#[Out]# 10  165  2018-08-23
#[Out]# 11  169  2018-08-20
#[Out]# 12  172  2018-08-27
#[Out]# 13  176  2018-08-22
#[Out]# 14  177  2018-08-22
#[Out]# 15  190  2018-08-26
query2 = '''
SELECT cID
FROM purchase
WHERE pID = (SELECT pID
FROM product
WHERE pName = 'Onions')

'''

pd.read_sql_query(query2, conn)
#[Out]#     cID
#[Out]# 0     2
#[Out]# 1    29
#[Out]# 2    31
#[Out]# 3    33
#[Out]# 4    52
#[Out]# 5    59
#[Out]# 6    85
#[Out]# 7   124
#[Out]# 8   129
#[Out]# 9   162
#[Out]# 10  165
#[Out]# 11  169
#[Out]# 12  172
#[Out]# 13  176
#[Out]# 14  177
#[Out]# 15  190
query2 = '''
SELECT cID
FROM purchase as S, purchase as T
WHERE pID = (SELECT pID
FROM product
WHERE pName = 'Onions')
and T.date = S.date

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT cID
FROM purchase
WHERE pID = (SELECT pID
FROM product
WHERE pName = 'Onions')


'''

pd.read_sql_query(query2, conn)
#[Out]#     cID
#[Out]# 0     2
#[Out]# 1    29
#[Out]# 2    31
#[Out]# 3    33
#[Out]# 4    52
#[Out]# 5    59
#[Out]# 6    85
#[Out]# 7   124
#[Out]# 8   129
#[Out]# 9   162
#[Out]# 10  165
#[Out]# 11  169
#[Out]# 12  172
#[Out]# 13  176
#[Out]# 14  177
#[Out]# 15  190
query2 = '''
SELECT cID
FROM purchase AS S, purchase as T
WHERE pID = (SELECT pID
FROM product
WHERE pName = 'Onions')
and S.date = T.date

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT cID
FROM purchase AS S, purchase AS T
WHERE pID = (SELECT pID
FROM product
WHERE pName = 'Onions')
and S.date = T.date

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT S.cID
FROM purchase AS S, purchase AS T
WHERE pID = (SELECT pID
FROM product
WHERE pName = 'Onions')
and S.date = T.date

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT S.cID
FROM purchase s, purchase t
WHERE pID = (SELECT pID
FROM product
WHERE pName = 'Onions')
and s.date = t.date

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT s.cID
FROM purchase s, purchase t
WHERE s.pID = (SELECT pID
FROM product
WHERE pName = 'Onions')
and s.date = t.date

'''

pd.read_sql_query(query2, conn)
#[Out]#      cID
#[Out]# 0      2
#[Out]# 1      2
#[Out]# 2      2
#[Out]# 3      2
#[Out]# 4      2
#[Out]# 5      2
#[Out]# 6      2
#[Out]# 7      2
#[Out]# 8      2
#[Out]# 9      2
#[Out]# 10     2
#[Out]# 11     2
#[Out]# 12     2
#[Out]# 13     2
#[Out]# 14     2
#[Out]# 15     2
#[Out]# 16     2
#[Out]# 17     2
#[Out]# 18     2
#[Out]# 19     2
#[Out]# 20     2
#[Out]# 21     2
#[Out]# 22     2
#[Out]# 23     2
#[Out]# 24     2
#[Out]# 25     2
#[Out]# 26     2
#[Out]# 27     2
#[Out]# 28     2
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 631  190
#[Out]# 632  190
#[Out]# 633  190
#[Out]# 634  190
#[Out]# 635  190
#[Out]# 636  190
#[Out]# 637  190
#[Out]# 638  190
#[Out]# 639  190
#[Out]# 640  190
#[Out]# 641  190
#[Out]# 642  190
#[Out]# 643  190
#[Out]# 644  190
#[Out]# 645  190
#[Out]# 646  190
#[Out]# 647  190
#[Out]# 648  190
#[Out]# 649  190
#[Out]# 650  190
#[Out]# 651  190
#[Out]# 652  190
#[Out]# 653  190
#[Out]# 654  190
#[Out]# 655  190
#[Out]# 656  190
#[Out]# 657  190
#[Out]# 658  190
#[Out]# 659  190
#[Out]# 660  190
#[Out]# 
#[Out]# [661 rows x 1 columns]
query2 = '''
SELECT s.cID
FROM purchase s, purchase t
WHERE s.pID = (SELECT pID
FROM product
WHERE pName = 'Onions') and t.pID = (SELECT pID
FROM product
WHERE pName = 'Coffee')
and s.date = t.date

'''

pd.read_sql_query(query2, conn)
#[Out]#     cID
#[Out]# 0    29
#[Out]# 1    31
#[Out]# 2    33
#[Out]# 3    33
#[Out]# 4    33
#[Out]# 5    52
#[Out]# 6    52
#[Out]# 7    52
#[Out]# 8    59
#[Out]# 9    59
#[Out]# 10   59
#[Out]# 11   85
#[Out]# 12   85
#[Out]# 13   85
#[Out]# 14  124
#[Out]# 15  124
#[Out]# 16  124
#[Out]# 17  129
#[Out]# 18  169
#[Out]# 19  169
#[Out]# 20  169
#[Out]# 21  169
#[Out]# 22  172
#[Out]# 23  176
#[Out]# 24  176
#[Out]# 25  176
#[Out]# 26  177
#[Out]# 27  177
#[Out]# 28  177
#[Out]# 29  190
#[Out]# 30  190
#[Out]# 31  190
query2 = '''
SELECT s.cID, s.pID
FROM purchase s, purchase t
WHERE s.pID = (SELECT pID
FROM product
WHERE pName = 'Onions') and t.pID = (SELECT pID
FROM product
WHERE pName = 'Coffee')
and s.date = t.date

'''

pd.read_sql_query(query2, conn)
#[Out]#     cID  pID
#[Out]# 0    29    4
#[Out]# 1    31    4
#[Out]# 2    33    4
#[Out]# 3    33    4
#[Out]# 4    33    4
#[Out]# 5    52    4
#[Out]# 6    52    4
#[Out]# 7    52    4
#[Out]# 8    59    4
#[Out]# 9    59    4
#[Out]# 10   59    4
#[Out]# 11   85    4
#[Out]# 12   85    4
#[Out]# 13   85    4
#[Out]# 14  124    4
#[Out]# 15  124    4
#[Out]# 16  124    4
#[Out]# 17  129    4
#[Out]# 18  169    4
#[Out]# 19  169    4
#[Out]# 20  169    4
#[Out]# 21  169    4
#[Out]# 22  172    4
#[Out]# 23  176    4
#[Out]# 24  176    4
#[Out]# 25  176    4
#[Out]# 26  177    4
#[Out]# 27  177    4
#[Out]# 28  177    4
#[Out]# 29  190    4
#[Out]# 30  190    4
#[Out]# 31  190    4
query2 = '''
SELECT s.cID, s.pID, t.PID
FROM purchase s, purchase t
WHERE s.pID = (SELECT pID
FROM product
WHERE pName = 'Onions') and t.pID = (SELECT pID
FROM product
WHERE pName = 'Coffee')
and s.date = t.date

'''

pd.read_sql_query(query2, conn)
#[Out]#     cID  pID  pID
#[Out]# 0    29    4   21
#[Out]# 1    31    4   21
#[Out]# 2    33    4   21
#[Out]# 3    33    4   21
#[Out]# 4    33    4   21
#[Out]# 5    52    4   21
#[Out]# 6    52    4   21
#[Out]# 7    52    4   21
#[Out]# 8    59    4   21
#[Out]# 9    59    4   21
#[Out]# 10   59    4   21
#[Out]# 11   85    4   21
#[Out]# 12   85    4   21
#[Out]# 13   85    4   21
#[Out]# 14  124    4   21
#[Out]# 15  124    4   21
#[Out]# 16  124    4   21
#[Out]# 17  129    4   21
#[Out]# 18  169    4   21
#[Out]# 19  169    4   21
#[Out]# 20  169    4   21
#[Out]# 21  169    4   21
#[Out]# 22  172    4   21
#[Out]# 23  176    4   21
#[Out]# 24  176    4   21
#[Out]# 25  176    4   21
#[Out]# 26  177    4   21
#[Out]# 27  177    4   21
#[Out]# 28  177    4   21
#[Out]# 29  190    4   21
#[Out]# 30  190    4   21
#[Out]# 31  190    4   21
query2 = '''
SELECT s.cID, s.pID, t.pID
FROM purchase s, purchase t
WHERE s.pID = (SELECT pID
FROM product
WHERE pName = 'Onions') and t.pID = (SELECT pID
FROM product
WHERE pName = 'Coffee')
and s.date = t.date

'''

pd.read_sql_query(query2, conn)
#[Out]#     cID  pID  pID
#[Out]# 0    29    4   21
#[Out]# 1    31    4   21
#[Out]# 2    33    4   21
#[Out]# 3    33    4   21
#[Out]# 4    33    4   21
#[Out]# 5    52    4   21
#[Out]# 6    52    4   21
#[Out]# 7    52    4   21
#[Out]# 8    59    4   21
#[Out]# 9    59    4   21
#[Out]# 10   59    4   21
#[Out]# 11   85    4   21
#[Out]# 12   85    4   21
#[Out]# 13   85    4   21
#[Out]# 14  124    4   21
#[Out]# 15  124    4   21
#[Out]# 16  124    4   21
#[Out]# 17  129    4   21
#[Out]# 18  169    4   21
#[Out]# 19  169    4   21
#[Out]# 20  169    4   21
#[Out]# 21  169    4   21
#[Out]# 22  172    4   21
#[Out]# 23  176    4   21
#[Out]# 24  176    4   21
#[Out]# 25  176    4   21
#[Out]# 26  177    4   21
#[Out]# 27  177    4   21
#[Out]# 28  177    4   21
#[Out]# 29  190    4   21
#[Out]# 30  190    4   21
#[Out]# 31  190    4   21
query2 = '''
SELECT s.cID, s.pID, t.pID
FROM purchase s, purchase t
WHERE s.pID = (SELECT pID
FROM product
WHERE pName = 'Onions') and t.pID = (SELECT pID
FROM product
WHERE pName = 'Coffee')
and s.date = t.date and s.cID = t.cID

'''

pd.read_sql_query(query2, conn)
#[Out]#    cID  pID  pID
#[Out]# 0  124    4   21
#[Out]# 1  190    4   21
query2 = '''
SELECT s.cID
FROM purchase s, purchase t
WHERE s.pID = (SELECT pID
FROM product
WHERE pName = 'Onions') and t.pID = (SELECT pID
FROM product
WHERE pName = 'Coffee')
and s.date = t.date and s.cID = t.cID

'''

pd.read_sql_query(query2, conn)
#[Out]#    cID
#[Out]# 0  124
#[Out]# 1  190
query1 = '''
SELECT pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#         pID
#[Out]# 0        10
#[Out]# 1        10
#[Out]# 2        10
#[Out]# 3        10
#[Out]# 4        10
#[Out]# 5        10
#[Out]# 6        10
#[Out]# 7        10
#[Out]# 8        10
#[Out]# 9        10
#[Out]# 10       10
#[Out]# 11       10
#[Out]# 12       10
#[Out]# 13       10
#[Out]# 14       10
#[Out]# 15       10
#[Out]# 16       10
#[Out]# 17       10
#[Out]# 18       10
#[Out]# 19       10
#[Out]# 20       10
#[Out]# 21       10
#[Out]# 22       10
#[Out]# 23       10
#[Out]# 24       10
#[Out]# 25       10
#[Out]# 26       10
#[Out]# 27       10
#[Out]# 28       10
#[Out]# 29       10
#[Out]# ...     ...
#[Out]# 155754   18
#[Out]# 155755   18
#[Out]# 155756   18
#[Out]# 155757   18
#[Out]# 155758   18
#[Out]# 155759   18
#[Out]# 155760   18
#[Out]# 155761   18
#[Out]# 155762   18
#[Out]# 155763   18
#[Out]# 155764   18
#[Out]# 155765   18
#[Out]# 155766   18
#[Out]# 155767   18
#[Out]# 155768   18
#[Out]# 155769   18
#[Out]# 155770   18
#[Out]# 155771   18
#[Out]# 155772   18
#[Out]# 155773   18
#[Out]# 155774   18
#[Out]# 155775   18
#[Out]# 155776   18
#[Out]# 155777   18
#[Out]# 155778   18
#[Out]# 155779   18
#[Out]# 155780   18
#[Out]# 155781   18
#[Out]# 155782   18
#[Out]# 155783   18
#[Out]# 
#[Out]# [155784 rows x 1 columns]
query1 = '''
SELECT pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   30
#[Out]# 1   30
query1 = '''
SELECT pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query1 = '''

SELECT a.pID, a.cID, b.cID, c.cID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#         pID  cID  cID  cID
#[Out]# 0        10    0   13   22
#[Out]# 1        10    0   13   24
#[Out]# 2        10    0   13   72
#[Out]# 3        10    0   13   82
#[Out]# 4        10    0   13  100
#[Out]# 5        10    0   13  124
#[Out]# 6        10    0   13  163
#[Out]# 7        10    0   13  165
#[Out]# 8        10    0   13  169
#[Out]# 9        10    0   13  179
#[Out]# 10       10    0   13  180
#[Out]# 11       10    0   13  190
#[Out]# 12       10    0   13  190
#[Out]# 13       10    0   13  190
#[Out]# 14       10    0   22   13
#[Out]# 15       10    0   22   24
#[Out]# 16       10    0   22   72
#[Out]# 17       10    0   22   82
#[Out]# 18       10    0   22  100
#[Out]# 19       10    0   22  124
#[Out]# 20       10    0   22  163
#[Out]# 21       10    0   22  165
#[Out]# 22       10    0   22  169
#[Out]# 23       10    0   22  179
#[Out]# 24       10    0   22  180
#[Out]# 25       10    0   22  190
#[Out]# 26       10    0   22  190
#[Out]# 27       10    0   22  190
#[Out]# 28       10    0   24   13
#[Out]# 29       10    0   24   22
#[Out]# ...     ...  ...  ...  ...
#[Out]# 144588   18  190  123   51
#[Out]# 144589   18  190  123   71
#[Out]# 144590   18  190  123   82
#[Out]# 144591   18  190  123  162
#[Out]# 144592   18  190  123  177
#[Out]# 144593   18  190  123  182
#[Out]# 144594   18  190  162   24
#[Out]# 144595   18  190  162   39
#[Out]# 144596   18  190  162   51
#[Out]# 144597   18  190  162   71
#[Out]# 144598   18  190  162   82
#[Out]# 144599   18  190  162  123
#[Out]# 144600   18  190  162  177
#[Out]# 144601   18  190  162  182
#[Out]# 144602   18  190  177   24
#[Out]# 144603   18  190  177   39
#[Out]# 144604   18  190  177   51
#[Out]# 144605   18  190  177   71
#[Out]# 144606   18  190  177   82
#[Out]# 144607   18  190  177  123
#[Out]# 144608   18  190  177  162
#[Out]# 144609   18  190  177  182
#[Out]# 144610   18  190  182   24
#[Out]# 144611   18  190  182   39
#[Out]# 144612   18  190  182   51
#[Out]# 144613   18  190  182   71
#[Out]# 144614   18  190  182   82
#[Out]# 144615   18  190  182  123
#[Out]# 144616   18  190  182  162
#[Out]# 144617   18  190  182  177
#[Out]# 
#[Out]# [144618 rows x 4 columns]
query1 = '''
SELECT pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID, a.cID, b.cID, c.cID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query1 = '''
SELECT pID, date
FROM purchase
WHERE pID NOT IN(
SELECT a.pID, a.date
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT pID, date
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID        date
#[Out]# 0   29  2018-08-20
#[Out]# 1   29  2018-08-21
#[Out]# 2   30  2018-08-20
#[Out]# 3   30  2018-09-20
query1 = '''
SELECT pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query1 = '''
SELECT UNIQUE pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query3 = '''
    SELECT cID
    FROM purchase
    WHERE cID NOT IN(
    SELECT i.cID
    FROM purchase i, store j
    WHERE j.sID = i.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID
    FROM purchase
    WHERE cID NOT IN(
    SELECT i.cID
    FROM purchase i, store j
    WHERE NOT j.sID = i.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID
    FROM purchase
    WHERE cID NOT IN(
    SELECT i.cID
    FROM purchase i, store j
    WHERE j.sID not in i.sID)
'''

pd.read_sql_query(query3, conn)
query6 = '''
    SELECT i.unit_price - j.unit_price
    FROM inventory i, inventory j
    WHERE date = ‘2018-08-23’ and not i.sID = j.sID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = ‘2018-08-23’ ) and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = ‘2018-08-23’ )
    
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT i.unit_price - j.unit_price
    FROM inventory i, inventory j
    WHERE date = '2018-08-23' and not i.sID = j.sID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' ) and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
    
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT i.unit_price - j.unit_price
    FROM inventory i, inventory j
    WHERE i.date = j.date = '2018-08-23' and not i.sID = j.sID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' ) and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
    
'''

pd.read_sql_query(query6, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [i.unit_price - j.unit_price]
#[Out]# Index: []
query6 = '''
    SELECT i.unit_price - j.unit_price
    FROM inventory i, inventory j
    WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' ) and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
    
'''

pd.read_sql_query(query6, conn)
#[Out]#    i.unit_price - j.unit_price
#[Out]# 0                        12.95
#[Out]# 1                        12.95
query6 = '''
    SELECT i.unit_price - j.unit_price
    FROM inventory i, inventory j
    WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' ) and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
    
'''

pd.read_sql_query(query6, conn)
#[Out]#    i.unit_price - j.unit_price
#[Out]# 0                        12.95
#[Out]# 1                        12.95
query6 = '''
    SELECT i.unit_price - j.unit_price
    FROM inventory i, inventory j
    WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' ) and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
#[Out]#    i.unit_price - j.unit_price
#[Out]# 0                        12.95
#[Out]# 1                        12.95
query5 = '''
    SELECT pName, sName
    FROM purchase
    WHERE price = (SELECT MAX (PRICE)
    FROM purchase) and pName = (SELECT pID
    FROM purchase
    WHERE price = MAX (price))
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pName, sName
    FROM purchase
    WHERE price = MAX (price) and pName = (SELECT pName
    FROM product
    WHERE pID = (SELECT pID
    FROM purchase
    WHERE price = MAX (price)) and sName = (SELECT sName
    FROM store
    WHERE sID = (SELECT sID
    FROM purchase
    WHERE price = MAX (price)))
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pID, sID
    FROM purchase
    WHERE price = MAX (price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pID, sID
    FROM purchase
    WHERE price = (SELECT MAX (price)
    FROM purchase) and pName = (SELECT pName
    FROM product
    WHERE pID = (SELECT pID
    FROM purchase
    WHERE price = (SELECT MAX (price)
    FROM purchase)) and sName = (SELECT sName
    FROM store
    WHERE sID = (SELECT sID
    FROM purchase
    WHERE price = (SELECT MAX (price)
    FROM purchase)))
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pName, sName
    FROM purchase
    WHERE price = (SELECT MAX (price)
    FROM purchase) and pName = (SELECT pName
    FROM product
    WHERE pID = (SELECT pID
    FROM purchase
    WHERE price = (SELECT MAX (price)
    FROM purchase))) and sName = (SELECT sName
    FROM store
    WHERE sID = (SELECT sID
    FROM purchase
    WHERE price = (SELECT MAX (price)
    FROM purchase)))
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pID, sID
    FROM purchase
    WHERE price = (SELECT MAX (price)
    FROM purchase)%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pID, sID
    FROM purchase
    WHERE price = (SELECT MAX (price)
    FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#    pID  sID
#[Out]# 0   12   27
query5 = '''
SELECT i.pName, j.sName
FROM product i, store j
WHERE i.pID =(SELECT pID
    FROM purchase
    WHERE price = (SELECT MAX (price)
        FROM purchase)
        and j.sID = (SELECT sID
            FROM purchase
            WHERE price = (SELECT MAX (price)
                FROM purchase))
'''

pd.read_sql_query(query5, conn)
query5 = '''
SELECT i.pName, j.sName
FROM product i, store j
WHERE i.pID =(SELECT pID
    FROM purchase
    WHERE price = (SELECT MAX (price)
        FROM purchase))
        and j.sID = (SELECT sID
            FROM purchase
            WHERE price = (SELECT MAX (price)
                FROM purchase))
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT i.unit_price - j.unit_price
    FROM inventory i, inventory j
    WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' ) and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
#[Out]#    i.unit_price - j.unit_price
#[Out]# 0                        12.95
#[Out]# 1                        12.95
query3 = '''
    SELECT cID
    FROM purchase
    WHERE cID NOT IN(
    SELECT i.cID
    FROM purchase i, store j
    WHERE j.sID = not i.sID)
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID
    FROM purchase
    WHERE cID NOT IN(
    SELECT i.cID
    FROM purchase i, store j
    WHERE not j.sID = not i.sID )
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sName = j.sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sName = j.sName
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j

GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query1 = '''
SELECT pID < 30
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID < 30
#[Out]# 0         1
#[Out]# 1         1
#[Out]# 2         0
#[Out]# 3         0
query1 = '''
SELECT pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query4 = '''
SELECT sName
FROM purchase j
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT sName
FROM store i, purchase j
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j

GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j

GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query3 = '''
SELECT cID
FROM purchase i,
GROUP BY cID
HAVING COUNT (DISTINCT i.sID) = (SELECT COUNT (DISTINCT sID)
    FROM store)
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT i.cID
FROM purchase i,
GROUP BY i.cID
HAVING COUNT (DISTINCT i.sID) = (SELECT COUNT (DISTINCT sID)
    FROM store)
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT i.cID
FROM purchase i
GROUP BY i.cID
HAVING COUNT (DISTINCT i.sID) = (SELECT COUNT (DISTINCT sID)
    FROM store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query1 = '''
SELECT pID
FROM purchase
GROUP BY pID
HAVING COUNT (DISTINCT cID)
'''

'''
SELECT pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
SELECT pID
FROM purchase
GROUP BY pID
HAVING COUNT (DISTINCT cID) < 3
'''

'''
SELECT pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
SELECT pID
FROM purchase
WHERE pID NOT IN(
SELECT a.pID
FROM purchase a, purchase b, purchase c 
WHERE a.pID = b.pID and b.pID = c.pID and not a.cID = b.cID and not b.cID = c.cID and not a.cID = c.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query1 = '''
SELECT pID
FROM purchase
GROUP BY pID
HAVING COUNT (DISTINCT cID) < 3
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
SELECT pID
FROM purchase
GROUP BY pID
HAVING COUNT (DISTINCT cID) < 3
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query6 = '''
SELECT i.unit_price - j.unit_price
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
#[Out]#    i.unit_price - j.unit_price
#[Out]# 0                        12.95
#[Out]# 1                        12.95
query6 = '''
SELECT pID
FROM inventory
WHERE date = '2018-08-23'
GROUP BY pID
HAVING MAX (SELECT MAX (i.unit_price - j.unit_price)
    FROM inventory)
'''

'''
SELECT i.unit_price - j.unit_price
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX (i.unit_price - j.unit_price)
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID
and i.pID = j.pID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
#[Out]#   MAX (i.unit_price - j.unit_price)
#[Out]# 0                              None
query6 = '''
SELECT i.unit_price - j.unit_price
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID
and i.pID = j.pID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [i.unit_price - j.unit_price]
#[Out]# Index: []
query6 = '''
SELECT i.unit_price - j.unit_price
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID
and i.pID = j.pID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [i.unit_price - j.unit_price]
#[Out]# Index: []
query6 = '''
SELECT pID
FROM inventory
WHERE date = '2018-08-23'
GROUP BY pID
HAVING MAX (SELECT MAX (i.unit_price - j.unit_price)
    FROM inventory)
'''


'''
SELECT i.unit_price - j.unit_price
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID
and i.pID = j.pID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT pID
FROM inventory
WHERE date = '2018-08-23'
GROUP BY pID
HAVING MAX (SELECT MAX (i.unit_price)
    FROM inventory)
'''


'''
SELECT i.unit_price - j.unit_price
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID
and i.pID = j.pID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT pID
FROM inventory
WHERE date = '2018-08-23'
GROUP BY pID
HAVING MAX (unit_price)
'''


'''
SELECT i.unit_price - j.unit_price
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID
and i.pID = j.pID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9    10
#[Out]# 10   11
#[Out]# 11   12
#[Out]# 12   13
#[Out]# 13   14
#[Out]# 14   15
#[Out]# 15   16
#[Out]# 16   17
#[Out]# 17   19
#[Out]# 18   22
#[Out]# 19   23
#[Out]# 20   24
#[Out]# 21   25
#[Out]# 22   27
#[Out]# 23   28
query6 = '''
SELECT MAX (i.unit_price - j.unit_price)
FROM inventory i, inventory j
WHERE date = '2018-08-23'

'''


'''
SELECT i.unit_price - j.unit_price
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID
and i.pID = j.pID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX (i.unit_price - j.unit_price)
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date
and i.pID = j.pID

'''


'''
SELECT i.unit_price - j.unit_price
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date and not i.sID = j.sID
and i.pID = j.pID and i.unit_price = (SELECT MAX (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )
and j.unit_price = (SELECT MIN (unit_price)
    FROM inventory
    WHERE date = '2018-08-23' )   
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX (i.unit_price - j.unit_price)
#[Out]# 0                                2.0
query6 = '''
SELECT MAX (i.unit_price - j.unit_price)
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date
and i.pID = j.pID and not i.sID = j.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX (i.unit_price - j.unit_price)
#[Out]# 0                                2.0
query6 = '''
SELECT MAX (i.unit_price - j.unit_price)
FROM inventory i, inventory j
WHERE i.date = '2018-08-23' and j.date = i.date
and i.pID = j.pID and not i.sID = j.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX (i.unit_price - j.unit_price)
#[Out]# 0                                2.0
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 10
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 5
'''

pd.read_sql_query(query4, conn)
#[Out]#        sName
#[Out]# 0       Dirk
#[Out]# 1  Hoogvliet
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 5
'''

pd.read_sql_query(query4, conn)
#[Out]#        sName
#[Out]# 0       Dirk
#[Out]# 1  Hoogvliet
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 6
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 3
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query2 = '''
SELECT cID, cName
FROM customer
WHERE cID = (SELECT s.cID
    FROM purchase s, purchase t
    WHERE s.pID = (SELECT pID
        FROM product
        WHERE pName = 'Onions') 
    and t.pID = (SELECT pID
        FROM product
        WHERE pName = 'Coffee')
    and s.date = t.date and s.cID = t.cID)
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID  cName
#[Out]# 0  124  Sofie
query2 = '''
SELECT cID
FROM customer
WHERE cID = (SELECT s.cID
    FROM purchase s, purchase t
    WHERE s.pID = (SELECT pID
        FROM product
        WHERE pName = 'Onions') 
    and t.pID = (SELECT pID
        FROM product
        WHERE pName = 'Coffee')
    and s.date = t.date and s.cID = t.cID)
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID
#[Out]# 0  124
query2 = '''
SELECT s.cID
    FROM purchase s, purchase t
    WHERE s.pID = (SELECT pID
        FROM product
        WHERE pName = 'Onions') 
    and t.pID = (SELECT pID
        FROM product
        WHERE pName = 'Coffee')
    and s.date = t.date and s.cID = t.cID)
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT s.cID
    FROM purchase s, purchase t
    WHERE s.pID = (SELECT pID
        FROM product
        WHERE pName = 'Onions') 
    and t.pID = (SELECT pID
        FROM product
        WHERE pName = 'Coffee')
    and s.date = t.date and s.cID = t.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID
#[Out]# 0  124
#[Out]# 1  190
query2 = '''
SELECT cID, cName
FROM customer
WHERE cID = (SELECT s.cID
    FROM purchase s, purchase t
    WHERE s.pID = (SELECT pID
        FROM product
        WHERE pName = 'Onions') 
    and t.pID = (SELECT pID
        FROM product
        WHERE pName = 'Coffee')
    and s.date = t.date and s.cID = t.cID)
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID  cName
#[Out]# 0  124  Sofie
query2 = '''
SELECT cID, cName
FROM customer
WHERE cID = (SELECT s.cID
    FROM purchase s, purchase t
    WHERE s.pID = (SELECT pID
        FROM product
        WHERE pName = 'Onions') 
    and t.pID = (SELECT pID
        FROM product
        WHERE pName = 'Coffee')
    and s.date = t.date and s.cID = t.cID)
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID  cName
#[Out]# 0  124  Sofie
query2 = '''
SELECT s.cID, cName
FROM purchase s, purchase t, customer
WHERE s.pID = (SELECT pID
    FROM product
    WHERE pName = 'Onions') 
and t.pID = (SELECT pID
    FROM product
    WHERE pName = 'Coffee')
and s.date = t.date and s.cID = t.cID)
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT s.cID, cName
FROM purchase s, purchase t, customer
WHERE s.pID = (SELECT pID
    FROM product
    WHERE pName = 'Onions') 
and t.pID = (SELECT pID
    FROM product
    WHERE pName = 'Coffee')
and s.date = t.date and s.cID = t.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID    cName
#[Out]# 0    124     Noah
#[Out]# 1    190     Noah
#[Out]# 2    124      Sem
#[Out]# 3    190      Sem
#[Out]# 4    124    Lucas
#[Out]# 5    190    Lucas
#[Out]# 6    124     Finn
#[Out]# 7    190     Finn
#[Out]# 8    124     Daan
#[Out]# 9    190     Daan
#[Out]# 10   124     Levi
#[Out]# 11   190     Levi
#[Out]# 12   124    Milan
#[Out]# 13   190    Milan
#[Out]# 14   124     Bram
#[Out]# 15   190     Bram
#[Out]# 16   124     Liam
#[Out]# 17   190     Liam
#[Out]# 18   124   Thomas
#[Out]# 19   190   Thomas
#[Out]# 20   124      Sam
#[Out]# 21   190      Sam
#[Out]# 22   124    Thijs
#[Out]# 23   190    Thijs
#[Out]# 24   124     Adam
#[Out]# 25   190     Adam
#[Out]# 26   124    James
#[Out]# 27   190    James
#[Out]# 28   124      Max
#[Out]# 29   190      Max
#[Out]# ..   ...      ...
#[Out]# 350  124      Sam
#[Out]# 351  190      Sam
#[Out]# 352  124    Amira
#[Out]# 353  190    Amira
#[Out]# 354  124    Eline
#[Out]# 355  190    Eline
#[Out]# 356  124     Elif
#[Out]# 357  190     Elif
#[Out]# 358  124     Juul
#[Out]# 359  190     Juul
#[Out]# 360  124    Merel
#[Out]# 361  190    Merel
#[Out]# 362  124     Liva
#[Out]# 363  190     Liva
#[Out]# 364  124  Johanna
#[Out]# 365  190  Johanna
#[Out]# 366  124    Nikki
#[Out]# 367  190    Nikki
#[Out]# 368  124    Wilko
#[Out]# 369  190    Wilko
#[Out]# 370  124     Nick
#[Out]# 371  190     Nick
#[Out]# 372  124   Angela
#[Out]# 373  190   Angela
#[Out]# 374  124     Pino
#[Out]# 375  190     Pino
#[Out]# 376  124     Koen
#[Out]# 377  190     Koen
#[Out]# 378  124   Kostas
#[Out]# 379  190   Kostas
#[Out]# 
#[Out]# [380 rows x 2 columns]
query2 = '''
SELECT s.cID, s.cName
FROM purchase s, purchase t, customer
WHERE s.pID = (SELECT pID
    FROM product
    WHERE pName = 'Onions') 
and t.pID = (SELECT pID
    FROM product
    WHERE pName = 'Coffee')
and s.date = t.date and s.cID = t.cID
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT s.cID, r.cID
FROM purchase s, purchase t, customer r
WHERE s.pID = (SELECT pID
    FROM product
    WHERE pName = 'Onions') 
and t.pID = (SELECT pID
    FROM product
    WHERE pName = 'Coffee')
and s.date = t.date and s.cID = t.cID
and r.cID = t.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID  cID
#[Out]# 0  124  124
#[Out]# 1  190  190
query2 = '''
SELECT s.cID, r.cName
FROM purchase s, purchase t, customer r
WHERE s.pID = (SELECT pID
    FROM product
    WHERE pName = 'Onions') 
and t.pID = (SELECT pID
    FROM product
    WHERE pName = 'Coffee')
and s.date = t.date and s.cID = t.cID
and r.cID = t.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
SELECT s.cID, r.cName
FROM purchase s, purchase t, customer r
WHERE s.pID = (SELECT pID
    FROM product
    WHERE pName = 'Onions') 
and t.pID = (SELECT pID
    FROM product
    WHERE pName = 'Coffee')
and s.date = t.date and s.cID = t.cID = r.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID cName
#[Out]# 0    29  Noah
#[Out]# 1    31  Noah
#[Out]# 2    33  Noah
#[Out]# 3    33  Noah
#[Out]# 4    33  Noah
#[Out]# 5    52  Noah
#[Out]# 6    52  Noah
#[Out]# 7    52  Noah
#[Out]# 8    59  Noah
#[Out]# 9    59  Noah
#[Out]# 10   59  Noah
#[Out]# 11   85  Noah
#[Out]# 12   85  Noah
#[Out]# 13   85  Noah
#[Out]# 14  124   Sem
#[Out]# 15  124  Noah
#[Out]# 16  124  Noah
#[Out]# 17  129  Noah
#[Out]# 18  169  Noah
#[Out]# 19  169  Noah
#[Out]# 20  169  Noah
#[Out]# 21  169  Noah
#[Out]# 22  172  Noah
#[Out]# 23  176  Noah
#[Out]# 24  176  Noah
#[Out]# 25  176  Noah
#[Out]# 26  177  Noah
#[Out]# 27  177  Noah
#[Out]# 28  177  Noah
#[Out]# 29  190  Noah
#[Out]# 30  190  Noah
#[Out]# 31  190   Sem
query2 = '''
SELECT s.cID, r.c
FROM purchase s, purchase t, customer r
WHERE s.pID = (SELECT pID
    FROM product
    WHERE pName = 'Onions') 
and t.pID = (SELECT pID
    FROM product
    WHERE pName = 'Coffee')
and s.date = t.date and s.cID = t.cID
and r.cID = t.cID
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT s.cID, r.cName
FROM purchase s, purchase t, customer r
WHERE s.pID = (SELECT pID
    FROM product
    WHERE pName = 'Onions') 
and t.pID = (SELECT pID
    FROM product
    WHERE pName = 'Coffee')
and s.date = t.date and s.cID = t.cID
and r.cID = t.cID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
SELECT cID
FROM purchase 
GROUP BY cID
HAVING COUNT (DISTINCT sID) = (SELECT COUNT (DISTINCT sID)
    FROM store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
SELECT i.sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
SELECT i.sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY i.sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
SELECT i.pName, j.sName
FROM product i, store j
WHERE i.pID = (SELECT pID
    FROM purchase
    WHERE price = (SELECT MAX (price)
        FROM purchase))
and j.sID = (SELECT sID
    FROM purchase
    WHERE price = (SELECT MAX (price)
        FROM purchase))
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
practicequery1a = '''
(SELECT i.cID
FROM purchase i, shoppinglist j,
WHERE i.date = j.date and i.cID = j.cID)
EXCEPT
(SELECT i.cID
FROM purchase i, shoppinglist j,
WHERE i.date = j.date and i.cID = j.cID and i.pID = j.pID)
'''

pd.read_sql_query(practicequery1a, conn)
practicequery1a = '''
(SELECT i.cID
FROM purchase i, shoppinglist j,
WHERE i.date = j.date and i.cID = j.cID)
DIVISION
(SELECT i.cID
FROM purchase i, shoppinglist j,
WHERE i.date = j.date and i.cID = j.cID and i.pID = j.pID)
'''

pd.read_sql_query(practicequery1a, conn)
practicequery1a = '''
(SELECT i.cID
FROM purchase i, shoppinglist j,
WHERE i.date = j.date and i.cID = j.cID)
'''

pd.read_sql_query(practicequery1a, conn)
practicequery1a = '''
SELECT i.cID
FROM purchase i, shoppinglist j,
WHERE i.date = j.date and i.cID = j.cID
'''

pd.read_sql_query(practicequery1a, conn)
practicequery1a = '''
(SELECT i.cID
FROM purchase i, shoppinglist j
WHERE i.date = j.date and i.cID = j.cID)
EXCEPT
(SELECT i.cID
FROM purchase i, shoppinglist j
WHERE i.date = j.date and i.cID = j.cID and i.pID = j.pID)
'''

pd.read_sql_query(practicequery1a, conn)
practicequery1a = '''
SELECT i.cID
FROM purchase i, shoppinglist j
WHERE i.date = j.date and i.cID = j.cID

'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#      cID
#[Out]# 0      1
#[Out]# 1      1
#[Out]# 2      1
#[Out]# 3      1
#[Out]# 4      1
#[Out]# 5      1
#[Out]# 6      1
#[Out]# 7      1
#[Out]# 8      1
#[Out]# 9      1
#[Out]# 10     1
#[Out]# 11     1
#[Out]# 12     1
#[Out]# 13     1
#[Out]# 14     1
#[Out]# 15     1
#[Out]# 16     1
#[Out]# 17     1
#[Out]# 18     1
#[Out]# 19     1
#[Out]# 20     1
#[Out]# 21     1
#[Out]# 22     1
#[Out]# 23     1
#[Out]# 24     1
#[Out]# 25     1
#[Out]# 26     1
#[Out]# 27     1
#[Out]# 28     1
#[Out]# 29     1
#[Out]# ..   ...
#[Out]# 946  176
#[Out]# 947  178
#[Out]# 948  178
#[Out]# 949  178
#[Out]# 950  178
#[Out]# 951  179
#[Out]# 952  179
#[Out]# 953  179
#[Out]# 954  179
#[Out]# 955  179
#[Out]# 956  179
#[Out]# 957  179
#[Out]# 958  179
#[Out]# 959  179
#[Out]# 960  179
#[Out]# 961  179
#[Out]# 962  179
#[Out]# 963  179
#[Out]# 964  179
#[Out]# 965  179
#[Out]# 966  180
#[Out]# 967  180
#[Out]# 968  180
#[Out]# 969  180
#[Out]# 970  181
#[Out]# 971  181
#[Out]# 972  181
#[Out]# 973  181
#[Out]# 974  181
#[Out]# 975  181
#[Out]# 
#[Out]# [976 rows x 1 columns]
practicequery1a = '''
(SELECT i.cID
FROM purchase i, shoppinglist j
WHERE i.date = j.date and i.cID = j.cID)

'''

pd.read_sql_query(practicequery1a, conn)
practicequery1a = '''
SELECT i.cID
FROM purchase i, shoppinglist j
WHERE i.date = j.date and i.cID = j.cID
EXCEPT
SELECT i.cID
FROM purchase i, shoppinglist j
WHERE i.date = j.date and i.cID = j.cID and i.pID = j.pID

'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#    cID
#[Out]# 0   38
#[Out]# 1   64
#[Out]# 2   68
#[Out]# 3  116
#[Out]# 4  144
query4 = '''
SELECT i.sName
WHERE i.sID = j.sID
GROUP BY i.sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT i.sName
FROM store i, purchase j
GROUP BY i.sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT i.sName
FROM store i, purchase j
GROUP BY i.sName
HAVING AVG (j.quantity) > 6
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
SELECT i.sName
FROM store i, purchase j
GROUP BY i.sName
HAVING AVG (j.quantity) > 5
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
SELECT i.sName
FROM store i, purchase j
GROUP BY i.sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT i.sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY i.sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
SELECT i.sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY i.sName
HAVING AVG (j.quantity) > 5
'''

pd.read_sql_query(query4, conn)
#[Out]#        sName
#[Out]# 0       Dirk
#[Out]# 1  Hoogvliet
query4 = '''
SELECT i.sName
FROM store i, purchase j
WHERE i.sID = j.sID
GROUP BY i.sName
HAVING AVG (j.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
SELECT i.pName, j.sName
FROM product i, store j
WHERE i.pID = (SELECT pID
    FROM purchase
    WHERE price = (SELECT MAX (price)
        FROM purchase))
and j.sID = (SELECT sID
    FROM purchase
    WHERE price = (SELECT MAX (price)
        FROM purchase))
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
practicequery1a = '''
SELECT i.cID
FROM purchase i, shoppinglist j
WHERE i.date = j.date and i.cID = j.cID
EXCEPT
SELECT i.cID
FROM purchase i, shoppinglist j
WHERE i.date = j.date and i.cID = j.cID and i.pID = j.pID
'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#    cID
#[Out]# 0   38
#[Out]# 1   64
#[Out]# 2   68
#[Out]# 3  116
#[Out]# 4  144
