# IPython log file

query1 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query1, conn)
query1 = '''
select pID
from purchase as p
where p.pID = pID and p.cID and (select count(*)
                                    from purchase
                                    where cID = p.cID) < 3
'''

pd.read_sql_query(query1, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x16e3fd5b2d0>
query1 = '''
select pID
from purchase as p
where p.pID = pID and p.cID and (select count(*)
                                    from purchase
                                    where cID = p.cID) < 3
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     6
#[Out]# 1     8
#[Out]# 2    24
#[Out]# 3    14
#[Out]# 4    11
#[Out]# 5    14
#[Out]# 6     7
#[Out]# 7    28
#[Out]# 8    10
#[Out]# 9    26
#[Out]# 10   23
#[Out]# 11   11
#[Out]# 12    7
#[Out]# 13    4
#[Out]# 14    4
#[Out]# 15   24
#[Out]# 16   26
#[Out]# 17   24
#[Out]# 18   28
#[Out]# 19   19
#[Out]# 20   13
#[Out]# 21   25
#[Out]# 22   22
#[Out]# 23   24
#[Out]# 24    3
#[Out]# 25    6
#[Out]# 26   21
#[Out]# 27    8
#[Out]# 28   23
#[Out]# 29   16
#[Out]# ..  ...
#[Out]# 67    7
#[Out]# 68   22
#[Out]# 69    6
#[Out]# 70   28
#[Out]# 71   20
#[Out]# 72    0
#[Out]# 73   12
#[Out]# 74    9
#[Out]# 75   17
#[Out]# 76   19
#[Out]# 77    9
#[Out]# 78   23
#[Out]# 79   26
#[Out]# 80   12
#[Out]# 81    1
#[Out]# 82    3
#[Out]# 83   21
#[Out]# 84    4
#[Out]# 85   16
#[Out]# 86   28
#[Out]# 87   21
#[Out]# 88   25
#[Out]# 89   24
#[Out]# 90    0
#[Out]# 91   29
#[Out]# 92   29
#[Out]# 93   30
#[Out]# 94   30
#[Out]# 95    7
#[Out]# 96   19
#[Out]# 
#[Out]# [97 rows x 1 columns]
query1 = '''
select pID
from purchase as p
where p.pID = pID and p.cID and (select count(*)
                                    from purchase
                                    where cID = p.cID) < 3
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     6
#[Out]# 1     8
#[Out]# 2    24
#[Out]# 3    14
#[Out]# 4    11
#[Out]# 5    14
#[Out]# 6     7
#[Out]# 7    28
#[Out]# 8    10
#[Out]# 9    26
#[Out]# 10   23
#[Out]# 11   11
#[Out]# 12    7
#[Out]# 13    4
#[Out]# 14    4
#[Out]# 15   24
#[Out]# 16   26
#[Out]# 17   24
#[Out]# 18   28
#[Out]# 19   19
#[Out]# 20   13
#[Out]# 21   25
#[Out]# 22   22
#[Out]# 23   24
#[Out]# 24    3
#[Out]# 25    6
#[Out]# 26   21
#[Out]# 27    8
#[Out]# 28   23
#[Out]# 29   16
#[Out]# ..  ...
#[Out]# 67    7
#[Out]# 68   22
#[Out]# 69    6
#[Out]# 70   28
#[Out]# 71   20
#[Out]# 72    0
#[Out]# 73   12
#[Out]# 74    9
#[Out]# 75   17
#[Out]# 76   19
#[Out]# 77    9
#[Out]# 78   23
#[Out]# 79   26
#[Out]# 80   12
#[Out]# 81    1
#[Out]# 82    3
#[Out]# 83   21
#[Out]# 84    4
#[Out]# 85   16
#[Out]# 86   28
#[Out]# 87   21
#[Out]# 88   25
#[Out]# 89   24
#[Out]# 90    0
#[Out]# 91   29
#[Out]# 92   29
#[Out]# 93   30
#[Out]# 94   30
#[Out]# 95    7
#[Out]# 96   19
#[Out]# 
#[Out]# [97 rows x 1 columns]
query1 = '''
select pID
from purchase
where (select count(*)
        from purchase as p
        where p.pID = pID and p.cID != cID) < 3
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 479   28
#[Out]# 480   27
#[Out]# 481    5
#[Out]# 482   28
#[Out]# 483    7
#[Out]# 484    0
#[Out]# 485   11
#[Out]# 486    6
#[Out]# 487   19
#[Out]# 488   17
#[Out]# 489    9
#[Out]# 490   11
#[Out]# 491   22
#[Out]# 492   17
#[Out]# 493   20
#[Out]# 494   11
#[Out]# 495   21
#[Out]# 496   23
#[Out]# 497   23
#[Out]# 498    8
#[Out]# 499    0
#[Out]# 500    8
#[Out]# 501   11
#[Out]# 502   15
#[Out]# 503    2
#[Out]# 504   17
#[Out]# 505    5
#[Out]# 506   19
#[Out]# 507    9
#[Out]# 508   18
#[Out]# 
#[Out]# [509 rows x 1 columns]
query1 = '''
select pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 3
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query1 = '''
select pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 4
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query1 = '''
select pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 5
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query1 = '''
select pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 6
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query1 = '''
select pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 100
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 479   28
#[Out]# 480   27
#[Out]# 481    5
#[Out]# 482   28
#[Out]# 483    7
#[Out]# 484    0
#[Out]# 485   11
#[Out]# 486    6
#[Out]# 487   19
#[Out]# 488   17
#[Out]# 489    9
#[Out]# 490   11
#[Out]# 491   22
#[Out]# 492   17
#[Out]# 493   20
#[Out]# 494   11
#[Out]# 495   21
#[Out]# 496   23
#[Out]# 497   23
#[Out]# 498    8
#[Out]# 499    0
#[Out]# 500    8
#[Out]# 501   11
#[Out]# 502   15
#[Out]# 503    2
#[Out]# 504   17
#[Out]# 505    5
#[Out]# 506   19
#[Out]# 507    9
#[Out]# 508   18
#[Out]# 
#[Out]# [509 rows x 1 columns]
query1 = '''
select pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 10
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     2
#[Out]# 1    18
#[Out]# 2     2
#[Out]# 3     2
#[Out]# 4    18
#[Out]# 5    18
#[Out]# 6    18
#[Out]# 7    18
#[Out]# 8     2
#[Out]# 9     2
#[Out]# 10    2
#[Out]# 11   18
#[Out]# 12   18
#[Out]# 13    2
#[Out]# 14    2
#[Out]# 15   18
#[Out]# 16   18
#[Out]# 17   29
#[Out]# 18   29
#[Out]# 19   30
#[Out]# 20   30
#[Out]# 21    2
#[Out]# 22    2
#[Out]# 23   18
query1 = '''
select pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 3
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   29
#[Out]# 2   30
#[Out]# 3   30
query1 = '''
select distinct pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 3
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
(select distinct pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 3)
union
(select pID
from product as prod
where prod.pID not in(select pID
                        from purchase))
'''

pd.read_sql_query(query1, conn)
query1 = '''
(select distinct pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 3)
union
(select pID
from product as prod
where prod.pID not in(select pID
                        from purchase))
'''

pd.read_sql_query(query1, conn)
query1 = '''
(select distinct pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 3)
union
(select pID
from product as prod
where prod.pID not in (select pID
                        from purchase))
'''

pd.read_sql_query(query1, conn)
query1 = '''

(select pID
from product as prod
where prod.pID not in (select pID
                        from purchase))
'''

pd.read_sql_query(query1, conn)
query1 = '''
select pID
from product as prod
where prod.pID not in (select pID
                        from purchase)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   31
query1 = '''
select distinct pID
from purchase as p
where p.pID = pID and (select count(*)
                        from purchase
                        where p.pID = pID and p.cID != cID) < 3
union
select pID
from product as prod
where prod.pID not in (select pID
                        from purchase)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
select cID, cName
from customer as c
where c.cID = cID and cID in (select cID
                                from purchase as p
                                where p.cID = c.cID and p.pID in (select pID
                                                                    from product as prod
                                                                    where prod.pName = Onions)) and cID in (select cID
                                                                                                            from purchase as p2
                                                                                                            where p2.cID = c.cID and p2.pID in (select pID
                                                                                                                                                from product as prod2
                                                                                                                                                where prod2.pName = Coffee) and p2.date = p.date)
'''

pd.read_sql_query(query2, conn)
query2 = '''
select cID, cName
from customer as c, purchase as p
where c.cID = cID and cID in (select cID
                                from purchase
                                where p.cID = c.cID and p.pID in (select pID
                                                                    from product as prod
                                                                    where prod.pName = Onions)) and cID in (select cID
                                                                                                            from purchase as p2
                                                                                                            where p2.cID = c.cID and p2.pID in (select pID
                                                                                                                                                from product as prod2
                                                                                                                                                where prod2.pName = Coffee) and p2.date = p.date)
'''

pd.read_sql_query(query2, conn)
query2 = '''
select cID, cName
from (select *
        from customer as c, purchase as p, product as prod
        where c.cID = p.cID and p.pID = prod.pID) as cust
where cust.cID = cID and cust.pName = Onions
'''

pd.read_sql_query(query2, conn)
query2 = '''
select cID, cName
from (select *
        from customer as c, purchase as p, product as prod
        where c.cID = p.cID and p.pID = prod.pID) as cust
where cust.cID = cID and cust.pName = 'Onions'
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID    cName
#[Out]# 0     2    Lucas
#[Out]# 1    29    Ruben
#[Out]# 2    31  Olivier
#[Out]# 3    33     Sven
#[Out]# 4    52   Willem
#[Out]# 5    59     Joep
#[Out]# 6    85   Pieter
#[Out]# 7   124    Sofie
#[Out]# 8   129    Esmee
#[Out]# 9   162    Elena
#[Out]# 10  165    Hanna
#[Out]# 11  169     Lily
#[Out]# 12  172     Lana
#[Out]# 13  176    Amira
#[Out]# 14  177    Eline
#[Out]# 15  190   Kostas
query2 = '''
select cID, cName
from (select *
        from customer as c, purchase as p, product as prod
        where c.cID = p.cID and p.pID = prod.pID) as cust
where cust.cID = cID and cust.pName = 'Onions' and cID in (select cID
                                                            from (select *
                                                                    from customer as c, purchase as p, product as prod
                                                                    where c.cID = p.cID and p.pID = prod.pID) as cust
                                                            where cust.cID = cID and cust.pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
query2 = '''
select cID, cName, pName
from (select *
        from customer as c, purchase as p, product as prod
        where c.cID = p.cID and p.pID = prod.pID) as cust
where cust.cID = cID and cust.pName = 'Onions' and cID in (select cID
                                                            from (select *
                                                                    from customer as c, purchase as p, product as prod
                                                                    where c.cID = p.cID and p.pID = prod.pID) as cust
                                                            where cust.cID = cID and cust.pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName   pName
#[Out]# 0   59    Joep  Onions
#[Out]# 1  124   Sofie  Onions
#[Out]# 2  169    Lily  Onions
#[Out]# 3  176   Amira  Onions
#[Out]# 4  190  Kostas  Onions
query2 = '''
select cID, cName
from (select *
        from customer as c, purchase as p, product as prod
        where c.cID = p.cID and p.pID = prod.pID) as cust
where cust.cID = cID and cust.pName = 'Onions' and cID in (select cID
                                                            from (select *
                                                                    from customer as c, purchase as p, product as prod
                                                                    where c.cID = p.cID and p.pID = prod.pID) as cust
                                                            where cust.cID = cID and cust.pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
query2 = '''
select cID, cName
from (select *
        from customer as c, purchase as p, product as prod
        where c.cID = p.cID and p.pID = prod.pID) as cust
where cust.cID = cID and cust.pName = 'Onions' and cID in (select cID
                                                            from (select *
                                                                    from customer as c, purchase as p, product as prod
                                                                    where c.cID = p.cID and p.pID = prod.pID) as cust2
                                                            where cust.cID = cID and cust2.pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
query2 = '''
select cID, cName
from (select *
        from customer as c, purchase as p, product as prod
        where c.cID = p.cID and p.pID = prod.pID) as cust
where cust.cID = cID and cust.pName = 'Onions' and cID in (select cID
                                                            from (select *
                                                                    from customer as c, purchase as p, product as prod
                                                                    where c.cID = p.cID and p.pID = prod.pID) as cust2
                                                            where cust.cID = cID and cust2.pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
query2 = '''
select cID, cName
from (select *
        from customer as c, purchase as p, product as prod
        where c.cID = p.cID and p.pID = prod.pID) as cust
where cust.cID = cID and cust.pName = 'Onions' and cID in (select cID
                                                            from (select *
                                                                    from customer as c, purchase as p, product as prod
                                                                    where c.cID = p.cID and p.pID = prod.pID) as cust2
                                                            where cust2.cID = cID and cust2.pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
query2 = '''
select cID, cName
from (select *
        from customer as c, purchase as p, product as prod
        where c.cID = p.cID and p.pID = prod.pID) as cust
where cust.cID = cID and cust.pName = 'Onions' and cID in (select cID
                                                            from (select *
                                                                    from customer as c, purchase as p, product as prod
                                                                    where c.cID = p.cID and p.pID = prod.pID) as cust2
                                                            where cust2.cID = cID and cust2.pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0   59    Joep
#[Out]# 1  124   Sofie
#[Out]# 2  169    Lily
#[Out]# 3  176   Amira
#[Out]# 4  190  Kostas
query3 = '''
select cID
from (select *
        from customer as c, purchase as p
        where c.cID = p.cID) as cust
where cust.cID = cID and (select count(*)
                            from (select *
                                    from customer as c2, purchase as p2
                                    where c2.cID = p2.cID) as cust2
                            where cust2.cID = cID and cID = cust.cID) = (select count(*)
                                                                            from store)
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0   190
#[Out]# 1   190
#[Out]# 2   190
#[Out]# 3   190
#[Out]# 4   190
#[Out]# 5   190
#[Out]# 6   190
#[Out]# 7   190
#[Out]# 8   190
#[Out]# 9   190
#[Out]# 10  190
#[Out]# 11  190
#[Out]# 12  190
#[Out]# 13  190
#[Out]# 14  190
#[Out]# 15  190
#[Out]# 16  190
#[Out]# 17  190
#[Out]# 18  190
#[Out]# 19  190
#[Out]# 20  190
#[Out]# 21  190
#[Out]# 22  190
#[Out]# 23  190
#[Out]# 24  190
#[Out]# 25  190
#[Out]# 26  190
#[Out]# 27  190
#[Out]# 28  190
#[Out]# 29  190
#[Out]# ..  ...
#[Out]# 34  190
#[Out]# 35  190
#[Out]# 36  190
#[Out]# 37  190
#[Out]# 38  190
#[Out]# 39  190
#[Out]# 40  190
#[Out]# 41  190
#[Out]# 42  190
#[Out]# 43  190
#[Out]# 44  190
#[Out]# 45  190
#[Out]# 46  190
#[Out]# 47  190
#[Out]# 48  190
#[Out]# 49  190
#[Out]# 50  190
#[Out]# 51  190
#[Out]# 52  190
#[Out]# 53  190
#[Out]# 54  190
#[Out]# 55  190
#[Out]# 56  190
#[Out]# 57  190
#[Out]# 58  190
#[Out]# 59  190
#[Out]# 60  190
#[Out]# 61  190
#[Out]# 62  190
#[Out]# 63  190
#[Out]# 
#[Out]# [64 rows x 1 columns]
query3 = '''
select distinct cID
from (select *
        from customer as c, purchase as p
        where c.cID = p.cID) as cust
where cust.cID = cID and (select count(*)
                            from (select *
                                    from customer as c2, purchase as p2
                                    where c2.cID = p2.cID) as cust2
                            where cust2.cID = cID and cID = cust.cID) = (select count(*)
                                                                            from store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
select avg(quantity)
from purchase
where s.sName = sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
select avg(quantity)
from purchase as p
where p.sName = sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
select avg(quantity)
from (select *
        from store as s, purchase as p
        where s.sID=p.pID) as store
where store.sName = sName
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(quantity)
#[Out]# 0       4.797642
query4 = '''
select sName
from (select *
        from store as s, purchase as p
        where s.sID=p.pID) as store
where store.sName = sName
'''

pd.read_sql_query(query4, conn)
#[Out]#            sName
#[Out]# 0          Jumbo
#[Out]# 1           Coop
#[Out]# 2           Lidl
#[Out]# 3    Albert Hein
#[Out]# 4    Albert Hein
#[Out]# 5      Hoogvliet
#[Out]# 6    Albert Hein
#[Out]# 7         Sligro
#[Out]# 8          Jumbo
#[Out]# 9    Albert Hein
#[Out]# 10     Hoogvliet
#[Out]# 11          Coop
#[Out]# 12          Lidl
#[Out]# 13          Coop
#[Out]# 14     Hoogvliet
#[Out]# 15   Albert Hein
#[Out]# 16   Albert Hein
#[Out]# 17        Sligro
#[Out]# 18          Lidl
#[Out]# 19          Coop
#[Out]# 20          Coop
#[Out]# 21     Hoogvliet
#[Out]# 22          Coop
#[Out]# 23     Hoogvliet
#[Out]# 24          Coop
#[Out]# 25          Lidl
#[Out]# 26          Lidl
#[Out]# 27          Coop
#[Out]# 28          Coop
#[Out]# 29         Jumbo
#[Out]# ..           ...
#[Out]# 479    Hoogvliet
#[Out]# 480       Sligro
#[Out]# 481       Sligro
#[Out]# 482    Hoogvliet
#[Out]# 483       Sligro
#[Out]# 484         Coop
#[Out]# 485  Albert Hein
#[Out]# 486         Coop
#[Out]# 487         Coop
#[Out]# 488    Hoogvliet
#[Out]# 489  Albert Hein
#[Out]# 490  Albert Hein
#[Out]# 491         Lidl
#[Out]# 492    Hoogvliet
#[Out]# 493        Jumbo
#[Out]# 494  Albert Hein
#[Out]# 495         Coop
#[Out]# 496         Dirk
#[Out]# 497         Dirk
#[Out]# 498  Albert Hein
#[Out]# 499         Coop
#[Out]# 500  Albert Hein
#[Out]# 501  Albert Hein
#[Out]# 502         Lidl
#[Out]# 503        Jumbo
#[Out]# 504    Hoogvliet
#[Out]# 505       Sligro
#[Out]# 506         Coop
#[Out]# 507  Albert Hein
#[Out]# 508       Sligro
#[Out]# 
#[Out]# [509 rows x 1 columns]
query4 = '''
select distinct sName
from (select *
        from store as s, purchase as p
        where s.sID=p.pID) as store
where store.sName = sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0        Jumbo
#[Out]# 1         Coop
#[Out]# 2         Lidl
#[Out]# 3  Albert Hein
#[Out]# 4    Hoogvliet
#[Out]# 5       Sligro
#[Out]# 6         Dirk
query4 = '''
select distinct sName
from (select *
        from store as s, purchase as p
        where s.sID=p.pID) as store
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0        Jumbo
#[Out]# 1         Coop
#[Out]# 2         Lidl
#[Out]# 3  Albert Hein
#[Out]# 4    Hoogvliet
#[Out]# 5       Sligro
#[Out]# 6         Dirk
query4 = '''
select distinct sName
from store as stor
where (select avg(quantity)
        from product as prod
        where prod.sID = sID) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
select distinct sName
from store as stor
where (select avg(quantity)
        from purchase as p
        where p.sID = sID) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2        Jumbo
#[Out]# 3       Sligro
#[Out]# 4  Albert Hein
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
select distinct sName
from store as s
where (select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain
      ) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain

'''

pd.read_sql_query(query4, conn)
query4 = '''
select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain
      ) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain
      ) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain
     
'''

pd.read_sql_query(query4, conn)
query4 = '''
select distinct sName
from store as s
where (select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain
      ) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
select distinct sName
from store as s
where (select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain
      ) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
select distinct sName
from store as s
where (select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain
        where storeChain.sID = sID) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
select distinct sName
from store as s
where (select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain
        where storeChain.sName = sName) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query5 = '''
select max(price)
from purchase
'''

pd.read_sql_query(query5, conn)
#[Out]#    max(price)
#[Out]# 0        13.8
query5 = '''
select price
from purchase p
where p.price = 13.8
'''

pd.read_sql_query(query5, conn)
#[Out]#    price
#[Out]# 0   13.8
query5 = '''
select price
from purchase p
where p.price => 13.8
'''

pd.read_sql_query(query5, conn)
query5 = '''
select price
from purchase p
where p.price >= 13.8
'''

pd.read_sql_query(query5, conn)
#[Out]#    price
#[Out]# 0   13.8
query5 = '''
select price, pName
from purchase p
where p.pName = pName and p.price in select (max(price)
                                        from purchase)
'''

pd.read_sql_query(query5, conn)
query5 = '''
select price, pName
from purchase p
where p.pName = pName and p.price in (select max(price)
                                        from purchase)
'''

pd.read_sql_query(query5, conn)
query4 = '''
select distinct sName
from store as s
where (select avg(quantity)
        from (select sName,quantity
                from purchase as p, store as stor
                where stor.sID = p.sID) as storeChain
        where storeChain.sName = sName) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2        Jumbo
#[Out]# 3       Sligro
#[Out]# 4  Albert Hein
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
select distinct sName
from store as s
where (select avg(quantity)
        from (select sName,quantity
                from purchase as p, store as stor
                where stor.sID = p.sID) as storeChain
        where storeChain.sName = sName) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2        Jumbo
#[Out]# 3       Sligro
#[Out]# 4  Albert Hein
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
select distinct sName
from store as s
where (select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain
        where storeChain.sName = sName) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
select distinct sName
from store as s
where (select avg(quantity)
        from (select sName,quantity
                from purchase as p
                where s.sID = p.sID) as storeChain
        where storeChain.sName = sName) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query5 = '''
select price, pName
from (select *
        from purchase as pur, product as prod
        where pur.pID = prod.pID)
where p.pName = pName and p.price in (select max(price)
                                        from purchase)
'''

pd.read_sql_query(query5, conn)
query5 = '''
select price, pName
from (select *
        from purchase as pur, product as prod
        where pur.pID = prod.pID) as p
where p.pName = pName and p.price in (select max(price)
                                        from purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#    price pName
#[Out]# 0   13.8  Beef
