# IPython log file

get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    select * 
    from customer
    limit 10;



'''


pd.read_sql_query(query1, conn)
#[Out]#    cID   cName            street       city
#[Out]# 0    0    Noah         Koestraat    Utrecht
#[Out]# 1    1     Sem  Rozemarijnstraat      Breda
#[Out]# 2    2   Lucas  Oude Leliestraat  Amsterdam
#[Out]# 3    3    Finn     Stationsplein      Breda
#[Out]# 4    4    Daan      Kalverstraat  Amsterdam
#[Out]# 5    5    Levi    Gasthuisstraat    Utrecht
#[Out]# 6    6   Milan       Parallelweg    Utrecht
#[Out]# 7    7    Bram      Schoolstraat  Eindhoven
#[Out]# 8    8    Liam     Rijsbergseweg      Breda
#[Out]# 9    9  Thomas       Parallelweg  Amsterdam
query1 = '''
    select p1.pID 
    from purchase as p1
    where unique (select from purchase)



'''


pd.read_sql_query(query1, conn)
query1 = '''
    select p1.pID 
    from purchase as p1
    where unique 



'''


pd.read_sql_query(query1, conn)
query1 = '''
    select p1.pID 
    from purchase as p1
    where unique pID



'''


pd.read_sql_query(query1, conn)
query5 = '''
    select pName, sName
    from purchase
    where price = (select max (price)
    from purchase) and pName = (select pName 
    from product 
    where pID = (select pID
    from purchase
    where price = (select max (price)
    from purchase))) and sName = (select sName
    from store
    where sID = (select sID
    from purchase
    where price = (select max (price)
    from purchase)))
'''

pd.read_sql_query(query5, conn)
query6 = '''
    select p1.unit_price
    from inventory as p1
    where p1.unit_price = (select max (unit_price) 
    from inventory
    where date ='2018-08-23')
'''
#p1 most expensive item
#p2 cheapest


pd.read_sql_query(query6, conn)
#[Out]#    unit_price
#[Out]# 0        13.4
query6 = '''
    select p1.unit_price-p2.unit_price
    from inventory as p1
    where p1.unit_price = (select max (unit_price) 
    from inventory
    where date ='2018-08-23')
'''
#p1 most expensive item
#p2 cheapest


pd.read_sql_query(query6, conn)
query6 = '''
    select p1.unit_price
    from inventory as p1
    where p1.unit_price = (select max (unit_price) 
    from inventory
    where date ='2018-08-23')
    
    select p2.unit_price
    from inventory as p2
    where p2.unit_price = (select min (unit_price)
    from inventory
    where date ='2018-08-23' and p2.sID is not p1.sID)
'''
#p1 most expensive item
#p2 cheapest


pd.read_sql_query(query6, conn)
query6 = '''

    
    select p2.unit_price
    from inventory as p2
    where p2.unit_price = (select min (unit_price)
    from inventory
    where date ='2018-08-23' and p2.sID is not p1.sID)
'''
#p1 most expensive item
#p2 cheapest


pd.read_sql_query(query6, conn)
query6 = '''
    select p1.unit_price
    from inventory as p1
    where p1.unit_price = (select max (unit_price) 
    from inventory
    where date ='2018-08-23')
    
    select p2.unit_price
    from inventory as p2
    where p2.unit_price = (select min (unit_price)
    from inventory
    where date ='2018-08-23')
'''
#p1 most expensive item
#p2 cheapest


pd.read_sql_query(query6, conn)
query6 = '''
    select p1.unit_price
    from inventory as p1
    where p1.unit_price = (select max (unit_price) 
    from inventory
    where date ='2018-08-23') 
    p2.unit_price = (select p2.unit_price
    from inventory as p2
    where p2.unit_price = (select min (unit_price)
    from inventory
    where date ='2018-08-23'))
'''
#p1 most expensive item
#p2 cheapest


pd.read_sql_query(query6, conn)
query6 = '''
    select p1.unit_price
    from inventory as p1
    where p1.unit_price = (select max (unit_price) 
    from inventory
    where date ='2018-08-23') 
    where p2.unit_price = (select p2.unit_price
    from inventory as p2
    where p2.unit_price = (select min (unit_price)
    from inventory
    where date ='2018-08-23'))
'''
#p1 most expensive item
#p2 cheapest


pd.read_sql_query(query6, conn)
query6 = '''
    select p1.unit_price
    from inventory as p1
    where p1.unit_price = (select max (unit_price) 
    from inventory
    where date ='2018-08-23') 
    p2.unit_price = (select p2.unit_price
    from inventory as p2
    where p2.unit_price = (select min (unit_price)
    from inventory
    where date ='2018-08-23'))
'''
#p1 most expensive item
#p2 cheapest


pd.read_sql_query(query6, conn)
query2 = '''
    select cID, cName 
    from purchase,customer,product 
    where pName='Onions' and pName='Coffee' and 
    purchase.cID=customer.cID and purchase.pID=product.pID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    select cID, cName 
    from purchase,customer,product 
    where pName='Onions' and pName='Coffee' and purchase.cID=customer.cID and purchase.pID=product.pID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    select cID, cName 
    from purchase,customer,product 
    where pName='Onions' and purchase.cID=customer.cID and purchase.pID=product.pID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    select cID, cName 
    from purchase,customer,product 
    where pName='Onions' and pName='Coffee' and purchase.cID=customer.cID and purchase.pID=product.pID
'''

pd.read_sql_query(query2, conn)
query3 = '''
    select cID
    from purchase
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      1
#[Out]# 3      1
#[Out]# 4      1
#[Out]# 5      1
#[Out]# 6      1
#[Out]# 7      1
#[Out]# 8      2
#[Out]# 9      2
#[Out]# 10     2
#[Out]# 11     2
#[Out]# 12     2
#[Out]# 13     3
#[Out]# 14     3
#[Out]# 15     3
#[Out]# 16     4
#[Out]# 17     4
#[Out]# 18     4
#[Out]# 19     4
#[Out]# 20     4
#[Out]# 21     4
#[Out]# 22     5
#[Out]# 23     5
#[Out]# 24     5
#[Out]# 25     5
#[Out]# 26     5
#[Out]# 27     5
#[Out]# 28     7
#[Out]# 29     7
#[Out]# ..   ...
#[Out]# 479  190
#[Out]# 480  190
#[Out]# 481  190
#[Out]# 482  190
#[Out]# 483  190
#[Out]# 484  190
#[Out]# 485  190
#[Out]# 486  190
#[Out]# 487  190
#[Out]# 488  190
#[Out]# 489  190
#[Out]# 490  190
#[Out]# 491  190
#[Out]# 492  190
#[Out]# 493  190
#[Out]# 494  190
#[Out]# 495  190
#[Out]# 496  190
#[Out]# 497  190
#[Out]# 498  190
#[Out]# 499  190
#[Out]# 500  190
#[Out]# 501  190
#[Out]# 502  190
#[Out]# 503  190
#[Out]# 504  190
#[Out]# 505  190
#[Out]# 506  190
#[Out]# 507  190
#[Out]# 508  190
#[Out]# 
#[Out]# [509 rows x 1 columns]
query3 = '''
    select distinct cID
    from purchase
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query1 = '''
    select p1.pID 
    from purchase as p1
    where unique p1.pID



'''


pd.read_sql_query(query1, conn)
query1 = '''
    select p1.pID 
    from purchase as p1




'''


pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 479   28
#[Out]# 480   27
#[Out]# 481    5
#[Out]# 482   28
#[Out]# 483    7
#[Out]# 484    0
#[Out]# 485   11
#[Out]# 486    6
#[Out]# 487   19
#[Out]# 488   17
#[Out]# 489    9
#[Out]# 490   11
#[Out]# 491   22
#[Out]# 492   17
#[Out]# 493   20
#[Out]# 494   11
#[Out]# 495   21
#[Out]# 496   23
#[Out]# 497   23
#[Out]# 498    8
#[Out]# 499    0
#[Out]# 500    8
#[Out]# 501   11
#[Out]# 502   15
#[Out]# 503    2
#[Out]# 504   17
#[Out]# 505    5
#[Out]# 506   19
#[Out]# 507    9
#[Out]# 508   18
#[Out]# 
#[Out]# [509 rows x 1 columns]
query1 = '''
    select p1.pID 
    from consumer,purchase as p1




'''


pd.read_sql_query(query1, conn)
query1 = '''
    select p1.pID,p1.cID
    from purchase as p1




'''


pd.read_sql_query(query1, conn)
#[Out]#      pID  cID
#[Out]# 0     10    0
#[Out]# 1     14    1
#[Out]# 2     16    1
#[Out]# 3      9    1
#[Out]# 4     25    1
#[Out]# 5     26    1
#[Out]# 6     11    1
#[Out]# 7     27    1
#[Out]# 8     20    2
#[Out]# 9      9    2
#[Out]# 10     4    2
#[Out]# 11    13    2
#[Out]# 12    22    2
#[Out]# 13    14    3
#[Out]# 14    26    3
#[Out]# 15     9    3
#[Out]# 16     8    4
#[Out]# 17    27    4
#[Out]# 18    12    4
#[Out]# 19     6    4
#[Out]# 20    13    4
#[Out]# 21    26    4
#[Out]# 22    14    5
#[Out]# 23    28    5
#[Out]# 24     6    5
#[Out]# 25    22    5
#[Out]# 26    16    5
#[Out]# 27    19    5
#[Out]# 28    19    7
#[Out]# 29     2    7
#[Out]# ..   ...  ...
#[Out]# 479   28  190
#[Out]# 480   27  190
#[Out]# 481    5  190
#[Out]# 482   28  190
#[Out]# 483    7  190
#[Out]# 484    0  190
#[Out]# 485   11  190
#[Out]# 486    6  190
#[Out]# 487   19  190
#[Out]# 488   17  190
#[Out]# 489    9  190
#[Out]# 490   11  190
#[Out]# 491   22  190
#[Out]# 492   17  190
#[Out]# 493   20  190
#[Out]# 494   11  190
#[Out]# 495   21  190
#[Out]# 496   23  190
#[Out]# 497   23  190
#[Out]# 498    8  190
#[Out]# 499    0  190
#[Out]# 500    8  190
#[Out]# 501   11  190
#[Out]# 502   15  190
#[Out]# 503    2  190
#[Out]# 504   17  190
#[Out]# 505    5  190
#[Out]# 506   19  190
#[Out]# 507    9  190
#[Out]# 508   18  190
#[Out]# 
#[Out]# [509 rows x 2 columns]
query1 = '''
    select sorted p1.pID,p1.cID
    from purchase as p1




'''


pd.read_sql_query(query1, conn)
query1 = '''
    select sort p1.pID,p1.cID
    from purchase as p1




'''


pd.read_sql_query(query1, conn)
query1 = '''
    select p1.pID,p1.cID
    from purchase as p1




'''


pd.read_sql_query(query1, conn)
#[Out]#      pID  cID
#[Out]# 0     10    0
#[Out]# 1     14    1
#[Out]# 2     16    1
#[Out]# 3      9    1
#[Out]# 4     25    1
#[Out]# 5     26    1
#[Out]# 6     11    1
#[Out]# 7     27    1
#[Out]# 8     20    2
#[Out]# 9      9    2
#[Out]# 10     4    2
#[Out]# 11    13    2
#[Out]# 12    22    2
#[Out]# 13    14    3
#[Out]# 14    26    3
#[Out]# 15     9    3
#[Out]# 16     8    4
#[Out]# 17    27    4
#[Out]# 18    12    4
#[Out]# 19     6    4
#[Out]# 20    13    4
#[Out]# 21    26    4
#[Out]# 22    14    5
#[Out]# 23    28    5
#[Out]# 24     6    5
#[Out]# 25    22    5
#[Out]# 26    16    5
#[Out]# 27    19    5
#[Out]# 28    19    7
#[Out]# 29     2    7
#[Out]# ..   ...  ...
#[Out]# 479   28  190
#[Out]# 480   27  190
#[Out]# 481    5  190
#[Out]# 482   28  190
#[Out]# 483    7  190
#[Out]# 484    0  190
#[Out]# 485   11  190
#[Out]# 486    6  190
#[Out]# 487   19  190
#[Out]# 488   17  190
#[Out]# 489    9  190
#[Out]# 490   11  190
#[Out]# 491   22  190
#[Out]# 492   17  190
#[Out]# 493   20  190
#[Out]# 494   11  190
#[Out]# 495   21  190
#[Out]# 496   23  190
#[Out]# 497   23  190
#[Out]# 498    8  190
#[Out]# 499    0  190
#[Out]# 500    8  190
#[Out]# 501   11  190
#[Out]# 502   15  190
#[Out]# 503    2  190
#[Out]# 504   17  190
#[Out]# 505    5  190
#[Out]# 506   19  190
#[Out]# 507    9  190
#[Out]# 508   18  190
#[Out]# 
#[Out]# [509 rows x 2 columns]
query1 = '''
    select p1.pID,p1.cID, count(pID)
    from purchase as p1




'''


pd.read_sql_query(query1, conn)
#[Out]#    pID  cID  count(pID)
#[Out]# 0   18  190         509
query1 = '''
    select p1.pID,p1.cID, count(p1.pID)
    from purchase as p1




'''


pd.read_sql_query(query1, conn)
#[Out]#    pID  cID  count(p1.pID)
#[Out]# 0   18  190            509
query1 = '''
    select p1.pID,p1.cID
    from purchase as p1




'''


pd.read_sql_query(query1, conn)
#[Out]#      pID  cID
#[Out]# 0     10    0
#[Out]# 1     14    1
#[Out]# 2     16    1
#[Out]# 3      9    1
#[Out]# 4     25    1
#[Out]# 5     26    1
#[Out]# 6     11    1
#[Out]# 7     27    1
#[Out]# 8     20    2
#[Out]# 9      9    2
#[Out]# 10     4    2
#[Out]# 11    13    2
#[Out]# 12    22    2
#[Out]# 13    14    3
#[Out]# 14    26    3
#[Out]# 15     9    3
#[Out]# 16     8    4
#[Out]# 17    27    4
#[Out]# 18    12    4
#[Out]# 19     6    4
#[Out]# 20    13    4
#[Out]# 21    26    4
#[Out]# 22    14    5
#[Out]# 23    28    5
#[Out]# 24     6    5
#[Out]# 25    22    5
#[Out]# 26    16    5
#[Out]# 27    19    5
#[Out]# 28    19    7
#[Out]# 29     2    7
#[Out]# ..   ...  ...
#[Out]# 479   28  190
#[Out]# 480   27  190
#[Out]# 481    5  190
#[Out]# 482   28  190
#[Out]# 483    7  190
#[Out]# 484    0  190
#[Out]# 485   11  190
#[Out]# 486    6  190
#[Out]# 487   19  190
#[Out]# 488   17  190
#[Out]# 489    9  190
#[Out]# 490   11  190
#[Out]# 491   22  190
#[Out]# 492   17  190
#[Out]# 493   20  190
#[Out]# 494   11  190
#[Out]# 495   21  190
#[Out]# 496   23  190
#[Out]# 497   23  190
#[Out]# 498    8  190
#[Out]# 499    0  190
#[Out]# 500    8  190
#[Out]# 501   11  190
#[Out]# 502   15  190
#[Out]# 503    2  190
#[Out]# 504   17  190
#[Out]# 505    5  190
#[Out]# 506   19  190
#[Out]# 507    9  190
#[Out]# 508   18  190
#[Out]# 
#[Out]# [509 rows x 2 columns]
query1 = '''
    select p1.pID,p1.cID
    from purchase as p1
    where p1.pID < count(p1.pID)




'''


pd.read_sql_query(query1, conn)
query1 = '''
    select p1.pID,p1.cID
    from purchase as p1
    where unique(select p2.pID
    from purchase as p2
    )




'''


pd.read_sql_query(query1, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
"""db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    select p1.pID
    from purchase as p1
    group by pID
    having count (distinct cID)
    from purchase as p2)




'''


pd.read_sql_query(query1, conn)
query1 = '''
    select p1.pID
    from purchase as p1
    group by pID
    having count (distinct cID)





'''


pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
    select p1.pID
    from purchase as p1
    group by pID
    having count (distinct cID) < 3





'''


pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    select s.cID, r.cName 
    from purchase s,purchase t, customer r 
    where s.pID = (select pID)
    from product
    where pName = 'Onions')
    and t.pID = (select pID
    from product
    where pName = 'Coffee')
    and s.date = t.date and s.cID = t.cID
    and r.cID - t.cID
    
    
    
    
'''

pd.read_sql_query(query2, conn)
query2 = '''
    select s.cID, r.cName 
    from purchase s, purchase t, customer r 
    where s.pID = (select pID
    from product
    where pName = 'Onions')
    and t.pID = (select pID
    from product
    where pName = 'Coffee')
    and s.date = t.date and s.cID = t.cID
    and r.cID - t.cID
    
    
    
    
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID    cName
#[Out]# 0    124     Noah
#[Out]# 1    190     Noah
#[Out]# 2    124      Sem
#[Out]# 3    190      Sem
#[Out]# 4    124    Lucas
#[Out]# 5    190    Lucas
#[Out]# 6    124     Finn
#[Out]# 7    190     Finn
#[Out]# 8    124     Daan
#[Out]# 9    190     Daan
#[Out]# 10   124     Levi
#[Out]# 11   190     Levi
#[Out]# 12   124    Milan
#[Out]# 13   190    Milan
#[Out]# 14   124     Bram
#[Out]# 15   190     Bram
#[Out]# 16   124     Liam
#[Out]# 17   190     Liam
#[Out]# 18   124   Thomas
#[Out]# 19   190   Thomas
#[Out]# 20   124      Sam
#[Out]# 21   190      Sam
#[Out]# 22   124    Thijs
#[Out]# 23   190    Thijs
#[Out]# 24   124     Adam
#[Out]# 25   190     Adam
#[Out]# 26   124    James
#[Out]# 27   190    James
#[Out]# 28   124      Max
#[Out]# 29   190      Max
#[Out]# ..   ...      ...
#[Out]# 348  190     Romy
#[Out]# 349  124      Sam
#[Out]# 350  190      Sam
#[Out]# 351  124    Amira
#[Out]# 352  190    Amira
#[Out]# 353  124    Eline
#[Out]# 354  190    Eline
#[Out]# 355  124     Elif
#[Out]# 356  190     Elif
#[Out]# 357  124     Juul
#[Out]# 358  190     Juul
#[Out]# 359  124    Merel
#[Out]# 360  190    Merel
#[Out]# 361  124     Liva
#[Out]# 362  190     Liva
#[Out]# 363  124  Johanna
#[Out]# 364  190  Johanna
#[Out]# 365  124    Nikki
#[Out]# 366  190    Nikki
#[Out]# 367  124    Wilko
#[Out]# 368  190    Wilko
#[Out]# 369  124     Nick
#[Out]# 370  190     Nick
#[Out]# 371  124   Angela
#[Out]# 372  190   Angela
#[Out]# 373  124     Pino
#[Out]# 374  190     Pino
#[Out]# 375  124     Koen
#[Out]# 376  190     Koen
#[Out]# 377  124   Kostas
#[Out]# 
#[Out]# [378 rows x 2 columns]
query2 = '''
    select s.cID, r.cName 
    from purchase s, purchase t, customer r 
    where s.pID = (select pID
    from product
    where pName = 'Onions')
    and t.pID = (select pID
    from product
    where pName = 'Coffee')
    and s.date = t.date and s.cID = t.cID
    and r.cID = t.cID
    
    
    
    
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    select p1.cID
    from purchase as p1
    group by p1.cID
    having count (distinct p1.sID) = (select count (distinct p1.sID) from store)
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
SELECT cID
FROM purchase 
GROUP BY cID
HAVING COUNT (DISTINCT sID) = (SELECT COUNT (DISTINCT sID)
    FROM store)
    '''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    select cID
    from purchase
    group by cID
    having count (distinct sID) = (select count (distinct sID) from store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    select cID
    from purchase
    group by cID
    having count (distinct sID) = (select count (distinct sID) from store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    select j.sName
    from store j, purchase k
    where j.sID = k.sID
    group by j.sName
    having avg (k.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    select j.pName, k.sName
    from product j, store k
    wher j.pID = (select pID
    from purchase
    where price = (select max (price)
    from purchase))
    and k.sID = (select sID
    from purchase
    where price = (select max (price)
    from purchase))
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select j.pName, k.sName
    from product j, store k
    where j.pID = (select pID
    from purchase
    where price = (select max (price)
    from purchase))
    and k.sID = (select sID
    from purchase
    where price = (select max (price)
    from purchase))
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    select j.pName, k.sName, j.unit_price
    from product j, store k
    where j.pID = (select pID
    from purchase
    where price = (select max (price)
    from purchase))
    and k.sID = (select sID
    from purchase
    where price = (select max (price)
    from purchase))
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select j.pName, k.sName
    from product j, store k
    where j.pID = (select pID
    from purchase
    where price = (select max (price)
    from purchase))
    and k.sID = (select sID
    from purchase
    where price = (select max (price)
    from purchase))
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    select max (j.unit_price - k.unit_price)
    from inventory j, inventory k
    where j.date = '2018-08-23' and k.date = j.date
    and j.pID = k.pID and not i.sID = j.sID
'''
#p1 most expensive item
#p2 cheapest


pd.read_sql_query(query6, conn)
query6 = '''
    select max (j.unit_price - k.unit_price)
    from inventory j, inventory k
    where j.date = '2018-08-23' and k.date = j.date
    and j.pID = k.pID and not j.sID = k.sID
'''
#p1 most expensive item
#p2 cheapest


pd.read_sql_query(query6, conn)
#[Out]#    max (j.unit_price - k.unit_price)
#[Out]# 0                                2.0
query6 = '''
    select max (j.unit_price - k.unit_price)
    from inventory j, inventory k
    where j.date = '2018-08-23' and k.date = j.date
    and j.pID = k.pID and not j.sID = k.sID
'''
#j most expensive item
#k cheapest item


pd.read_sql_query(query6, conn)
#[Out]#    max (j.unit_price - k.unit_price)
#[Out]# 0                                2.0
