# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT p.pID
    from purchase p
    
    EXCEPT
    


    SELECT p1.pID
    from purchase as p1, purchase as p2, purchase as p3, customer as c1, customer as c2, customer as c3 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID 
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    from purchase p
    
    EXCEPT
    


    SELECT p1.pID
    from purchase as p1, purchase as p2, purchase as p3, customer as c1, customer as c2, customer as c3 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID and p1.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    from purchase p
    
    EXCEPT
    


   ( SELECT p1.pID
    from purchase as p1, purchase as p2, purchase as p3, customer as c1, customer as c2, customer as c3 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID and p1.pID = p3.pID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    from purchase p
    
    EXCEPT
    
    SELECT p1
    from purchase as p1, purchase as p2, purchase as p3, customer as c1, customer as c2, customer as c3 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID and p1.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    from purchase p
    
    EXCEPT
    
    SELECT p1.pID
    from purchase as p1, purchase as p2, purchase as p3, customer as c1, customer as c2, customer as c3 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID and p1.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    from purchase p
    
    EXCEPT
    
    SELECT p1
    from purchase as p1, purchase as p2, purchase as p3, customer as c1, customer as c2, customer as c3 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID and p1.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    from purchase p
    
    EXCEPT
    
    SELECT p1*
    from purchase as p1, purchase as p2, purchase as p3, customer as c1, customer as c2, customer as c3 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID and p1.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    from purchase p
    
    EXCEPT
    
    SELECT p1.*
    from purchase as p1, purchase as p2, purchase as p3, customer as c1, customer as c2, customer as c3 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID and p1.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    from purchase p
    
    EXCEPT
    
    SELECT p1.pID
    from purchase as p1, purchase as p2, purchase as p3, customer as c1, customer as c2, customer as c3 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID and p1.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    from product p
    
    EXCEPT
    
    SELECT p.pID
    from purchase as p1, purchase as p2, purchase as p3, customer as c1, customer as c2, customer as c3, product p 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID and p1.pID = p3.pID and p.pid = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
    SELECT p.pID
    from product p
    
    EXCEPT
    
    SELECT p.pID
    from purchase p1, purchase p2, purchase p3, customer c1, customer c2, customer c3, product p 
    where c1.cID <> c2.cID and c1.cID <> c3.cID and c2.cID <> c3.cID 
    and p1.cID = c1.cId and p2.cID = c2.cID and p3.cID = c3.cID and p1.pID = p2.pID
    and p2.pID = p3.pID and p1.pID = p3.pID and p.pid = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
    SELECT p.pID
    FROM product p
    
    EXCEPT
    
    SELECT p.pID
    FROM purchase p1, purchase p2, purchase p3, customer c1, customer c2, customer c3, product p 
    WHERE c1.cID <> c2.cID AND c1.cID <> c3.cID AND c2.cID <> c3.cID 
    AND p1.cID = c1.cId AND p2.cID = c2.cID AND p3.cID = c3.cID AND p1.pID = p2.pID
    AND p2.pID = p3.pID AND p1.pID = p3.pID AND p.pid = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
    SELECT p.pID
    FROM product p
    
    EXCEPT
    
    SELECT p.pID
    FROM purchase p1, purchase p2, purchase p3, customer c1, customer c2, customer c3, product p 
    WHERE c1.cID <> c2.cID AND c1.cID <> c3.cID AND c2.cID <> c3.cID 
    AND p1.cID = c1.cID AND p2.cID = c2.cID AND p3.cID = c3.cID AND p1.pID = p2.pID
    AND p2.pID = p3.pID AND p1.pID = p3.pID AND p.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
    SELECT p.pID
    FROM product p
    
    EXCEPT
    
    SELECT p.pID
    FROM purchase p1, purchase p2, purchase p3, customer c1, customer c2, customer c3, product p 
    WHERE c1.cID <> c2.cID AND c1.cID <> c3.cID AND c2.cID <> c3.cID 
    AND p1.cID = c1.cID AND p2.cID = c2.cID AND p3.cID = c3.cID AND p1.pID = p2.pID
    AND p2.pID = p3.pID AND p1.pID = p3.pID AND p.pID = p3.pID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    Select c.cID, c.cName
    FROM product pr1, product pr2, customer c, purchase p1, purchase p2
    WHERE p1.pID = pr1.pID and p2.pID = pr2.pID and p1.cID = p2.cID and 
    p1.date = p2.date and pr1.pName = "Onions" and pr2.pName = "Coffee"
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID    cName
#[Out]# 0      0     Noah
#[Out]# 1      0     Noah
#[Out]# 2      1      Sem
#[Out]# 3      1      Sem
#[Out]# 4      2    Lucas
#[Out]# 5      2    Lucas
#[Out]# 6      3     Finn
#[Out]# 7      3     Finn
#[Out]# 8      4     Daan
#[Out]# 9      4     Daan
#[Out]# 10     5     Levi
#[Out]# 11     5     Levi
#[Out]# 12     6    Milan
#[Out]# 13     6    Milan
#[Out]# 14     7     Bram
#[Out]# 15     7     Bram
#[Out]# 16     8     Liam
#[Out]# 17     8     Liam
#[Out]# 18     9   Thomas
#[Out]# 19     9   Thomas
#[Out]# 20    10      Sam
#[Out]# 21    10      Sam
#[Out]# 22    11    Thijs
#[Out]# 23    11    Thijs
#[Out]# 24    12     Adam
#[Out]# 25    12     Adam
#[Out]# 26    13    James
#[Out]# 27    13    James
#[Out]# 28    14      Max
#[Out]# 29    14      Max
#[Out]# ..   ...      ...
#[Out]# 350  175      Sam
#[Out]# 351  175      Sam
#[Out]# 352  176    Amira
#[Out]# 353  176    Amira
#[Out]# 354  177    Eline
#[Out]# 355  177    Eline
#[Out]# 356  178     Elif
#[Out]# 357  178     Elif
#[Out]# 358  179     Juul
#[Out]# 359  179     Juul
#[Out]# 360  180    Merel
#[Out]# 361  180    Merel
#[Out]# 362  181     Liva
#[Out]# 363  181     Liva
#[Out]# 364  182  Johanna
#[Out]# 365  182  Johanna
#[Out]# 366  183    Nikki
#[Out]# 367  183    Nikki
#[Out]# 368  184    Wilko
#[Out]# 369  184    Wilko
#[Out]# 370  185     Nick
#[Out]# 371  185     Nick
#[Out]# 372  186   Angela
#[Out]# 373  186   Angela
#[Out]# 374  188     Pino
#[Out]# 375  188     Pino
#[Out]# 376  189     Koen
#[Out]# 377  189     Koen
#[Out]# 378  190   Kostas
#[Out]# 379  190   Kostas
#[Out]# 
#[Out]# [380 rows x 2 columns]
query2 = '''
    Select DISTINCT c.cID, c.cName
    FROM product pr1, product pr2, customer c, purchase p1, purchase p2
    WHERE p1.pID = pr1.pID and p2.pID = pr2.pID and p1.cID = p2.cID and 
    p1.date = p2.date and pr1.pName = "Onions" and pr2.pName = "Coffee"
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID     cName
#[Out]# 0      0      Noah
#[Out]# 1      1       Sem
#[Out]# 2      2     Lucas
#[Out]# 3      3      Finn
#[Out]# 4      4      Daan
#[Out]# 5      5      Levi
#[Out]# 6      6     Milan
#[Out]# 7      7      Bram
#[Out]# 8      8      Liam
#[Out]# 9      9    Thomas
#[Out]# 10    10       Sam
#[Out]# 11    11     Thijs
#[Out]# 12    12      Adam
#[Out]# 13    13     James
#[Out]# 14    14       Max
#[Out]# 15    15      Noud
#[Out]# 16    16    Julian
#[Out]# 17    17       Dex
#[Out]# 18    18      Hugo
#[Out]# 19    19      Lars
#[Out]# 20    20      Gijs
#[Out]# 21    21  Benjamin
#[Out]# 22    22      Mats
#[Out]# 23    23       Jan
#[Out]# 24    24      Luca
#[Out]# 25    25     Mason
#[Out]# 26    26    Jayden
#[Out]# 27    27       Tim
#[Out]# 28    28      Siem
#[Out]# 29    29     Ruben
#[Out]# ..   ...       ...
#[Out]# 160  160      Lara
#[Out]# 161  161     Floor
#[Out]# 162  162     Elena
#[Out]# 163  163      Cato
#[Out]# 164  164       Evy
#[Out]# 165  165     Hanna
#[Out]# 166  166   Rosalie
#[Out]# 167  167    Veerle
#[Out]# 168  168      Kiki
#[Out]# 169  169      Lily
#[Out]# 170  170      Iris
#[Out]# 171  171     Tessa
#[Out]# 172  172      Lana
#[Out]# 173  173     Livia
#[Out]# 174  174      Romy
#[Out]# 175  175       Sam
#[Out]# 176  176     Amira
#[Out]# 177  177     Eline
#[Out]# 178  178      Elif
#[Out]# 179  179      Juul
#[Out]# 180  180     Merel
#[Out]# 181  181      Liva
#[Out]# 182  182   Johanna
#[Out]# 183  183     Nikki
#[Out]# 184  184     Wilko
#[Out]# 185  185      Nick
#[Out]# 186  186    Angela
#[Out]# 187  188      Pino
#[Out]# 188  189      Koen
#[Out]# 189  190    Kostas
#[Out]# 
#[Out]# [190 rows x 2 columns]
query2 = '''
    Select DISTINCT c.cID, c.cName
    FROM product pr1, product pr2, customer c, purchase p1, purchase p2
    WHERE p1.pID = pr1.pID and p2.pID = pr2.pID and p1.cID = p2.cID and 
    p1.date = p2.date and pr1.pName = "Onions" and pr2.pName = "Coffee" and p2.quantity > 0 and p1.quantity > 0
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID     cName
#[Out]# 0      0      Noah
#[Out]# 1      1       Sem
#[Out]# 2      2     Lucas
#[Out]# 3      3      Finn
#[Out]# 4      4      Daan
#[Out]# 5      5      Levi
#[Out]# 6      6     Milan
#[Out]# 7      7      Bram
#[Out]# 8      8      Liam
#[Out]# 9      9    Thomas
#[Out]# 10    10       Sam
#[Out]# 11    11     Thijs
#[Out]# 12    12      Adam
#[Out]# 13    13     James
#[Out]# 14    14       Max
#[Out]# 15    15      Noud
#[Out]# 16    16    Julian
#[Out]# 17    17       Dex
#[Out]# 18    18      Hugo
#[Out]# 19    19      Lars
#[Out]# 20    20      Gijs
#[Out]# 21    21  Benjamin
#[Out]# 22    22      Mats
#[Out]# 23    23       Jan
#[Out]# 24    24      Luca
#[Out]# 25    25     Mason
#[Out]# 26    26    Jayden
#[Out]# 27    27       Tim
#[Out]# 28    28      Siem
#[Out]# 29    29     Ruben
#[Out]# ..   ...       ...
#[Out]# 160  160      Lara
#[Out]# 161  161     Floor
#[Out]# 162  162     Elena
#[Out]# 163  163      Cato
#[Out]# 164  164       Evy
#[Out]# 165  165     Hanna
#[Out]# 166  166   Rosalie
#[Out]# 167  167    Veerle
#[Out]# 168  168      Kiki
#[Out]# 169  169      Lily
#[Out]# 170  170      Iris
#[Out]# 171  171     Tessa
#[Out]# 172  172      Lana
#[Out]# 173  173     Livia
#[Out]# 174  174      Romy
#[Out]# 175  175       Sam
#[Out]# 176  176     Amira
#[Out]# 177  177     Eline
#[Out]# 178  178      Elif
#[Out]# 179  179      Juul
#[Out]# 180  180     Merel
#[Out]# 181  181      Liva
#[Out]# 182  182   Johanna
#[Out]# 183  183     Nikki
#[Out]# 184  184     Wilko
#[Out]# 185  185      Nick
#[Out]# 186  186    Angela
#[Out]# 187  188      Pino
#[Out]# 188  189      Koen
#[Out]# 189  190    Kostas
#[Out]# 
#[Out]# [190 rows x 2 columns]
query2 = '''
    Select DISTINCT c.cID, c.cName
    FROM product pr1, product pr2, customer c, purchase p1, purchase p2
    WHERE p1.pID = pr1.pID and p2.pID = pr2.pID and p1.cID = p2.cID and c.cID = p1.cID and
    p1.date = p2.date and pr1.pName = "Onions" and pr2.pName = "Coffee" and p2.quantity > 0 and p1.quantity > 0
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    Select DISTINCT c.cID, c.cName, pr1.pName, pr2.pName
    FROM product pr1, product pr2, customer c, purchase p1, purchase p2
    WHERE p1.pID = pr1.pID and p2.pID = pr2.pID and p1.cID = p2.cID and c.cID = p1.cID and
    p1.date = p2.date and pr1.pName = "Onions" and pr2.pName = "Coffee" and p2.quantity > 0 and p1.quantity > 0
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName   pName   pName
#[Out]# 0  124   Sofie  Onions  Coffee
#[Out]# 1  190  Kostas  Onions  Coffee
query2 = '''
    Select DISTINCT c.cID, c.cName, pr1.pName, pr2.pName
    FROM product pr1, product pr2, customer c, purchase p1, purchase p2
    WHERE p1.pID = pr1.pID and p2.pID = pr2.pID and p1.cID = p2.cID and
    p1.date = p2.date and pr1.pName = "Onions" and pr2.pName = "Coffee" and p2.quantity > 0 and p1.quantity > 0
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID     cName   pName   pName
#[Out]# 0      0      Noah  Onions  Coffee
#[Out]# 1      1       Sem  Onions  Coffee
#[Out]# 2      2     Lucas  Onions  Coffee
#[Out]# 3      3      Finn  Onions  Coffee
#[Out]# 4      4      Daan  Onions  Coffee
#[Out]# 5      5      Levi  Onions  Coffee
#[Out]# 6      6     Milan  Onions  Coffee
#[Out]# 7      7      Bram  Onions  Coffee
#[Out]# 8      8      Liam  Onions  Coffee
#[Out]# 9      9    Thomas  Onions  Coffee
#[Out]# 10    10       Sam  Onions  Coffee
#[Out]# 11    11     Thijs  Onions  Coffee
#[Out]# 12    12      Adam  Onions  Coffee
#[Out]# 13    13     James  Onions  Coffee
#[Out]# 14    14       Max  Onions  Coffee
#[Out]# 15    15      Noud  Onions  Coffee
#[Out]# 16    16    Julian  Onions  Coffee
#[Out]# 17    17       Dex  Onions  Coffee
#[Out]# 18    18      Hugo  Onions  Coffee
#[Out]# 19    19      Lars  Onions  Coffee
#[Out]# 20    20      Gijs  Onions  Coffee
#[Out]# 21    21  Benjamin  Onions  Coffee
#[Out]# 22    22      Mats  Onions  Coffee
#[Out]# 23    23       Jan  Onions  Coffee
#[Out]# 24    24      Luca  Onions  Coffee
#[Out]# 25    25     Mason  Onions  Coffee
#[Out]# 26    26    Jayden  Onions  Coffee
#[Out]# 27    27       Tim  Onions  Coffee
#[Out]# 28    28      Siem  Onions  Coffee
#[Out]# 29    29     Ruben  Onions  Coffee
#[Out]# ..   ...       ...     ...     ...
#[Out]# 160  160      Lara  Onions  Coffee
#[Out]# 161  161     Floor  Onions  Coffee
#[Out]# 162  162     Elena  Onions  Coffee
#[Out]# 163  163      Cato  Onions  Coffee
#[Out]# 164  164       Evy  Onions  Coffee
#[Out]# 165  165     Hanna  Onions  Coffee
#[Out]# 166  166   Rosalie  Onions  Coffee
#[Out]# 167  167    Veerle  Onions  Coffee
#[Out]# 168  168      Kiki  Onions  Coffee
#[Out]# 169  169      Lily  Onions  Coffee
#[Out]# 170  170      Iris  Onions  Coffee
#[Out]# 171  171     Tessa  Onions  Coffee
#[Out]# 172  172      Lana  Onions  Coffee
#[Out]# 173  173     Livia  Onions  Coffee
#[Out]# 174  174      Romy  Onions  Coffee
#[Out]# 175  175       Sam  Onions  Coffee
#[Out]# 176  176     Amira  Onions  Coffee
#[Out]# 177  177     Eline  Onions  Coffee
#[Out]# 178  178      Elif  Onions  Coffee
#[Out]# 179  179      Juul  Onions  Coffee
#[Out]# 180  180     Merel  Onions  Coffee
#[Out]# 181  181      Liva  Onions  Coffee
#[Out]# 182  182   Johanna  Onions  Coffee
#[Out]# 183  183     Nikki  Onions  Coffee
#[Out]# 184  184     Wilko  Onions  Coffee
#[Out]# 185  185      Nick  Onions  Coffee
#[Out]# 186  186    Angela  Onions  Coffee
#[Out]# 187  188      Pino  Onions  Coffee
#[Out]# 188  189      Koen  Onions  Coffee
#[Out]# 189  190    Kostas  Onions  Coffee
#[Out]# 
#[Out]# [190 rows x 4 columns]
query2 = '''
    Select DISTINCT c.cID, c.cName, pr1.pName, pr2.pName
    FROM product pr1, product pr2, customer c, purchase p1, purchase p2
    WHERE p1.pID = pr1.pID and p2.pID = pr2.pID and p1.cID = p2.cID and c.cID = p1.cID and
    p1.date = p2.date and pr1.pName = "Onions" and pr2.pName = "Coffee" and p2.quantity > 0 and p1.quantity > 0
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName   pName   pName
#[Out]# 0  124   Sofie  Onions  Coffee
#[Out]# 1  190  Kostas  Onions  Coffee
query3 = '''
    Select c.cID
    from customer c
    
    EXCEPT
    
    Select c.cID
    FROM customer c, purchase p, store s
    where c.cID = p.cID and p.sID <> s.sID
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
    s2.sID = p2.sID and avg(p1.quantity) > 4 and avg(p2.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
    group by p1
    where avg(quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query5 = '''
    SELECT s.sName, pr.pName(
    SELECT MAX(p.price)
    FROM store s, purchase p, product pr
    where p.sID = s.sID and pr.pID = p.pID)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT s.sName, pr.pName(
    SELECT MAX(p.price)
    FROM store s, purchase p, product pr
    where p.sID = s.sID and pr.pID = p.pID)
'''

pd.read_sql_query(query5, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
    group by p1
    where avg(quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
    group by purchase
    where avg(quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
    group by p1.quantity
    where avg(quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
    group by p1.quantity
    where avg(p1.quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
    group by sName
    where avg(p1.quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
    group by sName
    where avg(quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    
    group by sName
    where avg(quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    
    group by sName
  
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store 
    
    group by sName
  
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
    group by store
    where avg(quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
    group by sName
    where avg(quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID and 
  
   
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID  
    group by sName
    where avg(quantity) > 4
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID  
    group by sName
    
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID  
   
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0        Sligro
#[Out]# 1        Sligro
#[Out]# 2        Sligro
#[Out]# 3        Sligro
#[Out]# 4        Sligro
#[Out]# 5        Sligro
#[Out]# 6        Sligro
#[Out]# 7        Sligro
#[Out]# 8        Sligro
#[Out]# 9        Sligro
#[Out]# 10       Sligro
#[Out]# 11       Sligro
#[Out]# 12       Sligro
#[Out]# 13       Sligro
#[Out]# 14       Sligro
#[Out]# 15       Sligro
#[Out]# 16       Sligro
#[Out]# 17       Sligro
#[Out]# 18       Sligro
#[Out]# 19       Sligro
#[Out]# 20       Sligro
#[Out]# 21       Sligro
#[Out]# 22       Sligro
#[Out]# 23       Sligro
#[Out]# 24       Sligro
#[Out]# 25       Sligro
#[Out]# 26       Sligro
#[Out]# 27       Sligro
#[Out]# 28       Sligro
#[Out]# 29       Sligro
#[Out]# ...         ...
#[Out]# 2322028   Jumbo
#[Out]# 2322029   Jumbo
#[Out]# 2322030   Jumbo
#[Out]# 2322031   Jumbo
#[Out]# 2322032   Jumbo
#[Out]# 2322033   Jumbo
#[Out]# 2322034   Jumbo
#[Out]# 2322035   Jumbo
#[Out]# 2322036   Jumbo
#[Out]# 2322037   Jumbo
#[Out]# 2322038   Jumbo
#[Out]# 2322039   Jumbo
#[Out]# 2322040   Jumbo
#[Out]# 2322041   Jumbo
#[Out]# 2322042   Jumbo
#[Out]# 2322043   Jumbo
#[Out]# 2322044   Jumbo
#[Out]# 2322045   Jumbo
#[Out]# 2322046   Jumbo
#[Out]# 2322047   Jumbo
#[Out]# 2322048   Jumbo
#[Out]# 2322049   Jumbo
#[Out]# 2322050   Jumbo
#[Out]# 2322051   Jumbo
#[Out]# 2322052   Jumbo
#[Out]# 2322053   Jumbo
#[Out]# 2322054   Jumbo
#[Out]# 2322055   Jumbo
#[Out]# 2322056   Jumbo
#[Out]# 2322057   Jumbo
#[Out]# 
#[Out]# [2322058 rows x 1 columns]
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID  
    groupby sID
    
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID  
    group by sID
    
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID  
    group by s1.sID
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16         Lidl
#[Out]# 17    Hoogvliet
#[Out]# 18       Sligro
#[Out]# 19         Coop
#[Out]# 20        Jumbo
#[Out]# 21         Coop
#[Out]# 22         Lidl
#[Out]# 23         Dirk
#[Out]# 24  Albert Hein
#[Out]# 25  Albert Hein
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28    Hoogvliet
#[Out]# 29       Sligro
#[Out]# ..          ...
#[Out]# 34         Coop
#[Out]# 35         Lidl
#[Out]# 36         Lidl
#[Out]# 37        Jumbo
#[Out]# 38    Hoogvliet
#[Out]# 39       Sligro
#[Out]# 40    Hoogvliet
#[Out]# 41  Albert Hein
#[Out]# 42       Sligro
#[Out]# 43         Coop
#[Out]# 44  Albert Hein
#[Out]# 45         Coop
#[Out]# 46         Lidl
#[Out]# 47         Coop
#[Out]# 48    Hoogvliet
#[Out]# 49    Hoogvliet
#[Out]# 50       Sligro
#[Out]# 51         Coop
#[Out]# 52         Lidl
#[Out]# 53         Coop
#[Out]# 54         Dirk
#[Out]# 55         Coop
#[Out]# 56        Jumbo
#[Out]# 57         Dirk
#[Out]# 58         Dirk
#[Out]# 59        Jumbo
#[Out]# 60         Lidl
#[Out]# 61         Lidl
#[Out]# 62        Jumbo
#[Out]# 63        Jumbo
#[Out]# 
#[Out]# [64 rows x 1 columns]
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID  
    group by s1.sID
    where avg(p1.quantity) > 4
    
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID  
    group by s1.sID
    where avg(quantity) > 4
    
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID  
    group by s1.sID
    where avg(p1.quantity) > 4
    
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s1.sName
    FROM store s1, store s2, purchase p1, purchase p2
    where s1.sName = s2.sName and s1.sID <> s2.sID and s1.sID = p1.sID  
    group by s1.sID
    having avg(p1.quantity) > 4
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2        Sligro
#[Out]# 3     Hoogvliet
#[Out]# 4        Sligro
#[Out]# 5        Sligro
#[Out]# 6   Albert Hein
#[Out]# 7   Albert Hein
#[Out]# 8         Jumbo
#[Out]# 9   Albert Hein
#[Out]# 10         Lidl
#[Out]# 11         Lidl
#[Out]# 12    Hoogvliet
#[Out]# 13         Coop
#[Out]# 14        Jumbo
#[Out]# 15         Lidl
#[Out]# 16         Dirk
#[Out]# 17  Albert Hein
#[Out]# 18  Albert Hein
#[Out]# 19    Hoogvliet
#[Out]# 20       Sligro
#[Out]# 21    Hoogvliet
#[Out]# 22       Sligro
#[Out]# 23         Dirk
#[Out]# 24         Coop
#[Out]# 25         Dirk
#[Out]# 26         Coop
#[Out]# 27         Lidl
#[Out]# 28         Lidl
#[Out]# 29    Hoogvliet
#[Out]# 30       Sligro
#[Out]# 31    Hoogvliet
#[Out]# 32  Albert Hein
#[Out]# 33       Sligro
#[Out]# 34         Coop
#[Out]# 35  Albert Hein
#[Out]# 36         Lidl
#[Out]# 37         Coop
#[Out]# 38    Hoogvliet
#[Out]# 39         Coop
#[Out]# 40         Lidl
#[Out]# 41         Dirk
#[Out]# 42         Coop
#[Out]# 43         Dirk
#[Out]# 44         Dirk
#[Out]# 45         Lidl
#[Out]# 46         Lidl
query4 = '''
    Select s1.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2        Sligro
#[Out]# 3     Hoogvliet
#[Out]# 4        Sligro
#[Out]# 5        Sligro
#[Out]# 6   Albert Hein
#[Out]# 7   Albert Hein
#[Out]# 8         Jumbo
#[Out]# 9   Albert Hein
#[Out]# 10         Lidl
#[Out]# 11         Lidl
#[Out]# 12    Hoogvliet
#[Out]# 13         Coop
#[Out]# 14        Jumbo
#[Out]# 15         Lidl
#[Out]# 16         Dirk
#[Out]# 17  Albert Hein
#[Out]# 18  Albert Hein
#[Out]# 19    Hoogvliet
#[Out]# 20       Sligro
#[Out]# 21    Hoogvliet
#[Out]# 22       Sligro
#[Out]# 23         Dirk
#[Out]# 24         Coop
#[Out]# 25         Dirk
#[Out]# 26         Coop
#[Out]# 27         Lidl
#[Out]# 28         Lidl
#[Out]# 29    Hoogvliet
#[Out]# 30       Sligro
#[Out]# 31    Hoogvliet
#[Out]# 32  Albert Hein
#[Out]# 33       Sligro
#[Out]# 34         Coop
#[Out]# 35  Albert Hein
#[Out]# 36         Lidl
#[Out]# 37         Coop
#[Out]# 38    Hoogvliet
#[Out]# 39         Coop
#[Out]# 40         Lidl
#[Out]# 41         Dirk
#[Out]# 42         Coop
#[Out]# 43         Dirk
#[Out]# 44         Dirk
#[Out]# 45         Lidl
#[Out]# 46         Lidl
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
    EXCEPT
    
    Select s.sName
    FROM store s
    
    EXCEPT
    
    Select s.sName
    FROM store s1, store s2
    where s1.id <> s2.id AND s1.sName = s2.sName
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
    EXCEPT
    
    Select s3.sName
    FROM store s3
    
    EXCEPT
    
    Select s.sName
    FROM store s1, store s2
    where s1.id <> s2.id AND s1.sName = s2.sName
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
    EXCEPT
    
    Select s.sName
    FROM store s
    
    EXCEPT
    
    Select s.sName
    FROM store s1, store s2
    where s1.id <> s2.id AND s1.sName = s2.sName
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
    EXCEPT
    
    Select s.sName
    FROM store s
    
    EXCEPT
    
    Select s1.sName
    FROM store s1, store s2
    where s1.id <> s2.id AND s1.sName = s2.sName
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
    EXCEPT
    
    Select s.sName
    FROM store s
    
    EXCEPT
    
    Select s1.sName
    FROM store s1, store s2
    where s1.id <> s2.id AND s1.sName = s2.sName
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
    EXCEPT
    
    Select s.sName
    FROM store s
    
    EXCEPT
    
    Select s1.sName
    FROM store s1, store s2
    where s1.sID <> s2.sID AND s1.sName = s2.sName
   
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
    EXCEPT
    
    Select s
    FROM store s
    
    EXCEPT
    
    Select s1, s2
    FROM store s1, store s2
    where s1.sID <> s2.sID AND s1.sName = s2.sName
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
    EXCEPT
    
    Select s.*
    FROM store s
    
    EXCEPT
    
    Select s1.*, s2.*
    FROM store s1, store s2
    where s1.sID <> s2.sID AND s1.sName = s2.sName
   
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sID
    having avg(p.quantity) > 4
    
    EXCEPT
    
    Select s.sName
    FROM store s
    
    EXCEPT
    
    Select s1.sName
    FROM store s1, store s2
    where s1.sID <> s2.sID AND s1.sName = s2.sName
   
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sName
    having avg(p.quantity) > 4
    
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sId
    having avg(p.quantity) > 4
    
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2        Sligro
#[Out]# 3     Hoogvliet
#[Out]# 4        Sligro
#[Out]# 5        Sligro
#[Out]# 6   Albert Hein
#[Out]# 7   Albert Hein
#[Out]# 8         Jumbo
#[Out]# 9   Albert Hein
#[Out]# 10         Lidl
#[Out]# 11         Lidl
#[Out]# 12    Hoogvliet
#[Out]# 13         Coop
#[Out]# 14        Jumbo
#[Out]# 15         Lidl
#[Out]# 16         Dirk
#[Out]# 17  Albert Hein
#[Out]# 18  Albert Hein
#[Out]# 19    Hoogvliet
#[Out]# 20       Sligro
#[Out]# 21    Hoogvliet
#[Out]# 22       Sligro
#[Out]# 23         Dirk
#[Out]# 24         Coop
#[Out]# 25         Dirk
#[Out]# 26         Coop
#[Out]# 27         Lidl
#[Out]# 28         Lidl
#[Out]# 29    Hoogvliet
#[Out]# 30       Sligro
#[Out]# 31    Hoogvliet
#[Out]# 32  Albert Hein
#[Out]# 33       Sligro
#[Out]# 34         Coop
#[Out]# 35  Albert Hein
#[Out]# 36         Lidl
#[Out]# 37         Coop
#[Out]# 38    Hoogvliet
#[Out]# 39         Coop
#[Out]# 40         Lidl
#[Out]# 41         Dirk
#[Out]# 42         Coop
#[Out]# 43         Dirk
#[Out]# 44         Dirk
#[Out]# 45         Lidl
#[Out]# 46         Lidl
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sName
    having avg(p.quantity) > 4
    
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    Select s.sName
    FROM store s, purchase p
    where s.sID = p.sID  
    group by s.sName
    having avg(p.quantity) > 4 
    
    
   
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    Select s.sName
    FROM store s, store s2 purchase p
    where s.sID = p.sID and s.sName = s2.sName and s.sID <> s2.sID
    group by s.sName
    having avg(p.quantity) > 4 
       
'''

pd.read_sql_query(query4, conn)
query4 = '''
    Select s.sName
    FROM store s, store s2, purchase p
    where s.sID = p.sID and s.sName = s2.sName and s.sID <> s2.sID
    group by s.sName
    having avg(p.quantity) > 4 
       
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT s.sName
    FROM store s, purchase p, product pr
    where p.sID = s.sID and pr.pID = p.pID
'''

pd.read_sql_query(query5, conn)
#[Out]#            sName
#[Out]# 0         Sligro
#[Out]# 1           Dirk
#[Out]# 2         Sligro
#[Out]# 3      Hoogvliet
#[Out]# 4    Albert Hein
#[Out]# 5           Lidl
#[Out]# 6           Lidl
#[Out]# 7           Lidl
#[Out]# 8           Lidl
#[Out]# 9         Sligro
#[Out]# 10          Coop
#[Out]# 11          Coop
#[Out]# 12          Coop
#[Out]# 13   Albert Hein
#[Out]# 14          Dirk
#[Out]# 15        Sligro
#[Out]# 16     Hoogvliet
#[Out]# 17         Jumbo
#[Out]# 18          Coop
#[Out]# 19          Coop
#[Out]# 20        Sligro
#[Out]# 21   Albert Hein
#[Out]# 22     Hoogvliet
#[Out]# 23          Lidl
#[Out]# 24          Coop
#[Out]# 25          Coop
#[Out]# 26          Coop
#[Out]# 27     Hoogvliet
#[Out]# 28        Sligro
#[Out]# 29          Lidl
#[Out]# ..           ...
#[Out]# 479         Coop
#[Out]# 480         Lidl
#[Out]# 481         Lidl
#[Out]# 482        Jumbo
#[Out]# 483    Hoogvliet
#[Out]# 484       Sligro
#[Out]# 485    Hoogvliet
#[Out]# 486  Albert Hein
#[Out]# 487       Sligro
#[Out]# 488         Coop
#[Out]# 489  Albert Hein
#[Out]# 490         Coop
#[Out]# 491         Lidl
#[Out]# 492         Coop
#[Out]# 493    Hoogvliet
#[Out]# 494    Hoogvliet
#[Out]# 495       Sligro
#[Out]# 496         Coop
#[Out]# 497         Lidl
#[Out]# 498         Coop
#[Out]# 499         Dirk
#[Out]# 500         Coop
#[Out]# 501        Jumbo
#[Out]# 502         Dirk
#[Out]# 503         Dirk
#[Out]# 504        Jumbo
#[Out]# 505         Lidl
#[Out]# 506         Lidl
#[Out]# 507        Jumbo
#[Out]# 508        Jumbo
#[Out]# 
#[Out]# [509 rows x 1 columns]
query5 = '''
    SELECT MAX(p.price)
    FROM store s, purchase p, product pr
    where p.sID = s.sID and pr.pID = p.pID and p.quantity = 1
'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(p.price)
#[Out]# 0            12
query5 = '''
    SELECT MAX(p.price), p.pID
    FROM store s, purchase p, product pr
    where p.sID = s.sID and pr.pID = p.pID and p.quantity = 1
'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(p.price)  pID
#[Out]# 0            12   18
query5 = '''
    SELECT MAX(p.price), pr.pName
    FROM store s, purchase p, product pr
    where p.sID = s.sID and pr.pID = p.pID and p.quantity = 1
'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(p.price)   pName
#[Out]# 0            12  Cheese
query5 = '''
    SELECT MAX(p.price), pr.pName, s.sName
    FROM store s, purchase p, product pr
    where p.sID = s.sID and pr.pID = p.pID and p.quantity = 1
'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(p.price)   pName        sName
#[Out]# 0            12  Cheese  Albert Hein
query5 = '''
    SELECT MIN(p.price), pr.pName, s.sName
    FROM store s, purchase p, product pr
    where p.sID = s.sID and pr.pID = p.pID and p.quantity = 1
'''

pd.read_sql_query(query5, conn)
#[Out]#    MIN(p.price)  pName   sName
#[Out]# 0          0.45  Water  Sligro
query5 = '''
    SELECT MAX(p.price), pr.pName, s.sName
    FROM store s, purchase p, product pr
    where p.sID = s.sID and pr.pID = p.pID and p.quantity = 1
'''

pd.read_sql_query(query5, conn)
#[Out]#    MAX(p.price)   pName        sName
#[Out]# 0            12  Cheese  Albert Hein
query6 = '''
    Selecet s1.sid
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Selecet s1.sID
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select s1.sID
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#         sID
#[Out]# 0         0
#[Out]# 1         0
#[Out]# 2         0
#[Out]# 3         0
#[Out]# 4         0
#[Out]# 5         0
#[Out]# 6         0
#[Out]# 7         0
#[Out]# 8         0
#[Out]# 9         0
#[Out]# 10        0
#[Out]# 11        0
#[Out]# 12        0
#[Out]# 13        0
#[Out]# 14        0
#[Out]# 15        0
#[Out]# 16        0
#[Out]# 17        0
#[Out]# 18        0
#[Out]# 19        0
#[Out]# 20        0
#[Out]# 21        0
#[Out]# 22        0
#[Out]# 23        0
#[Out]# 24        0
#[Out]# 25        0
#[Out]# 26        0
#[Out]# 27        0
#[Out]# 28        0
#[Out]# 29        0
#[Out]# ...     ...
#[Out]# 674944   60
#[Out]# 674945   60
#[Out]# 674946   60
#[Out]# 674947   60
#[Out]# 674948   60
#[Out]# 674949   60
#[Out]# 674950   60
#[Out]# 674951   60
#[Out]# 674952   60
#[Out]# 674953   60
#[Out]# 674954   60
#[Out]# 674955   60
#[Out]# 674956   60
#[Out]# 674957   60
#[Out]# 674958   60
#[Out]# 674959   60
#[Out]# 674960   60
#[Out]# 674961   60
#[Out]# 674962   60
#[Out]# 674963   60
#[Out]# 674964   60
#[Out]# 674965   60
#[Out]# 674966   60
#[Out]# 674967   60
#[Out]# 674968   60
#[Out]# 674969   60
#[Out]# 674970   60
#[Out]# 674971   60
#[Out]# 674972   60
#[Out]# 674973   60
#[Out]# 
#[Out]# [674974 rows x 1 columns]
query6 = '''
    Select MAX(i1.unit-price)
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select MAX(i1.unitprice)
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select MAX(i1.unit-price)
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select i1.unit-price
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select i1.unitprice
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select i1.unitPrice
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select i1.price
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select i1.unit-price
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select i1.
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
practicequery1a = '''
    Select *
    from inventory
'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#      sID  pID        date  quantity  unit_price
#[Out]# 0     55   10  2018-08-26        17        0.60
#[Out]# 1     25   12  2018-08-24        30       14.80
#[Out]# 2     15    6  2018-08-26        13        1.15
#[Out]# 3      6   27  2018-08-19        51        7.30
#[Out]# 4     57    2  2018-08-22        24        2.05
#[Out]# 5     33    8  2018-08-19        46        5.70
#[Out]# 6     51   10  2018-08-23        31        0.60
#[Out]# 7     50   21  2018-08-22        32        1.90
#[Out]# 8      0   13  2018-08-25        13        3.05
#[Out]# 9     36    8  2018-08-27        11        5.05
#[Out]# 10    36   23  2018-08-18        35        2.20
#[Out]# 11    54   10  2018-08-24        16        0.55
#[Out]# 12    59    1  2018-08-26        36        6.20
#[Out]# 13     9   19  2018-08-22        28        2.50
#[Out]# 14    33    7  2018-08-26         5        1.60
#[Out]# 15    35   10  2018-08-21        51        0.55
#[Out]# 16     0   21  2018-08-15         0        2.20
#[Out]# 17    31   14  2018-08-17        10        4.50
#[Out]# 18    19   14  2018-08-20        42        4.70
#[Out]# 19    33   20  2018-08-21        51        2.15
#[Out]# 20    17   24  2018-08-16        44        2.85
#[Out]# 21     4   27  2018-08-18        27        9.00
#[Out]# 22     3   25  2018-08-27        24        4.60
#[Out]# 23    22   15  2018-08-20         4        1.30
#[Out]# 24    52   14  2018-08-18        44        4.25
#[Out]# 25    24   26  2018-08-25        18        2.90
#[Out]# 26     7   12  2018-08-20        13       12.55
#[Out]# 27    32   18  2018-08-21        41       11.85
#[Out]# 28    48   24  2018-08-19        10        3.20
#[Out]# 29    54    8  2018-08-17         3        5.55
#[Out]# ..   ...  ...         ...       ...         ...
#[Out]# 799   35    0  2018-08-25         1        4.35
#[Out]# 800   19   11  2018-08-25         9        0.90
#[Out]# 801    4   21  2018-08-25         9        2.15
#[Out]# 802    6    5  2018-08-26         6        0.50
#[Out]# 803   47   18  2018-08-20        12        8.85
#[Out]# 804   38   17  2018-08-20        10        2.30
#[Out]# 805   11    3  2018-08-21        15        1.30
#[Out]# 806   34   26  2018-08-21        14        3.40
#[Out]# 807   34   25  2018-08-27        17        3.60
#[Out]# 808   25   14  2018-08-24         3        3.70
#[Out]# 809   24   11  2018-08-24         1        0.85
#[Out]# 810   57   17  2018-08-24         4        2.40
#[Out]# 811   43   27  2018-08-22        15        9.00
#[Out]# 812   35   16  2018-08-22         8        1.85
#[Out]# 813   45   10  2018-08-22        21        0.45
#[Out]# 814   34   26  2018-08-26         9        3.10
#[Out]# 815   34   13  2018-08-26         3        4.05
#[Out]# 816   56   10  2018-08-27         1        0.60
#[Out]# 817    6   26  2018-08-24        13        2.70
#[Out]# 818   45    6  2018-08-24         9        0.90
#[Out]# 819   27   21  2018-08-27         1        2.00
#[Out]# 820   17   25  2018-08-27        14        3.90
#[Out]# 821    5   18  2018-08-28         1        9.70
#[Out]# 822    5    3  2018-08-28        13        1.30
#[Out]# 823    4   13  2018-08-23        23        4.20
#[Out]# 824   27   10  2018-08-20         7        0.55
#[Out]# 825   45   18  2018-08-21         5        9.20
#[Out]# 826   57    6  2018-08-22         9        1.15
#[Out]# 827   60   19  2018-07-10       525        1.75
#[Out]# 828    0    0  2018-07-18        15        5.95
#[Out]# 
#[Out]# [829 rows x 5 columns]
query6 = '''
    Select i1.unit_price
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#         unit_price
#[Out]# 0             0.60
#[Out]# 1             0.60
#[Out]# 2             0.60
#[Out]# 3             0.60
#[Out]# 4             0.60
#[Out]# 5             0.60
#[Out]# 6             0.60
#[Out]# 7             0.60
#[Out]# 8             0.60
#[Out]# 9             0.60
#[Out]# 10            0.60
#[Out]# 11            0.60
#[Out]# 12            0.60
#[Out]# 13            0.60
#[Out]# 14            0.60
#[Out]# 15            0.60
#[Out]# 16            0.60
#[Out]# 17            0.60
#[Out]# 18            0.60
#[Out]# 19            0.60
#[Out]# 20            0.60
#[Out]# 21            0.60
#[Out]# 22            0.60
#[Out]# 23            0.60
#[Out]# 24            0.60
#[Out]# 25            0.60
#[Out]# 26            0.60
#[Out]# 27            0.60
#[Out]# 28            0.60
#[Out]# 29            0.60
#[Out]# ...            ...
#[Out]# 674944        5.95
#[Out]# 674945        5.95
#[Out]# 674946        5.95
#[Out]# 674947        5.95
#[Out]# 674948        5.95
#[Out]# 674949        5.95
#[Out]# 674950        5.95
#[Out]# 674951        5.95
#[Out]# 674952        5.95
#[Out]# 674953        5.95
#[Out]# 674954        5.95
#[Out]# 674955        5.95
#[Out]# 674956        5.95
#[Out]# 674957        5.95
#[Out]# 674958        5.95
#[Out]# 674959        5.95
#[Out]# 674960        5.95
#[Out]# 674961        5.95
#[Out]# 674962        5.95
#[Out]# 674963        5.95
#[Out]# 674964        5.95
#[Out]# 674965        5.95
#[Out]# 674966        5.95
#[Out]# 674967        5.95
#[Out]# 674968        5.95
#[Out]# 674969        5.95
#[Out]# 674970        5.95
#[Out]# 674971        5.95
#[Out]# 674972        5.95
#[Out]# 674973        5.95
#[Out]# 
#[Out]# [674974 rows x 1 columns]
query6 = '''
    Select MAX(i1.unit_price)
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price)
#[Out]# 0                14.9
query6 = '''
    Select MAX(MAX(i1.unit_price))
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select MAX(MAX(i1.unit_price) - MIN(i2.unit_price))
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    Select MAX(i1.unit_price)
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price)
#[Out]# 0                14.9
query6 = '''
    Select MAX(i1.unit_price - i2.unit_price)
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                14.5
query6 = '''
    Select MIN(i2.unit_price)
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MIN(i2.unit_price)
#[Out]# 0                 0.4
query6 = '''
    Select MAX(i2.unit_price)
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i2.unit_price)
#[Out]# 0                14.9
query6 = '''
    Select MIN(i2.unit_price)
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MIN(i2.unit_price)
#[Out]# 0                 0.4
query6 = '''
    Select MAX(i1.unit_price - i2.unit_price)
    FROM store s1, store s2, inventory i1, inventory i2
    where s1.sID = i1.sID and s2.sID = i2.sID and s1.sID <> s2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(i1.unit_price - i2.unit_price)
#[Out]# 0                                14.5
query3 = '''
    Select Distinct c.cID
    from customer c
    
    EXCEPT
    
    Select c.cID
    FROM customer c, purchase p, store s
    where c.cID = p.cID and p.sID <> s.sID
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
