# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x288d5a6a500>
query1 = '''
    select cID, cName
    from customer
'''

pd.read_sql_query(query1, conn)
#[Out]#      cID     cName
#[Out]# 0      0      Noah
#[Out]# 1      1       Sem
#[Out]# 2      2     Lucas
#[Out]# 3      3      Finn
#[Out]# 4      4      Daan
#[Out]# 5      5      Levi
#[Out]# 6      6     Milan
#[Out]# 7      7      Bram
#[Out]# 8      8      Liam
#[Out]# 9      9    Thomas
#[Out]# 10    10       Sam
#[Out]# 11    11     Thijs
#[Out]# 12    12      Adam
#[Out]# 13    13     James
#[Out]# 14    14       Max
#[Out]# 15    15      Noud
#[Out]# 16    16    Julian
#[Out]# 17    17       Dex
#[Out]# 18    18      Hugo
#[Out]# 19    19      Lars
#[Out]# 20    20      Gijs
#[Out]# 21    21  Benjamin
#[Out]# 22    22      Mats
#[Out]# 23    23       Jan
#[Out]# 24    24      Luca
#[Out]# 25    25     Mason
#[Out]# 26    26    Jayden
#[Out]# 27    27       Tim
#[Out]# 28    28      Siem
#[Out]# 29    29     Ruben
#[Out]# ..   ...       ...
#[Out]# 160  160      Lara
#[Out]# 161  161     Floor
#[Out]# 162  162     Elena
#[Out]# 163  163      Cato
#[Out]# 164  164       Evy
#[Out]# 165  165     Hanna
#[Out]# 166  166   Rosalie
#[Out]# 167  167    Veerle
#[Out]# 168  168      Kiki
#[Out]# 169  169      Lily
#[Out]# 170  170      Iris
#[Out]# 171  171     Tessa
#[Out]# 172  172      Lana
#[Out]# 173  173     Livia
#[Out]# 174  174      Romy
#[Out]# 175  175       Sam
#[Out]# 176  176     Amira
#[Out]# 177  177     Eline
#[Out]# 178  178      Elif
#[Out]# 179  179      Juul
#[Out]# 180  180     Merel
#[Out]# 181  181      Liva
#[Out]# 182  182   Johanna
#[Out]# 183  183     Nikki
#[Out]# 184  184     Wilko
#[Out]# 185  185      Nick
#[Out]# 186  186    Angela
#[Out]# 187  188      Pino
#[Out]# 188  189      Koen
#[Out]# 189  190    Kostas
#[Out]# 
#[Out]# [190 rows x 2 columns]
query1 = '''
    select pID
    from purchase
    group by pID
    having (count(distinct cID) <= 2)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    select pID
    from purchase
    group by pID
    having (count(distinct cID) <= 3)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    select pID
    from purchase
    group by pID
    having (count(distinct cID) <= 4)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    select pID
    from purchase
    group by pID
    having (count(distinct cID) <= 5)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    select pID
    from purchase
    group by pID
    having (count(distinct cID) <= 100)
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
query1 = '''
    select pID
    from purchase
    group by pID
    having (count(distinct cID) <= 10)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0    2
#[Out]# 1   18
#[Out]# 2   29
#[Out]# 3   30
query1 = '''
    select pID
    from purchase
    group by pID
    having (count(distinct cID) <= 2)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    select pID
    from purchase
    group by pID
    having (count(distinct cID) > 2)
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
query1 = '''
    select pID
    from purchase
    group by pID
    having (count(distinct cID) <= 2)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    select *
    purchase
    group by pID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    select pID, cID
    purchase
    group by pID, cID
'''

pd.read_sql_query(query2, conn)
query2 = '''
    select pID, cID
    from purchase
    group by pID, cID
'''

pd.read_sql_query(query2, conn)
#[Out]#      pID  cID
#[Out]# 0      0   13
#[Out]# 1      0   16
#[Out]# 2      0   19
#[Out]# 3      0   20
#[Out]# 4      0   24
#[Out]# 5      0   33
#[Out]# 6      0   66
#[Out]# 7      0   78
#[Out]# 8      0   82
#[Out]# 9      0   95
#[Out]# 10     0  113
#[Out]# 11     0  123
#[Out]# 12     0  127
#[Out]# 13     0  139
#[Out]# 14     0  144
#[Out]# 15     0  157
#[Out]# 16     0  163
#[Out]# 17     0  167
#[Out]# 18     0  170
#[Out]# 19     0  176
#[Out]# 20     0  184
#[Out]# 21     0  190
#[Out]# 22     1   33
#[Out]# 23     1   59
#[Out]# 24     1   69
#[Out]# 25     1   92
#[Out]# 26     1  108
#[Out]# 27     1  109
#[Out]# 28     1  112
#[Out]# 29     1  131
#[Out]# ..   ...  ...
#[Out]# 438   27  134
#[Out]# 439   27  161
#[Out]# 440   27  179
#[Out]# 441   27  190
#[Out]# 442   28    5
#[Out]# 443   28   22
#[Out]# 444   28   35
#[Out]# 445   28   39
#[Out]# 446   28   40
#[Out]# 447   28   60
#[Out]# 448   28   70
#[Out]# 449   28   71
#[Out]# 450   28   82
#[Out]# 451   28   86
#[Out]# 452   28  100
#[Out]# 453   28  108
#[Out]# 454   28  118
#[Out]# 455   28  123
#[Out]# 456   28  124
#[Out]# 457   28  127
#[Out]# 458   28  136
#[Out]# 459   28  161
#[Out]# 460   28  162
#[Out]# 461   28  169
#[Out]# 462   28  170
#[Out]# 463   28  175
#[Out]# 464   28  190
#[Out]# 465   29  185
#[Out]# 466   29  186
#[Out]# 467   30  188
#[Out]# 
#[Out]# [468 rows x 2 columns]
query2 = '''
    select c.cID, c.cName
    from customer c, purchase p1, purchase p2, product prod1, product prod2
    where c.cID = p1.cID
    and p1.cID = p2.cID
    and p1.date = p2.date
    and p1.pID = prod1.pID
    and prod1.pName = 'Onions'
    and p2.pID = prod2.pID
    and prod2.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    select c.cID, c.cName
    from customer c, purchase p1, purchase p2, product prod1, product prod2
    where c.cID = p1.cID
    and p1.cID = p2.cID
    and p1.date = p2.date
    and p1.pID = prod1.pID
    and prod1.pName = 'Onion'
    and p2.pID = prod2.pID
    and prod2.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
    select c.cID, c.cName
    from customer c, purchase p1, purchase p2, product prod1, product prod2
    where c.cID = p1.cID
    and p1.cID = p2.cID
    and p1.date = p2.date
    and p1.pID = prod1.pID
    and prod1.pName = 'Onions'
    and p2.pID = prod2.pID
    and prod2.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    select c.cID, c.cName
    from customer c, purchase p1, purchase p2, product prod1, product prod2
    where c.cID = p1.cID
    and p1.cID = p2.cID
    and p1.date = p2.date
    and p1.pID = prod1.pID
    and prod1.pName = 'Coffee'
    and p2.pID = prod2.pID
    and prod2.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID   cName
#[Out]# 0    16  Julian
#[Out]# 1    42    Tijn
#[Out]# 2    59    Joep
#[Out]# 3    82   Dylan
#[Out]# 4    86    Stef
#[Out]# 5    92   Jelte
#[Out]# 6    97  Sophie
#[Out]# 7   108    Noor
#[Out]# 8   110    Saar
#[Out]# 9   111  Lauren
#[Out]# 10  122    Elin
#[Out]# 11  124   Sofie
#[Out]# 12  152    Anne
#[Out]# 13  169    Lily
#[Out]# 14  171   Tessa
#[Out]# 15  175     Sam
#[Out]# 16  176   Amira
#[Out]# 17  181    Liva
#[Out]# 18  190  Kostas
#[Out]# 19  190  Kostas
#[Out]# 20  190  Kostas
#[Out]# 21  190  Kostas
#[Out]# 22  190  Kostas
#[Out]# 23  190  Kostas
query2 = '''
    select c.cID, c.cName
    from customer c, purchase p1, purchase p2, product prod1, product prod2
    where c.cID = p1.cID
    and p1.cID = p2.cID
    and p1.date = p2.date
    and p1.pID = prod1.pID
    and prod1.pName = 'Onions'
    and p2.pID = prod2.pID
    and prod2.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    select c.cID
    from customer c, purchase p
    where count(distinct sID) = (
        select count(distinct sID)
        from store
    )
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c, purchase p
    where count(distinct sID) == (
        select count(distinct sID)
        from store
    )
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c, purchase p
    where count(distinct sID) in (
        select count(distinct sID)
        from store
    )
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c, purchase p
    where count(distinct sID) in (
        select count(distinct sID)
        from store
    )
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID, count(distinct sID)
    from purchase
    group by cID
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count(distinct sID)
#[Out]# 0      0                    1
#[Out]# 1      1                    7
#[Out]# 2      2                    5
#[Out]# 3      3                    3
#[Out]# 4      4                    6
#[Out]# 5      5                    6
#[Out]# 6      7                    6
#[Out]# 7      8                    2
#[Out]# 8     10                    1
#[Out]# 9     11                    1
#[Out]# 10    13                    7
#[Out]# 11    15                    1
#[Out]# 12    16                   10
#[Out]# 13    17                    2
#[Out]# 14    18                    3
#[Out]# 15    19                    4
#[Out]# 16    20                    3
#[Out]# 17    21                    3
#[Out]# 18    22                    2
#[Out]# 19    24                    9
#[Out]# 20    25                    1
#[Out]# 21    26                    1
#[Out]# 22    27                    5
#[Out]# 23    28                    1
#[Out]# 24    29                    2
#[Out]# 25    30                    3
#[Out]# 26    31                    2
#[Out]# 27    33                    9
#[Out]# 28    34                    1
#[Out]# 29    35                    2
#[Out]# ..   ...                  ...
#[Out]# 102  147                    3
#[Out]# 103  149                    2
#[Out]# 104  151                    2
#[Out]# 105  152                    3
#[Out]# 106  157                    2
#[Out]# 107  159                    2
#[Out]# 108  161                    9
#[Out]# 109  162                    8
#[Out]# 110  163                    4
#[Out]# 111  165                    6
#[Out]# 112  167                   10
#[Out]# 113  168                    1
#[Out]# 114  169                   11
#[Out]# 115  170                    3
#[Out]# 116  171                    2
#[Out]# 117  172                    2
#[Out]# 118  175                    2
#[Out]# 119  176                    6
#[Out]# 120  177                    5
#[Out]# 121  178                    2
#[Out]# 122  179                    6
#[Out]# 123  180                    2
#[Out]# 124  181                    3
#[Out]# 125  182                    3
#[Out]# 126  184                    1
#[Out]# 127  185                    1
#[Out]# 128  186                    1
#[Out]# 129  188                    1
#[Out]# 130  189                    2
#[Out]# 131  190                   64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    select cID, count(distinct sID)
    from purchase
    group by cID
    as store_number(cID, storeamount)
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from (
        select cID, count(distinct sID)
        from purchase
        group by cID)
    as store_number(cID, storeamount)
    where storeamount = 1
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from (
        select cID, count(distinct sID)
        from purchase
        group by cID
        ) as store_number(cID, storeamount)
    where storeamount = 1
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from (
        select cID, count(distinct sID)
        from purchase
        group by cID)
        as store_number(cID, storeamount)
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from (
        select cID, count(distinct sID)
        from purchase
        group by cID)
        as store_number(cID, storeamount)
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select *
    from (
        select cID, count(distinct sID)
        from purchase
        group by cID)
        as store_number(cID, storeamount)
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select *
    from (
        select cID
        from purchase
        group by cID)
        as store_number(cID, storeamount)
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select *
    from (
        select cID, count(distinct sID)
        from purchase
        group by cID)
        
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count(distinct sID)
#[Out]# 0      0                    1
#[Out]# 1      1                    7
#[Out]# 2      2                    5
#[Out]# 3      3                    3
#[Out]# 4      4                    6
#[Out]# 5      5                    6
#[Out]# 6      7                    6
#[Out]# 7      8                    2
#[Out]# 8     10                    1
#[Out]# 9     11                    1
#[Out]# 10    13                    7
#[Out]# 11    15                    1
#[Out]# 12    16                   10
#[Out]# 13    17                    2
#[Out]# 14    18                    3
#[Out]# 15    19                    4
#[Out]# 16    20                    3
#[Out]# 17    21                    3
#[Out]# 18    22                    2
#[Out]# 19    24                    9
#[Out]# 20    25                    1
#[Out]# 21    26                    1
#[Out]# 22    27                    5
#[Out]# 23    28                    1
#[Out]# 24    29                    2
#[Out]# 25    30                    3
#[Out]# 26    31                    2
#[Out]# 27    33                    9
#[Out]# 28    34                    1
#[Out]# 29    35                    2
#[Out]# ..   ...                  ...
#[Out]# 102  147                    3
#[Out]# 103  149                    2
#[Out]# 104  151                    2
#[Out]# 105  152                    3
#[Out]# 106  157                    2
#[Out]# 107  159                    2
#[Out]# 108  161                    9
#[Out]# 109  162                    8
#[Out]# 110  163                    4
#[Out]# 111  165                    6
#[Out]# 112  167                   10
#[Out]# 113  168                    1
#[Out]# 114  169                   11
#[Out]# 115  170                    3
#[Out]# 116  171                    2
#[Out]# 117  172                    2
#[Out]# 118  175                    2
#[Out]# 119  176                    6
#[Out]# 120  177                    5
#[Out]# 121  178                    2
#[Out]# 122  179                    6
#[Out]# 123  180                    2
#[Out]# 124  181                    3
#[Out]# 125  182                    3
#[Out]# 126  184                    1
#[Out]# 127  185                    1
#[Out]# 128  186                    1
#[Out]# 129  188                    1
#[Out]# 130  189                    2
#[Out]# 131  190                   64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    select *
    from (
        select cID, count(distinct sID)
        from purchase
        group by cID) as test
        
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count(distinct sID)
#[Out]# 0      0                    1
#[Out]# 1      1                    7
#[Out]# 2      2                    5
#[Out]# 3      3                    3
#[Out]# 4      4                    6
#[Out]# 5      5                    6
#[Out]# 6      7                    6
#[Out]# 7      8                    2
#[Out]# 8     10                    1
#[Out]# 9     11                    1
#[Out]# 10    13                    7
#[Out]# 11    15                    1
#[Out]# 12    16                   10
#[Out]# 13    17                    2
#[Out]# 14    18                    3
#[Out]# 15    19                    4
#[Out]# 16    20                    3
#[Out]# 17    21                    3
#[Out]# 18    22                    2
#[Out]# 19    24                    9
#[Out]# 20    25                    1
#[Out]# 21    26                    1
#[Out]# 22    27                    5
#[Out]# 23    28                    1
#[Out]# 24    29                    2
#[Out]# 25    30                    3
#[Out]# 26    31                    2
#[Out]# 27    33                    9
#[Out]# 28    34                    1
#[Out]# 29    35                    2
#[Out]# ..   ...                  ...
#[Out]# 102  147                    3
#[Out]# 103  149                    2
#[Out]# 104  151                    2
#[Out]# 105  152                    3
#[Out]# 106  157                    2
#[Out]# 107  159                    2
#[Out]# 108  161                    9
#[Out]# 109  162                    8
#[Out]# 110  163                    4
#[Out]# 111  165                    6
#[Out]# 112  167                   10
#[Out]# 113  168                    1
#[Out]# 114  169                   11
#[Out]# 115  170                    3
#[Out]# 116  171                    2
#[Out]# 117  172                    2
#[Out]# 118  175                    2
#[Out]# 119  176                    6
#[Out]# 120  177                    5
#[Out]# 121  178                    2
#[Out]# 122  179                    6
#[Out]# 123  180                    2
#[Out]# 124  181                    3
#[Out]# 125  182                    3
#[Out]# 126  184                    1
#[Out]# 127  185                    1
#[Out]# 128  186                    1
#[Out]# 129  188                    1
#[Out]# 130  189                    2
#[Out]# 131  190                   64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    select *
    from (
        select cID, count(distinct sID)
        from purchase
        group by cID) as test(cID, count)
        
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select *
    from (
        select cID, count(distinct sID)
        from purchase
        group by cID) as test(ok, cID, count)
        
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select *
    from (
        select cID, count(distinct sID)
        from purchase
        group by cID) as test
        
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count(distinct sID)
#[Out]# 0      0                    1
#[Out]# 1      1                    7
#[Out]# 2      2                    5
#[Out]# 3      3                    3
#[Out]# 4      4                    6
#[Out]# 5      5                    6
#[Out]# 6      7                    6
#[Out]# 7      8                    2
#[Out]# 8     10                    1
#[Out]# 9     11                    1
#[Out]# 10    13                    7
#[Out]# 11    15                    1
#[Out]# 12    16                   10
#[Out]# 13    17                    2
#[Out]# 14    18                    3
#[Out]# 15    19                    4
#[Out]# 16    20                    3
#[Out]# 17    21                    3
#[Out]# 18    22                    2
#[Out]# 19    24                    9
#[Out]# 20    25                    1
#[Out]# 21    26                    1
#[Out]# 22    27                    5
#[Out]# 23    28                    1
#[Out]# 24    29                    2
#[Out]# 25    30                    3
#[Out]# 26    31                    2
#[Out]# 27    33                    9
#[Out]# 28    34                    1
#[Out]# 29    35                    2
#[Out]# ..   ...                  ...
#[Out]# 102  147                    3
#[Out]# 103  149                    2
#[Out]# 104  151                    2
#[Out]# 105  152                    3
#[Out]# 106  157                    2
#[Out]# 107  159                    2
#[Out]# 108  161                    9
#[Out]# 109  162                    8
#[Out]# 110  163                    4
#[Out]# 111  165                    6
#[Out]# 112  167                   10
#[Out]# 113  168                    1
#[Out]# 114  169                   11
#[Out]# 115  170                    3
#[Out]# 116  171                    2
#[Out]# 117  172                    2
#[Out]# 118  175                    2
#[Out]# 119  176                    6
#[Out]# 120  177                    5
#[Out]# 121  178                    2
#[Out]# 122  179                    6
#[Out]# 123  180                    2
#[Out]# 124  181                    3
#[Out]# 125  182                    3
#[Out]# 126  184                    1
#[Out]# 127  185                    1
#[Out]# 128  186                    1
#[Out]# 129  188                    1
#[Out]# 130  189                    2
#[Out]# 131  190                   64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    select *
    from (select cID, count(distinct sID)
          from purchase
          group by cID)
         as test(cID, counter)
        
        
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select *
    from (select cID, count(distinct sID)
          from purchase
          group by cID)
         as test(cIDs, counter)
        
        
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select *
    from (select cID, count(distinct sID)
          from purchase
          group by cID)
         as test (cIDs, counter)
        
        
    
'''

pd.read_sql_query(query3, conn)
query4 = '''
    select *
    from cutomer as cust(cid, cname, ste, cit)
'''

pd.read_sql_query(query4, conn)
query3 = '''
    with *
    from (select cID, count(distinct sID)
          from purchase
          group by cID)
         as test(cIDs, counter)
        
        
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with customer_stores(cID, counter) as
    (select cID, count(distinct sID)
          from purchase
          group by cID)
        
        
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with customer_stores(cID, counter) as
    (select cID, count(distinct sID)
          from purchase
          group by cID)
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with customer_stores(cID, counter) as
    (select cID, count(distinct sID)
          from purchase
          group by cID
          )
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with cust(cid, name, stre, sity) as (
        select *
        from customer
    )
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with cust as (
        select *
        from customer
    )
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with cust as (
        select *
        from customer
    )
    select *
    from cust
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID     cName                street       city
#[Out]# 0      0      Noah             Koestraat    Utrecht
#[Out]# 1      1       Sem      Rozemarijnstraat      Breda
#[Out]# 2      2     Lucas      Oude Leliestraat  Amsterdam
#[Out]# 3      3      Finn         Stationsplein      Breda
#[Out]# 4      4      Daan          Kalverstraat  Amsterdam
#[Out]# 5      5      Levi        Gasthuisstraat    Utrecht
#[Out]# 6      6     Milan           Parallelweg    Utrecht
#[Out]# 7      7      Bram          Schoolstraat  Eindhoven
#[Out]# 8      8      Liam         Rijsbergseweg      Breda
#[Out]# 9      9    Thomas           Parallelweg  Amsterdam
#[Out]# 10    10       Sam           Langestraat    Tilburg
#[Out]# 11    11     Thijs             Koestraat    Tilburg
#[Out]# 12    12      Adam           Nieuwstraat  Eindhoven
#[Out]# 13    13     James       Sint Annastraat      Breda
#[Out]# 14    14       Max             Eikenlaan    Tilburg
#[Out]# 15    15      Noud          Koningshoeve    Tilburg
#[Out]# 16    16    Julian  Prins Bernhardstraat  Eindhoven
#[Out]# 17    17       Dex          Kasteeldreef    Tilburg
#[Out]# 18    18      Hugo          Kasteeldreef    Tilburg
#[Out]# 19    19      Lars         Rijsbergseweg      Breda
#[Out]# 20    20      Gijs            Heiligeweg  Amsterdam
#[Out]# 21    21  Benjamin           Stationsweg    Tilburg
#[Out]# 22    22      Mats           Molenstraat  Eindhoven
#[Out]# 23    23       Jan       Sint Annastraat      Breda
#[Out]# 24    24      Luca          Kasteeldreef    Tilburg
#[Out]# 25    25     Mason          Keizerstraat  Rotterdam
#[Out]# 26    26    Jayden          Schoolstraat  Eindhoven
#[Out]# 27    27       Tim             Koestraat    Utrecht
#[Out]# 28    28      Siem           Langestraat    Tilburg
#[Out]# 29    29     Ruben              Hofplein  Rotterdam
#[Out]# ..   ...       ...                   ...        ...
#[Out]# 160  160      Lara           Langestraat    Tilburg
#[Out]# 161  161     Floor             Eikenlaan    Tilburg
#[Out]# 162  162     Elena            Bergselaan  Rotterdam
#[Out]# 163  163      Cato          Kastanjelaan    Tilburg
#[Out]# 164  164       Evy      Rozemarijnstraat      Breda
#[Out]# 165  165     Hanna             Eikenlaan    Tilburg
#[Out]# 166  166   Rosalie           Stationsweg  Eindhoven
#[Out]# 167  167    Veerle        Ginnekenstraat      Breda
#[Out]# 168  168      Kiki          Keizerstraat  Rotterdam
#[Out]# 169  169      Lily        Gasthuisstraat    Utrecht
#[Out]# 170  170      Iris          Kastanjelaan  Eindhoven
#[Out]# 171  171     Tessa           Haringvliet  Rotterdam
#[Out]# 172  172      Lana             Eikenlaan    Tilburg
#[Out]# 173  173     Livia      Vierwindenstraat      Breda
#[Out]# 174  174      Romy           Parallelweg  Eindhoven
#[Out]# 175  175       Sam             Bredalaan  Eindhoven
#[Out]# 176  176     Amira           Parallelweg  Amsterdam
#[Out]# 177  177     Eline          Kalverstraat  Amsterdam
#[Out]# 178  178      Elif           Parallelweg    Utrecht
#[Out]# 179  179      Juul        Wilhelminapark    Tilburg
#[Out]# 180  180     Merel          Kalverstraat  Amsterdam
#[Out]# 181  181      Liva           Fredriklaan  Eindhoven
#[Out]# 182  182   Johanna         Beatrixstraat  Eindhoven
#[Out]# 183  183     Nikki         Julianastraat    Utrecht
#[Out]# 184  184     Wilko          Onbekendeweg  Eindhoven
#[Out]# 185  185      Nick                Verweg  Eindhoven
#[Out]# 186  186    Angela              Dichtweg  Eindhoven
#[Out]# 187  188      Pino            Maanstraat  Rotterdam
#[Out]# 188  189      Koen              Akkerweg        Oss
#[Out]# 189  190    Kostas              Eindeweg    Utrecht
#[Out]# 
#[Out]# [190 rows x 4 columns]
query3 = '''
    with cust(cid,name,ste,sity) as (
        select *
        from customer
    )
    select *
    from cust
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cid      name                   ste       sity
#[Out]# 0      0      Noah             Koestraat    Utrecht
#[Out]# 1      1       Sem      Rozemarijnstraat      Breda
#[Out]# 2      2     Lucas      Oude Leliestraat  Amsterdam
#[Out]# 3      3      Finn         Stationsplein      Breda
#[Out]# 4      4      Daan          Kalverstraat  Amsterdam
#[Out]# 5      5      Levi        Gasthuisstraat    Utrecht
#[Out]# 6      6     Milan           Parallelweg    Utrecht
#[Out]# 7      7      Bram          Schoolstraat  Eindhoven
#[Out]# 8      8      Liam         Rijsbergseweg      Breda
#[Out]# 9      9    Thomas           Parallelweg  Amsterdam
#[Out]# 10    10       Sam           Langestraat    Tilburg
#[Out]# 11    11     Thijs             Koestraat    Tilburg
#[Out]# 12    12      Adam           Nieuwstraat  Eindhoven
#[Out]# 13    13     James       Sint Annastraat      Breda
#[Out]# 14    14       Max             Eikenlaan    Tilburg
#[Out]# 15    15      Noud          Koningshoeve    Tilburg
#[Out]# 16    16    Julian  Prins Bernhardstraat  Eindhoven
#[Out]# 17    17       Dex          Kasteeldreef    Tilburg
#[Out]# 18    18      Hugo          Kasteeldreef    Tilburg
#[Out]# 19    19      Lars         Rijsbergseweg      Breda
#[Out]# 20    20      Gijs            Heiligeweg  Amsterdam
#[Out]# 21    21  Benjamin           Stationsweg    Tilburg
#[Out]# 22    22      Mats           Molenstraat  Eindhoven
#[Out]# 23    23       Jan       Sint Annastraat      Breda
#[Out]# 24    24      Luca          Kasteeldreef    Tilburg
#[Out]# 25    25     Mason          Keizerstraat  Rotterdam
#[Out]# 26    26    Jayden          Schoolstraat  Eindhoven
#[Out]# 27    27       Tim             Koestraat    Utrecht
#[Out]# 28    28      Siem           Langestraat    Tilburg
#[Out]# 29    29     Ruben              Hofplein  Rotterdam
#[Out]# ..   ...       ...                   ...        ...
#[Out]# 160  160      Lara           Langestraat    Tilburg
#[Out]# 161  161     Floor             Eikenlaan    Tilburg
#[Out]# 162  162     Elena            Bergselaan  Rotterdam
#[Out]# 163  163      Cato          Kastanjelaan    Tilburg
#[Out]# 164  164       Evy      Rozemarijnstraat      Breda
#[Out]# 165  165     Hanna             Eikenlaan    Tilburg
#[Out]# 166  166   Rosalie           Stationsweg  Eindhoven
#[Out]# 167  167    Veerle        Ginnekenstraat      Breda
#[Out]# 168  168      Kiki          Keizerstraat  Rotterdam
#[Out]# 169  169      Lily        Gasthuisstraat    Utrecht
#[Out]# 170  170      Iris          Kastanjelaan  Eindhoven
#[Out]# 171  171     Tessa           Haringvliet  Rotterdam
#[Out]# 172  172      Lana             Eikenlaan    Tilburg
#[Out]# 173  173     Livia      Vierwindenstraat      Breda
#[Out]# 174  174      Romy           Parallelweg  Eindhoven
#[Out]# 175  175       Sam             Bredalaan  Eindhoven
#[Out]# 176  176     Amira           Parallelweg  Amsterdam
#[Out]# 177  177     Eline          Kalverstraat  Amsterdam
#[Out]# 178  178      Elif           Parallelweg    Utrecht
#[Out]# 179  179      Juul        Wilhelminapark    Tilburg
#[Out]# 180  180     Merel          Kalverstraat  Amsterdam
#[Out]# 181  181      Liva           Fredriklaan  Eindhoven
#[Out]# 182  182   Johanna         Beatrixstraat  Eindhoven
#[Out]# 183  183     Nikki         Julianastraat    Utrecht
#[Out]# 184  184     Wilko          Onbekendeweg  Eindhoven
#[Out]# 185  185      Nick                Verweg  Eindhoven
#[Out]# 186  186    Angela              Dichtweg  Eindhoven
#[Out]# 187  188      Pino            Maanstraat  Rotterdam
#[Out]# 188  189      Koen              Akkerweg        Oss
#[Out]# 189  190    Kostas              Eindeweg    Utrecht
#[Out]# 
#[Out]# [190 rows x 4 columns]
query3 = '''
    with custstores as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    select *
    from cust
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    select *
    from custstores
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count(distinct sID)
#[Out]# 0      0                    1
#[Out]# 1      1                    7
#[Out]# 2      2                    5
#[Out]# 3      3                    3
#[Out]# 4      4                    6
#[Out]# 5      5                    6
#[Out]# 6      7                    6
#[Out]# 7      8                    2
#[Out]# 8     10                    1
#[Out]# 9     11                    1
#[Out]# 10    13                    7
#[Out]# 11    15                    1
#[Out]# 12    16                   10
#[Out]# 13    17                    2
#[Out]# 14    18                    3
#[Out]# 15    19                    4
#[Out]# 16    20                    3
#[Out]# 17    21                    3
#[Out]# 18    22                    2
#[Out]# 19    24                    9
#[Out]# 20    25                    1
#[Out]# 21    26                    1
#[Out]# 22    27                    5
#[Out]# 23    28                    1
#[Out]# 24    29                    2
#[Out]# 25    30                    3
#[Out]# 26    31                    2
#[Out]# 27    33                    9
#[Out]# 28    34                    1
#[Out]# 29    35                    2
#[Out]# ..   ...                  ...
#[Out]# 102  147                    3
#[Out]# 103  149                    2
#[Out]# 104  151                    2
#[Out]# 105  152                    3
#[Out]# 106  157                    2
#[Out]# 107  159                    2
#[Out]# 108  161                    9
#[Out]# 109  162                    8
#[Out]# 110  163                    4
#[Out]# 111  165                    6
#[Out]# 112  167                   10
#[Out]# 113  168                    1
#[Out]# 114  169                   11
#[Out]# 115  170                    3
#[Out]# 116  171                    2
#[Out]# 117  172                    2
#[Out]# 118  175                    2
#[Out]# 119  176                    6
#[Out]# 120  177                    5
#[Out]# 121  178                    2
#[Out]# 122  179                    6
#[Out]# 123  180                    2
#[Out]# 124  181                    3
#[Out]# 125  182                    3
#[Out]# 126  184                    1
#[Out]# 127  185                    1
#[Out]# 128  186                    1
#[Out]# 129  188                    1
#[Out]# 130  189                    2
#[Out]# 131  190                   64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    with custstores(cID,counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    select *
    from custstores
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  counter
#[Out]# 0      0        1
#[Out]# 1      1        7
#[Out]# 2      2        5
#[Out]# 3      3        3
#[Out]# 4      4        6
#[Out]# 5      5        6
#[Out]# 6      7        6
#[Out]# 7      8        2
#[Out]# 8     10        1
#[Out]# 9     11        1
#[Out]# 10    13        7
#[Out]# 11    15        1
#[Out]# 12    16       10
#[Out]# 13    17        2
#[Out]# 14    18        3
#[Out]# 15    19        4
#[Out]# 16    20        3
#[Out]# 17    21        3
#[Out]# 18    22        2
#[Out]# 19    24        9
#[Out]# 20    25        1
#[Out]# 21    26        1
#[Out]# 22    27        5
#[Out]# 23    28        1
#[Out]# 24    29        2
#[Out]# 25    30        3
#[Out]# 26    31        2
#[Out]# 27    33        9
#[Out]# 28    34        1
#[Out]# 29    35        2
#[Out]# ..   ...      ...
#[Out]# 102  147        3
#[Out]# 103  149        2
#[Out]# 104  151        2
#[Out]# 105  152        3
#[Out]# 106  157        2
#[Out]# 107  159        2
#[Out]# 108  161        9
#[Out]# 109  162        8
#[Out]# 110  163        4
#[Out]# 111  165        6
#[Out]# 112  167       10
#[Out]# 113  168        1
#[Out]# 114  169       11
#[Out]# 115  170        3
#[Out]# 116  171        2
#[Out]# 117  172        2
#[Out]# 118  175        2
#[Out]# 119  176        6
#[Out]# 120  177        5
#[Out]# 121  178        2
#[Out]# 122  179        6
#[Out]# 123  180        2
#[Out]# 124  181        3
#[Out]# 125  182        3
#[Out]# 126  184        1
#[Out]# 127  185        1
#[Out]# 128  186        1
#[Out]# 129  188        1
#[Out]# 130  189        2
#[Out]# 131  190       64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    select *
    from custstores
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  counter
#[Out]# 0      0        1
#[Out]# 1      1        7
#[Out]# 2      2        5
#[Out]# 3      3        3
#[Out]# 4      4        6
#[Out]# 5      5        6
#[Out]# 6      7        6
#[Out]# 7      8        2
#[Out]# 8     10        1
#[Out]# 9     11        1
#[Out]# 10    13        7
#[Out]# 11    15        1
#[Out]# 12    16       10
#[Out]# 13    17        2
#[Out]# 14    18        3
#[Out]# 15    19        4
#[Out]# 16    20        3
#[Out]# 17    21        3
#[Out]# 18    22        2
#[Out]# 19    24        9
#[Out]# 20    25        1
#[Out]# 21    26        1
#[Out]# 22    27        5
#[Out]# 23    28        1
#[Out]# 24    29        2
#[Out]# 25    30        3
#[Out]# 26    31        2
#[Out]# 27    33        9
#[Out]# 28    34        1
#[Out]# 29    35        2
#[Out]# ..   ...      ...
#[Out]# 102  147        3
#[Out]# 103  149        2
#[Out]# 104  151        2
#[Out]# 105  152        3
#[Out]# 106  157        2
#[Out]# 107  159        2
#[Out]# 108  161        9
#[Out]# 109  162        8
#[Out]# 110  163        4
#[Out]# 111  165        6
#[Out]# 112  167       10
#[Out]# 113  168        1
#[Out]# 114  169       11
#[Out]# 115  170        3
#[Out]# 116  171        2
#[Out]# 117  172        2
#[Out]# 118  175        2
#[Out]# 119  176        6
#[Out]# 120  177        5
#[Out]# 121  178        2
#[Out]# 122  179        6
#[Out]# 123  180        2
#[Out]# 124  181        3
#[Out]# 125  182        3
#[Out]# 126  184        1
#[Out]# 127  185        1
#[Out]# 128  186        1
#[Out]# 129  188        1
#[Out]# 130  189        2
#[Out]# 131  190       64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    with allstores(value) as (
        select count(distinct sID)
        from store
    )
    
    select *
    from allstores
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    select count(distinct sID) as maxstores
    from store
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    maxstores
#[Out]# 0         64
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    select count(distinct sID) as maxstores(value)
    from store
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    select count(distinct sID) as maxstores
    from store
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    maxstores
#[Out]# 0         64
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    with count(distinct sID) as maxstores
    from store
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    with maxstores as (
        select count(distinct sID)
        from store
    )
    
    select *
    from maxstores
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    with maxstores as (
        select count(distinct sID)
        from store
    )
    
    select count(distinct sID)
    from store
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    with maxstores as (
        select count(distinct sID)
        from store
    )
    
    select *
    from store
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    and
    with maxstores as (
        select count(distinct sID)
        from store
    )
    
    select *
    from store
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    with maxstores as (
        select count(distinct sID)
        from store
    )
    
    select *
    from store
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    with maxstores as (
        select count(distinct sID)
        from store
    )
    
    select *
    from maxstores
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    select *
    from custstores
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  counter
#[Out]# 0      0        1
#[Out]# 1      1        7
#[Out]# 2      2        5
#[Out]# 3      3        3
#[Out]# 4      4        6
#[Out]# 5      5        6
#[Out]# 6      7        6
#[Out]# 7      8        2
#[Out]# 8     10        1
#[Out]# 9     11        1
#[Out]# 10    13        7
#[Out]# 11    15        1
#[Out]# 12    16       10
#[Out]# 13    17        2
#[Out]# 14    18        3
#[Out]# 15    19        4
#[Out]# 16    20        3
#[Out]# 17    21        3
#[Out]# 18    22        2
#[Out]# 19    24        9
#[Out]# 20    25        1
#[Out]# 21    26        1
#[Out]# 22    27        5
#[Out]# 23    28        1
#[Out]# 24    29        2
#[Out]# 25    30        3
#[Out]# 26    31        2
#[Out]# 27    33        9
#[Out]# 28    34        1
#[Out]# 29    35        2
#[Out]# ..   ...      ...
#[Out]# 102  147        3
#[Out]# 103  149        2
#[Out]# 104  151        2
#[Out]# 105  152        3
#[Out]# 106  157        2
#[Out]# 107  159        2
#[Out]# 108  161        9
#[Out]# 109  162        8
#[Out]# 110  163        4
#[Out]# 111  165        6
#[Out]# 112  167       10
#[Out]# 113  168        1
#[Out]# 114  169       11
#[Out]# 115  170        3
#[Out]# 116  171        2
#[Out]# 117  172        2
#[Out]# 118  175        2
#[Out]# 119  176        6
#[Out]# 120  177        5
#[Out]# 121  178        2
#[Out]# 122  179        6
#[Out]# 123  180        2
#[Out]# 124  181        3
#[Out]# 125  182        3
#[Out]# 126  184        1
#[Out]# 127  185        1
#[Out]# 128  186        1
#[Out]# 129  188        1
#[Out]# 130  189        2
#[Out]# 131  190       64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    with storecount(value) as (
        select *
        from store
    )
    
    select *
    from custstores
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    with storecount as (
        select *
        from store
    )
    
    select *
    from custstores
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    )
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select *
    from custstores
    
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select *
    from custstores
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  counter
#[Out]# 0      0        1
#[Out]# 1      1        7
#[Out]# 2      2        5
#[Out]# 3      3        3
#[Out]# 4      4        6
#[Out]# 5      5        6
#[Out]# 6      7        6
#[Out]# 7      8        2
#[Out]# 8     10        1
#[Out]# 9     11        1
#[Out]# 10    13        7
#[Out]# 11    15        1
#[Out]# 12    16       10
#[Out]# 13    17        2
#[Out]# 14    18        3
#[Out]# 15    19        4
#[Out]# 16    20        3
#[Out]# 17    21        3
#[Out]# 18    22        2
#[Out]# 19    24        9
#[Out]# 20    25        1
#[Out]# 21    26        1
#[Out]# 22    27        5
#[Out]# 23    28        1
#[Out]# 24    29        2
#[Out]# 25    30        3
#[Out]# 26    31        2
#[Out]# 27    33        9
#[Out]# 28    34        1
#[Out]# 29    35        2
#[Out]# ..   ...      ...
#[Out]# 102  147        3
#[Out]# 103  149        2
#[Out]# 104  151        2
#[Out]# 105  152        3
#[Out]# 106  157        2
#[Out]# 107  159        2
#[Out]# 108  161        9
#[Out]# 109  162        8
#[Out]# 110  163        4
#[Out]# 111  165        6
#[Out]# 112  167       10
#[Out]# 113  168        1
#[Out]# 114  169       11
#[Out]# 115  170        3
#[Out]# 116  171        2
#[Out]# 117  172        2
#[Out]# 118  175        2
#[Out]# 119  176        6
#[Out]# 120  177        5
#[Out]# 121  178        2
#[Out]# 122  179        6
#[Out]# 123  180        2
#[Out]# 124  181        3
#[Out]# 125  182        3
#[Out]# 126  184        1
#[Out]# 127  185        1
#[Out]# 128  186        1
#[Out]# 129  188        1
#[Out]# 130  189        2
#[Out]# 131  190       64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select *
    from storecount
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    value
#[Out]# 0     64
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select cID
    from custstores cs, storecount sc
    where cs.counter = sc.value
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select cID
    from custstores cs, storecount sc
    where cs.counter = sc.value -1 
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select cID
    from custstores cs, storecount sc
    where cs.counter = sc.value -2
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select cID
    from custstores cs, storecount sc
    where cs.counter = sc.value -3
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select cID
    from custstores cs, storecount sc
    where cs.counter = cs.counter
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      7
#[Out]# 7      8
#[Out]# 8     10
#[Out]# 9     11
#[Out]# 10    13
#[Out]# 11    15
#[Out]# 12    16
#[Out]# 13    17
#[Out]# 14    18
#[Out]# 15    19
#[Out]# 16    20
#[Out]# 17    21
#[Out]# 18    22
#[Out]# 19    24
#[Out]# 20    25
#[Out]# 21    26
#[Out]# 22    27
#[Out]# 23    28
#[Out]# 24    29
#[Out]# 25    30
#[Out]# 26    31
#[Out]# 27    33
#[Out]# 28    34
#[Out]# 29    35
#[Out]# ..   ...
#[Out]# 102  147
#[Out]# 103  149
#[Out]# 104  151
#[Out]# 105  152
#[Out]# 106  157
#[Out]# 107  159
#[Out]# 108  161
#[Out]# 109  162
#[Out]# 110  163
#[Out]# 111  165
#[Out]# 112  167
#[Out]# 113  168
#[Out]# 114  169
#[Out]# 115  170
#[Out]# 116  171
#[Out]# 117  172
#[Out]# 118  175
#[Out]# 119  176
#[Out]# 120  177
#[Out]# 121  178
#[Out]# 122  179
#[Out]# 123  180
#[Out]# 124  181
#[Out]# 125  182
#[Out]# 126  184
#[Out]# 127  185
#[Out]# 128  186
#[Out]# 129  188
#[Out]# 130  189
#[Out]# 131  190
#[Out]# 
#[Out]# [132 rows x 1 columns]
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select *
    from storecount
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    value
#[Out]# 0     64
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select *
    from custstores
    
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  counter
#[Out]# 0      0        1
#[Out]# 1      1        7
#[Out]# 2      2        5
#[Out]# 3      3        3
#[Out]# 4      4        6
#[Out]# 5      5        6
#[Out]# 6      7        6
#[Out]# 7      8        2
#[Out]# 8     10        1
#[Out]# 9     11        1
#[Out]# 10    13        7
#[Out]# 11    15        1
#[Out]# 12    16       10
#[Out]# 13    17        2
#[Out]# 14    18        3
#[Out]# 15    19        4
#[Out]# 16    20        3
#[Out]# 17    21        3
#[Out]# 18    22        2
#[Out]# 19    24        9
#[Out]# 20    25        1
#[Out]# 21    26        1
#[Out]# 22    27        5
#[Out]# 23    28        1
#[Out]# 24    29        2
#[Out]# 25    30        3
#[Out]# 26    31        2
#[Out]# 27    33        9
#[Out]# 28    34        1
#[Out]# 29    35        2
#[Out]# ..   ...      ...
#[Out]# 102  147        3
#[Out]# 103  149        2
#[Out]# 104  151        2
#[Out]# 105  152        3
#[Out]# 106  157        2
#[Out]# 107  159        2
#[Out]# 108  161        9
#[Out]# 109  162        8
#[Out]# 110  163        4
#[Out]# 111  165        6
#[Out]# 112  167       10
#[Out]# 113  168        1
#[Out]# 114  169       11
#[Out]# 115  170        3
#[Out]# 116  171        2
#[Out]# 117  172        2
#[Out]# 118  175        2
#[Out]# 119  176        6
#[Out]# 120  177        5
#[Out]# 121  178        2
#[Out]# 122  179        6
#[Out]# 123  180        2
#[Out]# 124  181        3
#[Out]# 125  182        3
#[Out]# 126  184        1
#[Out]# 127  185        1
#[Out]# 128  186        1
#[Out]# 129  188        1
#[Out]# 130  189        2
#[Out]# 131  190       64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select cID
    from custstores cs, storecount sc
    where cs.counter = storecount.value
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select cID
    from custstores cs, storecount sc
    where cs.counter = storecount.value
    
'''

pd.read_sql_query(query3, conn)
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select cID
    from custstores cs, storecount sc
    where cs.counter = sc.value
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select *
    from custstores
    
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  counter
#[Out]# 0      0        1
#[Out]# 1      1        7
#[Out]# 2      2        5
#[Out]# 3      3        3
#[Out]# 4      4        6
#[Out]# 5      5        6
#[Out]# 6      7        6
#[Out]# 7      8        2
#[Out]# 8     10        1
#[Out]# 9     11        1
#[Out]# 10    13        7
#[Out]# 11    15        1
#[Out]# 12    16       10
#[Out]# 13    17        2
#[Out]# 14    18        3
#[Out]# 15    19        4
#[Out]# 16    20        3
#[Out]# 17    21        3
#[Out]# 18    22        2
#[Out]# 19    24        9
#[Out]# 20    25        1
#[Out]# 21    26        1
#[Out]# 22    27        5
#[Out]# 23    28        1
#[Out]# 24    29        2
#[Out]# 25    30        3
#[Out]# 26    31        2
#[Out]# 27    33        9
#[Out]# 28    34        1
#[Out]# 29    35        2
#[Out]# ..   ...      ...
#[Out]# 102  147        3
#[Out]# 103  149        2
#[Out]# 104  151        2
#[Out]# 105  152        3
#[Out]# 106  157        2
#[Out]# 107  159        2
#[Out]# 108  161        9
#[Out]# 109  162        8
#[Out]# 110  163        4
#[Out]# 111  165        6
#[Out]# 112  167       10
#[Out]# 113  168        1
#[Out]# 114  169       11
#[Out]# 115  170        3
#[Out]# 116  171        2
#[Out]# 117  172        2
#[Out]# 118  175        2
#[Out]# 119  176        6
#[Out]# 120  177        5
#[Out]# 121  178        2
#[Out]# 122  179        6
#[Out]# 123  180        2
#[Out]# 124  181        3
#[Out]# 125  182        3
#[Out]# 126  184        1
#[Out]# 127  185        1
#[Out]# 128  186        1
#[Out]# 129  188        1
#[Out]# 130  189        2
#[Out]# 131  190       64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select cID
    from custstores cs, storecount sc
    where cs.counter = sc.value
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1
    )
    
    select *
    from storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 0
    )
    
    select *
    from storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 2
    )
    
    select *
    from storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 0
    )
    
    select *
    from storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with storeChains as (
        select sName, count(distinct sID)
        from store
        group by sName
        having count(distinct sID) > 0
    )
    
    select *
    from storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  count(distinct sID)
#[Out]# 0  Albert Hein                    8
#[Out]# 1         Coop                   14
#[Out]# 2         Dirk                    6
#[Out]# 3    Hoogvliet                    9
#[Out]# 4        Jumbo                    8
#[Out]# 5         Lidl                   10
#[Out]# 6       Sligro                    9
query4 = '''
    with storeChains as (
        select sName, count(distinct sID)
        from store
        group by sName
    )
    
    select *
    from storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  count(distinct sID)
#[Out]# 0  Albert Hein                    8
#[Out]# 1         Coop                   14
#[Out]# 2         Dirk                    6
#[Out]# 3    Hoogvliet                    9
#[Out]# 4        Jumbo                    8
#[Out]# 5         Lidl                   10
#[Out]# 6       Sligro                    9
query4 = '''
    with storeChains as (
        select sName, count(distinct sID)
        from store
        group by sName
        having count(distinct sID) > 8
    )
    
    select *
    from storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#        sName  count(distinct sID)
#[Out]# 0       Coop                   14
#[Out]# 1  Hoogvliet                    9
#[Out]# 2       Lidl                   10
#[Out]# 3     Sligro                    9
query4 = '''
    with storeChains as (
        select sName, count(distinct sID)
        from store
        group by sName
        having count(distinct sID) > 1
    )
    
    select *
    from storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  count(distinct sID)
#[Out]# 0  Albert Hein                    8
#[Out]# 1         Coop                   14
#[Out]# 2         Dirk                    6
#[Out]# 3    Hoogvliet                    9
#[Out]# 4        Jumbo                    8
#[Out]# 5         Lidl                   10
#[Out]# 6       Sligro                    9
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1
    )
    
    select *
    from storeChains
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1
    ),
      
    select sc.sName
    from storeChains sc, store s, purchase p
    where sc.sName = s.sName
    and s.sID = p.sID
    group by sc.sID
    having avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1
    )
      
    select sc.sName
    from storeChains sc, store s, purchase p
    where sc.sName = s.sName
    and s.sID = p.sID
    group by sc.sID
    having avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1
    )
      
    select sc.sName
    from storeChains sc, store s, purchase p
    where sc.sName = s.sName
    and s.sID = p.sID
    group by sc.sName
    having avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1
    )
      
    select sc.sName
    from storeChains sc, store s, purchase p
    where sc.sName = s.sName
    and s.sID = p.sID
    group by sc.sName
    having avg(p.quantity) > 5
'''

pd.read_sql_query(query4, conn)
#[Out]#        sName
#[Out]# 0       Dirk
#[Out]# 1  Hoogvliet
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1
    )
      
    select sc.sName
    from storeChains sc, store s, purchase p
    where sc.sName = s.sName
    and s.sID = p.sID
    group by sc.sName
    having avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1
    )
      
    select sc.sName
    from storeChains sc, store s, purchase p
    where sc.sName = s.sName
    and s.sID = p.sID
    group by sc.sName
    having avg(p.quantity) > 3
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1
    )
      
    select sc.sName
    from storeChains sc, store s, purchase p
    where sc.sName = s.sName
    and s.sID = p.sID
    group by sc.sName
    having avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    select p.pName, s.sName
    from product p, store s, purchase pur
    where p.pID = pur.pID
    and pur.sID = s.sID
    and pur.price = max(pur.price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select p.pName, s.sName
    from product p, store s, purchase pur
    where p.pID = pur.pID
    and pur.sID = s.sID
    and pur.price in (
        select max(price)
        from purchase
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    select p.pname, s.sName, pur.price
    from product p, store s, purchase pur
    where p.pID = pur.pID
    and pur.sID = s.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#                 pName        sName  price
#[Out]# 0               Water       Sligro   0.45
#[Out]# 1              Apples         Dirk   4.65
#[Out]# 2                Rice       Sligro   1.60
#[Out]# 3             Bananas    Hoogvliet   1.25
#[Out]# 4              Donuts  Albert Hein   3.95
#[Out]# 5               Pasta         Lidl   2.75
#[Out]# 6                Milk         Lidl   0.90
#[Out]# 7               Pizza         Lidl   9.10
#[Out]# 8               Fanta         Lidl   2.45
#[Out]# 9             Bananas       Sligro   1.35
#[Out]# 10             Onions         Coop   1.10
#[Out]# 11               Eggs         Coop   3.70
#[Out]# 12                Tea         Coop   1.55
#[Out]# 13             Apples  Albert Hein   4.30
#[Out]# 14              Pasta         Dirk   2.75
#[Out]# 15            Bananas       Sligro   1.45
#[Out]# 16   Hot Dog Sausages    Hoogvliet   4.15
#[Out]# 17              Pizza        Jumbo   9.05
#[Out]# 18               Beef         Coop  13.60
#[Out]# 19            Carrots         Coop   1.05
#[Out]# 20               Eggs       Sligro   3.05
#[Out]# 21              Pasta  Albert Hein   2.75
#[Out]# 22             Apples    Hoogvliet   4.70
#[Out]# 23            Lasanga         Lidl   8.25
#[Out]# 24            Carrots         Coop   1.10
#[Out]# 25                Tea         Coop   1.55
#[Out]# 26               Rice         Coop   1.85
#[Out]# 27               Coca    Hoogvliet   2.20
#[Out]# 28               Coca       Sligro   2.10
#[Out]# 29           Potatoes         Lidl   1.70
#[Out]# ..                ...          ...    ...
#[Out]# 479           Lasanga         Coop   2.80
#[Out]# 480             Pizza         Lidl   0.50
#[Out]# 481         Mushrooms         Lidl   2.55
#[Out]# 482           Lasanga        Jumbo   0.65
#[Out]# 483          Tomatoes    Hoogvliet   0.70
#[Out]# 484       Cashew Nuts       Sligro   3.70
#[Out]# 485              Milk    Hoogvliet   3.50
#[Out]# 486           Carrots  Albert Hein   2.95
#[Out]# 487              Coca       Sligro   2.75
#[Out]# 488             Bread         Coop   1.50
#[Out]# 489           Bananas  Albert Hein   0.85
#[Out]# 490              Milk         Coop   3.55
#[Out]# 491               Tea         Lidl   2.60
#[Out]# 492             Bread         Coop   3.25
#[Out]# 493             Fanta    Hoogvliet   4.30
#[Out]# 494              Milk    Hoogvliet   3.05
#[Out]# 495            Coffee       Sligro   4.05
#[Out]# 496   Spiced Biscuits         Coop   1.50
#[Out]# 497   Spiced Biscuits         Lidl   2.50
#[Out]# 498  Hot Dog Sausages         Coop   3.95
#[Out]# 499       Cashew Nuts         Dirk   3.50
#[Out]# 500  Hot Dog Sausages         Coop   2.95
#[Out]# 501              Milk        Jumbo   1.60
#[Out]# 502         Cucumbers         Dirk   3.25
#[Out]# 503          Potatoes         Dirk   0.75
#[Out]# 504             Bread        Jumbo   3.80
#[Out]# 505         Mushrooms         Lidl   4.35
#[Out]# 506              Coca         Lidl   2.85
#[Out]# 507           Bananas        Jumbo   3.15
#[Out]# 508            Cheese        Jumbo   3.30
#[Out]# 
#[Out]# [509 rows x 3 columns]
query6 = '''
    select p.pname, s.sName, pur.price
    from product p, store s, purchase pur
    where p.pID = pur.pID
    and pur.sID = s.sID
    pur.price > 10
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select p.pname, s.sName, pur.price
    from product p, store s, purchase pur
    where p.pID = pur.pID
    and pur.sID = s.sID
    and pur.price > 10
'''

pd.read_sql_query(query6, conn)
#[Out]#      pName        sName  price
#[Out]# 0     Beef         Coop  13.60
#[Out]# 1     Beef  Albert Hein  10.75
#[Out]# 2   Cheese  Albert Hein  11.55
#[Out]# 3     Beef         Dirk  11.45
#[Out]# 4     Beef         Dirk  12.80
#[Out]# 5   Cheese         Coop  10.30
#[Out]# 6   Cheese         Coop  10.60
#[Out]# 7     Beef       Sligro  13.80
#[Out]# 8   Cheese       Sligro  10.50
#[Out]# 9   Cheese  Albert Hein  12.00
#[Out]# 10    Beef       Sligro  13.40
#[Out]# 11    Beef       Sligro  12.65
#[Out]# 12    Beef         Coop  11.20
#[Out]# 13    Beef       Sligro  13.65
#[Out]# 14    Beef    Hoogvliet  12.20
#[Out]# 15    Beef         Dirk  12.55
#[Out]# 16    Beef         Coop  10.15
#[Out]# 17    Beef         Dirk  11.65
#[Out]# 18    Beef  Albert Hein  13.25
#[Out]# 19    Beef    Hoogvliet  12.30
#[Out]# 20    Beef  Albert Hein  13.15
query6 = '''
    select distinct p.pname, s.sName, pur.price
    from product p, store s, purchase pur
    where p.pID = pur.pID
    and pur.sID = s.sID
    and pur.price > 10
'''

pd.read_sql_query(query6, conn)
#[Out]#      pName        sName  price
#[Out]# 0     Beef         Coop  13.60
#[Out]# 1     Beef  Albert Hein  10.75
#[Out]# 2   Cheese  Albert Hein  11.55
#[Out]# 3     Beef         Dirk  11.45
#[Out]# 4     Beef         Dirk  12.80
#[Out]# 5   Cheese         Coop  10.30
#[Out]# 6   Cheese         Coop  10.60
#[Out]# 7     Beef       Sligro  13.80
#[Out]# 8   Cheese       Sligro  10.50
#[Out]# 9   Cheese  Albert Hein  12.00
#[Out]# 10    Beef       Sligro  13.40
#[Out]# 11    Beef       Sligro  12.65
#[Out]# 12    Beef         Coop  11.20
#[Out]# 13    Beef       Sligro  13.65
#[Out]# 14    Beef    Hoogvliet  12.20
#[Out]# 15    Beef         Dirk  12.55
#[Out]# 16    Beef         Coop  10.15
#[Out]# 17    Beef         Dirk  11.65
#[Out]# 18    Beef  Albert Hein  13.25
#[Out]# 19    Beef    Hoogvliet  12.30
#[Out]# 20    Beef  Albert Hein  13.15
query6 = '''
    select p.pname, s.sName, pur.price
    from product p, store s, purchase pur
    where p.pID = pur.pID
    and pur.sID = s.sID
    and pur.price > 10
'''

pd.read_sql_query(query6, conn)
#[Out]#      pName        sName  price
#[Out]# 0     Beef         Coop  13.60
#[Out]# 1     Beef  Albert Hein  10.75
#[Out]# 2   Cheese  Albert Hein  11.55
#[Out]# 3     Beef         Dirk  11.45
#[Out]# 4     Beef         Dirk  12.80
#[Out]# 5   Cheese         Coop  10.30
#[Out]# 6   Cheese         Coop  10.60
#[Out]# 7     Beef       Sligro  13.80
#[Out]# 8   Cheese       Sligro  10.50
#[Out]# 9   Cheese  Albert Hein  12.00
#[Out]# 10    Beef       Sligro  13.40
#[Out]# 11    Beef       Sligro  12.65
#[Out]# 12    Beef         Coop  11.20
#[Out]# 13    Beef       Sligro  13.65
#[Out]# 14    Beef    Hoogvliet  12.20
#[Out]# 15    Beef         Dirk  12.55
#[Out]# 16    Beef         Coop  10.15
#[Out]# 17    Beef         Dirk  11.65
#[Out]# 18    Beef  Albert Hein  13.25
#[Out]# 19    Beef    Hoogvliet  12.30
#[Out]# 20    Beef  Albert Hein  13.15
query6 = '''
    select p.pname, distinct s.sName, pur.price
    from product p, store s, purchase pur
    where p.pID = pur.pID
    and pur.sID = s.sID
    and pur.price > 10
'''

pd.read_sql_query(query6, conn)
query2 = '''
    select distinct c.cID, c.cName
    from customer c, purchase p1, purchase p2, product prod1, product prod2
    where c.cID = p1.cID
    and p1.cID = p2.cID
    and p1.date = p2.date
    and p1.pID = prod1.pID
    and prod1.pName = 'Onions'
    and p2.pID = prod2.pID
    and prod2.pName = 'Coffee'
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query1 = '''
    select distinct pID
    from purchase
    group by pID
    having (count(distinct cID) <= 2)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query3 = '''
    with 
    custstores(cID, counter) as (
        select cID, count(distinct sID)
        from purchase
        group by cID
    ),
    
    storecount(value) as (
        select count(distinct sID)
        from store
    )
    
    select distinct cID
    from custstores cs, storecount sc
    where cs.counter = sc.value
    
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    with storeChains as (
        select sName
        from store
        group by sName
        having count(distinct sID) > 1
    )
      
    select distinct sc.sName
    from storeChains sc, store s, purchase p
    where sc.sName = s.sName
    and s.sID = p.sID
    group by sc.sName
    having avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    select distinct p.pName, s.sName
    from product p, store s, purchase pur
    where p.pID = pur.pID
    and pur.sID = s.sID
    and pur.price in (
        select max(price)
        from purchase
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    select p.pname, s.sName, pur.price
    from product p, store s, purchase pur
    where p.pID = pur.pID
    and pur.sID = s.sID
    and pur.price > 10
'''

pd.read_sql_query(query6, conn)
#[Out]#      pName        sName  price
#[Out]# 0     Beef         Coop  13.60
#[Out]# 1     Beef  Albert Hein  10.75
#[Out]# 2   Cheese  Albert Hein  11.55
#[Out]# 3     Beef         Dirk  11.45
#[Out]# 4     Beef         Dirk  12.80
#[Out]# 5   Cheese         Coop  10.30
#[Out]# 6   Cheese         Coop  10.60
#[Out]# 7     Beef       Sligro  13.80
#[Out]# 8   Cheese       Sligro  10.50
#[Out]# 9   Cheese  Albert Hein  12.00
#[Out]# 10    Beef       Sligro  13.40
#[Out]# 11    Beef       Sligro  12.65
#[Out]# 12    Beef         Coop  11.20
#[Out]# 13    Beef       Sligro  13.65
#[Out]# 14    Beef    Hoogvliet  12.20
#[Out]# 15    Beef         Dirk  12.55
#[Out]# 16    Beef         Coop  10.15
#[Out]# 17    Beef         Dirk  11.65
#[Out]# 18    Beef  Albert Hein  13.25
#[Out]# 19    Beef    Hoogvliet  12.30
#[Out]# 20    Beef  Albert Hein  13.15
query6 = '''
    with priceDiff(pID, diff) as (
        select pID, max(unit_price) - min(unit_price)
        from inventory
    )
    
    select *
    from priceDiff
'''

pd.read_sql_query(query6, conn)
#[Out]#    pID  diff
#[Out]# 0   10  14.5
query6 = '''
    with priceDiff(pID, diff) as (
        select pID, max(unit_price)
        from inventory
    )
    
    select *
    from priceDiff
'''

pd.read_sql_query(query6, conn)
#[Out]#    pID  diff
#[Out]# 0   12  14.9
query6 = '''
    with priceDiff(pID, diff) as (
        select pID, min(unit_price)
        from inventory
    )
    
    select *
    from priceDiff
'''

pd.read_sql_query(query6, conn)
#[Out]#    pID  diff
#[Out]# 0   10   0.4
query6 = '''
    with priceDiff(pID, date, max, min, diff) as (
        select i1.pID, i1.date, max(i1.unit_price), min(i2.unit_price)
        from inventory i1, inventory i2
    )
    
    select *
    from priceDiff
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with priceDiff(pID, date, max, min, diff) as (
        select i1.pID, i1.date, max(i1.unit_price), min(i2.unit_price), max(i1.unit_price) - min(i1.unit_price)
        from inventory i1, inventory i2
    )
    
    select *
    from priceDiff
'''

pd.read_sql_query(query6, conn)
#[Out]#    pID        date   max  min  diff
#[Out]# 0   10  2018-08-16  14.9  0.4  14.5
query6 = '''
    with priceDiff(pID, date, max, min, diff) as (
        select i1.pID, i1.date, max(i1.unit_price), min(i2.unit_price), max(i1.unit_price) - min(i1.unit_price)
        from inventory i1, inventory i2
        where i1.date = '2018-08-23'
    )
    
    select *
    from priceDiff
'''

pd.read_sql_query(query6, conn)
#[Out]#    pID        date   max  min   diff
#[Out]# 0    5  2018-08-23  13.4  0.4  12.95
query6 = '''
    with priceDiff(pID, date, diff) as (
        select i1.pID, i1.date, max(i1.unit_price) - min(i1.unit_price)
        from inventory i1
        where i1.date = '2018-08-23'
    )
    
    select *
    from priceDiff
'''

pd.read_sql_query(query6, conn)
#[Out]#    pID        date   diff
#[Out]# 0   10  2018-08-23  12.95
query6 = '''
    with priceDiff(pID, date, diff) as (
        select i1.pID, i1.date, max(i1.unit_price) - min(i1.unit_price)
        from inventory i1
        group by pID
    )
    
    select *
    from priceDiff
'''

pd.read_sql_query(query6, conn)
#[Out]#     pID        date  diff
#[Out]# 0     0  2018-08-24  2.25
#[Out]# 1     1  2018-08-23  2.15
#[Out]# 2     2  2018-08-18  0.70
#[Out]# 3     3  2018-08-27  0.60
#[Out]# 4     4  2018-08-18  0.40
#[Out]# 5     5  2018-08-24  0.20
#[Out]# 6     6  2018-08-15  0.30
#[Out]# 7     7  2018-08-26  0.80
#[Out]# 8     8  2018-08-15  1.65
#[Out]# 9     9  2018-08-25  0.60
#[Out]# 10   10  2018-08-16  0.20
#[Out]# 11   11  2018-08-21  0.40
#[Out]# 12   12  2018-08-17  4.75
#[Out]# 13   13  2018-08-19  1.35
#[Out]# 14   14  2018-08-21  1.55
#[Out]# 15   15  2018-08-21  0.40
#[Out]# 16   16  2018-08-19  0.70
#[Out]# 17   17  2018-08-18  0.85
#[Out]# 18   18  2018-08-19  3.45
#[Out]# 19   19  2018-07-10  1.25
#[Out]# 20   20  2018-08-17  0.85
#[Out]# 21   21  2018-08-22  0.75
#[Out]# 22   22  2018-08-18  0.70
#[Out]# 23   23  2018-08-23  0.80
#[Out]# 24   24  2018-08-16  1.35
#[Out]# 25   25  2018-08-18  1.45
#[Out]# 26   26  2018-08-25  1.10
#[Out]# 27   27  2018-08-24  2.80
#[Out]# 28   28  2018-08-23  3.20
query6 = '''
    with priceDiff(pID, date, diff) as (
        select i1.pID, i1.date
        from inventory i1
        group by pID
    )
    
    select *
    from priceDiff
'''

pd.read_sql_query(query6, conn)
query6 = '''
    with priceDiff(pID, date) as (
        select i1.pID, i1.date
        from inventory i1
        group by pID
    )
    
    select *
    from priceDiff
'''

pd.read_sql_query(query6, conn)
#[Out]#     pID        date
#[Out]# 0     0  2018-07-18
#[Out]# 1     1  2018-08-17
#[Out]# 2     2  2018-08-18
#[Out]# 3     3  2018-08-28
#[Out]# 4     4  2018-08-22
#[Out]# 5     5  2018-08-26
#[Out]# 6     6  2018-08-22
#[Out]# 7     7  2018-08-20
#[Out]# 8     8  2018-08-23
#[Out]# 9     9  2018-08-24
#[Out]# 10   10  2018-08-20
#[Out]# 11   11  2018-08-24
#[Out]# 12   12  2018-08-23
#[Out]# 13   13  2018-08-23
#[Out]# 14   14  2018-08-24
#[Out]# 15   15  2018-08-18
#[Out]# 16   16  2018-08-22
#[Out]# 17   17  2018-08-24
#[Out]# 18   18  2018-08-21
#[Out]# 19   19  2018-07-10
#[Out]# 20   20  2018-08-27
#[Out]# 21   21  2018-08-27
#[Out]# 22   22  2018-08-16
#[Out]# 23   23  2018-08-19
#[Out]# 24   24  2018-08-25
#[Out]# 25   25  2018-08-27
#[Out]# 26   26  2018-08-24
#[Out]# 27   27  2018-08-22
#[Out]# 28   28  2018-08-19
query6 = '''
    select *
    from inventory
'''

pd.read_sql_query(query6, conn)
#[Out]#      sID  pID        date  quantity  unit_price
#[Out]# 0     55   10  2018-08-26        17        0.60
#[Out]# 1     25   12  2018-08-24        30       14.80
#[Out]# 2     15    6  2018-08-26        13        1.15
#[Out]# 3      6   27  2018-08-19        51        7.30
#[Out]# 4     57    2  2018-08-22        24        2.05
#[Out]# 5     33    8  2018-08-19        46        5.70
#[Out]# 6     51   10  2018-08-23        31        0.60
#[Out]# 7     50   21  2018-08-22        32        1.90
#[Out]# 8      0   13  2018-08-25        13        3.05
#[Out]# 9     36    8  2018-08-27        11        5.05
#[Out]# 10    36   23  2018-08-18        35        2.20
#[Out]# 11    54   10  2018-08-24        16        0.55
#[Out]# 12    59    1  2018-08-26        36        6.20
#[Out]# 13     9   19  2018-08-22        28        2.50
#[Out]# 14    33    7  2018-08-26         5        1.60
#[Out]# 15    35   10  2018-08-21        51        0.55
#[Out]# 16     0   21  2018-08-15         0        2.20
#[Out]# 17    31   14  2018-08-17        10        4.50
#[Out]# 18    19   14  2018-08-20        42        4.70
#[Out]# 19    33   20  2018-08-21        51        2.15
#[Out]# 20    17   24  2018-08-16        44        2.85
#[Out]# 21     4   27  2018-08-18        27        9.00
#[Out]# 22     3   25  2018-08-27        24        4.60
#[Out]# 23    22   15  2018-08-20         4        1.30
#[Out]# 24    52   14  2018-08-18        44        4.25
#[Out]# 25    24   26  2018-08-25        18        2.90
#[Out]# 26     7   12  2018-08-20        13       12.55
#[Out]# 27    32   18  2018-08-21        41       11.85
#[Out]# 28    48   24  2018-08-19        10        3.20
#[Out]# 29    54    8  2018-08-17         3        5.55
#[Out]# ..   ...  ...         ...       ...         ...
#[Out]# 799   35    0  2018-08-25         1        4.35
#[Out]# 800   19   11  2018-08-25         9        0.90
#[Out]# 801    4   21  2018-08-25         9        2.15
#[Out]# 802    6    5  2018-08-26         6        0.50
#[Out]# 803   47   18  2018-08-20        12        8.85
#[Out]# 804   38   17  2018-08-20        10        2.30
#[Out]# 805   11    3  2018-08-21        15        1.30
#[Out]# 806   34   26  2018-08-21        14        3.40
#[Out]# 807   34   25  2018-08-27        17        3.60
#[Out]# 808   25   14  2018-08-24         3        3.70
#[Out]# 809   24   11  2018-08-24         1        0.85
#[Out]# 810   57   17  2018-08-24         4        2.40
#[Out]# 811   43   27  2018-08-22        15        9.00
#[Out]# 812   35   16  2018-08-22         8        1.85
#[Out]# 813   45   10  2018-08-22        21        0.45
#[Out]# 814   34   26  2018-08-26         9        3.10
#[Out]# 815   34   13  2018-08-26         3        4.05
#[Out]# 816   56   10  2018-08-27         1        0.60
#[Out]# 817    6   26  2018-08-24        13        2.70
#[Out]# 818   45    6  2018-08-24         9        0.90
#[Out]# 819   27   21  2018-08-27         1        2.00
#[Out]# 820   17   25  2018-08-27        14        3.90
#[Out]# 821    5   18  2018-08-28         1        9.70
#[Out]# 822    5    3  2018-08-28        13        1.30
#[Out]# 823    4   13  2018-08-23        23        4.20
#[Out]# 824   27   10  2018-08-20         7        0.55
#[Out]# 825   45   18  2018-08-21         5        9.20
#[Out]# 826   57    6  2018-08-22         9        1.15
#[Out]# 827   60   19  2018-07-10       525        1.75
#[Out]# 828    0    0  2018-07-18        15        5.95
#[Out]# 
#[Out]# [829 rows x 5 columns]
query6 = '''
    select *
    from inventory i1, inventory i2
    where i1.pID = i2.pID
    and i1.date = i2.date
'''

pd.read_sql_query(query6, conn)
#[Out]#       sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0      55   10  2018-08-26        17        0.60   18   10  2018-08-26   
#[Out]# 1      55   10  2018-08-26        17        0.60   24   10  2018-08-26   
#[Out]# 2      55   10  2018-08-26        17        0.60   45   10  2018-08-26   
#[Out]# 3      55   10  2018-08-26        17        0.60   55   10  2018-08-26   
#[Out]# 4      25   12  2018-08-24        30       14.80    4   12  2018-08-24   
#[Out]# 5      25   12  2018-08-24        30       14.80   25   12  2018-08-24   
#[Out]# 6      25   12  2018-08-24        30       14.80   32   12  2018-08-24   
#[Out]# 7      25   12  2018-08-24        30       14.80   50   12  2018-08-24   
#[Out]# 8      25   12  2018-08-24        30       14.80   53   12  2018-08-24   
#[Out]# 9      15    6  2018-08-26        13        1.15   15    6  2018-08-26   
#[Out]# 10     15    6  2018-08-26        13        1.15   39    6  2018-08-26   
#[Out]# 11      6   27  2018-08-19        51        7.30    6   27  2018-08-19   
#[Out]# 12      6   27  2018-08-19        51        7.30   26   27  2018-08-19   
#[Out]# 13     57    2  2018-08-22        24        2.05   46    2  2018-08-22   
#[Out]# 14     57    2  2018-08-22        24        2.05   57    2  2018-08-22   
#[Out]# 15     33    8  2018-08-19        46        5.70   33    8  2018-08-19   
#[Out]# 16     51   10  2018-08-23        31        0.60   34   10  2018-08-23   
#[Out]# 17     51   10  2018-08-23        31        0.60   50   10  2018-08-23   
#[Out]# 18     51   10  2018-08-23        31        0.60   51   10  2018-08-23   
#[Out]# 19     50   21  2018-08-22        32        1.90    3   21  2018-08-22   
#[Out]# 20     50   21  2018-08-22        32        1.90   17   21  2018-08-22   
#[Out]# 21     50   21  2018-08-22        32        1.90   32   21  2018-08-22   
#[Out]# 22     50   21  2018-08-22        32        1.90   50   21  2018-08-22   
#[Out]# 23      0   13  2018-08-25        13        3.05    0   13  2018-08-25   
#[Out]# 24      0   13  2018-08-25        13        3.05   27   13  2018-08-25   
#[Out]# 25      0   13  2018-08-25        13        3.05   35   13  2018-08-25   
#[Out]# 26      0   13  2018-08-25        13        3.05   46   13  2018-08-25   
#[Out]# 27      0   13  2018-08-25        13        3.05   55   13  2018-08-25   
#[Out]# 28     36    8  2018-08-27        11        5.05   36    8  2018-08-27   
#[Out]# 29     36   23  2018-08-18        35        2.20   36   23  2018-08-18   
#[Out]# ...   ...  ...         ...       ...         ...  ...  ...         ...   
#[Out]# 2537   56   10  2018-08-27         1        0.60   43   10  2018-08-27   
#[Out]# 2538   56   10  2018-08-27         1        0.60   56   10  2018-08-27   
#[Out]# 2539    6   26  2018-08-24        13        2.70    6   26  2018-08-24   
#[Out]# 2540    6   26  2018-08-24        13        2.70    7   26  2018-08-24   
#[Out]# 2541   45    6  2018-08-24         9        0.90    4    6  2018-08-24   
#[Out]# 2542   45    6  2018-08-24         9        0.90   21    6  2018-08-24   
#[Out]# 2543   45    6  2018-08-24         9        0.90   45    6  2018-08-24   
#[Out]# 2544   27   21  2018-08-27         1        2.00   27   21  2018-08-27   
#[Out]# 2545   17   25  2018-08-27        14        3.90    3   25  2018-08-27   
#[Out]# 2546   17   25  2018-08-27        14        3.90   16   25  2018-08-27   
#[Out]# 2547   17   25  2018-08-27        14        3.90   17   25  2018-08-27   
#[Out]# 2548   17   25  2018-08-27        14        3.90   22   25  2018-08-27   
#[Out]# 2549   17   25  2018-08-27        14        3.90   34   25  2018-08-27   
#[Out]# 2550    5   18  2018-08-28         1        9.70    5   18  2018-08-28   
#[Out]# 2551    5    3  2018-08-28        13        1.30    5    3  2018-08-28   
#[Out]# 2552    4   13  2018-08-23        23        4.20    4   13  2018-08-23   
#[Out]# 2553    4   13  2018-08-23        23        4.20   12   13  2018-08-23   
#[Out]# 2554    4   13  2018-08-23        23        4.20   35   13  2018-08-23   
#[Out]# 2555    4   13  2018-08-23        23        4.20   45   13  2018-08-23   
#[Out]# 2556   27   10  2018-08-20         7        0.55    5   10  2018-08-20   
#[Out]# 2557   27   10  2018-08-20         7        0.55   27   10  2018-08-20   
#[Out]# 2558   27   10  2018-08-20         7        0.55   45   10  2018-08-20   
#[Out]# 2559   45   18  2018-08-21         5        9.20   32   18  2018-08-21   
#[Out]# 2560   45   18  2018-08-21         5        9.20   44   18  2018-08-21   
#[Out]# 2561   45   18  2018-08-21         5        9.20   45   18  2018-08-21   
#[Out]# 2562   45   18  2018-08-21         5        9.20   51   18  2018-08-21   
#[Out]# 2563   57    6  2018-08-22         9        1.15   55    6  2018-08-22   
#[Out]# 2564   57    6  2018-08-22         9        1.15   57    6  2018-08-22   
#[Out]# 2565   60   19  2018-07-10       525        1.75   60   19  2018-07-10   
#[Out]# 2566    0    0  2018-07-18        15        5.95    0    0  2018-07-18   
#[Out]# 
#[Out]#       quantity  unit_price  
#[Out]# 0           16        0.50  
#[Out]# 1           19        0.55  
#[Out]# 2           54        0.50  
#[Out]# 3           17        0.60  
#[Out]# 4           38       10.20  
#[Out]# 5           30       14.80  
#[Out]# 6           15       10.75  
#[Out]# 7           38       13.10  
#[Out]# 8            3       13.60  
#[Out]# 9           13        1.15  
#[Out]# 10          20        1.05  
#[Out]# 11          51        7.30  
#[Out]# 12          12        9.25  
#[Out]# 13          19        1.80  
#[Out]# 14          24        2.05  
#[Out]# 15          46        5.70  
#[Out]# 16           8        0.45  
#[Out]# 17          54        0.55  
#[Out]# 18          31        0.60  
#[Out]# 19           0        2.25  
#[Out]# 20          21        2.30  
#[Out]# 21           6        1.60  
#[Out]# 22          32        1.90  
#[Out]# 23          13        3.05  
#[Out]# 24           2        4.00  
#[Out]# 25          13        3.10  
#[Out]# 26          10        3.50  
#[Out]# 27           1        3.85  
#[Out]# 28          11        5.05  
#[Out]# 29          35        2.20  
#[Out]# ...        ...         ...  
#[Out]# 2537        12        0.50  
#[Out]# 2538         1        0.60  
#[Out]# 2539        13        2.70  
#[Out]# 2540        16        2.85  
#[Out]# 2541         0        1.10  
#[Out]# 2542         8        1.05  
#[Out]# 2543         9        0.90  
#[Out]# 2544         1        2.00  
#[Out]# 2545        24        4.60  
#[Out]# 2546        42        3.55  
#[Out]# 2547        14        3.90  
#[Out]# 2548        32        4.60  
#[Out]# 2549        17        3.60  
#[Out]# 2550         1        9.70  
#[Out]# 2551        13        1.30  
#[Out]# 2552        23        4.20  
#[Out]# 2553        15        3.55  
#[Out]# 2554        28        4.15  
#[Out]# 2555        32        4.10  
#[Out]# 2556        11        0.50  
#[Out]# 2557         7        0.55  
#[Out]# 2558         6        0.60  
#[Out]# 2559        41       11.85  
#[Out]# 2560        46        9.65  
#[Out]# 2561         5        9.20  
#[Out]# 2562        16        9.65  
#[Out]# 2563        13        1.10  
#[Out]# 2564         9        1.15  
#[Out]# 2565       525        1.75  
#[Out]# 2566        15        5.95  
#[Out]# 
#[Out]# [2567 rows x 10 columns]
query6 = '''
    select priceDifference(pID, date, difference)
    from inventory i1, inventory i2
    where i1.pID = i2.pID
    and i1.date = i2.date
    group by pID, date
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select *
    from inventory i1, inventory i2
    where i1.pID = i2.pID
    and i1.date = i2.date
    group by pID, date
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select pID, date
    from inventory i1, inventory i2
    where i1.pID = i2.pID
    and i1.date = i2.date
    group by pID, date
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select i1.pID, i2.date
    from inventory i1, inventory i2
    where i1.pID = i2.pID
    and i1.date = i2.date
    group by pID, date
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select *
    from inventory i1, inventory i2
    where i1.pID = i2.pID
    and i1.date = i2.date
    group by pID, date
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select *
    from inventory i1, inventory i2
    where i1.pID = i2.pID
    and i1.date = i2.date
'''

pd.read_sql_query(query6, conn)
#[Out]#       sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0      55   10  2018-08-26        17        0.60   18   10  2018-08-26   
#[Out]# 1      55   10  2018-08-26        17        0.60   24   10  2018-08-26   
#[Out]# 2      55   10  2018-08-26        17        0.60   45   10  2018-08-26   
#[Out]# 3      55   10  2018-08-26        17        0.60   55   10  2018-08-26   
#[Out]# 4      25   12  2018-08-24        30       14.80    4   12  2018-08-24   
#[Out]# 5      25   12  2018-08-24        30       14.80   25   12  2018-08-24   
#[Out]# 6      25   12  2018-08-24        30       14.80   32   12  2018-08-24   
#[Out]# 7      25   12  2018-08-24        30       14.80   50   12  2018-08-24   
#[Out]# 8      25   12  2018-08-24        30       14.80   53   12  2018-08-24   
#[Out]# 9      15    6  2018-08-26        13        1.15   15    6  2018-08-26   
#[Out]# 10     15    6  2018-08-26        13        1.15   39    6  2018-08-26   
#[Out]# 11      6   27  2018-08-19        51        7.30    6   27  2018-08-19   
#[Out]# 12      6   27  2018-08-19        51        7.30   26   27  2018-08-19   
#[Out]# 13     57    2  2018-08-22        24        2.05   46    2  2018-08-22   
#[Out]# 14     57    2  2018-08-22        24        2.05   57    2  2018-08-22   
#[Out]# 15     33    8  2018-08-19        46        5.70   33    8  2018-08-19   
#[Out]# 16     51   10  2018-08-23        31        0.60   34   10  2018-08-23   
#[Out]# 17     51   10  2018-08-23        31        0.60   50   10  2018-08-23   
#[Out]# 18     51   10  2018-08-23        31        0.60   51   10  2018-08-23   
#[Out]# 19     50   21  2018-08-22        32        1.90    3   21  2018-08-22   
#[Out]# 20     50   21  2018-08-22        32        1.90   17   21  2018-08-22   
#[Out]# 21     50   21  2018-08-22        32        1.90   32   21  2018-08-22   
#[Out]# 22     50   21  2018-08-22        32        1.90   50   21  2018-08-22   
#[Out]# 23      0   13  2018-08-25        13        3.05    0   13  2018-08-25   
#[Out]# 24      0   13  2018-08-25        13        3.05   27   13  2018-08-25   
#[Out]# 25      0   13  2018-08-25        13        3.05   35   13  2018-08-25   
#[Out]# 26      0   13  2018-08-25        13        3.05   46   13  2018-08-25   
#[Out]# 27      0   13  2018-08-25        13        3.05   55   13  2018-08-25   
#[Out]# 28     36    8  2018-08-27        11        5.05   36    8  2018-08-27   
#[Out]# 29     36   23  2018-08-18        35        2.20   36   23  2018-08-18   
#[Out]# ...   ...  ...         ...       ...         ...  ...  ...         ...   
#[Out]# 2537   56   10  2018-08-27         1        0.60   43   10  2018-08-27   
#[Out]# 2538   56   10  2018-08-27         1        0.60   56   10  2018-08-27   
#[Out]# 2539    6   26  2018-08-24        13        2.70    6   26  2018-08-24   
#[Out]# 2540    6   26  2018-08-24        13        2.70    7   26  2018-08-24   
#[Out]# 2541   45    6  2018-08-24         9        0.90    4    6  2018-08-24   
#[Out]# 2542   45    6  2018-08-24         9        0.90   21    6  2018-08-24   
#[Out]# 2543   45    6  2018-08-24         9        0.90   45    6  2018-08-24   
#[Out]# 2544   27   21  2018-08-27         1        2.00   27   21  2018-08-27   
#[Out]# 2545   17   25  2018-08-27        14        3.90    3   25  2018-08-27   
#[Out]# 2546   17   25  2018-08-27        14        3.90   16   25  2018-08-27   
#[Out]# 2547   17   25  2018-08-27        14        3.90   17   25  2018-08-27   
#[Out]# 2548   17   25  2018-08-27        14        3.90   22   25  2018-08-27   
#[Out]# 2549   17   25  2018-08-27        14        3.90   34   25  2018-08-27   
#[Out]# 2550    5   18  2018-08-28         1        9.70    5   18  2018-08-28   
#[Out]# 2551    5    3  2018-08-28        13        1.30    5    3  2018-08-28   
#[Out]# 2552    4   13  2018-08-23        23        4.20    4   13  2018-08-23   
#[Out]# 2553    4   13  2018-08-23        23        4.20   12   13  2018-08-23   
#[Out]# 2554    4   13  2018-08-23        23        4.20   35   13  2018-08-23   
#[Out]# 2555    4   13  2018-08-23        23        4.20   45   13  2018-08-23   
#[Out]# 2556   27   10  2018-08-20         7        0.55    5   10  2018-08-20   
#[Out]# 2557   27   10  2018-08-20         7        0.55   27   10  2018-08-20   
#[Out]# 2558   27   10  2018-08-20         7        0.55   45   10  2018-08-20   
#[Out]# 2559   45   18  2018-08-21         5        9.20   32   18  2018-08-21   
#[Out]# 2560   45   18  2018-08-21         5        9.20   44   18  2018-08-21   
#[Out]# 2561   45   18  2018-08-21         5        9.20   45   18  2018-08-21   
#[Out]# 2562   45   18  2018-08-21         5        9.20   51   18  2018-08-21   
#[Out]# 2563   57    6  2018-08-22         9        1.15   55    6  2018-08-22   
#[Out]# 2564   57    6  2018-08-22         9        1.15   57    6  2018-08-22   
#[Out]# 2565   60   19  2018-07-10       525        1.75   60   19  2018-07-10   
#[Out]# 2566    0    0  2018-07-18        15        5.95    0    0  2018-07-18   
#[Out]# 
#[Out]#       quantity  unit_price  
#[Out]# 0           16        0.50  
#[Out]# 1           19        0.55  
#[Out]# 2           54        0.50  
#[Out]# 3           17        0.60  
#[Out]# 4           38       10.20  
#[Out]# 5           30       14.80  
#[Out]# 6           15       10.75  
#[Out]# 7           38       13.10  
#[Out]# 8            3       13.60  
#[Out]# 9           13        1.15  
#[Out]# 10          20        1.05  
#[Out]# 11          51        7.30  
#[Out]# 12          12        9.25  
#[Out]# 13          19        1.80  
#[Out]# 14          24        2.05  
#[Out]# 15          46        5.70  
#[Out]# 16           8        0.45  
#[Out]# 17          54        0.55  
#[Out]# 18          31        0.60  
#[Out]# 19           0        2.25  
#[Out]# 20          21        2.30  
#[Out]# 21           6        1.60  
#[Out]# 22          32        1.90  
#[Out]# 23          13        3.05  
#[Out]# 24           2        4.00  
#[Out]# 25          13        3.10  
#[Out]# 26          10        3.50  
#[Out]# 27           1        3.85  
#[Out]# 28          11        5.05  
#[Out]# 29          35        2.20  
#[Out]# ...        ...         ...  
#[Out]# 2537        12        0.50  
#[Out]# 2538         1        0.60  
#[Out]# 2539        13        2.70  
#[Out]# 2540        16        2.85  
#[Out]# 2541         0        1.10  
#[Out]# 2542         8        1.05  
#[Out]# 2543         9        0.90  
#[Out]# 2544         1        2.00  
#[Out]# 2545        24        4.60  
#[Out]# 2546        42        3.55  
#[Out]# 2547        14        3.90  
#[Out]# 2548        32        4.60  
#[Out]# 2549        17        3.60  
#[Out]# 2550         1        9.70  
#[Out]# 2551        13        1.30  
#[Out]# 2552        23        4.20  
#[Out]# 2553        15        3.55  
#[Out]# 2554        28        4.15  
#[Out]# 2555        32        4.10  
#[Out]# 2556        11        0.50  
#[Out]# 2557         7        0.55  
#[Out]# 2558         6        0.60  
#[Out]# 2559        41       11.85  
#[Out]# 2560        46        9.65  
#[Out]# 2561         5        9.20  
#[Out]# 2562        16        9.65  
#[Out]# 2563        13        1.10  
#[Out]# 2564         9        1.15  
#[Out]# 2565       525        1.75  
#[Out]# 2566        15        5.95  
#[Out]# 
#[Out]# [2567 rows x 10 columns]
query6 = '''
    select i1.pID, i1.date, i1.unit_price - i2.unit_price
    from inventory i1, inventory i2
    where i1.pID = i2.pID
    and i1.date = i2.date
'''

pd.read_sql_query(query6, conn)
#[Out]#       pID        date  i1.unit_price - i2.unit_price
#[Out]# 0      10  2018-08-26                           0.10
#[Out]# 1      10  2018-08-26                           0.10
#[Out]# 2      10  2018-08-26                           0.05
#[Out]# 3      10  2018-08-26                           0.00
#[Out]# 4      12  2018-08-24                           4.60
#[Out]# 5      12  2018-08-24                           4.05
#[Out]# 6      12  2018-08-24                           1.70
#[Out]# 7      12  2018-08-24                           1.20
#[Out]# 8      12  2018-08-24                           0.00
#[Out]# 9       6  2018-08-26                           0.10
#[Out]# 10      6  2018-08-26                           0.00
#[Out]# 11     27  2018-08-19                           0.00
#[Out]# 12     27  2018-08-19                          -1.95
#[Out]# 13      2  2018-08-22                           0.25
#[Out]# 14      2  2018-08-22                           0.00
#[Out]# 15      8  2018-08-19                           0.00
#[Out]# 16     10  2018-08-23                           0.15
#[Out]# 17     10  2018-08-23                           0.05
#[Out]# 18     10  2018-08-23                           0.00
#[Out]# 19     21  2018-08-22                           0.30
#[Out]# 20     21  2018-08-22                           0.00
#[Out]# 21     21  2018-08-22                          -0.35
#[Out]# 22     21  2018-08-22                          -0.40
#[Out]# 23     13  2018-08-25                           0.00
#[Out]# 24     13  2018-08-25                          -0.05
#[Out]# 25     13  2018-08-25                          -0.45
#[Out]# 26     13  2018-08-25                          -0.80
#[Out]# 27     13  2018-08-25                          -0.95
#[Out]# 28      8  2018-08-27                           0.00
#[Out]# 29     23  2018-08-18                           0.00
#[Out]# ...   ...         ...                            ...
#[Out]# 2537   10  2018-08-27                           0.10
#[Out]# 2538   10  2018-08-27                           0.00
#[Out]# 2539   26  2018-08-24                           0.00
#[Out]# 2540   26  2018-08-24                          -0.15
#[Out]# 2541    6  2018-08-24                           0.00
#[Out]# 2542    6  2018-08-24                          -0.15
#[Out]# 2543    6  2018-08-24                          -0.20
#[Out]# 2544   21  2018-08-27                           0.00
#[Out]# 2545   25  2018-08-27                           0.35
#[Out]# 2546   25  2018-08-27                           0.30
#[Out]# 2547   25  2018-08-27                           0.00
#[Out]# 2548   25  2018-08-27                          -0.70
#[Out]# 2549   25  2018-08-27                          -0.70
#[Out]# 2550   18  2018-08-28                           0.00
#[Out]# 2551    3  2018-08-28                           0.00
#[Out]# 2552   13  2018-08-23                           0.65
#[Out]# 2553   13  2018-08-23                           0.10
#[Out]# 2554   13  2018-08-23                           0.05
#[Out]# 2555   13  2018-08-23                           0.00
#[Out]# 2556   10  2018-08-20                           0.05
#[Out]# 2557   10  2018-08-20                           0.00
#[Out]# 2558   10  2018-08-20                          -0.05
#[Out]# 2559   18  2018-08-21                           0.00
#[Out]# 2560   18  2018-08-21                          -0.45
#[Out]# 2561   18  2018-08-21                          -0.45
#[Out]# 2562   18  2018-08-21                          -2.65
#[Out]# 2563    6  2018-08-22                           0.05
#[Out]# 2564    6  2018-08-22                           0.00
#[Out]# 2565   19  2018-07-10                           0.00
#[Out]# 2566    0  2018-07-18                           0.00
#[Out]# 
#[Out]# [2567 rows x 3 columns]
query6 = '''
    select i1.pID, i1.date, max(i1.unit_price - i2.unit_price)
    from inventory i1, inventory i2
    where i1.pID = i2.pID
    and i1.date = i2.date
'''

pd.read_sql_query(query6, conn)
#[Out]#    pID        date  max(i1.unit_price - i2.unit_price)
#[Out]# 0   12  2018-08-17                                4.75
query6 = '''
    select i1.pID, i1.date, i1.unit_price - i2.unit_price
    from inventory i1, inventory i2
    where i1.pID = i2.pID
    and i1.date = i2.date
'''

pd.read_sql_query(query6, conn)
#[Out]#       pID        date  i1.unit_price - i2.unit_price
#[Out]# 0      10  2018-08-26                           0.10
#[Out]# 1      10  2018-08-26                           0.10
#[Out]# 2      10  2018-08-26                           0.05
#[Out]# 3      10  2018-08-26                           0.00
#[Out]# 4      12  2018-08-24                           4.60
#[Out]# 5      12  2018-08-24                           4.05
#[Out]# 6      12  2018-08-24                           1.70
#[Out]# 7      12  2018-08-24                           1.20
#[Out]# 8      12  2018-08-24                           0.00
#[Out]# 9       6  2018-08-26                           0.10
#[Out]# 10      6  2018-08-26                           0.00
#[Out]# 11     27  2018-08-19                           0.00
#[Out]# 12     27  2018-08-19                          -1.95
#[Out]# 13      2  2018-08-22                           0.25
#[Out]# 14      2  2018-08-22                           0.00
#[Out]# 15      8  2018-08-19                           0.00
#[Out]# 16     10  2018-08-23                           0.15
#[Out]# 17     10  2018-08-23                           0.05
#[Out]# 18     10  2018-08-23                           0.00
#[Out]# 19     21  2018-08-22                           0.30
#[Out]# 20     21  2018-08-22                           0.00
#[Out]# 21     21  2018-08-22                          -0.35
#[Out]# 22     21  2018-08-22                          -0.40
#[Out]# 23     13  2018-08-25                           0.00
#[Out]# 24     13  2018-08-25                          -0.05
#[Out]# 25     13  2018-08-25                          -0.45
#[Out]# 26     13  2018-08-25                          -0.80
#[Out]# 27     13  2018-08-25                          -0.95
#[Out]# 28      8  2018-08-27                           0.00
#[Out]# 29     23  2018-08-18                           0.00
#[Out]# ...   ...         ...                            ...
#[Out]# 2537   10  2018-08-27                           0.10
#[Out]# 2538   10  2018-08-27                           0.00
#[Out]# 2539   26  2018-08-24                           0.00
#[Out]# 2540   26  2018-08-24                          -0.15
#[Out]# 2541    6  2018-08-24                           0.00
#[Out]# 2542    6  2018-08-24                          -0.15
#[Out]# 2543    6  2018-08-24                          -0.20
#[Out]# 2544   21  2018-08-27                           0.00
#[Out]# 2545   25  2018-08-27                           0.35
#[Out]# 2546   25  2018-08-27                           0.30
#[Out]# 2547   25  2018-08-27                           0.00
#[Out]# 2548   25  2018-08-27                          -0.70
#[Out]# 2549   25  2018-08-27                          -0.70
#[Out]# 2550   18  2018-08-28                           0.00
#[Out]# 2551    3  2018-08-28                           0.00
#[Out]# 2552   13  2018-08-23                           0.65
#[Out]# 2553   13  2018-08-23                           0.10
#[Out]# 2554   13  2018-08-23                           0.05
#[Out]# 2555   13  2018-08-23                           0.00
#[Out]# 2556   10  2018-08-20                           0.05
#[Out]# 2557   10  2018-08-20                           0.00
#[Out]# 2558   10  2018-08-20                          -0.05
#[Out]# 2559   18  2018-08-21                           0.00
#[Out]# 2560   18  2018-08-21                          -0.45
#[Out]# 2561   18  2018-08-21                          -0.45
#[Out]# 2562   18  2018-08-21                          -2.65
#[Out]# 2563    6  2018-08-22                           0.05
#[Out]# 2564    6  2018-08-22                           0.00
#[Out]# 2565   19  2018-07-10                           0.00
#[Out]# 2566    0  2018-07-18                           0.00
#[Out]# 
#[Out]# [2567 rows x 3 columns]
query6 = '''
    with priceDifferences(pID, date, difference) as (
        select i1.pID, i1.date, i1.unit_price - i2.unit_price
        from inventory i1, inventory i2
        where i1.pID = i2.pID
        and i1.date = i2.date
    )
    
    select *
    from priceDifferences
'''

pd.read_sql_query(query6, conn)
#[Out]#       pID        date  difference
#[Out]# 0      10  2018-08-26        0.10
#[Out]# 1      10  2018-08-26        0.10
#[Out]# 2      10  2018-08-26        0.05
#[Out]# 3      10  2018-08-26        0.00
#[Out]# 4      12  2018-08-24        4.60
#[Out]# 5      12  2018-08-24        4.05
#[Out]# 6      12  2018-08-24        1.70
#[Out]# 7      12  2018-08-24        1.20
#[Out]# 8      12  2018-08-24        0.00
#[Out]# 9       6  2018-08-26        0.10
#[Out]# 10      6  2018-08-26        0.00
#[Out]# 11     27  2018-08-19        0.00
#[Out]# 12     27  2018-08-19       -1.95
#[Out]# 13      2  2018-08-22        0.25
#[Out]# 14      2  2018-08-22        0.00
#[Out]# 15      8  2018-08-19        0.00
#[Out]# 16     10  2018-08-23        0.15
#[Out]# 17     10  2018-08-23        0.05
#[Out]# 18     10  2018-08-23        0.00
#[Out]# 19     21  2018-08-22        0.30
#[Out]# 20     21  2018-08-22        0.00
#[Out]# 21     21  2018-08-22       -0.35
#[Out]# 22     21  2018-08-22       -0.40
#[Out]# 23     13  2018-08-25        0.00
#[Out]# 24     13  2018-08-25       -0.05
#[Out]# 25     13  2018-08-25       -0.45
#[Out]# 26     13  2018-08-25       -0.80
#[Out]# 27     13  2018-08-25       -0.95
#[Out]# 28      8  2018-08-27        0.00
#[Out]# 29     23  2018-08-18        0.00
#[Out]# ...   ...         ...         ...
#[Out]# 2537   10  2018-08-27        0.10
#[Out]# 2538   10  2018-08-27        0.00
#[Out]# 2539   26  2018-08-24        0.00
#[Out]# 2540   26  2018-08-24       -0.15
#[Out]# 2541    6  2018-08-24        0.00
#[Out]# 2542    6  2018-08-24       -0.15
#[Out]# 2543    6  2018-08-24       -0.20
#[Out]# 2544   21  2018-08-27        0.00
#[Out]# 2545   25  2018-08-27        0.35
#[Out]# 2546   25  2018-08-27        0.30
#[Out]# 2547   25  2018-08-27        0.00
#[Out]# 2548   25  2018-08-27       -0.70
#[Out]# 2549   25  2018-08-27       -0.70
#[Out]# 2550   18  2018-08-28        0.00
#[Out]# 2551    3  2018-08-28        0.00
#[Out]# 2552   13  2018-08-23        0.65
#[Out]# 2553   13  2018-08-23        0.10
#[Out]# 2554   13  2018-08-23        0.05
#[Out]# 2555   13  2018-08-23        0.00
#[Out]# 2556   10  2018-08-20        0.05
#[Out]# 2557   10  2018-08-20        0.00
#[Out]# 2558   10  2018-08-20       -0.05
#[Out]# 2559   18  2018-08-21        0.00
#[Out]# 2560   18  2018-08-21       -0.45
#[Out]# 2561   18  2018-08-21       -0.45
#[Out]# 2562   18  2018-08-21       -2.65
#[Out]# 2563    6  2018-08-22        0.05
#[Out]# 2564    6  2018-08-22        0.00
#[Out]# 2565   19  2018-07-10        0.00
#[Out]# 2566    0  2018-07-18        0.00
#[Out]# 
#[Out]# [2567 rows x 3 columns]
query6 = '''
    with priceDifferences(pID, date, difference) as (
        select i1.pID, i1.date, i1.unit_price - i2.unit_price
        from inventory i1, inventory i2
        where i1.pID = i2.pID
        and i1.date = i2.date
    )
    
    select max(difference)
    from priceDifferences
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(difference)
#[Out]# 0             4.75
query6 = '''
    with priceDifferences(pID, date, difference) as (
        select i1.pID, i1.date, i1.unit_price - i2.unit_price
        from inventory i1, inventory i2
        where i1.pID = i2.pID
        and i1.date = i2.date
    )
    
    select min(difference)
    from priceDifferences
'''

pd.read_sql_query(query6, conn)
#[Out]#    min(difference)
#[Out]# 0            -4.75
query6 = '''
    with priceDifferences(pID, date, difference) as (
        select i1.pID, i1.date, i1.unit_price - i2.unit_price
        from inventory i1, inventory i2
        where i1.pID = i2.pID
        and i1.date = i2.date
    )
    
    select max(difference)
    from priceDifferences
    where date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(difference)
#[Out]# 0              2.0
query6 = '''
    with priceDifferences(pID, date, difference) as (
        select i1.pID, i1.date, i1.unit_price - i2.unit_price
        from inventory i1, inventory i2
        where i1.pID = i2.pID
        and i1.date = i2.date
    )
    
    select max(difference)
    from priceDifferences
    where date = '2018-08-24'
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(difference)
#[Out]# 0              4.6
query6 = '''
    with priceDifferences(pID, date, difference) as (
        select i1.pID, i1.date, i1.unit_price - i2.unit_price
        from inventory i1, inventory i2
        where i1.pID = i2.pID
        and i1.date = i2.date
    )
    
    select max(difference)
    from priceDifferences
    where date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(difference)
#[Out]# 0              2.0
