# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
query = '''
    SELECT i.sID, i.pID, i.unit_price
FROM inventory i
WHERE i.date = '2018-08-23'  
ORDER BY i.unit_price desc
        
'''

pd.read_sql_query(query, conn)
#[Out]#     sID  pID  unit_price
#[Out]# 0     5   12       13.40
#[Out]# 1     9   12       13.15
#[Out]# 2    54   12       12.55
#[Out]# 3    42   12       11.40
#[Out]# 4    35   27        8.85
#[Out]# 5    28   27        8.50
#[Out]# 6    37   28        7.75
#[Out]# 7    52   28        7.35
#[Out]# 8    40   27        6.90
#[Out]# 9    32   28        6.85
#[Out]# 10    7    1        5.80
#[Out]# 11   25    8        5.55
#[Out]# 12   29    0        5.15
#[Out]# 13   33    8        4.80
#[Out]# 14   55    1        4.80
#[Out]# 15   41    1        4.60
#[Out]# 16   31    0        4.60
#[Out]# 17   56    1        4.40
#[Out]# 18   56   25        4.35
#[Out]# 19    6    0        4.35
#[Out]# 20    4   13        4.20
#[Out]# 21   35   13        4.15
#[Out]# 22   45   13        4.10
#[Out]# 23    5   24        4.10
#[Out]# 24   40   14        4.10
#[Out]# 25   35   25        4.00
#[Out]# 26   50   14        3.85
#[Out]# 27   12   13        3.55
#[Out]# 28   38   24        3.55
#[Out]# 29   41   14        3.35
#[Out]# ..  ...  ...         ...
#[Out]# 38    3   19        2.10
#[Out]# 39   21   23        2.10
#[Out]# 40   30   22        2.05
#[Out]# 41    2   16        2.00
#[Out]# 42   29   17        1.95
#[Out]# 43   50   22        1.95
#[Out]# 44   43    7        1.95
#[Out]# 45   11   16        1.90
#[Out]# 46   47    7        1.85
#[Out]# 47    6   16        1.85
#[Out]# 48   38   23        1.80
#[Out]# 49   12    2        1.70
#[Out]# 50    5   16        1.65
#[Out]# 51   16   22        1.60
#[Out]# 52   51   22        1.55
#[Out]# 53    3    3        1.35
#[Out]# 54   11   15        1.30
#[Out]# 55   13   15        1.25
#[Out]# 56   12   15        1.25
#[Out]# 57   19    4        1.20
#[Out]# 58   35   11        1.20
#[Out]# 59   48    6        1.15
#[Out]# 60   33   11        1.05
#[Out]# 61    2   11        1.00
#[Out]# 62   45    4        1.00
#[Out]# 63    6   15        1.00
#[Out]# 64   51   10        0.60
#[Out]# 65   50   10        0.55
#[Out]# 66   34   10        0.45
#[Out]# 67    1    5        0.45
#[Out]# 
#[Out]# [68 rows x 3 columns]
#Find the largest difference in price for a product in stock (i.e., in the inventory of a store)
#on ‘2018-08-23’ between two different stores."

query6 = '''
    SELECT MAX(unit_price), MIN(unit_price)
    FROM inventory
    WHERE date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(unit_price)  MIN(unit_price)
#[Out]# 0             13.4             0.45
#Find the largest difference in price for a product in stock (i.e., in the inventory of a store)
#on ‘2018-08-23’ between two different stores."

query6 = '''
    SELECT MAX(unit_price), MIN(unit_price)
    FROM inventory
    GROUP BY pID
    WHERE date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#Find the largest difference in price for a product in stock (i.e., in the inventory of a store)
#on ‘2018-08-23’ between two different stores."

query6 = '''
    SELECT MAX(unit_price), MIN(unit_price)
    FROM inventory
    WHERE date = '2018-08-23'
    GROUP BY pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     MAX(unit_price)  MIN(unit_price)
#[Out]# 0              5.15             4.35
#[Out]# 1              5.80             4.40
#[Out]# 2              2.10             1.70
#[Out]# 3              1.35             1.35
#[Out]# 4              1.20             1.00
#[Out]# 5              0.45             0.45
#[Out]# 6              1.15             1.15
#[Out]# 7              2.20             1.85
#[Out]# 8              5.55             4.80
#[Out]# 9              0.60             0.45
#[Out]# 10             1.20             1.00
#[Out]# 11            13.40            11.40
#[Out]# 12             4.20             3.55
#[Out]# 13             4.10             3.20
#[Out]# 14             1.30             1.00
#[Out]# 15             2.00             1.65
#[Out]# 16             2.45             1.95
#[Out]# 17             2.95             2.10
#[Out]# 18             2.05             1.55
#[Out]# 19             2.10             1.80
#[Out]# 20             4.10             3.55
#[Out]# 21             4.35             4.00
#[Out]# 22             8.85             6.90
#[Out]# 23             7.75             6.85
#Find the largest difference in price for a product in stock (i.e., in the inventory of a store)
#on ‘2018-08-23’ between two different stores."

query6 = '''
    SELECT MAX(MAX(unit_price)-MIN(unit_price))
    FROM inventory
    WHERE date = '2018-08-23'
    GROUP BY pID
'''

pd.read_sql_query(query6, conn)
#Find the largest difference in price for a product in stock (i.e., in the inventory of a store)
#on ‘2018-08-23’ between two different stores."

query6 = '''
    SELECT MAX(unit_price), MIN(unit_price)
    FROM inventory
    WHERE date = '2018-08-23'
    GROUP BY pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     MAX(unit_price)  MIN(unit_price)
#[Out]# 0              5.15             4.35
#[Out]# 1              5.80             4.40
#[Out]# 2              2.10             1.70
#[Out]# 3              1.35             1.35
#[Out]# 4              1.20             1.00
#[Out]# 5              0.45             0.45
#[Out]# 6              1.15             1.15
#[Out]# 7              2.20             1.85
#[Out]# 8              5.55             4.80
#[Out]# 9              0.60             0.45
#[Out]# 10             1.20             1.00
#[Out]# 11            13.40            11.40
#[Out]# 12             4.20             3.55
#[Out]# 13             4.10             3.20
#[Out]# 14             1.30             1.00
#[Out]# 15             2.00             1.65
#[Out]# 16             2.45             1.95
#[Out]# 17             2.95             2.10
#[Out]# 18             2.05             1.55
#[Out]# 19             2.10             1.80
#[Out]# 20             4.10             3.55
#[Out]# 21             4.35             4.00
#[Out]# 22             8.85             6.90
#[Out]# 23             7.75             6.85
#Find the largest difference in price for a product in stock (i.e., in the inventory of a store)
#on ‘2018-08-23’ between two different stores."

query6 = '''
    SELECT MAX(unit_price) - MIN(unit_price)
    FROM inventory
    WHERE date = '2018-08-23'
    GROUP BY pID
'''

pd.read_sql_query(query6, conn)
#[Out]#     MAX(unit_price) - MIN(unit_price)
#[Out]# 0                                0.80
#[Out]# 1                                1.40
#[Out]# 2                                0.40
#[Out]# 3                                0.00
#[Out]# 4                                0.20
#[Out]# 5                                0.00
#[Out]# 6                                0.00
#[Out]# 7                                0.35
#[Out]# 8                                0.75
#[Out]# 9                                0.15
#[Out]# 10                               0.20
#[Out]# 11                               2.00
#[Out]# 12                               0.65
#[Out]# 13                               0.90
#[Out]# 14                               0.30
#[Out]# 15                               0.35
#[Out]# 16                               0.50
#[Out]# 17                               0.85
#[Out]# 18                               0.50
#[Out]# 19                               0.30
#[Out]# 20                               0.55
#[Out]# 21                               0.35
#[Out]# 22                               1.95
#[Out]# 23                               0.90
#Find the largest difference in price for a product in stock (i.e., in the inventory of a store)
#on ‘2018-08-23’ between two different stores."

query6 = '''
    SELECT  MAX(maxDiff) FROM (
    SELECT MAX(unit_price) - MIN(unit_price) as maxDiff
    FROM inventory
    WHERE date = '2018-08-23'
    GROUP BY pID
    )
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(maxDiff)
#[Out]# 0           2.0
