# IPython log file

query1 = '''
    Select pID
    From purchase 
    GROUP by pID
    Having count(cID) <= 2

    
    
'''

pd.read_sql_query(query1, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
query1 = '''
    Select pID
    From purchase 
    GROUP by pID
    Having count(cID) <= 2

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    Select c.cID, c.cName
    From customer c, product oni, product cof, purchase p1, purchase p2 
    Where p1.cID = c.cID AND p2.cID = c.cID AND p1.date = p2.date AND 
          p1.pID = oni.pID AND oni.pName = "Onions" AND p2.pID = cof.pID 
          AND cof.pName = "Coffee" AND p1.cID = p2.cID 
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    Select cID
    From purchase
    Group by cID
    Having count(sID) = (SELECT count(sID) 
                         From store)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    Select sName
    From purchase p, store s
    Where p.sID = s.sID
    Group by sName
    Having avg(quantity) > 4 
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    Select pt.pName, s.sName, max(i.unit_price)
    From inventory i, purchase p, store s, product pt
    Where p.pID = i.pID AND p.sID = i.sID AND p.date = i.date
          AND s.sID = i.sID AND pt.pID = i.pID

'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName  max(i.unit_price)
#[Out]# 0  Beef  Sligro               13.8
query6 = '''
    with prices_both(price1, price2) as (
        Select i1.unit_price, i2.unit_price
        From inventory i1, inventory i2
        Where i1.date = "2018-08-23" AND i1.date = i2.date AND i1.pID = i2.pID
        EXCEPT
        Select i1.unit_price, i2.unit_price
        From inventory i1, inventory i2
        Where  i1.sID = i2.sID
    )
    Select max(price1 - price2)
    from prices_both
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(price1 - price2)
#[Out]# 0                   2.0
query4 = '''
    with store_chain(name) as (
        Select s1.sName
        From store s1, store s2
        Where s1.sName = s2.sName AND s1.sID <> s2.sID 
    )
        
    Select store_chain.name
    From purchase p, store_chain, store s
    Where p.sID = s.sID AND s.sName = store_chain.name
    Group by sName
    Having avg(quantity) > 4 
'''

pd.read_sql_query(query4, conn)
#[Out]#           name
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x210d4b97dc0>
query1 = '''
    Select p.pID
    From purchase
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select pID
    From purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 479   28
#[Out]# 480   27
#[Out]# 481    5
#[Out]# 482   28
#[Out]# 483    7
#[Out]# 484    0
#[Out]# 485   11
#[Out]# 486    6
#[Out]# 487   19
#[Out]# 488   17
#[Out]# 489    9
#[Out]# 490   11
#[Out]# 491   22
#[Out]# 492   17
#[Out]# 493   20
#[Out]# 494   11
#[Out]# 495   21
#[Out]# 496   23
#[Out]# 497   23
#[Out]# 498    8
#[Out]# 499    0
#[Out]# 500    8
#[Out]# 501   11
#[Out]# 502   15
#[Out]# 503    2
#[Out]# 504   17
#[Out]# 505    5
#[Out]# 506   19
#[Out]# 507    9
#[Out]# 508   18
#[Out]# 
#[Out]# [509 rows x 1 columns]
query1 = '''
    Select *
    From purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select *
    From purchase
    group by pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   838  190   54    0  2018-08-25         6   3.50
#[Out]# 1   430  169   43    1  2018-08-18         9   6.55
#[Out]# 2   842  190   58    2  2018-08-19         7   0.75
#[Out]# 3   807  190   23    3  2018-08-18         1   2.75
#[Out]# 4   800  190   16    4  2018-08-26         1   2.40
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35
#[Out]# 6   825  190   41    6  2018-08-15         5   2.95
#[Out]# 7   822  190   38    7  2018-08-24         4   0.70
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   846  190   62    9  2018-08-16         2   3.15
#[Out]# 10  814  190   30   10  2018-08-18         4   4.35
#[Out]# 11  840  190   56   11  2018-08-15         4   1.60
#[Out]# 12  399  162    9   12  2018-08-24         9  13.15
#[Out]# 13  811  190   27   13  2018-08-17         4   0.90
#[Out]# 14  460  179   25   14  2018-08-24         5   3.70
#[Out]# 15  841  190   57   15  2018-08-22         5   3.25
#[Out]# 16  464  179   35   16  2018-08-22         9   1.85
#[Out]# 17  843  190   59   17  2018-08-26         2   3.80
#[Out]# 18  847  190   63   18  2018-08-21         1   3.30
#[Out]# 19  845  190   61   19  2018-08-23         5   2.85
#[Out]# 20  832  190   48   20  2018-08-26         6   4.30
#[Out]# 21  834  190   50   21  2018-08-22         6   4.05
#[Out]# 22  830  190   46   22  2018-08-25         4   2.60
#[Out]# 23  836  190   52   23  2018-08-15         5   2.50
#[Out]# 24  459  178   39   24  2018-08-27         1   3.90
#[Out]# 25  806  190   22   25  2018-08-19         7   3.20
#[Out]# 26  808  190   24   26  2018-08-16         5   3.25
#[Out]# 27  819  190   35   27  2018-08-15         5   0.50
#[Out]# 28  821  190   37   28  2018-08-15         4   0.65
#[Out]# 29  779  186   62   29  2018-08-21         5   1.00
#[Out]# 30  781  188   62   30  2018-09-20         1   1.00
query1 = '''
    Select *
    From purchase

'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select *
    From purchase
    Group by pID
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   838  190   54    0  2018-08-25         6   3.50
#[Out]# 1   430  169   43    1  2018-08-18         9   6.55
#[Out]# 2   842  190   58    2  2018-08-19         7   0.75
#[Out]# 3   807  190   23    3  2018-08-18         1   2.75
#[Out]# 4   800  190   16    4  2018-08-26         1   2.40
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35
#[Out]# 6   825  190   41    6  2018-08-15         5   2.95
#[Out]# 7   822  190   38    7  2018-08-24         4   0.70
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   846  190   62    9  2018-08-16         2   3.15
#[Out]# 10  814  190   30   10  2018-08-18         4   4.35
#[Out]# 11  840  190   56   11  2018-08-15         4   1.60
#[Out]# 12  399  162    9   12  2018-08-24         9  13.15
#[Out]# 13  811  190   27   13  2018-08-17         4   0.90
#[Out]# 14  460  179   25   14  2018-08-24         5   3.70
#[Out]# 15  841  190   57   15  2018-08-22         5   3.25
#[Out]# 16  464  179   35   16  2018-08-22         9   1.85
#[Out]# 17  843  190   59   17  2018-08-26         2   3.80
#[Out]# 18  847  190   63   18  2018-08-21         1   3.30
#[Out]# 19  845  190   61   19  2018-08-23         5   2.85
#[Out]# 20  832  190   48   20  2018-08-26         6   4.30
#[Out]# 21  834  190   50   21  2018-08-22         6   4.05
#[Out]# 22  830  190   46   22  2018-08-25         4   2.60
#[Out]# 23  836  190   52   23  2018-08-15         5   2.50
#[Out]# 24  459  178   39   24  2018-08-27         1   3.90
#[Out]# 25  806  190   22   25  2018-08-19         7   3.20
#[Out]# 26  808  190   24   26  2018-08-16         5   3.25
#[Out]# 27  819  190   35   27  2018-08-15         5   0.50
#[Out]# 28  821  190   37   28  2018-08-15         4   0.65
#[Out]# 29  779  186   62   29  2018-08-21         5   1.00
#[Out]# 30  781  188   62   30  2018-09-20         1   1.00
query1 = '''
    Select *
    From purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select *
    From purchase
    groupby cId
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select *
    From purchase
    Groupby cId
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select *
    From purchase
    Groupby cId
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select *
    From purchase
    Groupby cId
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select *
    From purchase
    Groupby cId
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select *
    From purchase
    Groupby pId
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select *
    From purchase
    Groupby pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select *
    From purchase
    Groupby pID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select *
    From purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select *
    From purchase
    Group by cID
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      7    1   36   27  2018-08-21         6   9.10
#[Out]# 2     12    2   47   22  2018-08-17         1   1.55
#[Out]# 3     15    3   29    9  2018-08-19         6   1.45
#[Out]# 4     21    4   44   26  2018-08-25         4   2.75
#[Out]# 5     27    5   17   19  2018-08-23         1   2.20
#[Out]# 6     33    7   42   20  2018-08-26         6   2.05
#[Out]# 7     35    8   51    8  2018-08-16         5   5.30
#[Out]# 8     36   10   34   24  2018-08-27         5   3.20
#[Out]# 9     37   11    0   14  2018-08-25         8   4.10
#[Out]# 10    46   13    8    5  2018-08-27         6   0.50
#[Out]# 11    47   15   25   11  2018-08-27         5   0.90
#[Out]# 12    57   16   26   27  2018-08-19         2   9.25
#[Out]# 13    59   17   44    7  2018-08-19        10   1.65
#[Out]# 14    62   18    6    8  2018-08-18         4   4.45
#[Out]# 15    66   19   15    3  2018-08-18         4   1.60
#[Out]# 16    69   20   40   27  2018-08-18         9   7.10
#[Out]# 17    72   21   47   27  2018-08-21         9   7.05
#[Out]# 18    74   22   27   10  2018-08-28         6   0.45
#[Out]# 19    83   24   59   13  2018-08-21         5   4.00
#[Out]# 20    84   25   12   26  2018-08-28         9   2.55
#[Out]# 21    85   26   21   23  2018-08-23         6   2.10
#[Out]# 22    91   27   34   22  2018-08-18         7   1.60
#[Out]# 23    92   28   43   11  2018-08-27         2   1.10
#[Out]# 24    94   29   29    4  2018-08-24         3   0.95
#[Out]# 25    97   30   57   12  2018-08-18         8  11.45
#[Out]# 26    99   31   39   24  2018-08-28         4   3.90
#[Out]# 27   108   33   29    4  2018-08-18         2   1.15
#[Out]# 28   109   34   26   26  2018-08-26         8   3.45
#[Out]# 29   111   35   34   28  2018-08-18         7   9.45
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 102  360  147   33   25  2018-08-25         7   4.40
#[Out]# 103  366  149   54   19  2018-08-25         5   2.25
#[Out]# 104  368  151   14   23  2018-08-17         5   2.10
#[Out]# 105  371  152   43   19  2018-08-21         4   2.20
#[Out]# 106  381  157   36    3  2018-08-28         7   1.80
#[Out]# 107  385  159   17   12  2018-08-26         3  12.30
#[Out]# 108  393  161   36   28  2018-08-26         4   7.20
#[Out]# 109  402  162   41   16  2018-08-16         2   1.65
#[Out]# 110  406  163    6   10  2018-08-22         6   0.55
#[Out]# 111  413  165   46    9  2018-08-25         6   1.80
#[Out]# 112  425  167   17   17  2018-08-15         9   2.05
#[Out]# 113  426  168   28    1  2018-08-16         6   5.65
#[Out]# 114  437  169   52   14  2018-08-28         7   4.65
#[Out]# 115  440  170   40   22  2018-08-16         5   2.05
#[Out]# 116  442  171   44   21  2018-08-20         2   2.35
#[Out]# 117  444  172    0   16  2018-08-24         4   1.85
#[Out]# 118  446  175   16   21  2018-08-20         2   2.25
#[Out]# 119  452  176    6    5  2018-08-26         9   0.50
#[Out]# 120  457  177   51    4  2018-08-22         6   1.10
#[Out]# 121  459  178   39   24  2018-08-27         1   3.90
#[Out]# 122  465  179   45   10  2018-08-23         7   0.45
#[Out]# 123  468  180   56   10  2018-08-27         3   0.60
#[Out]# 124  471  181   27   21  2018-08-27         5   2.00
#[Out]# 125  474  182    4   13  2018-08-23         9   4.20
#[Out]# 126  777  184    0    0  2018-08-20         2   3.50
#[Out]# 127  778  185   62   29  2018-08-20         1   1.00
#[Out]# 128  779  186   62   29  2018-08-21         5   1.00
#[Out]# 129  781  188   62   30  2018-09-20         1   1.00
#[Out]# 130  783  189   20   19  2018-08-26         3   2.50
#[Out]# 131  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [132 rows x 7 columns]
query1 = '''
    Select *
    From purchase
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select *
    From purchase
    Group by pID
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   838  190   54    0  2018-08-25         6   3.50
#[Out]# 1   430  169   43    1  2018-08-18         9   6.55
#[Out]# 2   842  190   58    2  2018-08-19         7   0.75
#[Out]# 3   807  190   23    3  2018-08-18         1   2.75
#[Out]# 4   800  190   16    4  2018-08-26         1   2.40
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35
#[Out]# 6   825  190   41    6  2018-08-15         5   2.95
#[Out]# 7   822  190   38    7  2018-08-24         4   0.70
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   846  190   62    9  2018-08-16         2   3.15
#[Out]# 10  814  190   30   10  2018-08-18         4   4.35
#[Out]# 11  840  190   56   11  2018-08-15         4   1.60
#[Out]# 12  399  162    9   12  2018-08-24         9  13.15
#[Out]# 13  811  190   27   13  2018-08-17         4   0.90
#[Out]# 14  460  179   25   14  2018-08-24         5   3.70
#[Out]# 15  841  190   57   15  2018-08-22         5   3.25
#[Out]# 16  464  179   35   16  2018-08-22         9   1.85
#[Out]# 17  843  190   59   17  2018-08-26         2   3.80
#[Out]# 18  847  190   63   18  2018-08-21         1   3.30
#[Out]# 19  845  190   61   19  2018-08-23         5   2.85
#[Out]# 20  832  190   48   20  2018-08-26         6   4.30
#[Out]# 21  834  190   50   21  2018-08-22         6   4.05
#[Out]# 22  830  190   46   22  2018-08-25         4   2.60
#[Out]# 23  836  190   52   23  2018-08-15         5   2.50
#[Out]# 24  459  178   39   24  2018-08-27         1   3.90
#[Out]# 25  806  190   22   25  2018-08-19         7   3.20
#[Out]# 26  808  190   24   26  2018-08-16         5   3.25
#[Out]# 27  819  190   35   27  2018-08-15         5   0.50
#[Out]# 28  821  190   37   28  2018-08-15         4   0.65
#[Out]# 29  779  186   62   29  2018-08-21         5   1.00
#[Out]# 30  781  188   62   30  2018-09-20         1   1.00
query1 = '''
    Select *
    From purchase
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select *
    From purchase
    Where pID = 29
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    tID  cID  sID  pID        date  quantity  price
#[Out]# 0  778  185   62   29  2018-08-20         1      1
#[Out]# 1  779  186   62   29  2018-08-21         5      1
query1 = '''
    Select *
    From purchase
    Where pID = 30
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    tID  cID  sID  pID        date  quantity  price
#[Out]# 0  780  188   62   30  2018-08-20         1      1
#[Out]# 1  781  188   62   30  2018-09-20         1      1
query1 = '''
    Select *
    From purchase
    Where pID = 31
    
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [tID, cID, sID, pID, date, quantity, price]
#[Out]# Index: []
query1 = '''
    Select *
    From purchase
    Where pID = 32
    
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [tID, cID, sID, pID, date, quantity, price]
#[Out]# Index: []
query1 = '''
    Select *
    From purchase
    Where pID = 28
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0    23    5   36   28  2018-08-22         6   8.25
#[Out]# 1    73   22   25   28  2018-08-27         3   8.05
#[Out]# 2   111   35   34   28  2018-08-18         7   9.45
#[Out]# 3   123   39   21   28  2018-08-29         3   7.05
#[Out]# 4   124   40   52   28  2018-08-16         9   9.60
#[Out]# 5   180   60   30   28  2018-08-23         6   8.90
#[Out]# 6   197   70   54   28  2018-08-25         4   9.70
#[Out]# 7   200   71   55   28  2018-08-24         8   7.25
#[Out]# 8   224   82   52   28  2018-08-23         2   7.35
#[Out]# 9   234   86   20   28  2018-08-17         6   8.60
#[Out]# 10  271  100   40   28  2018-08-22         2   8.25
#[Out]# 11  280  108   41   28  2018-08-15         2   7.65
#[Out]# 12  307  118   38   28  2018-08-20         5   6.95
#[Out]# 13  320  123   34   28  2018-08-24         3   8.25
#[Out]# 14  325  124   14   28  2018-08-26         6   8.25
#[Out]# 15  337  127   34   28  2018-08-26         7   8.35
#[Out]# 16  350  136   37   28  2018-08-24         5   7.75
#[Out]# 17  393  161   36   28  2018-08-26         4   7.20
#[Out]# 18  397  162   18   28  2018-08-22         1   8.70
#[Out]# 19  428  169   18   28  2018-08-17         8   7.70
#[Out]# 20  438  170    9   28  2018-08-16         2   9.85
#[Out]# 21  445  175   27   28  2018-08-19         1   8.10
#[Out]# 22  787  190    3   28  2018-08-23         5   0.50
#[Out]# 23  818  190   34   28  2018-08-20         4   2.80
#[Out]# 24  821  190   37   28  2018-08-15         4   0.65
query1 = '''
    Select *
    From purchase
    Where pID = 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    tID  cID  sID  pID        date  quantity  price
#[Out]# 0   29    7   12    2  2018-08-23         6   1.70
#[Out]# 1   88   27   47    2  2018-08-27         6   1.65
#[Out]# 2  106   33   34    2  2018-08-16         3   2.30
#[Out]# 3  230   85   37    2  2018-08-19         2   2.25
#[Out]# 4  246   91   47    2  2018-08-27         6   2.00
#[Out]# 5  266   97   26    2  2018-08-25        13   1.95
#[Out]# 6  401  162    0    2  2018-08-26         2   1.70
#[Out]# 7  417  167   57    2  2018-08-19         2   2.30
#[Out]# 8  789  190    5    2  2018-08-23         7   2.00
#[Out]# 9  842  190   58    2  2018-08-19         7   0.75
query1 = '''
    Select count cID
    From purchase
    Group by pID
    
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select count (distinct cID)
    From purchase
    Group by pID
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     count (distinct cID)
#[Out]# 0                     22
#[Out]# 1                     13
#[Out]# 2                      9
#[Out]# 3                     20
#[Out]# 4                     16
#[Out]# 5                     14
#[Out]# 6                     15
#[Out]# 7                     13
#[Out]# 8                     12
#[Out]# 9                     18
#[Out]# 10                    14
#[Out]# 11                    13
#[Out]# 12                    16
#[Out]# 13                    21
#[Out]# 14                    18
#[Out]# 15                    13
#[Out]# 16                    20
#[Out]# 17                    13
#[Out]# 18                    10
#[Out]# 19                    20
#[Out]# 20                    16
#[Out]# 21                    19
#[Out]# 22                    20
#[Out]# 23                    11
#[Out]# 24                    20
#[Out]# 25                    14
#[Out]# 26                    19
#[Out]# 27                    13
#[Out]# 28                    23
#[Out]# 29                     2
#[Out]# 30                     1
query1 = '''
    Select *
    From purchase
    Group by pID
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   838  190   54    0  2018-08-25         6   3.50
#[Out]# 1   430  169   43    1  2018-08-18         9   6.55
#[Out]# 2   842  190   58    2  2018-08-19         7   0.75
#[Out]# 3   807  190   23    3  2018-08-18         1   2.75
#[Out]# 4   800  190   16    4  2018-08-26         1   2.40
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35
#[Out]# 6   825  190   41    6  2018-08-15         5   2.95
#[Out]# 7   822  190   38    7  2018-08-24         4   0.70
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   846  190   62    9  2018-08-16         2   3.15
#[Out]# 10  814  190   30   10  2018-08-18         4   4.35
#[Out]# 11  840  190   56   11  2018-08-15         4   1.60
#[Out]# 12  399  162    9   12  2018-08-24         9  13.15
#[Out]# 13  811  190   27   13  2018-08-17         4   0.90
#[Out]# 14  460  179   25   14  2018-08-24         5   3.70
#[Out]# 15  841  190   57   15  2018-08-22         5   3.25
#[Out]# 16  464  179   35   16  2018-08-22         9   1.85
#[Out]# 17  843  190   59   17  2018-08-26         2   3.80
#[Out]# 18  847  190   63   18  2018-08-21         1   3.30
#[Out]# 19  845  190   61   19  2018-08-23         5   2.85
#[Out]# 20  832  190   48   20  2018-08-26         6   4.30
#[Out]# 21  834  190   50   21  2018-08-22         6   4.05
#[Out]# 22  830  190   46   22  2018-08-25         4   2.60
#[Out]# 23  836  190   52   23  2018-08-15         5   2.50
#[Out]# 24  459  178   39   24  2018-08-27         1   3.90
#[Out]# 25  806  190   22   25  2018-08-19         7   3.20
#[Out]# 26  808  190   24   26  2018-08-16         5   3.25
#[Out]# 27  819  190   35   27  2018-08-15         5   0.50
#[Out]# 28  821  190   37   28  2018-08-15         4   0.65
#[Out]# 29  779  186   62   29  2018-08-21         5   1.00
#[Out]# 30  781  188   62   30  2018-09-20         1   1.00
query1 = '''
    Select *
    From purchase
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select pID
    From purchase
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 479   28
#[Out]# 480   27
#[Out]# 481    5
#[Out]# 482   28
#[Out]# 483    7
#[Out]# 484    0
#[Out]# 485   11
#[Out]# 486    6
#[Out]# 487   19
#[Out]# 488   17
#[Out]# 489    9
#[Out]# 490   11
#[Out]# 491   22
#[Out]# 492   17
#[Out]# 493   20
#[Out]# 494   11
#[Out]# 495   21
#[Out]# 496   23
#[Out]# 497   23
#[Out]# 498    8
#[Out]# 499    0
#[Out]# 500    8
#[Out]# 501   11
#[Out]# 502   15
#[Out]# 503    2
#[Out]# 504   17
#[Out]# 505    5
#[Out]# 506   19
#[Out]# 507    9
#[Out]# 508   18
#[Out]# 
#[Out]# [509 rows x 1 columns]
query1 = '''
    Select *
    From purchase
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select *
    From purchase
    Where pID = 2
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    tID  cID  sID  pID        date  quantity  price
#[Out]# 0   29    7   12    2  2018-08-23         6   1.70
#[Out]# 1   88   27   47    2  2018-08-27         6   1.65
#[Out]# 2  106   33   34    2  2018-08-16         3   2.30
#[Out]# 3  230   85   37    2  2018-08-19         2   2.25
#[Out]# 4  246   91   47    2  2018-08-27         6   2.00
#[Out]# 5  266   97   26    2  2018-08-25        13   1.95
#[Out]# 6  401  162    0    2  2018-08-26         2   1.70
#[Out]# 7  417  167   57    2  2018-08-19         2   2.30
#[Out]# 8  789  190    5    2  2018-08-23         7   2.00
#[Out]# 9  842  190   58    2  2018-08-19         7   0.75
query1 = '''
    Select count(pID)
    From purchase
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(pID)
#[Out]# 0         509
query1 = '''
    Select count(pID)
    From purchase
    Group by cID
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      count(pID)
#[Out]# 0             1
#[Out]# 1             7
#[Out]# 2             5
#[Out]# 3             3
#[Out]# 4             6
#[Out]# 5             6
#[Out]# 6             6
#[Out]# 7             2
#[Out]# 8             1
#[Out]# 9             1
#[Out]# 10            9
#[Out]# 11            1
#[Out]# 12           10
#[Out]# 13            2
#[Out]# 14            3
#[Out]# 15            4
#[Out]# 16            3
#[Out]# 17            3
#[Out]# 18            2
#[Out]# 19            9
#[Out]# 20            1
#[Out]# 21            1
#[Out]# 22            6
#[Out]# 23            1
#[Out]# 24            2
#[Out]# 25            3
#[Out]# 26            2
#[Out]# 27            9
#[Out]# 28            1
#[Out]# 29            2
#[Out]# ..          ...
#[Out]# 102           3
#[Out]# 103           2
#[Out]# 104           2
#[Out]# 105           3
#[Out]# 106           3
#[Out]# 107           2
#[Out]# 108          11
#[Out]# 109           8
#[Out]# 110           4
#[Out]# 111           6
#[Out]# 112          10
#[Out]# 113           1
#[Out]# 114          11
#[Out]# 115           3
#[Out]# 116           2
#[Out]# 117           2
#[Out]# 118           2
#[Out]# 119           6
#[Out]# 120           5
#[Out]# 121           2
#[Out]# 122           6
#[Out]# 123           3
#[Out]# 124           3
#[Out]# 125           4
#[Out]# 126           1
#[Out]# 127           1
#[Out]# 128           1
#[Out]# 129           2
#[Out]# 130           2
#[Out]# 131          64
#[Out]# 
#[Out]# [132 rows x 1 columns]
query1 = '''
    Select cID, count(pID)
    From purchase
    Group by cID
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      cID  count(pID)
#[Out]# 0      0           1
#[Out]# 1      1           7
#[Out]# 2      2           5
#[Out]# 3      3           3
#[Out]# 4      4           6
#[Out]# 5      5           6
#[Out]# 6      7           6
#[Out]# 7      8           2
#[Out]# 8     10           1
#[Out]# 9     11           1
#[Out]# 10    13           9
#[Out]# 11    15           1
#[Out]# 12    16          10
#[Out]# 13    17           2
#[Out]# 14    18           3
#[Out]# 15    19           4
#[Out]# 16    20           3
#[Out]# 17    21           3
#[Out]# 18    22           2
#[Out]# 19    24           9
#[Out]# 20    25           1
#[Out]# 21    26           1
#[Out]# 22    27           6
#[Out]# 23    28           1
#[Out]# 24    29           2
#[Out]# 25    30           3
#[Out]# 26    31           2
#[Out]# 27    33           9
#[Out]# 28    34           1
#[Out]# 29    35           2
#[Out]# ..   ...         ...
#[Out]# 102  147           3
#[Out]# 103  149           2
#[Out]# 104  151           2
#[Out]# 105  152           3
#[Out]# 106  157           3
#[Out]# 107  159           2
#[Out]# 108  161          11
#[Out]# 109  162           8
#[Out]# 110  163           4
#[Out]# 111  165           6
#[Out]# 112  167          10
#[Out]# 113  168           1
#[Out]# 114  169          11
#[Out]# 115  170           3
#[Out]# 116  171           2
#[Out]# 117  172           2
#[Out]# 118  175           2
#[Out]# 119  176           6
#[Out]# 120  177           5
#[Out]# 121  178           2
#[Out]# 122  179           6
#[Out]# 123  180           3
#[Out]# 124  181           3
#[Out]# 125  182           4
#[Out]# 126  184           1
#[Out]# 127  185           1
#[Out]# 128  186           1
#[Out]# 129  188           2
#[Out]# 130  189           2
#[Out]# 131  190          64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query1 = '''
    Select cID, count(distinct pID)
    From purchase
    Group by cID
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      cID  count(distinct pID)
#[Out]# 0      0                    1
#[Out]# 1      1                    7
#[Out]# 2      2                    5
#[Out]# 3      3                    3
#[Out]# 4      4                    6
#[Out]# 5      5                    6
#[Out]# 6      7                    6
#[Out]# 7      8                    2
#[Out]# 8     10                    1
#[Out]# 9     11                    1
#[Out]# 10    13                    9
#[Out]# 11    15                    1
#[Out]# 12    16                   10
#[Out]# 13    17                    2
#[Out]# 14    18                    3
#[Out]# 15    19                    4
#[Out]# 16    20                    3
#[Out]# 17    21                    3
#[Out]# 18    22                    2
#[Out]# 19    24                    9
#[Out]# 20    25                    1
#[Out]# 21    26                    1
#[Out]# 22    27                    6
#[Out]# 23    28                    1
#[Out]# 24    29                    2
#[Out]# 25    30                    3
#[Out]# 26    31                    2
#[Out]# 27    33                    9
#[Out]# 28    34                    1
#[Out]# 29    35                    2
#[Out]# ..   ...                  ...
#[Out]# 102  147                    3
#[Out]# 103  149                    2
#[Out]# 104  151                    2
#[Out]# 105  152                    3
#[Out]# 106  157                    3
#[Out]# 107  159                    2
#[Out]# 108  161                   11
#[Out]# 109  162                    8
#[Out]# 110  163                    4
#[Out]# 111  165                    6
#[Out]# 112  167                   10
#[Out]# 113  168                    1
#[Out]# 114  169                   11
#[Out]# 115  170                    3
#[Out]# 116  171                    2
#[Out]# 117  172                    2
#[Out]# 118  175                    2
#[Out]# 119  176                    6
#[Out]# 120  177                    5
#[Out]# 121  178                    2
#[Out]# 122  179                    6
#[Out]# 123  180                    3
#[Out]# 124  181                    3
#[Out]# 125  182                    4
#[Out]# 126  184                    1
#[Out]# 127  185                    1
#[Out]# 128  186                    1
#[Out]# 129  188                    1
#[Out]# 130  189                    2
#[Out]# 131  190                   24
#[Out]# 
#[Out]# [132 rows x 2 columns]
query1 = '''
    Select *
    From purchase
    Group by cID
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      7    1   36   27  2018-08-21         6   9.10
#[Out]# 2     12    2   47   22  2018-08-17         1   1.55
#[Out]# 3     15    3   29    9  2018-08-19         6   1.45
#[Out]# 4     21    4   44   26  2018-08-25         4   2.75
#[Out]# 5     27    5   17   19  2018-08-23         1   2.20
#[Out]# 6     33    7   42   20  2018-08-26         6   2.05
#[Out]# 7     35    8   51    8  2018-08-16         5   5.30
#[Out]# 8     36   10   34   24  2018-08-27         5   3.20
#[Out]# 9     37   11    0   14  2018-08-25         8   4.10
#[Out]# 10    46   13    8    5  2018-08-27         6   0.50
#[Out]# 11    47   15   25   11  2018-08-27         5   0.90
#[Out]# 12    57   16   26   27  2018-08-19         2   9.25
#[Out]# 13    59   17   44    7  2018-08-19        10   1.65
#[Out]# 14    62   18    6    8  2018-08-18         4   4.45
#[Out]# 15    66   19   15    3  2018-08-18         4   1.60
#[Out]# 16    69   20   40   27  2018-08-18         9   7.10
#[Out]# 17    72   21   47   27  2018-08-21         9   7.05
#[Out]# 18    74   22   27   10  2018-08-28         6   0.45
#[Out]# 19    83   24   59   13  2018-08-21         5   4.00
#[Out]# 20    84   25   12   26  2018-08-28         9   2.55
#[Out]# 21    85   26   21   23  2018-08-23         6   2.10
#[Out]# 22    91   27   34   22  2018-08-18         7   1.60
#[Out]# 23    92   28   43   11  2018-08-27         2   1.10
#[Out]# 24    94   29   29    4  2018-08-24         3   0.95
#[Out]# 25    97   30   57   12  2018-08-18         8  11.45
#[Out]# 26    99   31   39   24  2018-08-28         4   3.90
#[Out]# 27   108   33   29    4  2018-08-18         2   1.15
#[Out]# 28   109   34   26   26  2018-08-26         8   3.45
#[Out]# 29   111   35   34   28  2018-08-18         7   9.45
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 102  360  147   33   25  2018-08-25         7   4.40
#[Out]# 103  366  149   54   19  2018-08-25         5   2.25
#[Out]# 104  368  151   14   23  2018-08-17         5   2.10
#[Out]# 105  371  152   43   19  2018-08-21         4   2.20
#[Out]# 106  381  157   36    3  2018-08-28         7   1.80
#[Out]# 107  385  159   17   12  2018-08-26         3  12.30
#[Out]# 108  393  161   36   28  2018-08-26         4   7.20
#[Out]# 109  402  162   41   16  2018-08-16         2   1.65
#[Out]# 110  406  163    6   10  2018-08-22         6   0.55
#[Out]# 111  413  165   46    9  2018-08-25         6   1.80
#[Out]# 112  425  167   17   17  2018-08-15         9   2.05
#[Out]# 113  426  168   28    1  2018-08-16         6   5.65
#[Out]# 114  437  169   52   14  2018-08-28         7   4.65
#[Out]# 115  440  170   40   22  2018-08-16         5   2.05
#[Out]# 116  442  171   44   21  2018-08-20         2   2.35
#[Out]# 117  444  172    0   16  2018-08-24         4   1.85
#[Out]# 118  446  175   16   21  2018-08-20         2   2.25
#[Out]# 119  452  176    6    5  2018-08-26         9   0.50
#[Out]# 120  457  177   51    4  2018-08-22         6   1.10
#[Out]# 121  459  178   39   24  2018-08-27         1   3.90
#[Out]# 122  465  179   45   10  2018-08-23         7   0.45
#[Out]# 123  468  180   56   10  2018-08-27         3   0.60
#[Out]# 124  471  181   27   21  2018-08-27         5   2.00
#[Out]# 125  474  182    4   13  2018-08-23         9   4.20
#[Out]# 126  777  184    0    0  2018-08-20         2   3.50
#[Out]# 127  778  185   62   29  2018-08-20         1   1.00
#[Out]# 128  779  186   62   29  2018-08-21         5   1.00
#[Out]# 129  781  188   62   30  2018-09-20         1   1.00
#[Out]# 130  783  189   20   19  2018-08-26         3   2.50
#[Out]# 131  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [132 rows x 7 columns]
query1 = '''
    Select *
    From purchase
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select *
    From purchase
    Where pID = 2
    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    tID  cID  sID  pID        date  quantity  price
#[Out]# 0   29    7   12    2  2018-08-23         6   1.70
#[Out]# 1   88   27   47    2  2018-08-27         6   1.65
#[Out]# 2  106   33   34    2  2018-08-16         3   2.30
#[Out]# 3  230   85   37    2  2018-08-19         2   2.25
#[Out]# 4  246   91   47    2  2018-08-27         6   2.00
#[Out]# 5  266   97   26    2  2018-08-25        13   1.95
#[Out]# 6  401  162    0    2  2018-08-26         2   1.70
#[Out]# 7  417  167   57    2  2018-08-19         2   2.30
#[Out]# 8  789  190    5    2  2018-08-23         7   2.00
#[Out]# 9  842  190   58    2  2018-08-19         7   0.75
query1 = '''
    Select *
    From purchase
    Where pID = 3
    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0    44   13    4    3  2018-08-25         1   1.70
#[Out]# 1    66   19   15    3  2018-08-18         4   1.60
#[Out]# 2    89   27   42    3  2018-08-16         8   1.20
#[Out]# 3   129   41    3    3  2018-08-23         3   1.35
#[Out]# 4   158   51   13    3  2018-08-26         5   1.30
#[Out]# 5   188   67   44    3  2018-08-27         1   1.40
#[Out]# 6   236   86    8    3  2018-08-18         1   1.40
#[Out]# 7   260   96   13    3  2018-08-16         1   1.30
#[Out]# 8   270  100    5    3  2018-08-21         4   1.40
#[Out]# 9   296  112   20    3  2018-08-25         4   1.40
#[Out]# 10  313  122   17    3  2018-08-25         1   1.50
#[Out]# 11  347  134   43    3  2018-08-25         6   1.70
#[Out]# 12  381  157   36    3  2018-08-28         7   1.80
#[Out]# 13  398  162   57    3  2018-08-23         7   1.25
#[Out]# 14  424  167   50    3  2018-08-15         2   1.70
#[Out]# 15  429  169   46    3  2018-08-17         5   1.75
#[Out]# 16  441  171   56    3  2018-08-20         1   1.50
#[Out]# 17  455  177   11    3  2018-08-21         6   1.30
#[Out]# 18  473  182    5    3  2018-08-28         7   1.30
#[Out]# 19  807  190   23    3  2018-08-18         1   2.75
query1 = '''
    Select *
    From purchase
    Where pID = 4
    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0    10    2   13    4  2018-08-17         6   1.10
#[Out]# 1    94   29   29    4  2018-08-24         3   0.95
#[Out]# 2    98   31   42    4  2018-08-27         9   0.90
#[Out]# 3   108   33   29    4  2018-08-18         2   1.15
#[Out]# 4   160   52    3    4  2018-08-25         3   0.90
#[Out]# 5   174   59   47    4  2018-08-25         5   1.05
#[Out]# 6   229   85   19    4  2018-08-18         1   0.85
#[Out]# 7   323  124   54    4  2018-08-26         4   1.10
#[Out]# 8   339  129   43    4  2018-08-24         7   1.10
#[Out]# 9   395  162   19    4  2018-08-21         5   1.05
#[Out]# 10  408  165   26    4  2018-08-23         8   0.95
#[Out]# 11  434  169    1    4  2018-08-20         3   1.10
#[Out]# 12  443  172   59    4  2018-08-27         4   0.90
#[Out]# 13  447  176   52    4  2018-08-22         7   0.90
#[Out]# 14  457  177   51    4  2018-08-22         6   1.10
#[Out]# 15  800  190   16    4  2018-08-26         1   2.40
query1 = '''
    Select *
    From purchase
    Group by pID
    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   838  190   54    0  2018-08-25         6   3.50
#[Out]# 1   430  169   43    1  2018-08-18         9   6.55
#[Out]# 2   842  190   58    2  2018-08-19         7   0.75
#[Out]# 3   807  190   23    3  2018-08-18         1   2.75
#[Out]# 4   800  190   16    4  2018-08-26         1   2.40
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35
#[Out]# 6   825  190   41    6  2018-08-15         5   2.95
#[Out]# 7   822  190   38    7  2018-08-24         4   0.70
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   846  190   62    9  2018-08-16         2   3.15
#[Out]# 10  814  190   30   10  2018-08-18         4   4.35
#[Out]# 11  840  190   56   11  2018-08-15         4   1.60
#[Out]# 12  399  162    9   12  2018-08-24         9  13.15
#[Out]# 13  811  190   27   13  2018-08-17         4   0.90
#[Out]# 14  460  179   25   14  2018-08-24         5   3.70
#[Out]# 15  841  190   57   15  2018-08-22         5   3.25
#[Out]# 16  464  179   35   16  2018-08-22         9   1.85
#[Out]# 17  843  190   59   17  2018-08-26         2   3.80
#[Out]# 18  847  190   63   18  2018-08-21         1   3.30
#[Out]# 19  845  190   61   19  2018-08-23         5   2.85
#[Out]# 20  832  190   48   20  2018-08-26         6   4.30
#[Out]# 21  834  190   50   21  2018-08-22         6   4.05
#[Out]# 22  830  190   46   22  2018-08-25         4   2.60
#[Out]# 23  836  190   52   23  2018-08-15         5   2.50
#[Out]# 24  459  178   39   24  2018-08-27         1   3.90
#[Out]# 25  806  190   22   25  2018-08-19         7   3.20
#[Out]# 26  808  190   24   26  2018-08-16         5   3.25
#[Out]# 27  819  190   35   27  2018-08-15         5   0.50
#[Out]# 28  821  190   37   28  2018-08-15         4   0.65
#[Out]# 29  779  186   62   29  2018-08-21         5   1.00
#[Out]# 30  781  188   62   30  2018-09-20         1   1.00
query1 = '''
    Select *
    From purchase

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select *
    From purchase
    Group by pID
    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   838  190   54    0  2018-08-25         6   3.50
#[Out]# 1   430  169   43    1  2018-08-18         9   6.55
#[Out]# 2   842  190   58    2  2018-08-19         7   0.75
#[Out]# 3   807  190   23    3  2018-08-18         1   2.75
#[Out]# 4   800  190   16    4  2018-08-26         1   2.40
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35
#[Out]# 6   825  190   41    6  2018-08-15         5   2.95
#[Out]# 7   822  190   38    7  2018-08-24         4   0.70
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   846  190   62    9  2018-08-16         2   3.15
#[Out]# 10  814  190   30   10  2018-08-18         4   4.35
#[Out]# 11  840  190   56   11  2018-08-15         4   1.60
#[Out]# 12  399  162    9   12  2018-08-24         9  13.15
#[Out]# 13  811  190   27   13  2018-08-17         4   0.90
#[Out]# 14  460  179   25   14  2018-08-24         5   3.70
#[Out]# 15  841  190   57   15  2018-08-22         5   3.25
#[Out]# 16  464  179   35   16  2018-08-22         9   1.85
#[Out]# 17  843  190   59   17  2018-08-26         2   3.80
#[Out]# 18  847  190   63   18  2018-08-21         1   3.30
#[Out]# 19  845  190   61   19  2018-08-23         5   2.85
#[Out]# 20  832  190   48   20  2018-08-26         6   4.30
#[Out]# 21  834  190   50   21  2018-08-22         6   4.05
#[Out]# 22  830  190   46   22  2018-08-25         4   2.60
#[Out]# 23  836  190   52   23  2018-08-15         5   2.50
#[Out]# 24  459  178   39   24  2018-08-27         1   3.90
#[Out]# 25  806  190   22   25  2018-08-19         7   3.20
#[Out]# 26  808  190   24   26  2018-08-16         5   3.25
#[Out]# 27  819  190   35   27  2018-08-15         5   0.50
#[Out]# 28  821  190   37   28  2018-08-15         4   0.65
#[Out]# 29  779  186   62   29  2018-08-21         5   1.00
#[Out]# 30  781  188   62   30  2018-09-20         1   1.00
query1 = '''
    Select *
    From purchase

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query1 = '''
    Select *
    From purchase
        Group by pID

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   838  190   54    0  2018-08-25         6   3.50
#[Out]# 1   430  169   43    1  2018-08-18         9   6.55
#[Out]# 2   842  190   58    2  2018-08-19         7   0.75
#[Out]# 3   807  190   23    3  2018-08-18         1   2.75
#[Out]# 4   800  190   16    4  2018-08-26         1   2.40
#[Out]# 5   844  190   60    5  2018-08-27         6   4.35
#[Out]# 6   825  190   41    6  2018-08-15         5   2.95
#[Out]# 7   822  190   38    7  2018-08-24         4   0.70
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   846  190   62    9  2018-08-16         2   3.15
#[Out]# 10  814  190   30   10  2018-08-18         4   4.35
#[Out]# 11  840  190   56   11  2018-08-15         4   1.60
#[Out]# 12  399  162    9   12  2018-08-24         9  13.15
#[Out]# 13  811  190   27   13  2018-08-17         4   0.90
#[Out]# 14  460  179   25   14  2018-08-24         5   3.70
#[Out]# 15  841  190   57   15  2018-08-22         5   3.25
#[Out]# 16  464  179   35   16  2018-08-22         9   1.85
#[Out]# 17  843  190   59   17  2018-08-26         2   3.80
#[Out]# 18  847  190   63   18  2018-08-21         1   3.30
#[Out]# 19  845  190   61   19  2018-08-23         5   2.85
#[Out]# 20  832  190   48   20  2018-08-26         6   4.30
#[Out]# 21  834  190   50   21  2018-08-22         6   4.05
#[Out]# 22  830  190   46   22  2018-08-25         4   2.60
#[Out]# 23  836  190   52   23  2018-08-15         5   2.50
#[Out]# 24  459  178   39   24  2018-08-27         1   3.90
#[Out]# 25  806  190   22   25  2018-08-19         7   3.20
#[Out]# 26  808  190   24   26  2018-08-16         5   3.25
#[Out]# 27  819  190   35   27  2018-08-15         5   0.50
#[Out]# 28  821  190   37   28  2018-08-15         4   0.65
#[Out]# 29  779  186   62   29  2018-08-21         5   1.00
#[Out]# 30  781  188   62   30  2018-09-20         1   1.00
query1 = '''
    Select count(*)
    From purchase
    Group by pID

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     count(*)
#[Out]# 0         25
#[Out]# 1         13
#[Out]# 2         10
#[Out]# 3         20
#[Out]# 4         16
#[Out]# 5         16
#[Out]# 6         15
#[Out]# 7         14
#[Out]# 8         13
#[Out]# 9         20
#[Out]# 10        16
#[Out]# 11        16
#[Out]# 12        16
#[Out]# 13        21
#[Out]# 14        18
#[Out]# 15        14
#[Out]# 16        20
#[Out]# 17        18
#[Out]# 18        10
#[Out]# 19        26
#[Out]# 20        18
#[Out]# 21        22
#[Out]# 22        21
#[Out]# 23        13
#[Out]# 24        20
#[Out]# 25        14
#[Out]# 26        20
#[Out]# 27        15
#[Out]# 28        25
#[Out]# 29         2
#[Out]# 30         2
query1 = '''
    Select count(cID)
    From purchase
    Group by pID

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     count(cID)
#[Out]# 0           25
#[Out]# 1           13
#[Out]# 2           10
#[Out]# 3           20
#[Out]# 4           16
#[Out]# 5           16
#[Out]# 6           15
#[Out]# 7           14
#[Out]# 8           13
#[Out]# 9           20
#[Out]# 10          16
#[Out]# 11          16
#[Out]# 12          16
#[Out]# 13          21
#[Out]# 14          18
#[Out]# 15          14
#[Out]# 16          20
#[Out]# 17          18
#[Out]# 18          10
#[Out]# 19          26
#[Out]# 20          18
#[Out]# 21          22
#[Out]# 22          21
#[Out]# 23          13
#[Out]# 24          20
#[Out]# 25          14
#[Out]# 26          20
#[Out]# 27          15
#[Out]# 28          25
#[Out]# 29           2
#[Out]# 30           2
query1 = '''
    Select pID, count(cID)
    From purchase
    Group by pID

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  count(cID)
#[Out]# 0     0          25
#[Out]# 1     1          13
#[Out]# 2     2          10
#[Out]# 3     3          20
#[Out]# 4     4          16
#[Out]# 5     5          16
#[Out]# 6     6          15
#[Out]# 7     7          14
#[Out]# 8     8          13
#[Out]# 9     9          20
#[Out]# 10   10          16
#[Out]# 11   11          16
#[Out]# 12   12          16
#[Out]# 13   13          21
#[Out]# 14   14          18
#[Out]# 15   15          14
#[Out]# 16   16          20
#[Out]# 17   17          18
#[Out]# 18   18          10
#[Out]# 19   19          26
#[Out]# 20   20          18
#[Out]# 21   21          22
#[Out]# 22   22          21
#[Out]# 23   23          13
#[Out]# 24   24          20
#[Out]# 25   25          14
#[Out]# 26   26          20
#[Out]# 27   27          15
#[Out]# 28   28          25
#[Out]# 29   29           2
#[Out]# 30   30           2
query1 = '''
    Select pID, count(cID)
    From purchase
    Group by pID
    Where count(cID) < 2

    
    
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select pID, count(cID)
    From purchase
    Group by pID
    Having cID < 2

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID, count(cID)]
#[Out]# Index: []
query1 = '''
    Select pID, count(cID)
    From purchase
    Group by pID
    Having count(cID) < 2

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID, count(cID)]
#[Out]# Index: []
query1 = '''
    Select pID, count(cID)
    From purchase
    Group by pID
    Having count(cID) < 2

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID, count(cID)]
#[Out]# Index: []
query1 = '''
    Select pID, count(cID)
    From purchase
    Group by pID
    Having count(cID) <= 2

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(cID)
#[Out]# 0   29           2
#[Out]# 1   30           2
query1 = '''
    Select pID, count(cID)
    From purchase
    Group by pID
    Having cID <= 2

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID, count(cID)]
#[Out]# Index: []
query1 = '''
    Select pID, count(cID)
    From purchase
    Group by pID
    Having count(cID) <= 2

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(cID)
#[Out]# 0   29           2
#[Out]# 1   30           2
query1 = '''
    Select pID, count(cID)
    From purchase
    Having count(cID) <= 2

    
    
'''

pd.read_sql_query(query1, conn)
query1 = '''
    Select pID, count(cID)
    From purchase
    Group by pID
    Having count(cID) <= 2

    
    
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(cID)
#[Out]# 0   29           2
#[Out]# 1   30           2

