# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
query4 = '''
SELECT sName
FROM (
    SELECT chain.sName, AVG(purchase.quantity) AS average
    FROM purchase, (
        SELECT s1.sId, s1.sName
        FROM store AS s1, store AS s2
        WHERE s1.sName = s2.sName AND s1.sID != s2.sID) AS chain
    WHERE purchase.sID = chain.sId
    GROUP BY chain.sName)
WHERE average > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
SELECT sName
FROM (
    SELECT chain.sName, AVG(purchase.quantity) AS average
    FROM purchase, (
        SELECT ALL s1.sId, s1.sName
        FROM store AS s1, store AS s2
        WHERE s1.sName = s2.sName AND s1.sID != s2.sID) AS chain
    WHERE purchase.sID = chain.sId
    GROUP BY chain.sName)
WHERE average > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
SELECT product.pID
FROM product
EXCEPT
SELECT p1.pID
FROM purchase AS p1, purchase AS p2, purchase AS p3
WHERE p1.pID = p2.pID AND p2.pID = p3.pID AND p1.cID != p2.cID AND p2.cID != p3.cID AND p1.cID != p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
SELECT customer.cID, customer.cName
FROM customer AS c1, customer AS c2, purchase AS p1, purchase AS p2, purchase AS p3, purchase AS p4
WHERE c1.cID != c2.cID AND
    c1.cID = p1.cID AND c1.cID = p2.cID AND
    c2.cID = p3.cID AND c2.cID = p4.cID AND
	p1.date = p2.date AND p2.date = p3.date AND p3.date = p4.date AND
    p1.pID = (SELECT pID FROM product WHERE pName = 'Onions') AND
    p2.pID = (SELECT pID FROM product WHERE pName = 'Coffee') AND
    p3.pID = (SELECT pID FROM product WHERE pName = 'Onions') AND
    p4.pID = (SELECT pID FROM product WHERE pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c1.cID, c1.cName
FROM customer AS c1, customer AS c2, purchase AS p1, purchase AS p2, purchase AS p3, purchase AS p4
WHERE c1.cID != c2.cID AND
    c1.cID = p1.cID AND c1.cID = p2.cID AND
    c2.cID = p3.cID AND c2.cID = p4.cID AND
	p1.date = p2.date AND p2.date = p3.date AND p3.date = p4.date AND
    p1.pID = (SELECT pID FROM product WHERE pName = 'Onions') AND
    p2.pID = (SELECT pID FROM product WHERE pName = 'Coffee') AND
    p3.pID = (SELECT pID FROM product WHERE pName = 'Onions') AND
    p4.pID = (SELECT pID FROM product WHERE pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query4 = '''

SELECT AVG(purchase.quantity)
FROM purchase, (SELECT s1.sId, s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID) AS sc
WHERE purchase.sID = sc.sId
'''

pd.read_sql_query(query4, conn)
#[Out]#    AVG(purchase.quantity)
#[Out]# 0                 4.77466
query4 = '''
SELECT AVG(purchase.quantity)
FROM purchase, (SELECT s1.sId, s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID) AS sc
WHERE purchase.sID = sc.sId
GROUP BY s1.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT AVG(purchase.quantity)
FROM purchase, (SELECT s1.sId, s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID) AS sc
WHERE purchase.sID = sc.sId
GROUP BY sc.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#    AVG(purchase.quantity)
#[Out]# 0                4.969697
#[Out]# 1                4.681818
#[Out]# 2                5.268293
#[Out]# 3                5.280000
#[Out]# 4                3.888889
#[Out]# 5                4.796875
#[Out]# 6                4.674419
query4 = '''
SELECT sc.sName, AVG(purchase.quantity)
FROM purchase, (SELECT s1.sId, s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID) AS sc
WHERE purchase.sID = sc.sId
GROUP BY sc.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#       sc.sName  AVG(purchase.quantity)
#[Out]# 0  Albert Hein                4.969697
#[Out]# 1         Coop                4.681818
#[Out]# 2         Dirk                5.268293
#[Out]# 3    Hoogvliet                5.280000
#[Out]# 4        Jumbo                3.888889
#[Out]# 5         Lidl                4.796875
#[Out]# 6       Sligro                4.674419
query4 = '''
SELECT sc.sName, AVG(purchase.quantity) AS avg
FROM purchase, (SELECT s1.sId, s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID) AS sc
WHERE purchase.sID = sc.sId AND avg > 4
GROUP BY sc.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT sc.sName, AVG(purchase.quantity) AS average
FROM purchase, (SELECT s1.sId, s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID) AS sc
WHERE purchase.sID = sc.sId AND average > 4
GROUP BY sc.sName
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT sc.sName, AVG(purchase.quantity) AS average
FROM purchase, (SELECT s1.sId, s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID) AS sc
WHERE purchase.sID = sc.sId
GROUP BY sc.sName
'''

pd.read_sql_query(query4, conn)
#[Out]#       sc.sName   average
#[Out]# 0  Albert Hein  4.969697
#[Out]# 1         Coop  4.681818
#[Out]# 2         Dirk  5.268293
#[Out]# 3    Hoogvliet  5.280000
#[Out]# 4        Jumbo  3.888889
#[Out]# 5         Lidl  4.796875
#[Out]# 6       Sligro  4.674419
query4 = '''
SELECT sName
FROM
(SELECT sc.sName, AVG(purchase.quantity) AS average
FROM purchase, (SELECT s1.sId, s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID) AS sc
WHERE purchase.sID = sc.sId
GROUP BY sc.sName)
WHERE average > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x297f8cecea0>
query1 = '''
(SELECT pID FROM product)
EXCEPT
(SELECT pID
FROM purchase AS p1, purchase AS p2, purchase AS p3
WHERE p1.pID = p2.pID AND p2.pID = p3.pID AND p1.cID != p2.cID AND p2.cID != p3.cID AND p1.cID != p3.cID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT pID
FROM product
EXCEPT
SELECT pID
FROM purchase AS p1, purchase AS p2, purchase AS p3
WHERE p1.pID = p2.pID AND p2.pID = p3.pID AND p1.cID != p2.cID AND p2.cID != p3.cID AND p1.cID != p3.cID
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT product.pID
FROM product
EXCEPT
SELECT p1.pID
FROM purchase AS p1, purchase AS p2, purchase AS p3
WHERE p1.pID = p2.pID AND p2.pID = p3.pID AND p1.cID != p2.cID AND p2.cID != p3.cID AND p1.cID != p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
SELECT cID, cName
FROM customer, purchase AS p1, purchase AS p2
WHERE customer.cID = p1.cID AND customer.cID = p2.cID AND
	p1.date = p2.date AND
    p1.pID = (SELECT pID FROM product WHERE pName = 'Onions') AND
    p2.pID = (SELECT pID FROM product WHERE pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT customer.cID, customer.cName
FROM customer, purchase AS p1, purchase AS p2
WHERE customer.cID = p1.cID AND customer.cID = p2.cID AND
	p1.date = p2.date AND
    p1.pID = (SELECT pID FROM product WHERE pName = 'Onions') AND
    p2.pID = (SELECT pID FROM product WHERE pName = 'Coffee')
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
SELECT cID
FROM purchase
WHERE NOT EXISTS (
    (SELECT sID FROM store)
    EXCEPT
    SELECT sID
    FROM purchase
    WHERE purchase.cID = customers.cID)
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT cID
FROM purchase
WHERE NOT EXISTS (
    SELECT sID FROM store
    EXCEPT
    SELECT sID
    FROM purchase
    WHERE purchase.cID = customers.cID)
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT cID
FROM purchase AS p
WHERE NOT EXISTS (
    SELECT sID FROM store
    EXCEPT
    SELECT sID
    FROM purchase
    WHERE purchase.cID = p.cID)
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0   190
#[Out]# 1   190
#[Out]# 2   190
#[Out]# 3   190
#[Out]# 4   190
#[Out]# 5   190
#[Out]# 6   190
#[Out]# 7   190
#[Out]# 8   190
#[Out]# 9   190
#[Out]# 10  190
#[Out]# 11  190
#[Out]# 12  190
#[Out]# 13  190
#[Out]# 14  190
#[Out]# 15  190
#[Out]# 16  190
#[Out]# 17  190
#[Out]# 18  190
#[Out]# 19  190
#[Out]# 20  190
#[Out]# 21  190
#[Out]# 22  190
#[Out]# 23  190
#[Out]# 24  190
#[Out]# 25  190
#[Out]# 26  190
#[Out]# 27  190
#[Out]# 28  190
#[Out]# 29  190
#[Out]# ..  ...
#[Out]# 34  190
#[Out]# 35  190
#[Out]# 36  190
#[Out]# 37  190
#[Out]# 38  190
#[Out]# 39  190
#[Out]# 40  190
#[Out]# 41  190
#[Out]# 42  190
#[Out]# 43  190
#[Out]# 44  190
#[Out]# 45  190
#[Out]# 46  190
#[Out]# 47  190
#[Out]# 48  190
#[Out]# 49  190
#[Out]# 50  190
#[Out]# 51  190
#[Out]# 52  190
#[Out]# 53  190
#[Out]# 54  190
#[Out]# 55  190
#[Out]# 56  190
#[Out]# 57  190
#[Out]# 58  190
#[Out]# 59  190
#[Out]# 60  190
#[Out]# 61  190
#[Out]# 62  190
#[Out]# 63  190
#[Out]# 
#[Out]# [64 rows x 1 columns]
query3 = '''
SELECT cID
FROM customer AS p
WHERE NOT EXISTS (
    SELECT sID FROM store
    EXCEPT
    SELECT sID
    FROM purchase
    WHERE purchase.cID = p.cID)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
SELECT cID
FROM customer AS c
WHERE NOT EXISTS (
    SELECT sID FROM store
    EXCEPT
    SELECT sID
    FROM purchase
    WHERE purchase.cID = c.cID)
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
SELECT sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1         Coop
#[Out]# 2         Coop
#[Out]# 3         Coop
#[Out]# 4         Coop
#[Out]# 5         Coop
#[Out]# 6         Coop
#[Out]# 7         Coop
#[Out]# 8         Coop
#[Out]# 9         Coop
#[Out]# 10        Coop
#[Out]# 11        Coop
#[Out]# 12        Coop
#[Out]# 13   Hoogvliet
#[Out]# 14   Hoogvliet
#[Out]# 15   Hoogvliet
#[Out]# 16   Hoogvliet
#[Out]# 17   Hoogvliet
#[Out]# 18   Hoogvliet
#[Out]# 19   Hoogvliet
#[Out]# 20   Hoogvliet
#[Out]# 21       Jumbo
#[Out]# 22       Jumbo
#[Out]# 23       Jumbo
#[Out]# 24       Jumbo
#[Out]# 25       Jumbo
#[Out]# 26       Jumbo
#[Out]# 27       Jumbo
#[Out]# 28      Sligro
#[Out]# 29      Sligro
#[Out]# ..         ...
#[Out]# 528       Lidl
#[Out]# 529       Lidl
#[Out]# 530       Lidl
#[Out]# 531       Lidl
#[Out]# 532       Lidl
#[Out]# 533       Lidl
#[Out]# 534       Lidl
#[Out]# 535       Lidl
#[Out]# 536       Lidl
#[Out]# 537       Lidl
#[Out]# 538       Lidl
#[Out]# 539       Lidl
#[Out]# 540       Lidl
#[Out]# 541       Lidl
#[Out]# 542       Lidl
#[Out]# 543       Lidl
#[Out]# 544      Jumbo
#[Out]# 545      Jumbo
#[Out]# 546      Jumbo
#[Out]# 547      Jumbo
#[Out]# 548      Jumbo
#[Out]# 549      Jumbo
#[Out]# 550      Jumbo
#[Out]# 551      Jumbo
#[Out]# 552      Jumbo
#[Out]# 553      Jumbo
#[Out]# 554      Jumbo
#[Out]# 555      Jumbo
#[Out]# 556      Jumbo
#[Out]# 557      Jumbo
#[Out]# 
#[Out]# [558 rows x 1 columns]
query4 = '''
SELECT DISTINCT s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2        Jumbo
#[Out]# 3       Sligro
#[Out]# 4  Albert Hein
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query5 = '''
SELECT pID
FROM purchase
WHERE price / quantity = MAX(price / quantity)
'''

pd.read_sql_query(query5, conn)
query5 = '''
SELECT pID
FROM purchase
WHERE price / quantity = (SELECT MAX(price / quantity) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#    pID
#[Out]# 0   18
query5 = '''
SELECT product.pName
FROM purchase
INNER JOIN product ON purchase.pID = product.pID
WHERE price / quantity = (SELECT MAX(price / quantity) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#     pName
#[Out]# 0  Cheese
query6 = '''
SELECT MAX(ABS(p1.unit_price - p2.unit_price))
FROM inventory AS i1, inventory AS i2
WHERE i1.sID != i2.sID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX(ABS(i1.unit_price - i2.unit_price))
FROM inventory AS i1, inventory AS i2
WHERE i1.sID != i2.sID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(ABS(i1.unit_price - i2.unit_price))
#[Out]# 0                                    12.95
query6 = '''
SELECT MAX(ABS(i1.unit_price - i2.unit_price)) AS difference
FROM inventory AS i1, inventory AS i2
WHERE i1.sID != i2.sID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    difference
#[Out]# 0       12.95
query6 = '''
SELECT MAX(ABS(i1.unit_price - i2.unit_price)) AS difference
FROM inventory AS i1, inventory AS i2
WHERE i1.sID != i2.sID AND i1.date = '2018-08-23' AND i2.date = '2018-08-23' AND i1.quantity != 0 AND i2.quantity != 0
'''

pd.read_sql_query(query6, conn)
#[Out]#    difference
#[Out]# 0       12.95
query5 = '''
SELECT product.pName, sName
FROM purchase
INNER JOIN product ON purchase.pID = product.pID
INNER JOIN store ON purchase.sID = store.sID
WHERE price / quantity = (SELECT MAX(price / quantity) FROM purchase)
'''

pd.read_sql_query(query5, conn)
#[Out]#     pName        sName
#[Out]# 0  Cheese  Albert Hein
query4 = '''
SELECT DISTINCT s1.sName, AVG(purchase.quantity)
FROM store AS s1, store AS s2
INNER JOIN purchase ON purchase.sID = s1.sID
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName  AVG(purchase.quantity)
#[Out]# 0  Jumbo                 4.77466
query4 = '''
SELECT DISTINCT s1.sName, AVG(purchase.quantity)
FROM store AS s1, store AS s2
LEFT JOIN purchase ON purchase.sID = s1.sID
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName  AVG(purchase.quantity)
#[Out]# 0  Jumbo                 4.77466
query4 = '''
SELECT s1.pID
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT s1.sID
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#      sID
#[Out]# 0      0
#[Out]# 1      0
#[Out]# 2      0
#[Out]# 3      0
#[Out]# 4      0
#[Out]# 5      0
#[Out]# 6      0
#[Out]# 7      0
#[Out]# 8      0
#[Out]# 9      0
#[Out]# 10     0
#[Out]# 11     0
#[Out]# 12     0
#[Out]# 13     1
#[Out]# 14     1
#[Out]# 15     1
#[Out]# 16     1
#[Out]# 17     1
#[Out]# 18     1
#[Out]# 19     1
#[Out]# 20     1
#[Out]# 21     2
#[Out]# 22     2
#[Out]# 23     2
#[Out]# 24     2
#[Out]# 25     2
#[Out]# 26     2
#[Out]# 27     2
#[Out]# 28     3
#[Out]# 29     3
#[Out]# ..   ...
#[Out]# 528   60
#[Out]# 529   60
#[Out]# 530   60
#[Out]# 531   60
#[Out]# 532   60
#[Out]# 533   60
#[Out]# 534   60
#[Out]# 535   61
#[Out]# 536   61
#[Out]# 537   61
#[Out]# 538   61
#[Out]# 539   61
#[Out]# 540   61
#[Out]# 541   61
#[Out]# 542   61
#[Out]# 543   61
#[Out]# 544   62
#[Out]# 545   62
#[Out]# 546   62
#[Out]# 547   62
#[Out]# 548   62
#[Out]# 549   62
#[Out]# 550   62
#[Out]# 551   63
#[Out]# 552   63
#[Out]# 553   63
#[Out]# 554   63
#[Out]# 555   63
#[Out]# 556   63
#[Out]# 557   63
#[Out]# 
#[Out]# [558 rows x 1 columns]
query4 = '''
SELECT DISTINCT s1.sID
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# ..  ...
#[Out]# 34   34
#[Out]# 35   35
#[Out]# 36   36
#[Out]# 37   37
#[Out]# 38   38
#[Out]# 39   39
#[Out]# 40   40
#[Out]# 41   41
#[Out]# 42   42
#[Out]# 43   43
#[Out]# 44   44
#[Out]# 45   45
#[Out]# 46   46
#[Out]# 47   47
#[Out]# 48   48
#[Out]# 49   49
#[Out]# 50   50
#[Out]# 51   51
#[Out]# 52   52
#[Out]# 53   53
#[Out]# 54   54
#[Out]# 55   55
#[Out]# 56   56
#[Out]# 57   57
#[Out]# 58   58
#[Out]# 59   59
#[Out]# 60   60
#[Out]# 61   61
#[Out]# 62   62
#[Out]# 63   63
#[Out]# 
#[Out]# [64 rows x 1 columns]
query4 = '''
SELECT DISTINCT s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2        Jumbo
#[Out]# 3       Sligro
#[Out]# 4  Albert Hein
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''

SELECT DISTINCT s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2        Jumbo
#[Out]# 3       Sligro
#[Out]# 4  Albert Hein
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
//TODO
SELECT DISTINCT s1.sName
FROM store AS s1, store AS s2
WHERE s1.sName = s2.sName AND s1.sID != s2.sID
'''

pd.read_sql_query(query4, conn)

