# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x17b850cff10>
query1 = '''
    SELECT *
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT *
    FROM *
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT *;
    FROM *;
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT *;
    FROM shopping
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT *;
    FROM customer
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT *
    FROM customer
'''

pd.read_sql_query(query1, conn)
#[Out]#      cID     cName                street       city
#[Out]# 0      0      Noah             Koestraat    Utrecht
#[Out]# 1      1       Sem      Rozemarijnstraat      Breda
#[Out]# 2      2     Lucas      Oude Leliestraat  Amsterdam
#[Out]# 3      3      Finn         Stationsplein      Breda
#[Out]# 4      4      Daan          Kalverstraat  Amsterdam
#[Out]# 5      5      Levi        Gasthuisstraat    Utrecht
#[Out]# 6      6     Milan           Parallelweg    Utrecht
#[Out]# 7      7      Bram          Schoolstraat  Eindhoven
#[Out]# 8      8      Liam         Rijsbergseweg      Breda
#[Out]# 9      9    Thomas           Parallelweg  Amsterdam
#[Out]# 10    10       Sam           Langestraat    Tilburg
#[Out]# 11    11     Thijs             Koestraat    Tilburg
#[Out]# 12    12      Adam           Nieuwstraat  Eindhoven
#[Out]# 13    13     James       Sint Annastraat      Breda
#[Out]# 14    14       Max             Eikenlaan    Tilburg
#[Out]# 15    15      Noud          Koningshoeve    Tilburg
#[Out]# 16    16    Julian  Prins Bernhardstraat  Eindhoven
#[Out]# 17    17       Dex          Kasteeldreef    Tilburg
#[Out]# 18    18      Hugo          Kasteeldreef    Tilburg
#[Out]# 19    19      Lars         Rijsbergseweg      Breda
#[Out]# 20    20      Gijs            Heiligeweg  Amsterdam
#[Out]# 21    21  Benjamin           Stationsweg    Tilburg
#[Out]# 22    22      Mats           Molenstraat  Eindhoven
#[Out]# 23    23       Jan       Sint Annastraat      Breda
#[Out]# 24    24      Luca          Kasteeldreef    Tilburg
#[Out]# 25    25     Mason          Keizerstraat  Rotterdam
#[Out]# 26    26    Jayden          Schoolstraat  Eindhoven
#[Out]# 27    27       Tim             Koestraat    Utrecht
#[Out]# 28    28      Siem           Langestraat    Tilburg
#[Out]# 29    29     Ruben              Hofplein  Rotterdam
#[Out]# ..   ...       ...                   ...        ...
#[Out]# 160  160      Lara           Langestraat    Tilburg
#[Out]# 161  161     Floor             Eikenlaan    Tilburg
#[Out]# 162  162     Elena            Bergselaan  Rotterdam
#[Out]# 163  163      Cato          Kastanjelaan    Tilburg
#[Out]# 164  164       Evy      Rozemarijnstraat      Breda
#[Out]# 165  165     Hanna             Eikenlaan    Tilburg
#[Out]# 166  166   Rosalie           Stationsweg  Eindhoven
#[Out]# 167  167    Veerle        Ginnekenstraat      Breda
#[Out]# 168  168      Kiki          Keizerstraat  Rotterdam
#[Out]# 169  169      Lily        Gasthuisstraat    Utrecht
#[Out]# 170  170      Iris          Kastanjelaan  Eindhoven
#[Out]# 171  171     Tessa           Haringvliet  Rotterdam
#[Out]# 172  172      Lana             Eikenlaan    Tilburg
#[Out]# 173  173     Livia      Vierwindenstraat      Breda
#[Out]# 174  174      Romy           Parallelweg  Eindhoven
#[Out]# 175  175       Sam             Bredalaan  Eindhoven
#[Out]# 176  176     Amira           Parallelweg  Amsterdam
#[Out]# 177  177     Eline          Kalverstraat  Amsterdam
#[Out]# 178  178      Elif           Parallelweg    Utrecht
#[Out]# 179  179      Juul        Wilhelminapark    Tilburg
#[Out]# 180  180     Merel          Kalverstraat  Amsterdam
#[Out]# 181  181      Liva           Fredriklaan  Eindhoven
#[Out]# 182  182   Johanna         Beatrixstraat  Eindhoven
#[Out]# 183  183     Nikki         Julianastraat    Utrecht
#[Out]# 184  184     Wilko          Onbekendeweg  Eindhoven
#[Out]# 185  185      Nick                Verweg  Eindhoven
#[Out]# 186  186    Angela              Dichtweg  Eindhoven
#[Out]# 187  188      Pino            Maanstraat  Rotterdam
#[Out]# 188  189      Koen              Akkerweg        Oss
#[Out]# 189  190    Kostas              Eindeweg    Utrecht
#[Out]# 
#[Out]# [190 rows x 4 columns]
query1 = '''
    SELECT *
    FROM customer, inventory
'''

pd.read_sql_query(query1, conn)
#[Out]#         cID   cName     street     city  sID  pID        date  quantity  \
#[Out]# 0         0    Noah  Koestraat  Utrecht   55   10  2018-08-26        17   
#[Out]# 1         0    Noah  Koestraat  Utrecht   25   12  2018-08-24        30   
#[Out]# 2         0    Noah  Koestraat  Utrecht   15    6  2018-08-26        13   
#[Out]# 3         0    Noah  Koestraat  Utrecht    6   27  2018-08-19        51   
#[Out]# 4         0    Noah  Koestraat  Utrecht   57    2  2018-08-22        24   
#[Out]# 5         0    Noah  Koestraat  Utrecht   33    8  2018-08-19        46   
#[Out]# 6         0    Noah  Koestraat  Utrecht   51   10  2018-08-23        31   
#[Out]# 7         0    Noah  Koestraat  Utrecht   50   21  2018-08-22        32   
#[Out]# 8         0    Noah  Koestraat  Utrecht    0   13  2018-08-25        13   
#[Out]# 9         0    Noah  Koestraat  Utrecht   36    8  2018-08-27        11   
#[Out]# 10        0    Noah  Koestraat  Utrecht   36   23  2018-08-18        35   
#[Out]# 11        0    Noah  Koestraat  Utrecht   54   10  2018-08-24        16   
#[Out]# 12        0    Noah  Koestraat  Utrecht   59    1  2018-08-26        36   
#[Out]# 13        0    Noah  Koestraat  Utrecht    9   19  2018-08-22        28   
#[Out]# 14        0    Noah  Koestraat  Utrecht   33    7  2018-08-26         5   
#[Out]# 15        0    Noah  Koestraat  Utrecht   35   10  2018-08-21        51   
#[Out]# 16        0    Noah  Koestraat  Utrecht    0   21  2018-08-15         0   
#[Out]# 17        0    Noah  Koestraat  Utrecht   31   14  2018-08-17        10   
#[Out]# 18        0    Noah  Koestraat  Utrecht   19   14  2018-08-20        42   
#[Out]# 19        0    Noah  Koestraat  Utrecht   33   20  2018-08-21        51   
#[Out]# 20        0    Noah  Koestraat  Utrecht   17   24  2018-08-16        44   
#[Out]# 21        0    Noah  Koestraat  Utrecht    4   27  2018-08-18        27   
#[Out]# 22        0    Noah  Koestraat  Utrecht    3   25  2018-08-27        24   
#[Out]# 23        0    Noah  Koestraat  Utrecht   22   15  2018-08-20         4   
#[Out]# 24        0    Noah  Koestraat  Utrecht   52   14  2018-08-18        44   
#[Out]# 25        0    Noah  Koestraat  Utrecht   24   26  2018-08-25        18   
#[Out]# 26        0    Noah  Koestraat  Utrecht    7   12  2018-08-20        13   
#[Out]# 27        0    Noah  Koestraat  Utrecht   32   18  2018-08-21        41   
#[Out]# 28        0    Noah  Koestraat  Utrecht   48   24  2018-08-19        10   
#[Out]# 29        0    Noah  Koestraat  Utrecht   54    8  2018-08-17         3   
#[Out]# ...     ...     ...        ...      ...  ...  ...         ...       ...   
#[Out]# 157480  190  Kostas   Eindeweg  Utrecht   35    0  2018-08-25         1   
#[Out]# 157481  190  Kostas   Eindeweg  Utrecht   19   11  2018-08-25         9   
#[Out]# 157482  190  Kostas   Eindeweg  Utrecht    4   21  2018-08-25         9   
#[Out]# 157483  190  Kostas   Eindeweg  Utrecht    6    5  2018-08-26         6   
#[Out]# 157484  190  Kostas   Eindeweg  Utrecht   47   18  2018-08-20        12   
#[Out]# 157485  190  Kostas   Eindeweg  Utrecht   38   17  2018-08-20        10   
#[Out]# 157486  190  Kostas   Eindeweg  Utrecht   11    3  2018-08-21        15   
#[Out]# 157487  190  Kostas   Eindeweg  Utrecht   34   26  2018-08-21        14   
#[Out]# 157488  190  Kostas   Eindeweg  Utrecht   34   25  2018-08-27        17   
#[Out]# 157489  190  Kostas   Eindeweg  Utrecht   25   14  2018-08-24         3   
#[Out]# 157490  190  Kostas   Eindeweg  Utrecht   24   11  2018-08-24         1   
#[Out]# 157491  190  Kostas   Eindeweg  Utrecht   57   17  2018-08-24         4   
#[Out]# 157492  190  Kostas   Eindeweg  Utrecht   43   27  2018-08-22        15   
#[Out]# 157493  190  Kostas   Eindeweg  Utrecht   35   16  2018-08-22         8   
#[Out]# 157494  190  Kostas   Eindeweg  Utrecht   45   10  2018-08-22        21   
#[Out]# 157495  190  Kostas   Eindeweg  Utrecht   34   26  2018-08-26         9   
#[Out]# 157496  190  Kostas   Eindeweg  Utrecht   34   13  2018-08-26         3   
#[Out]# 157497  190  Kostas   Eindeweg  Utrecht   56   10  2018-08-27         1   
#[Out]# 157498  190  Kostas   Eindeweg  Utrecht    6   26  2018-08-24        13   
#[Out]# 157499  190  Kostas   Eindeweg  Utrecht   45    6  2018-08-24         9   
#[Out]# 157500  190  Kostas   Eindeweg  Utrecht   27   21  2018-08-27         1   
#[Out]# 157501  190  Kostas   Eindeweg  Utrecht   17   25  2018-08-27        14   
#[Out]# 157502  190  Kostas   Eindeweg  Utrecht    5   18  2018-08-28         1   
#[Out]# 157503  190  Kostas   Eindeweg  Utrecht    5    3  2018-08-28        13   
#[Out]# 157504  190  Kostas   Eindeweg  Utrecht    4   13  2018-08-23        23   
#[Out]# 157505  190  Kostas   Eindeweg  Utrecht   27   10  2018-08-20         7   
#[Out]# 157506  190  Kostas   Eindeweg  Utrecht   45   18  2018-08-21         5   
#[Out]# 157507  190  Kostas   Eindeweg  Utrecht   57    6  2018-08-22         9   
#[Out]# 157508  190  Kostas   Eindeweg  Utrecht   60   19  2018-07-10       525   
#[Out]# 157509  190  Kostas   Eindeweg  Utrecht    0    0  2018-07-18        15   
#[Out]# 
#[Out]#         unit_price  
#[Out]# 0             0.60  
#[Out]# 1            14.80  
#[Out]# 2             1.15  
#[Out]# 3             7.30  
#[Out]# 4             2.05  
#[Out]# 5             5.70  
#[Out]# 6             0.60  
#[Out]# 7             1.90  
#[Out]# 8             3.05  
#[Out]# 9             5.05  
#[Out]# 10            2.20  
#[Out]# 11            0.55  
#[Out]# 12            6.20  
#[Out]# 13            2.50  
#[Out]# 14            1.60  
#[Out]# 15            0.55  
#[Out]# 16            2.20  
#[Out]# 17            4.50  
#[Out]# 18            4.70  
#[Out]# 19            2.15  
#[Out]# 20            2.85  
#[Out]# 21            9.00  
#[Out]# 22            4.60  
#[Out]# 23            1.30  
#[Out]# 24            4.25  
#[Out]# 25            2.90  
#[Out]# 26           12.55  
#[Out]# 27           11.85  
#[Out]# 28            3.20  
#[Out]# 29            5.55  
#[Out]# ...            ...  
#[Out]# 157480        4.35  
#[Out]# 157481        0.90  
#[Out]# 157482        2.15  
#[Out]# 157483        0.50  
#[Out]# 157484        8.85  
#[Out]# 157485        2.30  
#[Out]# 157486        1.30  
#[Out]# 157487        3.40  
#[Out]# 157488        3.60  
#[Out]# 157489        3.70  
#[Out]# 157490        0.85  
#[Out]# 157491        2.40  
#[Out]# 157492        9.00  
#[Out]# 157493        1.85  
#[Out]# 157494        0.45  
#[Out]# 157495        3.10  
#[Out]# 157496        4.05  
#[Out]# 157497        0.60  
#[Out]# 157498        2.70  
#[Out]# 157499        0.90  
#[Out]# 157500        2.00  
#[Out]# 157501        3.90  
#[Out]# 157502        9.70  
#[Out]# 157503        1.30  
#[Out]# 157504        4.20  
#[Out]# 157505        0.55  
#[Out]# 157506        9.20  
#[Out]# 157507        1.15  
#[Out]# 157508        1.75  
#[Out]# 157509        5.95  
#[Out]# 
#[Out]# [157510 rows x 9 columns]
query1 = '''
    SELECT *
    FROM customer
'''

pd.read_sql_query(query1, conn)
#[Out]#      cID     cName                street       city
#[Out]# 0      0      Noah             Koestraat    Utrecht
#[Out]# 1      1       Sem      Rozemarijnstraat      Breda
#[Out]# 2      2     Lucas      Oude Leliestraat  Amsterdam
#[Out]# 3      3      Finn         Stationsplein      Breda
#[Out]# 4      4      Daan          Kalverstraat  Amsterdam
#[Out]# 5      5      Levi        Gasthuisstraat    Utrecht
#[Out]# 6      6     Milan           Parallelweg    Utrecht
#[Out]# 7      7      Bram          Schoolstraat  Eindhoven
#[Out]# 8      8      Liam         Rijsbergseweg      Breda
#[Out]# 9      9    Thomas           Parallelweg  Amsterdam
#[Out]# 10    10       Sam           Langestraat    Tilburg
#[Out]# 11    11     Thijs             Koestraat    Tilburg
#[Out]# 12    12      Adam           Nieuwstraat  Eindhoven
#[Out]# 13    13     James       Sint Annastraat      Breda
#[Out]# 14    14       Max             Eikenlaan    Tilburg
#[Out]# 15    15      Noud          Koningshoeve    Tilburg
#[Out]# 16    16    Julian  Prins Bernhardstraat  Eindhoven
#[Out]# 17    17       Dex          Kasteeldreef    Tilburg
#[Out]# 18    18      Hugo          Kasteeldreef    Tilburg
#[Out]# 19    19      Lars         Rijsbergseweg      Breda
#[Out]# 20    20      Gijs            Heiligeweg  Amsterdam
#[Out]# 21    21  Benjamin           Stationsweg    Tilburg
#[Out]# 22    22      Mats           Molenstraat  Eindhoven
#[Out]# 23    23       Jan       Sint Annastraat      Breda
#[Out]# 24    24      Luca          Kasteeldreef    Tilburg
#[Out]# 25    25     Mason          Keizerstraat  Rotterdam
#[Out]# 26    26    Jayden          Schoolstraat  Eindhoven
#[Out]# 27    27       Tim             Koestraat    Utrecht
#[Out]# 28    28      Siem           Langestraat    Tilburg
#[Out]# 29    29     Ruben              Hofplein  Rotterdam
#[Out]# ..   ...       ...                   ...        ...
#[Out]# 160  160      Lara           Langestraat    Tilburg
#[Out]# 161  161     Floor             Eikenlaan    Tilburg
#[Out]# 162  162     Elena            Bergselaan  Rotterdam
#[Out]# 163  163      Cato          Kastanjelaan    Tilburg
#[Out]# 164  164       Evy      Rozemarijnstraat      Breda
#[Out]# 165  165     Hanna             Eikenlaan    Tilburg
#[Out]# 166  166   Rosalie           Stationsweg  Eindhoven
#[Out]# 167  167    Veerle        Ginnekenstraat      Breda
#[Out]# 168  168      Kiki          Keizerstraat  Rotterdam
#[Out]# 169  169      Lily        Gasthuisstraat    Utrecht
#[Out]# 170  170      Iris          Kastanjelaan  Eindhoven
#[Out]# 171  171     Tessa           Haringvliet  Rotterdam
#[Out]# 172  172      Lana             Eikenlaan    Tilburg
#[Out]# 173  173     Livia      Vierwindenstraat      Breda
#[Out]# 174  174      Romy           Parallelweg  Eindhoven
#[Out]# 175  175       Sam             Bredalaan  Eindhoven
#[Out]# 176  176     Amira           Parallelweg  Amsterdam
#[Out]# 177  177     Eline          Kalverstraat  Amsterdam
#[Out]# 178  178      Elif           Parallelweg    Utrecht
#[Out]# 179  179      Juul        Wilhelminapark    Tilburg
#[Out]# 180  180     Merel          Kalverstraat  Amsterdam
#[Out]# 181  181      Liva           Fredriklaan  Eindhoven
#[Out]# 182  182   Johanna         Beatrixstraat  Eindhoven
#[Out]# 183  183     Nikki         Julianastraat    Utrecht
#[Out]# 184  184     Wilko          Onbekendeweg  Eindhoven
#[Out]# 185  185      Nick                Verweg  Eindhoven
#[Out]# 186  186    Angela              Dichtweg  Eindhoven
#[Out]# 187  188      Pino            Maanstraat  Rotterdam
#[Out]# 188  189      Koen              Akkerweg        Oss
#[Out]# 189  190    Kostas              Eindeweg    Utrecht
#[Out]# 
#[Out]# [190 rows x 4 columns]
query1 = '''
    SELECT count(street)
    FROM customer
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(street)
#[Out]# 0            190
query1 = '''
    SELECT *
    FROM customer

'''

pd.read_sql_query(query1, conn)
#[Out]#      cID     cName                street       city
#[Out]# 0      0      Noah             Koestraat    Utrecht
#[Out]# 1      1       Sem      Rozemarijnstraat      Breda
#[Out]# 2      2     Lucas      Oude Leliestraat  Amsterdam
#[Out]# 3      3      Finn         Stationsplein      Breda
#[Out]# 4      4      Daan          Kalverstraat  Amsterdam
#[Out]# 5      5      Levi        Gasthuisstraat    Utrecht
#[Out]# 6      6     Milan           Parallelweg    Utrecht
#[Out]# 7      7      Bram          Schoolstraat  Eindhoven
#[Out]# 8      8      Liam         Rijsbergseweg      Breda
#[Out]# 9      9    Thomas           Parallelweg  Amsterdam
#[Out]# 10    10       Sam           Langestraat    Tilburg
#[Out]# 11    11     Thijs             Koestraat    Tilburg
#[Out]# 12    12      Adam           Nieuwstraat  Eindhoven
#[Out]# 13    13     James       Sint Annastraat      Breda
#[Out]# 14    14       Max             Eikenlaan    Tilburg
#[Out]# 15    15      Noud          Koningshoeve    Tilburg
#[Out]# 16    16    Julian  Prins Bernhardstraat  Eindhoven
#[Out]# 17    17       Dex          Kasteeldreef    Tilburg
#[Out]# 18    18      Hugo          Kasteeldreef    Tilburg
#[Out]# 19    19      Lars         Rijsbergseweg      Breda
#[Out]# 20    20      Gijs            Heiligeweg  Amsterdam
#[Out]# 21    21  Benjamin           Stationsweg    Tilburg
#[Out]# 22    22      Mats           Molenstraat  Eindhoven
#[Out]# 23    23       Jan       Sint Annastraat      Breda
#[Out]# 24    24      Luca          Kasteeldreef    Tilburg
#[Out]# 25    25     Mason          Keizerstraat  Rotterdam
#[Out]# 26    26    Jayden          Schoolstraat  Eindhoven
#[Out]# 27    27       Tim             Koestraat    Utrecht
#[Out]# 28    28      Siem           Langestraat    Tilburg
#[Out]# 29    29     Ruben              Hofplein  Rotterdam
#[Out]# ..   ...       ...                   ...        ...
#[Out]# 160  160      Lara           Langestraat    Tilburg
#[Out]# 161  161     Floor             Eikenlaan    Tilburg
#[Out]# 162  162     Elena            Bergselaan  Rotterdam
#[Out]# 163  163      Cato          Kastanjelaan    Tilburg
#[Out]# 164  164       Evy      Rozemarijnstraat      Breda
#[Out]# 165  165     Hanna             Eikenlaan    Tilburg
#[Out]# 166  166   Rosalie           Stationsweg  Eindhoven
#[Out]# 167  167    Veerle        Ginnekenstraat      Breda
#[Out]# 168  168      Kiki          Keizerstraat  Rotterdam
#[Out]# 169  169      Lily        Gasthuisstraat    Utrecht
#[Out]# 170  170      Iris          Kastanjelaan  Eindhoven
#[Out]# 171  171     Tessa           Haringvliet  Rotterdam
#[Out]# 172  172      Lana             Eikenlaan    Tilburg
#[Out]# 173  173     Livia      Vierwindenstraat      Breda
#[Out]# 174  174      Romy           Parallelweg  Eindhoven
#[Out]# 175  175       Sam             Bredalaan  Eindhoven
#[Out]# 176  176     Amira           Parallelweg  Amsterdam
#[Out]# 177  177     Eline          Kalverstraat  Amsterdam
#[Out]# 178  178      Elif           Parallelweg    Utrecht
#[Out]# 179  179      Juul        Wilhelminapark    Tilburg
#[Out]# 180  180     Merel          Kalverstraat  Amsterdam
#[Out]# 181  181      Liva           Fredriklaan  Eindhoven
#[Out]# 182  182   Johanna         Beatrixstraat  Eindhoven
#[Out]# 183  183     Nikki         Julianastraat    Utrecht
#[Out]# 184  184     Wilko          Onbekendeweg  Eindhoven
#[Out]# 185  185      Nick                Verweg  Eindhoven
#[Out]# 186  186    Angela              Dichtweg  Eindhoven
#[Out]# 187  188      Pino            Maanstraat  Rotterdam
#[Out]# 188  189      Koen              Akkerweg        Oss
#[Out]# 189  190    Kostas              Eindeweg    Utrecht
#[Out]# 
#[Out]# [190 rows x 4 columns]
query1 = '''
    SELECT count(street)
    FROM customer
    WHERE street = "Koestraat"
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(street)
#[Out]# 0             12
query1 = '''
    SELECT *
    FROM customer
'''

pd.read_sql_query(query1, conn)
#[Out]#      cID     cName                street       city
#[Out]# 0      0      Noah             Koestraat    Utrecht
#[Out]# 1      1       Sem      Rozemarijnstraat      Breda
#[Out]# 2      2     Lucas      Oude Leliestraat  Amsterdam
#[Out]# 3      3      Finn         Stationsplein      Breda
#[Out]# 4      4      Daan          Kalverstraat  Amsterdam
#[Out]# 5      5      Levi        Gasthuisstraat    Utrecht
#[Out]# 6      6     Milan           Parallelweg    Utrecht
#[Out]# 7      7      Bram          Schoolstraat  Eindhoven
#[Out]# 8      8      Liam         Rijsbergseweg      Breda
#[Out]# 9      9    Thomas           Parallelweg  Amsterdam
#[Out]# 10    10       Sam           Langestraat    Tilburg
#[Out]# 11    11     Thijs             Koestraat    Tilburg
#[Out]# 12    12      Adam           Nieuwstraat  Eindhoven
#[Out]# 13    13     James       Sint Annastraat      Breda
#[Out]# 14    14       Max             Eikenlaan    Tilburg
#[Out]# 15    15      Noud          Koningshoeve    Tilburg
#[Out]# 16    16    Julian  Prins Bernhardstraat  Eindhoven
#[Out]# 17    17       Dex          Kasteeldreef    Tilburg
#[Out]# 18    18      Hugo          Kasteeldreef    Tilburg
#[Out]# 19    19      Lars         Rijsbergseweg      Breda
#[Out]# 20    20      Gijs            Heiligeweg  Amsterdam
#[Out]# 21    21  Benjamin           Stationsweg    Tilburg
#[Out]# 22    22      Mats           Molenstraat  Eindhoven
#[Out]# 23    23       Jan       Sint Annastraat      Breda
#[Out]# 24    24      Luca          Kasteeldreef    Tilburg
#[Out]# 25    25     Mason          Keizerstraat  Rotterdam
#[Out]# 26    26    Jayden          Schoolstraat  Eindhoven
#[Out]# 27    27       Tim             Koestraat    Utrecht
#[Out]# 28    28      Siem           Langestraat    Tilburg
#[Out]# 29    29     Ruben              Hofplein  Rotterdam
#[Out]# ..   ...       ...                   ...        ...
#[Out]# 160  160      Lara           Langestraat    Tilburg
#[Out]# 161  161     Floor             Eikenlaan    Tilburg
#[Out]# 162  162     Elena            Bergselaan  Rotterdam
#[Out]# 163  163      Cato          Kastanjelaan    Tilburg
#[Out]# 164  164       Evy      Rozemarijnstraat      Breda
#[Out]# 165  165     Hanna             Eikenlaan    Tilburg
#[Out]# 166  166   Rosalie           Stationsweg  Eindhoven
#[Out]# 167  167    Veerle        Ginnekenstraat      Breda
#[Out]# 168  168      Kiki          Keizerstraat  Rotterdam
#[Out]# 169  169      Lily        Gasthuisstraat    Utrecht
#[Out]# 170  170      Iris          Kastanjelaan  Eindhoven
#[Out]# 171  171     Tessa           Haringvliet  Rotterdam
#[Out]# 172  172      Lana             Eikenlaan    Tilburg
#[Out]# 173  173     Livia      Vierwindenstraat      Breda
#[Out]# 174  174      Romy           Parallelweg  Eindhoven
#[Out]# 175  175       Sam             Bredalaan  Eindhoven
#[Out]# 176  176     Amira           Parallelweg  Amsterdam
#[Out]# 177  177     Eline          Kalverstraat  Amsterdam
#[Out]# 178  178      Elif           Parallelweg    Utrecht
#[Out]# 179  179      Juul        Wilhelminapark    Tilburg
#[Out]# 180  180     Merel          Kalverstraat  Amsterdam
#[Out]# 181  181      Liva           Fredriklaan  Eindhoven
#[Out]# 182  182   Johanna         Beatrixstraat  Eindhoven
#[Out]# 183  183     Nikki         Julianastraat    Utrecht
#[Out]# 184  184     Wilko          Onbekendeweg  Eindhoven
#[Out]# 185  185      Nick                Verweg  Eindhoven
#[Out]# 186  186    Angela              Dichtweg  Eindhoven
#[Out]# 187  188      Pino            Maanstraat  Rotterdam
#[Out]# 188  189      Koen              Akkerweg        Oss
#[Out]# 189  190    Kostas              Eindeweg    Utrecht
#[Out]# 
#[Out]# [190 rows x 4 columns]
query1 = '''
    SELECT count(*)
    FROM customer
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(*)
#[Out]# 0       190
query1 = '''
    SELECT *
    FROM customer
'''

pd.read_sql_query(query1, conn)
#[Out]#      cID     cName                street       city
#[Out]# 0      0      Noah             Koestraat    Utrecht
#[Out]# 1      1       Sem      Rozemarijnstraat      Breda
#[Out]# 2      2     Lucas      Oude Leliestraat  Amsterdam
#[Out]# 3      3      Finn         Stationsplein      Breda
#[Out]# 4      4      Daan          Kalverstraat  Amsterdam
#[Out]# 5      5      Levi        Gasthuisstraat    Utrecht
#[Out]# 6      6     Milan           Parallelweg    Utrecht
#[Out]# 7      7      Bram          Schoolstraat  Eindhoven
#[Out]# 8      8      Liam         Rijsbergseweg      Breda
#[Out]# 9      9    Thomas           Parallelweg  Amsterdam
#[Out]# 10    10       Sam           Langestraat    Tilburg
#[Out]# 11    11     Thijs             Koestraat    Tilburg
#[Out]# 12    12      Adam           Nieuwstraat  Eindhoven
#[Out]# 13    13     James       Sint Annastraat      Breda
#[Out]# 14    14       Max             Eikenlaan    Tilburg
#[Out]# 15    15      Noud          Koningshoeve    Tilburg
#[Out]# 16    16    Julian  Prins Bernhardstraat  Eindhoven
#[Out]# 17    17       Dex          Kasteeldreef    Tilburg
#[Out]# 18    18      Hugo          Kasteeldreef    Tilburg
#[Out]# 19    19      Lars         Rijsbergseweg      Breda
#[Out]# 20    20      Gijs            Heiligeweg  Amsterdam
#[Out]# 21    21  Benjamin           Stationsweg    Tilburg
#[Out]# 22    22      Mats           Molenstraat  Eindhoven
#[Out]# 23    23       Jan       Sint Annastraat      Breda
#[Out]# 24    24      Luca          Kasteeldreef    Tilburg
#[Out]# 25    25     Mason          Keizerstraat  Rotterdam
#[Out]# 26    26    Jayden          Schoolstraat  Eindhoven
#[Out]# 27    27       Tim             Koestraat    Utrecht
#[Out]# 28    28      Siem           Langestraat    Tilburg
#[Out]# 29    29     Ruben              Hofplein  Rotterdam
#[Out]# ..   ...       ...                   ...        ...
#[Out]# 160  160      Lara           Langestraat    Tilburg
#[Out]# 161  161     Floor             Eikenlaan    Tilburg
#[Out]# 162  162     Elena            Bergselaan  Rotterdam
#[Out]# 163  163      Cato          Kastanjelaan    Tilburg
#[Out]# 164  164       Evy      Rozemarijnstraat      Breda
#[Out]# 165  165     Hanna             Eikenlaan    Tilburg
#[Out]# 166  166   Rosalie           Stationsweg  Eindhoven
#[Out]# 167  167    Veerle        Ginnekenstraat      Breda
#[Out]# 168  168      Kiki          Keizerstraat  Rotterdam
#[Out]# 169  169      Lily        Gasthuisstraat    Utrecht
#[Out]# 170  170      Iris          Kastanjelaan  Eindhoven
#[Out]# 171  171     Tessa           Haringvliet  Rotterdam
#[Out]# 172  172      Lana             Eikenlaan    Tilburg
#[Out]# 173  173     Livia      Vierwindenstraat      Breda
#[Out]# 174  174      Romy           Parallelweg  Eindhoven
#[Out]# 175  175       Sam             Bredalaan  Eindhoven
#[Out]# 176  176     Amira           Parallelweg  Amsterdam
#[Out]# 177  177     Eline          Kalverstraat  Amsterdam
#[Out]# 178  178      Elif           Parallelweg    Utrecht
#[Out]# 179  179      Juul        Wilhelminapark    Tilburg
#[Out]# 180  180     Merel          Kalverstraat  Amsterdam
#[Out]# 181  181      Liva           Fredriklaan  Eindhoven
#[Out]# 182  182   Johanna         Beatrixstraat  Eindhoven
#[Out]# 183  183     Nikki         Julianastraat    Utrecht
#[Out]# 184  184     Wilko          Onbekendeweg  Eindhoven
#[Out]# 185  185      Nick                Verweg  Eindhoven
#[Out]# 186  186    Angela              Dichtweg  Eindhoven
#[Out]# 187  188      Pino            Maanstraat  Rotterdam
#[Out]# 188  189      Koen              Akkerweg        Oss
#[Out]# 189  190    Kostas              Eindeweg    Utrecht
#[Out]# 
#[Out]# [190 rows x 4 columns]
query1 = '''
    SELECT pID
    FROM purchase
    group by pID
    HAVING count(distinct pID) < 3
    UNION
    SELECT pID
    FROM product
    WHERE product.pID not in (
    SELECT pID
    FROM purchase
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
#[Out]# 29   29
#[Out]# 30   30
#[Out]# 31   31
query1 = '''
    SELECT pID, count(distinct pID)
    FROM purchase
    group by pID
    HAVING count(distinct pID) < 3
    UNION
    SELECT pID
    FROM product
    WHERE product.pID not in (
    SELECT pID
    FROM purchase
    )
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID, count(distinct cID)
    FROM purchase
    group by pID
    HAVING count(distinct pID) < 3
    UNION
    SELECT pID
    FROM product
    WHERE product.pID not in (
    SELECT pID
    FROM purchase
    )
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID, count(distinct cID)
    FROM purchase
    group by pID
    HAVING count(distinct pID) < 3
    UNION
    SELECT pID, 0
    FROM product
    WHERE product.pID not in (
    SELECT pID
    FROM purchase
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID  count(distinct cID)
#[Out]# 0     0                   22
#[Out]# 1     1                   13
#[Out]# 2     2                    9
#[Out]# 3     3                   20
#[Out]# 4     4                   16
#[Out]# 5     5                   14
#[Out]# 6     6                   15
#[Out]# 7     7                   13
#[Out]# 8     8                   12
#[Out]# 9     9                   18
#[Out]# 10   10                   14
#[Out]# 11   11                   13
#[Out]# 12   12                   16
#[Out]# 13   13                   21
#[Out]# 14   14                   18
#[Out]# 15   15                   13
#[Out]# 16   16                   20
#[Out]# 17   17                   13
#[Out]# 18   18                   10
#[Out]# 19   19                   20
#[Out]# 20   20                   16
#[Out]# 21   21                   19
#[Out]# 22   22                   20
#[Out]# 23   23                   11
#[Out]# 24   24                   20
#[Out]# 25   25                   14
#[Out]# 26   26                   19
#[Out]# 27   27                   13
#[Out]# 28   28                   23
#[Out]# 29   29                    2
#[Out]# 30   30                    1
#[Out]# 31   31                    0
query1 = '''
    SELECT pID, count(distinct cID)
    FROM purchase
    group by pID
    HAVING count(distinct cID) < 3
    UNION
    SELECT pID, 0
    FROM product
    WHERE product.pID not in (
    SELECT pID
    FROM purchase
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(distinct cID)
#[Out]# 0   29                    2
#[Out]# 1   30                    1
#[Out]# 2   31                    0
query1 = '''
    SELECT pID, count(distinct cID)
    FROM purchase
    group by pID
    HAVING count(distinct cID) < 3

'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(distinct cID)
#[Out]# 0   29                    2
#[Out]# 1   30                    1
query1 = '''
    SELECT pID, count(distinct cID)
    FROM purchase
    group by pID
    HAVING count(distinct cID) < 3
    UNION
    SELECT pID, 0
    FROM product
    WHERE product.pID not in (
    SELECT pID
    FROM purchase
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(distinct cID)
#[Out]# 0   29                    2
#[Out]# 1   30                    1
#[Out]# 2   31                    0
query1 = '''
    SELECT pID, count(distinct cID)
    FROM purchase
    group by pID
    HAVING count(distinct cID) < 3

'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(distinct cID)
#[Out]# 0   29                    2
#[Out]# 1   30                    1
query1 = '''
    SELECT pID, count(distinct cID)
    FROM purchase
    group by pID
    HAVING count(distinct cID) < 3
    UNION
    SELECT pID, 0
    FROM product
    WHERE product.pID not in (
    SELECT pID
    FROM purchase
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID  count(distinct cID)
#[Out]# 0   29                    2
#[Out]# 1   30                    1
#[Out]# 2   31                    0
query1 = '''
    SELECT pID
    FROM purchase
    group by pID
    HAVING count(distinct cID) < 3
    UNION
    SELECT pID
    FROM product
    WHERE product.pID not in (
    SELECT pID
    FROM purchase
    )
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    SELECT cID, cName
    FROM customer
    WHERE cID in (
    SELECT cID
    FROM purchase p1, purchase p2
    WHERE p1.cID = p2.cID AND p1.date = p2.date
    )
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT cID, cName
    FROM customer
    WHERE customer.cID in (
    SELECT p1.cID
    FROM purchase p1, purchase p2
    WHERE p1.cID = p2.cID AND p1.date = p2.date
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID     cName
#[Out]# 0      0      Noah
#[Out]# 1      1       Sem
#[Out]# 2      2     Lucas
#[Out]# 3      3      Finn
#[Out]# 4      4      Daan
#[Out]# 5      5      Levi
#[Out]# 6      7      Bram
#[Out]# 7      8      Liam
#[Out]# 8     10       Sam
#[Out]# 9     11     Thijs
#[Out]# 10    13     James
#[Out]# 11    15      Noud
#[Out]# 12    16    Julian
#[Out]# 13    17       Dex
#[Out]# 14    18      Hugo
#[Out]# 15    19      Lars
#[Out]# 16    20      Gijs
#[Out]# 17    21  Benjamin
#[Out]# 18    22      Mats
#[Out]# 19    24      Luca
#[Out]# 20    25     Mason
#[Out]# 21    26    Jayden
#[Out]# 22    27       Tim
#[Out]# 23    28      Siem
#[Out]# 24    29     Ruben
#[Out]# 25    30      Teun
#[Out]# 26    31   Olivier
#[Out]# 27    33      Sven
#[Out]# 28    34     David
#[Out]# 29    35     Stijn
#[Out]# ..   ...       ...
#[Out]# 102  147    Isabel
#[Out]# 103  149     Lizzy
#[Out]# 104  151      Jill
#[Out]# 105  152      Anne
#[Out]# 106  157      Puck
#[Out]# 107  159     Fenne
#[Out]# 108  161     Floor
#[Out]# 109  162     Elena
#[Out]# 110  163      Cato
#[Out]# 111  165     Hanna
#[Out]# 112  167    Veerle
#[Out]# 113  168      Kiki
#[Out]# 114  169      Lily
#[Out]# 115  170      Iris
#[Out]# 116  171     Tessa
#[Out]# 117  172      Lana
#[Out]# 118  175       Sam
#[Out]# 119  176     Amira
#[Out]# 120  177     Eline
#[Out]# 121  178      Elif
#[Out]# 122  179      Juul
#[Out]# 123  180     Merel
#[Out]# 124  181      Liva
#[Out]# 125  182   Johanna
#[Out]# 126  184     Wilko
#[Out]# 127  185      Nick
#[Out]# 128  186    Angela
#[Out]# 129  188      Pino
#[Out]# 130  189      Koen
#[Out]# 131  190    Kostas
#[Out]# 
#[Out]# [132 rows x 2 columns]
query2 = '''
    SELECT cID, cName
    FROM customer
    WHERE customer.cID in (
    SELECT p1.cID
    FROM purchase p1, purchase p2
    WHERE p1.cID = p2.cID AND p1.date = p2.date AND p1.pID = p2.pID
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID     cName
#[Out]# 0      0      Noah
#[Out]# 1      1       Sem
#[Out]# 2      2     Lucas
#[Out]# 3      3      Finn
#[Out]# 4      4      Daan
#[Out]# 5      5      Levi
#[Out]# 6      7      Bram
#[Out]# 7      8      Liam
#[Out]# 8     10       Sam
#[Out]# 9     11     Thijs
#[Out]# 10    13     James
#[Out]# 11    15      Noud
#[Out]# 12    16    Julian
#[Out]# 13    17       Dex
#[Out]# 14    18      Hugo
#[Out]# 15    19      Lars
#[Out]# 16    20      Gijs
#[Out]# 17    21  Benjamin
#[Out]# 18    22      Mats
#[Out]# 19    24      Luca
#[Out]# 20    25     Mason
#[Out]# 21    26    Jayden
#[Out]# 22    27       Tim
#[Out]# 23    28      Siem
#[Out]# 24    29     Ruben
#[Out]# 25    30      Teun
#[Out]# 26    31   Olivier
#[Out]# 27    33      Sven
#[Out]# 28    34     David
#[Out]# 29    35     Stijn
#[Out]# ..   ...       ...
#[Out]# 102  147    Isabel
#[Out]# 103  149     Lizzy
#[Out]# 104  151      Jill
#[Out]# 105  152      Anne
#[Out]# 106  157      Puck
#[Out]# 107  159     Fenne
#[Out]# 108  161     Floor
#[Out]# 109  162     Elena
#[Out]# 110  163      Cato
#[Out]# 111  165     Hanna
#[Out]# 112  167    Veerle
#[Out]# 113  168      Kiki
#[Out]# 114  169      Lily
#[Out]# 115  170      Iris
#[Out]# 116  171     Tessa
#[Out]# 117  172      Lana
#[Out]# 118  175       Sam
#[Out]# 119  176     Amira
#[Out]# 120  177     Eline
#[Out]# 121  178      Elif
#[Out]# 122  179      Juul
#[Out]# 123  180     Merel
#[Out]# 124  181      Liva
#[Out]# 125  182   Johanna
#[Out]# 126  184     Wilko
#[Out]# 127  185      Nick
#[Out]# 128  186    Angela
#[Out]# 129  188      Pino
#[Out]# 130  189      Koen
#[Out]# 131  190    Kostas
#[Out]# 
#[Out]# [132 rows x 2 columns]
query2 = '''
    SELECT cID, cName
    FROM customer
    WHERE customer.cID in (
    SELECT p1.cID
    FROM purchase p1, purchase p2
    WHERE p1.cID = p2.cID AND p1.date = p2.date AND p1.pID = p2.pID AND p1.pID in (
        SELECT pID
        FROM product
        WHERE pName = "Onions"
        ) AND p2.pID in (
        SELECT pID
        FROM product
        WHERE pName = "Coffee"
        )
    )
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
    SELECT cID, cName
    FROM customer
    WHERE customer.cID in (
    SELECT p1.cID
    FROM purchase p1, purchase p2
    WHERE p1.cID = p2.cID AND p1.date = p2.date AND p1.pID in (
        SELECT pID
        FROM product
        WHERE pName = "Onions"
        ) AND p2.pID in (
        SELECT pID
        FROM product
        WHERE pName = "Coffee"
        )
    )
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT cID
    FROM purchase
    WHERE count(distinct sID) = (
    SELECT count(distinct sID)
    FROM purchase
    )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT cID
    FROM purchase
    HAVING count(distinct sID) = (
    SELECT count(distinct sID)
    FROM purchase
    )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT cID
    FROM purchase
    group by cID
    HAVING count(distinct sID) = (
    SELECT count(distinct sID)
    FROM purchase
    )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT cID
    FROM purchase
    group by sID
    HAVING count(distinct sID) = (
    SELECT count(distinct sID)
    FROM purchase
    )
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT cID
    FROM purchase
    group by cID
    HAVING count(distinct sID) = (
    SELECT count(distinct sID)
    FROM purchase
    )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT sID
    FROM purchase
    group by sID
    HAVING count(distinct sID) = (
    SELECT count(distinct sID)
    FROM purchase
    )
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sID]
#[Out]# Index: []
query3 = '''
    SELECT cID
    FROM purchase
    group by cID
    HAVING count(distinct sID) = (
    SELECT count(distinct sID)
    FROM purchase
    )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT sID, avg(quantity) as subAVG
    FROM purchase
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID    subAVG
#[Out]# 0   63  4.797642
query4 = '''
    SELECT distinct sID, avg(quantity) as subAVG
    FROM purchase
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID    subAVG
#[Out]# 0   63  4.797642
query4 = '''
    SELECT avg(quantity) as subAVG
    FROM purchase
'''

pd.read_sql_query(query4, conn)
#[Out]#      subAVG
#[Out]# 0  4.797642
query4 = '''
    SELECT cID, avg(quantity) as subAVG
    FROM purchase
'''

pd.read_sql_query(query4, conn)
#[Out]#    cID    subAVG
#[Out]# 0  190  4.797642
query4 = '''
    SELECT cID, avg(cID) as subAVG
    FROM purchase
'''

pd.read_sql_query(query4, conn)
#[Out]#    cID      subAVG
#[Out]# 0  190  102.850688
query4 = '''
    SELECT cID, max(quantity) as subAVG
    FROM purchase
'''

pd.read_sql_query(query4, conn)
#[Out]#    cID  subAVG
#[Out]# 0   59      13
query4 = '''
    SELECT *
    FROM purchase
'''

pd.read_sql_query(query4, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0      0    0    3   10  2018-08-22         1   0.45
#[Out]# 1      1    1   23   14  2018-08-20         2   4.65
#[Out]# 2      2    1    3   16  2018-08-20         3   1.60
#[Out]# 3      3    1   17    9  2018-08-20         2   1.25
#[Out]# 4      4    1   32   25  2018-08-20         4   3.95
#[Out]# 5      5    1   16   26  2018-08-20         4   2.75
#[Out]# 6      6    1   46   11  2018-08-21         8   0.90
#[Out]# 7      7    1   36   27  2018-08-21         6   9.10
#[Out]# 8      8    2   12   20  2018-08-16         1   2.45
#[Out]# 9      9    2   39    9  2018-08-17         7   1.35
#[Out]# 10    10    2   13    4  2018-08-17         6   1.10
#[Out]# 11    11    2   51   13  2018-08-17         4   3.70
#[Out]# 12    12    2   47   22  2018-08-17         1   1.55
#[Out]# 13    13    3   44   14  2018-08-18         2   4.30
#[Out]# 14    14    3   30   26  2018-08-19         2   2.75
#[Out]# 15    15    3   29    9  2018-08-19         6   1.45
#[Out]# 16    16    4   17    8  2018-08-24         2   4.15
#[Out]# 17    17    4   10   27  2018-08-24         9   9.05
#[Out]# 18    18    4   53   12  2018-08-25         5  13.60
#[Out]# 19    19    4   21    6  2018-08-24         2   1.05
#[Out]# 20    20    4    7   13  2018-08-25         9   3.05
#[Out]# 21    21    4   44   26  2018-08-25         4   2.75
#[Out]# 22    22    5    4   14  2018-08-17         6   4.70
#[Out]# 23    23    5   36   28  2018-08-22         6   8.25
#[Out]# 24    24    5   55    6  2018-08-23         9   1.10
#[Out]# 25    25    5   51   22  2018-08-23         2   1.55
#[Out]# 26    26    5    6   16  2018-08-23         2   1.85
#[Out]# 27    27    5   17   19  2018-08-23         1   2.20
#[Out]# 28    28    7    3   19  2018-08-23         2   2.10
#[Out]# 29    29    7   12    2  2018-08-23         6   1.70
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  818  190   34   28  2018-08-20         4   2.80
#[Out]# 480  819  190   35   27  2018-08-15         5   0.50
#[Out]# 481  820  190   36    5  2018-08-23         3   2.55
#[Out]# 482  821  190   37   28  2018-08-15         4   0.65
#[Out]# 483  822  190   38    7  2018-08-24         4   0.70
#[Out]# 484  823  190   39    0  2018-08-25         4   3.70
#[Out]# 485  824  190   40   11  2018-08-15         2   3.50
#[Out]# 486  825  190   41    6  2018-08-15         5   2.95
#[Out]# 487  826  190   42   19  2018-08-22         5   2.75
#[Out]# 488  827  190   43   17  2018-08-17         7   1.50
#[Out]# 489  828  190   44    9  2018-08-18         5   0.85
#[Out]# 490  829  190   45   11  2018-08-19         2   3.55
#[Out]# 491  830  190   46   22  2018-08-25         4   2.60
#[Out]# 492  831  190   47   17  2018-08-17         4   3.25
#[Out]# 493  832  190   48   20  2018-08-26         6   4.30
#[Out]# 494  833  190   49   11  2018-08-17         3   3.05
#[Out]# 495  834  190   50   21  2018-08-22         6   4.05
#[Out]# 496  835  190   51   23  2018-08-19         1   1.50
#[Out]# 497  836  190   52   23  2018-08-15         5   2.50
#[Out]# 498  837  190   53    8  2018-08-18         4   3.95
#[Out]# 499  838  190   54    0  2018-08-25         6   3.50
#[Out]# 500  839  190   55    8  2018-08-18         7   2.95
#[Out]# 501  840  190   56   11  2018-08-15         4   1.60
#[Out]# 502  841  190   57   15  2018-08-22         5   3.25
#[Out]# 503  842  190   58    2  2018-08-19         7   0.75
#[Out]# 504  843  190   59   17  2018-08-26         2   3.80
#[Out]# 505  844  190   60    5  2018-08-27         6   4.35
#[Out]# 506  845  190   61   19  2018-08-23         5   2.85
#[Out]# 507  846  190   62    9  2018-08-16         2   3.15
#[Out]# 508  847  190   63   18  2018-08-21         1   3.30
#[Out]# 
#[Out]# [509 rows x 7 columns]
query4 = '''
    SELECT *
    FROM purchase
    ORDER BY sID DESC
'''

pd.read_sql_query(query4, conn)
#[Out]#      tID  cID  sID  pID        date  quantity  price
#[Out]# 0    782  189   63    7  2018-08-25         5   1.25
#[Out]# 1    847  190   63   18  2018-08-21         1   3.30
#[Out]# 2    778  185   62   29  2018-08-20         1   1.00
#[Out]# 3    779  186   62   29  2018-08-21         5   1.00
#[Out]# 4    780  188   62   30  2018-08-20         1   1.00
#[Out]# 5    781  188   62   30  2018-09-20         1   1.00
#[Out]# 6    846  190   62    9  2018-08-16         2   3.15
#[Out]# 7    845  190   61   19  2018-08-23         5   2.85
#[Out]# 8    844  190   60    5  2018-08-27         6   4.35
#[Out]# 9     63   19   59    0  2018-08-17         1   3.90
#[Out]# 10    83   24   59   13  2018-08-21         5   4.00
#[Out]# 11    87   27   59   14  2018-08-26         4   3.50
#[Out]# 12   176   59   59   21  2018-08-15         6   2.20
#[Out]# 13   443  172   59    4  2018-08-27         4   0.90
#[Out]# 14   843  190   59   17  2018-08-26         2   3.80
#[Out]# 15   171   59   58   27  2018-08-23        13   6.45
#[Out]# 16   357  145   58    9  2018-08-22         9   1.70
#[Out]# 17   842  190   58    2  2018-08-19         7   0.75
#[Out]# 18    97   30   57   12  2018-08-18         8  11.45
#[Out]# 19   101   33   57   19  2018-08-26         4   2.60
#[Out]# 20   398  162   57    3  2018-08-23         7   1.25
#[Out]# 21   417  167   57    2  2018-08-19         2   2.30
#[Out]# 22   462  179   57   17  2018-08-24         2   2.40
#[Out]# 23   841  190   57   15  2018-08-22         5   3.25
#[Out]# 24   126   40   56   19  2018-08-17         5   2.25
#[Out]# 25   215   78   56   13  2018-08-18         5   4.15
#[Out]# 26   287  109   56   26  2018-08-21         2   3.25
#[Out]# 27   316  122   56    7  2018-08-22         4   2.35
#[Out]# 28   334  126   56   15  2018-08-22         1   1.00
#[Out]# 29   410  165   56    1  2018-08-23         3   4.40
#[Out]# ..   ...  ...  ...  ...         ...       ...    ...
#[Out]# 479  251   92    3   14  2018-08-27         6   4.50
#[Out]# 480  259   95    3    0  2018-08-24         5   4.85
#[Out]# 481  279  108    3   21  2018-08-15         6   1.70
#[Out]# 482  336  127    3    0  2018-08-25         9   3.75
#[Out]# 483  390  161    3   16  2018-08-26         1   1.90
#[Out]# 484  421  167    3   11  2018-08-20         8   1.15
#[Out]# 485  787  190    3   28  2018-08-23         5   0.50
#[Out]# 486   61   18    2    9  2018-08-16         6   1.70
#[Out]# 487   65   19    2   15  2018-08-18         1   1.05
#[Out]# 488   71   21    2   23  2018-08-16         3   2.40
#[Out]# 489  159   52    2    5  2018-08-25         6   0.50
#[Out]# 490  278  104    2   22  2018-08-22         2   2.00
#[Out]# 491  786  190    2   19  2018-08-19         4   1.40
#[Out]# 492   70   21    1   26  2018-08-15         3   3.45
#[Out]# 493  196   70    1   20  2018-08-25         7   2.05
#[Out]# 494  213   77    1    5  2018-08-23         3   0.45
#[Out]# 495  297  113    1    0  2018-08-26         5   5.30
#[Out]# 496  330  124    1   11  2018-08-26         6   1.00
#[Out]# 497  388  161    1   27  2018-08-26         5   6.95
#[Out]# 498  434  169    1    4  2018-08-20         3   1.10
#[Out]# 499  785  190    1   19  2018-08-24         6   2.55
#[Out]# 500   37   11    0   14  2018-08-25         8   4.10
#[Out]# 501   76   24    0   16  2018-08-19         9   1.40
#[Out]# 502  247   91    0   15  2018-08-27         4   1.20
#[Out]# 503  281  108    0    1  2018-08-15         1   6.35
#[Out]# 504  317  123    0   16  2018-08-17         8   1.50
#[Out]# 505  401  162    0    2  2018-08-26         2   1.70
#[Out]# 506  444  172    0   16  2018-08-24         4   1.85
#[Out]# 507  777  184    0    0  2018-08-20         2   3.50
#[Out]# 508  784  190    0   27  2018-08-19         5   4.45
#[Out]# 
#[Out]# [509 rows x 7 columns]
query4 = '''
    SELECT *
    FROM purchase
    group by sID
    ORDER BY sID DESC
'''

pd.read_sql_query(query4, conn)
#[Out]#     tID  cID  sID  pID        date  quantity  price
#[Out]# 0   847  190   63   18  2018-08-21         1   3.30
#[Out]# 1   846  190   62    9  2018-08-16         2   3.15
#[Out]# 2   845  190   61   19  2018-08-23         5   2.85
#[Out]# 3   844  190   60    5  2018-08-27         6   4.35
#[Out]# 4   843  190   59   17  2018-08-26         2   3.80
#[Out]# 5   842  190   58    2  2018-08-19         7   0.75
#[Out]# 6   841  190   57   15  2018-08-22         5   3.25
#[Out]# 7   840  190   56   11  2018-08-15         4   1.60
#[Out]# 8   839  190   55    8  2018-08-18         7   2.95
#[Out]# 9   838  190   54    0  2018-08-25         6   3.50
#[Out]# 10  837  190   53    8  2018-08-18         4   3.95
#[Out]# 11  836  190   52   23  2018-08-15         5   2.50
#[Out]# 12  835  190   51   23  2018-08-19         1   1.50
#[Out]# 13  834  190   50   21  2018-08-22         6   4.05
#[Out]# 14  833  190   49   11  2018-08-17         3   3.05
#[Out]# 15  832  190   48   20  2018-08-26         6   4.30
#[Out]# 16  831  190   47   17  2018-08-17         4   3.25
#[Out]# 17  830  190   46   22  2018-08-25         4   2.60
#[Out]# 18  829  190   45   11  2018-08-19         2   3.55
#[Out]# 19  828  190   44    9  2018-08-18         5   0.85
#[Out]# 20  827  190   43   17  2018-08-17         7   1.50
#[Out]# 21  826  190   42   19  2018-08-22         5   2.75
#[Out]# 22  825  190   41    6  2018-08-15         5   2.95
#[Out]# 23  824  190   40   11  2018-08-15         2   3.50
#[Out]# 24  823  190   39    0  2018-08-25         4   3.70
#[Out]# 25  822  190   38    7  2018-08-24         4   0.70
#[Out]# 26  821  190   37   28  2018-08-15         4   0.65
#[Out]# 27  820  190   36    5  2018-08-23         3   2.55
#[Out]# 28  819  190   35   27  2018-08-15         5   0.50
#[Out]# 29  818  190   34   28  2018-08-20         4   2.80
#[Out]# ..  ...  ...  ...  ...         ...       ...    ...
#[Out]# 34  813  190   29   17  2018-08-27         5   1.20
#[Out]# 35  812  190   28   19  2018-08-23         5   1.75
#[Out]# 36  811  190   27   13  2018-08-17         4   0.90
#[Out]# 37  810  190   26   21  2018-08-22         7   0.60
#[Out]# 38  809  190   25    5  2018-08-20         2   1.75
#[Out]# 39  808  190   24   26  2018-08-16         5   3.25
#[Out]# 40  807  190   23    3  2018-08-18         1   2.75
#[Out]# 41  806  190   22   25  2018-08-19         7   3.20
#[Out]# 42  805  190   21   17  2018-08-16         6   3.15
#[Out]# 43  804  190   20   20  2018-08-17         7   0.50
#[Out]# 44  803  190   19   23  2018-08-15         7   3.75
#[Out]# 45  802  190   18   27  2018-08-21         4   0.55
#[Out]# 46  801  190   17   10  2018-08-23         6   0.95
#[Out]# 47  800  190   16    4  2018-08-26         1   2.40
#[Out]# 48  799  190   15   21  2018-08-20         2   3.10
#[Out]# 49  798  190   14   15  2018-08-17         5   3.80
#[Out]# 50  797  190   13    0  2018-08-26         4   2.00
#[Out]# 51  796  190   12   26  2018-08-17         6   2.75
#[Out]# 52  795  190   11    9  2018-08-22         5   3.00
#[Out]# 53  794  190   10   19  2018-08-22         7   0.90
#[Out]# 54  793  190    9   21  2018-08-26         5   4.25
#[Out]# 55  792  190    8   20  2018-08-16         7   3.25
#[Out]# 56  791  190    7   22  2018-08-20         4   3.20
#[Out]# 57  790  190    6   10  2018-08-15         2   4.15
#[Out]# 58  789  190    5    2  2018-08-23         7   2.00
#[Out]# 59  788  190    4    7  2018-08-26         7   1.30
#[Out]# 60  787  190    3   28  2018-08-23         5   0.50
#[Out]# 61  786  190    2   19  2018-08-19         4   1.40
#[Out]# 62  785  190    1   19  2018-08-24         6   2.55
#[Out]# 63  784  190    0   27  2018-08-19         5   4.45
#[Out]# 
#[Out]# [64 rows x 7 columns]
query4 = '''
    SELECT sID, avg(quantity)
    FROM purchase
    group by sID
    ORDER BY sID DESC
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID  avg(quantity)
#[Out]# 0    63       3.000000
#[Out]# 1    62       2.000000
#[Out]# 2    61       5.000000
#[Out]# 3    60       6.000000
#[Out]# 4    59       3.666667
#[Out]# 5    58       9.666667
#[Out]# 6    57       4.666667
#[Out]# 7    56       2.900000
#[Out]# 8    55       5.454545
#[Out]# 9    54       4.636364
#[Out]# 10   53       4.000000
#[Out]# 11   52       5.750000
#[Out]# 12   51       4.100000
#[Out]# 13   50       4.000000
#[Out]# 14   49       3.333333
#[Out]# 15   48       7.500000
#[Out]# 16   47       4.636364
#[Out]# 17   46       5.600000
#[Out]# 18   45       3.875000
#[Out]# 19   44       4.300000
#[Out]# 20   43       5.769231
#[Out]# 21   42       5.900000
#[Out]# 22   41       4.833333
#[Out]# 23   40       4.300000
#[Out]# 24   39       4.571429
#[Out]# 25   38       5.400000
#[Out]# 26   37       4.000000
#[Out]# 27   36       4.142857
#[Out]# 28   35       4.428571
#[Out]# 29   34       5.400000
#[Out]# ..  ...            ...
#[Out]# 34   29       6.000000
#[Out]# 35   28       5.000000
#[Out]# 36   27       4.750000
#[Out]# 37   26       6.500000
#[Out]# 38   25       5.700000
#[Out]# 39   24       5.400000
#[Out]# 40   23       4.400000
#[Out]# 41   22       5.500000
#[Out]# 42   21       3.600000
#[Out]# 43   20       5.428571
#[Out]# 44   19       5.571429
#[Out]# 45   18       3.181818
#[Out]# 46   17       5.538462
#[Out]# 47   16       3.500000
#[Out]# 48   15       4.250000
#[Out]# 49   14       3.125000
#[Out]# 50   13       3.888889
#[Out]# 51   12       5.000000
#[Out]# 52   11       4.272727
#[Out]# 53   10       6.400000
#[Out]# 54    9       5.444444
#[Out]# 55    8       5.600000
#[Out]# 56    7       4.444444
#[Out]# 57    6       3.800000
#[Out]# 58    5       4.875000
#[Out]# 59    4       6.090909
#[Out]# 60    3       4.076923
#[Out]# 61    2       3.666667
#[Out]# 62    1       4.750000
#[Out]# 63    0       4.777778
#[Out]# 
#[Out]# [64 rows x 2 columns]
query4 = '''
    SELECT sID, avg(quantity)
    FROM purchase
    group by sID
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID  avg(quantity)
#[Out]# 0     0       4.777778
#[Out]# 1     1       4.750000
#[Out]# 2     2       3.666667
#[Out]# 3     3       4.076923
#[Out]# 4     4       6.090909
#[Out]# 5     5       4.875000
#[Out]# 6     6       3.800000
#[Out]# 7     7       4.444444
#[Out]# 8     8       5.600000
#[Out]# 9     9       5.444444
#[Out]# 10   10       6.400000
#[Out]# 11   11       4.272727
#[Out]# 12   12       5.000000
#[Out]# 13   13       3.888889
#[Out]# 14   14       3.125000
#[Out]# 15   15       4.250000
#[Out]# 16   16       3.500000
#[Out]# 17   17       5.538462
#[Out]# 18   18       3.181818
#[Out]# 19   19       5.571429
#[Out]# 20   20       5.428571
#[Out]# 21   21       3.600000
#[Out]# 22   22       5.500000
#[Out]# 23   23       4.400000
#[Out]# 24   24       5.400000
#[Out]# 25   25       5.700000
#[Out]# 26   26       6.500000
#[Out]# 27   27       4.750000
#[Out]# 28   28       5.000000
#[Out]# 29   29       6.000000
#[Out]# ..  ...            ...
#[Out]# 34   34       5.400000
#[Out]# 35   35       4.428571
#[Out]# 36   36       4.142857
#[Out]# 37   37       4.000000
#[Out]# 38   38       5.400000
#[Out]# 39   39       4.571429
#[Out]# 40   40       4.300000
#[Out]# 41   41       4.833333
#[Out]# 42   42       5.900000
#[Out]# 43   43       5.769231
#[Out]# 44   44       4.300000
#[Out]# 45   45       3.875000
#[Out]# 46   46       5.600000
#[Out]# 47   47       4.636364
#[Out]# 48   48       7.500000
#[Out]# 49   49       3.333333
#[Out]# 50   50       4.000000
#[Out]# 51   51       4.100000
#[Out]# 52   52       5.750000
#[Out]# 53   53       4.000000
#[Out]# 54   54       4.636364
#[Out]# 55   55       5.454545
#[Out]# 56   56       2.900000
#[Out]# 57   57       4.666667
#[Out]# 58   58       9.666667
#[Out]# 59   59       3.666667
#[Out]# 60   60       6.000000
#[Out]# 61   61       5.000000
#[Out]# 62   62       2.000000
#[Out]# 63   63       3.000000
#[Out]# 
#[Out]# [64 rows x 2 columns]
query4 = '''
    SELECT sID, avg(quantity) as AVG
    FROM purchase
    group by sID
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID       AVG
#[Out]# 0     0  4.777778
#[Out]# 1     1  4.750000
#[Out]# 2     2  3.666667
#[Out]# 3     3  4.076923
#[Out]# 4     4  6.090909
#[Out]# 5     5  4.875000
#[Out]# 6     6  3.800000
#[Out]# 7     7  4.444444
#[Out]# 8     8  5.600000
#[Out]# 9     9  5.444444
#[Out]# 10   10  6.400000
#[Out]# 11   11  4.272727
#[Out]# 12   12  5.000000
#[Out]# 13   13  3.888889
#[Out]# 14   14  3.125000
#[Out]# 15   15  4.250000
#[Out]# 16   16  3.500000
#[Out]# 17   17  5.538462
#[Out]# 18   18  3.181818
#[Out]# 19   19  5.571429
#[Out]# 20   20  5.428571
#[Out]# 21   21  3.600000
#[Out]# 22   22  5.500000
#[Out]# 23   23  4.400000
#[Out]# 24   24  5.400000
#[Out]# 25   25  5.700000
#[Out]# 26   26  6.500000
#[Out]# 27   27  4.750000
#[Out]# 28   28  5.000000
#[Out]# 29   29  6.000000
#[Out]# ..  ...       ...
#[Out]# 34   34  5.400000
#[Out]# 35   35  4.428571
#[Out]# 36   36  4.142857
#[Out]# 37   37  4.000000
#[Out]# 38   38  5.400000
#[Out]# 39   39  4.571429
#[Out]# 40   40  4.300000
#[Out]# 41   41  4.833333
#[Out]# 42   42  5.900000
#[Out]# 43   43  5.769231
#[Out]# 44   44  4.300000
#[Out]# 45   45  3.875000
#[Out]# 46   46  5.600000
#[Out]# 47   47  4.636364
#[Out]# 48   48  7.500000
#[Out]# 49   49  3.333333
#[Out]# 50   50  4.000000
#[Out]# 51   51  4.100000
#[Out]# 52   52  5.750000
#[Out]# 53   53  4.000000
#[Out]# 54   54  4.636364
#[Out]# 55   55  5.454545
#[Out]# 56   56  2.900000
#[Out]# 57   57  4.666667
#[Out]# 58   58  9.666667
#[Out]# 59   59  3.666667
#[Out]# 60   60  6.000000
#[Out]# 61   61  5.000000
#[Out]# 62   62  2.000000
#[Out]# 63   63  3.000000
#[Out]# 
#[Out]# [64 rows x 2 columns]
query4 = '''
    SELECT distinct sName
    FROM store
    WHERE store.sID in (
    SELECT sID, avg(quantity) as AVG
    FROM purchase
    group by sID
    )
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT distinct sName
    FROM store
    WHERE store.sID in (
    SELECT sID, avg(quantity) as AVG
    FROM purchase
    WHERE AVG > 4
    group by sID
    )
'''

pd.read_sql_query(query4, conn)
query4 = '''

    SELECT sID, avg(quantity) as AVG
    FROM purchase
    WHERE AVG > 4
    group by sID
    
'''

pd.read_sql_query(query4, conn)
query4 = '''

    SELECT sID, avg(quantity) as AVG
    FROM purchase
    WHERE avg(quantity) > 4
    group by sID
    
'''

pd.read_sql_query(query4, conn)
query4 = '''

    SELECT sID, avg(quantity) as AVG
    FROM purchase
    group by sID
    HAVING avg(quantity) > 4
    
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID       AVG
#[Out]# 0     0  4.777778
#[Out]# 1     1  4.750000
#[Out]# 2     3  4.076923
#[Out]# 3     4  6.090909
#[Out]# 4     5  4.875000
#[Out]# 5     7  4.444444
#[Out]# 6     8  5.600000
#[Out]# 7     9  5.444444
#[Out]# 8    10  6.400000
#[Out]# 9    11  4.272727
#[Out]# 10   12  5.000000
#[Out]# 11   15  4.250000
#[Out]# 12   17  5.538462
#[Out]# 13   19  5.571429
#[Out]# 14   20  5.428571
#[Out]# 15   22  5.500000
#[Out]# 16   23  4.400000
#[Out]# 17   24  5.400000
#[Out]# 18   25  5.700000
#[Out]# 19   26  6.500000
#[Out]# 20   27  4.750000
#[Out]# 21   28  5.000000
#[Out]# 22   29  6.000000
#[Out]# 23   30  4.900000
#[Out]# 24   31  7.166667
#[Out]# 25   33  6.166667
#[Out]# 26   34  5.400000
#[Out]# 27   35  4.428571
#[Out]# 28   36  4.142857
#[Out]# 29   38  5.400000
#[Out]# 30   39  4.571429
#[Out]# 31   40  4.300000
#[Out]# 32   41  4.833333
#[Out]# 33   42  5.900000
#[Out]# 34   43  5.769231
#[Out]# 35   44  4.300000
#[Out]# 36   46  5.600000
#[Out]# 37   47  4.636364
#[Out]# 38   48  7.500000
#[Out]# 39   51  4.100000
#[Out]# 40   52  5.750000
#[Out]# 41   54  4.636364
#[Out]# 42   55  5.454545
#[Out]# 43   57  4.666667
#[Out]# 44   58  9.666667
#[Out]# 45   60  6.000000
#[Out]# 46   61  5.000000
query4 = '''
    SELECT distinct sName
    FROM store
    WHERE store.sID in (
    SELECT sID, avg(quantity) as AVG
    FROM purchase
    group by sID
    HAVING avg(quantity) > 4
    )
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT distinct sName
    FROM store
    WHERE store.sID in (
    SELECT sID
    FROM purchase
    group by sID
    HAVING avg(quantity) > 4
    )
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0         Coop
#[Out]# 1    Hoogvliet
#[Out]# 2       Sligro
#[Out]# 3  Albert Hein
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6         Dirk
query4 = '''
    SELECT sID
    FROM purchase
    group by sID
    HAVING avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     3
#[Out]# 3     4
#[Out]# 4     5
#[Out]# 5     7
#[Out]# 6     8
#[Out]# 7     9
#[Out]# 8    10
#[Out]# 9    11
#[Out]# 10   12
#[Out]# 11   15
#[Out]# 12   17
#[Out]# 13   19
#[Out]# 14   20
#[Out]# 15   22
#[Out]# 16   23
#[Out]# 17   24
#[Out]# 18   25
#[Out]# 19   26
#[Out]# 20   27
#[Out]# 21   28
#[Out]# 22   29
#[Out]# 23   30
#[Out]# 24   31
#[Out]# 25   33
#[Out]# 26   34
#[Out]# 27   35
#[Out]# 28   36
#[Out]# 29   38
#[Out]# 30   39
#[Out]# 31   40
#[Out]# 32   41
#[Out]# 33   42
#[Out]# 34   43
#[Out]# 35   44
#[Out]# 36   46
#[Out]# 37   47
#[Out]# 38   48
#[Out]# 39   51
#[Out]# 40   52
#[Out]# 41   54
#[Out]# 42   55
#[Out]# 43   57
#[Out]# 44   58
#[Out]# 45   60
#[Out]# 46   61
query4 = '''
    SELECT sID, avg(quantity) as AVG
    FROM purchase
    group by sID
    HAVING avg(quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID       AVG
#[Out]# 0     0  4.777778
#[Out]# 1     1  4.750000
#[Out]# 2     3  4.076923
#[Out]# 3     4  6.090909
#[Out]# 4     5  4.875000
#[Out]# 5     7  4.444444
#[Out]# 6     8  5.600000
#[Out]# 7     9  5.444444
#[Out]# 8    10  6.400000
#[Out]# 9    11  4.272727
#[Out]# 10   12  5.000000
#[Out]# 11   15  4.250000
#[Out]# 12   17  5.538462
#[Out]# 13   19  5.571429
#[Out]# 14   20  5.428571
#[Out]# 15   22  5.500000
#[Out]# 16   23  4.400000
#[Out]# 17   24  5.400000
#[Out]# 18   25  5.700000
#[Out]# 19   26  6.500000
#[Out]# 20   27  4.750000
#[Out]# 21   28  5.000000
#[Out]# 22   29  6.000000
#[Out]# 23   30  4.900000
#[Out]# 24   31  7.166667
#[Out]# 25   33  6.166667
#[Out]# 26   34  5.400000
#[Out]# 27   35  4.428571
#[Out]# 28   36  4.142857
#[Out]# 29   38  5.400000
#[Out]# 30   39  4.571429
#[Out]# 31   40  4.300000
#[Out]# 32   41  4.833333
#[Out]# 33   42  5.900000
#[Out]# 34   43  5.769231
#[Out]# 35   44  4.300000
#[Out]# 36   46  5.600000
#[Out]# 37   47  4.636364
#[Out]# 38   48  7.500000
#[Out]# 39   51  4.100000
#[Out]# 40   52  5.750000
#[Out]# 41   54  4.636364
#[Out]# 42   55  5.454545
#[Out]# 43   57  4.666667
#[Out]# 44   58  9.666667
#[Out]# 45   60  6.000000
#[Out]# 46   61  5.000000
query4 = '''
    SELECT sID, avg(quantity) as AVG
    FROM purchase
    group by sID
'''

pd.read_sql_query(query4, conn)
#[Out]#     sID       AVG
#[Out]# 0     0  4.777778
#[Out]# 1     1  4.750000
#[Out]# 2     2  3.666667
#[Out]# 3     3  4.076923
#[Out]# 4     4  6.090909
#[Out]# 5     5  4.875000
#[Out]# 6     6  3.800000
#[Out]# 7     7  4.444444
#[Out]# 8     8  5.600000
#[Out]# 9     9  5.444444
#[Out]# 10   10  6.400000
#[Out]# 11   11  4.272727
#[Out]# 12   12  5.000000
#[Out]# 13   13  3.888889
#[Out]# 14   14  3.125000
#[Out]# 15   15  4.250000
#[Out]# 16   16  3.500000
#[Out]# 17   17  5.538462
#[Out]# 18   18  3.181818
#[Out]# 19   19  5.571429
#[Out]# 20   20  5.428571
#[Out]# 21   21  3.600000
#[Out]# 22   22  5.500000
#[Out]# 23   23  4.400000
#[Out]# 24   24  5.400000
#[Out]# 25   25  5.700000
#[Out]# 26   26  6.500000
#[Out]# 27   27  4.750000
#[Out]# 28   28  5.000000
#[Out]# 29   29  6.000000
#[Out]# ..  ...       ...
#[Out]# 34   34  5.400000
#[Out]# 35   35  4.428571
#[Out]# 36   36  4.142857
#[Out]# 37   37  4.000000
#[Out]# 38   38  5.400000
#[Out]# 39   39  4.571429
#[Out]# 40   40  4.300000
#[Out]# 41   41  4.833333
#[Out]# 42   42  5.900000
#[Out]# 43   43  5.769231
#[Out]# 44   44  4.300000
#[Out]# 45   45  3.875000
#[Out]# 46   46  5.600000
#[Out]# 47   47  4.636364
#[Out]# 48   48  7.500000
#[Out]# 49   49  3.333333
#[Out]# 50   50  4.000000
#[Out]# 51   51  4.100000
#[Out]# 52   52  5.750000
#[Out]# 53   53  4.000000
#[Out]# 54   54  4.636364
#[Out]# 55   55  5.454545
#[Out]# 56   56  2.900000
#[Out]# 57   57  4.666667
#[Out]# 58   58  9.666667
#[Out]# 59   59  3.666667
#[Out]# 60   60  6.000000
#[Out]# 61   61  5.000000
#[Out]# 62   62  2.000000
#[Out]# 63   63  3.000000
#[Out]# 
#[Out]# [64 rows x 2 columns]
query4 = '''
    SELECT distinct sName, avg(purchase.quantity) as AVG
    FROM store, purchase
    WHERE purchase.sID = store.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName       AVG
#[Out]# 0  Jumbo  4.797642
query4 = '''
    SELECT distinct sName, avg(purchase.quantity) as AVG
    FROM store, purchase
    WHERE purchase.sID = store.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#    sName       AVG
#[Out]# 0  Jumbo  4.797642
query4 = '''
    SELECT distinct sName, avg(purchase.quantity) as AVG
    FROM store, purchase
    WHERE purchase.sID = store.sID
    group by sName
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName       AVG
#[Out]# 0  Albert Hein  4.969697
#[Out]# 1         Coop  4.681818
#[Out]# 2         Dirk  5.268293
#[Out]# 3    Hoogvliet  5.280000
#[Out]# 4        Jumbo  3.888889
#[Out]# 5         Lidl  4.796875
#[Out]# 6       Sligro  4.674419
query4 = '''
    SELECT distinct sName, avg(purchase.quantity) as AVG
    FROM store, purchase
    WHERE purchase.sID = store.sID
    group by sName
    HAVING avg(purchase.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName       AVG
#[Out]# 0  Albert Hein  4.969697
#[Out]# 1         Coop  4.681818
#[Out]# 2         Dirk  5.268293
#[Out]# 3    Hoogvliet  5.280000
#[Out]# 4         Lidl  4.796875
#[Out]# 5       Sligro  4.674419
query4 = '''
    SELECT distinct sName
    FROM store, purchase
    WHERE purchase.sID = store.sID
    group by sName
    HAVING avg(purchase.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT pID, max(price)
    FROM purchase
'''

pd.read_sql_query(query5, conn)
#[Out]#    pID  max(price)
#[Out]# 0   12        13.8
query5 = '''
    SELECT max(quantity)
    FROM purchase
'''

pd.read_sql_query(query5, conn)
#[Out]#    max(quantity)
#[Out]# 0             13
query5 = '''
    SELECT max(price)
    FROM purchase
'''

pd.read_sql_query(query5, conn)
#[Out]#    max(price)
#[Out]# 0        13.8
query5 = '''
    SELECT avg(price)
    FROM purchase
'''

pd.read_sql_query(query5, conn)
#[Out]#    avg(price)
#[Out]# 0    3.291159
query5 = '''
    SELECT max(price)
    FROM purchase
'''

pd.read_sql_query(query5, conn)
#[Out]#    max(price)
#[Out]# 0        13.8
query5 = '''
    SELECT max(price), pName
    FROM purchase, product
    WHERE purchase.pID = product.pID
'''

pd.read_sql_query(query5, conn)
#[Out]#    max(price) pName
#[Out]# 0        13.8  Beef
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 479           Lasanga         Coop
#[Out]# 480             Pizza         Lidl
#[Out]# 481         Mushrooms         Lidl
#[Out]# 482           Lasanga        Jumbo
#[Out]# 483          Tomatoes    Hoogvliet
#[Out]# 484       Cashew Nuts       Sligro
#[Out]# 485              Milk    Hoogvliet
#[Out]# 486           Carrots  Albert Hein
#[Out]# 487              Coca       Sligro
#[Out]# 488             Bread         Coop
#[Out]# 489           Bananas  Albert Hein
#[Out]# 490              Milk         Coop
#[Out]# 491               Tea         Lidl
#[Out]# 492             Bread         Coop
#[Out]# 493             Fanta    Hoogvliet
#[Out]# 494              Milk    Hoogvliet
#[Out]# 495            Coffee       Sligro
#[Out]# 496   Spiced Biscuits         Coop
#[Out]# 497   Spiced Biscuits         Lidl
#[Out]# 498  Hot Dog Sausages         Coop
#[Out]# 499       Cashew Nuts         Dirk
#[Out]# 500  Hot Dog Sausages         Coop
#[Out]# 501              Milk        Jumbo
#[Out]# 502         Cucumbers         Dirk
#[Out]# 503          Potatoes         Dirk
#[Out]# 504             Bread        Jumbo
#[Out]# 505         Mushrooms         Lidl
#[Out]# 506              Coca         Lidl
#[Out]# 507           Bananas        Jumbo
#[Out]# 508            Cheese        Jumbo
#[Out]# 
#[Out]# [509 rows x 2 columns]
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
    HAVING purchase.price = (
    SELECT max(price)
    FROM purchase
    )
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
    group by pName
    HAVING purchase.price = (
    SELECT max(price)
    FROM purchase
    )
'''

pd.read_sql_query(query5, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName, sName]
#[Out]# Index: []
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
    group by sName
    HAVING purchase.price = (
    SELECT max(price)
    FROM purchase
    )
'''

pd.read_sql_query(query5, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName, sName]
#[Out]# Index: []
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = 13.8
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = max(purchase.price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
    HAVING purchase.price = max(purchase.price)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID
    group by pName
    HAVING purchase.price = max(purchase.price)
'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0             Apples    Hoogvliet
#[Out]# 1            Bananas        Jumbo
#[Out]# 2               Beef       Sligro
#[Out]# 3              Bread        Jumbo
#[Out]# 4            Carrots  Albert Hein
#[Out]# 5        Cashew Nuts         Coop
#[Out]# 6             Cheese  Albert Hein
#[Out]# 7               Coca         Dirk
#[Out]# 8             Coffee  Albert Hein
#[Out]# 9          Cucumbers         Coop
#[Out]# 10            Donuts        Jumbo
#[Out]# 11              Eggs    Hoogvliet
#[Out]# 12             Fanta    Hoogvliet
#[Out]# 13      Green Pepper         Dirk
#[Out]# 14  Hot Dog Sausages  Albert Hein
#[Out]# 15           Ketchup        Jumbo
#[Out]# 16           Lasanga  Albert Hein
#[Out]# 17              Milk         Coop
#[Out]# 18        Mixed Nuts         Coop
#[Out]# 19         Mushrooms         Lidl
#[Out]# 20            Onions         Lidl
#[Out]# 21           Oranges         Coop
#[Out]# 22             Pasta         Lidl
#[Out]# 23             Pizza    Hoogvliet
#[Out]# 24          Potatoes         Coop
#[Out]# 25              Rice        Jumbo
#[Out]# 26            Salmon        Jumbo
#[Out]# 27   Spiced Biscuits         Coop
#[Out]# 28               Tea       Sligro
#[Out]# 29          Tomatoes        Jumbo
#[Out]# 30             Water         Dirk
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND product.pName in (
    SELECT pName
    FROM product, purchase
    group by pName
    HAVING purchase.price = max(purchase.price)
    )
    group by pName
    HAVING purchase.price = max(purchase.price)
'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0             Apples    Hoogvliet
#[Out]# 1            Bananas        Jumbo
#[Out]# 2               Beef       Sligro
#[Out]# 3              Bread        Jumbo
#[Out]# 4            Carrots  Albert Hein
#[Out]# 5        Cashew Nuts         Coop
#[Out]# 6             Cheese  Albert Hein
#[Out]# 7               Coca         Dirk
#[Out]# 8             Coffee  Albert Hein
#[Out]# 9          Cucumbers         Coop
#[Out]# 10            Donuts        Jumbo
#[Out]# 11              Eggs    Hoogvliet
#[Out]# 12             Fanta    Hoogvliet
#[Out]# 13      Green Pepper         Dirk
#[Out]# 14  Hot Dog Sausages  Albert Hein
#[Out]# 15           Ketchup        Jumbo
#[Out]# 16           Lasanga  Albert Hein
#[Out]# 17              Milk         Coop
#[Out]# 18        Mixed Nuts         Coop
#[Out]# 19         Mushrooms         Lidl
#[Out]# 20            Onions         Lidl
#[Out]# 21           Oranges         Coop
#[Out]# 22             Pasta         Lidl
#[Out]# 23             Pizza    Hoogvliet
#[Out]# 24          Potatoes         Coop
#[Out]# 25              Rice        Jumbo
#[Out]# 26            Salmon        Jumbo
#[Out]# 27   Spiced Biscuits         Coop
#[Out]# 28               Tea       Sligro
#[Out]# 29          Tomatoes        Jumbo
#[Out]# 30             Water         Dirk
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = (
    SELECT max(price)
    FROM purchase
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT max(t1.price - t2.price)
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price)
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(t1.unit_price - t2.unit_price)
#[Out]# 0                                3.25
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#    difference
#[Out]# 0        3.25
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = (
    SELECT price
    FROM purchase
    order by price DESC
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = (
    SELECT price
    FROM purchase
    order by price DESC
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = (
    SELECT price
    FROM purchase
    order by price DESC
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = (
    SELECT price
    FROM purchase
    order by price DESC
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = (
    SELECT price
    FROM purchase
    order by price DESC
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = (
    SELECT price
    FROM purchase
    order by price DESC
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = (
    SELECT price
    FROM purchase
    order by price DESC
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT pName, sName
    FROM product, store, purchase
    WHERE purchase.pID = product.pID AND purchase.sID = store.sID AND purchase.price = (
    SELECT price
    FROM purchase
    order by price DESC
    )
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT t1.pID, (t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#       pID  difference
#[Out]# 0      10        0.15
#[Out]# 1      10        0.15
#[Out]# 2      10        0.10
#[Out]# 3      10        0.05
#[Out]# 4      10        0.10
#[Out]# 5      10        0.10
#[Out]# 6      10        0.10
#[Out]# 7      10        0.05
#[Out]# 8      10        0.05
#[Out]# 9      10        0.15
#[Out]# 10     10        0.05
#[Out]# 11     10        0.05
#[Out]# 12     10        0.20
#[Out]# 13     10        0.20
#[Out]# 14     10        0.20
#[Out]# 15     10        0.15
#[Out]# 16     10        0.05
#[Out]# 17     10        0.10
#[Out]# 18     10        0.00
#[Out]# 19     10        0.05
#[Out]# 20     10        0.10
#[Out]# 21     10        0.15
#[Out]# 22     10        0.15
#[Out]# 23     10        0.10
#[Out]# 24     10        0.00
#[Out]# 25     10        0.05
#[Out]# 26     10        0.15
#[Out]# 27     10        0.10
#[Out]# 28     10        0.05
#[Out]# 29     10        0.00
#[Out]# ...   ...         ...
#[Out]# 1907   13        0.35
#[Out]# 1908   13        1.30
#[Out]# 1909   13        1.20
#[Out]# 1910   13        0.65
#[Out]# 1911   13        0.90
#[Out]# 1912   13        0.80
#[Out]# 1913   13        0.55
#[Out]# 1914   13        0.75
#[Out]# 1915   13        0.70
#[Out]# 1916   13        0.20
#[Out]# 1917   13        0.95
#[Out]# 1918   13        0.15
#[Out]# 1919   13        0.65
#[Out]# 1920   13        0.15
#[Out]# 1921   13        1.10
#[Out]# 1922   13        0.05
#[Out]# 1923   13        1.30
#[Out]# 1924   13        1.15
#[Out]# 1925   13        0.90
#[Out]# 1926   13        1.30
#[Out]# 1927   13        0.60
#[Out]# 1928   13        0.10
#[Out]# 1929   13        0.70
#[Out]# 1930   13        0.50
#[Out]# 1931   13        0.85
#[Out]# 1932   13        0.75
#[Out]# 1933   13        0.35
#[Out]# 1934   13        0.05
#[Out]# 1935   13        0.60
#[Out]# 1936   13        0.20
#[Out]# 
#[Out]# [1937 rows x 2 columns]
query6 = '''
    SELECT t1.pID, (t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = '2018-08-23'
    order by difference DESC
'''

pd.read_sql_query(query6, conn)
#[Out]#       pID  difference
#[Out]# 0      12        3.25
#[Out]# 1      12        3.20
#[Out]# 2      12        3.00
#[Out]# 3      12        2.95
#[Out]# 4      12        2.80
#[Out]# 5      12        2.75
#[Out]# 6      12        2.65
#[Out]# 7      12        2.65
#[Out]# 8      12        2.55
#[Out]# 9      12        2.40
#[Out]# 10     12        2.40
#[Out]# 11     12        2.40
#[Out]# 12     12        2.35
#[Out]# 13     12        2.25
#[Out]# 14     12        2.20
#[Out]# 15     27        2.20
#[Out]# 16     12        2.15
#[Out]# 17     27        2.10
#[Out]# 18     27        2.00
#[Out]# 19     12        2.00
#[Out]# 20     12        2.00
#[Out]# 21     12        1.95
#[Out]# 22     12        1.95
#[Out]# 23     12        1.95
#[Out]# 24     27        1.95
#[Out]# 25     27        1.95
#[Out]# 26     27        1.90
#[Out]# 27     27        1.85
#[Out]# 28     12        1.80
#[Out]# 29     12        1.80
#[Out]# ...   ...         ...
#[Out]# 1907    1       -2.15
#[Out]# 1908   12       -2.20
#[Out]# 1909   27       -2.20
#[Out]# 1910   27       -2.20
#[Out]# 1911   28       -2.20
#[Out]# 1912   12       -2.25
#[Out]# 1913   12       -2.25
#[Out]# 1914   27       -2.30
#[Out]# 1915   28       -2.30
#[Out]# 1916   27       -2.35
#[Out]# 1917   27       -2.35
#[Out]# 1918   28       -2.35
#[Out]# 1919   12       -2.35
#[Out]# 1920   12       -2.40
#[Out]# 1921   27       -2.40
#[Out]# 1922   12       -2.45
#[Out]# 1923   28       -2.45
#[Out]# 1924   28       -2.50
#[Out]# 1925   27       -2.55
#[Out]# 1926   28       -2.60
#[Out]# 1927   12       -2.65
#[Out]# 1928   12       -2.65
#[Out]# 1929   28       -2.70
#[Out]# 1930   28       -2.70
#[Out]# 1931   28       -2.75
#[Out]# 1932   28       -2.85
#[Out]# 1933   28       -3.00
#[Out]# 1934   28       -3.20
#[Out]# 1935   12       -3.40
#[Out]# 1936   12       -3.50
#[Out]# 
#[Out]# [1937 rows x 2 columns]
query6 = '''
    SELECT t1.pID, (t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.date = '2018-08-23'
    order by difference DESC
'''

pd.read_sql_query(query6, conn)
#[Out]#       pID  difference
#[Out]# 0      12        3.25
#[Out]# 1      12        3.20
#[Out]# 2      12        3.00
#[Out]# 3      12        3.00
#[Out]# 4      12        2.95
#[Out]# 5      12        2.80
#[Out]# 6      12        2.75
#[Out]# 7      12        2.65
#[Out]# 8      12        2.65
#[Out]# 9      12        2.55
#[Out]# 10     12        2.40
#[Out]# 11     12        2.40
#[Out]# 12     12        2.40
#[Out]# 13     12        2.35
#[Out]# 14     12        2.25
#[Out]# 15     12        2.20
#[Out]# 16     27        2.20
#[Out]# 17     12        2.15
#[Out]# 18     27        2.10
#[Out]# 19     27        2.00
#[Out]# 20     12        2.00
#[Out]# 21     12        2.00
#[Out]# 22     12        1.95
#[Out]# 23     12        1.95
#[Out]# 24     12        1.95
#[Out]# 25     27        1.95
#[Out]# 26     27        1.95
#[Out]# 27     27        1.90
#[Out]# 28     27        1.85
#[Out]# 29     12        1.80
#[Out]# ...   ...         ...
#[Out]# 2002   27       -2.20
#[Out]# 2003   27       -2.20
#[Out]# 2004   28       -2.20
#[Out]# 2005   12       -2.25
#[Out]# 2006   12       -2.25
#[Out]# 2007   28       -2.25
#[Out]# 2008   12       -2.25
#[Out]# 2009   27       -2.30
#[Out]# 2010   28       -2.30
#[Out]# 2011   27       -2.35
#[Out]# 2012   27       -2.35
#[Out]# 2013   28       -2.35
#[Out]# 2014   12       -2.35
#[Out]# 2015   12       -2.40
#[Out]# 2016   27       -2.40
#[Out]# 2017   12       -2.45
#[Out]# 2018   28       -2.45
#[Out]# 2019   28       -2.50
#[Out]# 2020   27       -2.55
#[Out]# 2021   28       -2.60
#[Out]# 2022   12       -2.65
#[Out]# 2023   12       -2.65
#[Out]# 2024   28       -2.70
#[Out]# 2025   28       -2.70
#[Out]# 2026   28       -2.75
#[Out]# 2027   28       -2.85
#[Out]# 2028   28       -3.00
#[Out]# 2029   28       -3.20
#[Out]# 2030   12       -3.40
#[Out]# 2031   12       -3.50
#[Out]# 
#[Out]# [2032 rows x 2 columns]
query6 = '''
    SELECT t1.pID, (t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.date = '2018-08-23'
    order by difference DESC
'''

pd.read_sql_query(query6, conn)
#[Out]#       pID  difference
#[Out]# 0      12        3.25
#[Out]# 1      12        3.20
#[Out]# 2      12        3.00
#[Out]# 3      12        3.00
#[Out]# 4      12        2.95
#[Out]# 5      12        2.80
#[Out]# 6      12        2.75
#[Out]# 7      12        2.65
#[Out]# 8      12        2.65
#[Out]# 9      12        2.55
#[Out]# 10     12        2.40
#[Out]# 11     12        2.40
#[Out]# 12     12        2.40
#[Out]# 13     12        2.35
#[Out]# 14     12        2.25
#[Out]# 15     12        2.20
#[Out]# 16     27        2.20
#[Out]# 17     12        2.15
#[Out]# 18     27        2.10
#[Out]# 19     27        2.00
#[Out]# 20     12        2.00
#[Out]# 21     12        2.00
#[Out]# 22     12        1.95
#[Out]# 23     12        1.95
#[Out]# 24     12        1.95
#[Out]# 25     27        1.95
#[Out]# 26     27        1.95
#[Out]# 27     27        1.90
#[Out]# 28     27        1.85
#[Out]# 29     12        1.80
#[Out]# ...   ...         ...
#[Out]# 2002   27       -2.20
#[Out]# 2003   27       -2.20
#[Out]# 2004   28       -2.20
#[Out]# 2005   12       -2.25
#[Out]# 2006   12       -2.25
#[Out]# 2007   28       -2.25
#[Out]# 2008   12       -2.25
#[Out]# 2009   27       -2.30
#[Out]# 2010   28       -2.30
#[Out]# 2011   27       -2.35
#[Out]# 2012   27       -2.35
#[Out]# 2013   28       -2.35
#[Out]# 2014   12       -2.35
#[Out]# 2015   12       -2.40
#[Out]# 2016   27       -2.40
#[Out]# 2017   12       -2.45
#[Out]# 2018   28       -2.45
#[Out]# 2019   28       -2.50
#[Out]# 2020   27       -2.55
#[Out]# 2021   28       -2.60
#[Out]# 2022   12       -2.65
#[Out]# 2023   12       -2.65
#[Out]# 2024   28       -2.70
#[Out]# 2025   28       -2.70
#[Out]# 2026   28       -2.75
#[Out]# 2027   28       -2.85
#[Out]# 2028   28       -3.00
#[Out]# 2029   28       -3.20
#[Out]# 2030   12       -3.40
#[Out]# 2031   12       -3.50
#[Out]# 
#[Out]# [2032 rows x 2 columns]
query6 = '''
    SELECT t1.pID, (t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = '2018-08-23'
    order by difference DESC
'''

pd.read_sql_query(query6, conn)
#[Out]#       pID  difference
#[Out]# 0      12        3.25
#[Out]# 1      12        3.20
#[Out]# 2      12        3.00
#[Out]# 3      12        2.95
#[Out]# 4      12        2.80
#[Out]# 5      12        2.75
#[Out]# 6      12        2.65
#[Out]# 7      12        2.65
#[Out]# 8      12        2.55
#[Out]# 9      12        2.40
#[Out]# 10     12        2.40
#[Out]# 11     12        2.40
#[Out]# 12     12        2.35
#[Out]# 13     12        2.25
#[Out]# 14     12        2.20
#[Out]# 15     27        2.20
#[Out]# 16     12        2.15
#[Out]# 17     27        2.10
#[Out]# 18     27        2.00
#[Out]# 19     12        2.00
#[Out]# 20     12        2.00
#[Out]# 21     12        1.95
#[Out]# 22     12        1.95
#[Out]# 23     12        1.95
#[Out]# 24     27        1.95
#[Out]# 25     27        1.95
#[Out]# 26     27        1.90
#[Out]# 27     27        1.85
#[Out]# 28     12        1.80
#[Out]# 29     12        1.80
#[Out]# ...   ...         ...
#[Out]# 1907    1       -2.15
#[Out]# 1908   12       -2.20
#[Out]# 1909   27       -2.20
#[Out]# 1910   27       -2.20
#[Out]# 1911   28       -2.20
#[Out]# 1912   12       -2.25
#[Out]# 1913   12       -2.25
#[Out]# 1914   27       -2.30
#[Out]# 1915   28       -2.30
#[Out]# 1916   27       -2.35
#[Out]# 1917   27       -2.35
#[Out]# 1918   28       -2.35
#[Out]# 1919   12       -2.35
#[Out]# 1920   12       -2.40
#[Out]# 1921   27       -2.40
#[Out]# 1922   12       -2.45
#[Out]# 1923   28       -2.45
#[Out]# 1924   28       -2.50
#[Out]# 1925   27       -2.55
#[Out]# 1926   28       -2.60
#[Out]# 1927   12       -2.65
#[Out]# 1928   12       -2.65
#[Out]# 1929   28       -2.70
#[Out]# 1930   28       -2.70
#[Out]# 1931   28       -2.75
#[Out]# 1932   28       -2.85
#[Out]# 1933   28       -3.00
#[Out]# 1934   28       -3.20
#[Out]# 1935   12       -3.40
#[Out]# 1936   12       -3.50
#[Out]# 
#[Out]# [1937 rows x 2 columns]
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = '2018-08-23'
    order by difference DESC
'''

pd.read_sql_query(query6, conn)
#[Out]#    difference
#[Out]# 0        3.25
query3 = '''
    SELECT cID, cName
    FROM purchase
    group by cID
    HAVING count(distinct sID) = (
    SELECT count(distinct sID)
    FROM purchase
    )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT cID
    FROM purchase
    group by cID
    HAVING count(distinct sID) = (
    SELECT count(distinct sID)
    FROM purchase
    )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = "2018-08-23"
'''

pd.read_sql_query(query6, conn)
#[Out]#    difference
#[Out]# 0        3.25
query6 = '''

    SELECT * FROM inventory WHERE date = '2018-08-23' ORDER BY pID, unit_price
'''

pd.read_sql_query(query6, conn)
#[Out]#     sID  pID        date  quantity  unit_price
#[Out]# 0     6    0  2018-08-23        37        4.35
#[Out]# 1    31    0  2018-08-23        25        4.60
#[Out]# 2    29    0  2018-08-23        28        5.15
#[Out]# 3    56    1  2018-08-23         1        4.40
#[Out]# 4    41    1  2018-08-23        53        4.60
#[Out]# 5    55    1  2018-08-23         1        4.80
#[Out]# 6     7    1  2018-08-23        18        5.80
#[Out]# 7    12    2  2018-08-23         3        1.70
#[Out]# 8    11    2  2018-08-23        22        2.10
#[Out]# 9     3    3  2018-08-23        17        1.35
#[Out]# 10   45    4  2018-08-23        50        1.00
#[Out]# 11   19    4  2018-08-23        53        1.20
#[Out]# 12    1    5  2018-08-23         2        0.45
#[Out]# 13   48    6  2018-08-23        21        1.15
#[Out]# 14   47    7  2018-08-23        27        1.85
#[Out]# 15   43    7  2018-08-23        20        1.95
#[Out]# 16   35    7  2018-08-23         7        2.20
#[Out]# 17   33    8  2018-08-23        16        4.80
#[Out]# 18   25    8  2018-08-23         6        5.55
#[Out]# 19   34   10  2018-08-23         8        0.45
#[Out]# 20   50   10  2018-08-23        54        0.55
#[Out]# 21   51   10  2018-08-23        31        0.60
#[Out]# 22    2   11  2018-08-23        21        1.00
#[Out]# 23   33   11  2018-08-23        32        1.05
#[Out]# 24   35   11  2018-08-23        15        1.20
#[Out]# 25   42   12  2018-08-23        46       11.40
#[Out]# 26   54   12  2018-08-23         5       12.55
#[Out]# 27    9   12  2018-08-23         5       13.15
#[Out]# 28    5   12  2018-08-23        11       13.40
#[Out]# 29   12   13  2018-08-23        15        3.55
#[Out]# ..  ...  ...         ...       ...         ...
#[Out]# 38   13   15  2018-08-23        11        1.25
#[Out]# 39   12   15  2018-08-23         1        1.25
#[Out]# 40   11   15  2018-08-23        14        1.30
#[Out]# 41    5   16  2018-08-23         4        1.65
#[Out]# 42    6   16  2018-08-23        14        1.85
#[Out]# 43   11   16  2018-08-23         3        1.90
#[Out]# 44    2   16  2018-08-23         0        2.00
#[Out]# 45   29   17  2018-08-23         4        1.95
#[Out]# 46    5   17  2018-08-23        34        2.45
#[Out]# 47    3   19  2018-08-23        11        2.10
#[Out]# 48   17   19  2018-08-23        10        2.20
#[Out]# 49   33   19  2018-08-23        32        2.25
#[Out]# 50   44   19  2018-08-23         4        2.65
#[Out]# 51   57   19  2018-08-23        12        2.95
#[Out]# 52   51   22  2018-08-23        13        1.55
#[Out]# 53   16   22  2018-08-23        14        1.60
#[Out]# 54   50   22  2018-08-23         5        1.95
#[Out]# 55   30   22  2018-08-23        29        2.05
#[Out]# 56   38   23  2018-08-23        29        1.80
#[Out]# 57   21   23  2018-08-23        20        2.10
#[Out]# 58   38   24  2018-08-23        10        3.55
#[Out]# 59    5   24  2018-08-23        32        4.10
#[Out]# 60   35   25  2018-08-23        36        4.00
#[Out]# 61   56   25  2018-08-23        19        4.35
#[Out]# 62   40   27  2018-08-23        17        6.90
#[Out]# 63   28   27  2018-08-23        43        8.50
#[Out]# 64   35   27  2018-08-23        54        8.85
#[Out]# 65   32   28  2018-08-23        36        6.85
#[Out]# 66   52   28  2018-08-23         8        7.35
#[Out]# 67   37   28  2018-08-23        19        7.75
#[Out]# 
#[Out]# [68 rows x 5 columns]
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = "2018-08-23" AND quantity > 0
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = "2018-08-23" AND t1.quantity > 0
'''

pd.read_sql_query(query6, conn)
#[Out]#    difference
#[Out]# 0        3.25
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = "2018-08-23" AND t1.quantity > 0 AND t2.date = "2018-08-23"
'''

pd.read_sql_query(query6, conn)
#[Out]#    difference
#[Out]# 0         2.0
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price) as difference
    FROM inventory t1, inventory t2
    WHERE t1.pID = t2.pID AND t1.sID != t2.sID AND t1.date = "2018-08-23" AND t1.quantity > 0 AND t2.date = t1.date
'''

pd.read_sql_query(query6, conn)
#[Out]#    difference
#[Out]# 0         2.0
