# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x1f122941f80>
query1 = '''
    SELECT count(*)
    FROM PURCHASE
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(*)
#[Out]# 0       509
query1 = '''
    SELECT count(*)
    FROM CUSTOMER
'''

pd.read_sql_query(query1, conn)
#[Out]#    count(*)
#[Out]# 0       190
query1 = '''
    select pID
    from purchase
    group by pID
    having count(cID) > 2
     
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
query1 = '''
    (select pID
    from product)
    except
    (select pID
    from purchase
    group by pID
    having count(cID) > 2)
     
'''

pd.read_sql_query(query1, conn)
query1 = '''
    
    (select pID
    from purchase
    group by pID
    having count(cID) > 2)
     
'''

pd.read_sql_query(query1, conn)
query1 = '''
    
    select pID
    from purchase
    group by pID
    having count(cID) > 2
     
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
query1 = '''
    select pID
    from product
    where pID not in 
    (select pID
    from purchase
    group by pID
    having count(cID) > 2)
     
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query3 = '''
    select cID
    from customer c
    where not exists (
        select distinct sID
        from store s
        except (
            select p.sID
            from purchase p
            where p.cID = c.cID
            )
        )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer c
    where not exists(
        select distinct sID
        from store s
        except(
            select p.sID
            from purchase p
            where p.cID = c.cID
            )
        )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer c
    where not exists(
        select distinct s.sID
        from store s
        except(
            select p.sID
            from purchase p
            where p.cID = c.cID
            )
        )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c
    where not exists(
        select distinct s.sID
        from store s
        except(
            select p.sID
            from purchase p
            where p.cID = c.cID
            )
        )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c
    where not exists( select distinct s.sID
        from store s
        except(select p.sID
            from purchase p
            where p.cID = c.cID
            )
        )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c
    where not exists(select distinct s.sID
        from store s
        except(select p.sID
            from purchase p
            where p.cID = c.cID
            )
        )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c
    where not exists(select distinct s.sID
        from store s
        except(select p.sID
            from purchase p
            where p.cID = c.cID))
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c
    where not exists((select distinct s.sID
        from store s)
        except(select p.sID
            from purchase p
            where p.cID = c.cID))
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c
    where not exists(
        (select distinct s.sID
        from store s)
        except(
            select p.sID
            from purchase p
            where p.cID = c.cID
            )
        )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c
    where not exists(
        select distinct s.sID
        from store s
        
        )
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    select c.cID
    from customer c
    where not exists(
        select distinct s.sID
        from store s
        except (
            select p.sID
            from purchase p
            where p.cID = c.cID
            )
        )
'''

pd.read_sql_query(query3, conn)
query4 = '''
    (select cID from customer)
    except
    (select cID from purchase)
'''

pd.read_sql_query(query4, conn)
query4 = '''
    select cID from customer
    except
    (select cID from purchase)
'''

pd.read_sql_query(query4, conn)
query4 = '''
    select cID from customer
    except
    select cID from purchase
'''

pd.read_sql_query(query4, conn)
#[Out]#     cID
#[Out]# 0     6
#[Out]# 1     9
#[Out]# 2    12
#[Out]# 3    14
#[Out]# 4    23
#[Out]# 5    32
#[Out]# 6    36
#[Out]# 7    46
#[Out]# 8    48
#[Out]# 9    49
#[Out]# 10   50
#[Out]# 11   53
#[Out]# 12   54
#[Out]# 13   56
#[Out]# 14   61
#[Out]# 15   62
#[Out]# 16   65
#[Out]# 17   73
#[Out]# 18   74
#[Out]# 19   79
#[Out]# 20   81
#[Out]# 21   83
#[Out]# 22   87
#[Out]# 23   89
#[Out]# 24   93
#[Out]# 25   98
#[Out]# 26  101
#[Out]# 27  102
#[Out]# 28  105
#[Out]# 29  106
#[Out]# 30  107
#[Out]# 31  114
#[Out]# 32  115
#[Out]# 33  117
#[Out]# 34  120
#[Out]# 35  121
#[Out]# 36  125
#[Out]# 37  130
#[Out]# 38  132
#[Out]# 39  138
#[Out]# 40  140
#[Out]# 41  141
#[Out]# 42  142
#[Out]# 43  143
#[Out]# 44  146
#[Out]# 45  148
#[Out]# 46  150
#[Out]# 47  153
#[Out]# 48  154
#[Out]# 49  155
#[Out]# 50  156
#[Out]# 51  158
#[Out]# 52  160
#[Out]# 53  164
#[Out]# 54  166
#[Out]# 55  173
#[Out]# 56  174
#[Out]# 57  183
query3 = '''
    select c.cID
    from customer c
    where not exists (
        select distinct s.sID
        from store s
        except (
            select p.sID
            from purchase p
            where p.cID = c.cID
            )
        )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c
    where not exists (
        select distinct s.sID
        from store s
        except 
            select p.sID
            from purchase p
            where p.cID = c.cID
            
        )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    (select c.cID
    from customer c
    where not exists (
        select distinct s.sID
        from store s)
        except 
            select p.sID
            from purchase p
            where p.cID = c.cID
            
        )
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select c.cID
    from customer c
    where not exists (
        select distinct s.sID
        from store s
        except 
            select p.sID
            from purchase p
            where p.cID = c.cID
        )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    with chain(Name) as (
        select s.Name
        from store s
        group by s.Name
        having count(distinct s.sID) > 1
        )
    select *
    from chain(Name)
    
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(Name) as (
        select s.Name
        from store s
        group by s.Name
        having count(distinct s.sID) > 1
        )
    select *
    from chain
    
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(Name) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
    select *
    from chain
    
'''

pd.read_sql_query(query4, conn)
#[Out]#           Name
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query5 = '''
    PUT YOUR QUERY HERE
'''
pd.to_csv('out.csv')
pd.read_sql_query(query5, conn)
query5 = '''
    PUT YOUR QUERY HERE
'''
sql.to_csv('out.csv')
pd.read_sql_query(query5, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select (chName, avg(p.quantity))
        from chain ch, purchase p
        group by chain
        ) 
    select *
    from chain_avg_quantity
    
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select (chName, avg(p.quantity))
        from chain ch, purchase p
        group by chain
        ) 
    select *
    from chain_avg_quantity
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select chName, avg(p.quantity)
        from chain ch, purchase p
        group by chain
        ) 
    select *
    from chain_avg_quantity
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select chName, avg(p.quantity)
        from chain ch, purchase p
        group by ch.chName
        ) 
    select *
    from chain_avg_quantity
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select chName, avg(p.quantity)
        from chain ch, purchase p, store s
        where ch.chName = s.sName and p.sID = s.sID
        group by ch.chName
        ) 
    select *
    from chain_avg_quantity
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select chName
        from chain ch, purchase p, store s
        where ch.chName = s.sName and p.sID = s.sID
        group by ch.chName
        ) 
    select *
    from chain_avg_quantity
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select chName, avg(p.quantity)
        from chain ch, purchase p, store s
        
        ) 
    select *
    from chain_avg_quantity
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qtychName as (
        select chName
        from chain ch, purchase p, store s
        where ch.chName = s.sName and p.sID = s.sID
        group by ch.chName
        ) 
    select *
    from chain_avg_quantity
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty (chName) as (
        select chName
        from chain ch, purchase p, store s
        where ch.chName = s.sName and p.sID = s.sID
        group by ch.chName
        ) 
    select *
    from chain_avg_quantity
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select chName, avg(p.quantity)
        from chain ch, purchase p, store s
        where ch.chName = s.sName and p.sID = s.sID
        group by ch.chName
        ) 
    select *
    from chain_avg_quantity
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select ch.chName, avg(p.quantity)
        from chain ch, purchase p, store s
        where ch.chName = s.sName and p.sID = s.sID
        group by ch.chName
        ) 
    select *
    from chain_avg_quantity
'''

pd.read_sql_query(query4, conn)
query5 = '''
    with expProduct(pName, pID, price) as (
        select pr.pName, pr.pID, pu.price
        from product pr, purchase pu
        )
'''
pd.read_sql_query(query5, conn)
query5 = '''
    with expProduct(pName, pID, price) as (
        select pr.pName, pr.pID, pu.price
        from product pr, purchase pu
        )
    select *
    from expProduct
'''
pd.read_sql_query(query5, conn)
#[Out]#                  pName  pID  price
#[Out]# 0          Cashew Nuts    0   0.45
#[Out]# 1          Cashew Nuts    0   4.65
#[Out]# 2          Cashew Nuts    0   1.60
#[Out]# 3          Cashew Nuts    0   1.25
#[Out]# 4          Cashew Nuts    0   3.95
#[Out]# 5          Cashew Nuts    0   2.75
#[Out]# 6          Cashew Nuts    0   0.90
#[Out]# 7          Cashew Nuts    0   9.10
#[Out]# 8          Cashew Nuts    0   2.45
#[Out]# 9          Cashew Nuts    0   1.35
#[Out]# 10         Cashew Nuts    0   1.10
#[Out]# 11         Cashew Nuts    0   3.70
#[Out]# 12         Cashew Nuts    0   1.55
#[Out]# 13         Cashew Nuts    0   4.30
#[Out]# 14         Cashew Nuts    0   2.75
#[Out]# 15         Cashew Nuts    0   1.45
#[Out]# 16         Cashew Nuts    0   4.15
#[Out]# 17         Cashew Nuts    0   9.05
#[Out]# 18         Cashew Nuts    0  13.60
#[Out]# 19         Cashew Nuts    0   1.05
#[Out]# 20         Cashew Nuts    0   3.05
#[Out]# 21         Cashew Nuts    0   2.75
#[Out]# 22         Cashew Nuts    0   4.70
#[Out]# 23         Cashew Nuts    0   8.25
#[Out]# 24         Cashew Nuts    0   1.10
#[Out]# 25         Cashew Nuts    0   1.55
#[Out]# 26         Cashew Nuts    0   1.85
#[Out]# 27         Cashew Nuts    0   2.20
#[Out]# 28         Cashew Nuts    0   2.10
#[Out]# 29         Cashew Nuts    0   1.70
#[Out]# ...                ...  ...    ...
#[Out]# 16258  French baguette   31   2.80
#[Out]# 16259  French baguette   31   0.50
#[Out]# 16260  French baguette   31   2.55
#[Out]# 16261  French baguette   31   0.65
#[Out]# 16262  French baguette   31   0.70
#[Out]# 16263  French baguette   31   3.70
#[Out]# 16264  French baguette   31   3.50
#[Out]# 16265  French baguette   31   2.95
#[Out]# 16266  French baguette   31   2.75
#[Out]# 16267  French baguette   31   1.50
#[Out]# 16268  French baguette   31   0.85
#[Out]# 16269  French baguette   31   3.55
#[Out]# 16270  French baguette   31   2.60
#[Out]# 16271  French baguette   31   3.25
#[Out]# 16272  French baguette   31   4.30
#[Out]# 16273  French baguette   31   3.05
#[Out]# 16274  French baguette   31   4.05
#[Out]# 16275  French baguette   31   1.50
#[Out]# 16276  French baguette   31   2.50
#[Out]# 16277  French baguette   31   3.95
#[Out]# 16278  French baguette   31   3.50
#[Out]# 16279  French baguette   31   2.95
#[Out]# 16280  French baguette   31   1.60
#[Out]# 16281  French baguette   31   3.25
#[Out]# 16282  French baguette   31   0.75
#[Out]# 16283  French baguette   31   3.80
#[Out]# 16284  French baguette   31   4.35
#[Out]# 16285  French baguette   31   2.85
#[Out]# 16286  French baguette   31   3.15
#[Out]# 16287  French baguette   31   3.30
#[Out]# 
#[Out]# [16288 rows x 3 columns]
query5 = '''
    with expProduct(pName, pID, price) as (
        select pr.pName, pr.pID, pu.price
        from product pr, purchase pu
        where not exists(
            select p1.pID
            from purchase p1, purchase p2
            where p1.price > p2.price)
        )
    select *
    from expProduct
'''
pd.read_sql_query(query5, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName, pID, price]
#[Out]# Index: []
query5 = '''
    with expProduct(pName, pID, price) as (
        select pr.pName, pr.pID, pu.price
        from product pr, purchase pu
        where not exists(
            select p1.pID
            from purchase p1, purchase p2
            where p1.price >= p2.price)
        )
    select *
    from expProduct
'''
pd.read_sql_query(query5, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName, pID, price]
#[Out]# Index: []
query5 = '''
    with expProduct(pName, pID, price) as (
        select pr.pName, pr.pID, pu.price
        from product pr, purchase pu
        where not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price >= pu.price)
        )
    select *
    from expProduct
'''
pd.read_sql_query(query5, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName, pID, price]
#[Out]# Index: []
query5 = '''
    with expProduct(pName, pID, price) as (
        select pr.pName, pr.pID, pu.price
        from product pr, purchase pu
        where not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price > pu.price)
        )
    select *
    from expProduct
'''
pd.read_sql_query(query5, conn)
#[Out]#                pName  pID  price
#[Out]# 0        Cashew Nuts    0   13.8
#[Out]# 1         Mixed Nuts    1   13.8
#[Out]# 2           Potatoes    2   13.8
#[Out]# 3       Green Pepper    3   13.8
#[Out]# 4             Onions    4   13.8
#[Out]# 5          Mushrooms    5   13.8
#[Out]# 6            Carrots    6   13.8
#[Out]# 7           Tomatoes    7   13.8
#[Out]# 8   Hot Dog Sausages    8   13.8
#[Out]# 9            Bananas    9   13.8
#[Out]# 10             Water   10   13.8
#[Out]# 11              Milk   11   13.8
#[Out]# 12              Beef   12   13.8
#[Out]# 13              Eggs   13   13.8
#[Out]# 14            Apples   14   13.8
#[Out]# 15         Cucumbers   15   13.8
#[Out]# 16              Rice   16   13.8
#[Out]# 17             Bread   17   13.8
#[Out]# 18            Cheese   18   13.8
#[Out]# 19              Coca   19   13.8
#[Out]# 20             Fanta   20   13.8
#[Out]# 21            Coffee   21   13.8
#[Out]# 22               Tea   22   13.8
#[Out]# 23   Spiced Biscuits   23   13.8
#[Out]# 24           Oranges   24   13.8
#[Out]# 25            Donuts   25   13.8
#[Out]# 26             Pasta   26   13.8
#[Out]# 27             Pizza   27   13.8
#[Out]# 28           Lasanga   28   13.8
#[Out]# 29            Salmon   29   13.8
#[Out]# 30           Ketchup   30   13.8
#[Out]# 31   French baguette   31   13.8
query5 = '''
    with expProduct(pName, pID, price) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select *
    from expProduct
'''
pd.read_sql_query(query5, conn)
#[Out]#                pName  pID  price
#[Out]# 0        Cashew Nuts    0     12
#[Out]# 1         Mixed Nuts    1     12
#[Out]# 2           Potatoes    2     12
#[Out]# 3       Green Pepper    3     12
#[Out]# 4             Onions    4     12
#[Out]# 5          Mushrooms    5     12
#[Out]# 6            Carrots    6     12
#[Out]# 7           Tomatoes    7     12
#[Out]# 8   Hot Dog Sausages    8     12
#[Out]# 9            Bananas    9     12
#[Out]# 10             Water   10     12
#[Out]# 11              Milk   11     12
#[Out]# 12              Beef   12     12
#[Out]# 13              Eggs   13     12
#[Out]# 14            Apples   14     12
#[Out]# 15         Cucumbers   15     12
#[Out]# 16              Rice   16     12
#[Out]# 17             Bread   17     12
#[Out]# 18            Cheese   18     12
#[Out]# 19              Coca   19     12
#[Out]# 20             Fanta   20     12
#[Out]# 21            Coffee   21     12
#[Out]# 22               Tea   22     12
#[Out]# 23   Spiced Biscuits   23     12
#[Out]# 24           Oranges   24     12
#[Out]# 25            Donuts   25     12
#[Out]# 26             Pasta   26     12
#[Out]# 27             Pizza   27     12
#[Out]# 28           Lasanga   28     12
#[Out]# 29            Salmon   29     12
#[Out]# 30           Ketchup   30     12
#[Out]# 31   French baguette   31     12
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select *
    from expProduct
'''
pd.read_sql_query(query5, conn)
#[Out]#     pName  pID  unitPrice
#[Out]# 0  Cheese   18         12
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select s.sName, eP.pName
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
    
'''
pd.read_sql_query(query5, conn)
#[Out]#          sName   pName
#[Out]# 0  Albert Hein  Cheese
#[Out]# 1         Coop  Cheese
#[Out]# 2         Coop  Cheese
#[Out]# 3       Sligro  Cheese
#[Out]# 4  Albert Hein  Cheese
#[Out]# 5         Lidl  Cheese
#[Out]# 6         Coop  Cheese
#[Out]# 7         Coop  Cheese
#[Out]# 8       Sligro  Cheese
#[Out]# 9        Jumbo  Cheese
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select distinct s.sName, eP.pName
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
    
'''
pd.read_sql_query(query5, conn)
#[Out]#          sName   pName
#[Out]# 0  Albert Hein  Cheese
#[Out]# 1         Coop  Cheese
#[Out]# 2       Sligro  Cheese
#[Out]# 3         Lidl  Cheese
#[Out]# 4        Jumbo  Cheese
query6 = '''
    select max(abs(i1.price - i2.price)
    from inventory i1, inventory i2
    
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select max(abs(i1.price - i2.price)
    from inventory i1, inventory i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select max(i1.price - i2.price)
    from inventory i1, inventory i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select max i1.price
    from inventory i1, inventory i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select max(i1.price)
    from inventory i1, inventory i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select max(abs(i1.unit-price - i2.unit-price)
    from inventory i1, inventory i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select max(i1.unit-price - i2.unit-price)
    from inventory i1, inventory i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select i1.unit-price
    from inventory i1, inventory i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    select *
    from inventory i1, inventory i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#        sID  pID        date  quantity  unit_price  sID  pID        date  \
#[Out]# 0       55   10  2018-08-26        17        0.60    1   10  2018-08-17   
#[Out]# 1       55   10  2018-08-26        17        0.60    3   10  2018-08-21   
#[Out]# 2       55   10  2018-08-26        17        0.60    5   10  2018-08-20   
#[Out]# 3       55   10  2018-08-26        17        0.60    6   10  2018-08-22   
#[Out]# 4       55   10  2018-08-26        17        0.60    8   10  2018-08-27   
#[Out]# 5       55   10  2018-08-26        17        0.60    9   10  2018-08-22   
#[Out]# 6       55   10  2018-08-26        17        0.60   18   10  2018-08-26   
#[Out]# 7       55   10  2018-08-26        17        0.60   23   10  2018-08-22   
#[Out]# 8       55   10  2018-08-26        17        0.60   24   10  2018-08-26   
#[Out]# 9       55   10  2018-08-26        17        0.60   27   10  2018-08-16   
#[Out]# 10      55   10  2018-08-26        17        0.60   27   10  2018-08-20   
#[Out]# 11      55   10  2018-08-26        17        0.60   27   10  2018-08-27   
#[Out]# 12      55   10  2018-08-26        17        0.60   28   10  2018-08-16   
#[Out]# 13      55   10  2018-08-26        17        0.60   28   10  2018-08-25   
#[Out]# 14      55   10  2018-08-26        17        0.60   34   10  2018-08-22   
#[Out]# 15      55   10  2018-08-26        17        0.60   34   10  2018-08-23   
#[Out]# 16      55   10  2018-08-26        17        0.60   35   10  2018-08-21   
#[Out]# 17      55   10  2018-08-26        17        0.60   38   10  2018-08-25   
#[Out]# 18      55   10  2018-08-26        17        0.60   38   10  2018-08-27   
#[Out]# 19      55   10  2018-08-26        17        0.60   42   10  2018-08-21   
#[Out]# 20      55   10  2018-08-26        17        0.60   43   10  2018-08-27   
#[Out]# 21      55   10  2018-08-26        17        0.60   45   10  2018-08-20   
#[Out]# 22      55   10  2018-08-26        17        0.60   45   10  2018-08-22   
#[Out]# 23      55   10  2018-08-26        17        0.60   45   10  2018-08-24   
#[Out]# 24      55   10  2018-08-26        17        0.60   45   10  2018-08-26   
#[Out]# 25      55   10  2018-08-26        17        0.60   50   10  2018-08-23   
#[Out]# 26      55   10  2018-08-26        17        0.60   51   10  2018-08-23   
#[Out]# 27      55   10  2018-08-26        17        0.60   53   10  2018-08-24   
#[Out]# 28      55   10  2018-08-26        17        0.60   54   10  2018-08-22   
#[Out]# 29      55   10  2018-08-26        17        0.60   54   10  2018-08-24   
#[Out]# ...    ...  ...         ...       ...         ...  ...  ...         ...   
#[Out]# 24457    0    0  2018-07-18        15        5.95    3    0  2018-08-24   
#[Out]# 24458    0    0  2018-07-18        15        5.95    3    0  2018-08-25   
#[Out]# 24459    0    0  2018-07-18        15        5.95    6    0  2018-08-23   
#[Out]# 24460    0    0  2018-07-18        15        5.95    8    0  2018-08-21   
#[Out]# 24461    0    0  2018-07-18        15        5.95   10    0  2018-08-16   
#[Out]# 24462    0    0  2018-07-18        15        5.95   14    0  2018-08-20   
#[Out]# 24463    0    0  2018-07-18        15        5.95   21    0  2018-08-17   
#[Out]# 24464    0    0  2018-07-18        15        5.95   22    0  2018-08-21   
#[Out]# 24465    0    0  2018-07-18        15        5.95   24    0  2018-08-17   
#[Out]# 24466    0    0  2018-07-18        15        5.95   26    0  2018-08-18   
#[Out]# 24467    0    0  2018-07-18        15        5.95   29    0  2018-08-23   
#[Out]# 24468    0    0  2018-07-18        15        5.95   30    0  2018-08-19   
#[Out]# 24469    0    0  2018-07-18        15        5.95   30    0  2018-08-21   
#[Out]# 24470    0    0  2018-07-18        15        5.95   31    0  2018-08-15   
#[Out]# 24471    0    0  2018-07-18        15        5.95   31    0  2018-08-21   
#[Out]# 24472    0    0  2018-07-18        15        5.95   31    0  2018-08-23   
#[Out]# 24473    0    0  2018-07-18        15        5.95   33    0  2018-08-17   
#[Out]# 24474    0    0  2018-07-18        15        5.95   35    0  2018-08-25   
#[Out]# 24475    0    0  2018-07-18        15        5.95   36    0  2018-08-26   
#[Out]# 24476    0    0  2018-07-18        15        5.95   41    0  2018-08-15   
#[Out]# 24477    0    0  2018-07-18        15        5.95   42    0  2018-08-24   
#[Out]# 24478    0    0  2018-07-18        15        5.95   42    0  2018-08-26   
#[Out]# 24479    0    0  2018-07-18        15        5.95   43    0  2018-08-25   
#[Out]# 24480    0    0  2018-07-18        15        5.95   44    0  2018-08-16   
#[Out]# 24481    0    0  2018-07-18        15        5.95   47    0  2018-08-24   
#[Out]# 24482    0    0  2018-07-18        15        5.95   49    0  2018-08-24   
#[Out]# 24483    0    0  2018-07-18        15        5.95   49    0  2018-08-27   
#[Out]# 24484    0    0  2018-07-18        15        5.95   50    0  2018-08-24   
#[Out]# 24485    0    0  2018-07-18        15        5.95   52    0  2018-08-16   
#[Out]# 24486    0    0  2018-07-18        15        5.95   59    0  2018-08-17   
#[Out]# 
#[Out]#        quantity  unit_price  
#[Out]# 0            29        0.45  
#[Out]# 1            13        0.45  
#[Out]# 2            11        0.50  
#[Out]# 3            20        0.55  
#[Out]# 4            26        0.50  
#[Out]# 5             3        0.50  
#[Out]# 6            16        0.50  
#[Out]# 7            52        0.55  
#[Out]# 8            19        0.55  
#[Out]# 9            16        0.55  
#[Out]# 10            7        0.55  
#[Out]# 11           19        0.45  
#[Out]# 12           15        0.40  
#[Out]# 13            7        0.40  
#[Out]# 14           31        0.40  
#[Out]# 15            8        0.45  
#[Out]# 16           51        0.55  
#[Out]# 17            9        0.60  
#[Out]# 18           33        0.50  
#[Out]# 19            3        0.55  
#[Out]# 20           12        0.50  
#[Out]# 21            6        0.60  
#[Out]# 22           21        0.45  
#[Out]# 23           11        0.45  
#[Out]# 24           54        0.50  
#[Out]# 25           54        0.55  
#[Out]# 26           31        0.60  
#[Out]# 27           32        0.45  
#[Out]# 28            4        0.50  
#[Out]# 29           16        0.55  
#[Out]# ...         ...         ...  
#[Out]# 24457        18        4.85  
#[Out]# 24458         5        3.75  
#[Out]# 24459        37        4.35  
#[Out]# 24460        16        4.00  
#[Out]# 24461        18        5.30  
#[Out]# 24462         9        4.80  
#[Out]# 24463         3        5.40  
#[Out]# 24464        16        4.50  
#[Out]# 24465        53        3.80  
#[Out]# 24466         9        4.90  
#[Out]# 24467        28        5.15  
#[Out]# 24468        30        5.25  
#[Out]# 24469        21        4.90  
#[Out]# 24470         7        5.25  
#[Out]# 24471        12        5.10  
#[Out]# 24472        25        4.60  
#[Out]# 24473        12        5.35  
#[Out]# 24474         1        4.35  
#[Out]# 24475        13        3.95  
#[Out]# 24476        35        4.55  
#[Out]# 24477        12        5.00  
#[Out]# 24478        18        4.65  
#[Out]# 24479        13        4.40  
#[Out]# 24480        11        5.40  
#[Out]# 24481        13        4.80  
#[Out]# 24482        12        4.40  
#[Out]# 24483        10        4.20  
#[Out]# 24484         3        3.70  
#[Out]# 24485        18        3.95  
#[Out]# 24486         1        3.90  
#[Out]# 
#[Out]# [24487 rows x 10 columns]
query6 = '''
    select max(i1.unit_price - i2.unit_price)
    from inventory i1, inventory i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price - i2.unit_price)
#[Out]# 0                                4.75
query6 = '''
    select max(abs(i1.unit_price - i2.unit_price))
    from inventory i1, inventory i2
    where i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                     4.75
query6 = '''
    select max(abs(i1.unit_price - i2.unit_price))
    from inventory i1, inventory i2
    where i1.pID = i2.pID and i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                     4.75
query6 = '''
    select max(abs(i1.unit_price - i2.unit_price))
    from inventory i1, inventory i2
    where i1.pID = i2.pID and i1.sID != i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                     4.75
query6 = '''
    select max(abs(i1.unit_price - i2.unit_price))
    from inventory i1, inventory i2
    where i1.pID = i2.pID and i1.sID != i2.sID and i1.date = "2018-08-23"
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                      3.5
query6 = '''
    select max(abs(i1.unit_price - i2.unit_price))
    from inventory i1, inventory i2
    where i1.pID = i2.pID and i1.sID != i2.sID and i1.date = "2018-08-23" and i2.date = "2018-08-23"
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                      2.0
query6 = '''
    select max(abs(i1.unit_price - i2.unit_price))
    from inventory i1, inventory i2
    where i1.pID = i2.pID and i1.sID != i2.sID 
    and i1.date = "2018-08-23" and i2.date = "2018-08-23"
    and i1.quantity > 0 and i2.quantity > 0
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                      2.0
query2 = '''
    select c.cID, c.cName
    from customer c, purchase pu1, purchase pu2, product pr1, product pr2
    where c.cID = pu1.cID and c.cID = pu2.cID
        and pu1.pID = pr1.pID and pu2.pID = pr2.pID
        and pu1.date = pu2.date and pr1.pName = "Onions"
        and pr2.pName = "Coffee"
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select ch.chName, avg(p.quantity)
        from chain ch, purchase p, store s
        where ch.chName = s.sName and p.sID = s.sID
        group by ch.chName
        ) 
    select *
    from chain_avg_qty
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select ch.chName, avg(p.quantity)
        from chain ch, purchase p, store s
        where ch.chName = s.sName and p.sID = s.sID
        group by ch.chName
        ) 
    select *
    from chain
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    
    select *
    from chain
'''

pd.read_sql_query(query4, conn)
#[Out]#         chName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select ch.chName, avg(p.quantity)
        from chain ch, purchase p, store s
        where p.sID = s.sID and s.sName = ch.chName
        )
    select *
    from chain
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName, avg_qty) as (
        select ch.chName, p.quantity
        from chain ch, purchase p, store s
        where p.sID = s.sID and s.sName = ch.chName
        )
    select *
    from chain
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName) as (
        select ch.chName
        from chain ch, purchase p, store s
        where p.sID = s.sID and s.sName = ch.chName
        )
    select *
    from chain
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    with chain_avg_qty(chName) as (
        select p.pID
        from chain ch, purchase p, store s
        where p.sID = s.sID and s.sName = ch.chName
        )
    select *
    from chain
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
'''

pd.read_sql_query(query4, conn)
#[Out]#              chName
#[Out]# 0       Albert Hein
#[Out]# 1       Albert Hein
#[Out]# 2       Albert Hein
#[Out]# 3       Albert Hein
#[Out]# 4       Albert Hein
#[Out]# 5       Albert Hein
#[Out]# 6       Albert Hein
#[Out]# 7       Albert Hein
#[Out]# 8       Albert Hein
#[Out]# 9       Albert Hein
#[Out]# 10      Albert Hein
#[Out]# 11      Albert Hein
#[Out]# 12      Albert Hein
#[Out]# 13      Albert Hein
#[Out]# 14      Albert Hein
#[Out]# 15      Albert Hein
#[Out]# 16      Albert Hein
#[Out]# 17      Albert Hein
#[Out]# 18      Albert Hein
#[Out]# 19      Albert Hein
#[Out]# 20      Albert Hein
#[Out]# 21      Albert Hein
#[Out]# 22      Albert Hein
#[Out]# 23      Albert Hein
#[Out]# 24      Albert Hein
#[Out]# 25      Albert Hein
#[Out]# 26      Albert Hein
#[Out]# 27      Albert Hein
#[Out]# 28      Albert Hein
#[Out]# 29      Albert Hein
#[Out]# ...             ...
#[Out]# 228002       Sligro
#[Out]# 228003       Sligro
#[Out]# 228004       Sligro
#[Out]# 228005       Sligro
#[Out]# 228006       Sligro
#[Out]# 228007       Sligro
#[Out]# 228008       Sligro
#[Out]# 228009       Sligro
#[Out]# 228010       Sligro
#[Out]# 228011       Sligro
#[Out]# 228012       Sligro
#[Out]# 228013       Sligro
#[Out]# 228014       Sligro
#[Out]# 228015       Sligro
#[Out]# 228016       Sligro
#[Out]# 228017       Sligro
#[Out]# 228018       Sligro
#[Out]# 228019       Sligro
#[Out]# 228020       Sligro
#[Out]# 228021       Sligro
#[Out]# 228022       Sligro
#[Out]# 228023       Sligro
#[Out]# 228024       Sligro
#[Out]# 228025       Sligro
#[Out]# 228026       Sligro
#[Out]# 228027       Sligro
#[Out]# 228028       Sligro
#[Out]# 228029       Sligro
#[Out]# 228030       Sligro
#[Out]# 228031       Sligro
#[Out]# 
#[Out]# [228032 rows x 1 columns]
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
'''

pd.read_sql_query(query4, conn)
#[Out]#           chName
#[Out]# 0         Sligro
#[Out]# 1           Dirk
#[Out]# 2         Sligro
#[Out]# 3      Hoogvliet
#[Out]# 4    Albert Hein
#[Out]# 5           Lidl
#[Out]# 6           Lidl
#[Out]# 7           Lidl
#[Out]# 8           Lidl
#[Out]# 9         Sligro
#[Out]# 10          Coop
#[Out]# 11          Coop
#[Out]# 12          Coop
#[Out]# 13   Albert Hein
#[Out]# 14          Dirk
#[Out]# 15        Sligro
#[Out]# 16     Hoogvliet
#[Out]# 17         Jumbo
#[Out]# 18          Coop
#[Out]# 19          Coop
#[Out]# 20        Sligro
#[Out]# 21   Albert Hein
#[Out]# 22     Hoogvliet
#[Out]# 23          Lidl
#[Out]# 24          Coop
#[Out]# 25          Coop
#[Out]# 26          Coop
#[Out]# 27     Hoogvliet
#[Out]# 28        Sligro
#[Out]# 29          Lidl
#[Out]# ..           ...
#[Out]# 479         Coop
#[Out]# 480         Lidl
#[Out]# 481         Lidl
#[Out]# 482        Jumbo
#[Out]# 483    Hoogvliet
#[Out]# 484       Sligro
#[Out]# 485    Hoogvliet
#[Out]# 486  Albert Hein
#[Out]# 487       Sligro
#[Out]# 488         Coop
#[Out]# 489  Albert Hein
#[Out]# 490         Coop
#[Out]# 491         Lidl
#[Out]# 492         Coop
#[Out]# 493    Hoogvliet
#[Out]# 494    Hoogvliet
#[Out]# 495       Sligro
#[Out]# 496         Coop
#[Out]# 497         Lidl
#[Out]# 498         Coop
#[Out]# 499         Dirk
#[Out]# 500         Coop
#[Out]# 501        Jumbo
#[Out]# 502         Dirk
#[Out]# 503         Dirk
#[Out]# 504        Jumbo
#[Out]# 505         Lidl
#[Out]# 506         Lidl
#[Out]# 507        Jumbo
#[Out]# 508        Jumbo
#[Out]# 
#[Out]# [509 rows x 1 columns]
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
    groupby ch.chName
'''

pd.read_sql_query(query4, conn)
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
    group by ch.chName
'''

pd.read_sql_query(query4, conn)
#[Out]#         chName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
    group by ch.chName
    having avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#         chName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
    group by ch.chName
    having avg(p.quantity) > 8
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [chName]
#[Out]# Index: []
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
    group by ch.chName
    having avg(p.quantity) > 1
'''

pd.read_sql_query(query4, conn)
#[Out]#         chName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
    group by ch.chName
    having avg(p.quantity) > 2
'''

pd.read_sql_query(query4, conn)
#[Out]#         chName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
    group by ch.chName
    having avg(p.quantity) > 3
'''

pd.read_sql_query(query4, conn)
#[Out]#         chName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
    group by ch.chName
    having avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#         chName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
    group by ch.chName
    having avg(p.quantity) > 3
'''

pd.read_sql_query(query4, conn)
#[Out]#         chName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
    with chain(chName) as (
        select s.sName
        from store s
        group by s.sName
        having count(distinct s.sID) > 1
        )
        
    select ch.chName
    from chain ch, purchase p, store s
    where ch.chName = s.sName and s.sID = p.sID
    group by ch.chName
    having avg(p.quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#         chName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query1 = '''
    select pID
    from product
    where pID not in 
        (select pID
        from purchase
        group by pID
        having count(cID) > 2) 
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select distinct s.sName, eP.pName, p.price
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
    
'''
pd.read_sql_query(query5, conn)
#[Out]#          sName   pName  price
#[Out]# 0  Albert Hein  Cheese  11.55
#[Out]# 1         Coop  Cheese  10.30
#[Out]# 2         Coop  Cheese  10.60
#[Out]# 3       Sligro  Cheese  10.50
#[Out]# 4  Albert Hein  Cheese  12.00
#[Out]# 5         Lidl  Cheese   8.55
#[Out]# 6         Coop  Cheese   9.65
#[Out]# 7         Coop  Cheese   8.85
#[Out]# 8       Sligro  Cheese   9.70
#[Out]# 9        Jumbo  Cheese   3.30
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select distinct s.sName, eP.pName, p.price / p.quantity
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
    
'''
pd.read_sql_query(query5, conn)
#[Out]#          sName   pName  p.price / p.quantity
#[Out]# 0  Albert Hein  Cheese             11.550000
#[Out]# 1         Coop  Cheese             10.300000
#[Out]# 2         Coop  Cheese              3.533333
#[Out]# 3       Sligro  Cheese              1.500000
#[Out]# 4  Albert Hein  Cheese             12.000000
#[Out]# 5         Lidl  Cheese              8.550000
#[Out]# 6         Coop  Cheese              1.608333
#[Out]# 7         Coop  Cheese              8.850000
#[Out]# 8       Sligro  Cheese              9.700000
#[Out]# 9        Jumbo  Cheese              3.300000
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select distinct s.sName, eP.pName, p.price / p.quantity
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
        and eP.unit_price = p.price / p.quantity
'''
pd.read_sql_query(query5, conn)
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select distinct s.sName, eP.pName, p.price / p.quantity
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
        and eP.price = p.unit_price / p.quantity
'''
pd.read_sql_query(query5, conn)
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select distinct s.sName, eP.pName, p.price / p.quantity
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
        and eP.unitPrice = p.unit_price / p.quantity
'''
pd.read_sql_query(query5, conn)
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select distinct s.sName, eP.pName, p.price / p.quantity
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
        and eP.unitPrice = p.price / p.quantity
'''
pd.read_sql_query(query5, conn)
#[Out]#          sName   pName  p.price / p.quantity
#[Out]# 0  Albert Hein  Cheese                    12
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select distinct s.sName, eP.pName
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
        and eP.unitPrice = p.price / p.quantity
'''
pd.read_sql_query(query5, conn)
#[Out]#          sName   pName
#[Out]# 0  Albert Hein  Cheese
query = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select distinct s.sName, eP.pName
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
        and eP.unitPrice = p.price / p.quantity
'''
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price > pu.price)
        )
    select distinct s.sName, eP.pName
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
        and eP.unitPrice = p.price
'''
pd.read_sql_query(query5, conn)
#[Out]#     sName pName
#[Out]# 0  Sligro  Beef
query5 = '''
    with expProduct(pName, pID, unitPrice) as (
        select pr.pName, pr.pID, pu.price / pu.quantity
        from product pr, purchase pu
        where pr.pID = pu.pID and not exists(
            select pu2.pID
            from purchase pu2
            where pu2.price / pu2.quantity > pu.price / pu.quantity)
        )
    select distinct s.sName, eP.pName
    from store s, purchase p, expProduct eP
    where s.sID = p.sID and p.pID = eP.pID
        and eP.unitPrice = p.price / p.quantity
'''
pd.read_sql_query(query5, conn)
#[Out]#          sName   pName
#[Out]# 0  Albert Hein  Cheese
