# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
query1 = '''
        SELECT pID
      FROM product
    EXCEPT
    SELECT pID
      FROM purchase
     GROUP BY pID
    HAVING count(DISTINCT cID) > 3;

  )
'''

pd.read_sql_query(query1, conn)
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
#db_location = 'shoppingDB.sql'

#f = open(db_location,'r')
#sql = f.read()
#cur.executescript(sql)
query1 = '''
        SELECT pID
      FROM product
    EXCEPT
    SELECT pID
      FROM purchase
     GROUP BY pID
    HAVING count(DISTINCT cID) > 3;

  )
'''

pd.read_sql_query(query1, conn)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
query1 = '''
        SELECT pID
      FROM product
    EXCEPT
    SELECT pID
      FROM purchase
     GROUP BY pID
    HAVING count(DISTINCT cID) > 3;

  )
'''

pd.read_sql_query(query1, conn)
query1 = '''
        SELECT pID
      FROM product
    EXCEPT
    SELECT pID
      FROM purchase
     GROUP BY pID
    HAVING count(DISTINCT cID) > 3
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
        SELECT pID
      FROM product
    EXCEPT
    SELECT pID
      FROM purchase
     GROUP BY pID
    HAVING count(DISTINCT cID) > 3;
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    SELECT 
        c.cID, c.cName
    FROM 
        customer AS c,
        purchase AS p1,
        purchase AS p2, 
        product AS pr1, 
        product AS pr2
    WHERE 
        p1.cID = c.cID AND
        p2.cID = c.cID AND
        p1.date = p2.date AND
        pr1.pName = 'Onions' AND
        pr2.pName = 'Coffee' AND
        p1.pID = pr1.pID AND
        p2.pID = pr2.pID;
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    WITH [temp] (
    cID,
    nStores
)
AS (
    SELECT cID,
           count(DISTINCT sID) 
      FROM purchase
     GROUP BY cID
)
SELECT cID
  FROM [temp]
 WHERE nStores IN (
           SELECT count(DISTINCT sID) 
             FROM store
       );

'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT s.sName
  FROM store AS s,
       purchase AS p
 WHERE p.sID = s.sID
 GROUP BY s.sName
HAVING avg(p.quantity) > 4;


'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT p.pName, i.sID
    FROM product AS p, inventory AS i
    WHERE p.pID = i.pID AND i.unit_price in 
        (SELECT max(inventory.unit_price)
         FROM inventory)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID
#[Out]# 0  Beef    8
query5 = '''
    SELECT p.pName, s.sName
    FROM product AS p, inventory AS i, store as s
    WHERE p.pID = i.pID AND s.sID = i.sID and i.unit_price in 
        (SELECT max(inventory.unit_price)
         FROM inventory)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName
#[Out]# 0  Beef  Albert Hein

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
query1 = '''
    SELECT
      product.pID
    FROM
      product
    WHERE
      product.pID NOT IN (
        SELECT
          p.pID
        FROM
          product AS p,
          purchase AS p1,
          purchase AS p2,
          purchase AS p3
        WHERE
          p.pID = p1.pID
          AND p.pID = p2.pID
          AND p.pID = p3.pID
          AND p1.cID <> p2.cID
          AND p1.cID <> p3.cID
          AND p2.cID <> p3.cID
  )
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    SELECT 
        c.cID, c.cName
    FROM 
        customer AS c,
        purchase AS p1,
        purchase AS p2, 
        product AS pr1, 
        product AS pr2
    WHERE 
        p1.cID = c.cID AND
        p2.cID = c.cID AND
        p1.date = p2.date AND
        pr1.pName = 'Onions' AND
        pr2.pName = 'Coffee' AND
        p1.pID = pr1.pID AND
        p2.pID = pr2.pID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query5 = '''
    SELECT p.pName, i.sID
    FROM product AS p, inventory AS i
    WHERE p.pID = i.pID AND i.unit_price = 
        (SELECT max(inventory.unit_price)
         FROM inventory)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID
#[Out]# 0  Beef    8
query5 = '''
    SELECT p.pName, i.sID
    FROM product AS p, inventory AS i
    WHERE p.pID = i.pID AND i.unit_price = 
        (SELECT max(inventory.unit_price)
         FROM inventory)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID
#[Out]# 0  Beef    8
query5 = '''
    SELECT p.pName, i.sID
    FROM product AS p, inventory AS i
    WHERE p.pID = i.pID AND i.unit_price = 
        (SELECT max(inventory.unit_price)
         FROM inventory)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID
#[Out]# 0  Beef    8
query5 = '''
    SELECT p.pName, i.sID
    FROM product AS p, inventory AS i
    WHERE p.pID = i.pID AND i.unit_price = 
        (SELECT max(inventory.unit_price)
         FROM inventory)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID
#[Out]# 0  Beef    8
query3 = '''
    select
  storesVisited.cID
from
  (
    select
      count(distinct sID) as nStores
    from
      store
  ) as storesCount,
  (
    select
      p.cID,
      count(distinct p.sID) as nStoresCustomer
    from
      store as s,
      purchase as p
    where
      p.sID = s.sID
    group by
      p.cID
  ) as storesVisited
where
  storesCount.nStores = storesVisited.nStoresCustomer

'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    select
  chainsQ.sName
from
  (
    select
      s.sName,
      avg(p.quantity) as averageQ
    from
      store as s,
      purchase as p,
      (
        select
          distinct st.sName
        from
          store as st,
          store as st1
        where
          st1.sID <> st.sName
          and st1.sName = st.sName
      ) as storeChains
    where
      p.sID = s.sID
      and storeChains.sName = s.sName
    group by
      s.sName
  ) as chainsQ
where
  chainsQ.averageQ > 4

'''

pd.read_sql_query(query4, conn)
#[Out]#   chainsQ.sName
#[Out]# 0   Albert Hein
#[Out]# 1          Coop
#[Out]# 2          Dirk
#[Out]# 3     Hoogvliet
#[Out]# 4          Lidl
#[Out]# 5        Sligro
query4 = '''
    select
  chainsQ.sName as sName
from
  (
    select
      s.sName,
      avg(p.quantity) as averageQ
    from
      store as s,
      purchase as p,
      (
        select
          distinct st.sName
        from
          store as st,
          store as st1
        where
          st1.sID <> st.sName
          and st1.sName = st.sName
      ) as storeChains
    where
      p.sID = s.sID
      and storeChains.sName = s.sName
    group by
      s.sName
  ) as chainsQ
where
  chainsQ.averageQ > 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    select
  sName
from
  (
    select
      s.sName,
      avg(p.quantity) as averageQ
    from
      store as s,
      purchase as p,
      (
        select
          distinct st.sName
        from
          store as st,
          store as st1
        where
          st1.sID <> st.sName
          and st1.sName = st.sName
      ) as storeChains
    where
      p.sID = s.sID
      and storeChains.sName = s.sName
    group by
      s.sName
  ) as chainsQ
where
  chainsQ.averageQ > 4

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query6 = '''
        SELECT max(i.unit_price) - min(i.unit_price) AS diff
      FROM inventory AS i,
           inventory AS i2
     WHERE i.date = "2018-08-23" AND 
           i.pID = i2.pID AND 
           i.sID <> i2.sID
     GROUP BY i.pID
     ORDER BY diff DESC
     LIMIT 1;

'''

pd.read_sql_query(query6, conn)
#[Out]#    diff
#[Out]# 0   2.0

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x1f4c9370d50>
query1 = '''
    SELECT p.pID
    FROM product AS p, purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p.pID = p1.pID AND p.pID = p2.pID AND p.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID and p2.cID <> p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#         pID
#[Out]# 0        10
#[Out]# 1        10
#[Out]# 2        10
#[Out]# 3        10
#[Out]# 4        10
#[Out]# 5        10
#[Out]# 6        10
#[Out]# 7        10
#[Out]# 8        10
#[Out]# 9        10
#[Out]# 10       10
#[Out]# 11       10
#[Out]# 12       10
#[Out]# 13       10
#[Out]# 14       10
#[Out]# 15       10
#[Out]# 16       10
#[Out]# 17       10
#[Out]# 18       10
#[Out]# 19       10
#[Out]# 20       10
#[Out]# 21       10
#[Out]# 22       10
#[Out]# 23       10
#[Out]# 24       10
#[Out]# 25       10
#[Out]# 26       10
#[Out]# 27       10
#[Out]# 28       10
#[Out]# 29       10
#[Out]# ...     ...
#[Out]# 144588   18
#[Out]# 144589   18
#[Out]# 144590   18
#[Out]# 144591   18
#[Out]# 144592   18
#[Out]# 144593   18
#[Out]# 144594   18
#[Out]# 144595   18
#[Out]# 144596   18
#[Out]# 144597   18
#[Out]# 144598   18
#[Out]# 144599   18
#[Out]# 144600   18
#[Out]# 144601   18
#[Out]# 144602   18
#[Out]# 144603   18
#[Out]# 144604   18
#[Out]# 144605   18
#[Out]# 144606   18
#[Out]# 144607   18
#[Out]# 144608   18
#[Out]# 144609   18
#[Out]# 144610   18
#[Out]# 144611   18
#[Out]# 144612   18
#[Out]# 144613   18
#[Out]# 144614   18
#[Out]# 144615   18
#[Out]# 144616   18
#[Out]# 144617   18
#[Out]# 
#[Out]# [144618 rows x 1 columns]
query1 = '''
    SELECT DISTINCT p.pID
    FROM product AS p, purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p.pID = p1.pID AND p.pID = p2.pID AND p.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID and p2.cID <> p3.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     0
#[Out]# 1     1
#[Out]# 2     2
#[Out]# 3     3
#[Out]# 4     4
#[Out]# 5     5
#[Out]# 6     6
#[Out]# 7     7
#[Out]# 8     8
#[Out]# 9     9
#[Out]# 10   10
#[Out]# 11   11
#[Out]# 12   12
#[Out]# 13   13
#[Out]# 14   14
#[Out]# 15   15
#[Out]# 16   16
#[Out]# 17   17
#[Out]# 18   18
#[Out]# 19   19
#[Out]# 20   20
#[Out]# 21   21
#[Out]# 22   22
#[Out]# 23   23
#[Out]# 24   24
#[Out]# 25   25
#[Out]# 26   26
#[Out]# 27   27
#[Out]# 28   28
query1 = '''
    SELECT product.pID
    FROM product
    WHERE product.pID NOT IN
    (SELECT p.pID
    FROM product AS p, purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p.pID = p1.pID AND p.pID = p2.pID AND p.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID and p2.cID <> p3.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
    SELECT product.pID
    FROM product
    EXCEPT
        (SELECT p.pID
        FROM product AS p, purchase AS p1, purchase AS p2, purchase AS p3
        WHERE p.pID = p1.pID AND p.pID = p2.pID AND p.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID and p2.cID <> p3.cID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT product.pID
    FROM product
    WHERE product.pID NOT IN
        (SELECT p.pID
        FROM product AS p, purchase AS p1, purchase AS p2, purchase AS p3
        WHERE p.pID = p1.pID AND p.pID = p2.pID AND p.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID and p2.cID <> p3.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
    (SELECT product.pID
    FROM product)
    EXCEPT
        (SELECT p.pID
        FROM product AS p, purchase AS p1, purchase AS p2, purchase AS p3
        WHERE p.pID = p1.pID AND p.pID = p2.pID AND p.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID and p2.cID <> p3.cID)
'''

pd.read_sql_query(query1, conn)
query1 = '''
    (SELECT product.pID
    FROM product)
    EXCEPT
        (SELECT p.pID
        FROM product AS p, purchase AS p1, purchase AS p2, purchase AS p3
        WHERE p.pID = p1.pID AND p.pID = p2.pID AND p.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID and p2.cID <> p3.cID);
'''

pd.read_sql_query(query1, conn)
query1 = '''
    (SELECT pID
    FROM product)
    EXCEPT
        (SELECT p.pID
        FROM product AS p, purchase AS p1, purchase AS p2, purchase AS p3
        WHERE p.pID = p1.pID AND p.pID = p2.pID AND p.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID and p2.cID <> p3.cID);
'''

pd.read_sql_query(query1, conn)
query1 = '''
    (SELECT pID
    FROM product)
    EXCEPT:
        (SELECT p.pID
        FROM product AS p, purchase AS p1, purchase AS p2, purchase AS p3
        WHERE p.pID = p1.pID AND p.pID = p2.pID AND p.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID and p2.cID <> p3.cID);
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT product.pID
    FROM product
    WHERE product.pID NOT IN
    SELECT p.pID
    FROM product AS p, 
        purchase AS p1, 
        purchase AS p2, 
        purchase AS p3
    WHERE 
        p.pID = p1.pID AND 
        p.pID = p2.pID AND 
        p.pID = p3.pID AND 
        p1.cID <> p2.cID AND 
        p1.cID <> p3.cID AND 
        p2.cID <> p3.cID
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT product.pID
    FROM product
    WHERE product.pID NOT IN
    (SELECT p.pID
    FROM product AS p, 
        purchase AS p1, 
        purchase AS p2, 
        purchase AS p3
    WHERE 
        p.pID = p1.pID AND 
        p.pID = p2.pID AND 
        p.pID = p3.pID AND 
        p1.cID <> p2.cID AND 
        p1.cID <> p3.cID AND 
        p2.cID <> p3.cID)
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
        SELECT
          product.pID
        FROM
          product
        WHERE
          product.pID NOT IN (
            SELECT
              p.pID
            FROM
              product AS p,
              purchase AS p1,
              purchase AS p2,
              purchase AS p3
            WHERE
              p.pID = p1.pID
              AND p.pID = p2.pID
              AND p.pID = p3.pID
              AND p1.cID <> p2.cID
              AND p1.cID <> p3.cID
              AND p2.cID <> p3.cID
  )
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    SELECT 
        c.cID, c.cName
    FROM 
        customer AS c, purchase AS p1, purchase AS p2, product AS pr1, product AS pr2
    WHERE 
        p1.cID = c.cID AND
        p2.cID = c.cID AND
        p1.date = p2.date AND
        pr1.pName = 'Onions' AND
        pr2.pName = 'Coffee' AND
        p1.pID = pr1.pID AND
        p2.pID = pr2.pID
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query5 = '''
    SELECT p.pID, p.pName, i.sID, max(i.unit_price)
    FROM product AS p, inventory AS i
    WHERE p.pID = i.pID
'''

pd.read_sql_query(query5, conn)
#[Out]#    pID pName  sID  max(i.unit_price)
#[Out]# 0   12  Beef    8               14.9
query5 = '''
    SELECT p.pID, p.pName, i.sID
    FROM product AS p, inventory AS i
    WHERE p.pID = i.pID AND i.unit_price = 
        (SELECT max(inventory.unit_price)
         FROM inventory)
'''

pd.read_sql_query(query5, conn)
#[Out]#    pID pName  sID
#[Out]# 0   12  Beef    8
query5 = '''
    SELECT p.pName, i.sID
    FROM product AS p, inventory AS i
    WHERE p.pID = i.pID AND i.unit_price = 
        (SELECT max(inventory.unit_price)
         FROM inventory)
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName  sID
#[Out]# 0  Beef    8
