# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
query1 = '''
    SELECT a.pID
    FROM (SELECT count(p.pID) as c, p.pID
         FROM purchase p
         GROUP BY p.pID) a
    WHERE a.c <= 2
'''
pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query3 = '''
    SELECT pu.cID
    FROM (SELECT DISTINCT pu.sID as sID FROM purchase pu) pu, store s
    WHERE count(DISTINCT pu.sID) = count(DISTINCT s.sID)
    GROUP BY pu.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM (SELECT DISTINCT pu.sID as sID 
          FROM purchase pu) pu, store s
    WHERE count(DISTINCT pu.sID) = count(DISTINCT s.sID)
    GROUP BY pu.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT DISTINCT pu.sID
          FROM purchase pu
'''
'''
    SELECT pu.cID
    FROM (SELECT DISTINCT pu.sID
          FROM purchase pu) pu, store s
    WHERE count(DISTINCT pu.sID) = count(DISTINCT s.sID)
    GROUP BY pu.cID
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID
#[Out]# 0     3
#[Out]# 1    23
#[Out]# 2    17
#[Out]# 3    32
#[Out]# 4    16
#[Out]# 5    46
#[Out]# 6    36
#[Out]# 7    12
#[Out]# 8    39
#[Out]# 9    13
#[Out]# 10   51
#[Out]# 11   47
#[Out]# 12   44
#[Out]# 13   30
#[Out]# 14   29
#[Out]# 15   10
#[Out]# 16   53
#[Out]# 17   21
#[Out]# 18    7
#[Out]# 19    4
#[Out]# 20   55
#[Out]# 21    6
#[Out]# 22   11
#[Out]# 23   38
#[Out]# 24   42
#[Out]# 25   43
#[Out]# 26   34
#[Out]# 27    0
#[Out]# 28   33
#[Out]# 29   50
#[Out]# ..  ...
#[Out]# 34   14
#[Out]# 35   22
#[Out]# 36   31
#[Out]# 37   27
#[Out]# 38    2
#[Out]# 39   59
#[Out]# 40   15
#[Out]# 41   40
#[Out]# 42    1
#[Out]# 43   45
#[Out]# 44   49
#[Out]# 45    9
#[Out]# 46   57
#[Out]# 47   54
#[Out]# 48   37
#[Out]# 49   52
#[Out]# 50   56
#[Out]# 51    5
#[Out]# 52   20
#[Out]# 53   18
#[Out]# 54   19
#[Out]# 55   58
#[Out]# 56   35
#[Out]# 57   41
#[Out]# 58   24
#[Out]# 59   48
#[Out]# 60   62
#[Out]# 61   63
#[Out]# 62   60
#[Out]# 63   61
#[Out]# 
#[Out]# [64 rows x 1 columns]
query3 = '''
    SELECT DISTINCT purchase.sID
          FROM purchase
'''
'''
    SELECT pu.cID
    FROM (SELECT DISTINCT pu.sID
          FROM purchase pu) pu, store s
    WHERE count(DISTINCT pu.sID) = count(DISTINCT s.sID)
    GROUP BY pu.cID
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID
#[Out]# 0     3
#[Out]# 1    23
#[Out]# 2    17
#[Out]# 3    32
#[Out]# 4    16
#[Out]# 5    46
#[Out]# 6    36
#[Out]# 7    12
#[Out]# 8    39
#[Out]# 9    13
#[Out]# 10   51
#[Out]# 11   47
#[Out]# 12   44
#[Out]# 13   30
#[Out]# 14   29
#[Out]# 15   10
#[Out]# 16   53
#[Out]# 17   21
#[Out]# 18    7
#[Out]# 19    4
#[Out]# 20   55
#[Out]# 21    6
#[Out]# 22   11
#[Out]# 23   38
#[Out]# 24   42
#[Out]# 25   43
#[Out]# 26   34
#[Out]# 27    0
#[Out]# 28   33
#[Out]# 29   50
#[Out]# ..  ...
#[Out]# 34   14
#[Out]# 35   22
#[Out]# 36   31
#[Out]# 37   27
#[Out]# 38    2
#[Out]# 39   59
#[Out]# 40   15
#[Out]# 41   40
#[Out]# 42    1
#[Out]# 43   45
#[Out]# 44   49
#[Out]# 45    9
#[Out]# 46   57
#[Out]# 47   54
#[Out]# 48   37
#[Out]# 49   52
#[Out]# 50   56
#[Out]# 51    5
#[Out]# 52   20
#[Out]# 53   18
#[Out]# 54   19
#[Out]# 55   58
#[Out]# 56   35
#[Out]# 57   41
#[Out]# 58   24
#[Out]# 59   48
#[Out]# 60   62
#[Out]# 61   63
#[Out]# 62   60
#[Out]# 63   61
#[Out]# 
#[Out]# [64 rows x 1 columns]
query3 = '''
    SELECT DISTINCT purchase.sID
          FROM purchase
'''
'''
    SELECT p.cID
    FROM (SELECT DISTINCT purchase.sID
          FROM purchase purchase) p, store s
    WHERE count(DISTINCT pu.sID) = count(DISTINCT s.sID)
    GROUP BY pu.cID
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID
#[Out]# 0     3
#[Out]# 1    23
#[Out]# 2    17
#[Out]# 3    32
#[Out]# 4    16
#[Out]# 5    46
#[Out]# 6    36
#[Out]# 7    12
#[Out]# 8    39
#[Out]# 9    13
#[Out]# 10   51
#[Out]# 11   47
#[Out]# 12   44
#[Out]# 13   30
#[Out]# 14   29
#[Out]# 15   10
#[Out]# 16   53
#[Out]# 17   21
#[Out]# 18    7
#[Out]# 19    4
#[Out]# 20   55
#[Out]# 21    6
#[Out]# 22   11
#[Out]# 23   38
#[Out]# 24   42
#[Out]# 25   43
#[Out]# 26   34
#[Out]# 27    0
#[Out]# 28   33
#[Out]# 29   50
#[Out]# ..  ...
#[Out]# 34   14
#[Out]# 35   22
#[Out]# 36   31
#[Out]# 37   27
#[Out]# 38    2
#[Out]# 39   59
#[Out]# 40   15
#[Out]# 41   40
#[Out]# 42    1
#[Out]# 43   45
#[Out]# 44   49
#[Out]# 45    9
#[Out]# 46   57
#[Out]# 47   54
#[Out]# 48   37
#[Out]# 49   52
#[Out]# 50   56
#[Out]# 51    5
#[Out]# 52   20
#[Out]# 53   18
#[Out]# 54   19
#[Out]# 55   58
#[Out]# 56   35
#[Out]# 57   41
#[Out]# 58   24
#[Out]# 59   48
#[Out]# 60   62
#[Out]# 61   63
#[Out]# 62   60
#[Out]# 63   61
#[Out]# 
#[Out]# [64 rows x 1 columns]
query3 = '''
    SELECT p.cID
    FROM (SELECT DISTINCT purchase.sID
          FROM purchase purchase) p, store s
    WHERE count(DISTINCT pu.sID) = count(DISTINCT s.sID)
    GROUP BY pu.cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT DISTINCT purchase.sID
          FROM purchase purchase
'''
'''
    SELECT p.cID
    FROM (SELECT DISTINCT purchase.sID
          FROM purchase purchase) p, store s
    WHERE count(DISTINCT pu.sID) = count(DISTINCT s.sID)
    GROUP BY pu.cID
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID
#[Out]# 0     3
#[Out]# 1    23
#[Out]# 2    17
#[Out]# 3    32
#[Out]# 4    16
#[Out]# 5    46
#[Out]# 6    36
#[Out]# 7    12
#[Out]# 8    39
#[Out]# 9    13
#[Out]# 10   51
#[Out]# 11   47
#[Out]# 12   44
#[Out]# 13   30
#[Out]# 14   29
#[Out]# 15   10
#[Out]# 16   53
#[Out]# 17   21
#[Out]# 18    7
#[Out]# 19    4
#[Out]# 20   55
#[Out]# 21    6
#[Out]# 22   11
#[Out]# 23   38
#[Out]# 24   42
#[Out]# 25   43
#[Out]# 26   34
#[Out]# 27    0
#[Out]# 28   33
#[Out]# 29   50
#[Out]# ..  ...
#[Out]# 34   14
#[Out]# 35   22
#[Out]# 36   31
#[Out]# 37   27
#[Out]# 38    2
#[Out]# 39   59
#[Out]# 40   15
#[Out]# 41   40
#[Out]# 42    1
#[Out]# 43   45
#[Out]# 44   49
#[Out]# 45    9
#[Out]# 46   57
#[Out]# 47   54
#[Out]# 48   37
#[Out]# 49   52
#[Out]# 50   56
#[Out]# 51    5
#[Out]# 52   20
#[Out]# 53   18
#[Out]# 54   19
#[Out]# 55   58
#[Out]# 56   35
#[Out]# 57   41
#[Out]# 58   24
#[Out]# 59   48
#[Out]# 60   62
#[Out]# 61   63
#[Out]# 62   60
#[Out]# 63   61
#[Out]# 
#[Out]# [64 rows x 1 columns]
query3 = '''
    SELECT p.sID
    FROM (SELECT DISTINCT purchase.sID
          FROM purchase purchase) p, store s
    WHERE count(DISTINCT pu.sID) = count(DISTINCT s.sID)
    GROUP BY pu.cID
'''

'''
    SELECT DISTINCT purchase.sID
    FROM purchase purchase
'''


pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.sID
    FROM (SELECT DISTINCT purchase.sID
          FROM purchase purchase) p, store s
    WHERE count(DISTINCT pp.sID) = count(DISTINCT s.sID)
    GROUP BY p.cID
'''

'''
    SELECT DISTINCT purchase.sID
    FROM purchase purchase
'''


pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.sID
    FROM (SELECT DISTINCT purchase.sID
          FROM purchase purchase) p, store s
    WHERE count(DISTINCT p.sID) = count(DISTINCT s.sID)
    GROUP BY p.cID
'''

'''
    SELECT DISTINCT purchase.sID
    FROM purchase purchase
'''


pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.sID
    FROM (SELECT DISTINCT purchase.sID
          FROM purchase purchase) p, store s
    WHERE count(DISTINCT p.sID) = count(DISTINCT s.sID)
    GROUP BY p.sID
'''

'''
    SELECT DISTINCT purchase.sID
    FROM purchase purchase
'''


pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.sID
    FROM (SELECT DISTINCT purchase.sID
          FROM purchase purchase) p, store s
    WHERE count(DISTINCT p.sID) = count(DISTINCT s.sID)
    
'''

'''
    SELECT DISTINCT purchase.sID
    FROM purchase purchase
'''


pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.sID
    FROM (SELECT DISTINCT purchase.sID
          FROM purchase purchase) p, store s
    GROUP BY p.sID
    WHERE count(DISTINCT p.sID) = count(DISTINCT s.sID)
    
'''

'''
    SELECT DISTINCT purchase.sID
    FROM purchase purchase
'''


pd.read_sql_query(query3, conn)
query3 = '''
    SELECT p.sID
    FROM (SELECT DISTINCT purchase.sID
          FROM purchase purchase) p, store s
    GROUP BY p.sID AND s.sID
    WHERE count(DISTINCT p.sID) = count(DISTINCT s.sID)
    
'''

'''
    SELECT DISTINCT purchase.sID
    FROM purchase purchase
'''


pd.read_sql_query(query3, conn)
