# IPython log file

query2 = '''
    WITH Onion(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Onions" ),
        Coffee(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Coffee" )
         
        
    SELECT c.cName, c.cID
    FROM customer as c, Onion, Coffee
    WHERE Onion.date = Coffee.date AND c.cID = Onion.cID AND c.cID = Cofee.cID 
    
    
'''

pd.read_sql_query(query2, conn)
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = '''
    SELECT pID
    FROM product
    EXCEPT
    SELECT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.pID = p2.pID AND p1.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID AND p3.cID <> p2.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    WITH Onion(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Onions" ),
        Coffee(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Coffee" )
         
        
    SELECT c.cName, c.cID
    FROM customer as c, Onion, Coffee
    WHERE Onion.date = Coffee.date AND c.cID = Onion.cID AND c.cID = Cofee.cID 
    
    
'''

pd.read_sql_query(query2, conn)
query2 = '''
    WITH Onion(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Onions" ),
        Coffee(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Coffee" )
         
        
    SELECT c.cName, c.cID
    FROM customer as c, Onion, Coffee
    WHERE Onion.date = Coffee.date AND c.cID = Onion.cID AND c.cID = Coffee.cID 
    
    
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cName, cID]
#[Out]# Index: []
query4 = '''
    WITH Onion(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Onions" ),
        Coffee(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Coffee" )
         
        
    SELECT Onion.cID
    FROM Onion, Coffee
    WHERE Onion.date = Coffee.date Onion.cID = Coffee.cID 
'''

pd.read_sql_query(query4, conn)
query4 = '''
    WITH Onion(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Onions" ),
        Coffee(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Coffee" )
         
        
    SELECT Onion.cID
    FROM Onion, Coffee
    WHERE Onion.date = Coffee.date AND Onion.cID = Coffee.cID 
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query6 = '''
    SELECT product.pID, cID, date
    FROM product, purchase
    WHERE product.pName = "Onions"
'''

pd.read_sql_query(query6, conn)
#[Out]#      pID  cID        date
#[Out]# 0      4    0  2018-08-22
#[Out]# 1      4    1  2018-08-20
#[Out]# 2      4    1  2018-08-20
#[Out]# 3      4    1  2018-08-20
#[Out]# 4      4    1  2018-08-20
#[Out]# 5      4    1  2018-08-20
#[Out]# 6      4    1  2018-08-21
#[Out]# 7      4    1  2018-08-21
#[Out]# 8      4    2  2018-08-16
#[Out]# 9      4    2  2018-08-17
#[Out]# 10     4    2  2018-08-17
#[Out]# 11     4    2  2018-08-17
#[Out]# 12     4    2  2018-08-17
#[Out]# 13     4    3  2018-08-18
#[Out]# 14     4    3  2018-08-19
#[Out]# 15     4    3  2018-08-19
#[Out]# 16     4    4  2018-08-24
#[Out]# 17     4    4  2018-08-24
#[Out]# 18     4    4  2018-08-25
#[Out]# 19     4    4  2018-08-24
#[Out]# 20     4    4  2018-08-25
#[Out]# 21     4    4  2018-08-25
#[Out]# 22     4    5  2018-08-17
#[Out]# 23     4    5  2018-08-22
#[Out]# 24     4    5  2018-08-23
#[Out]# 25     4    5  2018-08-23
#[Out]# 26     4    5  2018-08-23
#[Out]# 27     4    5  2018-08-23
#[Out]# 28     4    7  2018-08-23
#[Out]# 29     4    7  2018-08-23
#[Out]# ..   ...  ...         ...
#[Out]# 479    4  190  2018-08-20
#[Out]# 480    4  190  2018-08-15
#[Out]# 481    4  190  2018-08-23
#[Out]# 482    4  190  2018-08-15
#[Out]# 483    4  190  2018-08-24
#[Out]# 484    4  190  2018-08-25
#[Out]# 485    4  190  2018-08-15
#[Out]# 486    4  190  2018-08-15
#[Out]# 487    4  190  2018-08-22
#[Out]# 488    4  190  2018-08-17
#[Out]# 489    4  190  2018-08-18
#[Out]# 490    4  190  2018-08-19
#[Out]# 491    4  190  2018-08-25
#[Out]# 492    4  190  2018-08-17
#[Out]# 493    4  190  2018-08-26
#[Out]# 494    4  190  2018-08-17
#[Out]# 495    4  190  2018-08-22
#[Out]# 496    4  190  2018-08-19
#[Out]# 497    4  190  2018-08-15
#[Out]# 498    4  190  2018-08-18
#[Out]# 499    4  190  2018-08-25
#[Out]# 500    4  190  2018-08-18
#[Out]# 501    4  190  2018-08-15
#[Out]# 502    4  190  2018-08-22
#[Out]# 503    4  190  2018-08-19
#[Out]# 504    4  190  2018-08-26
#[Out]# 505    4  190  2018-08-27
#[Out]# 506    4  190  2018-08-23
#[Out]# 507    4  190  2018-08-16
#[Out]# 508    4  190  2018-08-21
#[Out]# 
#[Out]# [509 rows x 3 columns]
query4 = '''
    WITH Onion(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Onions" ),
        Coffee(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Coffee" )
         
        
    SELECT Onion.cID
    FROM Onion, Coffee
    WHERE Onion.cID = Coffee.cID 
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
practicequery1a = '''
    SELECT product.pID, cID, date
    FROM product, purchase
    WHERE product.pName = "Coffee"
'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#      pID  cID        date
#[Out]# 0     21    0  2018-08-22
#[Out]# 1     21    1  2018-08-20
#[Out]# 2     21    1  2018-08-20
#[Out]# 3     21    1  2018-08-20
#[Out]# 4     21    1  2018-08-20
#[Out]# 5     21    1  2018-08-20
#[Out]# 6     21    1  2018-08-21
#[Out]# 7     21    1  2018-08-21
#[Out]# 8     21    2  2018-08-16
#[Out]# 9     21    2  2018-08-17
#[Out]# 10    21    2  2018-08-17
#[Out]# 11    21    2  2018-08-17
#[Out]# 12    21    2  2018-08-17
#[Out]# 13    21    3  2018-08-18
#[Out]# 14    21    3  2018-08-19
#[Out]# 15    21    3  2018-08-19
#[Out]# 16    21    4  2018-08-24
#[Out]# 17    21    4  2018-08-24
#[Out]# 18    21    4  2018-08-25
#[Out]# 19    21    4  2018-08-24
#[Out]# 20    21    4  2018-08-25
#[Out]# 21    21    4  2018-08-25
#[Out]# 22    21    5  2018-08-17
#[Out]# 23    21    5  2018-08-22
#[Out]# 24    21    5  2018-08-23
#[Out]# 25    21    5  2018-08-23
#[Out]# 26    21    5  2018-08-23
#[Out]# 27    21    5  2018-08-23
#[Out]# 28    21    7  2018-08-23
#[Out]# 29    21    7  2018-08-23
#[Out]# ..   ...  ...         ...
#[Out]# 479   21  190  2018-08-20
#[Out]# 480   21  190  2018-08-15
#[Out]# 481   21  190  2018-08-23
#[Out]# 482   21  190  2018-08-15
#[Out]# 483   21  190  2018-08-24
#[Out]# 484   21  190  2018-08-25
#[Out]# 485   21  190  2018-08-15
#[Out]# 486   21  190  2018-08-15
#[Out]# 487   21  190  2018-08-22
#[Out]# 488   21  190  2018-08-17
#[Out]# 489   21  190  2018-08-18
#[Out]# 490   21  190  2018-08-19
#[Out]# 491   21  190  2018-08-25
#[Out]# 492   21  190  2018-08-17
#[Out]# 493   21  190  2018-08-26
#[Out]# 494   21  190  2018-08-17
#[Out]# 495   21  190  2018-08-22
#[Out]# 496   21  190  2018-08-19
#[Out]# 497   21  190  2018-08-15
#[Out]# 498   21  190  2018-08-18
#[Out]# 499   21  190  2018-08-25
#[Out]# 500   21  190  2018-08-18
#[Out]# 501   21  190  2018-08-15
#[Out]# 502   21  190  2018-08-22
#[Out]# 503   21  190  2018-08-19
#[Out]# 504   21  190  2018-08-26
#[Out]# 505   21  190  2018-08-27
#[Out]# 506   21  190  2018-08-23
#[Out]# 507   21  190  2018-08-16
#[Out]# 508   21  190  2018-08-21
#[Out]# 
#[Out]# [509 rows x 3 columns]
query4 = '''
    WITH Onion(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Onions" ),
        Coffee(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Coffee" )
         
        
    SELECT Onion.cID
    FROM Onion, Coffee
    WHERE Onion.cID = 4
'''

pd.read_sql_query(query4, conn)
#[Out]#         cID
#[Out]# 0         4
#[Out]# 1         4
#[Out]# 2         4
#[Out]# 3         4
#[Out]# 4         4
#[Out]# 5         4
#[Out]# 6         4
#[Out]# 7         4
#[Out]# 8         4
#[Out]# 9         4
#[Out]# 10        4
#[Out]# 11        4
#[Out]# 12        4
#[Out]# 13        4
#[Out]# 14        4
#[Out]# 15        4
#[Out]# 16        4
#[Out]# 17        4
#[Out]# 18        4
#[Out]# 19        4
#[Out]# 20        4
#[Out]# 21        4
#[Out]# 22        4
#[Out]# 23        4
#[Out]# 24        4
#[Out]# 25        4
#[Out]# 26        4
#[Out]# 27        4
#[Out]# 28        4
#[Out]# 29        4
#[Out]# ...     ...
#[Out]# 259051    4
#[Out]# 259052    4
#[Out]# 259053    4
#[Out]# 259054    4
#[Out]# 259055    4
#[Out]# 259056    4
#[Out]# 259057    4
#[Out]# 259058    4
#[Out]# 259059    4
#[Out]# 259060    4
#[Out]# 259061    4
#[Out]# 259062    4
#[Out]# 259063    4
#[Out]# 259064    4
#[Out]# 259065    4
#[Out]# 259066    4
#[Out]# 259067    4
#[Out]# 259068    4
#[Out]# 259069    4
#[Out]# 259070    4
#[Out]# 259071    4
#[Out]# 259072    4
#[Out]# 259073    4
#[Out]# 259074    4
#[Out]# 259075    4
#[Out]# 259076    4
#[Out]# 259077    4
#[Out]# 259078    4
#[Out]# 259079    4
#[Out]# 259080    4
#[Out]# 
#[Out]# [259081 rows x 1 columns]
query4 = '''
    WITH Onion(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Onions" ),
        Coffee(cID, pID, date) as (
        SELECT product.pID, cID, date
        FROM product, purchase
        WHERE product.pName = "Coffee" )
         
        
    SELECT Onion.cID
    FROM Onion, Coffee
    WHERE Onion.cID = Coffee.cID
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    select customer.cID, count (distinct sID)
    from purchase, customer
    where customer.cID = purchase.cID
    group by cID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select customer.cID, count (distinct sID)
    from purchase, customer
    where customer.cID = purchase.cID
    group by customer.cID
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count (distinct sID)
#[Out]# 0      0                     1
#[Out]# 1      1                     7
#[Out]# 2      2                     5
#[Out]# 3      3                     3
#[Out]# 4      4                     6
#[Out]# 5      5                     6
#[Out]# 6      7                     6
#[Out]# 7      8                     2
#[Out]# 8     10                     1
#[Out]# 9     11                     1
#[Out]# 10    13                     7
#[Out]# 11    15                     1
#[Out]# 12    16                    10
#[Out]# 13    17                     2
#[Out]# 14    18                     3
#[Out]# 15    19                     4
#[Out]# 16    20                     3
#[Out]# 17    21                     3
#[Out]# 18    22                     2
#[Out]# 19    24                     9
#[Out]# 20    25                     1
#[Out]# 21    26                     1
#[Out]# 22    27                     5
#[Out]# 23    28                     1
#[Out]# 24    29                     2
#[Out]# 25    30                     3
#[Out]# 26    31                     2
#[Out]# 27    33                     9
#[Out]# 28    34                     1
#[Out]# 29    35                     2
#[Out]# ..   ...                   ...
#[Out]# 102  147                     3
#[Out]# 103  149                     2
#[Out]# 104  151                     2
#[Out]# 105  152                     3
#[Out]# 106  157                     2
#[Out]# 107  159                     2
#[Out]# 108  161                     9
#[Out]# 109  162                     8
#[Out]# 110  163                     4
#[Out]# 111  165                     6
#[Out]# 112  167                    10
#[Out]# 113  168                     1
#[Out]# 114  169                    11
#[Out]# 115  170                     3
#[Out]# 116  171                     2
#[Out]# 117  172                     2
#[Out]# 118  175                     2
#[Out]# 119  176                     6
#[Out]# 120  177                     5
#[Out]# 121  178                     2
#[Out]# 122  179                     6
#[Out]# 123  180                     2
#[Out]# 124  181                     3
#[Out]# 125  182                     3
#[Out]# 126  184                     1
#[Out]# 127  185                     1
#[Out]# 128  186                     1
#[Out]# 129  188                     1
#[Out]# 130  189                     2
#[Out]# 131  190                    64
#[Out]# 
#[Out]# [132 rows x 2 columns]
query3 = '''
    select customer.cID, count (distinct sName)
    from purchase, customer, store
    where customer.cID = purchase.cID AND purchase.sID = store.sID
    group by customer.cID
'''

pd.read_sql_query(query3, conn)
#[Out]#      cID  count (distinct sName)
#[Out]# 0      0                       1
#[Out]# 1      1                       5
#[Out]# 2      2                       3
#[Out]# 3      3                       3
#[Out]# 4      4                       5
#[Out]# 5      5                       3
#[Out]# 6      7                       4
#[Out]# 7      8                       1
#[Out]# 8     10                       1
#[Out]# 9     11                       1
#[Out]# 10    13                       5
#[Out]# 11    15                       1
#[Out]# 12    16                       5
#[Out]# 13    17                       2
#[Out]# 14    18                       3
#[Out]# 15    19                       3
#[Out]# 16    20                       3
#[Out]# 17    21                       3
#[Out]# 18    22                       2
#[Out]# 19    24                       5
#[Out]# 20    25                       1
#[Out]# 21    26                       1
#[Out]# 22    27                       4
#[Out]# 23    28                       1
#[Out]# 24    29                       2
#[Out]# 25    30                       3
#[Out]# 26    31                       1
#[Out]# 27    33                       5
#[Out]# 28    34                       1
#[Out]# 29    35                       2
#[Out]# ..   ...                     ...
#[Out]# 102  147                       3
#[Out]# 103  149                       2
#[Out]# 104  151                       1
#[Out]# 105  152                       2
#[Out]# 106  157                       2
#[Out]# 107  159                       2
#[Out]# 108  161                       4
#[Out]# 109  162                       4
#[Out]# 110  163                       3
#[Out]# 111  165                       4
#[Out]# 112  167                       5
#[Out]# 113  168                       1
#[Out]# 114  169                       6
#[Out]# 115  170                       3
#[Out]# 116  171                       2
#[Out]# 117  172                       2
#[Out]# 118  175                       2
#[Out]# 119  176                       3
#[Out]# 120  177                       3
#[Out]# 121  178                       2
#[Out]# 122  179                       4
#[Out]# 123  180                       2
#[Out]# 124  181                       2
#[Out]# 125  182                       2
#[Out]# 126  184                       1
#[Out]# 127  185                       1
#[Out]# 128  186                       1
#[Out]# 129  188                       1
#[Out]# 130  189                       1
#[Out]# 131  190                       7
#[Out]# 
#[Out]# [132 rows x 2 columns]
practicequery1a = '''
    select count(distinct sName)
    from store
'''

pd.read_sql_query(practicequery1a, conn)
#[Out]#    count(distinct sName)
#[Out]# 0                      7
query3 = '''
    select cID
    from cust_store (cID, number_stores) as (
        select customer.cID, count (distinct sName)
        from purchase, customer, store
        where customer.cID = purchase.cID AND purchase.sID = store.sID
        group by customer.cID )
    where number_stores = 7
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from ( select customer.cID, count (distinct sName)
           from purchase, customer, store
           where customer.cID = purchase.cID AND purchase.sID = store.sID
           group by customer.cID )
           as cust_names (cID, number_of_stores)
    where number_of_stores = 7
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from ( select customer.cID, count (distinct sName)
           from purchase, customer, store
           where customer.cID = purchase.cID AND purchase.sID = store.sID
           group by customer.cID )
        as cust_names (cID, number_of_stores)
    where number_of_stores = 7
'''

pd.read_sql_query(query3, conn)
query3 = '''
    
    with cust_names (cID, number_of_stores) as (
        select customer.cID, count (distinct sName)
        from purchase, customer, store
        where customer.cID = purchase.cID AND purchase.sID = store.sID
        group by customer.cID )
        
    select cID
    from cust_names
    where number_of_stores = 7
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query5 = '''
    select pID, max(price-unit)
    from inventory
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select pID, max(unit-price)
    from inventory
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select pID, max(unitprice)
    from inventory
'''

pd.read_sql_query(query5, conn)
query5 = '''
    select *
    from inventory
'''

pd.read_sql_query(query5, conn)
#[Out]#      sID  pID        date  quantity  unit_price
#[Out]# 0     55   10  2018-08-26        17        0.60
#[Out]# 1     25   12  2018-08-24        30       14.80
#[Out]# 2     15    6  2018-08-26        13        1.15
#[Out]# 3      6   27  2018-08-19        51        7.30
#[Out]# 4     57    2  2018-08-22        24        2.05
#[Out]# 5     33    8  2018-08-19        46        5.70
#[Out]# 6     51   10  2018-08-23        31        0.60
#[Out]# 7     50   21  2018-08-22        32        1.90
#[Out]# 8      0   13  2018-08-25        13        3.05
#[Out]# 9     36    8  2018-08-27        11        5.05
#[Out]# 10    36   23  2018-08-18        35        2.20
#[Out]# 11    54   10  2018-08-24        16        0.55
#[Out]# 12    59    1  2018-08-26        36        6.20
#[Out]# 13     9   19  2018-08-22        28        2.50
#[Out]# 14    33    7  2018-08-26         5        1.60
#[Out]# 15    35   10  2018-08-21        51        0.55
#[Out]# 16     0   21  2018-08-15         0        2.20
#[Out]# 17    31   14  2018-08-17        10        4.50
#[Out]# 18    19   14  2018-08-20        42        4.70
#[Out]# 19    33   20  2018-08-21        51        2.15
#[Out]# 20    17   24  2018-08-16        44        2.85
#[Out]# 21     4   27  2018-08-18        27        9.00
#[Out]# 22     3   25  2018-08-27        24        4.60
#[Out]# 23    22   15  2018-08-20         4        1.30
#[Out]# 24    52   14  2018-08-18        44        4.25
#[Out]# 25    24   26  2018-08-25        18        2.90
#[Out]# 26     7   12  2018-08-20        13       12.55
#[Out]# 27    32   18  2018-08-21        41       11.85
#[Out]# 28    48   24  2018-08-19        10        3.20
#[Out]# 29    54    8  2018-08-17         3        5.55
#[Out]# ..   ...  ...         ...       ...         ...
#[Out]# 799   35    0  2018-08-25         1        4.35
#[Out]# 800   19   11  2018-08-25         9        0.90
#[Out]# 801    4   21  2018-08-25         9        2.15
#[Out]# 802    6    5  2018-08-26         6        0.50
#[Out]# 803   47   18  2018-08-20        12        8.85
#[Out]# 804   38   17  2018-08-20        10        2.30
#[Out]# 805   11    3  2018-08-21        15        1.30
#[Out]# 806   34   26  2018-08-21        14        3.40
#[Out]# 807   34   25  2018-08-27        17        3.60
#[Out]# 808   25   14  2018-08-24         3        3.70
#[Out]# 809   24   11  2018-08-24         1        0.85
#[Out]# 810   57   17  2018-08-24         4        2.40
#[Out]# 811   43   27  2018-08-22        15        9.00
#[Out]# 812   35   16  2018-08-22         8        1.85
#[Out]# 813   45   10  2018-08-22        21        0.45
#[Out]# 814   34   26  2018-08-26         9        3.10
#[Out]# 815   34   13  2018-08-26         3        4.05
#[Out]# 816   56   10  2018-08-27         1        0.60
#[Out]# 817    6   26  2018-08-24        13        2.70
#[Out]# 818   45    6  2018-08-24         9        0.90
#[Out]# 819   27   21  2018-08-27         1        2.00
#[Out]# 820   17   25  2018-08-27        14        3.90
#[Out]# 821    5   18  2018-08-28         1        9.70
#[Out]# 822    5    3  2018-08-28        13        1.30
#[Out]# 823    4   13  2018-08-23        23        4.20
#[Out]# 824   27   10  2018-08-20         7        0.55
#[Out]# 825   45   18  2018-08-21         5        9.20
#[Out]# 826   57    6  2018-08-22         9        1.15
#[Out]# 827   60   19  2018-07-10       525        1.75
#[Out]# 828    0    0  2018-07-18        15        5.95
#[Out]# 
#[Out]# [829 rows x 5 columns]
query5 = '''
    select pID, max(unit_price)
    from inventory
'''

pd.read_sql_query(query5, conn)
#[Out]#    pID  max(unit_price)
#[Out]# 0   12             14.9
query5 = '''
    select pID, sID, max(unit_price)
    from inventory
'''

pd.read_sql_query(query5, conn)
#[Out]#    pID  sID  max(unit_price)
#[Out]# 0   12    8             14.9
query5 = '''
    with highest_price(pID, sID, max_price) as (
        select pID, sID, max(unit_price)
        from inventory)
    
    select pName, sName
    from highest_price, product, store
    where highest_price.pID = product.pID AND highest_price.sID = store.sID
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName
#[Out]# 0  Beef  Albert Hein
query6 = '''
    SELECT unit_price
    FROM inventory
    WHERE date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#     unit_price
#[Out]# 0         0.60
#[Out]# 1         2.95
#[Out]# 2         1.80
#[Out]# 3         4.15
#[Out]# 4         4.10
#[Out]# 5         2.45
#[Out]# 6         1.25
#[Out]# 7         0.55
#[Out]# 8         5.80
#[Out]# 9         1.00
#[Out]# 10        8.50
#[Out]# 11        4.00
#[Out]# 12        4.60
#[Out]# 13        4.35
#[Out]# 14        1.00
#[Out]# 15        1.20
#[Out]# 16        1.95
#[Out]# 17        2.10
#[Out]# 18        6.85
#[Out]# 19        4.35
#[Out]# 20        1.05
#[Out]# 21        8.85
#[Out]# 22        0.45
#[Out]# 23       11.40
#[Out]# 24        3.35
#[Out]# 25        2.25
#[Out]# 26        2.05
#[Out]# 27        1.95
#[Out]# 28        5.15
#[Out]# 29        1.85
#[Out]# ..         ...
#[Out]# 38        1.90
#[Out]# 39        2.10
#[Out]# 40        1.95
#[Out]# 41        4.10
#[Out]# 42        1.35
#[Out]# 43        1.60
#[Out]# 44        3.85
#[Out]# 45        6.90
#[Out]# 46        4.80
#[Out]# 47        2.65
#[Out]# 48        1.25
#[Out]# 49        3.20
#[Out]# 50        1.65
#[Out]# 51        0.45
#[Out]# 52        7.35
#[Out]# 53       13.40
#[Out]# 54        3.55
#[Out]# 55        1.20
#[Out]# 56        4.80
#[Out]# 57       12.55
#[Out]# 58        1.30
#[Out]# 59        2.20
#[Out]# 60        1.00
#[Out]# 61        7.75
#[Out]# 62        5.55
#[Out]# 63       13.15
#[Out]# 64        3.55
#[Out]# 65        4.40
#[Out]# 66        1.15
#[Out]# 67        4.20
#[Out]# 
#[Out]# [68 rows x 1 columns]
query6 = '''
    SELECT unit_price, sID
    FROM inventory
    WHERE date = '2018-08-23'
'''

pd.read_sql_query(query6, conn)
#[Out]#     unit_price  sID
#[Out]# 0         0.60   51
#[Out]# 1         2.95   57
#[Out]# 2         1.80   38
#[Out]# 3         4.15   35
#[Out]# 4         4.10   45
#[Out]# 5         2.45    5
#[Out]# 6         1.25   13
#[Out]# 7         0.55   50
#[Out]# 8         5.80    7
#[Out]# 9         1.00    2
#[Out]# 10        8.50   28
#[Out]# 11        4.00   35
#[Out]# 12        4.60   41
#[Out]# 13        4.35   56
#[Out]# 14        1.00   45
#[Out]# 15        1.20   19
#[Out]# 16        1.95   29
#[Out]# 17        2.10   11
#[Out]# 18        6.85   32
#[Out]# 19        4.35    6
#[Out]# 20        1.05   33
#[Out]# 21        8.85   35
#[Out]# 22        0.45   34
#[Out]# 23       11.40   42
#[Out]# 24        3.35   41
#[Out]# 25        2.25   33
#[Out]# 26        2.05   30
#[Out]# 27        1.95   50
#[Out]# 28        5.15   29
#[Out]# 29        1.85   47
#[Out]# ..         ...  ...
#[Out]# 38        1.90   11
#[Out]# 39        2.10   21
#[Out]# 40        1.95   43
#[Out]# 41        4.10   40
#[Out]# 42        1.35    3
#[Out]# 43        1.60   16
#[Out]# 44        3.85   50
#[Out]# 45        6.90   40
#[Out]# 46        4.80   33
#[Out]# 47        2.65   44
#[Out]# 48        1.25   12
#[Out]# 49        3.20   11
#[Out]# 50        1.65    5
#[Out]# 51        0.45    1
#[Out]# 52        7.35   52
#[Out]# 53       13.40    5
#[Out]# 54        3.55   12
#[Out]# 55        1.20   35
#[Out]# 56        4.80   55
#[Out]# 57       12.55   54
#[Out]# 58        1.30   11
#[Out]# 59        2.20   35
#[Out]# 60        1.00    6
#[Out]# 61        7.75   37
#[Out]# 62        5.55   25
#[Out]# 63       13.15    9
#[Out]# 64        3.55   38
#[Out]# 65        4.40   56
#[Out]# 66        1.15   48
#[Out]# 67        4.20    4
#[Out]# 
#[Out]# [68 rows x 2 columns]
query6 = '''
    SELECT unit_price, sID
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT i1.unit_price, sID
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT i1.unit_price, i1.sID
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date
'''

pd.read_sql_query(query6, conn)
#[Out]#       unit_price  sID
#[Out]# 0            0.6   51
#[Out]# 1            0.6   51
#[Out]# 2            0.6   51
#[Out]# 3            0.6   51
#[Out]# 4            0.6   51
#[Out]# 5            0.6   51
#[Out]# 6            0.6   51
#[Out]# 7            0.6   51
#[Out]# 8            0.6   51
#[Out]# 9            0.6   51
#[Out]# 10           0.6   51
#[Out]# 11           0.6   51
#[Out]# 12           0.6   51
#[Out]# 13           0.6   51
#[Out]# 14           0.6   51
#[Out]# 15           0.6   51
#[Out]# 16           0.6   51
#[Out]# 17           0.6   51
#[Out]# 18           0.6   51
#[Out]# 19           0.6   51
#[Out]# 20           0.6   51
#[Out]# 21           0.6   51
#[Out]# 22           0.6   51
#[Out]# 23           0.6   51
#[Out]# 24           0.6   51
#[Out]# 25           0.6   51
#[Out]# 26           0.6   51
#[Out]# 27           0.6   51
#[Out]# 28           0.6   51
#[Out]# 29           0.6   51
#[Out]# ...          ...  ...
#[Out]# 4594         4.2    4
#[Out]# 4595         4.2    4
#[Out]# 4596         4.2    4
#[Out]# 4597         4.2    4
#[Out]# 4598         4.2    4
#[Out]# 4599         4.2    4
#[Out]# 4600         4.2    4
#[Out]# 4601         4.2    4
#[Out]# 4602         4.2    4
#[Out]# 4603         4.2    4
#[Out]# 4604         4.2    4
#[Out]# 4605         4.2    4
#[Out]# 4606         4.2    4
#[Out]# 4607         4.2    4
#[Out]# 4608         4.2    4
#[Out]# 4609         4.2    4
#[Out]# 4610         4.2    4
#[Out]# 4611         4.2    4
#[Out]# 4612         4.2    4
#[Out]# 4613         4.2    4
#[Out]# 4614         4.2    4
#[Out]# 4615         4.2    4
#[Out]# 4616         4.2    4
#[Out]# 4617         4.2    4
#[Out]# 4618         4.2    4
#[Out]# 4619         4.2    4
#[Out]# 4620         4.2    4
#[Out]# 4621         4.2    4
#[Out]# 4622         4.2    4
#[Out]# 4623         4.2    4
#[Out]# 
#[Out]# [4624 rows x 2 columns]
query6 = '''
    SELECT i1.unit_price, i1.sID, i1.pID
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date
'''

pd.read_sql_query(query6, conn)
#[Out]#       unit_price  sID  pID
#[Out]# 0            0.6   51   10
#[Out]# 1            0.6   51   10
#[Out]# 2            0.6   51   10
#[Out]# 3            0.6   51   10
#[Out]# 4            0.6   51   10
#[Out]# 5            0.6   51   10
#[Out]# 6            0.6   51   10
#[Out]# 7            0.6   51   10
#[Out]# 8            0.6   51   10
#[Out]# 9            0.6   51   10
#[Out]# 10           0.6   51   10
#[Out]# 11           0.6   51   10
#[Out]# 12           0.6   51   10
#[Out]# 13           0.6   51   10
#[Out]# 14           0.6   51   10
#[Out]# 15           0.6   51   10
#[Out]# 16           0.6   51   10
#[Out]# 17           0.6   51   10
#[Out]# 18           0.6   51   10
#[Out]# 19           0.6   51   10
#[Out]# 20           0.6   51   10
#[Out]# 21           0.6   51   10
#[Out]# 22           0.6   51   10
#[Out]# 23           0.6   51   10
#[Out]# 24           0.6   51   10
#[Out]# 25           0.6   51   10
#[Out]# 26           0.6   51   10
#[Out]# 27           0.6   51   10
#[Out]# 28           0.6   51   10
#[Out]# 29           0.6   51   10
#[Out]# ...          ...  ...  ...
#[Out]# 4594         4.2    4   13
#[Out]# 4595         4.2    4   13
#[Out]# 4596         4.2    4   13
#[Out]# 4597         4.2    4   13
#[Out]# 4598         4.2    4   13
#[Out]# 4599         4.2    4   13
#[Out]# 4600         4.2    4   13
#[Out]# 4601         4.2    4   13
#[Out]# 4602         4.2    4   13
#[Out]# 4603         4.2    4   13
#[Out]# 4604         4.2    4   13
#[Out]# 4605         4.2    4   13
#[Out]# 4606         4.2    4   13
#[Out]# 4607         4.2    4   13
#[Out]# 4608         4.2    4   13
#[Out]# 4609         4.2    4   13
#[Out]# 4610         4.2    4   13
#[Out]# 4611         4.2    4   13
#[Out]# 4612         4.2    4   13
#[Out]# 4613         4.2    4   13
#[Out]# 4614         4.2    4   13
#[Out]# 4615         4.2    4   13
#[Out]# 4616         4.2    4   13
#[Out]# 4617         4.2    4   13
#[Out]# 4618         4.2    4   13
#[Out]# 4619         4.2    4   13
#[Out]# 4620         4.2    4   13
#[Out]# 4621         4.2    4   13
#[Out]# 4622         4.2    4   13
#[Out]# 4623         4.2    4   13
#[Out]# 
#[Out]# [4624 rows x 3 columns]
query6 = '''
    SELECT i1.unit_price, i1.sID, i1.pID
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#      unit_price  sID  pID
#[Out]# 0          0.60   51   10
#[Out]# 1          0.60   51   10
#[Out]# 2          0.60   51   10
#[Out]# 3          2.95   57   19
#[Out]# 4          2.95   57   19
#[Out]# 5          2.95   57   19
#[Out]# 6          2.95   57   19
#[Out]# 7          2.95   57   19
#[Out]# 8          1.80   38   23
#[Out]# 9          1.80   38   23
#[Out]# 10         4.15   35   13
#[Out]# 11         4.15   35   13
#[Out]# 12         4.15   35   13
#[Out]# 13         4.15   35   13
#[Out]# 14         4.10   45   13
#[Out]# 15         4.10   45   13
#[Out]# 16         4.10   45   13
#[Out]# 17         4.10   45   13
#[Out]# 18         2.45    5   17
#[Out]# 19         2.45    5   17
#[Out]# 20         1.25   13   15
#[Out]# 21         1.25   13   15
#[Out]# 22         1.25   13   15
#[Out]# 23         1.25   13   15
#[Out]# 24         0.55   50   10
#[Out]# 25         0.55   50   10
#[Out]# 26         0.55   50   10
#[Out]# 27         5.80    7    1
#[Out]# 28         5.80    7    1
#[Out]# 29         5.80    7    1
#[Out]# ..          ...  ...  ...
#[Out]# 192        1.30   11   15
#[Out]# 193        1.30   11   15
#[Out]# 194        1.30   11   15
#[Out]# 195        2.20   35    7
#[Out]# 196        2.20   35    7
#[Out]# 197        2.20   35    7
#[Out]# 198        1.00    6   15
#[Out]# 199        1.00    6   15
#[Out]# 200        1.00    6   15
#[Out]# 201        1.00    6   15
#[Out]# 202        7.75   37   28
#[Out]# 203        7.75   37   28
#[Out]# 204        7.75   37   28
#[Out]# 205        5.55   25    8
#[Out]# 206        5.55   25    8
#[Out]# 207       13.15    9   12
#[Out]# 208       13.15    9   12
#[Out]# 209       13.15    9   12
#[Out]# 210       13.15    9   12
#[Out]# 211        3.55   38   24
#[Out]# 212        3.55   38   24
#[Out]# 213        4.40   56    1
#[Out]# 214        4.40   56    1
#[Out]# 215        4.40   56    1
#[Out]# 216        4.40   56    1
#[Out]# 217        1.15   48    6
#[Out]# 218        4.20    4   13
#[Out]# 219        4.20    4   13
#[Out]# 220        4.20    4   13
#[Out]# 221        4.20    4   13
#[Out]# 
#[Out]# [222 rows x 3 columns]
query6 = '''
    SELECT i1.unit_price - i2.unit_price, i1.sID, i1.pID
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID
'''

pd.read_sql_query(query6, conn)
#[Out]#      i1.unit_price - i2.unit_price  sID  pID
#[Out]# 0                             0.15   51   10
#[Out]# 1                             0.05   51   10
#[Out]# 2                             0.00   51   10
#[Out]# 3                             0.85   57   19
#[Out]# 4                             0.75   57   19
#[Out]# 5                             0.70   57   19
#[Out]# 6                             0.30   57   19
#[Out]# 7                             0.00   57   19
#[Out]# 8                             0.00   38   23
#[Out]# 9                            -0.30   38   23
#[Out]# 10                            0.60   35   13
#[Out]# 11                            0.05   35   13
#[Out]# 12                            0.00   35   13
#[Out]# 13                           -0.05   35   13
#[Out]# 14                            0.55   45   13
#[Out]# 15                            0.00   45   13
#[Out]# 16                           -0.05   45   13
#[Out]# 17                           -0.10   45   13
#[Out]# 18                            0.50    5   17
#[Out]# 19                            0.00    5   17
#[Out]# 20                            0.25   13   15
#[Out]# 21                            0.00   13   15
#[Out]# 22                            0.00   13   15
#[Out]# 23                           -0.05   13   15
#[Out]# 24                            0.10   50   10
#[Out]# 25                            0.00   50   10
#[Out]# 26                           -0.05   50   10
#[Out]# 27                            1.40    7    1
#[Out]# 28                            1.20    7    1
#[Out]# 29                            1.00    7    1
#[Out]# ..                             ...  ...  ...
#[Out]# 192                           0.05   11   15
#[Out]# 193                           0.05   11   15
#[Out]# 194                           0.00   11   15
#[Out]# 195                           0.35   35    7
#[Out]# 196                           0.25   35    7
#[Out]# 197                           0.00   35    7
#[Out]# 198                           0.00    6   15
#[Out]# 199                          -0.25    6   15
#[Out]# 200                          -0.25    6   15
#[Out]# 201                          -0.30    6   15
#[Out]# 202                           0.90   37   28
#[Out]# 203                           0.40   37   28
#[Out]# 204                           0.00   37   28
#[Out]# 205                           0.75   25    8
#[Out]# 206                           0.00   25    8
#[Out]# 207                           1.75    9   12
#[Out]# 208                           0.60    9   12
#[Out]# 209                           0.00    9   12
#[Out]# 210                          -0.25    9   12
#[Out]# 211                           0.00   38   24
#[Out]# 212                          -0.55   38   24
#[Out]# 213                           0.00   56    1
#[Out]# 214                          -0.20   56    1
#[Out]# 215                          -0.40   56    1
#[Out]# 216                          -1.40   56    1
#[Out]# 217                           0.00   48    6
#[Out]# 218                           0.65    4   13
#[Out]# 219                           0.10    4   13
#[Out]# 220                           0.05    4   13
#[Out]# 221                           0.00    4   13
#[Out]# 
#[Out]# [222 rows x 3 columns]
query6 = '''
    SELECT i1.unit_price - i2.unit_price, i1.sID, i1.pID
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID and i1.sID <> i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#      i1.unit_price - i2.unit_price  sID  pID
#[Out]# 0                             0.15   51   10
#[Out]# 1                             0.05   51   10
#[Out]# 2                             0.85   57   19
#[Out]# 3                             0.75   57   19
#[Out]# 4                             0.70   57   19
#[Out]# 5                             0.30   57   19
#[Out]# 6                            -0.30   38   23
#[Out]# 7                            -0.05   35   13
#[Out]# 8                             0.60   35   13
#[Out]# 9                             0.05   35   13
#[Out]# 10                           -0.10   45   13
#[Out]# 11                            0.55   45   13
#[Out]# 12                           -0.05   45   13
#[Out]# 13                            0.50    5   17
#[Out]# 14                            0.25   13   15
#[Out]# 15                           -0.05   13   15
#[Out]# 16                            0.00   13   15
#[Out]# 17                            0.10   50   10
#[Out]# 18                           -0.05   50   10
#[Out]# 19                            1.20    7    1
#[Out]# 20                            1.00    7    1
#[Out]# 21                            1.40    7    1
#[Out]# 22                           -0.05    2   11
#[Out]# 23                           -0.20    2   11
#[Out]# 24                           -0.35   28   27
#[Out]# 25                            1.60   28   27
#[Out]# 26                           -0.35   35   25
#[Out]# 27                           -1.20   41    1
#[Out]# 28                           -0.20   41    1
#[Out]# 29                            0.20   41    1
#[Out]# ..                             ...  ...  ...
#[Out]# 124                          -0.55   12   13
#[Out]# 125                           0.20   35   11
#[Out]# 126                           0.15   35   11
#[Out]# 127                          -1.00   55    1
#[Out]# 128                           0.20   55    1
#[Out]# 129                           0.40   55    1
#[Out]# 130                          -0.85   54   12
#[Out]# 131                          -0.60   54   12
#[Out]# 132                           1.15   54   12
#[Out]# 133                           0.30   11   15
#[Out]# 134                           0.05   11   15
#[Out]# 135                           0.05   11   15
#[Out]# 136                           0.25   35    7
#[Out]# 137                           0.35   35    7
#[Out]# 138                          -0.30    6   15
#[Out]# 139                          -0.25    6   15
#[Out]# 140                          -0.25    6   15
#[Out]# 141                           0.90   37   28
#[Out]# 142                           0.40   37   28
#[Out]# 143                           0.75   25    8
#[Out]# 144                          -0.25    9   12
#[Out]# 145                           1.75    9   12
#[Out]# 146                           0.60    9   12
#[Out]# 147                          -0.55   38   24
#[Out]# 148                          -1.40   56    1
#[Out]# 149                          -0.20   56    1
#[Out]# 150                          -0.40   56    1
#[Out]# 151                           0.65    4   13
#[Out]# 152                           0.05    4   13
#[Out]# 153                           0.10    4   13
#[Out]# 
#[Out]# [154 rows x 3 columns]
query6 = '''
    SELECT max(i1.unit_price - i2.unit_price), i1.sID, i1.pID
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID and i1.sID <> i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price - i2.unit_price)  sID  pID
#[Out]# 0                                 2.0    5   12
query6 = '''
    SELECT min(i1.unit_price - i2.unit_price), i1.sID, i1.pID
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID and i1.sID <> i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    min(i1.unit_price - i2.unit_price)  sID  pID
#[Out]# 0                                -2.0   42   12
query6 = '''
    SELECT max(i1.unit_price - i2.unit_price), i1.sID, i1.pID
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID and i1.sID <> i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price - i2.unit_price)  sID  pID
#[Out]# 0                                 2.0    5   12
query3 = '''
    
    with cust_names (cID, number_of_stores) as (
        select customer.cID, count (distinct sName)
        from purchase, customer, store
        where customer.cID = purchase.cID AND purchase.sID = store.sID
        group by customer.cID )
        
    select cID
    from cust_names, store
    where number_of_stores = count(distinct sName)
'''

pd.read_sql_query(query3, conn)
query3 = '''
    
    with cust_names (cID, number_of_stores) as (
        select customer.cID, count (distinct sName)
        from purchase, customer, store
        where customer.cID = purchase.cID AND purchase.sID = store.sID
        group by customer.cID )
        
    select cID
    from cust_names
    where number_of_stores = 7
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
practicequery1f = '''
    select distinct p1.pID, distinct p2.pID
    from product as p1, product as p2
    where p1.pName = "Onions" and p2.pName = "Coffee"
'''

pd.read_sql_query(practicequery1f, conn)
practicequery1f = '''
    select p1.pID, p2.pID
    from product as p1, product as p2
    where p1.pName = "Onions" and p2.pName = "Coffee"
'''

pd.read_sql_query(practicequery1f, conn)
#[Out]#    pID  pID
#[Out]# 0    4   21
practicequery1e = '''
    with ids(onion_id, coffee_id) as ()
        select distinct p1.pID, distinct p2.pID
        from product as p1, product as p2
        where p1.pName = "Onions" and p2.pName = "Coffee")\
    
    select c.cName, c.cID
    from customer as c, purchase as p1, purchase as p2, ids
    where p1.date = p2.date and p1.cID = p2.cID and p1.cID = c.cID and p1.pID = onion_id and p2.pID = coffee_id
'''

pd.read_sql_query(practicequery1e, conn)
practicequery1e = '''
    with ids(onion_id, coffee_id) as (
        select distinct p1.pID, distinct p2.pID
        from product as p1, product as p2
        where p1.pName = "Onions" and p2.pName = "Coffee")
    
    select c.cName, c.cID
    from customer as c, purchase as p1, purchase as p2, ids
    where p1.date = p2.date and p1.cID = p2.cID and p1.cID = c.cID and p1.pID = onion_id and p2.pID = coffee_id
'''

pd.read_sql_query(practicequery1e, conn)
practicequery1e = '''
    with ids(onion_id, coffee_id) as (
        select p1.pID, p2.pID
        from product as p1, product as p2
        where p1.pName = "Onions" and p2.pName = "Coffee")
    
    select c.cName, c.cID
    from customer as c, purchase as p1, purchase as p2, ids
    where p1.date = p2.date and p1.cID = p2.cID and p1.cID = c.cID and p1.pID = onion_id and p2.pID = coffee_id
'''

pd.read_sql_query(practicequery1e, conn)
#[Out]#     cName  cID
#[Out]# 0   Sofie  124
#[Out]# 1  Kostas  190
query2 = '''
    with ids(onion_id, coffee_id) as (
        select p1.pID, p2.pID
        from product as p1, product as p2
        where p1.pName = "Onions" and p2.pName = "Coffee")
    
    select c.cName, c.cID
    from customer as c, purchase as p1, purchase as p2, ids
    where p1.date = p2.date and p1.cID = p2.cID and p1.cID = c.cID and p1.pID = onion_id and p2.pID = coffee_id
    
    
'''

pd.read_sql_query(query2, conn)
#[Out]#     cName  cID
#[Out]# 0   Sofie  124
#[Out]# 1  Kostas  190
query4 = '''
    select sID, avg (quantity)
    from inventory
    

'''

pd.read_sql_query(query4, conn)
#[Out]#    sID  avg (quantity)
#[Out]# 0    0       18.342581
query4 = '''
    select distinct sID, avg (quantity)
    from inventory
    

'''

pd.read_sql_query(query4, conn)
#[Out]#    sID  avg (quantity)
#[Out]# 0    0       18.342581
query4 = '''
    select sID, avg (quantity)
    from inventory
    group by sID

'''

pd.read_sql_query(query4, conn)
#[Out]#     sID  avg (quantity)
#[Out]# 0     0       16.142857
#[Out]# 1     1       18.500000
#[Out]# 2     2       17.363636
#[Out]# 3     3       17.611111
#[Out]# 4     4       18.421053
#[Out]# 5     5       14.583333
#[Out]# 6     6       24.772727
#[Out]# 7     7       14.800000
#[Out]# 8     8       22.500000
#[Out]# 9     9       17.500000
#[Out]# 10   10       23.400000
#[Out]# 11   11       10.250000
#[Out]# 12   12       15.583333
#[Out]# 13   13       20.250000
#[Out]# 14   14       13.000000
#[Out]# 15   15       22.625000
#[Out]# 16   16       22.000000
#[Out]# 17   17       15.800000
#[Out]# 18   18       16.062500
#[Out]# 19   19       19.692308
#[Out]# 20   20       13.200000
#[Out]# 21   21       12.166667
#[Out]# 22   22       24.333333
#[Out]# 23   23       19.600000
#[Out]# 24   24       20.400000
#[Out]# 25   25       14.785714
#[Out]# 26   26       19.562500
#[Out]# 27   27       15.750000
#[Out]# 28   28       16.307692
#[Out]# 29   29       13.875000
#[Out]# ..  ...             ...
#[Out]# 31   31       22.800000
#[Out]# 32   32       20.250000
#[Out]# 33   33       25.666667
#[Out]# 34   34        9.777778
#[Out]# 35   35       26.055556
#[Out]# 36   36       18.555556
#[Out]# 37   37       17.444444
#[Out]# 38   38       14.562500
#[Out]# 39   39       17.900000
#[Out]# 40   40       18.187500
#[Out]# 41   41       20.705882
#[Out]# 42   42       16.789474
#[Out]# 43   43       12.562500
#[Out]# 44   44       15.647059
#[Out]# 45   45       21.461538
#[Out]# 46   46       14.666667
#[Out]# 47   47       10.933333
#[Out]# 48   48       15.600000
#[Out]# 49   49       12.333333
#[Out]# 50   50       23.866667
#[Out]# 51   51       17.923077
#[Out]# 52   52       16.583333
#[Out]# 53   53       14.090909
#[Out]# 54   54       14.687500
#[Out]# 55   55       17.428571
#[Out]# 56   56       11.062500
#[Out]# 57   57       23.562500
#[Out]# 58   58       36.833333
#[Out]# 59   59       16.846154
#[Out]# 60   60      525.000000
#[Out]# 
#[Out]# [61 rows x 2 columns]
practicequery1d = '''
    select *
    from inventory
    
'''

pd.read_sql_query(practicequery1d, conn)
#[Out]#      sID  pID        date  quantity  unit_price
#[Out]# 0     55   10  2018-08-26        17        0.60
#[Out]# 1     25   12  2018-08-24        30       14.80
#[Out]# 2     15    6  2018-08-26        13        1.15
#[Out]# 3      6   27  2018-08-19        51        7.30
#[Out]# 4     57    2  2018-08-22        24        2.05
#[Out]# 5     33    8  2018-08-19        46        5.70
#[Out]# 6     51   10  2018-08-23        31        0.60
#[Out]# 7     50   21  2018-08-22        32        1.90
#[Out]# 8      0   13  2018-08-25        13        3.05
#[Out]# 9     36    8  2018-08-27        11        5.05
#[Out]# 10    36   23  2018-08-18        35        2.20
#[Out]# 11    54   10  2018-08-24        16        0.55
#[Out]# 12    59    1  2018-08-26        36        6.20
#[Out]# 13     9   19  2018-08-22        28        2.50
#[Out]# 14    33    7  2018-08-26         5        1.60
#[Out]# 15    35   10  2018-08-21        51        0.55
#[Out]# 16     0   21  2018-08-15         0        2.20
#[Out]# 17    31   14  2018-08-17        10        4.50
#[Out]# 18    19   14  2018-08-20        42        4.70
#[Out]# 19    33   20  2018-08-21        51        2.15
#[Out]# 20    17   24  2018-08-16        44        2.85
#[Out]# 21     4   27  2018-08-18        27        9.00
#[Out]# 22     3   25  2018-08-27        24        4.60
#[Out]# 23    22   15  2018-08-20         4        1.30
#[Out]# 24    52   14  2018-08-18        44        4.25
#[Out]# 25    24   26  2018-08-25        18        2.90
#[Out]# 26     7   12  2018-08-20        13       12.55
#[Out]# 27    32   18  2018-08-21        41       11.85
#[Out]# 28    48   24  2018-08-19        10        3.20
#[Out]# 29    54    8  2018-08-17         3        5.55
#[Out]# ..   ...  ...         ...       ...         ...
#[Out]# 799   35    0  2018-08-25         1        4.35
#[Out]# 800   19   11  2018-08-25         9        0.90
#[Out]# 801    4   21  2018-08-25         9        2.15
#[Out]# 802    6    5  2018-08-26         6        0.50
#[Out]# 803   47   18  2018-08-20        12        8.85
#[Out]# 804   38   17  2018-08-20        10        2.30
#[Out]# 805   11    3  2018-08-21        15        1.30
#[Out]# 806   34   26  2018-08-21        14        3.40
#[Out]# 807   34   25  2018-08-27        17        3.60
#[Out]# 808   25   14  2018-08-24         3        3.70
#[Out]# 809   24   11  2018-08-24         1        0.85
#[Out]# 810   57   17  2018-08-24         4        2.40
#[Out]# 811   43   27  2018-08-22        15        9.00
#[Out]# 812   35   16  2018-08-22         8        1.85
#[Out]# 813   45   10  2018-08-22        21        0.45
#[Out]# 814   34   26  2018-08-26         9        3.10
#[Out]# 815   34   13  2018-08-26         3        4.05
#[Out]# 816   56   10  2018-08-27         1        0.60
#[Out]# 817    6   26  2018-08-24        13        2.70
#[Out]# 818   45    6  2018-08-24         9        0.90
#[Out]# 819   27   21  2018-08-27         1        2.00
#[Out]# 820   17   25  2018-08-27        14        3.90
#[Out]# 821    5   18  2018-08-28         1        9.70
#[Out]# 822    5    3  2018-08-28        13        1.30
#[Out]# 823    4   13  2018-08-23        23        4.20
#[Out]# 824   27   10  2018-08-20         7        0.55
#[Out]# 825   45   18  2018-08-21         5        9.20
#[Out]# 826   57    6  2018-08-22         9        1.15
#[Out]# 827   60   19  2018-07-10       525        1.75
#[Out]# 828    0    0  2018-07-18        15        5.95
#[Out]# 
#[Out]# [829 rows x 5 columns]
query4 = '''
    select sName, avg (quantity)
    from inventory, store
    group by sName

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg (quantity)
#[Out]# 0  Albert Hein       18.342581
#[Out]# 1         Coop       18.342581
#[Out]# 2         Dirk       18.342581
#[Out]# 3    Hoogvliet       18.342581
#[Out]# 4        Jumbo       18.342581
#[Out]# 5         Lidl       18.342581
#[Out]# 6       Sligro       18.342581
practicequery1d = '''
    select *
    from inventory
    group by sID
    
    
'''

pd.read_sql_query(practicequery1d, conn)
#[Out]#     sID  pID        date  quantity  unit_price
#[Out]# 0     0   27  2018-08-24        22        6.65
#[Out]# 1     1   28  2018-08-18        45        8.40
#[Out]# 2     2   28  2018-08-25        49        7.75
#[Out]# 3     3   25  2018-08-27        24        4.60
#[Out]# 4     4   27  2018-08-18        27        9.00
#[Out]# 5     5   24  2018-08-26         0        3.25
#[Out]# 6     6   27  2018-08-19        51        7.30
#[Out]# 7     7   27  2018-08-25         7        9.25
#[Out]# 8     8   24  2018-08-21        25        3.70
#[Out]# 9     9   28  2018-08-19        25       10.05
#[Out]# 10   10   24  2018-08-16        15        3.65
#[Out]# 11   11   24  2018-08-21         3        3.20
#[Out]# 12   12   26  2018-08-27        51        2.55
#[Out]# 13   13   23  2018-08-17         6        2.50
#[Out]# 14   14   28  2018-08-26         2        8.25
#[Out]# 15   15   20  2018-08-17         7        1.90
#[Out]# 16   16   27  2018-08-25        11        9.20
#[Out]# 17   17   26  2018-08-26         7        2.75
#[Out]# 18   18   28  2018-08-22         9        8.70
#[Out]# 19   19   27  2018-08-16         7        7.90
#[Out]# 20   20   27  2018-08-17        17        6.85
#[Out]# 21   21   28  2018-08-29        17        7.05
#[Out]# 22   22   27  2018-08-17        52        7.40
#[Out]# 23   23   27  2018-08-22        21        9.00
#[Out]# 24   24   28  2018-08-25         8        8.20
#[Out]# 25   25   28  2018-08-27         6        8.05
#[Out]# 26   26   27  2018-08-25        25        6.75
#[Out]# 27   27   28  2018-08-19        14        8.10
#[Out]# 28   28   27  2018-08-27         8        9.10
#[Out]# 29   29   27  2018-08-18        11        7.75
#[Out]# ..  ...  ...         ...       ...         ...
#[Out]# 31   31   24  2018-08-25        18        4.20
#[Out]# 32   32   28  2018-08-23        36        6.85
#[Out]# 33   33   27  2018-08-25        41        8.15
#[Out]# 34   34   28  2018-08-25        13        8.35
#[Out]# 35   35   28  2018-08-24        32        7.75
#[Out]# 36   36   28  2018-08-26         7        7.20
#[Out]# 37   37   28  2018-08-24        11        9.30
#[Out]# 38   38   28  2018-08-20         3        6.95
#[Out]# 39   39   28  2018-08-21        37        8.85
#[Out]# 40   40   28  2018-08-21         9        8.25
#[Out]# 41   41   28  2018-08-15        14        7.65
#[Out]# 42   42   27  2018-08-22        12        8.05
#[Out]# 43   43   27  2018-08-22        15        9.00
#[Out]# 44   44   28  2018-08-27        32        6.90
#[Out]# 45   45   24  2018-08-16         1        3.45
#[Out]# 46   46   26  2018-08-25        10        3.45
#[Out]# 47   47   28  2018-08-16         2        7.65
#[Out]# 48   48   24  2018-08-19        10        3.20
#[Out]# 49   49   27  2018-08-21         7        8.95
#[Out]# 50   50   26  2018-08-19        43        3.10
#[Out]# 51   51   24  2018-08-26        17        2.95
#[Out]# 52   52   28  2018-08-23         8        7.35
#[Out]# 53   53   23  2018-08-28         9        1.85
#[Out]# 54   54   28  2018-08-25        13        9.70
#[Out]# 55   55   28  2018-08-24        15        7.25
#[Out]# 56   56   26  2018-08-20        14        3.25
#[Out]# 57   57   26  2018-08-17        12        3.50
#[Out]# 58   58   27  2018-08-16        54        9.45
#[Out]# 59   59   28  2018-08-25        16        9.55
#[Out]# 60   60   19  2018-07-10       525        1.75
#[Out]# 
#[Out]# [61 rows x 5 columns]
query4 = '''
    select sName, avg (quantity)
    from inventory, store
    where inventory.sID = store.sID
    group by sName

'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg (quantity)
#[Out]# 0  Albert Hein       18.008475
#[Out]# 1         Coop       16.695000
#[Out]# 2         Dirk       20.884615
#[Out]# 3    Hoogvliet       16.898438
#[Out]# 4        Jumbo       16.312500
#[Out]# 5         Lidl       25.048077
#[Out]# 6       Sligro       16.795620
query4 = '''
    select sName, avg (quantity)
    from inventory, store
    where inventory.sID = store.sID
    group by sName
    having avg (quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName  avg (quantity)
#[Out]# 0  Albert Hein       18.008475
#[Out]# 1         Coop       16.695000
#[Out]# 2         Dirk       20.884615
#[Out]# 3    Hoogvliet       16.898438
#[Out]# 4        Jumbo       16.312500
#[Out]# 5         Lidl       25.048077
#[Out]# 6       Sligro       16.795620
query6 = '''
    CREATE VIEW diff as
    SELECT max(i1.unit_price - i2.unit_price)
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID and i1.sID <> i2.sID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(i1.unit_price - i2.unit_price)
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID and i1.sID <> i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(i1.unit_price - i2.unit_price)
#[Out]# 0                                 2.0
query6 = '''
    SELECT abs (max(i1.unit_price - i2.unit_price))
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID and i1.sID <> i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    abs (max(i1.unit_price - i2.unit_price))
#[Out]# 0                                       2.0
query6 = '''
    SELECT  max(abs(i1.unit_price - i2.unit_price))
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID and i1.sID <> i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                      2.0
query1 = '''
    SELECT pID
    FROM product
    EXCEPT
    SELECT p1.pID
    FROM purchase AS p1, purchase AS p2, purchase AS p3
    WHERE p1.pID = p2.pID AND p1.pID = p3.pID AND p1.cID <> p2.cID AND p1.cID <> p3.cID AND p3.cID <> p2.cID
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
    with ids(onion_id, coffee_id) as (
        select p1.pID, p2.pID
        from product as p1, product as p2
        where p1.pName = "Onions" and p2.pName = "Coffee")
    
    select c.cName, c.cID
    from customer as c, purchase as p1, purchase as p2, ids
    where p1.date = p2.date and p1.cID = p2.cID and p1.cID = c.cID and p1.pID = onion_id and p2.pID = coffee_id
    
    
'''

pd.read_sql_query(query2, conn)
#[Out]#     cName  cID
#[Out]# 0   Sofie  124
#[Out]# 1  Kostas  190
query3 = '''
    
    with cust_names (cID, number_of_stores) as (
        select customer.cID, count (distinct sName)
        from purchase, customer, store
        where customer.cID = purchase.cID AND purchase.sID = store.sID
        group by customer.cID )
        
    select cID
    from cust_names
    where number_of_stores = 7
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    select sName
    from inventory, store
    where inventory.sID = store.sID
    group by sName
    having avg (quantity) > 4
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query5 = '''
    with highest_price(pID, sID, max_price) as (
        select pID, sID, max(unit_price)
        from inventory)
    
    select pName, sName
    from highest_price, product, store
    where highest_price.pID = product.pID AND highest_price.sID = store.sID
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName        sName
#[Out]# 0  Beef  Albert Hein
query6 = '''
    SELECT  max(abs(i1.unit_price - i2.unit_price))
    FROM inventory as i1, inventory as i2
    WHERE i1.date = '2018-08-23' and i1.date = i2.date and i1.pID = i2.pID and i1.sID <> i2.sID
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(abs(i1.unit_price - i2.unit_price))
#[Out]# 0                                      2.0
