# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query4 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query4, conn)
query6 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query6, conn)
practicequery1a = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1a, conn)
practicequery1b = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1b, conn)
practicequery1c = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1c, conn)
practicequery1d = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1d, conn)
practicequery1e = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1e, conn)
practicequery1f = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1f, conn)
practicequery1g = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(practicequery1g, conn)
query2 = '''
    SELECT c.cID,c.cName
    FROM customer c,product p,purchase pr
    WHERE c.cID=pr.cID AND pr.pID=p.pID AND p.pName='Onions' AND pr.date =
    (SELECT pr1.date 
    FROM product p1, purchase pr1
    WHERE c.cID = pr1.cID AND pr1.pID=p1.pID AND p1.pName='COffee');
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
    SELECT c.cID,c.cName
    FROM customer c,product p,purchase pr
    WHERE c.cID=pr.cID AND pr.pID=p.pID AND p.pName='Onions' AND pr.date =
    (SELECT pr1.date 
    FROM product p1, purchase pr1
    WHERE c.cID = pr1.cID AND pr1.pID=p1.pID AND p1.pName='COffee');
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
    SELECT c.cID,c.cName
    FROM customer c,product p,purchase pr
    WHERE c.cID=pr.cID AND pr.pID=p.pID AND p.pName='Onions' AND pr.date =
    (SELECT pr1.date 
    FROM product p1, purchase pr1
    WHERE c.cID = pr1.cID AND pr1.pID=p1.pID AND p1.pName='Coffee');
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query1 = '''
    SELECT p.pID
    FROM product as p, purchase as pr
    WHERE p.pID = pr.pID
    GROUP BY pr.pID 
    HAVING count(DISTINCT pr.cID)<3;
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query5 = '''
    SELECT p.pName, s.sName
    FROM product p
    JOIN
    (SELECT sID,pID
    FROM purchase
    WHERE price=(
    SELECT MAX(price)
    FROM purchase
    ))pu
    ON (p.pID = pu.pID)
    JOIN store s
    ON(p.sID = s.sID);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT T1.pName, T3.sName
    FROM product T1
    JOIN
    (SELECT sID,pID
    FROM purchase
    WHERE price=(
    SELECT MAX(price)
    FROM purchase
    ))T2
    ON (T1.pID = T2.pID)
    JOIN store T3
    ON(T1.sID = T3.sID);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT T1.pName, T3.sName
    FROM product T1
    JOIN
    (SELECT sID,pID
    FROM purchase
    WHERE price=(
    SELECT MAX(price)
    FROM purchase
    )) as T2
    ON (T1.pID = T2.pID)
    JOIN store T3
    ON(T1.sID = T3.sID);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT T1.pName, T3.sName
    FROM product T1
    JOIN
    (SELECT sID,pID
    FROM purchase
    WHERE price=(
    SELECT MAX(price)
    FROM purchase
    )) T2
    ON (T1.pID = T2.pID)
    JOIN store T3
    ON(T1.sID = T3.sID);
'''

pd.read_sql_query(query5, conn)
query6 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query6, conn)
query5 = '''
    SELECT T1.pName, T3.sName
    FROM product T1
    JOIN
    (SELECT sID,pID
    FROM purchase
    WHERE price=(
    SELECT MAX(price)
    FROM purchase
    )) T2
    ON (T1.pID = T2.pID)
    JOIN store T3
    ON(T2.sID = T3.sID);
'''

pd.read_sql_query(query5, conn)
#[Out]#   T1.pName T3.sName
#[Out]# 0     Beef   Sligro
query4 = '''
    SELECT t1.sName
    FROM store t1
    JOIN (
    SELECT sID,count(*) as total
    FROM purchase
    GROUP BY sID
    having count(*)>4
    )t2
    on(t1.sID=t2.sID)
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16    Hoogvliet
#[Out]# 17       Sligro
#[Out]# 18         Coop
#[Out]# 19        Jumbo
#[Out]# 20         Coop
#[Out]# 21         Dirk
#[Out]# 22  Albert Hein
#[Out]# 23  Albert Hein
#[Out]# 24    Hoogvliet
#[Out]# 25       Sligro
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28         Dirk
#[Out]# 29         Coop
#[Out]# 30  Albert Hein
#[Out]# 31         Dirk
#[Out]# 32         Coop
#[Out]# 33         Lidl
#[Out]# 34         Lidl
#[Out]# 35    Hoogvliet
#[Out]# 36       Sligro
#[Out]# 37    Hoogvliet
#[Out]# 38  Albert Hein
#[Out]# 39       Sligro
#[Out]# 40         Coop
#[Out]# 41  Albert Hein
#[Out]# 42         Coop
#[Out]# 43         Lidl
#[Out]# 44         Coop
#[Out]# 45    Hoogvliet
#[Out]# 46       Sligro
#[Out]# 47         Coop
#[Out]# 48         Lidl
#[Out]# 49         Coop
#[Out]# 50         Dirk
#[Out]# 51         Coop
#[Out]# 52        Jumbo
#[Out]# 53         Dirk
#[Out]# 54        Jumbo
#[Out]# 55        Jumbo
query6 = '''
    SELECT max(t1.price-t2.price)
    FROM ( SELECT price, sID, pID 
    FROM inventory
    WHERE date = ‘2018-08-23’ AND quantity > 0) t1,
    ( SELECT price, sID,pID
    FROM inventory
    WHERE date = ‘2018-08-23’ AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.price-t2.price)
    FROM ( SELECT price, sID, pID 
    FROM inventory
    WHERE date = ‘2018-08-23’ AND quantity > 0) t1,
    ( SELECT price, sID,pID
    FROM inventory
    WHERE date = ‘2018-08-23’ AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.price-t2.price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date = ‘2018-08-23’ AND quantity > 0) t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date = ‘2018-08-23’ AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.price-t2.price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date = 2018-08-23 AND quantity > 0) t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date = 2018-08-23 AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.price-t2.price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date = '2018-08-23' AND quantity > 0) t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date = '2018-08-23' AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.price-t2.price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date_ = date'2018-08-23' AND quantity > 0) t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date_ = date'2018-08-23' AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.price-t2.price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date = date'2018-08-23' AND quantity > 0) t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date = date'2018-08-23' AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.price-t2.price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date = '2018-08-23' AND quantity > 0) t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date = '2018-08-23' AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.price,t2.price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date = '2018-08-23' AND quantity > 0) t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date = '2018-08-23' AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.unit_price-t2.unit_price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date = '2018-08-23' AND quantity > 0) t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date = '2018-08-23' AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.unit_price-t2.unit_price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date_= date'2018-08-23' AND quantity > 0) t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date_ =date'2018-08-23' AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.unit_price-t2.unit_price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date= date'2018-08-23' AND quantity > 0) t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date=date'2018-08-23' AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.unit_price-t2.unit_price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0) t1 AND
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0) t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.unit_price-t2.unit_price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query5 = '''
    SELECT T1.pName, T3.sName
    FROM product T1
    JOIN
    (SELECT sID,pID
    FROM purchase
    WHERE price=
    SELECT MAX(price)
    FROM purchase
    )) T2
    ON (T1.pID = T2.pID)
    JOIN store T3
    ON(T2.sID = T3.sID);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT T1.pName, T3.sName
    FROM product T1
    JOIN
    (SELECT sID,pID
    FROM purchase
    WHERE price=
    SELECT MAX(price)
    FROM purchase
    )) T2
    ON (T1.pID = T2.pID)
    JOIN store T3
    ON(T2.sID = T3.sID);
'''

pd.read_sql_query(query5, conn)
query4 = '''
    SELECT t1.sName
    FROM store t1
    JOIN (
    SELECT sID,count(*) as total
    FROM purchase
    GROUP BY sID
    having count(*)>4
    )t2
    on(t1.sID=t2.sID)
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16    Hoogvliet
#[Out]# 17       Sligro
#[Out]# 18         Coop
#[Out]# 19        Jumbo
#[Out]# 20         Coop
#[Out]# 21         Dirk
#[Out]# 22  Albert Hein
#[Out]# 23  Albert Hein
#[Out]# 24    Hoogvliet
#[Out]# 25       Sligro
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28         Dirk
#[Out]# 29         Coop
#[Out]# 30  Albert Hein
#[Out]# 31         Dirk
#[Out]# 32         Coop
#[Out]# 33         Lidl
#[Out]# 34         Lidl
#[Out]# 35    Hoogvliet
#[Out]# 36       Sligro
#[Out]# 37    Hoogvliet
#[Out]# 38  Albert Hein
#[Out]# 39       Sligro
#[Out]# 40         Coop
#[Out]# 41  Albert Hein
#[Out]# 42         Coop
#[Out]# 43         Lidl
#[Out]# 44         Coop
#[Out]# 45    Hoogvliet
#[Out]# 46       Sligro
#[Out]# 47         Coop
#[Out]# 48         Lidl
#[Out]# 49         Coop
#[Out]# 50         Dirk
#[Out]# 51         Coop
#[Out]# 52        Jumbo
#[Out]# 53         Dirk
#[Out]# 54        Jumbo
#[Out]# 55        Jumbo
query5 = '''
    SELECT T1.pName, T3.sName
    FROM product T1
    JOIN
    (SELECT sID,pID
    FROM purchase
    WHERE price=
    SELECT MAX(price)
    FROM purchase
    )) T2
    ON (T1.pID = T2.pID)
    JOIN store T3
    ON(T2.sID = T3.sID);
'''

pd.read_sql_query(query5, conn)
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query5 = '''
    SELECT T1.pName, T3.sName
    FROM product T1
    JOIN
    (SELECT sID,pID
    FROM purchase
    WHERE price=
    SELECT MAX(price)
    FROM purchase
    )) T2
    ON (T1.pID = T2.pID)
    JOIN store T3
    ON(T2.sID = T3.sID);
'''

pd.read_sql_query(query5, conn)
query1 = '''
    SELECT p.pID
    FROM product as p, purchase as pr
    WHERE p.pID = pr.pID
    GROUP BY pr.pID 
    HAVING count(DISTINCT pr.cID)<3;
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT c.cID,c.cName
    FROM customer c,product p,purchase pr
    WHERE c.cID=pr.cID AND pr.pID=p.pID AND p.pName='Onions' AND pr.date =
    (SELECT pr1.date 
    FROM product p1, purchase pr1
    WHERE c.cID = pr1.cID AND pr1.pID=p1.pID AND p1.pName='Coffee');
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query4 = '''
    SELECT t1.sName
    FROM store t1
    JOIN (
    SELECT sID,count(*) as total
    FROM purchase
    GROUP BY sID
    having count(*)>4
    )t2
    on(t1.sID=t2.sID)
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16    Hoogvliet
#[Out]# 17       Sligro
#[Out]# 18         Coop
#[Out]# 19        Jumbo
#[Out]# 20         Coop
#[Out]# 21         Dirk
#[Out]# 22  Albert Hein
#[Out]# 23  Albert Hein
#[Out]# 24    Hoogvliet
#[Out]# 25       Sligro
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28         Dirk
#[Out]# 29         Coop
#[Out]# 30  Albert Hein
#[Out]# 31         Dirk
#[Out]# 32         Coop
#[Out]# 33         Lidl
#[Out]# 34         Lidl
#[Out]# 35    Hoogvliet
#[Out]# 36       Sligro
#[Out]# 37    Hoogvliet
#[Out]# 38  Albert Hein
#[Out]# 39       Sligro
#[Out]# 40         Coop
#[Out]# 41  Albert Hein
#[Out]# 42         Coop
#[Out]# 43         Lidl
#[Out]# 44         Coop
#[Out]# 45    Hoogvliet
#[Out]# 46       Sligro
#[Out]# 47         Coop
#[Out]# 48         Lidl
#[Out]# 49         Coop
#[Out]# 50         Dirk
#[Out]# 51         Coop
#[Out]# 52        Jumbo
#[Out]# 53         Dirk
#[Out]# 54        Jumbo
#[Out]# 55        Jumbo
query5 = '''
    SELECT T1.pName, T3.sName
    FROM product T1
    JOIN
    (SELECT sID,pID
    FROM purchase
    WHERE price=(
    SELECT MAX(price)
    FROM purchase
    )) T2
    ON (T1.pID = T2.pID)
    JOIN store T3
    ON(T2.sID = T3.sID);
'''

pd.read_sql_query(query5, conn)
#[Out]#   T1.pName T3.sName
#[Out]# 0     Beef   Sligro
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t2
    WHERE t1.sID<>t2.sID, t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    SELECT max(t1.unit_price - t2.unit_price)
    FROM ( SELECT unit_price, sID, pID 
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t1,
    ( SELECT unit_price, sID,pID
    FROM inventory
    WHERE date='2018-08-23' AND quantity > 0)t2
    WHERE t1.sID<>t2.sID AND t1.pID = t2.pID;
'''

pd.read_sql_query(query6, conn)
#[Out]#    max(t1.unit_price - t2.unit_price)
#[Out]# 0                                 2.0
query3 = '''
    SELECT pu.cID
    FROM purchase pu
    WHERE count(DISTINCT pu.sID) =
    (SELECT count(*)
    FROM store)
    GROUP BY pu.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM purchase pu
    WHERE count(DISTINCT pu.sID) =
    (SELECT count*
    FROM store)
    GROUP BY pu.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM purchase pu
    WHERE count(DISTINCT pu.sID) =
    (SELECT count(*) as total
    FROM store)
    GROUP BY pu.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM purchase pu
    WHERE count(DISTINCT pu.sID) =
    (SELECT count(*) as total
    FROM store)
    GROUP BY pu.cID;
'''

pd.read_sql_query(query3, conn)
query1 = '''
    SELECT p.pID
    FROM product as p, purchase as pr
    WHERE p.pID = pr.pID
    GROUP BY pr.pID 
    WHERE count(DISTINCT pr.cID)<3;
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM product as p, purchase as pr
    WHERE p.pID = pr.pID
    GROUP BY pr.pID 
    HAVING count(DISTINCT pr.cID)<3;
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query3 = '''
    SELECT pu.cID
    FROM purchase pu
    WHERE count(DISTINCT pu.sID) =
    (SELECT count(*) as total
    FROM store)
    GROUP BY pu.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM purchase pu
    WHERE count(DISTINCT pu.sID) =
    (SELECT count(sID)
    FROM store)
    GROUP BY pu.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM purchase pu
    WHERE count(DISTINCT pu.sID) =
    (SELECT count(s.sID)
    FROM store)
    GROUP BY pu.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM purchase pu, store s
    WHERE count(DISTINCT pu.sID) = count(s.sID)
    GROUP BY pu.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM purchase pu, store s
    WHERE count(DISTINCT pu.sID) = count(DISTINCT s.sID)
    GROUP BY pu.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM purchase pu, store s
    HAVING count(DISTINCT pu.sID) = count(DISTINCT s.sID)
    GROUP BY pu.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM purchase pu, store s
    GROUP BY pu.cID
    HAVING count(DISTINCT pu.sID) = count(DISTINCT s.sID);
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query1 = '''
    SELECT p.pID
    FROM product as p, purchase as pr
    WHERE p.pID = pr.pID
    GROUP BY pr.pID 
    HAVING count(DISTINCT pr.cID)<3;
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query1 = '''
    SELECT p.pID
    FROM product as p, purchase as pr
    WHERE p.pID = pr.pID
    GROUP BY p.pID 
    HAVING count(DISTINCT pr.cID)<3;
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query4 = '''
    SELECT t1.sName
    FROM store t1
    JOIN (
    SELECT sID,count(*) as total
    FROM purchase
    GROUP BY sID
    having count(*)>4
    )t2
    WHERE (t1.sID=t2.sID)
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16    Hoogvliet
#[Out]# 17       Sligro
#[Out]# 18         Coop
#[Out]# 19        Jumbo
#[Out]# 20         Coop
#[Out]# 21         Dirk
#[Out]# 22  Albert Hein
#[Out]# 23  Albert Hein
#[Out]# 24    Hoogvliet
#[Out]# 25       Sligro
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28         Dirk
#[Out]# 29         Coop
#[Out]# 30  Albert Hein
#[Out]# 31         Dirk
#[Out]# 32         Coop
#[Out]# 33         Lidl
#[Out]# 34         Lidl
#[Out]# 35    Hoogvliet
#[Out]# 36       Sligro
#[Out]# 37    Hoogvliet
#[Out]# 38  Albert Hein
#[Out]# 39       Sligro
#[Out]# 40         Coop
#[Out]# 41  Albert Hein
#[Out]# 42         Coop
#[Out]# 43         Lidl
#[Out]# 44         Coop
#[Out]# 45    Hoogvliet
#[Out]# 46       Sligro
#[Out]# 47         Coop
#[Out]# 48         Lidl
#[Out]# 49         Coop
#[Out]# 50         Dirk
#[Out]# 51         Coop
#[Out]# 52        Jumbo
#[Out]# 53         Dirk
#[Out]# 54        Jumbo
#[Out]# 55        Jumbo
query3 = '''
    select cID
    from customer
    where cID not in (select cID
                      from customer c,store s
                      where (c.cID,s.sID) not in(select cID, sID from purchase))
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer
    where cID not in (select cID
                      from customer c,store s
                      where (c.cID,s.sID) not in(select cID, sID from purchase));
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer
    where cID not in (select cID
                      from customer as c,store as s
                      where (c.cID, s.sID) not in(select cID, sID 
                      from purchase));
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer
    where cID not in (select cID
                      from customer as c,store as s
                      where c.city=s.city and (c.cID, s.sID) not in(select cID, sID 
                                               from purchase));
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer
    where cID not in (select cID
                      from customer as c,store as s
                      where c.city=s.city and (c.cID, s.sID) not in(select cID, sID 
                                               from purchase))
'''

pd.read_sql_query(query3, conn)
query2 = '''
    SELECT c.cID,c.cName
    FROM customer c,product p,purchase pr
    WHERE c.cID=pr.cID AND pr.pID=p.pID AND p.pName='Onions' AND pr.date =
    (SELECT pr1.date 
    FROM product p1, purchase pr1
    WHERE c.cID = pr1.cID AND pr1.pID=p1.pID AND p1.pName='Coffee');
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query2 = '''
    SELECT c.cID,c.cName
    FROM customer c,product p,purchase pr
    WHERE c.cID=pr.cID AND pr.pID=p.pID AND p.pName='Onions' AND pr.date =
    (SELECT pr1.date 
    FROM product p1, purchase pr1
    WHERE c.cID = pr1.cID AND pr1.pID=p1.pID AND p1.pName='Coffee');
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    select cID
    from customer
    where cID not in (select cID
                      from customer as c,store as s
                      where c.city=s.city and (c.cID, s.sID) not in(select cID, sID 
                                               from purchase))
'''

pd.read_sql_query(query3, conn)
query3 = '''
select cID
    from customer
    where cID not in(select cID
                     from customer as c, store as s
                     where (c.cID, s.sID) not in(select cID, sID
                                                 from purchase))
'''

pd.read_sql_query(query3, conn)
query3 = select cID
    from customer
    where cID not in(select cID
                     from customer as c, store as s
                     where (c.cID, s.sID) not in(select cID, sID
                                                 from purchase))

pd.read_sql_query(query3, conn)
query3 = select cID
    from customer
    where cID not in(select cID
                     from customer as c, store as s
                     where (c.cID, s.sID) not in(select cID, sID
                                                 from purchase));

pd.read_sql_query(query3, conn)
query3 = 

    select cID
    from customer
    where cID not in(select cID
                     from customer as c, store as s
                     where (c.cID, s.sID) not in(select cID, sID
                                                 from purchase));

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer
    where cID not in (select cID
                      from customer as c,store as s
                      where c.city=s.city and (c.cID, s.sID) not in(select cID, sID 
                                               from purchase));
'''

pd.read_sql_query(query3, conn)
query3 = '''
select cID
    from customer
    where cID not in(select cID
                     from customer as c, store as s
                     where (c.cID, s.sID) not in(select cID, sID
                                                 from purchase))
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT pu.cID
    FROM purchase pu, store s
    GROUP BY pu.cID
    HAVING count(DISTINCT pu.sID) = count(DISTINCT s.sID);
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    select customer.cID
    from customer
    where cID not in(select cID
                     from customer as c, store as s
                     where (c.cID, s.sID) not in(select cID, sID
                                                 from purchase))
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer
    where cID not in(select cID
                     from customer as c, store as s
                     where (c.cID, s.sID) not in(select cID, sID
                                                 from purchase))
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer
    where cID not in(select cID
                     from customer as c, store as s
                     where (c.cID, s.sID) not in(select cID, sID
                                                 from purchase))
'''

pd.read_sql_query(query3, conn)
query3 = '''
    select cID
    from customer
    where cID not in(select cID
                     from customer as c, store as s
                     where (c.cID, s.sID) not in(select cID, sID
                                                 from purchase))
'''

pd.read_sql_query(query3, conn)


