# IPython log file

get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)

query2 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

a = pd.read_sql_query(query2, conn)

query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID
            AND p1.pID=p2.pID AND p2.pID=p3.pID AND p1.pID=p3.pID
            AND p1.tID<>p2.tID AND p1.tID<>p3.tID AND p2.tID<>p3.tID;
'''

b = pd.read_sql_query(query1, conn)
print(a, b)
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, purchase p2, product pp1, product pp2
    WHERE p1.date=p2.date AND p1.cID=c1.cID AND p2.cID=c1.cID AND pp1.pName="Onions" AND pp2.pName="Coffee"
    AND p1.pID=pp1.pID AND p2.pID=pp2.pID;
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE p.cID=c.cID
    GROUP BY p.cID HAVING COUNT(p.sID)=1;
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     0
#[Out]# 1    10
#[Out]# 2    11
#[Out]# 3    15
#[Out]# 4    25
#[Out]# 5    26
#[Out]# 6    28
#[Out]# 7    34
#[Out]# 8    47
#[Out]# 9    63
#[Out]# 10   69
#[Out]# 11   76
#[Out]# 12   77
#[Out]# 13   80
#[Out]# 14   88
#[Out]# 15   90
#[Out]# 16   99
#[Out]# 17  103
#[Out]# 18  104
#[Out]# 19  111
#[Out]# 20  128
#[Out]# 21  131
#[Out]# 22  135
#[Out]# 23  136
#[Out]# 24  137
#[Out]# 25  145
#[Out]# 26  168
#[Out]# 27  184
#[Out]# 28  185
#[Out]# 29  186
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Jumbo";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)  sName
#[Out]# 0         3.888889  Jumbo
query4 = '''
    SELECT avg(p.quantity), s.sID
    FROM store s, purchase p
    WHERE p.sID=s.sID;
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)  sID
#[Out]# 0         4.797642   63
query4 = '''
    SELECT s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID HAVING avg(p.quantity) > 4;
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID GROUP BY s.sName 
    HAVING avg(p.quantity) > 4;
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Jumbo";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)  sName
#[Out]# 0         3.888889  Jumbo
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Albert Heijn";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#   avg(p.quantity) sName
#[Out]# 0            None  None
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Albert Hein";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)        sName
#[Out]# 0         4.969697  Albert Hein
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Sligro";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)   sName
#[Out]# 0         4.674419  Sligro
query4 = '''
    SELECT s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID GROUP BY s.sName 
    HAVING avg(p.quantity) > 4;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT p.pName, s.sName
    
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM purchase p, store s
    WHERE p.sID=s.sID AND p.price >= ALL (SELECT p1.price
                                            FROM purchase p1)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM purchase p, store s
    WHERE p.sID=s.sID AND p.price >= ALL (SELECT p1.price
                                            FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName
    FROM purchase p
    WHERE p.price >= ALL (SELECT p1.price
                                            FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName
    FROM purchase p, store s
    WHERE s.sID=p.sID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.name, s.sName
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.name, s.sName
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT pr.pName, s.sName, p.price
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName  price
#[Out]# 0  Beef  Sligro   13.8
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT difference
    FROM inventory i, store s
    WHERE i.date="2018-08-23" AND DIFFERENCE(i.unit_price) >= (SELECT MAX(DIFFERENCE(i1.unit_price, i2.unit_price) 
                                                                       FROM inventory i1, inventory i2 
                                                                       WHERE i1.date="2018-08-23" AND i2.date="2018-08-23");
'''

pd.read_sql_query(query6, conn)
query6 = '''
    WITH difference(value, date) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT *
    FROM difference;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT *
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#        value
#[Out]# 0       0.10
#[Out]# 1       0.10
#[Out]# 2       0.10
#[Out]# 3       0.10
#[Out]# 4       0.05
#[Out]# 5       0.00
#[Out]# 6      -0.35
#[Out]# 7      -0.40
#[Out]# 8      -0.45
#[Out]# 9      -0.50
#[Out]# 10     -0.55
#[Out]# 11     -0.70
#[Out]# 12     -1.00
#[Out]# 13     -1.05
#[Out]# 14     -1.05
#[Out]# 15     -1.05
#[Out]# 16     -1.10
#[Out]# 17     -1.15
#[Out]# 18     -1.20
#[Out]# 19     -1.20
#[Out]# 20     -1.25
#[Out]# 21     -1.25
#[Out]# 22     -1.25
#[Out]# 23     -1.30
#[Out]# 24     -1.30
#[Out]# 25     -1.35
#[Out]# 26     -1.40
#[Out]# 27     -1.45
#[Out]# 28     -1.45
#[Out]# 29     -1.55
#[Out]# ...      ...
#[Out]# 52411  -0.90
#[Out]# 52412  -1.10
#[Out]# 52413  -1.10
#[Out]# 52414  -1.15
#[Out]# 52415  -1.20
#[Out]# 52416  -1.25
#[Out]# 52417  -1.25
#[Out]# 52418  -1.35
#[Out]# 52419  -1.65
#[Out]# 52420  -2.25
#[Out]# 52421  -2.50
#[Out]# 52422  -2.60
#[Out]# 52423  -2.95
#[Out]# 52424  -3.05
#[Out]# 52425  -3.15
#[Out]# 52426  -4.70
#[Out]# 52427  -6.90
#[Out]# 52428  -7.10
#[Out]# 52429  -7.35
#[Out]# 52430  -7.55
#[Out]# 52431  -7.75
#[Out]# 52432  -7.85
#[Out]# 52433  -7.85
#[Out]# 52434  -8.15
#[Out]# 52435  -9.45
#[Out]# 52436 -10.05
#[Out]# 52437 -10.85
#[Out]# 52438 -12.10
#[Out]# 52439   0.00
#[Out]# 52440   0.00
#[Out]# 
#[Out]# [52441 rows x 1 columns]
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT MAX(*)
    FROM difference;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT *
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#        value
#[Out]# 0       0.10
#[Out]# 1       0.10
#[Out]# 2       0.10
#[Out]# 3       0.10
#[Out]# 4       0.05
#[Out]# 5       0.00
#[Out]# 6      -0.35
#[Out]# 7      -0.40
#[Out]# 8      -0.45
#[Out]# 9      -0.50
#[Out]# 10     -0.55
#[Out]# 11     -0.70
#[Out]# 12     -1.00
#[Out]# 13     -1.05
#[Out]# 14     -1.05
#[Out]# 15     -1.05
#[Out]# 16     -1.10
#[Out]# 17     -1.15
#[Out]# 18     -1.20
#[Out]# 19     -1.20
#[Out]# 20     -1.25
#[Out]# 21     -1.25
#[Out]# 22     -1.25
#[Out]# 23     -1.30
#[Out]# 24     -1.30
#[Out]# 25     -1.35
#[Out]# 26     -1.40
#[Out]# 27     -1.45
#[Out]# 28     -1.45
#[Out]# 29     -1.55
#[Out]# ...      ...
#[Out]# 52411  -0.90
#[Out]# 52412  -1.10
#[Out]# 52413  -1.10
#[Out]# 52414  -1.15
#[Out]# 52415  -1.20
#[Out]# 52416  -1.25
#[Out]# 52417  -1.25
#[Out]# 52418  -1.35
#[Out]# 52419  -1.65
#[Out]# 52420  -2.25
#[Out]# 52421  -2.50
#[Out]# 52422  -2.60
#[Out]# 52423  -2.95
#[Out]# 52424  -3.05
#[Out]# 52425  -3.15
#[Out]# 52426  -4.70
#[Out]# 52427  -6.90
#[Out]# 52428  -7.10
#[Out]# 52429  -7.35
#[Out]# 52430  -7.55
#[Out]# 52431  -7.75
#[Out]# 52432  -7.85
#[Out]# 52433  -7.85
#[Out]# 52434  -8.15
#[Out]# 52435  -9.45
#[Out]# 52436 -10.05
#[Out]# 52437 -10.85
#[Out]# 52438 -12.10
#[Out]# 52439   0.00
#[Out]# 52440   0.00
#[Out]# 
#[Out]# [52441 rows x 1 columns]
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT difference.value
    FROM difference
    WHERE;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT difference.value
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#        value
#[Out]# 0       0.10
#[Out]# 1       0.10
#[Out]# 2       0.10
#[Out]# 3       0.10
#[Out]# 4       0.05
#[Out]# 5       0.00
#[Out]# 6      -0.35
#[Out]# 7      -0.40
#[Out]# 8      -0.45
#[Out]# 9      -0.50
#[Out]# 10     -0.55
#[Out]# 11     -0.70
#[Out]# 12     -1.00
#[Out]# 13     -1.05
#[Out]# 14     -1.05
#[Out]# 15     -1.05
#[Out]# 16     -1.10
#[Out]# 17     -1.15
#[Out]# 18     -1.20
#[Out]# 19     -1.20
#[Out]# 20     -1.25
#[Out]# 21     -1.25
#[Out]# 22     -1.25
#[Out]# 23     -1.30
#[Out]# 24     -1.30
#[Out]# 25     -1.35
#[Out]# 26     -1.40
#[Out]# 27     -1.45
#[Out]# 28     -1.45
#[Out]# 29     -1.55
#[Out]# ...      ...
#[Out]# 52411  -0.90
#[Out]# 52412  -1.10
#[Out]# 52413  -1.10
#[Out]# 52414  -1.15
#[Out]# 52415  -1.20
#[Out]# 52416  -1.25
#[Out]# 52417  -1.25
#[Out]# 52418  -1.35
#[Out]# 52419  -1.65
#[Out]# 52420  -2.25
#[Out]# 52421  -2.50
#[Out]# 52422  -2.60
#[Out]# 52423  -2.95
#[Out]# 52424  -3.05
#[Out]# 52425  -3.15
#[Out]# 52426  -4.70
#[Out]# 52427  -6.90
#[Out]# 52428  -7.10
#[Out]# 52429  -7.35
#[Out]# 52430  -7.55
#[Out]# 52431  -7.75
#[Out]# 52432  -7.85
#[Out]# 52433  -7.85
#[Out]# 52434  -8.15
#[Out]# 52435  -9.45
#[Out]# 52436 -10.05
#[Out]# 52437 -10.85
#[Out]# 52438 -12.10
#[Out]# 52439   0.00
#[Out]# 52440   0.00
#[Out]# 
#[Out]# [52441 rows x 1 columns]
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT MAX(difference.value)
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(difference.value)
#[Out]# 0                  14.45
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date AND i1.sID<>i2.sID
    )
    SELECT MAX(difference.value)
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(difference.value)
#[Out]# 0                  14.45
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x7f54b2e3c810>
query1 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0    10
#[Out]# 1     8
#[Out]# 2    24
#[Out]# 3    14
#[Out]# 4    11
#[Out]# 5     7
#[Out]# 6    10
#[Out]# 7    26
#[Out]# 8    23
#[Out]# 9    11
#[Out]# 10    4
#[Out]# 11   24
#[Out]# 12   26
#[Out]# 13   28
#[Out]# 14   13
#[Out]# 15   22
#[Out]# 16    3
#[Out]# 17   21
#[Out]# 18   23
#[Out]# 19   16
#[Out]# 20    5
#[Out]# 21    9
#[Out]# 22   27
#[Out]# 23   16
#[Out]# 24    1
#[Out]# 25   28
#[Out]# 26   25
#[Out]# 27    5
#[Out]# 28   13
#[Out]# 29    8
#[Out]# ..  ...
#[Out]# 34   25
#[Out]# 35   26
#[Out]# 36   12
#[Out]# 37   22
#[Out]# 38   21
#[Out]# 39   15
#[Out]# 40    8
#[Out]# 41   22
#[Out]# 42   28
#[Out]# 43    6
#[Out]# 44    1
#[Out]# 45   22
#[Out]# 46    6
#[Out]# 47   28
#[Out]# 48   20
#[Out]# 49   12
#[Out]# 50    9
#[Out]# 51   19
#[Out]# 52   23
#[Out]# 53   12
#[Out]# 54    1
#[Out]# 55   21
#[Out]# 56   16
#[Out]# 57   21
#[Out]# 58   24
#[Out]# 59    0
#[Out]# 60   29
#[Out]# 61   29
#[Out]# 62   30
#[Out]# 63   19
#[Out]# 
#[Out]# [64 rows x 1 columns]
query1 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.pID HAVING COUNT(p.cID) < 3;

'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, purchase p2, product pp1, product pp2
    WHERE p1.date=p2.date AND p1.cID=c1.cID AND p2.cID=c1.cID AND pp1.pName="Onions" AND pp2.pName="Coffee"
    AND p1.pID=pp1.pID AND p2.pID=pp2.pID;
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE p.cID=c.cID
    GROUP BY p.sID HAVING COUNT(p.sID)=1;
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
#[Out]# 1  190
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer c, purchase p
    WHERE p.cID=c.cID
    GROUP BY p.sID HAVING COUNT(p.sID)=1;
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE p.cID=c.cID
    GROUP BY p.sID HAVING COUNT(p.sID)=1;
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
#[Out]# 1  190
query3 = '''
    SELECT DISTINCT c.cID
    FROM customer c, purchase p
    WHERE p.cID=c.cID
    GROUP BY p.sID HAVING COUNT(p.sID)=1;
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
    SELECT s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID GROUP BY s.sName 
    HAVING avg(p.quantity) > 4;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date AND i1.sID<>i2.sID AND i1.date='2018-08-23'
    )
    SELECT MAX(difference.value)
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(difference.value)
#[Out]# 0                  12.95
query2 = '''
    SELECT c1.cID, 
    c1.cName
    FROM customer c1, purchase 
    p1, purchase p2, product pp1, product pp2
    WHERE p1.date=p2.date AND p1.cID=c1.cID AND p2.cID=c1.cID AND pp1.pName="Onions" AND pp2.pName="Coffee"
    AND p1.pID=pp1.pID AND 
    p2.pID=pp2.pID;
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas

# IPython log file

get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)

query2 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

a = pd.read_sql_query(query2, conn)

query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID
            AND p1.pID=p2.pID AND p2.pID=p3.pID AND p1.pID=p3.pID
            AND p1.tID<>p2.tID AND p1.tID<>p3.tID AND p2.tID<>p3.tID;
'''

b = pd.read_sql_query(query1, conn)
print(a, b)
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, purchase p2, product pp1, product pp2
    WHERE p1.date=p2.date AND p1.cID=c1.cID AND p2.cID=c1.cID AND pp1.pName="Onions" AND pp2.pName="Coffee"
    AND p1.pID=pp1.pID AND p2.pID=pp2.pID;
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE p.cID=c.cID
    GROUP BY p.cID HAVING COUNT(p.sID)=1;
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     0
#[Out]# 1    10
#[Out]# 2    11
#[Out]# 3    15
#[Out]# 4    25
#[Out]# 5    26
#[Out]# 6    28
#[Out]# 7    34
#[Out]# 8    47
#[Out]# 9    63
#[Out]# 10   69
#[Out]# 11   76
#[Out]# 12   77
#[Out]# 13   80
#[Out]# 14   88
#[Out]# 15   90
#[Out]# 16   99
#[Out]# 17  103
#[Out]# 18  104
#[Out]# 19  111
#[Out]# 20  128
#[Out]# 21  131
#[Out]# 22  135
#[Out]# 23  136
#[Out]# 24  137
#[Out]# 25  145
#[Out]# 26  168
#[Out]# 27  184
#[Out]# 28  185
#[Out]# 29  186
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Jumbo";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)  sName
#[Out]# 0         3.888889  Jumbo
query4 = '''
    SELECT avg(p.quantity), s.sID
    FROM store s, purchase p
    WHERE p.sID=s.sID;
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)  sID
#[Out]# 0         4.797642   63
query4 = '''
    SELECT s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID HAVING avg(p.quantity) > 4;
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID GROUP BY s.sName 
    HAVING avg(p.quantity) > 4;
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Jumbo";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)  sName
#[Out]# 0         3.888889  Jumbo
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Albert Heijn";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#   avg(p.quantity) sName
#[Out]# 0            None  None
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Albert Hein";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)        sName
#[Out]# 0         4.969697  Albert Hein
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Sligro";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)   sName
#[Out]# 0         4.674419  Sligro
query4 = '''
    SELECT s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID GROUP BY s.sName 
    HAVING avg(p.quantity) > 4;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4         Lidl
#[Out]# 5       Sligro
query5 = '''
    SELECT p.pName, s.sName
    
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM purchase p, store s
    WHERE p.sID=s.sID AND p.price >= ALL (SELECT p1.price
                                            FROM purchase p1)
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName, s.sName
    FROM purchase p, store s
    WHERE p.sID=s.sID AND p.price >= ALL (SELECT p1.price
                                            FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName
    FROM purchase p
    WHERE p.price >= ALL (SELECT p1.price
                                            FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT p.pName
    FROM purchase p, store s
    WHERE s.sID=p.sID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.name, s.sName
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.name, s.sName
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query5 = '''
    SELECT pr.pName, s.sName, p.price
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName  price
#[Out]# 0  Beef  Sligro   13.8
query5 = '''
    SELECT pr.pName, s.sName
    FROM purchase p, store s, product pr
    WHERE s.sID=p.sID AND p.pID=pr.pID AND p.price >= (SELECT MAX(p1.price) FROM purchase p1);
'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
    SELECT difference
    FROM inventory i, store s
    WHERE i.date="2018-08-23" AND DIFFERENCE(i.unit_price) >= (SELECT MAX(DIFFERENCE(i1.unit_price, i2.unit_price) 
                                                                       FROM inventory i1, inventory i2 
                                                                       WHERE i1.date="2018-08-23" AND i2.date="2018-08-23");
'''

pd.read_sql_query(query6, conn)
query6 = '''
    WITH difference(value, date) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT *
    FROM difference;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT *
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#        value
#[Out]# 0       0.10
#[Out]# 1       0.10
#[Out]# 2       0.10
#[Out]# 3       0.10
#[Out]# 4       0.05
#[Out]# 5       0.00
#[Out]# 6      -0.35
#[Out]# 7      -0.40
#[Out]# 8      -0.45
#[Out]# 9      -0.50
#[Out]# 10     -0.55
#[Out]# 11     -0.70
#[Out]# 12     -1.00
#[Out]# 13     -1.05
#[Out]# 14     -1.05
#[Out]# 15     -1.05
#[Out]# 16     -1.10
#[Out]# 17     -1.15
#[Out]# 18     -1.20
#[Out]# 19     -1.20
#[Out]# 20     -1.25
#[Out]# 21     -1.25
#[Out]# 22     -1.25
#[Out]# 23     -1.30
#[Out]# 24     -1.30
#[Out]# 25     -1.35
#[Out]# 26     -1.40
#[Out]# 27     -1.45
#[Out]# 28     -1.45
#[Out]# 29     -1.55
#[Out]# ...      ...
#[Out]# 52411  -0.90
#[Out]# 52412  -1.10
#[Out]# 52413  -1.10
#[Out]# 52414  -1.15
#[Out]# 52415  -1.20
#[Out]# 52416  -1.25
#[Out]# 52417  -1.25
#[Out]# 52418  -1.35
#[Out]# 52419  -1.65
#[Out]# 52420  -2.25
#[Out]# 52421  -2.50
#[Out]# 52422  -2.60
#[Out]# 52423  -2.95
#[Out]# 52424  -3.05
#[Out]# 52425  -3.15
#[Out]# 52426  -4.70
#[Out]# 52427  -6.90
#[Out]# 52428  -7.10
#[Out]# 52429  -7.35
#[Out]# 52430  -7.55
#[Out]# 52431  -7.75
#[Out]# 52432  -7.85
#[Out]# 52433  -7.85
#[Out]# 52434  -8.15
#[Out]# 52435  -9.45
#[Out]# 52436 -10.05
#[Out]# 52437 -10.85
#[Out]# 52438 -12.10
#[Out]# 52439   0.00
#[Out]# 52440   0.00
#[Out]# 
#[Out]# [52441 rows x 1 columns]
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT MAX(*)
    FROM difference;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT *
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#        value
#[Out]# 0       0.10
#[Out]# 1       0.10
#[Out]# 2       0.10
#[Out]# 3       0.10
#[Out]# 4       0.05
#[Out]# 5       0.00
#[Out]# 6      -0.35
#[Out]# 7      -0.40
#[Out]# 8      -0.45
#[Out]# 9      -0.50
#[Out]# 10     -0.55
#[Out]# 11     -0.70
#[Out]# 12     -1.00
#[Out]# 13     -1.05
#[Out]# 14     -1.05
#[Out]# 15     -1.05
#[Out]# 16     -1.10
#[Out]# 17     -1.15
#[Out]# 18     -1.20
#[Out]# 19     -1.20
#[Out]# 20     -1.25
#[Out]# 21     -1.25
#[Out]# 22     -1.25
#[Out]# 23     -1.30
#[Out]# 24     -1.30
#[Out]# 25     -1.35
#[Out]# 26     -1.40
#[Out]# 27     -1.45
#[Out]# 28     -1.45
#[Out]# 29     -1.55
#[Out]# ...      ...
#[Out]# 52411  -0.90
#[Out]# 52412  -1.10
#[Out]# 52413  -1.10
#[Out]# 52414  -1.15
#[Out]# 52415  -1.20
#[Out]# 52416  -1.25
#[Out]# 52417  -1.25
#[Out]# 52418  -1.35
#[Out]# 52419  -1.65
#[Out]# 52420  -2.25
#[Out]# 52421  -2.50
#[Out]# 52422  -2.60
#[Out]# 52423  -2.95
#[Out]# 52424  -3.05
#[Out]# 52425  -3.15
#[Out]# 52426  -4.70
#[Out]# 52427  -6.90
#[Out]# 52428  -7.10
#[Out]# 52429  -7.35
#[Out]# 52430  -7.55
#[Out]# 52431  -7.75
#[Out]# 52432  -7.85
#[Out]# 52433  -7.85
#[Out]# 52434  -8.15
#[Out]# 52435  -9.45
#[Out]# 52436 -10.05
#[Out]# 52437 -10.85
#[Out]# 52438 -12.10
#[Out]# 52439   0.00
#[Out]# 52440   0.00
#[Out]# 
#[Out]# [52441 rows x 1 columns]
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT difference.value
    FROM difference
    WHERE;
'''

pd.read_sql_query(query6, conn)
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT difference.value
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#        value
#[Out]# 0       0.10
#[Out]# 1       0.10
#[Out]# 2       0.10
#[Out]# 3       0.10
#[Out]# 4       0.05
#[Out]# 5       0.00
#[Out]# 6      -0.35
#[Out]# 7      -0.40
#[Out]# 8      -0.45
#[Out]# 9      -0.50
#[Out]# 10     -0.55
#[Out]# 11     -0.70
#[Out]# 12     -1.00
#[Out]# 13     -1.05
#[Out]# 14     -1.05
#[Out]# 15     -1.05
#[Out]# 16     -1.10
#[Out]# 17     -1.15
#[Out]# 18     -1.20
#[Out]# 19     -1.20
#[Out]# 20     -1.25
#[Out]# 21     -1.25
#[Out]# 22     -1.25
#[Out]# 23     -1.30
#[Out]# 24     -1.30
#[Out]# 25     -1.35
#[Out]# 26     -1.40
#[Out]# 27     -1.45
#[Out]# 28     -1.45
#[Out]# 29     -1.55
#[Out]# ...      ...
#[Out]# 52411  -0.90
#[Out]# 52412  -1.10
#[Out]# 52413  -1.10
#[Out]# 52414  -1.15
#[Out]# 52415  -1.20
#[Out]# 52416  -1.25
#[Out]# 52417  -1.25
#[Out]# 52418  -1.35
#[Out]# 52419  -1.65
#[Out]# 52420  -2.25
#[Out]# 52421  -2.50
#[Out]# 52422  -2.60
#[Out]# 52423  -2.95
#[Out]# 52424  -3.05
#[Out]# 52425  -3.15
#[Out]# 52426  -4.70
#[Out]# 52427  -6.90
#[Out]# 52428  -7.10
#[Out]# 52429  -7.35
#[Out]# 52430  -7.55
#[Out]# 52431  -7.75
#[Out]# 52432  -7.85
#[Out]# 52433  -7.85
#[Out]# 52434  -8.15
#[Out]# 52435  -9.45
#[Out]# 52436 -10.05
#[Out]# 52437 -10.85
#[Out]# 52438 -12.10
#[Out]# 52439   0.00
#[Out]# 52440   0.00
#[Out]# 
#[Out]# [52441 rows x 1 columns]
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date
    )
    SELECT MAX(difference.value)
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(difference.value)
#[Out]# 0                  14.45
query6 = '''
    WITH difference(value) AS (
        SELECT i1.unit_price - i2.unit_price
        FROM inventory i1, inventory i2
        WHERE i1.date=i2.date AND i1.sID<>i2.sID
    )
    SELECT MAX(difference.value)
    FROM difference;
'''

pd.read_sql_query(query6, conn)
#[Out]#    MAX(difference.value)
#[Out]# 0                  14.45
get_ipython().run_line_magic('logstop', '')
get_ipython().run_line_magic('logstart', '-o')
import sqlite3
import pandas as pd

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)

query2 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

a = pd.read_sql_query(query2, conn)

query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID
            AND p1.pID=p2.pID AND p2.pID=p3.pID AND p1.pID=p3.pID
            AND p1.tID<>p2.tID AND p1.tID<>p3.tID AND p2.tID<>p3.tID;
'''

b = pd.read_sql_query(query1, conn)
print(a, b)
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, purchase p2, product pp1, product pp2
    WHERE p1.date=p2.date AND p1.cID=c1.cID AND p2.cID=c1.cID AND pp1.pName="Onions" AND pp2.pName="Coffee"
    AND p1.pID=pp1.pID AND p2.pID=pp2.pID;
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE p.cID=c.cID
    GROUP BY p.cID HAVING COUNT(p.sID)=1;
'''

pd.read_sql_query(query3, conn)
#[Out]#     cID
#[Out]# 0     0
#[Out]# 1    10
#[Out]# 2    11
#[Out]# 3    15
#[Out]# 4    25
#[Out]# 5    26
#[Out]# 6    28
#[Out]# 7    34
#[Out]# 8    47
#[Out]# 9    63
#[Out]# 10   69
#[Out]# 11   76
#[Out]# 12   77
#[Out]# 13   80
#[Out]# 14   88
#[Out]# 15   90
#[Out]# 16   99
#[Out]# 17  103
#[Out]# 18  104
#[Out]# 19  111
#[Out]# 20  128
#[Out]# 21  131
#[Out]# 22  135
#[Out]# 23  136
#[Out]# 24  137
#[Out]# 25  145
#[Out]# 26  168
#[Out]# 27  184
#[Out]# 28  185
#[Out]# 29  186
query4 = '''
    SELECT s.sID
    FROM store
    WHERE s.sName="Jumbo";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName 
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT s.sID
    FROM store s
    WHERE s.sName="Jumbo";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName 
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    sID
#[Out]# 0    2
#[Out]# 1   10
#[Out]# 2   20
#[Out]# 3   37
#[Out]# 4   56
#[Out]# 5   59
#[Out]# 6   62
#[Out]# 7   63
query4 = '''
    SELECT p.quantity
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Jumbo";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName 
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#     quantity
#[Out]# 0          9
#[Out]# 1          6
#[Out]# 2          1
#[Out]# 3          1
#[Out]# 4          3
#[Out]# 5          5
#[Out]# 6          4
#[Out]# 7          4
#[Out]# 8          5
#[Out]# 9          5
#[Out]# 10         7
#[Out]# 11         6
#[Out]# 12         6
#[Out]# 13         8
#[Out]# 14         5
#[Out]# 15         3
#[Out]# 16         7
#[Out]# 17         5
#[Out]# 18         2
#[Out]# 19         6
#[Out]# 20         2
#[Out]# 21         2
#[Out]# 22         4
#[Out]# 23         4
#[Out]# 24         1
#[Out]# 25         5
#[Out]# 26         3
#[Out]# 27         1
#[Out]# 28         1
#[Out]# 29         4
#[Out]# 30         3
#[Out]# 31         1
#[Out]# 32         5
#[Out]# 33         1
#[Out]# 34         1
#[Out]# 35         5
#[Out]# 36         3
#[Out]# 37         4
#[Out]# 38         7
#[Out]# 39         7
#[Out]# 40         4
#[Out]# 41         4
#[Out]# 42         2
#[Out]# 43         2
#[Out]# 44         1
query4 = '''
    SELECT p.quantity, s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Jumbo";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#     quantity  sName
#[Out]# 0          9  Jumbo
#[Out]# 1          6  Jumbo
#[Out]# 2          1  Jumbo
#[Out]# 3          1  Jumbo
#[Out]# 4          3  Jumbo
#[Out]# 5          5  Jumbo
#[Out]# 6          4  Jumbo
#[Out]# 7          4  Jumbo
#[Out]# 8          5  Jumbo
#[Out]# 9          5  Jumbo
#[Out]# 10         7  Jumbo
#[Out]# 11         6  Jumbo
#[Out]# 12         6  Jumbo
#[Out]# 13         8  Jumbo
#[Out]# 14         5  Jumbo
#[Out]# 15         3  Jumbo
#[Out]# 16         7  Jumbo
#[Out]# 17         5  Jumbo
#[Out]# 18         2  Jumbo
#[Out]# 19         6  Jumbo
#[Out]# 20         2  Jumbo
#[Out]# 21         2  Jumbo
#[Out]# 22         4  Jumbo
#[Out]# 23         4  Jumbo
#[Out]# 24         1  Jumbo
#[Out]# 25         5  Jumbo
#[Out]# 26         3  Jumbo
#[Out]# 27         1  Jumbo
#[Out]# 28         1  Jumbo
#[Out]# 29         4  Jumbo
#[Out]# 30         3  Jumbo
#[Out]# 31         1  Jumbo
#[Out]# 32         5  Jumbo
#[Out]# 33         1  Jumbo
#[Out]# 34         1  Jumbo
#[Out]# 35         5  Jumbo
#[Out]# 36         3  Jumbo
#[Out]# 37         4  Jumbo
#[Out]# 38         7  Jumbo
#[Out]# 39         7  Jumbo
#[Out]# 40         4  Jumbo
#[Out]# 41         4  Jumbo
#[Out]# 42         2  Jumbo
#[Out]# 43         2  Jumbo
#[Out]# 44         1  Jumbo
query4 = '''
    SELECT p.quantity, s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID;
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#      quantity        sName
#[Out]# 0           1       Sligro
#[Out]# 1           2         Dirk
#[Out]# 2           3       Sligro
#[Out]# 3           2    Hoogvliet
#[Out]# 4           4  Albert Hein
#[Out]# 5           4         Lidl
#[Out]# 6           8         Lidl
#[Out]# 7           6         Lidl
#[Out]# 8           1         Lidl
#[Out]# 9           7       Sligro
#[Out]# 10          6         Coop
#[Out]# 11          4         Coop
#[Out]# 12          1         Coop
#[Out]# 13          2  Albert Hein
#[Out]# 14          2         Dirk
#[Out]# 15          6       Sligro
#[Out]# 16          2    Hoogvliet
#[Out]# 17          9        Jumbo
#[Out]# 18          5         Coop
#[Out]# 19          2         Coop
#[Out]# 20          9       Sligro
#[Out]# 21          4  Albert Hein
#[Out]# 22          6    Hoogvliet
#[Out]# 23          6         Lidl
#[Out]# 24          9         Coop
#[Out]# 25          2         Coop
#[Out]# 26          2         Coop
#[Out]# 27          1    Hoogvliet
#[Out]# 28          2       Sligro
#[Out]# 29          6         Lidl
#[Out]# ..        ...          ...
#[Out]# 479         4         Coop
#[Out]# 480         5         Lidl
#[Out]# 481         3         Lidl
#[Out]# 482         4        Jumbo
#[Out]# 483         4    Hoogvliet
#[Out]# 484         4       Sligro
#[Out]# 485         2    Hoogvliet
#[Out]# 486         5  Albert Hein
#[Out]# 487         5       Sligro
#[Out]# 488         7         Coop
#[Out]# 489         5  Albert Hein
#[Out]# 490         2         Coop
#[Out]# 491         4         Lidl
#[Out]# 492         4         Coop
#[Out]# 493         6    Hoogvliet
#[Out]# 494         3    Hoogvliet
#[Out]# 495         6       Sligro
#[Out]# 496         1         Coop
#[Out]# 497         5         Lidl
#[Out]# 498         4         Coop
#[Out]# 499         6         Dirk
#[Out]# 500         7         Coop
#[Out]# 501         4        Jumbo
#[Out]# 502         5         Dirk
#[Out]# 503         7         Dirk
#[Out]# 504         2        Jumbo
#[Out]# 505         6         Lidl
#[Out]# 506         5         Lidl
#[Out]# 507         2        Jumbo
#[Out]# 508         1        Jumbo
#[Out]# 
#[Out]# [509 rows x 2 columns]
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Jumbo";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)  sName
#[Out]# 0         3.888889  Jumbo
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID ORDER BY s.sName";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID ORDER BY s.sName;
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)  sName
#[Out]# 0         4.797642  Jumbo
query4 = '''
    SELECT avg(p.quantity), s.sName
    FROM store s, purchase p
    WHERE p.sID=s.sID AND s.sName="Jumbo";
'''

query = '''
    WITH store_chain_purchases(p.id) AS 
    (
         SELECT p
         FROM purchase p, store s
         WHERE p.sID=s.sID ANDE
    ), 
    store_chain_avg AS 
    (
         SELECT avg(p.quantity)
         FROM 
         WHERE 
    )
    SELECT store_chain.sName
    FROM store_chain, store_chain_avg
    WHERE store_chain_avg.value>4;
'''

pd.read_sql_query(query4, conn)
#[Out]#    avg(p.quantity)  sName
#[Out]# 0         3.888889  Jumbo

# IPython log file

# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
#[Out]# <sqlite3.Cursor at 0x7fe784353c00>
query1 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query1, conn)
query1 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase
    WHERE true;
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID
    FROM purchase
    WHERE 1=1;
'''

pd.read_sql_query(query1, conn)
#[Out]#      pID
#[Out]# 0     10
#[Out]# 1     14
#[Out]# 2     16
#[Out]# 3      9
#[Out]# 4     25
#[Out]# 5     26
#[Out]# 6     11
#[Out]# 7     27
#[Out]# 8     20
#[Out]# 9      9
#[Out]# 10     4
#[Out]# 11    13
#[Out]# 12    22
#[Out]# 13    14
#[Out]# 14    26
#[Out]# 15     9
#[Out]# 16     8
#[Out]# 17    27
#[Out]# 18    12
#[Out]# 19     6
#[Out]# 20    13
#[Out]# 21    26
#[Out]# 22    14
#[Out]# 23    28
#[Out]# 24     6
#[Out]# 25    22
#[Out]# 26    16
#[Out]# 27    19
#[Out]# 28    19
#[Out]# 29     2
#[Out]# ..   ...
#[Out]# 479   28
#[Out]# 480   27
#[Out]# 481    5
#[Out]# 482   28
#[Out]# 483    7
#[Out]# 484    0
#[Out]# 485   11
#[Out]# 486    6
#[Out]# 487   19
#[Out]# 488   17
#[Out]# 489    9
#[Out]# 490   11
#[Out]# 491   22
#[Out]# 492   17
#[Out]# 493   20
#[Out]# 494   11
#[Out]# 495   21
#[Out]# 496   23
#[Out]# 497   23
#[Out]# 498    8
#[Out]# 499    0
#[Out]# 500    8
#[Out]# 501   11
#[Out]# 502   15
#[Out]# 503    2
#[Out]# 504   17
#[Out]# 505    5
#[Out]# 506   19
#[Out]# 507    9
#[Out]# 508   18
#[Out]# 
#[Out]# [509 rows x 1 columns]
query1 = '''
    SELECT p.pID
    FROM purchase p
    WHERE not exists (SELECT p1.pID
                      FROM purchase p1, purchase p2, purchase p3
                      WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID);
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID]
#[Out]# Index: []
query1 = '''
    SELECT p.pID
    FROM purchase p
    WHERE except (SELECT p1.pID
                      FROM purchase p1, purchase p2, purchase p3
                      WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID);
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT (SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID);
'''

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID;
'''

pd.read_sql_query(query1, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID]
#[Out]# Index: []
query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID;
'''

pd.read_sql_query(query1, conn)

query2 = '''
    SELECT p.pID
    FROM purchase
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

pd.read_sql_query(query2, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID;
'''

pd.read_sql_query(query1, conn)

query2 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

pd.read_sql_query(query2, conn)
#[Out]#     pID
#[Out]# 0    10
#[Out]# 1     8
#[Out]# 2    24
#[Out]# 3    14
#[Out]# 4    11
#[Out]# 5     7
#[Out]# 6    10
#[Out]# 7    26
#[Out]# 8    23
#[Out]# 9    11
#[Out]# 10    4
#[Out]# 11   24
#[Out]# 12   26
#[Out]# 13   28
#[Out]# 14   13
#[Out]# 15   22
#[Out]# 16    3
#[Out]# 17   21
#[Out]# 18   23
#[Out]# 19   16
#[Out]# 20    5
#[Out]# 21    9
#[Out]# 22   27
#[Out]# 23   16
#[Out]# 24    1
#[Out]# 25   28
#[Out]# 26   25
#[Out]# 27    5
#[Out]# 28   13
#[Out]# 29    8
#[Out]# ..  ...
#[Out]# 34   25
#[Out]# 35   26
#[Out]# 36   12
#[Out]# 37   22
#[Out]# 38   21
#[Out]# 39   15
#[Out]# 40    8
#[Out]# 41   22
#[Out]# 42   28
#[Out]# 43    6
#[Out]# 44    1
#[Out]# 45   22
#[Out]# 46    6
#[Out]# 47   28
#[Out]# 48   20
#[Out]# 49   12
#[Out]# 50    9
#[Out]# 51   19
#[Out]# 52   23
#[Out]# 53   12
#[Out]# 54    1
#[Out]# 55   21
#[Out]# 56   16
#[Out]# 57   21
#[Out]# 58   24
#[Out]# 59    0
#[Out]# 60   29
#[Out]# 61   29
#[Out]# 62   30
#[Out]# 63   19
#[Out]# 
#[Out]# [64 rows x 1 columns]
query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID
            AND p1.pID=p2.pID AND p2.pID=p3.pID AND p1.pID=p3.pID;
'''

pd.read_sql_query(query1, conn)

query2 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

pd.read_sql_query(query2, conn)
#[Out]#     pID
#[Out]# 0    10
#[Out]# 1     8
#[Out]# 2    24
#[Out]# 3    14
#[Out]# 4    11
#[Out]# 5     7
#[Out]# 6    10
#[Out]# 7    26
#[Out]# 8    23
#[Out]# 9    11
#[Out]# 10    4
#[Out]# 11   24
#[Out]# 12   26
#[Out]# 13   28
#[Out]# 14   13
#[Out]# 15   22
#[Out]# 16    3
#[Out]# 17   21
#[Out]# 18   23
#[Out]# 19   16
#[Out]# 20    5
#[Out]# 21    9
#[Out]# 22   27
#[Out]# 23   16
#[Out]# 24    1
#[Out]# 25   28
#[Out]# 26   25
#[Out]# 27    5
#[Out]# 28   13
#[Out]# 29    8
#[Out]# ..  ...
#[Out]# 34   25
#[Out]# 35   26
#[Out]# 36   12
#[Out]# 37   22
#[Out]# 38   21
#[Out]# 39   15
#[Out]# 40    8
#[Out]# 41   22
#[Out]# 42   28
#[Out]# 43    6
#[Out]# 44    1
#[Out]# 45   22
#[Out]# 46    6
#[Out]# 47   28
#[Out]# 48   20
#[Out]# 49   12
#[Out]# 50    9
#[Out]# 51   19
#[Out]# 52   23
#[Out]# 53   12
#[Out]# 54    1
#[Out]# 55   21
#[Out]# 56   16
#[Out]# 57   21
#[Out]# 58   24
#[Out]# 59    0
#[Out]# 60   29
#[Out]# 61   29
#[Out]# 62   30
#[Out]# 63   19
#[Out]# 
#[Out]# [64 rows x 1 columns]
query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID
            AND p1.pID=p2.pID AND p2.pID=p3.pID AND p1.pID=p3.pID;
'''

pd.read_sql_query(query1, conn)

query2 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

# pd.read_sql_query(query2, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID
            AND p1.pID=p2.pID AND p2.pID=p3.pID AND p1.pID=p3.pID;
'''

pd.read_sql_query(query1, conn)

query2 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

# pd.read_sql_query(query2, conn)
query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID
            AND p1.pID=p2.pID AND p2.pID=p3.pID AND p1.pID=p3.pID;
'''

pd.read_sql_query(query1, conn)

#query2 = '''
#
# pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pID]
#[Out]# Index: []

query2 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

pd.read_sql_query(query2, conn)

query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID
            AND p1.pID=p2.pID AND p2.pID=p3.pID AND p1.pID=p3.pID
            AND p1.tID<>p2.tID AND p1.tID<>p3.tID AND p2.tID<>p3.tID;
'''

pd.read_sql_query(query1, conn)
#[Out]#     pID
#[Out]# 0     1
#[Out]# 1     2
#[Out]# 2     3
#[Out]# 3     4
#[Out]# 4     6
#[Out]# 5     7
#[Out]# 6     8
#[Out]# 7    12
#[Out]# 8    13
#[Out]# 9    14
#[Out]# 10   15
#[Out]# 11   16
#[Out]# 12   18
#[Out]# 13   22
#[Out]# 14   24
#[Out]# 15   25
#[Out]# 16   26
#[Out]# 17   29
#[Out]# 18   30

query2 = '''
    SELECT p.pID
    FROM purchase p
    GROUP BY p.cID HAVING COUNT(p.cID) < 3;

'''

a = pd.read_sql_query(query2, conn)

query1 = '''
    SELECT p.pID
    FROM purchase p 
    EXCEPT SELECT p1.pID
            FROM purchase p1, purchase p2, purchase p3
            WHERE p1.cID=p2.cID AND p2.cID=p3.cID AND p1.cID=p3.cID
            AND p1.pID=p2.pID AND p2.pID=p3.pID AND p1.pID=p3.pID
            AND p1.tID<>p2.tID AND p1.tID<>p3.tID AND p2.tID<>p3.tID;
'''

b = pd.read_sql_query(query1, conn)
print(a, b)
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, purchase p2, product pp1, product pp2
    WHERE p1.date=p2.date AND p1.cID=c1.cID AND p2.cID=c1.cID AND product pp1='Onions' AND pp2='Coffee';
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, purchase p2, product pp1, product pp2
    WHERE p1.date=p2.date AND p1.cID=c1.cID AND p2.cID=c1.cID AND product pp1="Onions" AND pp2="Coffee";
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, purchase p2, product pp1, product pp2
    WHERE p1.date=p2.date AND p1.cID=c1.cID AND p2.cID=c1.cID AND pp1="Onions" AND pp2="Coffee";
'''

pd.read_sql_query(query2, conn)
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, purchase p2, product pp1, product pp2
    WHERE p1.date=p2.date AND p1.cID=c1.cID AND p2.cID=c1.cID AND pp1.pName="Onions" AND pp2.pName="Coffee";
'''

pd.read_sql_query(query2, conn)
#[Out]#       cID   cName
#[Out]# 0       0    Noah
#[Out]# 1       1     Sem
#[Out]# 2       1     Sem
#[Out]# 3       1     Sem
#[Out]# 4       1     Sem
#[Out]# 5       1     Sem
#[Out]# 6       1     Sem
#[Out]# 7       1     Sem
#[Out]# 8       1     Sem
#[Out]# 9       1     Sem
#[Out]# 10      1     Sem
#[Out]# 11      1     Sem
#[Out]# 12      1     Sem
#[Out]# 13      1     Sem
#[Out]# 14      1     Sem
#[Out]# 15      1     Sem
#[Out]# 16      1     Sem
#[Out]# 17      1     Sem
#[Out]# 18      1     Sem
#[Out]# 19      1     Sem
#[Out]# 20      1     Sem
#[Out]# 21      1     Sem
#[Out]# 22      1     Sem
#[Out]# 23      1     Sem
#[Out]# 24      1     Sem
#[Out]# 25      1     Sem
#[Out]# 26      1     Sem
#[Out]# 27      1     Sem
#[Out]# 28      1     Sem
#[Out]# 29      1     Sem
#[Out]# ...   ...     ...
#[Out]# 1413  190  Kostas
#[Out]# 1414  190  Kostas
#[Out]# 1415  190  Kostas
#[Out]# 1416  190  Kostas
#[Out]# 1417  190  Kostas
#[Out]# 1418  190  Kostas
#[Out]# 1419  190  Kostas
#[Out]# 1420  190  Kostas
#[Out]# 1421  190  Kostas
#[Out]# 1422  190  Kostas
#[Out]# 1423  190  Kostas
#[Out]# 1424  190  Kostas
#[Out]# 1425  190  Kostas
#[Out]# 1426  190  Kostas
#[Out]# 1427  190  Kostas
#[Out]# 1428  190  Kostas
#[Out]# 1429  190  Kostas
#[Out]# 1430  190  Kostas
#[Out]# 1431  190  Kostas
#[Out]# 1432  190  Kostas
#[Out]# 1433  190  Kostas
#[Out]# 1434  190  Kostas
#[Out]# 1435  190  Kostas
#[Out]# 1436  190  Kostas
#[Out]# 1437  190  Kostas
#[Out]# 1438  190  Kostas
#[Out]# 1439  190  Kostas
#[Out]# 1440  190  Kostas
#[Out]# 1441  190  Kostas
#[Out]# 1442  190  Kostas
#[Out]# 
#[Out]# [1443 rows x 2 columns]
query2 = '''
    SELECT c1.cID, c1.cName
    FROM customer c1, purchase p1, purchase p2, product pp1, product pp2
    WHERE p1.date=p2.date AND p1.cID=c1.cID AND p2.cID=c1.cID AND pp1.pName="Onions" AND pp2.pName="Coffee"
    AND p1.pID=pp1.pID AND p2.pID=pp2.pID;
'''

pd.read_sql_query(query2, conn)
#[Out]#    cID   cName
#[Out]# 0  124   Sofie
#[Out]# 1  190  Kostas
query3 = '''
    SELECT * FROM stores;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT * FROM store;
'''

pd.read_sql_query(query3, conn)
#[Out]#     sID        sName            street       city
#[Out]# 0     0         Coop      Kalverstraat  Amsterdam
#[Out]# 1     1    Hoogvliet  Rozemarijnstraat      Breda
#[Out]# 2     2        Jumbo    Stadhoudersweg  Rotterdam
#[Out]# 3     3       Sligro    Stadhoudersweg  Rotterdam
#[Out]# 4     4    Hoogvliet       Molenstraat  Eindhoven
#[Out]# 5     5       Sligro     Stationsplein      Breda
#[Out]# 6     6         Coop    Stadhoudersweg  Rotterdam
#[Out]# 7     7       Sligro  Wilhelminastraat  Eindhoven
#[Out]# 8     8  Albert Hein       Molenstraat  Eindhoven
#[Out]# 9     9  Albert Hein         Koestraat    Tilburg
#[Out]# 10   10        Jumbo        Bergselaan  Rotterdam
#[Out]# 11   11  Albert Hein          Hofplein  Rotterdam
#[Out]# 12   12         Lidl  Wilhelminastraat  Eindhoven
#[Out]# 13   13         Coop         Koestraat    Tilburg
#[Out]# 14   14         Coop     Keizersgracht  Amsterdam
#[Out]# 15   15         Lidl     Prinsengracht  Amsterdam
#[Out]# 16   16         Lidl     Ambachtstraat    Utrecht
#[Out]# 17   17    Hoogvliet        Kerkstraat  Eindhoven
#[Out]# 18   18       Sligro       Parallelweg    Tilburg
#[Out]# 19   19         Coop       Karrestraat      Breda
#[Out]# 20   20        Jumbo      Kasteeldreef    Tilburg
#[Out]# 21   21         Coop      Kasteeldreef    Tilburg
#[Out]# 22   22         Lidl     Prinsengracht  Amsterdam
#[Out]# 23   23         Dirk     Stationsplein      Breda
#[Out]# 24   24  Albert Hein     Stationsplein      Breda
#[Out]# 25   25  Albert Hein     Stationsplein      Breda
#[Out]# 26   26    Hoogvliet   Sint Annastraat      Breda
#[Out]# 27   27       Sligro      Kalverstraat  Amsterdam
#[Out]# 28   28    Hoogvliet         Koestraat    Tilburg
#[Out]# 29   29       Sligro      Marnixstraat  Amsterdam
#[Out]# ..  ...          ...               ...        ...
#[Out]# 34   34         Coop          Bierkaai  Amsterdam
#[Out]# 35   35         Lidl     Julianastraat    Utrecht
#[Out]# 36   36         Lidl     Julianastraat  Eindhoven
#[Out]# 37   37        Jumbo          Molenweg  Eindhoven
#[Out]# 38   38    Hoogvliet          Hofplein  Rotterdam
#[Out]# 39   39       Sligro       Dorpsstraat  Eindhoven
#[Out]# 40   40    Hoogvliet          Hofplein  Rotterdam
#[Out]# 41   41  Albert Hein        Bergselaan  Rotterdam
#[Out]# 42   42       Sligro      Kalverstraat  Amsterdam
#[Out]# 43   43         Coop    Gasthuisstraat    Utrecht
#[Out]# 44   44  Albert Hein     Ambachtstraat    Utrecht
#[Out]# 45   45         Coop      Kasteeldreef    Tilburg
#[Out]# 46   46         Lidl        Bergselaan  Rotterdam
#[Out]# 47   47         Coop     Julianastraat  Rotterdam
#[Out]# 48   48    Hoogvliet      Kasteeldreef    Tilburg
#[Out]# 49   49    Hoogvliet      Keizerstraat  Rotterdam
#[Out]# 50   50       Sligro     Stationsplein      Breda
#[Out]# 51   51         Coop       Parallelweg    Utrecht
#[Out]# 52   52         Lidl       Nieuwstraat  Eindhoven
#[Out]# 53   53         Coop        Hoogstraat    Utrecht
#[Out]# 54   54         Dirk     Julianastraat  Eindhoven
#[Out]# 55   55         Coop   Sint Annastraat      Breda
#[Out]# 56   56        Jumbo       Parallelweg  Eindhoven
#[Out]# 57   57         Dirk       Molenstraat  Eindhoven
#[Out]# 58   58         Dirk      Keizerstraat  Rotterdam
#[Out]# 59   59        Jumbo  Rozemarijnstraat      Breda
#[Out]# 60   60         Lidl      Pannekoekweg      Breda
#[Out]# 61   61         Lidl      Pannekoekweg      Breda
#[Out]# 62   62        Jumbo     Poffertjesweg  Eindhoven
#[Out]# 63   63        Jumbo     Stationstraat        Oss
#[Out]# 
#[Out]# [64 rows x 4 columns]
query3 = '''
    SELECT cID
    FROM customer c, purchase p
    WHERE count(sID)=64 GROUP BY sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE count(sID)=64 GROUP BY sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE count(p.sID)=64 GROUP BY p.sID
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE GROUP BY p.sID HAVING COUNT(p.sID)=64
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE GROUP BY p.sID HAVING COUNT(p.sID)=64;
'''

pd.read_sql_query(query3, conn)
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    GROUP BY p.sID HAVING COUNT(p.sID)=64;
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE p.cID=c.cID
    GROUP BY p.sID HAVING COUNT(p.sID)=63;
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE p.cID=c.cID
    GROUP BY p.sID HAVING COUNT(p.sID)=64;
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
    SELECT c.cID
    FROM customer c, purchase p
    WHERE p.cID=c.cID
    GROUP BY p.sID HAVING COUNT(p.sID)=1;
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
#[Out]# 1  190
query3 = '''
    SELECT count(s.sID)
    FROM store s
    GROUP BY s.sID;
'''

pd.read_sql_query(query3, conn)
#[Out]#     count(s.sID)
#[Out]# 0              1
#[Out]# 1              1
#[Out]# 2              1
#[Out]# 3              1
#[Out]# 4              1
#[Out]# 5              1
#[Out]# 6              1
#[Out]# 7              1
#[Out]# 8              1
#[Out]# 9              1
#[Out]# 10             1
#[Out]# 11             1
#[Out]# 12             1
#[Out]# 13             1
#[Out]# 14             1
#[Out]# 15             1
#[Out]# 16             1
#[Out]# 17             1
#[Out]# 18             1
#[Out]# 19             1
#[Out]# 20             1
#[Out]# 21             1
#[Out]# 22             1
#[Out]# 23             1
#[Out]# 24             1
#[Out]# 25             1
#[Out]# 26             1
#[Out]# 27             1
#[Out]# 28             1
#[Out]# 29             1
#[Out]# ..           ...
#[Out]# 34             1
#[Out]# 35             1
#[Out]# 36             1
#[Out]# 37             1
#[Out]# 38             1
#[Out]# 39             1
#[Out]# 40             1
#[Out]# 41             1
#[Out]# 42             1
#[Out]# 43             1
#[Out]# 44             1
#[Out]# 45             1
#[Out]# 46             1
#[Out]# 47             1
#[Out]# 48             1
#[Out]# 49             1
#[Out]# 50             1
#[Out]# 51             1
#[Out]# 52             1
#[Out]# 53             1
#[Out]# 54             1
#[Out]# 55             1
#[Out]# 56             1
#[Out]# 57             1
#[Out]# 58             1
#[Out]# 59             1
#[Out]# 60             1
#[Out]# 61             1
#[Out]# 62             1
#[Out]# 63             1
#[Out]# 
#[Out]# [64 rows x 1 columns]

