# IPython log file

get_ipython().magic('logstop')
get_ipython().magic('logstart -o')
import sqlite3
import pandas as pd
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file.
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
# This connects a database instance on your local machine, make the name of the database descriptive!
conn = sqlite3.connect('shopping.db')
cur = conn.cursor()

# The first time you ran this command, it initialized a database instance.
# In the cell below, you fill it with the appropriate sql dump file. 
# This cell populates the database.
# You can only populate each database once, so comment this cell out once it is finished.
# If you want to create a new database instance or use another database, 
# fill in another name in the cell above, 
# change the source file below and run both cells.

# Replace this line with the correct location of the SQL dump, 
# and the correct database instance needed for the questions.
db_location = 'shoppingDB.sql'

f = open(db_location,'r')
sql = f.read()
cur.executescript(sql)
query1 = 
(SELECT pID FROM product)
EXCEPT
(SELECT p1.pID FROM purchase AS p1, purchase AS p2, purchase AS p3 WHERE
p1.pID=p2.pID AND
p1.pID=p3.pID AND
p1.cID<>p2.cID AND
p1.cID<>p3.cID AND
p2.cID<>p3.cID);

pd.read_sql_query(query1, conn)
query1 = 
SELECT pID FROM product
EXCEPT
SELECT p1.pID FROM purchase AS p1, purchase AS p2, purchase AS p3 WHERE
p1.pID=p2.pID AND
p1.pID=p3.pID AND
p1.cID<>p2.cID AND
p1.cID<>p3.cID AND
p2.cID<>p3.cID;

pd.read_sql_query(query1, conn)
query1 = '''
    SELECT pID FROM product
EXCEPT
SELECT p1.pID FROM purchase AS p1, purchase AS p2, purchase AS p3 WHERE
p1.pID=p2.pID AND
p1.pID=p3.pID AND
p1.cID<>p2.cID AND
p1.cID<>p3.cID AND
p2.cID<>p3.cID;
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query1 = '''
(SELECT pID FROM product)
EXCEPT
(SELECT p1.pID FROM purchase AS p1, purchase AS p2, purchase AS p3 WHERE
p1.pID=p2.pID AND
p1.pID=p3.pID AND
p1.cID<>p2.cID AND
p1.cID<>p3.cID AND
p2.cID<>p3.cID);
'''

pd.read_sql_query(query1, conn)
query1 = '''
(SELECT pID FROM product)
EXCEPT
(SELECT p1.pID FROM purchase AS p1, purchase AS p2, purchase AS p3 WHERE
p1.pID=p2.pID AND
p1.pID=p3.pID AND
p1.cID<>p2.cID AND
p1.cID<>p3.cID AND
p2.cID<>p3.cID);
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT pID FROM product
EXCEPT
(SELECT p1.pID FROM purchase AS p1, purchase AS p2, purchase AS p3 WHERE
p1.pID=p2.pID AND
p1.pID=p3.pID AND
p1.cID<>p2.cID AND
p1.cID<>p3.cID AND
p2.cID<>p3.cID);
'''

pd.read_sql_query(query1, conn)
query1 = '''
SELECT pID FROM product
EXCEPT
SELECT p1.pID FROM purchase AS p1, purchase AS p2, purchase AS p3 WHERE
p1.pID=p2.pID AND
p1.pID=p3.pID AND
p1.cID<>p2.cID AND
p1.cID<>p3.cID AND
p2.cID<>p3.cID;
'''

pd.read_sql_query(query1, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
(SELECT c.cID,c.cName FROM customer as c)
EXCEPT
(SELECT c.cID,c.cName FROM customer as c, purchase as p WHERE c.cID=p.cID AND (c.cID,cName,date,pID) NOT IN (SELECT c.cID,cName,date,pID FROM customer as c, shoppinglist as s WHERE c.cID=s.cID));
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID,c.cName FROM customer as C)
EXCEPT
SELECT c.cID,c.cName FROM customer as c, purchase as p WHERE c.cID=p.cID AND (c.cID,cName,date,pID) NOT IN (SELECT c.cID,cName,date,pID FROM customer as c, shoppinglist as s WHERE c.cID=s.cID);
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID,c.cName FROM customer as C)
EXCEPT
SELECT c.cID,c.cName FROM customer as c, purchase as p WHERE c.cID=p.cID AND c.cID,cName,date,pID NOT IN SELECT c.cID,cName,date,pID FROM customer as c, shoppinglist as s WHERE c.cID=s.cID;
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID,c.cName FROM customer as C
EXCEPT
SELECT c.cID,c.cName FROM customer as c, purchase as p WHERE c.cID=p.cID AND c.cID,cName,date,pID NOT IN SELECT c.cID,cName,date,pID FROM customer as c, shoppinglist as s WHERE c.cID=s.cID;
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT pID FROM product
EXCEPT
SELECT p1.pID FROM purchase AS p1, purchase AS p2, purchase AS p3 WHERE
p1.pID=p2.pID AND
p1.pID=p3.pID AND
p1.cID<>p2.cID AND
p1.cID<>p3.cID AND
p2.cID<>p3.cID;
'''

pd.read_sql_query(query2, conn)
#[Out]#    pID
#[Out]# 0   29
#[Out]# 1   30
#[Out]# 2   31
query2 = '''
SELECT c.cID, c.cName 
FROM customer as c, product as pr, purchase as pu
WHERE pr.pName='Unions'
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
SELECT c.cID, c.cName 
FROM customer as c, product as pr, purchase as pu
WHERE pr.pName=coffee
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName 
FROM customer as c, product as pr, purchase as pu
WHERE pr.pName=coffee;
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName 
FROM customer as c, product as pr, purchase as pu
WHERE pr.pName='coffee';
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
SELECT pName
FROM product
WHERE product.pName='coffee';
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName]
#[Out]# Index: []
query2 = '''
SELECT pName
FROM product
WHERE product.pName='Unions';
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName]
#[Out]# Index: []
query2 = '''
SELECT pName
FROM product
WHERE product.pName=Unions;
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT pName
FROM product
WHERE product.pName="Unions";
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [pName]
#[Out]# Index: []
query2 = '''
SELECT pName
FROM product
WHERE product.pName="Coffee";
'''

pd.read_sql_query(query2, conn)
#[Out]#     pName
#[Out]# 0  Coffee
query2 = '''
SELECT pName
FROM product
WHERE product.pName="Onions";
'''

pd.read_sql_query(query2, conn)
#[Out]#     pName
#[Out]# 0  Onions
query2 = '''
SELECT suffix
FROM product
WHERE product.pName="Onions";
'''

pd.read_sql_query(query2, conn)
#[Out]#   suffix
#[Out]# 0       
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, product AS pr1, purchase AS pu1, purchase AS pu2
WHERE pu1.date=pu2.date AND
(pu.pID="Unions" AND pu.pID="Coffee");
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, product AS pr1, purchase AS pu1, purchase AS pu2
WHERE pu1.date=pu2.date AND
pu.pID="Unions" AND pu.pID="Coffee";
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, product AS pr1, purchase AS pu1, purchase AS pu2
WHERE pu1.date=pu2.date;
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, product AS p
WHERE p.pID="Unions";
;
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, product AS p
WHERE p.pID="Unions";

'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, product AS p
WHERE p.pName="Unions";

'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, product AS p
WHERE c.cName="Peter";

'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, product AS p
WHERE c.cName=*;

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, product AS p
WHERE c.cName="*";

'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, product AS p
WHERE c.cID=*;

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID,c.cName FROM customer as c, purchase as p WHERE c.cID=p.cID AND (c.cID,cName,date,pID) NOT IN (SELECT c.cID,cName,date,pID FROM customer as c, shoppinglist as s WHERE c.cID=s.cID);

'''

pd.read_sql_query(query2, conn)
query2 =
SELECT c.cID,c.cName FROM customer as c, purchase as p WHERE c.cID=p.cID AND (c.cID,cName,date,pID) NOT IN (SELECT c.cID,cName,date,pID FROM customer as c, shoppinglist as s WHERE c.cID=s.cID);


pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID,c.cName FROM customer as c, purchase as p WHERE c.cID=p.cID AND (c.cID,cName,date,pID) NOT IN (SELECT c.cID,cName,date,pID FROM customer as c, shoppinglist as s WHERE c.cID=s.cID);

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID,c.cName FROM customer AS c, shoppinglist AS s, inventory AS i WHERE c.cID=s.cID AND s.pID=i.pID AND s.date=i.date AND s.quantity <= i.quantity;
'''

pd.read_sql_query(query2, conn)
#[Out]#       cID  cName
#[Out]# 0       1    Sem
#[Out]# 1       1    Sem
#[Out]# 2       1    Sem
#[Out]# 3       1    Sem
#[Out]# 4       1    Sem
#[Out]# 5       1    Sem
#[Out]# 6       1    Sem
#[Out]# 7       1    Sem
#[Out]# 8       1    Sem
#[Out]# 9       1    Sem
#[Out]# 10      1    Sem
#[Out]# 11      1    Sem
#[Out]# 12      1    Sem
#[Out]# 13      1    Sem
#[Out]# 14      1    Sem
#[Out]# 15      1    Sem
#[Out]# 16      1    Sem
#[Out]# 17      1    Sem
#[Out]# 18      1    Sem
#[Out]# 19      1    Sem
#[Out]# 20      1    Sem
#[Out]# 21      2  Lucas
#[Out]# 22      2  Lucas
#[Out]# 23      2  Lucas
#[Out]# 24      2  Lucas
#[Out]# 25      2  Lucas
#[Out]# 26      2  Lucas
#[Out]# 27      2  Lucas
#[Out]# 28      2  Lucas
#[Out]# 29      2  Lucas
#[Out]# ...   ...    ...
#[Out]# 1129  179   Juul
#[Out]# 1130  179   Juul
#[Out]# 1131  179   Juul
#[Out]# 1132  179   Juul
#[Out]# 1133  179   Juul
#[Out]# 1134  179   Juul
#[Out]# 1135  180  Merel
#[Out]# 1136  180  Merel
#[Out]# 1137  180  Merel
#[Out]# 1138  180  Merel
#[Out]# 1139  180  Merel
#[Out]# 1140  180  Merel
#[Out]# 1141  180  Merel
#[Out]# 1142  180  Merel
#[Out]# 1143  181   Liva
#[Out]# 1144  181   Liva
#[Out]# 1145  181   Liva
#[Out]# 1146  181   Liva
#[Out]# 1147  181   Liva
#[Out]# 1148  183  Nikki
#[Out]# 1149  183  Nikki
#[Out]# 1150  183  Nikki
#[Out]# 1151  183  Nikki
#[Out]# 1152  183  Nikki
#[Out]# 1153  183  Nikki
#[Out]# 1154  183  Nikki
#[Out]# 1155  183  Nikki
#[Out]# 1156  183  Nikki
#[Out]# 1157  183  Nikki
#[Out]# 1158  183  Nikki
#[Out]# 
#[Out]# [1159 rows x 2 columns]
query2 = '''
SELECT c.cID,c.cName FROM customer AS c, shoppinglist AS s, inventory AS i WHERE c.cID=s.cID AND s.pID=i.pID AND s.date=i.date AND (s.quantity <= i.quantity);
'''

pd.read_sql_query(query2, conn)
#[Out]#       cID  cName
#[Out]# 0       1    Sem
#[Out]# 1       1    Sem
#[Out]# 2       1    Sem
#[Out]# 3       1    Sem
#[Out]# 4       1    Sem
#[Out]# 5       1    Sem
#[Out]# 6       1    Sem
#[Out]# 7       1    Sem
#[Out]# 8       1    Sem
#[Out]# 9       1    Sem
#[Out]# 10      1    Sem
#[Out]# 11      1    Sem
#[Out]# 12      1    Sem
#[Out]# 13      1    Sem
#[Out]# 14      1    Sem
#[Out]# 15      1    Sem
#[Out]# 16      1    Sem
#[Out]# 17      1    Sem
#[Out]# 18      1    Sem
#[Out]# 19      1    Sem
#[Out]# 20      1    Sem
#[Out]# 21      2  Lucas
#[Out]# 22      2  Lucas
#[Out]# 23      2  Lucas
#[Out]# 24      2  Lucas
#[Out]# 25      2  Lucas
#[Out]# 26      2  Lucas
#[Out]# 27      2  Lucas
#[Out]# 28      2  Lucas
#[Out]# 29      2  Lucas
#[Out]# ...   ...    ...
#[Out]# 1129  179   Juul
#[Out]# 1130  179   Juul
#[Out]# 1131  179   Juul
#[Out]# 1132  179   Juul
#[Out]# 1133  179   Juul
#[Out]# 1134  179   Juul
#[Out]# 1135  180  Merel
#[Out]# 1136  180  Merel
#[Out]# 1137  180  Merel
#[Out]# 1138  180  Merel
#[Out]# 1139  180  Merel
#[Out]# 1140  180  Merel
#[Out]# 1141  180  Merel
#[Out]# 1142  180  Merel
#[Out]# 1143  181   Liva
#[Out]# 1144  181   Liva
#[Out]# 1145  181   Liva
#[Out]# 1146  181   Liva
#[Out]# 1147  181   Liva
#[Out]# 1148  183  Nikki
#[Out]# 1149  183  Nikki
#[Out]# 1150  183  Nikki
#[Out]# 1151  183  Nikki
#[Out]# 1152  183  Nikki
#[Out]# 1153  183  Nikki
#[Out]# 1154  183  Nikki
#[Out]# 1155  183  Nikki
#[Out]# 1156  183  Nikki
#[Out]# 1157  183  Nikki
#[Out]# 1158  183  Nikki
#[Out]# 
#[Out]# [1159 rows x 2 columns]
query2 = '''
SELECT c.cID, c.cName
FROM customer as C, purchase as pu, product as pr
WHERE 
c.cID=pu.cID AND 
pu.pID=pr.pID AND
pr.pName="Onions" OR pr.pName="Coffee";


'''

pd.read_sql_query(query2, conn)
#[Out]#        cID   cName
#[Out]# 0        0    Noah
#[Out]# 1        0    Noah
#[Out]# 2        0    Noah
#[Out]# 3        0    Noah
#[Out]# 4        0    Noah
#[Out]# 5        0    Noah
#[Out]# 6        0    Noah
#[Out]# 7        0    Noah
#[Out]# 8        0    Noah
#[Out]# 9        0    Noah
#[Out]# 10       0    Noah
#[Out]# 11       0    Noah
#[Out]# 12       0    Noah
#[Out]# 13       0    Noah
#[Out]# 14       0    Noah
#[Out]# 15       0    Noah
#[Out]# 16       0    Noah
#[Out]# 17       0    Noah
#[Out]# 18       0    Noah
#[Out]# 19       0    Noah
#[Out]# 20       0    Noah
#[Out]# 21       0    Noah
#[Out]# 22       0    Noah
#[Out]# 23       0    Noah
#[Out]# 24       0    Noah
#[Out]# 25       0    Noah
#[Out]# 26       0    Noah
#[Out]# 27       0    Noah
#[Out]# 28       0    Noah
#[Out]# 29       0    Noah
#[Out]# ...    ...     ...
#[Out]# 96696  190  Kostas
#[Out]# 96697  190  Kostas
#[Out]# 96698  190  Kostas
#[Out]# 96699  190  Kostas
#[Out]# 96700  190  Kostas
#[Out]# 96701  190  Kostas
#[Out]# 96702  190  Kostas
#[Out]# 96703  190  Kostas
#[Out]# 96704  190  Kostas
#[Out]# 96705  190  Kostas
#[Out]# 96706  190  Kostas
#[Out]# 96707  190  Kostas
#[Out]# 96708  190  Kostas
#[Out]# 96709  190  Kostas
#[Out]# 96710  190  Kostas
#[Out]# 96711  190  Kostas
#[Out]# 96712  190  Kostas
#[Out]# 96713  190  Kostas
#[Out]# 96714  190  Kostas
#[Out]# 96715  190  Kostas
#[Out]# 96716  190  Kostas
#[Out]# 96717  190  Kostas
#[Out]# 96718  190  Kostas
#[Out]# 96719  190  Kostas
#[Out]# 96720  190  Kostas
#[Out]# 96721  190  Kostas
#[Out]# 96722  190  Kostas
#[Out]# 96723  190  Kostas
#[Out]# 96724  190  Kostas
#[Out]# 96725  190  Kostas
#[Out]# 
#[Out]# [96726 rows x 2 columns]
query2 = '''
SELECT c.cID, c.cName
FROM customer as C, purchase as pu, product as pr1, product as pr2
WHERE 
c.cID=pu.cID AND 
pu.pID=pr.pID AND
pr1.pID="Unions" AND pr2.pID="Coffee";


'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer as C, purchase as pu, product as pr1, product as pr2
WHERE 
c.cID=pu.cID AND 
pu.pID=pr.pID AND
pr1.pID="Unions" AND 
pr2.pID="Coffee";


'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer as C, purchase as pu, product as pr1, product as pr2
WHERE 
c.cID=pu.cID AND 
pu.pID=pr.pID AND
pr1.pID="Unions" OR 
pr2.pID="Coffee";


'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer as C, purchase as pu, product as pr1, product as pr2
WHERE 
c.cID=pu.cID AND 
pu.pID=pr.pID AND
pr1.pID="Unions" OR 
pr2.pID="Coffee";


'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer as C, purchase as pu, product as pr1, product as pr2
WHERE 
c.cID=pu.cID AND 
pu.pID=pr.pID AND
pr1.pID="Unions";


'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS C, purchase AS pu, product AS pr1, product AS pr2
WHERE 
c.cID=pu.cID AND 
pu.pID=pr.pID AND
pr1.pID="Unions";


'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS C, purchase AS pu, product AS pr1, product AS pr2
WHERE 
c.cID=pu.cID AND 
pu.pID=pr1.pID AND
pr1.pID="Unions";


'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
SELECT c.cID, c.cName
FROM customer AS C, purchase AS pu, product AS pr1, product AS pr2
WHERE 
c.cID=pu.cID AND 
pu.pID=pr1.pID AND
(pr1.pID="Unions" OR pr1.pID="Coffee")AND
(pr2.pID="Unions" OR pr2.pID="Coffee");
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu, product AS pr1, product AS pr2
WHERE 
c.cID=pu.cID AND 
pu.pID=pr1.pID AND
(pr1.pID="Unions" OR pr1.pID="Coffee")AND
(pr2.pID="Unions" OR pr2.pID="Coffee");
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query3 = '''
    PUT YOUR QUERY HERE
'''

pd.read_sql_query(query3, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu, product AS pr1, product AS pr2
WHERE c.cID=12;
'''

pd.read_sql_query(query2, conn)
#[Out]#         cID cName
#[Out]# 0        12  Adam
#[Out]# 1        12  Adam
#[Out]# 2        12  Adam
#[Out]# 3        12  Adam
#[Out]# 4        12  Adam
#[Out]# 5        12  Adam
#[Out]# 6        12  Adam
#[Out]# 7        12  Adam
#[Out]# 8        12  Adam
#[Out]# 9        12  Adam
#[Out]# 10       12  Adam
#[Out]# 11       12  Adam
#[Out]# 12       12  Adam
#[Out]# 13       12  Adam
#[Out]# 14       12  Adam
#[Out]# 15       12  Adam
#[Out]# 16       12  Adam
#[Out]# 17       12  Adam
#[Out]# 18       12  Adam
#[Out]# 19       12  Adam
#[Out]# 20       12  Adam
#[Out]# 21       12  Adam
#[Out]# 22       12  Adam
#[Out]# 23       12  Adam
#[Out]# 24       12  Adam
#[Out]# 25       12  Adam
#[Out]# 26       12  Adam
#[Out]# 27       12  Adam
#[Out]# 28       12  Adam
#[Out]# 29       12  Adam
#[Out]# ...     ...   ...
#[Out]# 521186   12  Adam
#[Out]# 521187   12  Adam
#[Out]# 521188   12  Adam
#[Out]# 521189   12  Adam
#[Out]# 521190   12  Adam
#[Out]# 521191   12  Adam
#[Out]# 521192   12  Adam
#[Out]# 521193   12  Adam
#[Out]# 521194   12  Adam
#[Out]# 521195   12  Adam
#[Out]# 521196   12  Adam
#[Out]# 521197   12  Adam
#[Out]# 521198   12  Adam
#[Out]# 521199   12  Adam
#[Out]# 521200   12  Adam
#[Out]# 521201   12  Adam
#[Out]# 521202   12  Adam
#[Out]# 521203   12  Adam
#[Out]# 521204   12  Adam
#[Out]# 521205   12  Adam
#[Out]# 521206   12  Adam
#[Out]# 521207   12  Adam
#[Out]# 521208   12  Adam
#[Out]# 521209   12  Adam
#[Out]# 521210   12  Adam
#[Out]# 521211   12  Adam
#[Out]# 521212   12  Adam
#[Out]# 521213   12  Adam
#[Out]# 521214   12  Adam
#[Out]# 521215   12  Adam
#[Out]# 
#[Out]# [521216 rows x 2 columns]
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu, product AS pr1, product AS pr2
WHERE
pu.cID=c.cID;
'''

pd.read_sql_query(query2, conn)
#[Out]#         cID   cName
#[Out]# 0         0    Noah
#[Out]# 1         0    Noah
#[Out]# 2         0    Noah
#[Out]# 3         0    Noah
#[Out]# 4         0    Noah
#[Out]# 5         0    Noah
#[Out]# 6         0    Noah
#[Out]# 7         0    Noah
#[Out]# 8         0    Noah
#[Out]# 9         0    Noah
#[Out]# 10        0    Noah
#[Out]# 11        0    Noah
#[Out]# 12        0    Noah
#[Out]# 13        0    Noah
#[Out]# 14        0    Noah
#[Out]# 15        0    Noah
#[Out]# 16        0    Noah
#[Out]# 17        0    Noah
#[Out]# 18        0    Noah
#[Out]# 19        0    Noah
#[Out]# 20        0    Noah
#[Out]# 21        0    Noah
#[Out]# 22        0    Noah
#[Out]# 23        0    Noah
#[Out]# 24        0    Noah
#[Out]# 25        0    Noah
#[Out]# 26        0    Noah
#[Out]# 27        0    Noah
#[Out]# 28        0    Noah
#[Out]# 29        0    Noah
#[Out]# ...     ...     ...
#[Out]# 521186  190  Kostas
#[Out]# 521187  190  Kostas
#[Out]# 521188  190  Kostas
#[Out]# 521189  190  Kostas
#[Out]# 521190  190  Kostas
#[Out]# 521191  190  Kostas
#[Out]# 521192  190  Kostas
#[Out]# 521193  190  Kostas
#[Out]# 521194  190  Kostas
#[Out]# 521195  190  Kostas
#[Out]# 521196  190  Kostas
#[Out]# 521197  190  Kostas
#[Out]# 521198  190  Kostas
#[Out]# 521199  190  Kostas
#[Out]# 521200  190  Kostas
#[Out]# 521201  190  Kostas
#[Out]# 521202  190  Kostas
#[Out]# 521203  190  Kostas
#[Out]# 521204  190  Kostas
#[Out]# 521205  190  Kostas
#[Out]# 521206  190  Kostas
#[Out]# 521207  190  Kostas
#[Out]# 521208  190  Kostas
#[Out]# 521209  190  Kostas
#[Out]# 521210  190  Kostas
#[Out]# 521211  190  Kostas
#[Out]# 521212  190  Kostas
#[Out]# 521213  190  Kostas
#[Out]# 521214  190  Kostas
#[Out]# 521215  190  Kostas
#[Out]# 
#[Out]# [521216 rows x 2 columns]
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu, product AS pr1, product AS pr2
WHERE
pu.cID=c.cID AND
pu.pID=pr1.pID;
'''

pd.read_sql_query(query2, conn)
#[Out]#        cID   cName
#[Out]# 0        0    Noah
#[Out]# 1        0    Noah
#[Out]# 2        0    Noah
#[Out]# 3        0    Noah
#[Out]# 4        0    Noah
#[Out]# 5        0    Noah
#[Out]# 6        0    Noah
#[Out]# 7        0    Noah
#[Out]# 8        0    Noah
#[Out]# 9        0    Noah
#[Out]# 10       0    Noah
#[Out]# 11       0    Noah
#[Out]# 12       0    Noah
#[Out]# 13       0    Noah
#[Out]# 14       0    Noah
#[Out]# 15       0    Noah
#[Out]# 16       0    Noah
#[Out]# 17       0    Noah
#[Out]# 18       0    Noah
#[Out]# 19       0    Noah
#[Out]# 20       0    Noah
#[Out]# 21       0    Noah
#[Out]# 22       0    Noah
#[Out]# 23       0    Noah
#[Out]# 24       0    Noah
#[Out]# 25       0    Noah
#[Out]# 26       0    Noah
#[Out]# 27       0    Noah
#[Out]# 28       0    Noah
#[Out]# 29       0    Noah
#[Out]# ...    ...     ...
#[Out]# 16258  190  Kostas
#[Out]# 16259  190  Kostas
#[Out]# 16260  190  Kostas
#[Out]# 16261  190  Kostas
#[Out]# 16262  190  Kostas
#[Out]# 16263  190  Kostas
#[Out]# 16264  190  Kostas
#[Out]# 16265  190  Kostas
#[Out]# 16266  190  Kostas
#[Out]# 16267  190  Kostas
#[Out]# 16268  190  Kostas
#[Out]# 16269  190  Kostas
#[Out]# 16270  190  Kostas
#[Out]# 16271  190  Kostas
#[Out]# 16272  190  Kostas
#[Out]# 16273  190  Kostas
#[Out]# 16274  190  Kostas
#[Out]# 16275  190  Kostas
#[Out]# 16276  190  Kostas
#[Out]# 16277  190  Kostas
#[Out]# 16278  190  Kostas
#[Out]# 16279  190  Kostas
#[Out]# 16280  190  Kostas
#[Out]# 16281  190  Kostas
#[Out]# 16282  190  Kostas
#[Out]# 16283  190  Kostas
#[Out]# 16284  190  Kostas
#[Out]# 16285  190  Kostas
#[Out]# 16286  190  Kostas
#[Out]# 16287  190  Kostas
#[Out]# 
#[Out]# [16288 rows x 2 columns]
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu, product AS pr1, product AS pr2
WHERE
pu.cID=c.cID AND
pu.pID=pr1.pID AND
pr1.pName="Onions";
'''

pd.read_sql_query(query2, conn)
#[Out]#      cID    cName
#[Out]# 0      2    Lucas
#[Out]# 1     29    Ruben
#[Out]# 2     31  Olivier
#[Out]# 3     33     Sven
#[Out]# 4     52   Willem
#[Out]# 5     59     Joep
#[Out]# 6     85   Pieter
#[Out]# 7    124    Sofie
#[Out]# 8    129    Esmee
#[Out]# 9    162    Elena
#[Out]# 10   165    Hanna
#[Out]# 11   169     Lily
#[Out]# 12   172     Lana
#[Out]# 13   176    Amira
#[Out]# 14   177    Eline
#[Out]# 15   190   Kostas
#[Out]# 16     2    Lucas
#[Out]# 17    29    Ruben
#[Out]# 18    31  Olivier
#[Out]# 19    33     Sven
#[Out]# 20    52   Willem
#[Out]# 21    59     Joep
#[Out]# 22    85   Pieter
#[Out]# 23   124    Sofie
#[Out]# 24   129    Esmee
#[Out]# 25   162    Elena
#[Out]# 26   165    Hanna
#[Out]# 27   169     Lily
#[Out]# 28   172     Lana
#[Out]# 29   176    Amira
#[Out]# ..   ...      ...
#[Out]# 482   31  Olivier
#[Out]# 483   33     Sven
#[Out]# 484   52   Willem
#[Out]# 485   59     Joep
#[Out]# 486   85   Pieter
#[Out]# 487  124    Sofie
#[Out]# 488  129    Esmee
#[Out]# 489  162    Elena
#[Out]# 490  165    Hanna
#[Out]# 491  169     Lily
#[Out]# 492  172     Lana
#[Out]# 493  176    Amira
#[Out]# 494  177    Eline
#[Out]# 495  190   Kostas
#[Out]# 496    2    Lucas
#[Out]# 497   29    Ruben
#[Out]# 498   31  Olivier
#[Out]# 499   33     Sven
#[Out]# 500   52   Willem
#[Out]# 501   59     Joep
#[Out]# 502   85   Pieter
#[Out]# 503  124    Sofie
#[Out]# 504  129    Esmee
#[Out]# 505  162    Elena
#[Out]# 506  165    Hanna
#[Out]# 507  169     Lily
#[Out]# 508  172     Lana
#[Out]# 509  176    Amira
#[Out]# 510  177    Eline
#[Out]# 511  190   Kostas
#[Out]# 
#[Out]# [512 rows x 2 columns]
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu, product AS pr1, product AS pr2
WHERE
pu.cID=c.cID AND
pu.pID=pr1.pID AND
pr1.pName="Onions" AND
pr2.pName="Coffee";
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID    cName
#[Out]# 0     2    Lucas
#[Out]# 1    29    Ruben
#[Out]# 2    31  Olivier
#[Out]# 3    33     Sven
#[Out]# 4    52   Willem
#[Out]# 5    59     Joep
#[Out]# 6    85   Pieter
#[Out]# 7   124    Sofie
#[Out]# 8   129    Esmee
#[Out]# 9   162    Elena
#[Out]# 10  165    Hanna
#[Out]# 11  169     Lily
#[Out]# 12  172     Lana
#[Out]# 13  176    Amira
#[Out]# 14  177    Eline
#[Out]# 15  190   Kostas
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
(pu1.cID=c.cID AND
pu1.pID=pr1.pID AND
pr1.pName="Onions" OR
pr2.pName="Coffee")
;
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
pu1.date = pu2.date;

;
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
pu1.date = pu2.date;
'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
c.cID=pu1.cID AND
c.cID=pu2.cID AND
pu1.date = pu2.date;

'''

pd.read_sql_query(query2, conn)
#[Out]#          cID   cName
#[Out]# 0          0    Noah
#[Out]# 1          0    Noah
#[Out]# 2          0    Noah
#[Out]# 3          0    Noah
#[Out]# 4          0    Noah
#[Out]# 5          0    Noah
#[Out]# 6          0    Noah
#[Out]# 7          0    Noah
#[Out]# 8          0    Noah
#[Out]# 9          0    Noah
#[Out]# 10         0    Noah
#[Out]# 11         0    Noah
#[Out]# 12         0    Noah
#[Out]# 13         0    Noah
#[Out]# 14         0    Noah
#[Out]# 15         0    Noah
#[Out]# 16         0    Noah
#[Out]# 17         0    Noah
#[Out]# 18         0    Noah
#[Out]# 19         0    Noah
#[Out]# 20         0    Noah
#[Out]# 21         0    Noah
#[Out]# 22         0    Noah
#[Out]# 23         0    Noah
#[Out]# 24         0    Noah
#[Out]# 25         0    Noah
#[Out]# 26         0    Noah
#[Out]# 27         0    Noah
#[Out]# 28         0    Noah
#[Out]# 29         0    Noah
#[Out]# ...      ...     ...
#[Out]# 1477602  190  Kostas
#[Out]# 1477603  190  Kostas
#[Out]# 1477604  190  Kostas
#[Out]# 1477605  190  Kostas
#[Out]# 1477606  190  Kostas
#[Out]# 1477607  190  Kostas
#[Out]# 1477608  190  Kostas
#[Out]# 1477609  190  Kostas
#[Out]# 1477610  190  Kostas
#[Out]# 1477611  190  Kostas
#[Out]# 1477612  190  Kostas
#[Out]# 1477613  190  Kostas
#[Out]# 1477614  190  Kostas
#[Out]# 1477615  190  Kostas
#[Out]# 1477616  190  Kostas
#[Out]# 1477617  190  Kostas
#[Out]# 1477618  190  Kostas
#[Out]# 1477619  190  Kostas
#[Out]# 1477620  190  Kostas
#[Out]# 1477621  190  Kostas
#[Out]# 1477622  190  Kostas
#[Out]# 1477623  190  Kostas
#[Out]# 1477624  190  Kostas
#[Out]# 1477625  190  Kostas
#[Out]# 1477626  190  Kostas
#[Out]# 1477627  190  Kostas
#[Out]# 1477628  190  Kostas
#[Out]# 1477629  190  Kostas
#[Out]# 1477630  190  Kostas
#[Out]# 1477631  190  Kostas
#[Out]# 
#[Out]# [1477632 rows x 2 columns]
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
c.cID=pu1.cID AND
c.cID=pu2.cID AND
pu1.date = pu2.date AND
pu1.pID=pr1.pID;

'''

pd.read_sql_query(query2, conn)
#[Out]#        cID   cName
#[Out]# 0        0    Noah
#[Out]# 1        0    Noah
#[Out]# 2        0    Noah
#[Out]# 3        0    Noah
#[Out]# 4        0    Noah
#[Out]# 5        0    Noah
#[Out]# 6        0    Noah
#[Out]# 7        0    Noah
#[Out]# 8        0    Noah
#[Out]# 9        0    Noah
#[Out]# 10       0    Noah
#[Out]# 11       0    Noah
#[Out]# 12       0    Noah
#[Out]# 13       0    Noah
#[Out]# 14       0    Noah
#[Out]# 15       0    Noah
#[Out]# 16       0    Noah
#[Out]# 17       0    Noah
#[Out]# 18       0    Noah
#[Out]# 19       0    Noah
#[Out]# 20       0    Noah
#[Out]# 21       0    Noah
#[Out]# 22       0    Noah
#[Out]# 23       0    Noah
#[Out]# 24       0    Noah
#[Out]# 25       0    Noah
#[Out]# 26       0    Noah
#[Out]# 27       0    Noah
#[Out]# 28       0    Noah
#[Out]# 29       0    Noah
#[Out]# ...    ...     ...
#[Out]# 46146  190  Kostas
#[Out]# 46147  190  Kostas
#[Out]# 46148  190  Kostas
#[Out]# 46149  190  Kostas
#[Out]# 46150  190  Kostas
#[Out]# 46151  190  Kostas
#[Out]# 46152  190  Kostas
#[Out]# 46153  190  Kostas
#[Out]# 46154  190  Kostas
#[Out]# 46155  190  Kostas
#[Out]# 46156  190  Kostas
#[Out]# 46157  190  Kostas
#[Out]# 46158  190  Kostas
#[Out]# 46159  190  Kostas
#[Out]# 46160  190  Kostas
#[Out]# 46161  190  Kostas
#[Out]# 46162  190  Kostas
#[Out]# 46163  190  Kostas
#[Out]# 46164  190  Kostas
#[Out]# 46165  190  Kostas
#[Out]# 46166  190  Kostas
#[Out]# 46167  190  Kostas
#[Out]# 46168  190  Kostas
#[Out]# 46169  190  Kostas
#[Out]# 46170  190  Kostas
#[Out]# 46171  190  Kostas
#[Out]# 46172  190  Kostas
#[Out]# 46173  190  Kostas
#[Out]# 46174  190  Kostas
#[Out]# 46175  190  Kostas
#[Out]# 
#[Out]# [46176 rows x 2 columns]
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
c.cID=pu1.cID AND
c.cID=pu2.cID AND
pu1.date = pu2.date AND
pu1.pID=pr1.pID
pr1.pID="Onions";

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
c.cID=pu1.cID AND
c.cID=pu2.cID AND
pu1.date = pu2.date AND
pu1.pID=pr1.pID AND
pr1.pID="Onions";

'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
c.cID=pu1.cID AND
c.cID=pu2.cID AND
pu1.date = pu2.date AND
pu1.pID=pr1.pID AND
(pr1.pID="Onions" OR pr1.pID="Coffee";

'''

pd.read_sql_query(query2, conn)
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
c.cID=pu1.cID AND
c.cID=pu2.cID AND
pu1.date = pu2.date AND
pu1.pID=pr1.pID AND
(pr1.pID="Onions" OR pr1.pID="Coffee");
'''

pd.read_sql_query(query2, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID, cName]
#[Out]# Index: []
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
c.cID=pu1.cID AND
c.cID=pu2.cID AND
pu1.date = pu2.date AND
pu1.pID=pr1.pID AND
(pr1.pName="Onions" OR pr1.pName="Coffee");
'''

pd.read_sql_query(query2, conn)
#[Out]#       cID   cName
#[Out]# 0       2   Lucas
#[Out]# 1       2   Lucas
#[Out]# 2       2   Lucas
#[Out]# 3       2   Lucas
#[Out]# 4       2   Lucas
#[Out]# 5       2   Lucas
#[Out]# 6       2   Lucas
#[Out]# 7       2   Lucas
#[Out]# 8       2   Lucas
#[Out]# 9       2   Lucas
#[Out]# 10      2   Lucas
#[Out]# 11      2   Lucas
#[Out]# 12      2   Lucas
#[Out]# 13      2   Lucas
#[Out]# 14      2   Lucas
#[Out]# 15      2   Lucas
#[Out]# 16      2   Lucas
#[Out]# 17      2   Lucas
#[Out]# 18      2   Lucas
#[Out]# 19      2   Lucas
#[Out]# 20      2   Lucas
#[Out]# 21      2   Lucas
#[Out]# 22      2   Lucas
#[Out]# 23      2   Lucas
#[Out]# 24      2   Lucas
#[Out]# 25      2   Lucas
#[Out]# 26      2   Lucas
#[Out]# 27      2   Lucas
#[Out]# 28      2   Lucas
#[Out]# 29      2   Lucas
#[Out]# ...   ...     ...
#[Out]# 3266  190  Kostas
#[Out]# 3267  190  Kostas
#[Out]# 3268  190  Kostas
#[Out]# 3269  190  Kostas
#[Out]# 3270  190  Kostas
#[Out]# 3271  190  Kostas
#[Out]# 3272  190  Kostas
#[Out]# 3273  190  Kostas
#[Out]# 3274  190  Kostas
#[Out]# 3275  190  Kostas
#[Out]# 3276  190  Kostas
#[Out]# 3277  190  Kostas
#[Out]# 3278  190  Kostas
#[Out]# 3279  190  Kostas
#[Out]# 3280  190  Kostas
#[Out]# 3281  190  Kostas
#[Out]# 3282  190  Kostas
#[Out]# 3283  190  Kostas
#[Out]# 3284  190  Kostas
#[Out]# 3285  190  Kostas
#[Out]# 3286  190  Kostas
#[Out]# 3287  190  Kostas
#[Out]# 3288  190  Kostas
#[Out]# 3289  190  Kostas
#[Out]# 3290  190  Kostas
#[Out]# 3291  190  Kostas
#[Out]# 3292  190  Kostas
#[Out]# 3293  190  Kostas
#[Out]# 3294  190  Kostas
#[Out]# 3295  190  Kostas
#[Out]# 
#[Out]# [3296 rows x 2 columns]
query2 = '''
SELECT c.cID, c.cName
FROM customer AS c, purchase AS pu1, purchase AS pu2, product AS pr1, product AS pr2
WHERE
c.cID=pu1.cID AND
c.cID=pu2.cID AND
pu1.date = pu2.date AND
((pu1.pID=pr1.pID) AND (pr1.pName="Onions" OR pr1.pName="Coffee"))
AND
((pu2.pID=pr2.pID) AND (pr2.pName="Onions" OR pr2.pName="COffee"));
'''

pd.read_sql_query(query2, conn)
#[Out]#     cID    cName
#[Out]# 0     2    Lucas
#[Out]# 1    29    Ruben
#[Out]# 2    31  Olivier
#[Out]# 3    33     Sven
#[Out]# 4    52   Willem
#[Out]# 5    59     Joep
#[Out]# 6    85   Pieter
#[Out]# 7   124    Sofie
#[Out]# 8   124    Sofie
#[Out]# 9   129    Esmee
#[Out]# 10  162    Elena
#[Out]# 11  165    Hanna
#[Out]# 12  169     Lily
#[Out]# 13  172     Lana
#[Out]# 14  176    Amira
#[Out]# 15  177    Eline
#[Out]# 16  190   Kostas
#[Out]# 17  190   Kostas
query3 = '''
    SELECT c.cID
    FROM customer AS c
    WHERE NOT EXISTS ((SELECT s.sID FROM store as s)
    EXEPT
    (SELECT p.tID FROM purchase AS p WHERE p.cID=c.CID));
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT c.cID
FROM customer AS c
WHERE NOT EXISTS ((SELECT s.sID FROM store as s)
EXCEPT
(SELECT p.tID FROM purchase AS p WHERE p.cID=c.CID));
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT c.cID
FROM customer AS c
WHERE NOT EXISTS ((SELECT s.sID FROM store as s)
EXCEPT
 (SELECT p.tID FROM purchase AS p WHERE p.cID=c.CID));
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT c.cID
FROM customer AS c
WHERE NOT EXISTS (( SELECT s.sID FROM store as s )
EXCEPT
 (SELECT p.tID FROM purchase AS p WHERE p.cID=c.CID ) );
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT c.cID
FROM customer AS c
WHERE NOT EXISTS (( SELECT s.sID FROM store as s )
EXCEPT
 ( SELECT p.tID FROM purchase AS p WHERE p.cID=c.CID ) );
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT c.cID
FROM customer AS c
WHERE NOT EXISTS (( SELECT s.sID FROM store AS s )
EXCEPT
 ( SELECT p.tID FROM purchase AS p WHERE p.cID=c.cID ) );
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT c.cID
FROM customer AS c
WHERE NOT EXISTS (( SELECT s.sID FROM store AS s)
EXCEPT
(SELECT p.tID FROM purchase AS p WHERE p.cID=c.cID));
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT c.cID
FROM customer AS c
WHERE NOT EXISTS (
SELECT s.sID FROM store AS s
EXCEPT
SELECT p.tID FROM purchase AS p WHERE p.cID=c.cID);
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''

SELECT p.tID FROM purchase AS p WHERE p.cID=c.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''

SELECT p.tID FROM purchase AS p WHERE p.cID=customer.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''

SELECT purchase.tID 
FROM purchase 
WHERE purchase.cID=customer.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''

SELECT purchase.tID 
FROM purchase 
WHERE purchase.cID = customer.cID;
'''

pd.read_sql_query(query3, conn)
query3 = '''

SELECT purchase.tID 
FROM purchase, customer
WHERE purchase.cID = customer.cID;
'''

pd.read_sql_query(query3, conn)
#[Out]#      tID
#[Out]# 0      0
#[Out]# 1      1
#[Out]# 2      2
#[Out]# 3      3
#[Out]# 4      4
#[Out]# 5      5
#[Out]# 6      6
#[Out]# 7      7
#[Out]# 8      8
#[Out]# 9      9
#[Out]# 10    10
#[Out]# 11    11
#[Out]# 12    12
#[Out]# 13    13
#[Out]# 14    14
#[Out]# 15    15
#[Out]# 16    16
#[Out]# 17    17
#[Out]# 18    18
#[Out]# 19    19
#[Out]# 20    20
#[Out]# 21    21
#[Out]# 22    22
#[Out]# 23    23
#[Out]# 24    24
#[Out]# 25    25
#[Out]# 26    26
#[Out]# 27    27
#[Out]# 28    28
#[Out]# 29    29
#[Out]# ..   ...
#[Out]# 479  818
#[Out]# 480  819
#[Out]# 481  820
#[Out]# 482  821
#[Out]# 483  822
#[Out]# 484  823
#[Out]# 485  824
#[Out]# 486  825
#[Out]# 487  826
#[Out]# 488  827
#[Out]# 489  828
#[Out]# 490  829
#[Out]# 491  830
#[Out]# 492  831
#[Out]# 493  832
#[Out]# 494  833
#[Out]# 495  834
#[Out]# 496  835
#[Out]# 497  836
#[Out]# 498  837
#[Out]# 499  838
#[Out]# 500  839
#[Out]# 501  840
#[Out]# 502  841
#[Out]# 503  842
#[Out]# 504  843
#[Out]# 505  844
#[Out]# 506  845
#[Out]# 507  846
#[Out]# 508  847
#[Out]# 
#[Out]# [509 rows x 1 columns]
query3 = '''
SELECT c.cID
FROM customer AS c
WHERE NOT EXISTS (
SELECT s.sID FROM store AS s
EXCEPT
SELECT p.tID FROM purchase AS p WHERE p.cID=c.cID);
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
SELECT c.cID
FROM customer AS c
WHERE NOT EXISTS 
((SELECT s.sID FROM store AS s) EXCEPT (SELECT p.tID FROM purchase AS p WHERE p.cID=c.cID);
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT c.cID
FROM customer AS c
WHERE NOT EXISTS 
(SELECT s.sID FROM store AS s EXCEPT SELECT p.tID FROM purchase AS p WHERE p.cID=c.cID);
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
SELECT p.cID
FROM purchase AS p
WHERE NOT EXISTS 
(SELECT s.sID FROM store AS s EXCEPT SELECT p.tID FROM purchase AS p WHERE p.cID=c.cID);
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT p.cID
FROM purchase AS p
WHERE NOT EXISTS 
(SELECT s.sID FROM store AS s;
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT p.cID
FROM purchase AS p
WHERE NOT EXISTS 
SELECT s.sID FROM store AS s;
'''

pd.read_sql_query(query3, conn)
query3 = '''
SELECT p.cID
FROM purchase AS p
WHERE NOT EXISTS 
(SELECT s.sID FROM store AS s);
'''

pd.read_sql_query(query3, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [cID]
#[Out]# Index: []
query3 = '''
SELECT cID
FROM purchase
Where sID IN (
            SELECT sID
            FROM store
            )
GROUP BY cID
HAVING COUNT(*) = (
                    SELECT COUNT (*)
                    FROM store
                    )
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
SELECT cID
FROM purchase
Where sID IN (
            SELECT sID
            FROM store
            )
GROUP BY cID
HAVING COUNT(*) = (
                    SELECT COUNT (*)
                    FROM store
                    );
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query3 = '''
SELECT cID
FROM purchase
Where sID IN 
(SELECT sID FROM store)
GROUP BY cID
HAVING COUNT(*) = (SELECT COUNT (*) FROM store);
'''

pd.read_sql_query(query3, conn)
#[Out]#    cID
#[Out]# 0  190
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
WHERE s.sID = p.sID AND
HAVING avg (p.quantity) > 4;
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (p.quantity) > 4;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (p.quantity) > 1;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (p.quantity) > 19;
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (p.quantity) > 5;
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (p.quantity) > 4;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (p.quantity) > 1;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (quantity) > ;
'''

pd.read_sql_query(query4, conn)
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (p.quantity) > 4;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sID
HAVING avg (p.quantity) > 4;
'''

pd.read_sql_query(query4, conn)
#[Out]#           sName
#[Out]# 0          Coop
#[Out]# 1     Hoogvliet
#[Out]# 2         Jumbo
#[Out]# 3        Sligro
#[Out]# 4     Hoogvliet
#[Out]# 5        Sligro
#[Out]# 6          Coop
#[Out]# 7        Sligro
#[Out]# 8   Albert Hein
#[Out]# 9   Albert Hein
#[Out]# 10        Jumbo
#[Out]# 11  Albert Hein
#[Out]# 12         Lidl
#[Out]# 13         Coop
#[Out]# 14         Coop
#[Out]# 15         Lidl
#[Out]# 16         Lidl
#[Out]# 17    Hoogvliet
#[Out]# 18       Sligro
#[Out]# 19         Coop
#[Out]# 20        Jumbo
#[Out]# 21         Coop
#[Out]# 22         Lidl
#[Out]# 23         Dirk
#[Out]# 24  Albert Hein
#[Out]# 25  Albert Hein
#[Out]# 26    Hoogvliet
#[Out]# 27       Sligro
#[Out]# 28    Hoogvliet
#[Out]# 29       Sligro
#[Out]# ..          ...
#[Out]# 34         Coop
#[Out]# 35         Lidl
#[Out]# 36         Lidl
#[Out]# 37        Jumbo
#[Out]# 38    Hoogvliet
#[Out]# 39       Sligro
#[Out]# 40    Hoogvliet
#[Out]# 41  Albert Hein
#[Out]# 42       Sligro
#[Out]# 43         Coop
#[Out]# 44  Albert Hein
#[Out]# 45         Coop
#[Out]# 46         Lidl
#[Out]# 47         Coop
#[Out]# 48    Hoogvliet
#[Out]# 49    Hoogvliet
#[Out]# 50       Sligro
#[Out]# 51         Coop
#[Out]# 52         Lidl
#[Out]# 53         Coop
#[Out]# 54         Dirk
#[Out]# 55         Coop
#[Out]# 56        Jumbo
#[Out]# 57         Dirk
#[Out]# 58         Dirk
#[Out]# 59        Jumbo
#[Out]# 60         Lidl
#[Out]# 61         Lidl
#[Out]# 62        Jumbo
#[Out]# 63        Jumbo
#[Out]# 
#[Out]# [64 rows x 1 columns]
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (p.quantity) > 4;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (p.quantity) > 5;
'''

pd.read_sql_query(query4, conn)
#[Out]# Empty DataFrame
#[Out]# Columns: [sName]
#[Out]# Index: []
query4 = '''
SELECT s.sName
FROM store AS s, purchase AS p
GROUP BY s.sName
HAVING avg (p.quantity) > 4;
'''

pd.read_sql_query(query4, conn)
#[Out]#          sName
#[Out]# 0  Albert Hein
#[Out]# 1         Coop
#[Out]# 2         Dirk
#[Out]# 3    Hoogvliet
#[Out]# 4        Jumbo
#[Out]# 5         Lidl
#[Out]# 6       Sligro
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE
p.pID=pu.pID AND
s.sID=pu.sID 
GROUP BY p.price
HAVING MAX (price);

'''

pd.read_sql_query(query5, conn)
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE
p.pID=pu.pID AND
s.sID=pu.sID 
GROUP BY pu.price
HAVING MAX (price);

'''

pd.read_sql_query(query5, conn)
#[Out]#             pName        sName
#[Out]# 0           Water    Hoogvliet
#[Out]# 1           Water       Sligro
#[Out]# 2       Mushrooms  Albert Hein
#[Out]# 3       Mushrooms         Lidl
#[Out]# 4           Water         Coop
#[Out]# 5         Lasanga        Jumbo
#[Out]# 6        Tomatoes    Hoogvliet
#[Out]# 7        Potatoes         Dirk
#[Out]# 8            Milk         Lidl
#[Out]# 9          Onions         Coop
#[Out]# 10           Milk         Lidl
#[Out]# 11        Carrots         Coop
#[Out]# 12      Cucumbers         Coop
#[Out]# 13        Carrots         Coop
#[Out]# 14         Onions         Coop
#[Out]# 15        Carrots         Lidl
#[Out]# 16   Green Pepper       Sligro
#[Out]# 17        Bananas    Hoogvliet
#[Out]# 18        Bananas    Hoogvliet
#[Out]# 19        Bananas       Sligro
#[Out]# 20           Rice         Coop
#[Out]# 21        Bananas       Sligro
#[Out]# 22            Tea       Sligro
#[Out]# 23            Tea         Coop
#[Out]# 24           Rice       Sligro
#[Out]# 25        Bananas    Hoogvliet
#[Out]# 26       Potatoes         Lidl
#[Out]# 27        Bananas       Sligro
#[Out]# 28       Tomatoes         Coop
#[Out]# 29           Rice         Coop
#[Out]# ..            ...          ...
#[Out]# 125         Pizza         Coop
#[Out]# 126         Pizza        Jumbo
#[Out]# 127         Pizza         Lidl
#[Out]# 128         Pizza    Hoogvliet
#[Out]# 129       Lasanga         Coop
#[Out]# 130       Lasanga         Lidl
#[Out]# 131        Cheese         Coop
#[Out]# 132       Lasanga         Dirk
#[Out]# 133       Lasanga  Albert Hein
#[Out]# 134          Beef         Coop
#[Out]# 135        Cheese         Coop
#[Out]# 136        Cheese       Sligro
#[Out]# 137        Cheese         Coop
#[Out]# 138          Beef  Albert Hein
#[Out]# 139          Beef         Coop
#[Out]# 140          Beef         Dirk
#[Out]# 141        Cheese  Albert Hein
#[Out]# 142          Beef         Dirk
#[Out]# 143        Cheese  Albert Hein
#[Out]# 144          Beef    Hoogvliet
#[Out]# 145          Beef    Hoogvliet
#[Out]# 146          Beef         Dirk
#[Out]# 147          Beef       Sligro
#[Out]# 148          Beef         Dirk
#[Out]# 149          Beef  Albert Hein
#[Out]# 150          Beef  Albert Hein
#[Out]# 151          Beef       Sligro
#[Out]# 152          Beef         Coop
#[Out]# 153          Beef       Sligro
#[Out]# 154          Beef       Sligro
#[Out]# 
#[Out]# [155 rows x 2 columns]
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE
p.pID=pu.pID AND
s.sID=pu.sID 
GROUP BY pu.price
HAVING MAX (pu.price);

'''

pd.read_sql_query(query5, conn)
#[Out]#             pName        sName
#[Out]# 0           Water    Hoogvliet
#[Out]# 1           Water       Sligro
#[Out]# 2       Mushrooms  Albert Hein
#[Out]# 3       Mushrooms         Lidl
#[Out]# 4           Water         Coop
#[Out]# 5         Lasanga        Jumbo
#[Out]# 6        Tomatoes    Hoogvliet
#[Out]# 7        Potatoes         Dirk
#[Out]# 8            Milk         Lidl
#[Out]# 9          Onions         Coop
#[Out]# 10           Milk         Lidl
#[Out]# 11        Carrots         Coop
#[Out]# 12      Cucumbers         Coop
#[Out]# 13        Carrots         Coop
#[Out]# 14         Onions         Coop
#[Out]# 15        Carrots         Lidl
#[Out]# 16   Green Pepper       Sligro
#[Out]# 17        Bananas    Hoogvliet
#[Out]# 18        Bananas    Hoogvliet
#[Out]# 19        Bananas       Sligro
#[Out]# 20           Rice         Coop
#[Out]# 21        Bananas       Sligro
#[Out]# 22            Tea       Sligro
#[Out]# 23            Tea         Coop
#[Out]# 24           Rice       Sligro
#[Out]# 25        Bananas    Hoogvliet
#[Out]# 26       Potatoes         Lidl
#[Out]# 27        Bananas       Sligro
#[Out]# 28       Tomatoes         Coop
#[Out]# 29           Rice         Coop
#[Out]# ..            ...          ...
#[Out]# 125         Pizza         Coop
#[Out]# 126         Pizza        Jumbo
#[Out]# 127         Pizza         Lidl
#[Out]# 128         Pizza    Hoogvliet
#[Out]# 129       Lasanga         Coop
#[Out]# 130       Lasanga         Lidl
#[Out]# 131        Cheese         Coop
#[Out]# 132       Lasanga         Dirk
#[Out]# 133       Lasanga  Albert Hein
#[Out]# 134          Beef         Coop
#[Out]# 135        Cheese         Coop
#[Out]# 136        Cheese       Sligro
#[Out]# 137        Cheese         Coop
#[Out]# 138          Beef  Albert Hein
#[Out]# 139          Beef         Coop
#[Out]# 140          Beef         Dirk
#[Out]# 141        Cheese  Albert Hein
#[Out]# 142          Beef         Dirk
#[Out]# 143        Cheese  Albert Hein
#[Out]# 144          Beef    Hoogvliet
#[Out]# 145          Beef    Hoogvliet
#[Out]# 146          Beef         Dirk
#[Out]# 147          Beef       Sligro
#[Out]# 148          Beef         Dirk
#[Out]# 149          Beef  Albert Hein
#[Out]# 150          Beef  Albert Hein
#[Out]# 151          Beef       Sligro
#[Out]# 152          Beef         Coop
#[Out]# 153          Beef       Sligro
#[Out]# 154          Beef       Sligro
#[Out]# 
#[Out]# [155 rows x 2 columns]
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE
p.pID=pu.pID AND
s.sID=pu.sID 
GROUP BY pu.price
HAVING MAX(pu.price);

'''

pd.read_sql_query(query5, conn)
#[Out]#             pName        sName
#[Out]# 0           Water    Hoogvliet
#[Out]# 1           Water       Sligro
#[Out]# 2       Mushrooms  Albert Hein
#[Out]# 3       Mushrooms         Lidl
#[Out]# 4           Water         Coop
#[Out]# 5         Lasanga        Jumbo
#[Out]# 6        Tomatoes    Hoogvliet
#[Out]# 7        Potatoes         Dirk
#[Out]# 8            Milk         Lidl
#[Out]# 9          Onions         Coop
#[Out]# 10           Milk         Lidl
#[Out]# 11        Carrots         Coop
#[Out]# 12      Cucumbers         Coop
#[Out]# 13        Carrots         Coop
#[Out]# 14         Onions         Coop
#[Out]# 15        Carrots         Lidl
#[Out]# 16   Green Pepper       Sligro
#[Out]# 17        Bananas    Hoogvliet
#[Out]# 18        Bananas    Hoogvliet
#[Out]# 19        Bananas       Sligro
#[Out]# 20           Rice         Coop
#[Out]# 21        Bananas       Sligro
#[Out]# 22            Tea       Sligro
#[Out]# 23            Tea         Coop
#[Out]# 24           Rice       Sligro
#[Out]# 25        Bananas    Hoogvliet
#[Out]# 26       Potatoes         Lidl
#[Out]# 27        Bananas       Sligro
#[Out]# 28       Tomatoes         Coop
#[Out]# 29           Rice         Coop
#[Out]# ..            ...          ...
#[Out]# 125         Pizza         Coop
#[Out]# 126         Pizza        Jumbo
#[Out]# 127         Pizza         Lidl
#[Out]# 128         Pizza    Hoogvliet
#[Out]# 129       Lasanga         Coop
#[Out]# 130       Lasanga         Lidl
#[Out]# 131        Cheese         Coop
#[Out]# 132       Lasanga         Dirk
#[Out]# 133       Lasanga  Albert Hein
#[Out]# 134          Beef         Coop
#[Out]# 135        Cheese         Coop
#[Out]# 136        Cheese       Sligro
#[Out]# 137        Cheese         Coop
#[Out]# 138          Beef  Albert Hein
#[Out]# 139          Beef         Coop
#[Out]# 140          Beef         Dirk
#[Out]# 141        Cheese  Albert Hein
#[Out]# 142          Beef         Dirk
#[Out]# 143        Cheese  Albert Hein
#[Out]# 144          Beef    Hoogvliet
#[Out]# 145          Beef    Hoogvliet
#[Out]# 146          Beef         Dirk
#[Out]# 147          Beef       Sligro
#[Out]# 148          Beef         Dirk
#[Out]# 149          Beef  Albert Hein
#[Out]# 150          Beef  Albert Hein
#[Out]# 151          Beef       Sligro
#[Out]# 152          Beef         Coop
#[Out]# 153          Beef       Sligro
#[Out]# 154          Beef       Sligro
#[Out]# 
#[Out]# [155 rows x 2 columns]
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE
p.pID=pu.pID AND
s.sID=pu.sID 
GROUP BY pu.price
HAVING MAX (pu.price);

'''

pd.read_sql_query(query5, conn)
#[Out]#             pName        sName
#[Out]# 0           Water    Hoogvliet
#[Out]# 1           Water       Sligro
#[Out]# 2       Mushrooms  Albert Hein
#[Out]# 3       Mushrooms         Lidl
#[Out]# 4           Water         Coop
#[Out]# 5         Lasanga        Jumbo
#[Out]# 6        Tomatoes    Hoogvliet
#[Out]# 7        Potatoes         Dirk
#[Out]# 8            Milk         Lidl
#[Out]# 9          Onions         Coop
#[Out]# 10           Milk         Lidl
#[Out]# 11        Carrots         Coop
#[Out]# 12      Cucumbers         Coop
#[Out]# 13        Carrots         Coop
#[Out]# 14         Onions         Coop
#[Out]# 15        Carrots         Lidl
#[Out]# 16   Green Pepper       Sligro
#[Out]# 17        Bananas    Hoogvliet
#[Out]# 18        Bananas    Hoogvliet
#[Out]# 19        Bananas       Sligro
#[Out]# 20           Rice         Coop
#[Out]# 21        Bananas       Sligro
#[Out]# 22            Tea       Sligro
#[Out]# 23            Tea         Coop
#[Out]# 24           Rice       Sligro
#[Out]# 25        Bananas    Hoogvliet
#[Out]# 26       Potatoes         Lidl
#[Out]# 27        Bananas       Sligro
#[Out]# 28       Tomatoes         Coop
#[Out]# 29           Rice         Coop
#[Out]# ..            ...          ...
#[Out]# 125         Pizza         Coop
#[Out]# 126         Pizza        Jumbo
#[Out]# 127         Pizza         Lidl
#[Out]# 128         Pizza    Hoogvliet
#[Out]# 129       Lasanga         Coop
#[Out]# 130       Lasanga         Lidl
#[Out]# 131        Cheese         Coop
#[Out]# 132       Lasanga         Dirk
#[Out]# 133       Lasanga  Albert Hein
#[Out]# 134          Beef         Coop
#[Out]# 135        Cheese         Coop
#[Out]# 136        Cheese       Sligro
#[Out]# 137        Cheese         Coop
#[Out]# 138          Beef  Albert Hein
#[Out]# 139          Beef         Coop
#[Out]# 140          Beef         Dirk
#[Out]# 141        Cheese  Albert Hein
#[Out]# 142          Beef         Dirk
#[Out]# 143        Cheese  Albert Hein
#[Out]# 144          Beef    Hoogvliet
#[Out]# 145          Beef    Hoogvliet
#[Out]# 146          Beef         Dirk
#[Out]# 147          Beef       Sligro
#[Out]# 148          Beef         Dirk
#[Out]# 149          Beef  Albert Hein
#[Out]# 150          Beef  Albert Hein
#[Out]# 151          Beef       Sligro
#[Out]# 152          Beef         Coop
#[Out]# 153          Beef       Sligro
#[Out]# 154          Beef       Sligro
#[Out]# 
#[Out]# [155 rows x 2 columns]
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID
GROUP BY pu.pID
HAVING MAX(pu.price);


    

'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts         Coop
#[Out]# 2           Potatoes         Coop
#[Out]# 3       Green Pepper         Dirk
#[Out]# 4             Onions         Lidl
#[Out]# 5          Mushrooms         Lidl
#[Out]# 6            Carrots  Albert Hein
#[Out]# 7           Tomatoes        Jumbo
#[Out]# 8   Hot Dog Sausages  Albert Hein
#[Out]# 9            Bananas        Jumbo
#[Out]# 10             Water         Dirk
#[Out]# 11              Milk         Coop
#[Out]# 12              Beef       Sligro
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples    Hoogvliet
#[Out]# 15         Cucumbers         Coop
#[Out]# 16              Rice        Jumbo
#[Out]# 17             Bread        Jumbo
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca         Dirk
#[Out]# 20             Fanta    Hoogvliet
#[Out]# 21            Coffee  Albert Hein
#[Out]# 22               Tea       Sligro
#[Out]# 23   Spiced Biscuits         Coop
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza    Hoogvliet
#[Out]# 28           Lasanga  Albert Hein
#[Out]# 29            Salmon        Jumbo
#[Out]# 30           Ketchup        Jumbo
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID
GROUP BY pu.pID
HAVING MAX(pu.price);


    

'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts         Coop
#[Out]# 2           Potatoes         Coop
#[Out]# 3       Green Pepper         Dirk
#[Out]# 4             Onions         Lidl
#[Out]# 5          Mushrooms         Lidl
#[Out]# 6            Carrots  Albert Hein
#[Out]# 7           Tomatoes        Jumbo
#[Out]# 8   Hot Dog Sausages  Albert Hein
#[Out]# 9            Bananas        Jumbo
#[Out]# 10             Water         Dirk
#[Out]# 11              Milk         Coop
#[Out]# 12              Beef       Sligro
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples    Hoogvliet
#[Out]# 15         Cucumbers         Coop
#[Out]# 16              Rice        Jumbo
#[Out]# 17             Bread        Jumbo
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca         Dirk
#[Out]# 20             Fanta    Hoogvliet
#[Out]# 21            Coffee  Albert Hein
#[Out]# 22               Tea       Sligro
#[Out]# 23   Spiced Biscuits         Coop
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza    Hoogvliet
#[Out]# 28           Lasanga  Albert Hein
#[Out]# 29            Salmon        Jumbo
#[Out]# 30           Ketchup        Jumbo
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID
GROUP BY pu.tID
HAVING MAX(pu.price);


    

'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName
#[Out]# 0               Water       Sligro
#[Out]# 1              Apples         Dirk
#[Out]# 2                Rice       Sligro
#[Out]# 3             Bananas    Hoogvliet
#[Out]# 4              Donuts  Albert Hein
#[Out]# 5               Pasta         Lidl
#[Out]# 6                Milk         Lidl
#[Out]# 7               Pizza         Lidl
#[Out]# 8               Fanta         Lidl
#[Out]# 9             Bananas       Sligro
#[Out]# 10             Onions         Coop
#[Out]# 11               Eggs         Coop
#[Out]# 12                Tea         Coop
#[Out]# 13             Apples  Albert Hein
#[Out]# 14              Pasta         Dirk
#[Out]# 15            Bananas       Sligro
#[Out]# 16   Hot Dog Sausages    Hoogvliet
#[Out]# 17              Pizza        Jumbo
#[Out]# 18               Beef         Coop
#[Out]# 19            Carrots         Coop
#[Out]# 20               Eggs       Sligro
#[Out]# 21              Pasta  Albert Hein
#[Out]# 22             Apples    Hoogvliet
#[Out]# 23            Lasanga         Lidl
#[Out]# 24            Carrots         Coop
#[Out]# 25                Tea         Coop
#[Out]# 26               Rice         Coop
#[Out]# 27               Coca    Hoogvliet
#[Out]# 28               Coca       Sligro
#[Out]# 29           Potatoes         Lidl
#[Out]# ..                ...          ...
#[Out]# 474           Lasanga         Coop
#[Out]# 475             Pizza         Lidl
#[Out]# 476         Mushrooms         Lidl
#[Out]# 477           Lasanga        Jumbo
#[Out]# 478          Tomatoes    Hoogvliet
#[Out]# 479       Cashew Nuts       Sligro
#[Out]# 480              Milk    Hoogvliet
#[Out]# 481           Carrots  Albert Hein
#[Out]# 482              Coca       Sligro
#[Out]# 483             Bread         Coop
#[Out]# 484           Bananas  Albert Hein
#[Out]# 485              Milk         Coop
#[Out]# 486               Tea         Lidl
#[Out]# 487             Bread         Coop
#[Out]# 488             Fanta    Hoogvliet
#[Out]# 489              Milk    Hoogvliet
#[Out]# 490            Coffee       Sligro
#[Out]# 491   Spiced Biscuits         Coop
#[Out]# 492   Spiced Biscuits         Lidl
#[Out]# 493  Hot Dog Sausages         Coop
#[Out]# 494       Cashew Nuts         Dirk
#[Out]# 495  Hot Dog Sausages         Coop
#[Out]# 496              Milk        Jumbo
#[Out]# 497         Cucumbers         Dirk
#[Out]# 498          Potatoes         Dirk
#[Out]# 499             Bread        Jumbo
#[Out]# 500         Mushrooms         Lidl
#[Out]# 501              Coca         Lidl
#[Out]# 502           Bananas        Jumbo
#[Out]# 503            Cheese        Jumbo
#[Out]# 
#[Out]# [504 rows x 2 columns]
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID
GROUP BY p.pID
HAVING MAX(pu.price);


    

'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName
#[Out]# 0        Cashew Nuts         Coop
#[Out]# 1         Mixed Nuts         Coop
#[Out]# 2           Potatoes         Coop
#[Out]# 3       Green Pepper         Dirk
#[Out]# 4             Onions         Lidl
#[Out]# 5          Mushrooms         Lidl
#[Out]# 6            Carrots  Albert Hein
#[Out]# 7           Tomatoes        Jumbo
#[Out]# 8   Hot Dog Sausages  Albert Hein
#[Out]# 9            Bananas        Jumbo
#[Out]# 10             Water         Dirk
#[Out]# 11              Milk         Coop
#[Out]# 12              Beef       Sligro
#[Out]# 13              Eggs    Hoogvliet
#[Out]# 14            Apples    Hoogvliet
#[Out]# 15         Cucumbers         Coop
#[Out]# 16              Rice        Jumbo
#[Out]# 17             Bread        Jumbo
#[Out]# 18            Cheese  Albert Hein
#[Out]# 19              Coca         Dirk
#[Out]# 20             Fanta    Hoogvliet
#[Out]# 21            Coffee  Albert Hein
#[Out]# 22               Tea       Sligro
#[Out]# 23   Spiced Biscuits         Coop
#[Out]# 24           Oranges         Coop
#[Out]# 25            Donuts        Jumbo
#[Out]# 26             Pasta         Lidl
#[Out]# 27             Pizza    Hoogvliet
#[Out]# 28           Lasanga  Albert Hein
#[Out]# 29            Salmon        Jumbo
#[Out]# 30           Ketchup        Jumbo
query5 = '''
SELECT p.pName, s.sName, MAX(pu.price)
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID
GROUP BY p.pID
HAVING MAX(pu.price);


    

'''

pd.read_sql_query(query5, conn)
#[Out]#                pName        sName  MAX(pu.price)
#[Out]# 0        Cashew Nuts         Coop           5.40
#[Out]# 1         Mixed Nuts         Coop           6.55
#[Out]# 2           Potatoes         Coop           2.30
#[Out]# 3       Green Pepper         Dirk           2.75
#[Out]# 4             Onions         Lidl           2.40
#[Out]# 5          Mushrooms         Lidl           4.35
#[Out]# 6            Carrots  Albert Hein           2.95
#[Out]# 7           Tomatoes        Jumbo           2.35
#[Out]# 8   Hot Dog Sausages  Albert Hein           5.70
#[Out]# 9            Bananas        Jumbo           3.15
#[Out]# 10             Water         Dirk           4.35
#[Out]# 11              Milk         Coop           3.55
#[Out]# 12              Beef       Sligro          13.80
#[Out]# 13              Eggs    Hoogvliet           4.20
#[Out]# 14            Apples    Hoogvliet           4.70
#[Out]# 15         Cucumbers         Coop           3.80
#[Out]# 16              Rice        Jumbo           2.10
#[Out]# 17             Bread        Jumbo           3.80
#[Out]# 18            Cheese  Albert Hein          12.00
#[Out]# 19              Coca         Dirk           4.25
#[Out]# 20             Fanta    Hoogvliet           4.30
#[Out]# 21            Coffee  Albert Hein           4.25
#[Out]# 22               Tea       Sligro           3.20
#[Out]# 23   Spiced Biscuits         Coop           3.75
#[Out]# 24           Oranges         Coop           4.20
#[Out]# 25            Donuts        Jumbo           4.70
#[Out]# 26             Pasta         Lidl           3.55
#[Out]# 27             Pizza    Hoogvliet           9.25
#[Out]# 28           Lasanga  Albert Hein           9.85
#[Out]# 29            Salmon        Jumbo           1.00
#[Out]# 30           Ketchup        Jumbo           1.00
query5 = '''
SELECT p.pName, s.sName, MAX(pu.price)
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID
GROUP BY pu.tID
HAVING MAX(pu.price);


    

'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName  MAX(pu.price)
#[Out]# 0               Water       Sligro           0.45
#[Out]# 1              Apples         Dirk           4.65
#[Out]# 2                Rice       Sligro           1.60
#[Out]# 3             Bananas    Hoogvliet           1.25
#[Out]# 4              Donuts  Albert Hein           3.95
#[Out]# 5               Pasta         Lidl           2.75
#[Out]# 6                Milk         Lidl           0.90
#[Out]# 7               Pizza         Lidl           9.10
#[Out]# 8               Fanta         Lidl           2.45
#[Out]# 9             Bananas       Sligro           1.35
#[Out]# 10             Onions         Coop           1.10
#[Out]# 11               Eggs         Coop           3.70
#[Out]# 12                Tea         Coop           1.55
#[Out]# 13             Apples  Albert Hein           4.30
#[Out]# 14              Pasta         Dirk           2.75
#[Out]# 15            Bananas       Sligro           1.45
#[Out]# 16   Hot Dog Sausages    Hoogvliet           4.15
#[Out]# 17              Pizza        Jumbo           9.05
#[Out]# 18               Beef         Coop          13.60
#[Out]# 19            Carrots         Coop           1.05
#[Out]# 20               Eggs       Sligro           3.05
#[Out]# 21              Pasta  Albert Hein           2.75
#[Out]# 22             Apples    Hoogvliet           4.70
#[Out]# 23            Lasanga         Lidl           8.25
#[Out]# 24            Carrots         Coop           1.10
#[Out]# 25                Tea         Coop           1.55
#[Out]# 26               Rice         Coop           1.85
#[Out]# 27               Coca    Hoogvliet           2.20
#[Out]# 28               Coca       Sligro           2.10
#[Out]# 29           Potatoes         Lidl           1.70
#[Out]# ..                ...          ...            ...
#[Out]# 474           Lasanga         Coop           2.80
#[Out]# 475             Pizza         Lidl           0.50
#[Out]# 476         Mushrooms         Lidl           2.55
#[Out]# 477           Lasanga        Jumbo           0.65
#[Out]# 478          Tomatoes    Hoogvliet           0.70
#[Out]# 479       Cashew Nuts       Sligro           3.70
#[Out]# 480              Milk    Hoogvliet           3.50
#[Out]# 481           Carrots  Albert Hein           2.95
#[Out]# 482              Coca       Sligro           2.75
#[Out]# 483             Bread         Coop           1.50
#[Out]# 484           Bananas  Albert Hein           0.85
#[Out]# 485              Milk         Coop           3.55
#[Out]# 486               Tea         Lidl           2.60
#[Out]# 487             Bread         Coop           3.25
#[Out]# 488             Fanta    Hoogvliet           4.30
#[Out]# 489              Milk    Hoogvliet           3.05
#[Out]# 490            Coffee       Sligro           4.05
#[Out]# 491   Spiced Biscuits         Coop           1.50
#[Out]# 492   Spiced Biscuits         Lidl           2.50
#[Out]# 493  Hot Dog Sausages         Coop           3.95
#[Out]# 494       Cashew Nuts         Dirk           3.50
#[Out]# 495  Hot Dog Sausages         Coop           2.95
#[Out]# 496              Milk        Jumbo           1.60
#[Out]# 497         Cucumbers         Dirk           3.25
#[Out]# 498          Potatoes         Dirk           0.75
#[Out]# 499             Bread        Jumbo           3.80
#[Out]# 500         Mushrooms         Lidl           4.35
#[Out]# 501              Coca         Lidl           2.85
#[Out]# 502           Bananas        Jumbo           3.15
#[Out]# 503            Cheese        Jumbo           3.30
#[Out]# 
#[Out]# [504 rows x 3 columns]
query5 = '''
SELECT p.pName, s.sName, MAX(pu.price)
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID
GROUP BY pu.tID



    

'''

pd.read_sql_query(query5, conn)
#[Out]#                 pName        sName  MAX(pu.price)
#[Out]# 0               Water       Sligro           0.45
#[Out]# 1              Apples         Dirk           4.65
#[Out]# 2                Rice       Sligro           1.60
#[Out]# 3             Bananas    Hoogvliet           1.25
#[Out]# 4              Donuts  Albert Hein           3.95
#[Out]# 5               Pasta         Lidl           2.75
#[Out]# 6                Milk         Lidl           0.90
#[Out]# 7               Pizza         Lidl           9.10
#[Out]# 8               Fanta         Lidl           2.45
#[Out]# 9             Bananas       Sligro           1.35
#[Out]# 10             Onions         Coop           1.10
#[Out]# 11               Eggs         Coop           3.70
#[Out]# 12                Tea         Coop           1.55
#[Out]# 13             Apples  Albert Hein           4.30
#[Out]# 14              Pasta         Dirk           2.75
#[Out]# 15            Bananas       Sligro           1.45
#[Out]# 16   Hot Dog Sausages    Hoogvliet           4.15
#[Out]# 17              Pizza        Jumbo           9.05
#[Out]# 18               Beef         Coop          13.60
#[Out]# 19            Carrots         Coop           1.05
#[Out]# 20               Eggs       Sligro           3.05
#[Out]# 21              Pasta  Albert Hein           2.75
#[Out]# 22             Apples    Hoogvliet           4.70
#[Out]# 23            Lasanga         Lidl           8.25
#[Out]# 24            Carrots         Coop           1.10
#[Out]# 25                Tea         Coop           1.55
#[Out]# 26               Rice         Coop           1.85
#[Out]# 27               Coca    Hoogvliet           2.20
#[Out]# 28               Coca       Sligro           2.10
#[Out]# 29           Potatoes         Lidl           1.70
#[Out]# ..                ...          ...            ...
#[Out]# 474           Lasanga         Coop           2.80
#[Out]# 475             Pizza         Lidl           0.50
#[Out]# 476         Mushrooms         Lidl           2.55
#[Out]# 477           Lasanga        Jumbo           0.65
#[Out]# 478          Tomatoes    Hoogvliet           0.70
#[Out]# 479       Cashew Nuts       Sligro           3.70
#[Out]# 480              Milk    Hoogvliet           3.50
#[Out]# 481           Carrots  Albert Hein           2.95
#[Out]# 482              Coca       Sligro           2.75
#[Out]# 483             Bread         Coop           1.50
#[Out]# 484           Bananas  Albert Hein           0.85
#[Out]# 485              Milk         Coop           3.55
#[Out]# 486               Tea         Lidl           2.60
#[Out]# 487             Bread         Coop           3.25
#[Out]# 488             Fanta    Hoogvliet           4.30
#[Out]# 489              Milk    Hoogvliet           3.05
#[Out]# 490            Coffee       Sligro           4.05
#[Out]# 491   Spiced Biscuits         Coop           1.50
#[Out]# 492   Spiced Biscuits         Lidl           2.50
#[Out]# 493  Hot Dog Sausages         Coop           3.95
#[Out]# 494       Cashew Nuts         Dirk           3.50
#[Out]# 495  Hot Dog Sausages         Coop           2.95
#[Out]# 496              Milk        Jumbo           1.60
#[Out]# 497         Cucumbers         Dirk           3.25
#[Out]# 498          Potatoes         Dirk           0.75
#[Out]# 499             Bread        Jumbo           3.80
#[Out]# 500         Mushrooms         Lidl           4.35
#[Out]# 501              Coca         Lidl           2.85
#[Out]# 502           Bananas        Jumbo           3.15
#[Out]# 503            Cheese        Jumbo           3.30
#[Out]# 
#[Out]# [504 rows x 3 columns]
query5 = '''
SELECT p.pName, s.sName, MAX(pu.price)
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID




    

'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName  MAX(pu.price)
#[Out]# 0  Beef  Sligro           13.8
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID AND MAX(pu.price);
'''

pd.read_sql_query(query5, conn)
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID 
GROUP BY pu.price
HAVING MAX(pu.price);
'''

pd.read_sql_query(query5, conn)
#[Out]#             pName        sName
#[Out]# 0           Water    Hoogvliet
#[Out]# 1           Water       Sligro
#[Out]# 2       Mushrooms  Albert Hein
#[Out]# 3       Mushrooms         Lidl
#[Out]# 4           Water         Coop
#[Out]# 5         Lasanga        Jumbo
#[Out]# 6        Tomatoes    Hoogvliet
#[Out]# 7        Potatoes         Dirk
#[Out]# 8            Milk         Lidl
#[Out]# 9          Onions         Coop
#[Out]# 10           Milk         Lidl
#[Out]# 11        Carrots         Coop
#[Out]# 12      Cucumbers         Coop
#[Out]# 13        Carrots         Coop
#[Out]# 14         Onions         Coop
#[Out]# 15        Carrots         Lidl
#[Out]# 16   Green Pepper       Sligro
#[Out]# 17        Bananas    Hoogvliet
#[Out]# 18        Bananas    Hoogvliet
#[Out]# 19        Bananas       Sligro
#[Out]# 20           Rice         Coop
#[Out]# 21        Bananas       Sligro
#[Out]# 22            Tea       Sligro
#[Out]# 23            Tea         Coop
#[Out]# 24           Rice       Sligro
#[Out]# 25        Bananas    Hoogvliet
#[Out]# 26       Potatoes         Lidl
#[Out]# 27        Bananas       Sligro
#[Out]# 28       Tomatoes         Coop
#[Out]# 29           Rice         Coop
#[Out]# ..            ...          ...
#[Out]# 125         Pizza         Coop
#[Out]# 126         Pizza        Jumbo
#[Out]# 127         Pizza         Lidl
#[Out]# 128         Pizza    Hoogvliet
#[Out]# 129       Lasanga         Coop
#[Out]# 130       Lasanga         Lidl
#[Out]# 131        Cheese         Coop
#[Out]# 132       Lasanga         Dirk
#[Out]# 133       Lasanga  Albert Hein
#[Out]# 134          Beef         Coop
#[Out]# 135        Cheese         Coop
#[Out]# 136        Cheese       Sligro
#[Out]# 137        Cheese         Coop
#[Out]# 138          Beef  Albert Hein
#[Out]# 139          Beef         Coop
#[Out]# 140          Beef         Dirk
#[Out]# 141        Cheese  Albert Hein
#[Out]# 142          Beef         Dirk
#[Out]# 143        Cheese  Albert Hein
#[Out]# 144          Beef    Hoogvliet
#[Out]# 145          Beef    Hoogvliet
#[Out]# 146          Beef         Dirk
#[Out]# 147          Beef       Sligro
#[Out]# 148          Beef         Dirk
#[Out]# 149          Beef  Albert Hein
#[Out]# 150          Beef  Albert Hein
#[Out]# 151          Beef       Sligro
#[Out]# 152          Beef         Coop
#[Out]# 153          Beef       Sligro
#[Out]# 154          Beef       Sligro
#[Out]# 
#[Out]# [155 rows x 2 columns]
query5 = '''
SELECT p.pName, s.sName
FROM product AS p, store AS s, purchase AS pu
WHERE pu.pID=p.pID AND pu.sID = s.sID AND
pu.price = (SELECT MAX(pu.price) FROM purchase AS pu);

'''

pd.read_sql_query(query5, conn)
#[Out]#   pName   sName
#[Out]# 0  Beef  Sligro
query6 = '''
SELECT MAX(purchase.price) - MIN (purchase.price) DIFFERENCE
FROM purchase
'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0        13.4
query6 = '''
SELECT MAX(pu.price) - MIN (pu.price) DIFFERENCE
FROM purchase AS pu

'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0        13.4
query6 = '''
SELECT MAX(pu.price) - MIN (pu.price) DIFFERENCE, pu.date
FROM purchase AS pu


'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE        date
#[Out]# 0        13.4  2018-08-25
query6 = '''
SELECT MAX(pu.price) - MIN (pu.price) DIFFERENCE, pu.date
FROM purchase AS pu
were pu.date ='2018-08-23';

'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX(pu.price) - MIN (pu.price) DIFFERENCE, pu.date
FROM purchase AS pu
were pu.date ="2018-08-23";

'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX(pu.price) - MIN (pu.price) DIFFERENCE
FROM purchase AS pu
were pu.date ="2018-08-23";

'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX(pu.price) - MIN (pu.price) DIFFERENCE, pu.date
FROM purchase AS pu
WHERE pu.date ="2018-08-23";

'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE        date
#[Out]# 0        12.8  2018-08-23
query6 = '''
SELECT MAX(i.unit_price) - MIN (i.unit_price) DIFFERENCE
FROM inventory AS i
WHERE pu.date ="2018-08-23" AND
;

'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX(i.unit_price) - MIN (i.unit_price) DIFFERENCE
FROM inventory AS i
WHERE pu.date ="2018-08-23" 
;

'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX(i.unit_price) - MIN (i.unit_price) DIFFERENCE
FROM inventory AS i
WHERE i.date ="2018-08-23";

'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0       12.95
query6 = '''
SELECT MAX(i.unit_price) - MIN (i.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE i.date ="2018-08-23" AND
i1.sID<>i2.sID;

'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX(i.unit_price) - MIN (i.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE i.date ="2018-08-23";


'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX(i1.unit_price) - MIN (i1.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE i.date ="2018-08-23" AND
i1.sID<>i2.sID;


'''

pd.read_sql_query(query6, conn)
query6 = '''
SELECT MAX(i1.unit_price) - MIN (i1.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE i1.date ="2018-08-23" AND
i1.sID<>i2.sID;


'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0       12.95
query6 = '''
SELECT MAX(i1.unit_price) - MIN (i2.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE i1.date ="2018-08-23" AND
i1.sID<>i2.sID;


'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0        13.0
query6 = '''
SELECT MAX(i2.unit_price) - MIN (i1.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE i1.date ="2018-08-23" AND
i1.sID<>i2.sID;


'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0       14.45
query6 = '''
SELECT MAX(i1.unit_price) - MIN (i1.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE i1.date ="2018-08-23" AND
i1.sID<>i2.sID;


'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0       12.95
query6 = '''
SELECT MAX(i2.unit_price) - MIN (i2.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE i1.date ="2018-08-23" AND
i1.sID<>i2.sID;


'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0        14.5
query6 = '''
SELECT MAX(i2.unit_price) - MIN (i2.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE i1.date ="2018-08-23" AND
i2.date ="2018-08-23" AND
i1.sID<>i2.sID;


'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0       12.95
query6 = '''
SELECT MAX(i1.unit_price) - MIN (i2.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE i1.date ="2018-08-23" AND
i2.date ="2018-08-23" AND
i1.sID<>i2.sID;


'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0       12.95
query6 = '''
SELECT MAX(i2.unit_price) - MIN (i1.unit_price) DIFFERENCE
FROM inventory AS i1, inventory as i2
WHERE   i1.date ="2018-08-23" AND
        i2.date ="2018-08-23" AND
        i1.sID<>i2.sID;


'''

pd.read_sql_query(query6, conn)
#[Out]#    DIFFERENCE
#[Out]# 0       12.95
